FIAT
****

The Fortran IFS and Arpege Toolkit

Introduction
============

FIAT is a collection of selected Fortran utility libraries, extracted from the IFS/Arpege model.
 
 - drhook    : tracing
 - gstats    : timing
 - parkind   : choose precision
 - mpl       : MPI communication
 - mpi_serial: MPI dummy symbols compiled into static library
 - other various routines

License
=======

FIAT is distributed under the Apache License Version 2.0.
See `LICENSE` file for details.

Installing FIAT 
===============

Supported Platforms
-------------------

- Linux
- Apple MacOS

Other UNIX-like operating systems may work too out of the box.

Requirements
------------
- Fortran and C compiler, and optionally C++ compiler
- CMake (see https://cmake.org)
- ecbuild (see https://github.com/ecmwf/ecbuild)

Further optional dependencies:
- MPI Fortran libraries
- fckit compiled with eckit support (see https://github.com/ecmwf/fckit)

Building FIAT
-------------

Environment variables 

    $ export ecbuild_ROOT=<path-to-ecbuild>
    $ export MPI_HOME=<path-to-MPI>
    $ export fckit_ROOT=<path-to-fckit>
    $ export CC=<path-to-C-compiler>
    $ export FC=<path-to-Fortran-compiler>
    $ export CXX=<path-to-C++-compiler> 

You must compile FIAT out-of-source, so create a build-directory

    $ mkdir build && cd build
 
Configuration of the build happens through standard CMake

    $ cmake ..

Extra options can be added to the `cmake` command to control the build:

 - `-DCMAKE_BUILD_TYPE=<Debug|RelWithDebInfo|Release|Bit>` default=RelWithDebInfo (typically `-O2 -g`)
 - `-DENABLE_TESTS=<ON|OFF>` 
 - `-DENABLE_MPI=<ON|OFF>` 
 - `-DENABLE_OMP=<ON|OFF>`
 - `-DCMAKE_INSTALL_PREFIX=<install-prefix>`

More options to control compilation flags, only when defaults are not sufficient

 - `-DOpenMP_Fortran_FLAGS=<flags>`
 - `-DCMAKE_Fortran_FLAGS=<fortran-flags>`
 - `-DCMAKE_C_FLAGS=<c-flags>`

Once this has finished successfully, run ``make`` and ``make install``.

Optionally, tests can be run to check succesful compilation, when the feature TESTS is enabled (`-DENABLE_TESTS=ON`, default ON)

    $ ctest

Reporting Bugs
==============

TODO

Contributing
============

TODO

! (C) Copyright 2005- ECMWF.
! (C) Copyright 2013- Meteo-France.
! 
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!

MODULE MPL_COMM_CREATE_MOD

!**** MPL_COMM_CREATE Create a new communicator

!     Purpose.
!     --------
!     Create a new communicator and set as default

!**   Interface.
!     ----------
!        CALL MPL_COMM_CREATE

!        Input required arguments :
!        -------------------------

!        Input optional arguments :
!        -------------------------

!        Output required arguments :
!        -------------------------

!        Output optional arguments :
!        -------------------------
!           KERROR   -  return error code.     If not supplied, 
!                       MPL_COMM_CREATE aborts when an error is detected.
!     Author.
!     -------
!        D.Dent, M.Hamrud     ECMWF

!     Modifications.
!     --------------
!        Original: 2000-09-01

!     ------------------------------------------------------------------

USE EC_PARKIND  ,ONLY : JPIM
USE OML_MOD   ,ONLY : OML_MY_THREAD

USE MPL_MPIF
USE MPL_DATA_MODULE
USE MPL_MESSAGE_MOD

IMPLICIT NONE

PRIVATE
PUBLIC MPL_COMM_CREATE

CONTAINS 

SUBROUTINE MPL_COMM_CREATE(KERROR)
INTEGER(KIND=JPIM),OPTIONAL,INTENT(OUT) :: KERROR
INTEGER(KIND=JPIM) :: ITID
ITID = OML_MY_THREAD()
!   this line to be replaced
MPL_COMM_OML(ITID)=MPL_COMM
KERROR=0

RETURN
END SUBROUTINE MPL_COMM_CREATE

END MODULE MPL_COMM_CREATE_MOD

module test_drhook_counters_gemm_mod
  use yomhook, only : lhook,dr_hook,jphook
  implicit none
  
contains
  subroutine gemm_combinations(n_init)
    implicit none
    integer(kind=8), intent(in), optional :: n_init
    integer(kind=8) :: n,i
    real(kind=jphook) :: zhook_handle
    n=1000
    if (present(n_init)) then
      n = n_init
    endif
#if defined(HAVE_BLAS)
    if (lhook) call dr_hook('GEMM_ALL',0,zhook_handle)
    do i=1,4
       call dgemm_driver(n)
       call sgemm_driver(n)
       n=n*2
    end do
    if (lhook) call dr_hook('GEMM_ALL',1,zhook_handle)
#endif
  end subroutine gemm_combinations

#if defined(HAVE_BLAS)
  subroutine  dgemm_driver(nn)
    implicit none
    double precision, allocatable :: a(:,:),b(:,:),c(:,:)
    double precision :: alpha,beta
    integer :: m,k,n
    integer :: i,j
    integer*8 :: nn 
    real(kind=jphook) :: zhook_handle
    character(len=25) :: tag

    write(tag,'(i20)')nn
    tag="_n="//adjustl(tag)
    m=nn
    n=nn
    k=nn
    alpha=1.0
    beta=0.0

    allocate(a(m,k), b(k,n), c(m,n))
    a=1.0
    b=2.0
    c=3.0
    if (lhook) call dr_hook('DGEMM'//TRIM(tag),0,zhook_handle)
    call dgemm('n','n',m,n,k,alpha,a,m,b,k,beta,c,m)
    if (lhook) call dr_hook('DGEMM'//TRIM(tag),1,zhook_handle)

    return
    
  end subroutine dgemm_driver
  
  subroutine  sgemm_driver(nn)
    implicit none
    real*4, allocatable :: a(:,:),b(:,:),c(:,:)
    real*4 :: alpha,beta
    integer :: m,k,n
    integer :: i,j
    integer*8 :: nn 
    real(kind=jphook) :: zhook_handle
    character(len=25) :: tag

    write(tag,'(i20)')nn
    tag="_n="//adjustl(tag)
    m=nn
    n=nn
    k=nn
    alpha=1.0
    beta=0.0

    allocate(a(m,k), b(k,n), c(m,n))
    a=1.0
    b=2.0
    c=3.0
    if (lhook) call dr_hook('SGEMM'//TRIM(tag),0,zhook_handle)
    call sgemm('n','n',m,n,k,alpha,a,m,b,k,beta,c,m)
    if (lhook) call dr_hook('SGEMM'//TRIM(tag),1,zhook_handle)

    return
    
  end subroutine sgemm_driver
#endif
  
end module

! (C) Copyright 2005- ECMWF.
! (C) Copyright 2013- Meteo-France.
! 
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!

SUBROUTINE DR_HOOK_UTIL(LDHOOK,CDNAME,KCASE,PKEY,CDFILENAME,KSIZEINFO)
USE EC_PARKIND , ONLY : JPIM, JPRD
USE OML_MOD    , ONLY : OML_MY_THREAD
USE YOMHOOK    , ONLY : LHOOK
USE DR_HACK_MOD, ONLY : LL_DRHACK, DR_HACK_INIT, DR_HACK

IMPLICIT NONE

! Arguments
LOGICAL,INTENT(INOUT)         :: LDHOOK
CHARACTER(LEN=*),INTENT(IN)   :: CDNAME,CDFILENAME
INTEGER(KIND=JPIM),INTENT(IN) :: KCASE,KSIZEINFO
REAL(KIND=JPRD),INTENT(INOUT) :: PKEY

! Persistent variables, setup at first call
LOGICAL,SAVE :: LL_INIT       = .FALSE.
LOGICAL,SAVE :: LL_STACKCHECK = .FALSE. ! Will be set to .TRUE. if envvar DR_HOOK_STACKCHECK=1
LOGICAL,SAVE :: LL_HEAPCHECK  = .FALSE. ! Will be set to .TRUE. if envvar DR_HOOK_HEAPCHECK=1

! Local variables
INTEGER(KIND=JPIM) :: IMYTID
INTEGER(KIND=8)    :: MAXMEM=0 ! For comparing memory between HEAPCHECK_START and HEAPCHECK_END

#include "dr_hook_init.intfb.h"

IF (.NOT.LDHOOK) RETURN

IMYTID = OML_MY_THREAD()

IF (.NOT.LL_INIT) THEN
  LL_INIT = .TRUE.
  CALL DR_HOOK_INIT()
  IF(.NOT.LHOOK) RETURN ! LHOOK is set to .TRUE. within DR_HOOK_INIT() only when envvar DR_HOOK=1

  CALL DR_HACK_INIT()
  CALL STACKCHECK_INIT()
  CALL HEAPCHECK_INIT()
ENDIF ! .NOT.LL_INIT

IF (LL_STACKCHECK) CALL STACKCHECK()

IF (KCASE == 0) THEN
  CALL C_DRHOOK_START(CDNAME, IMYTID, PKEY, CDFILENAME, KSIZEINFO)
  IF(LL_HEAPCHECK) CALL HEAPCHECK_START()
ELSE IF (KCASE == 1) THEN
  IF(LL_HEAPCHECK) CALL HEAPCHECK_END()
  CALL C_DRHOOK_END  (CDNAME, IMYTID, PKEY, CDFILENAME, KSIZEINFO)
ENDIF

IF (LL_DRHACK) THEN 
  CALL DR_HACK(CDNAME,KCASE)
ENDIF

CALL GSTATS_FINDSUMB() ! currently only dead code within

!-------------------- END SUBROUTINE DR_HOOK_UTIL -----------------

CONTAINS

FUNCTION MYPROC()
  USE MPL_DATA_MODULE ,ONLY : MPL_NUMPROC
  USE MPL_MYRANK_MOD  ,ONLY : MPL_MYRANK
  INTEGER(KIND=JPIM) :: MYPROC
  IF( MPL_NUMPROC > 0 ) THEN
    MYPROC = MPL_MYRANK()
  ELSE
    MYPROC = 1
  ENDIF
END FUNCTION MYPROC


SUBROUTINE HEAPCHECK_INIT()
IMPLICIT NONE
CHARACTER(LEN=4)  :: CHEAP
!JFH---Initialisation to monitor heap usage-----------------------
CALL GET_ENVIRONMENT_VARIABLE('DR_HOOK_HEAPCHECK',CHEAP)
IF( CHEAP == 'yes'  .OR. CHEAP == 'YES'  .OR. &
  & CHEAP == 'true' .OR. CHEAP == 'TRUE' .OR. &
  & CHEAP == 'on'   .OR. CHEAP == 'ON'   .OR. &
  & CHEAP == '1' ) THEN
  LL_HEAPCHECK = .TRUE.
  IF(IMYTID == 1) THEN
    CALL SETHEAPCHECK()
  ENDIF
ENDIF
!JFH------------ End ---------------------------------------------
END SUBROUTINE HEAPCHECK_INIT

SUBROUTINE HEAPCHECK_START()
!JFH---Code to monitor heap usage -------------------------
USE EC_LUN ,ONLY : NULERR
IMPLICIT NONE 
INTEGER(KIND=8) :: GETMAXLOC
INTEGER(KIND=8) :: GETMAXMEM
IF(IMYTID == 1) THEN
  IF( MYPROC() == 1) THEN
    GETMAXMEM=GETMAXLOC()
    IF(GETMAXMEM .GT. MAXMEM) THEN
      MAXMEM = GETMAXMEM
      WRITE(NULERR,*) "HEAPCHECK Max heap at beg of routine =",MAXMEM," ",CDNAME
    ENDIF
  ENDIF
ENDIF
!JFH------------ End ---------------------------------------------
END SUBROUTINE HEAPCHECK_START

SUBROUTINE HEAPCHECK_END()
!JFH---Code to monitor heap usage -------------------------
USE EC_LUN ,ONLY : NULERR
IMPLICIT NONE
INTEGER(KIND=8) :: GETMAXLOC
INTEGER(KIND=8) :: GETMAXMEM
IF(IMYTID == 1) THEN
  IF( MYPROC() == 1) THEN
    GETMAXMEM=GETMAXLOC()
    IF(GETMAXMEM .GT. MAXMEM) THEN
      MAXMEM = GETMAXMEM
      WRITE(NULERR,*) "HEAPCHECK Max heap at end of routine =",MAXMEM," ",CDNAME
    ENDIF
  ENDIF
ENDIF
!JFH------------ End ---------------------------------------------
END SUBROUTINE HEAPCHECK_END

SUBROUTINE STACKCHECK_INIT()
  USE DR_HOOK_STACKCHECK_MOD ,ONLY : LL_THREAD_FIRST,ISAVE,IMAXSTACK   ! For monitoring thread stack usage
  USE OML_MOD       ,ONLY : OML_MAX_THREADS
  IMPLICIT NONE
  INTEGER(KIND=JPIM) :: INUMTIDS
  CHARACTER(LEN=4)   :: CSTACK

  !JFH---Initialisation to monitor stack usage by threads-------------
  CALL GET_ENVIRONMENT_VARIABLE('DR_HOOK_STACKCHECK',CSTACK)
  IF ( CSTACK == 'yes'  .OR. CSTACK == 'YES'  .OR. &
     & CSTACK == 'true' .OR. CSTACK == 'TRUE' .OR. &
     & CSTACK == 'on'   .OR. CSTACK == 'ON'   .OR. &
     & CSTACK == '1' ) THEN
    LL_STACKCHECK = .TRUE.
    IF(IMYTID == 1 ) THEN
      INUMTIDS = OML_MAX_THREADS()
      ALLOCATE(LL_THREAD_FIRST(INUMTIDS))
      ALLOCATE(ISAVE(INUMTIDS))
      ALLOCATE(IMAXSTACK(INUMTIDS))
      LL_THREAD_FIRST=.TRUE.
      ISAVE=0
      IMAXSTACK=0
    ENDIF
  ENDIF
!JFH------------ End ---------------------------------------------
END SUBROUTINE STACKCHECK_INIT


SUBROUTINE STACKCHECK()
!JFH---Code to monitor stack usage by threads---------------------
#ifndef NAG
USE DR_HOOK_STACKCHECK_MOD ,ONLY : LL_THREAD_FIRST,ISAVE,IMAXSTACK
USE EC_LUN  ,ONLY : NULERR
IMPLICIT NONE
INTEGER(KIND=8) :: ILOC  ! For monitoring thread stack usage
IF(IMYTID > 1) THEN
  IF(LL_THREAD_FIRST(IMYTID))THEN 
    LL_THREAD_FIRST(IMYTID)=.FALSE.
    ISAVE(IMYTID)=LOC(ILOC)
  ENDIF
  
  ILOC=LOC(ILOC)

  IF(ISAVE(IMYTID)-ILOC > IMAXSTACK(IMYTID)) THEN
    IMAXSTACK(IMYTID)=ISAVE(IMYTID)-ILOC
    WRITE(NULERR,'(A,I3,A,I12,2X,A)')"STACKCHECK Max stack usage by thread",IMYTID," =",IMAXSTACK(IMYTID),CDNAME
  ENDIF
ENDIF
#endif
!JFH------------ End ---------------------------------------------
END SUBROUTINE STACKCHECK


SUBROUTINE GSTATS_FINDSUMB()
!GM---Code to find gstats SUMB time-------------------------------
!!!! Willem Deconinck - June 2021:
!!!!     Note following code was dead as LLFINDSUMB = .FALSE. hardcoded.
!!!!     From gstats.F90 documentation: LLFINDSUMB - when set is used detect gstat counter problems.
!!!!     If agreed, this could be removed altogether, and remove dependency of dr_hook on gstats
!!!!     Now removed from compilation with #if 0
#if 0
USE YOMGSTATS, ONLY : LAST_KNUM,LAST_KSWITCH,LDETAILED_STATS,MYPROC_STATS, &
                      NHOOK_MESSAGES,TIME_LAST_CALL
IMPLICIT NONE
LOGICAL, PARAMETER :: LLFINDSUMB=.FALSE.
REAL(KIND=JPRD) :: ZCLOCK
REAL(KIND=JPRD) :: ZDIFF
CHARACTER(LEN=7) CLSTR

IF( LDETAILED_STATS .AND. LLFINDSUMB )THEN
  IF( IMYTID==1 .AND. LAST_KNUM>=500 .AND. MYPROC_STATS <= 2 )THEN
    IF( LAST_KSWITCH==1 .OR. LAST_KSWITCH==2 )THEN
      CALL USER_CLOCK(PELAPSED_TIME=ZCLOCK)
      ZDIFF=ZCLOCK-TIME_LAST_CALL
      IF( ZDIFF > 0.1_JPRD )THEN
        IF( KCASE == 0 )THEN
          CLSTR='ENTERED'
        ELSE
          CLSTR='EXITED'
        ENDIF
        IF( NHOOK_MESSAGES < 100000 )THEN
          WRITE(0,'("DR_HOOK_UTIL: ",A,2X,A," TIMESUMB=",F10.6)')CDNAME,CLSTR,ZDIFF
          NHOOK_MESSAGES=NHOOK_MESSAGES+1
        ENDIF
      ENDIF
    ENDIF
  ENDIF
ENDIF
#endif
!GM------------ End --------------------------------------------- 
END SUBROUTINE GSTATS_FINDSUMB

END SUBROUTINE DR_HOOK_UTIL

! (C) Copyright 2005- ECMWF.
! (C) Copyright 2013- Meteo-France.
! 
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!

MODULE MPL_BARRIER_MOD

!**** MPL_BARRIER - Barrier synchronisation

!     Purpose.
!     --------
!     Blocks the caller until all group members have called it.

!**   Interface.
!     ----------
!        CALL MPL_BARRIER

!        Input required arguments :
!        -------------------------
!           none

!        Input optional arguments :
!        -------------------------
!           KCOMM    -  Communicator number if different from MPI_COMM_WORLD 
!                       or from that established as the default 
!                       by an MPL communicator routine
!           CDSTRING -  Character string for ABORT messages
!                       used when KERROR is not provided

!        Output required arguments :
!        -------------------------
!           none

!        Output optional arguments :
!        -------------------------
!           KERROR   -  return error code.     If not supplied, 
!                       MPL_BARRIER aborts when an error is detected.
!     Author.
!     -------
!        D.Dent, M.Hamrud     ECMWF

!     Modifications.
!     --------------
!        Original: 2000-09-01
!        Threadsafe: 2004-12-15, J.Hague

!     ------------------------------------------------------------------

USE EC_PARKIND  ,ONLY : JPIM
USE OML_MOD   ,ONLY : OML_MY_THREAD
USE MPL_DATA_MODULE
USE MPL_MESSAGE_MOD

IMPLICIT NONE


PRIVATE

LOGICAL :: LLABORT=.TRUE.

PUBLIC MPL_BARRIER

CONTAINS

SUBROUTINE MPL_BARRIER(KCOMM,CDSTRING,KERROR)


#ifdef USE_8_BYTE_WORDS
  USE MPI4TO8, ONLY : &
    MPI_BARRIER => MPI_BARRIER8
#endif


INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL   :: KCOMM
INTEGER(KIND=JPIM),INTENT(OUT),OPTIONAL  :: KERROR
CHARACTER(LEN=*),INTENT(IN),OPTIONAL :: CDSTRING
INTEGER :: ICOMM,IERROR,ITID
IERROR = 0
ITID = OML_MY_THREAD()
IF(MPL_NUMPROC < 1) CALL MPL_MESSAGE(CDSTRING=CDSTRING,&
  & CDMESSAGE='MPL_BARRIER: MPL NOT INITIALISED ',LDABORT=LLABORT)
 
IF(PRESENT(KCOMM)) THEN
  ICOMM=KCOMM
ELSE
  ICOMM=MPL_COMM_OML(ITID)
ENDIF

CALL MPI_BARRIER(ICOMM,IERROR)

IF(PRESENT(KERROR)) THEN
  KERROR=IERROR
ELSE
  IF(IERROR /= 0 ) CALL MPL_MESSAGE(IERROR,'MPL_BARRIER',CDSTRING,LDABORT=LLABORT)
ENDIF
  
RETURN
END SUBROUTINE MPL_BARRIER

END MODULE MPL_BARRIER_MOD

! (C) Copyright 2024- ECMWF.
!
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
!
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.

program drhook_roctx_skip_spam_regions

use yomhook, only : jphook, dr_hook

implicit none

real(jphook) :: zhook_handle
call dr_hook('drhook_roctx_skip_spam_regions', 0, zhook_handle)
call foo(0)
call dr_hook('drhook_roctx_skip_spam_regions', 1, zhook_handle)

contains

  recursive subroutine foo (depth)
    integer, intent(in) :: depth
    real(jphook) :: zhook_handle

    call dr_hook('foo', 0, zhook_handle)

    if (depth < 10) then
      call foo(depth + 1)
    end if

    call dr_hook('foo', 1, zhook_handle)
  end subroutine

end program drhook_roctx_skip_spam_regions

! (C) Copyright 2005- ECMWF.
! (C) Copyright 2013- Meteo-France.
! 
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!

SUBROUTINE GSTATS(KNUM, KSWITCH)

!**** *GSTATS*  - Gather timing statistics

!     PURPOSE.
!     --------
!       To gather timings for subsequent output by routine STATS_OUTPUT 


!**   INTERFACE.
!     ----------
!       *CALL* *GSTATS(KNUM,KSWITCH)

!        EXPLICIT ARGUMENTS
!        --------------------
!        KNUM - timing event number (for list of already defined events
!               see routine STATS_OUTPUT)
!        KSWITCH  - KSWITCH=0 - switch on timer
!                   KSWITCH=1 - switch off timer
!                   KSWITCH=2 - suspend timer
!                   KSWITCH=3 - resume  timer

!        IMPLICIT ARGUMENTS
!        --------------------
!        Module YOMSTATS

!     METHOD.
!     -------


!     EXTERNALS.   USER_CLOCK - timing routine
!     ----------

!     REFERENCE.
!     ----------
!        ECMWF Research Department documentation of the IFS

!     AUTHOR.
!     -------
!        Mats Hamrud ECMWF

!     MODIFICATIONS.
!     --------------
!        ORIGINAL : 98-11-15
!        D.Salmond: 02-02-25  Return if not master thread when called from a 
!                             parallel region. 
!        J.Hague:   03-06-11  Memory tracing (for NSTATS_MEM MPI tasks)
!        G.Mozdzynski: 18 Apr 2008 Many corrections to gstats,
!                             see LLFINDSUMB - when set is used detect gstat counter problems.
!        G.Mozdzynski: 20 Jan 2010 Further corrections to gstats to get timed sections and
!                             SUMB to 100 percent of the total time.
!      F. Vana  05-Mar-2015  Support for single precision
!     ------------------------------------------------------------------

USE EC_PARKIND, ONLY: JPRD, JPIM ,JPIB
USE YOMHOOK, ONLY: LHOOK, DR_HOOK, JPHOOK
USE YOMGSTATS, ONLY: JPMAXSTAT, LSTATS, LGSTATS_LABEL, CCDESC, CCTYPE, LSTATSCPU, TIMESUM, NCALLS, &
  &                  NSWITCHVAL, TIMESQSUM, TIMEMAX, TIMESUMB, TTCPUSUM, TVCPUSUM, TIMELCALL, &
  &                  NTMEM, TIME_LAST_CALL, JPERR, MYPROC_STATS, THISTIME, TTCPULCALL, TVCPULCALL, &
  &                  THISTCPU, THISVCPU, NSTATS_MEM, LSTATS_ALLOC, LSTATS_MPL, UNKNOWN_NUMSEND, &
  &                  UNKNOWN_NUMRECV, UNKNOWN_SENDBYTES, UNKNOWN_RECVBYTES, NUMSEND, NUMRECV, &
  &                  SENDBYTES, RECVBYTES, JPMAXDELAYS, NDELAY_INDEX, NDELAY_COUNTER, &
  &                  TDELAY_VALUE, CDELAY_TIME, LTRACE_STATS, NTRACE_STATS, NCALLS_TOTAL, &
  &                  TIME_TRACE, NCALL_TRACE, LAST_KSWITCH, LAST_KNUM
USE MPL_STATS_MOD, ONLY: MPL_STATSON, MPL_STATSREAD
USE OML_MOD, ONLY: OML_MY_THREAD, OML_GET_MAX_THREADS, OML_MAX_THREADS

IMPLICIT NONE

INTEGER(KIND=JPIM), INTENT(IN) :: KNUM
INTEGER(KIND=JPIM), INTENT(IN) :: KSWITCH

INTEGER(KIND=JPIM) :: IMOD, ICALL
INTEGER(KIND=JPIM) :: IIMEM, IIPAG, IIMEMC
INTEGER(KIND=JPIB) :: IMEM, IMEMH, IMEMS, IMEMC, IPAG, INUM
INTEGER(KIND=JPIB) :: GETMAXRSS, GETHWM, GETSTK, GETCURHEAP, GETPAG
EXTERNAL GETMAXRSS, GETHWM, GETSTK, GETCURHEAP, GETPAG
REAL(KIND=JPRD) :: ZTIMED, ZCLOCK, ZCLOCK1, ZTIME, ZTCPU, ZVCPU
LOGICAL :: LLFIRST = .TRUE.
LOGICAL :: LLMFIRST = .TRUE.
CHARACTER(LEN=32), SAVE :: CCDESC_DRHOOK(JPMAXSTAT)
CHARACTER(LEN=32), SAVE :: CCDESC_BARR(JPMAXSTAT)
SAVE IIMEM, IIPAG, IIMEMC

INTEGER(KIND=JPIM), SAVE :: NUM_THREADS
INTEGER(KIND=JPIM) :: INUMTH ! Current value <= NUM_THREADS
REAL(KIND=JPHOOK), ALLOCATABLE,SAVE :: ZHOOK_HANDLE(:)
REAL(KIND=JPHOOK), SAVE :: ZHOOK_HANDLE_COMMS, ZHOOK_HANDLE_COMMS1
REAL(KIND=JPHOOK), SAVE :: ZHOOK_HANDLE_TRANS
REAL(KIND=JPHOOK), SAVE :: ZHOOK_HANDLE_BARR
CHARACTER*4 CC

CHARACTER(LEN=10) ::  CLDATEOD, CLZONEOD
INTEGER(KIND=JPIM) :: IVALUES(8)

! Change LLFINDSUMB to TRUE to add diagnostics to help find SUMB times
! Note that a similar setting exists in dr_hook_util for the same objective
LOGICAL :: LLFINDSUMB = .FALSE.
INTEGER(KIND=JPIM), SAVE :: ISUMBSTACK(10)
INTEGER(KIND=JPIM) :: J
REAL(KIND=JPRD)    :: SBYTES, RBYTES
INTEGER(KIND=JPIM) :: NSEND, NRECV
CHARACTER(LEN=4) :: CL_MAXSTAT
CHARACTER(LEN=66) :: CL_ERROR_MESSAGE

#include "user_clock.intfb.h"

! Process GSTATS calls if LSTATS is .TRUE. and we are the master
IF (LSTATS .AND. OML_MY_THREAD() == 1) THEN
  IF (.NOT. ALLOCATED(ZHOOK_HANDLE)) THEN
    NUM_THREADS = OML_GET_MAX_THREADS()
    ALLOCATE(ZHOOK_HANDLE(NUM_THREADS))
  ENDIF

  IF (LGSTATS_LABEL) THEN
    DO INUM = 1, JPMAXSTAT
      WRITE(CC,'(I4)') INUM
      CCDESC_BARR(INUM) = '>BAR-' // CCDESC(INUM)(1:21) // '(' // CC // ')'
    ENDDO
    DO INUM = 1, JPMAXSTAT
      WRITE(CC,'(I4)') INUM
      IF (CCTYPE(INUM) .EQ. "TRS" .OR. CCTYPE(INUM) .EQ. 'MP-' .OR. CCTYPE(INUM) .EQ. 'MPL' &
        & .OR. CCTYPE(INUM) .EQ. 'BAR' .OR. CCTYPE(INUM) .EQ. 'OMP') THEN
        CCDESC_DRHOOK(INUM) = '>' // CCTYPE(INUM) // '-' // CCDESC(INUM)(1:21) // '(' // CC // ')'
      ENDIF
    ENDDO
    LGSTATS_LABEL = .FALSE.
  ENDIF
!     ------------------------------------------------------------------

  CALL USER_CLOCK(PELAPSED_TIME=ZCLOCK)
  IF (LSTATSCPU .OR. KNUM == 0) THEN
    CALL USER_CLOCK(PTOTAL_CP=ZTCPU, PVECTOR_CP=ZVCPU)
  ELSE
    ZTCPU = 0.0_JPRD
    ZVCPU = 0.0_JPRD
  ENDIF

  IF (LLFIRST) THEN
    TIMESUM(:) = 0.0_JPRD
    NCALLS(:) = 0
  ENDIF

  IF (LHOOK .AND. (KSWITCH == 0 .OR. KSWITCH == 1)) THEN
    IF (CCTYPE(KNUM) .EQ. "TRS") THEN
      CALL DR_HOOK(CCDESC_DRHOOK(KNUM), KSWITCH, ZHOOK_HANDLE_TRANS)
    ELSEIF (CCTYPE(KNUM) .EQ. 'MP-') THEN
      CALL DR_HOOK(CCDESC_DRHOOK(KNUM), KSWITCH, ZHOOK_HANDLE_COMMS)
    ELSEIF (CCTYPE(KNUM) .EQ. 'MPL' .AND. KNUM .NE. 682) THEN
      CALL DR_HOOK(CCDESC_DRHOOK(KNUM), KSWITCH, ZHOOK_HANDLE_COMMS1)
    ELSEIF (CCTYPE(KNUM) .EQ. 'OMP') THEN
      ! The prevailing number of threads -- could now be less than the absolute max (i.e. export
      ! OMP_NUM_THREADS=<value>)
      INUMTH = OML_MAX_THREADS()
      CALL DR_HOOK(CCDESC_DRHOOK(KNUM), KSWITCH, ZHOOK_HANDLE(1:INUMTH))
    ELSEIF (CCTYPE(KNUM) .EQ. 'BAR')THEN
      CALL DR_HOOK(CCDESC_DRHOOK(KNUM), KSWITCH, ZHOOK_HANDLE_BARR)
    ENDIF
    ! Measure GSTATS HOOK overhead
    CALL USER_CLOCK(PELAPSED_TIME=ZCLOCK1)
    TIMESUM(401) = TIMESUM(401) + ZCLOCK1 - ZCLOCK
    NCALLS(401) = NCALLS(401) + 1
    ZCLOCK = ZCLOCK1
  ENDIF

  IF (LLFIRST) THEN

    NSWITCHVAL(:) = -1
    TIMESQSUM(:) = 0.0_JPRD
    TIMEMAX(:) = 0.0_JPRD
    TIMESUMB(:) = 0.0_JPRD
    IF (LLFINDSUMB) THEN
      ISUMBSTACK(:) = 0
    ENDIF
    TTCPUSUM(:) = 0.0_JPRD
    TVCPUSUM(:) = 0.0_JPRD
    TIMELCALL(:) = ZCLOCK
    CCDESC = ""
    CCTYPE = ""
    NTMEM = 0
    NTMEM(:,5) = 99999999
    IIMEM = 0
    IIPAG = 0
    IIMEMC = 0
    TIME_LAST_CALL = ZCLOCK
    LLFIRST = .FALSE.
  ENDIF

  ! Check KNUM is valid (> 0 and < JPMAXSTAT)
  IF (KNUM < 0) CALL ABOR1('GSTATS: KNUM cannot be negative')
  IF (KNUM > JPMAXSTAT) THEN
    WRITE(CL_MAXSTAT,'(I4)') JPMAXSTAT
    CALL ABOR1('GSTATS: KNUM cannot be greater than ' // CL_MAXSTAT)
  ENDIF

  IF (KSWITCH == 0 .OR. KSWITCH == 1) THEN
    NCALLS(KNUM) = NCALLS(KNUM) + 1
  ENDIF
  IMOD = MOD(NCALLS(KNUM), 2)

  ! Check we haven't opened or closed a region twice in a row
  IF (.NOT.((KSWITCH == 0 .AND. IMOD == 1) .OR. (KSWITCH == 2 .AND. IMOD == 1) .OR. &
    &       (KSWITCH == 3 .AND. IMOD == 1) .OR. (KSWITCH == 1 .AND. IMOD == 0))) THEN
    WRITE(CL_ERROR_MESSAGE,'(A42,I4)') "Invalid GSTATS call - check region KNUM = ", KNUM
    CALL ABOR1('GSTATS: ' // CL_ERROR_MESSAGE)
  ENDIF

  NSWITCHVAL(KNUM) = KSWITCH

  IF (KSWITCH == 0) THEN
    ! Start timing event
    IF (KNUM >= 500) THEN
      ZTIMED = ZCLOCK - TIME_LAST_CALL
      TIMESUMB(KNUM) = TIMESUMB(KNUM) + ZTIMED
    ELSE
      ZTIMED = 0.0_JPRD
    ENDIF

    IF (LLFINDSUMB .AND. MYPROC_STATS <= 2)THEN
      ! Diagnostic code to find source of sumb (this should only be activated temporarily)
      DO J = 9, 1, -1
        ISUMBSTACK(J+1) = ISUMBSTACK(J)
      ENDDO
      ISUMBSTACK(1) = KNUM
      IF (ZTIMED > 0.1_JPRD .AND. (TIMESUMB(KNUM) > 1.0_JPRD)) THEN
        WRITE(0,'("GSTATS(SUMB): KNUM=",I4," ZTIMED=",F10.6," TIMESUMB=",F10.6)') &
        & KNUM, ZTIMED, TIMESUMB(KNUM)
        DO J = 1, 10
          IF (ISUMBSTACK(J) > 0) THEN
            WRITE(0,'("GSTATS(SUMB): ",I4,2X,I8,2X,A40)') ISUMBSTACK(J), NCALLS(ISUMBSTACK(J)), &
              & CCDESC(ISUMBSTACK(J))
          ENDIF
        ENDDO
      ENDIF
      ! Check if grouped counters are overlapping
      DO J = 0, JPMAXSTAT
        IF (J /= KNUM)THEN
          IF (CCTYPE(J   ) /= '   ' .AND. CCTYPE(J   ) /= 'TRS' .AND. CCTYPE(J   ) /= 'MP-' .AND. &
            & CCTYPE(KNUM) /= '   ' .AND. CCTYPE(KNUM) /= 'TRS' .AND. CCTYPE(KNUM) /= 'MP-') THEN
            IF (NSWITCHVAL(J) == 0 .OR. NSWITCHVAL(J) == 3) THEN
              WRITE(0,'("GSTATS(SUMB): OVERLAPPING COUNTERS ",I4,2X,I4)') KNUM, J
            ENDIF
          ENDIF
        ENDIF
      ENDDO
    ENDIF

    THISTIME(KNUM) = 0.0_JPRD
    TIMELCALL(KNUM) = ZCLOCK
    TTCPULCALL(KNUM) = ZTCPU
    TVCPULCALL(KNUM) = ZVCPU
    THISTCPU(KNUM) = 0.0_JPRD
    THISVCPU(KNUM) = 0.0_JPRD
    IF (MYPROC_STATS .LE. NSTATS_MEM .AND. MYPROC_STATS .NE. 0) THEN
      IMEM = GETMAXRSS() / 1024
      IPAG = GETPAG()
      IMEMH = GETHWM() / 1024
      IMEMS = GETSTK() / 1024
      IMEMC = 0
      IF (LSTATS_ALLOC) IMEMC = GETCURHEAP() / 1024
      IF (IMEM > IIMEM .OR. IPAG > IIPAG .OR. (LSTATS_ALLOC .AND. (IMEMC .NE. IIMEMC))) THEN
        IF (LLMFIRST) THEN
          WRITE(0,*) ".---------------------------------------------------------"
          WRITE(0,*) "| Memory trace details"
          WRITE(0,*) "| --------------------"
          WRITE(0,*) "| Memory examined at each GSTATS call if NSTATS_MEM>0."
          WRITE(0,*) "| Header for each trace line is:"    
          WRITE(0,*) "|"
          WRITE(0,*) "|   RSS_INC: Increase in RSS_MAX (KB)"
          WRITE(0,*) "|   RSS_MAX: Maximum real working set so far (KB)"
          WRITE(0,*) "|   HEAP_MX: High Water Mark for heap so far (KB)"
          WRITE(0,*) "|   STK:     Current Stack usage (KB)"
          WRITE(0,*) "|   PGS:     Page faults w I/O since last trace line"
          WRITE(0,*) "|   CALL:    Number of gstats call"
          WRITE(0,*) "|   HEAP:    Current malloc'd total (KB)"
          WRITE(0,*) "|" 
          WRITE(0,*) "| Trace line written for NSTATS_MEM MPI tasks if RSS_MAX"
          WRITE(0,*) "| RSS_MAX increases, PGS>0, or HEAP changed"
          WRITE(0,*) "| (if LTATS_ALLOC=.TRUE.)"
          WRITE(0,*) "`---------------------------------------------------------"
          WRITE(0,*) ""
          WRITE(0,'(A10,A5,21X,A7,2A8,A7,A5,A5,A8)') &
           & "MEMORY    "," KNUM","RSS_INC"," RSS_MAX"," HEAP_MX","    STK", &
           & "  PGS"," CALL","    HEAP"
          LLMFIRST = .FALSE.
        ENDIF
        WRITE(0,'(A10,I5,1X,A20,1X,I6,2(1X,I7),1X,I6,1X,I4,1X,I4,1X,I7)') &
             & "MEMORY bfr", KNUM, CCDESC(KNUM), IMEM - IIMEM, IMEM, IMEMH, IMEMS, IPAG - IIPAG, &
             & (NCALLS(KNUM) + 1) / 2, IMEMC
      ENDIF
      NTMEM(KNUM,2) = IMEM
      IIMEM = IMEM
      IIPAG = IPAG
      IIMEMC = IMEMC
    ENDIF
    IF (LSTATS_MPL .AND. CCTYPE(KNUM) .EQ. 'MPL') THEN
      CALL MPL_STATSON(NSEND, SBYTES, NRECV, RBYTES)
      UNKNOWN_NUMSEND(KNUM) = UNKNOWN_NUMSEND(KNUM) + NSEND
      UNKNOWN_NUMRECV(KNUM) = UNKNOWN_NUMRECV(KNUM) + NRECV
      UNKNOWN_SENDBYTES(KNUM) = UNKNOWN_SENDBYTES(KNUM) + SBYTES
      UNKNOWN_RECVBYTES(KNUM) = UNKNOWN_RECVBYTES(KNUM) + RBYTES
    ENDIF
  ELSEIF (KSWITCH == 1) THEN
    ! Finish timing event
    ZTIME = THISTIME(KNUM) + (ZCLOCK - TIMELCALL(KNUM))
    IF (LSTATS_MPL .AND. CCTYPE(KNUM) .EQ. 'MPL') THEN
      CALL MPL_STATSREAD(NSEND, SBYTES, NRECV, RBYTES)
      NUMSEND(KNUM) = NUMSEND(KNUM) + NSEND
      NUMRECV(KNUM) = NUMRECV(KNUM) + NRECV
      SENDBYTES(KNUM) = SENDBYTES(KNUM) + SBYTES
      RECVBYTES(KNUM) = RECVBYTES(KNUM) + RBYTES
    ENDIF
    TIMESUM(KNUM) = TIMESUM(KNUM) + ZTIME
    TIMESQSUM(KNUM) = TIMESQSUM(KNUM) + ZTIME ** 2
    TIMEMAX(KNUM) = MAX(TIMEMAX(KNUM), ZTIME)
    TTCPUSUM(KNUM) = TTCPUSUM(KNUM) + THISTCPU(KNUM) + ZTCPU - TTCPULCALL(KNUM)
    TVCPUSUM(KNUM) = TVCPUSUM(KNUM) + THISVCPU(KNUM) + ZVCPU - TVCPULCALL(KNUM)
    IF (MYPROC_STATS .LE. NSTATS_MEM .AND. MYPROC_STATS .NE. 0) THEN
      IMEM = GETMAXRSS() / 1024
      IPAG = GETPAG()
      IMEMH = GETHWM() / 1024
      IMEMS = GETSTK() / 1024
      IMEMC = 0
      IF (LSTATS_ALLOC) IMEMC = GETCURHEAP() / 1024
      IF (IMEM > IIMEM .OR. IPAG > IIPAG .OR. (LSTATS_ALLOC .AND. (IMEMC .NE. IIMEMC))) THEN
        WRITE(0,'(A10,I5,1X,A20,1X,I6,2(1X,I7),1X,I6,1X,I4,1X,I4,1X,I7)') &
             & "MEMORY aft ", KNUM, CCDESC(KNUM), IMEM - IIMEM, IMEM, IMEMH, IMEMS, IPAG - IIPAG, &
             & NCALLS(KNUM) / 2, IMEMC
      ENDIF
      IIMEM = IMEM
      IIPAG = IPAG
      IIMEMC = IMEMC
      IMEM = IMEM - NTMEM(KNUM, 2)
      NTMEM(KNUM,4) = NTMEM(KNUM, 4) + IMEM
      IF (IMEM > NTMEM(KNUM,1)) THEN
        NTMEM(KNUM,1) = IMEM
        NTMEM(KNUM,3) = NCALLS(KNUM)
      ENDIF
      IF (IMEM < NTMEM(KNUM,5)) NTMEM(KNUM,5) = IMEM
    ENDIF
    ! Save counters that result in large delays
    IF (KNUM >= 500 .AND. NCALLS(KNUM) / 2 > 10)THEN
      IF (ZTIME > TIMESUM(KNUM) / FLOAT(NCALLS(KNUM)/2) + 0.2_JPRD) THEN
        ! Ignore counters 1007 and 1013 due to NFRLW frequency LW radiation calls 
        ! in ec_phys_tl and ec_phys_ad call trees
        ! also ignore 635 and 636 due to increasing sujbwavallo matrix sizes
        IF (KNUM /= 1007 .AND. KNUM /= 1013 .AND. KNUM /= 635 .AND. KNUM /= 636 ) THEN
          IF (NDELAY_INDEX < JPMAXDELAYS) THEN
            NDELAY_INDEX = NDELAY_INDEX + 1
            NDELAY_COUNTER(NDELAY_INDEX) = KNUM
            TDELAY_VALUE(NDELAY_INDEX) = ZTIME - TIMESUM(KNUM) / FLOAT(NCALLS(KNUM) / 2)
            CALL DATE_AND_TIME(CLDATEOD, CDELAY_TIME(NDELAY_INDEX), CLZONEOD, IVALUES)
          ENDIF
        ENDIF
      ENDIF
    ENDIF
  ELSEIF (KSWITCH == 2) THEN
    ! Suspend timing event
    ZTIMED = ZCLOCK - TIMELCALL(KNUM)
    THISTIME(KNUM) = THISTIME(KNUM) + ZTIMED
    THISTCPU(KNUM) = THISTCPU(KNUM) + ZTCPU - TTCPULCALL(KNUM)
    THISVCPU(KNUM) = THISVCPU(KNUM) + ZVCPU - TVCPULCALL(KNUM)
    IF (LSTATS_MPL .AND. CCTYPE(KNUM) .EQ. 'MPL') THEN
      CALL MPL_STATSREAD(NSEND, SBYTES, NRECV, RBYTES)
      NUMSEND(KNUM) = NUMSEND(KNUM) + NSEND
      NUMRECV(KNUM) = NUMRECV(KNUM) + NRECV
      SENDBYTES(KNUM) = SENDBYTES(KNUM) + SBYTES
      RECVBYTES(KNUM) = RECVBYTES(KNUM) + RBYTES
    ENDIF
  ELSEIF (KSWITCH == 3) THEN
    ! Resume timing event
    TIMELCALL(KNUM) = ZCLOCK
    TTCPULCALL(KNUM) = ZTCPU
    TVCPULCALL(KNUM) = ZVCPU
    IF (LSTATS_MPL .AND. CCTYPE(KNUM) .EQ. 'MPL') THEN
      CALL MPL_STATSON(NSEND, SBYTES, NRECV, RBYTES)
      UNKNOWN_NUMSEND(KNUM) = UNKNOWN_NUMSEND(KNUM) + NSEND
      UNKNOWN_NUMRECV(KNUM) = UNKNOWN_NUMRECV(KNUM) + NRECV
      UNKNOWN_SENDBYTES(KNUM) = UNKNOWN_SENDBYTES(KNUM) + SBYTES
      UNKNOWN_RECVBYTES(KNUM) = UNKNOWN_RECVBYTES(KNUM) + RBYTES
    ENDIF
    IF (KNUM >= 500) THEN
      ZTIMED = ZCLOCK - TIME_LAST_CALL
      TIMESUMB(KNUM) = TIMESUMB(KNUM) + ZTIMED
    ENDIF
  ENDIF
  IF (KNUM >= 500) THEN
    TIME_LAST_CALL = ZCLOCK
  ENDIF

  ! Trace stats
  NCALLS_TOTAL = NCALLS_TOTAL + 1
  IF (LTRACE_STATS .AND. NCALLS_TOTAL <= NTRACE_STATS) THEN
    ICALL = NCALLS_TOTAL
    TIME_TRACE(ICALL) = ZCLOCK
    NCALL_TRACE(ICALL) = (JPMAXSTAT+1) * KSWITCH + KNUM
  ENDIF

  ! Measure gstats overhead
  CALL USER_CLOCK(PELAPSED_TIME=ZCLOCK1)
  TIMESUM(400) = TIMESUM(400) + ZCLOCK1 - ZCLOCK
  NCALLS(400) = NCALLS(400) + 1
  LAST_KSWITCH = KSWITCH
  LAST_KNUM = KNUM
  
ENDIF

END SUBROUTINE GSTATS

! (C) Copyright 2005- ECMWF.
! (C) Copyright 2013- Meteo-France.
! 
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!

!OPTIONS NOOPT
MODULE STRHANDLER_MOD

USE EC_PARKIND  ,ONLY : JPIM, JPRM, JPRD

IMPLICIT NONE

PRIVATE

PUBLIC :: TOLOWER, TOUPPER, EXPAND_STRING
PUBLIC :: SADJUSTL, SADJUSTR
PUBLIC :: STRANSFER

INTERFACE STRANSFER
MODULE PROCEDURE &
  STRANSFER_R8_TO_STR, STRANSFER_STR_TO_R8, &
& STRANSFER_R4_TO_STR, STRANSFER_STR_TO_R4
END INTERFACE

CONTAINS

FUNCTION STRANSFER_R8_TO_STR(SOURCE, MOLD) RESULT(C)
REAL(KIND=JPRD) , INTENT(IN) :: SOURCE
CHARACTER(LEN=*), INTENT(IN) :: MOLD
CHARACTER(LEN=8) :: C
CALL ECMWF_TRANSFER(C,MIN(8,LEN(MOLD)),SOURCE,8)
END FUNCTION STRANSFER_R8_TO_STR


FUNCTION STRANSFER_STR_TO_R8(SOURCE, MOLD) RESULT(Z)
CHARACTER(LEN=*), INTENT(IN) :: SOURCE
REAL(KIND=JPRD) , INTENT(IN) :: MOLD
REAL(KIND=JPRD) :: Z
CALL ECMWF_TRANSFER(Z,8,SOURCE,LEN(SOURCE))
END FUNCTION STRANSFER_STR_TO_R8


FUNCTION STRANSFER_R4_TO_STR(SOURCE, MOLD) RESULT(C)
REAL(KIND=JPRM) , INTENT(IN) :: SOURCE
CHARACTER(LEN=*), INTENT(IN) :: MOLD
CHARACTER(LEN=4) :: C
CALL ECMWF_TRANSFER(C,MIN(4,LEN(MOLD)),SOURCE,4)
END FUNCTION STRANSFER_R4_TO_STR


FUNCTION STRANSFER_STR_TO_R4(SOURCE, MOLD) RESULT(Z)
CHARACTER(LEN=*), INTENT(IN) :: SOURCE
REAL(KIND=JPRM) , INTENT(IN) :: MOLD
REAL(KIND=JPRM) :: Z
CALL ECMWF_TRANSFER(Z,4,SOURCE,LEN(SOURCE))
END FUNCTION STRANSFER_STR_TO_R4


FUNCTION SADJUSTL(S) RESULT(C)
CHARACTER(LEN=*), INTENT(IN) :: S
CHARACTER(LEN=MAX(1,LEN(S))) C
C = ' '
IF (LEN(S) > 0) THEN
  IF (S /= ' ') C = ADJUSTL(S)
ENDIF
END FUNCTION SADJUSTL


FUNCTION SADJUSTR(S) RESULT(C)
CHARACTER(LEN=*), INTENT(IN) :: S
CHARACTER(LEN=MAX(1,LEN(S))) C
C = ' '
IF (LEN(S) > 0) THEN
  IF (S /= ' ') C = ADJUSTR(S)
ENDIF
END FUNCTION SADJUSTR


SUBROUTINE TOLOWER(CDS)
CHARACTER(LEN=*), INTENT(INOUT) :: CDS
INTEGER(KIND=JPIM), PARAMETER :: ICH_A = ICHAR('a')
INTEGER(KIND=JPIM), PARAMETER :: ICHA  = ICHAR('A')
INTEGER(KIND=JPIM), PARAMETER :: ICHZ  = ICHAR('Z')
INTEGER(KIND=JPIM) :: I, ICH, NEW_ICH
CHARACTER(LEN=1) CH
DO I=1,LEN(CDS)
  CH = CDS(I:I)
  ICH = ICHAR(CH)
  IF ( ICH >= ICHA .AND. ICH <= ICHZ ) THEN
    NEW_ICH = ICH + (ICH_A - ICHA)
    CH = CHAR(NEW_ICH)
    CDS(I:I) = CH
  ENDIF
ENDDO
END SUBROUTINE TOLOWER


SUBROUTINE TOUPPER(CDS)
CHARACTER(LEN=*), INTENT(INOUT) :: CDS
INTEGER(KIND=JPIM), PARAMETER :: ICH_A = ICHAR('A')
INTEGER(KIND=JPIM), PARAMETER :: ICHA  = ICHAR('a')
INTEGER(KIND=JPIM), PARAMETER :: ICHZ  = ICHAR('z')
INTEGER(KIND=JPIM) :: I, ICH, NEW_ICH
CHARACTER(LEN=1) CH
DO I=1,LEN(CDS)
  CH = CDS(I:I)
  ICH = ICHAR(CH)
  IF ( ICH >= ICHA .AND. ICH <= ICHZ ) THEN
    NEW_ICH = ICH + (ICH_A - ICHA)
    CH = CHAR(NEW_ICH)
    CDS(I:I) = CH
  ENDIF
ENDDO
END SUBROUTINE TOUPPER


SUBROUTINE EXPAND_STRING(&
     &MYPROC,               &! %p
     &nproc,                &! %n
     &timestep,             &! %t
     &max_timestep,&
     &s)                   ! %s

INTEGER(KIND=JPIM), INTENT(IN)          :: MYPROC, NPROC
INTEGER(KIND=JPIM), INTENT(IN)          :: TIMESTEP, MAX_TIMESTEP
CHARACTER(LEN=*), INTENT(INOUT) :: S(:)
CHARACTER(LEN=2*LEN(S))  T
CHARACTER(LEN=2*LEN(S)) TT
INTEGER(KIND=JPIM) :: I, J, JJ, LOC_P, LEN_T, N
INTEGER(KIND=JPIM) :: NDIGS(4), NUM(4)
CHARACTER(LEN=6) FMT(4)

N = SIZE(S)

IF (N < 1) RETURN

!*    Setup output formats
NUM(1) = MYPROC
NUM(2) = MAX(NPROC,MYPROC)
NUM(3) = N
NUM(4) = MAX(MAX_TIMESTEP,TIMESTEP)

!*    Count number of digits in each integer
DO J=1,4
  NDIGS(J) = 1
  IF (NUM(J) /= 0) THEN
    NDIGS(J) = 1 + LOG10(DBLE(ABS(NUM(J))))
    IF (NUM(J) < 0) NDIGS(J) = NDIGS(J) + 1 ! Room for minus sign
  ENDIF
  NDIGS(J) = MIN(NDIGS(J),9)   ! Max 9 digits supported; i.e. '999999999'
  WRITE(FMT(J),'("(i",i1,")")') NDIGS(J)
ENDDO


!*    Expand fields '%s', '%p', '%n' and '%t' with their values


!*    A special treatment with the sequence numbering
IF (N>1) THEN
  LOC_P = INDEX(S(1),'%s')
  IF (LOC_P > 0) THEN
    S(2:) = S(1)
  ENDIF
ENDIF

DO I=1,N
  T = ADJUSTL(S(I))//' '
  LOC_P = INDEX(T,'%')

  IF (LOC_P > 0) THEN
    LEN_T = LEN_TRIM(T)
    J = LOC_P
    TT(:J-1) = T(:J-1)
    TT(J:) = ' '
    JJ = J-1

    DO WHILE (J <= LEN_T)
      IF (T(J:J) == '%') THEN
        J = J + 1
        IF (J <= LEN_T) THEN
          SELECT CASE ( T(J:J) )
          CASE ( 'p' )   ! myproc
          WRITE(TT(JJ+1:JJ+NDIGS(1)),FMT(1)) MYPROC
          JJ = JJ + NDIGS(1)
          CASE ( 'n' )   ! nproc
          WRITE(TT(JJ+1:JJ+NDIGS(2)),FMT(2)) NPROC
          JJ = JJ + NDIGS(2)
          CASE ( 's' )   ! sequence number i=[1..n]
          WRITE(TT(JJ+1:JJ+NDIGS(3)),FMT(3)) I
          JJ = JJ + NDIGS(3)
          CASE ( 't' )   ! timestep
          WRITE(TT(JJ+1:JJ+NDIGS(4)),FMT(4)) TIMESTEP
          JJ = JJ + NDIGS(4)
          CASE DEFAULT
          TT(JJ+1:JJ+2) = '%'//T(J:J)
          JJ = JJ + 2
          END SELECT
        ELSE
          TT(JJ+1:JJ+1) = '%'
          JJ = JJ + 1
        ENDIF
      ELSE
        TT(JJ+1:JJ+1) = T(J:J)
        JJ = JJ + 1
      ENDIF
      J = J + 1
    ENDDO

    T = ADJUSTL(TT)

!*   Get also rid of any blanks in the middle of the string

    LEN_T = LEN_TRIM(T)
    J = 1
    DO WHILE (J < LEN_T)
      IF (T(J:J) == ' ') THEN
        T(J:) = T(J+1:)
        LEN_T = LEN_TRIM(T)
      ELSE
        J = J + 1
      ENDIF
    ENDDO

  ENDIF

  S(I) = T
ENDDO

END SUBROUTINE EXPAND_STRING

END MODULE STRHANDLER_MOD

! (C) Copyright 2005- ECMWF.
! (C) Copyright 2013- Meteo-France.
! 
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!

SUBROUTINE GSTATS_SETUP( KPROC,KMYPROC,KPRCIDS,&
 & LDSTATS,LDSTATSCPU,LDSYNCSTATS,LDDETAILED_STATS,LDBARRIER_STATS,LDBARRIER_STATS2,&
 & LDSTATS_OMP,LDSTATS_COMMS,LDSTATS_MEM,KSTATS_MEM,LDSTATS_ALLOC,&
 & LDTRACE_STATS,KTRACE_STATS,KPRNT_STATS,LDXML_STATS)

!**** *GSTATS_SETUP*  - Setup stats package

!     PURPOSE.  
!     --------
!      Setup gstats package


!**   INTERFACE.
!     ----------
!       *CALL* *GSTATS_SETUP

!        EXPLICIT ARGUMENTS   None
!        --------------------

!        IMPLICIT ARGUMENTS
!        --------------------
!        Module YOMSTATS

!     METHOD.
!     -------


!     EXTERNALS.   USER_CLOCK - timing routine
!     ----------

!     REFERENCE.
!     ----------
!        ECMWF Research Department documentation of the IFS

!     AUTHOR.
!     -------
!        Mats Hamrud ECMWF

!     MODIFICATIONS.
!     --------------
!        ORIGINAL : 98-11-15
!        I. Hadade  19-05-20  Removed LDSTATS_MPL as not used and enabled collection
!                             of MPL send/recv statistics if LDETAILED_STATS is true
!                             rather than LBARRIER_STATS
!     ------------------------------------------------------------------

USE EC_PARKIND, ONLY: JPIM, JPRD
USE YOMGSTATS, ONLY: LSTATS, LSTATSCPU, LSYNCSTATS, LDETAILED_STATS, LBARRIER_STATS, &
  &                  LBARRIER_STATS2, LXML_STATS, LSTATS_OMP, LSTATS_COMMS, NSTATS_MEM, &
  &                  LSTATS_MEM, LSTATS_ALLOC, LTRACE_STATS, NTRACE_STATS, MYPROC_STATS, &
  &                  NPROC_STATS, NPRCIDS_STATS, NCALL_TRACE, TIME_TRACE, LSTATS_MPL, NUMSEND, &
  &                  NUMRECV, SENDBYTES, RECVBYTES, UNKNOWN_NUMSEND, UNKNOWN_NUMRECV, &
  &                  UNKNOWN_SENDBYTES, UNKNOWN_RECVBYTES, NPRNT_STATS
USE MPL_STATS_MOD, ONLY: MPL_STATSINIT

IMPLICIT NONE

LOGICAL :: LDSTATS
LOGICAL :: LDSTATSCPU
LOGICAL :: LDSYNCSTATS
LOGICAL :: LDDETAILED_STATS
LOGICAL :: LDBARRIER_STATS
LOGICAL :: LDBARRIER_STATS2
LOGICAL :: LDSTATS_OMP
LOGICAL :: LDSTATS_COMMS
LOGICAL :: LDTRACE_STATS
INTEGER(KIND=JPIM) :: KTRACE_STATS
INTEGER(KIND=JPIM) :: KPROC,KMYPROC
INTEGER(KIND=JPIM) :: KPRCIDS(KPROC)
INTEGER(KIND=JPIM) :: KSTATS_MEM
INTEGER(KIND=JPIM) :: KPRNT_STATS
LOGICAL :: LDSTATS_MEM
LOGICAL :: LDSTATS_ALLOC
LOGICAL :: LDXML_STATS
!     ------------------------------------------------------------------

LSTATS = LDSTATS
LSTATSCPU = LDSTATSCPU
LSYNCSTATS = LDSYNCSTATS
LDETAILED_STATS=LDDETAILED_STATS
LBARRIER_STATS=LDBARRIER_STATS
LBARRIER_STATS2=LDBARRIER_STATS2
LXML_STATS=LDXML_STATS
LSTATS_OMP = LDSTATS_OMP
LSTATS_COMMS = LDSTATS_COMMS
NSTATS_MEM = KSTATS_MEM
LSTATS_MEM = LDSTATS_MEM
LSTATS_ALLOC = LDSTATS_ALLOC
LTRACE_STATS = LDTRACE_STATS
IF (LTRACE_STATS) NTRACE_STATS = KTRACE_STATS

MYPROC_STATS = KMYPROC
NPROC_STATS  = KPROC
ALLOCATE(NPRCIDS_STATS(NPROC_STATS))
NPRCIDS_STATS(:) = KPRCIDS(1:NPROC_STATS)
IF (NPROC_STATS == 1) LSYNCSTATS = .FALSE.

IF (LTRACE_STATS .AND. NTRACE_STATS > 0) THEN
  ALLOCATE(NCALL_TRACE(NTRACE_STATS))
  ALLOCATE(TIME_TRACE (NTRACE_STATS))
  NCALL_TRACE(:) = 0
  TIME_TRACE (:) = 0.0_JPRD
ENDIF


IF (LDETAILED_STATS) THEN
  LSTATS_MPL = .TRUE.
  ALLOCATE(NUMSEND(501:1000))
  ALLOCATE(NUMRECV(501:1000))
  ALLOCATE(SENDBYTES(501:1000))
  ALLOCATE(RECVBYTES(501:1000))
  ALLOCATE(UNKNOWN_NUMSEND(501:1000))
  ALLOCATE(UNKNOWN_NUMRECV(501:1000))
  ALLOCATE(UNKNOWN_SENDBYTES(501:1000))
  ALLOCATE(UNKNOWN_RECVBYTES(501:1000))
  NUMSEND(:) = 0
  NUMRECV(:) = 0
  SENDBYTES(:) = 0
  RECVBYTES(:) = 0
  UNKNOWN_NUMSEND(:) = 0
  UNKNOWN_NUMRECV(:) = 0
  UNKNOWN_SENDBYTES(:) = 0
  UNKNOWN_RECVBYTES(:) = 0
  CALL MPL_STATSINIT
ENDIF

NPRNT_STATS = KPRNT_STATS

END SUBROUTINE GSTATS_SETUP

C (C) Copyright 2005- ECMWF.
C (C) Copyright 2013- Meteo-France.
C 
C This software is licensed under the terms of the Apache Licence Version 2.0
C which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      subroutine mpi_irecv
      call abort()
      return
      end

! (C) Copyright 2005- ECMWF.
! 
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!

program drhook_ex2
use yomhook, only : jphook, dr_hook
use dr_hook_watch_mod, only : dr_hook_watch
implicit none
integer(4) :: n
real(8), allocatable :: a(:)
integer(4) :: j
character(len=256) a_out
character(len=20) cn
real(jphook) :: zhook_handle
call dr_hook('drhook_ex2',0,zhook_handle)
n = 5
allocate(a(n))
do j=1,n
  a(j) = j-1
enddo
! Watch & fail when A gets altered
call dr_hook_watch('a(:)',a,LDABORT=.TRUE.,LDPRINT=.FALSE.,LDTRBK=.FALSE.)
call sub1(a,n)
deallocate(a)
call dr_hook('drhook_ex2',1,zhook_handle)
end program drhook_ex2

subroutine sub1(a,n)
use yomhook, only : jphook, dr_hook
implicit none
integer(4), intent(in) :: n
real(8), intent(inout) :: a(n)
real(jphook) :: zhook_handle
call dr_hook('sub1',0,zhook_handle)
if (n > 0) call sub2(a(1))
call dr_hook('sub1',1,zhook_handle)
end subroutine sub1

subroutine sub2(s)
use yomhook, only : jphook, dr_hook
implicit none
real(8), intent(inout) :: s
real(jphook) :: zhook_handle
call dr_hook('sub2',0,zhook_handle)
!s = 1/s ! divide by zero removed
s = 1 ! a(1) has now been altered --> watch point should detect this
call dr_hook('sub2',1,zhook_handle)
end subroutine sub2

! (C) Copyright 2005- ECMWF.
!
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
!
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.

program drhook_ex5
use mpl_module
use yomhook, only : jphook, dr_hook
use sdl_mod, only : sdl_traceback
implicit none
integer j, numargs
integer jpe, npes, mype
character(len=256) arg, env
real(jphook) :: zhook_handle
call mpl_init(ldinfo=.false.)
call dr_hook('drhook_ex5',0,zhook_handle)
npes = mpl_nproc()
mype = mpl_myrank()
do jpe=1,npes
   if (jpe == mype) then
      write(0,1000) mype,&
           & ': Basic MPL/MPI implementation works : # of MPI-tasks = ',npes
      numargs = mpl_iargc()
      write(0,1000) mype,&
           & ': Number of args = ',numargs
      do j=0,numargs
         call mpl_getarg(j,arg)
         write(0,1001) mype, ': arg#', j, ' "'//trim(arg)//'"'
      enddo
      call get_environment_variable('MPICH_ROOT',env)
      write(0,1002) mype, ': env MPICH_ROOT="'//trim(env)//'"'
      call ec_flush(0)
   endif
   call mpl_barrier()
enddo
call mpl_barrier()
call sdl_traceback() ! Testing traceback, too
call mpl_end()
1000  format(i5,a,i5)
1001  format(i5,a,i2,a)
1002  format(i5,a)
call dr_hook('drhook_ex5',1,zhook_handle)
end program drhook_ex5

! (C) Copyright 2005- ECMWF.
! (C) Copyright 2013- Meteo-France.
! 
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!

MODULE MPL_COMM_SPLIT_MOD

!**** *MPL_COMM_SPLIT* - Split a communicator

!     Author. 
!     ------- 
!      Philippe Marguinaud *METEO FRANCE*
!      Original : 11-09-2012


USE EC_PARKIND, ONLY : JPIM 
USE MPL_MPIF, ONLY : MPI_UNDEFINED

IMPLICIT NONE

PRIVATE
PUBLIC MPL_COMM_SPLIT

CONTAINS 

SUBROUTINE MPL_COMM_SPLIT (KCOMM, KCOLOR, KKEY, KNEWCOMM, KERROR, CDSTRING)
INTEGER (KIND=JPIM), INTENT (IN)  :: KCOMM
INTEGER (KIND=JPIM), INTENT (IN)  :: KCOLOR
INTEGER (KIND=JPIM), INTENT (IN)  :: KKEY
INTEGER (KIND=JPIM), INTENT (OUT) :: KNEWCOMM
INTEGER (KIND=JPIM), INTENT (OUT) :: KERROR
CHARACTER (LEN=*), OPTIONAL, INTENT (IN) :: CDSTRING
INTEGER (KIND=JPIM) :: ICOLOR

ICOLOR=KCOLOR
IF(ICOLOR<0) ICOLOR=MPI_UNDEFINED

CALL MPI_COMM_SPLIT (KCOMM, ICOLOR, KKEY, KNEWCOMM, KERROR)

END SUBROUTINE MPL_COMM_SPLIT

END MODULE MPL_COMM_SPLIT_MOD

! (C) Copyright 2005- ECMWF.
! (C) Copyright 2013- Meteo-France.
! 
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!

MODULE YOMGSTATS

USE EC_PARKIND, ONLY: JPRD, JPIM

IMPLICIT NONE

SAVE

PRIVATE :: JPRD, JPIM

!     ------------------------------------------------------------------
! Module for timing statistics. Module is internal to the GSTATS package -
! routines GSTATS, SUSTATS and STATS_OUTPUT. The logical switches are
! re-initialized in SUMPINI

! LSTATS - TRUE for gathering timing statistics
! LSTATSCPU - TRUE for gathering CPU timing  statistics
! LSYNCSTATS - TRUE for syncronization (call to barrier) at the 
!              start of timing event
! LDETAILED_STATS - TRUE for more detail in output
! LXML_STATS - TRUE for stats output in XML
! LSTATS_OMP - TRUE for gathering timing statistics on OpenMP regions
!                 1001-1999
! LSTATS_COMMS - TRUE for gathering detailed timing of Message passing
!                 501-1000
! LSTATS_MPL   - TRUE for gathering detailed info on message passing
! NTRACE_STATS    - max number of entries in trace
! LTRACE_STATS    - True for trace of all calls to gstats
! LGSTATS_LABEL   - True after GSTATS-labels have been set
! JPMAXSTAT - max number of separate  timers in gstats
! JPOBCOUNT_BASE - first counter for obs types
! NCALLS - number of times a timer has been switched on
! TIMESUM - total time spent with timer on
! TIMESQSUM - sum of the squares of times
! TIMEMAX - max time of all calls
! TIMESUMB - sum of times between previous timer was invoked and this
!            timer was switched on ( to be used for finding out which parts
!            of the code that is not being timed)
! TIMELCALL - time when event was switched on or resumed
! TTCPUSUM - total cpu time
! TVCPUSUM - total vector cpu time
! THISTIME - total accumulated time for this call to timing event (necessary
!            to be able to suspend and resume timer and still have it counted
!            as one timing event)
! THISTCPU - as THISTIME but for CPU time
! THISVCPU - as THISTIME but for vector CPU time
! TTCPULCALL - as TIMELCALL but for CPU time
! TVCPULCALL - as TIMELCALL but for vector CPU time
! TIME_LAST_CALL - last time GSTATS was called
! TIME_START - used for recording parallel startup time
!
! NSWITCHVAL - for detecting overlapping counters


LOGICAL :: LSTATS = .TRUE.
LOGICAL :: LSTATS_OMP = .FALSE.
LOGICAL :: LSTATS_COMMS = .FALSE.
LOGICAL :: LSTATS_MPL = .FALSE.
LOGICAL :: LSTATS_MEM = .FALSE.
LOGICAL :: LSTATS_ALLOC = .FALSE.
LOGICAL :: LSTATSCPU = .TRUE.
LOGICAL :: LSYNCSTATS = .FALSE.
LOGICAL :: LXML_STATS = .FALSE.
LOGICAL :: LDETAILED_STATS = .TRUE.
LOGICAL :: LBARRIER_STATS = .FALSE.
LOGICAL :: LBARRIER_STATS2 = .FALSE.
LOGICAL :: LTRACE_STATS = .FALSE.
LOGICAL :: LGSTATS_LABEL = .FALSE.

INTEGER(KIND=JPIM),PARAMETER :: JBMAXBASE=2500
INTEGER(KIND=JPIM),PARAMETER :: JPMAXBARS=500
INTEGER(KIND=JPIM),PARAMETER :: JPMAXSTAT=JBMAXBASE+JPMAXBARS

INTEGER(KIND=JPIM),PARAMETER :: JPOBCOUNT_BASE=201
INTEGER(KIND=JPIM) :: NTRACE_STATS=0
INTEGER(KIND=JPIM) :: NCALLS(0:JPMAXSTAT)
INTEGER(KIND=JPIM) :: NSWITCHVAL(0:JPMAXSTAT)
INTEGER(KIND=JPIM) :: NCALLS_TOTAL=0
INTEGER(KIND=JPIM) :: LAST_KSWITCH=0
INTEGER(KIND=JPIM) :: LAST_KNUM=0
INTEGER(KIND=JPIM) :: NHOOK_MESSAGES=0
INTEGER(KIND=JPIM) :: NBAR_PTR(0:JPMAXSTAT)=0
INTEGER(KIND=JPIM) :: NBAR2=JBMAXBASE+1
INTEGER(KIND=JPIM),ALLOCATABLE :: NCALL_TRACE(:)
INTEGER(KIND=JPIM),ALLOCATABLE :: NUMSEND(:)
INTEGER(KIND=JPIM),ALLOCATABLE :: NUMRECV(:)
REAL(KIND=JPRD),ALLOCATABLE :: SENDBYTES(:)
REAL(KIND=JPRD),ALLOCATABLE :: RECVBYTES(:)
INTEGER(KIND=JPIM),ALLOCATABLE :: UNKNOWN_NUMSEND(:)
INTEGER(KIND=JPIM),ALLOCATABLE :: UNKNOWN_NUMRECV(:)
REAL(KIND=JPRD),ALLOCATABLE :: UNKNOWN_SENDBYTES(:)
REAL(KIND=JPRD),ALLOCATABLE :: UNKNOWN_RECVBYTES(:)

REAL(KIND=JPRD) :: TIMESUM(0:JPMAXSTAT)
REAL(KIND=JPRD) :: TIMESQSUM(0:JPMAXSTAT)
REAL(KIND=JPRD) :: TIMEMAX(0:JPMAXSTAT)
REAL(KIND=JPRD) :: TIMESUMB(0:JPMAXSTAT)
REAL(KIND=JPRD) :: TIMELCALL(0:JPMAXSTAT)
REAL(KIND=JPRD) :: TTCPUSUM(0:JPMAXSTAT)
REAL(KIND=JPRD) :: TVCPUSUM(0:JPMAXSTAT)
REAL(KIND=JPRD) :: THISTIME(0:JPMAXSTAT)
REAL(KIND=JPRD) :: THISTCPU(0:JPMAXSTAT)
REAL(KIND=JPRD) :: THISVCPU(0:JPMAXSTAT)
REAL(KIND=JPRD) :: TTCPULCALL(0:JPMAXSTAT)
REAL(KIND=JPRD) :: TVCPULCALL(0:JPMAXSTAT)
REAL(KIND=JPRD) :: TIME_LAST_CALL

REAL(KIND=JPRD),ALLOCATABLE :: TIME_START(:)
REAL(KIND=JPRD),ALLOCATABLE :: TIME_TRACE(:)
INTEGER(KIND=JPIM),PARAMETER :: JPERR=0
INTEGER(KIND=JPIM),PARAMETER :: JPTAGSTAT=20555

INTEGER(KIND=JPIM),PARAMETER :: JPMAXDELAYS=1000
INTEGER(KIND=JPIM) :: NDELAY_COUNTER(1:JPMAXDELAYS)
REAL(KIND=JPRD)    :: TDELAY_VALUE(1:JPMAXDELAYS)
CHARACTER*10       :: CDELAY_TIME(1:JPMAXDELAYS)
INTEGER(KIND=JPIM) :: NDELAY_INDEX = 0

CHARACTER*50 :: CCDESC(0:JPMAXSTAT) = ""
CHARACTER*3  :: CCTYPE(0:JPMAXSTAT) = ""

INTEGER(KIND=JPIM) :: NPROC_STATS = 1
INTEGER(KIND=JPIM) :: MYPROC_STATS = 1
INTEGER(KIND=JPIM),ALLOCATABLE :: NPRCIDS_STATS(:)

INTEGER(KIND=JPIM) :: NTMEM(0:JPMAXSTAT,5)
INTEGER(KIND=JPIM) :: NSTATS_MEM=0

INTEGER(KIND=JPIM) :: NPRNT_STATS=3

END MODULE YOMGSTATS

! (C) Copyright 2025- ECMWF.
! 
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.

PROGRAM TEST_MPL_SPLIT_COMM

USE EC_PARKIND, ONLY: JPIM
USE MPL_MODULE, ONLY: MPL_INIT, MPL_NPROC, MPL_MYRANK, MPL_COMM, MPL_COMM_SPLIT, MPL_SETDFLT_COMM, &
  &                   MPL_ABORT, MPL_END

IMPLICIT NONE

INTEGER(JPIM), PARAMETER :: STDOUT = 6

INTEGER(JPIM) :: IGLOBAL_NPROC, IGLOBAL_RANK, ISPLIT_COLOUR, IERROR, ISPLIT_COMM, IDUMMY_COMM
INTEGER(JPIM) :: ISPLIT_RANK, ISPLIT_NPROC

CALL MPL_INIT

IGLOBAL_NPROC = MPL_NPROC()
IGLOBAL_RANK = MPL_MYRANK()

! First rank in group 0, others in group 1
ISPLIT_COLOUR = MERGE(0, 1, IGLOBAL_RANK == 1)

! Split world communicator according to rank colour
CALL MPL_COMM_SPLIT(MPL_COMM, ISPLIT_COLOUR, IGLOBAL_RANK, ISPLIT_COMM, IERROR)

IF (IERROR /= 0) THEN
  CALL MPL_ABORT("TEST_MPL_SPLIT_COMM: MPL_COMM_SPLIT failed")
ENDIF

! Set new split communicator as default
CALL MPL_SETDFLT_COMM(ISPLIT_COMM, IDUMMY_COMM)

! Get rank and comm size in new split communicator
ISPLIT_RANK = MPL_MYRANK()
ISPLIT_NPROC = MPL_NPROC()

! Check all values are correct
IF (IGLOBAL_RANK == 1) THEN
  IF (ISPLIT_NPROC /= 1) THEN
    CALL MPL_ABORT("TEST_MPL_SPLIT_COMM: 1st split comm does not have 1 rank")
  ENDIF
  IF (ISPLIT_RANK /= 1) THEN
    CALL MPL_ABORT("TEST_MPL_SPLIT_COMM: 1st global rank is not 1st rank in 1st split comm")
  ENDIF
ELSE
  IF (ISPLIT_NPROC /= IGLOBAL_NPROC - 1) THEN
    CALL MPL_ABORT("TEST_MPL_SPLIT_COMM: 2nd split comm does not have correct # ranks")
  ENDIF
  IF (ISPLIT_RANK /= IGLOBAL_RANK - 1) THEN
    CALL MPL_ABORT("TEST_MPL_SPLIT_COMM: rank does not have correct number in 2nd split comm")
  ENDIF
ENDIF

CALL MPL_END(LDMEMINFO=.FALSE.)

END PROGRAM TEST_MPL_SPLIT_COMM

! (C) Copyright 2005- ECMWF.
! (C) Copyright 2013- Meteo-France.
! 
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!

MODULE MPL_MPIF
#include "mpif.h"
END MODULE MPL_MPIF

! (C) Copyright 2005- ECMWF.
! (C) Copyright 2005- Meteo France.
! 
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!

! Sort character strings
SUBROUTINE QSORTC (N,ORD,A)
USE EC_PARKIND, ONLY : JPIM
IMPLICIT NONE
      
INTEGER(KIND=JPIM), INTENT(IN)    :: N
INTEGER(KIND=JPIM), INTENT(INOUT) :: ORD(N)
CHARACTER(LEN=*),   INTENT(IN)    :: A(N)

INTEGER(KIND=JPIM) :: I,IP,IQ,IX,IZ,L,L1,NDEEP,P
INTEGER(KIND=JPIM) :: POPLST(2,20)
INTEGER(KIND=JPIM) :: Q,U,U1,YP

CHARACTER(LEN=LEN(A)) :: X,XX,Z,ZZ,Y

      NDEEP=0
      U1=N
      L1=1
      DO I=1,N
        ORD(I)=I
      ENDDO
    2 IF (U1.LE.L1) RETURN

    3 L=L1
      U=U1
    4 P=L
      Q=U

      X=A(ORD(P))
      Z=A(ORD(Q))
      IF (X.LE.Z) GO TO 5
      Y=X
      X=Z
      Z=Y
      YP=ORD(P)
      ORD(P)=ORD(Q)
      ORD(Q)=YP
    5 IF (U-L.LE.1) GO TO 15
      XX=X
      IX=P
      ZZ=Z
      IZ=Q

    6 P=P+1
      IF (P.GE.Q) GO TO 7
      X=A(ORD(P))
      IF (X.GE.XX) GO TO 8
      GO TO 6
    7 P=Q-1
      GO TO 13

    8 Q=Q-1
      IF (Q.LE.P) GO TO 9
      Z=A(ORD(Q))
      IF (Z.LE.ZZ) GO TO 10
      GO TO 8
    9 Q=P
      P=P-1
      Z=X
      X=A(ORD(P))

   10 IF (X.LE.Z) GO TO 11
      Y=X
      X=Z
      Z=Y
      IP=ORD(P)
      ORD(P)=ORD(Q)
      ORD(Q)=IP
   11 IF (X.LE.XX) GO TO 12
      XX=X
      IX=P
   12 IF (Z.GE.ZZ) GO TO 6
      ZZ=Z
      IZ=Q
      GO TO 6

   13 CONTINUE
      IF (.NOT.(P.NE.IX.AND.X.NE.XX)) GO TO 14
      IP=ORD(P)
      ORD(P)=ORD(IX)
      ORD(IX)=IP
   14 CONTINUE
      IF (.NOT.(Q.NE.IZ.AND.Z.NE.ZZ)) GO TO 15
      IQ=ORD(Q)
      ORD(Q)=ORD(IZ)
      ORD(IZ)=IQ
   15 CONTINUE
      IF (U-Q.LE.P-L) GO TO 16
      L1=L
      U1=P-1
      L=Q+1
      GO TO 17
   16 U1=U
      L1=Q+1
      U=P-1
   17 CONTINUE
      IF (U1.LE.L1) GO TO 18

      NDEEP=NDEEP+1
      POPLST(1,NDEEP)=U
      POPLST(2,NDEEP)=L
      GO TO 3
   18 IF (U.GT.L) GO TO 4

      IF (NDEEP.EQ.0) GO TO 2
      U=POPLST(1,NDEEP)
      L=POPLST(2,NDEEP)
      NDEEP=NDEEP-1
      GO TO 18

END SUBROUTINE QSORTC

! (C) Copyright 2005- ECMWF.
! (C) Copyright 2013- Meteo-France.
! 
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!

MODULE MPL_ARG_MOD

!**** MPL_GETARG : A substitute for GET_COMMAND_ARGUMENT (formerly GETARG) for MPL applications
!     MPL_IARGC  : A substitute for function COMMAND_ARGUMENT_COUNT (formerly IARGC) for MPL applications

!     Purpose.
!     --------
!     MPL-task#1 calls GET_COMMAND_ARGUMENT until COMMAND_ARGUMENT_COUNT() arguments read
!     or until the argument is a terminating argument
!     Then arguments are passed on to other processors
!     If MPL has not been initialized, it will be done now.

!**   Interface.
!     ----------
!        CALL MPL_GETARG(KARG, CDARG)

!        Input required arguments :
!        -------------------------
!           KARG     -  The argument number requested (INTEGER(4))
!                       Range : [ 0 .. MPL_IARGC() ]

!        Output required arguments :
!        ---------------------------
!           CDARG    -  Return argument value (CHARACTER(LEN=*))
!
!**   Interface.
!     ----------
!        INUM_ARGS = MPL_IARGC()
!
!     where INUM_ARGS is INTEGER(4)

!     Author.
!     -------
!        S.Saarinen, G.Mozdzynski  ECMWF

!     Modifications.
!     --------------
!        Original: 2006-03-15

USE EC_PARKIND  ,ONLY : JPIM
USE MPL_MPIF
USE MPL_DATA_MODULE, ONLY : MPL_NUMPROC,LINITMPI_VIA_MPL,LMPLUSERCOMM,MPLUSERCOMM

IMPLICIT NONE

PRIVATE

CHARACTER(LEN=10), SAVE :: CL_TERMINATE = '-^' ! terminating argument

INTEGER(KIND=JPIM), PARAMETER :: JP_ARGLEN = 1024
CHARACTER(LEN=JP_ARGLEN), ALLOCATABLE, SAVE :: CL_ARGS(:)
INTEGER(KIND=JPIM), SAVE :: N_ARGS = -1

PUBLIC :: MPL_GETARG
PUBLIC :: MPL_IARGC
PUBLIC :: MPL_ARG_SET_CL_TERMINATE
PUBLIC :: MPL_ARG_GET_CL_TERMINATE

CONTAINS

SUBROUTINE MPL_ARG_SET_CL_TERMINATE(CDTERM)
CHARACTER(LEN=*), INTENT(IN) :: CDTERM
CL_TERMINATE = CDTERM
END SUBROUTINE MPL_ARG_SET_CL_TERMINATE

SUBROUTINE MPL_ARG_GET_CL_TERMINATE(CDTERM)
CHARACTER(LEN=*), INTENT(OUT) :: CDTERM
CDTERM = CL_TERMINATE
END SUBROUTINE MPL_ARG_GET_CL_TERMINATE

SUBROUTINE INIT_ARGS()

#ifdef USE_8_BYTE_WORDS
  USE MPI4TO8, ONLY : &
    MPI_INITIALIZED => MPI_INITIALIZED8, MPI_COMM_SIZE => MPI_COMM_SIZE8, &
    MPI_COMM_RANK => MPI_COMM_RANK8, MPI_BCAST => MPI_BCAST8, &
    MPI_INIT => MPI_INIT8
#endif

INTEGER(KIND=JPIM) :: IARGS
INTEGER(KIND=JPIM) :: IERROR, IROOT, ICOUNT
INTEGER(KIND=JPIM) :: IRANK, INUMPROC, IRET, J
INTEGER(KIND=JPIM) :: IARGC_C
CHARACTER(LEN=LEN(CL_TERMINATE)) :: ENV_CL_TERMINATE
CHARACTER(LEN=JP_ARGLEN) :: CLARG0
LOGICAL LLCARGS
INTEGER LLINIT
INTEGER(KIND=JPIM) :: ICOMM

IF (N_ARGS == -1) THEN
  IF (MPL_NUMPROC == -1) THEN
    ! This is complicated, but I hope it works:
    ! MPI has not yet been initialized, when this routines was called.
    ! Initialize MPI, but NOT via MPL_INIT to avoid recursion in MPL_IARGC()
    ! However, must pretend that MPL_INIT has actually initialized it, but 
    ! MPL_NUMPROC will not be set
    CALL MPI_INITIALIZED(LLINIT,IRET)
    IF (LLINIT == 0) THEN
      CALL MPI_INIT(IERROR)
      LINITMPI_VIA_MPL = .TRUE.
      CALL EC_MPI_ATEXIT() ! ifsaux/support/endian.c: to make sure MPI_FINALIZE gets called
    ENDIF
  ENDIF

  ! If LMPLUSERCOMM is not set use MPI_COMM_WORLD
  IF (LMPLUSERCOMM) THEN
    ICOMM = MPLUSERCOMM
  ELSE
    ICOMM = MPI_COMM_WORLD
  ENDIF

  CALL MPI_COMM_SIZE(ICOMM,INUMPROC,IERROR)
  CALL MPI_COMM_RANK(ICOMM,IRANK,IERROR)
  IRANK=IRANK+1

  IF (IRANK == 1 .OR. INUMPROC == 1) THEN
    CALL GET_ENVIRONMENT_VARIABLE('MPL_CL_TERMINATE',ENV_CL_TERMINATE)
    IF (ENV_CL_TERMINATE /= ' ') CL_TERMINATE = ENV_CL_TERMINATE
    IARGS = COMMAND_ARGUMENT_COUNT()
    LLCARGS = (IARGS < 0) ! Should be true for non-F90 main programs
    IF (LLCARGS) THEN
      IARGS = IARGC_C()
      LLCARGS = (IARGS >= 0)
      CALL GETARG_C(0,CLARG0) ! The executable name (see ifsaux/support/cargs.c)
    ELSE
      CALL PUTARG_INFO(IARGS, TRIM(CL_TERMINATE)) ! (see ifsaux/support/cargs.c)
      CALL GET_COMMAND_ARGUMENT(0,CLARG0)         ! The executable name (normal F2003 way)
      CALL PUTARG_C(0,TRIM(CLARG0))               ! (see ifsaux/support/cargs.c)
    ENDIF
    IF (IARGS < 0) IARGS = 0
    ALLOCATE(CL_ARGS(0:IARGS))
    N_ARGS = 0
    CL_ARGS(0) = CLARG0
    DO J=1,IARGS ! Other args (repeat until end of loop or terminating argument found)
      IF (LLCARGS) THEN
        CALL GETARG_C(J,CL_ARGS(J))
      ELSE
        CALL GET_COMMAND_ARGUMENT(J,CL_ARGS(J))
        CALL PUTARG_C(J,TRIM(CL_ARGS(J)))
      ENDIF
      IF (CL_ARGS(J) == CL_TERMINATE) EXIT
      N_ARGS = N_ARGS + 1
    ENDDO
  ENDIF

  IF (INUMPROC > 1) THEN
    IROOT = 0
    IARGS = 0
    IF (IRANK == 1) IARGS = N_ARGS
    ! The following broadcast does not use "mailbox" nor attached buffer, both potentially yet to be allocated
    CALL MPI_BCAST(IARGS,1,MPI_INTEGER,IROOT,ICOMM,IERROR)
    ICOUNT = JP_ARGLEN
    IF (IRANK > 1) ALLOCATE(CL_ARGS(0:IARGS))
    IF (IRANK > 1) CALL PUTARG_INFO(IARGS, TRIM(CL_TERMINATE))
    DO J=0,IARGS
     ! The following broadcast does not use "mailbox" nor attached buffer, both potentially yet to be allocated
      CALL MPI_BCAST(CL_ARGS(J),ICOUNT,MPI_BYTE,IROOT,ICOMM,IERROR)
      IF (IRANK > 1) CALL PUTARG_C(J,TRIM(CL_ARGS(J)))
    ENDDO
    IF (IRANK > 1) N_ARGS = IARGS
  ENDIF
ENDIF
END SUBROUTINE INIT_ARGS

SUBROUTINE MPL_GETARG(KARG, CDARG)
INTEGER(KIND=JPIM), INTENT(IN) :: KARG
CHARACTER(LEN=*), INTENT(OUT)  :: CDARG
IF (N_ARGS == -1) CALL INIT_ARGS()
IF (KARG >= 0 .AND. KARG <= N_ARGS) THEN
  CDARG = CL_ARGS(KARG)
ELSE
  CDARG = ' '
ENDIF
END SUBROUTINE MPL_GETARG

FUNCTION MPL_IARGC() RESULT(IRET)
INTEGER(KIND=JPIM) :: IRET
IF (N_ARGS == -1) CALL INIT_ARGS()
IRET = N_ARGS
END FUNCTION MPL_IARGC

END MODULE MPL_ARG_MOD

program hello

    USE SDL_MOD   , ONLY : SDL_SRLABORT, SDL_TRACEBACK

    implicit none
    include "mpif.h"

    integer rank, ierr

    call MPI_Init(ierr)
    call MPI_Comm_rank(MPI_COMM_WORLD,rank,ierr)
    write(6,*) "My rank number is ", rank

    CALL SDL_TRACEBACK
    call MPI_Finalize(ierr)
    write(6,*) "Execution finished ", rank

end

! (C) Copyright 2005- ECMWF.
! (C) Copyright 2013- Meteo France.
! 
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!

!! C bindings to the MPI and MPL routines
!! Please include "mpl.h" for the C interfaces

FUNCTION FORTRAN_MPI_ABORT(KRC) BIND(C,NAME="fortran_mpi_abort") RESULT(IRET)
    USE MPL_MPIF, ONLY : MPI_COMM_WORLD
    IMPLICIT NONE
    INTEGER,INTENT(IN),VALUE :: KRC
    INTEGER :: IRET
    CALL MPI_ABORT(MPI_COMM_WORLD,KRC,IRET)
END FUNCTION FORTRAN_MPI_ABORT

FUNCTION FORTRAN_MPI_INITIALIZED() BIND(C,NAME="fortran_mpi_initialized") RESULT(IRET)
    IMPLICIT NONE
    INTEGER :: IRET
    INTEGER :: IERROR
    LOGICAL :: LINIT
    CALL MPI_INITIALIZED(LINIT,IERROR)
    IF (LINIT) THEN
      IRET = 1
    ELSE
      IRET = 0
    ENDIF
END FUNCTION FORTRAN_MPI_INITIALIZED

FUNCTION MPL_INIT_BINDC() BIND(C,NAME="mpl_init") RESULT(KERROR)
    USE ISO_C_BINDING, ONLY : C_INT
    USE MPL_MODULE,    ONLY : MPL_INIT
    IMPLICIT NONE
    INTEGER(KIND=C_INT) :: KERROR
    CALL MPL_INIT(KERROR=KERROR,LDINFO=.FALSE.)
END FUNCTION MPL_INIT_BINDC

FUNCTION MPL_END_BINDC() BIND(C,NAME="mpl_end") RESULT(KERROR)
    USE ISO_C_BINDING, ONLY : C_INT
    USE MPL_MODULE,    ONLY : MPL_END
    IMPLICIT NONE
    INTEGER(KIND=C_INT) :: KERROR
    CALL MPL_END(KERROR=KERROR)
END FUNCTION MPL_END_BINDC

FUNCTION MPL_MYRANK_BINDC() BIND(C,NAME="mpl_myrank") RESULT(MYRANK)
    USE ISO_C_BINDING, ONLY : C_INT
    USE MPL_MODULE,    ONLY : MPL_MYRANK
    IMPLICIT NONE
    INTEGER(KIND=C_INT) :: MYRANK
    MYRANK = MPL_MYRANK()
END FUNCTION

FUNCTION MPL_COMM_BINDC() BIND(C,NAME="mpl_comm") RESULT(NCOMM)
    USE ISO_C_BINDING, ONLY : C_INT
    USE MPL_MODULE,    ONLY : MPL_COMM
    IMPLICIT NONE
    INTEGER(KIND=C_INT) :: NCOMM
    NCOMM = MPL_COMM
END FUNCTION

FUNCTION MPL_COMM_OML_BINDC(OML_THREAD) BIND(C,NAME="mpl_comm_oml") RESULT(NCOMM)
    USE ISO_C_BINDING, ONLY : C_INT
    USE MPL_MODULE,    ONLY : MPL_COMM_OML
    IMPLICIT NONE
    INTEGER(KIND=C_INT) :: NCOMM
    INTEGER(KIND=C_INT), VALUE, INTENT(IN) :: OML_THREAD
    NCOMM = MPL_COMM_OML(OML_THREAD)
END FUNCTION


! SUBROUTINE CMPL_ABORT(CDMESS)
! USE MPL_MODULE
! IMPLICIT NONE
! CHARACTER(LEN=*) CDMESS
! CALL MPL_ABORT(CDMESS)
! END SUBROUTINE CMPL_ABORT

! FUNCTION CMPL_NPROC()
! USE MPL_MODULE
! IMPLICIT NONE
! INTEGER CMPL_NPROC
! CMPL_NPROC=MPL_NPROC()
! END FUNCTION CMPL_NPROC

! FUNCTION CMPL_MYRANK()
! USE MPL_MODULE
! IMPLICIT NONE
! INTEGER CMPL_MYRANK
! CMPL_MYRANK=MPL_MYRANK()
! END FUNCTION CMPL_MYRANK

! SUBROUTINE CMPL_BARRIER(KERROR)
! USE MPL_MODULE
! IMPLICIT NONE
! INTEGER KERROR
! CALL MPL_BARRIER(KERROR=KERROR)
! END SUBROUTINE CMPL_BARRIER

! SUBROUTINE CMPL_END(KERROR)
! USE MPL_MODULE
! IMPLICIT NONE
! INTEGER KERROR
! CALL MPL_END(KERROR=KERROR)
! END SUBROUTINE CMPL_END

! SUBROUTINE CMPL_GETARG(KARGNO, CDARG)
! USE MPL_MODULE
! IMPLICIT NONE
! INTEGER KARGNO
! CHARACTER(LEN=*) CDARG
! CALL MPL_GETARG(KARGNO, CDARG)
! END SUBROUTINE CMPL_GETARG

! FUNCTION CMPL_IARGC()
! USE MPL_MODULE
! IMPLICIT NONE
! INTEGER CMPL_IARGC
! CMPL_IARGC = MPL_IARGC()
! END FUNCTION CMPL_IARGC

! (C) Copyright 2005- ECMWF.
! 
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!

program abort_test
use oml_mod
use mpl_module
use yomhook, only : lhook, dr_hook_init
use fckit_module
implicit none

#include "abor1.intfb.h"

interface
   subroutine my_namespace__function_1() bind(C)
   end subroutine
end interface

call test_init()
if( fckit_mpi%rank() == fckit_mpi%size()-1 ) then
    call my_namespace__function_1()
endif
call test_end()

contains

subroutine test_init()
    use fckit_module, only : fckit_main, fckit_signal, fckit_exception
    use ec_env_mod, only : ec_setenv
    implicit none


    if( mpl() ) then
        call mpl_init(LDINFO=.TRUE.)
    endif

    call fckit_main%initialise()

    if( do_abor1() ) then
        call set_abor1_exception_handler()
    endif

    call ec_setenv("DR_HOOK","1",overwrite=.false.)
    call ec_setenv("DR_HOOK_SILENT","1",overwrite=.false.)
    call dr_hook_init()
    if (.not.lhook) then
        call fckit_signal%set_handler(fckit_signal%SIGTRAP())
        call fckit_signal%set_handler(fckit_signal%SIGABRT())
    endif
    
end subroutine

subroutine test_end()
    if( mpl() ) then
        call mpl_barrier()
        call mpl_end(LDMEMINFO=.FALSE.)    
    endif
end subroutine

function mpl() result(lmpl)
    logical :: lmpl
    character(len=512) :: env
    CALL get_environment_variable('MPL',env)
    if( env == '0' ) then
        lmpl = .false.
    else
        lmpl = .true.
    endif
end function

function do_abor1() result(labor1)
    logical :: labor1
    character(len=512) :: env = ' '
    CALL get_environment_variable('ABOR1',env)
    if( env == '0' .or. len_trim(env) == 0 ) then
        labor1 = .false.
    else
        labor1 = .true.
    endif
end function


end program

! (C) Copyright 2025- ECMWF.
!
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!

!
! Simple Test program
!
subroutine fail_impl(msg,line)
  character(*) :: msg
  integer :: line
  write(0,'(A,I0,A)') "TEST FAILED in test_byteswap.F90 @ line ",line," :"
  write(0,*) msg
  stop 1
end subroutine

#define FAIL(msg) call fail_impl(msg,__LINE__)

program byteswap_test
use byteswap_mod
use, intrinsic :: iso_c_binding
implicit none

call test_convert_to_big_endian_int32()
call test_convert_to_big_endian_int64()
call test_convert_to_big_endian_real32()
call test_convert_to_big_endian_real64()

call test_byteswap_int32()
call test_byteswap_int64()
call test_byteswap_real32()
call test_byteswap_real64()

write(0,'(A)') "SUCCESS"

CONTAINS

  subroutine test_convert_to_big_endian_int32()
    integer :: i
    integer(c_int32_t) :: buffer(3), buffer_BE(3)
    character(len=8) :: hex(3), hex_BE(3)
    write(0,'(A)') "test_convert_to_big_endian_int32"
    buffer = [12345678,23456789,34567890]

    call convert_to_big_endian(buffer_BE, buffer)
    !call iswap(buffer_BE, buffer, 4, 3)

    if (is_little_endian()) then
      do i=1,3
        write(hex(i),'(Z8.8)') transfer(buffer(i),0_c_int32_t)
        write(hex_BE(i),'(Z8.8)') transfer(buffer_BE(i),0_c_int32_t)
        write(0,*) "   ", hex(i), " --> " , hex_BE(i)
      enddo
      if (any(hex_BE /= ["4E61BC00","15EC6501","D2760F02"])) then
        FAIL("conversion to big_endian failed")
      endif
    else
      if (any(buffer /= buffer_BE) ) then
        FAIL("buffer_BE should be copy of buffer on big_endian architecture")
      endif
    endif
  end subroutine

  subroutine test_convert_to_big_endian_int64()
    integer :: i
    integer(c_int64_t) :: buffer(3), buffer_BE(3)
    character(len=16) :: hex(3), hex_BE(3)
    write(0,'(A)') "test_convert_to_big_endian_int64"
    buffer = [123456789012345678_c_int64_t,&
              234567890123456789_c_int64_t,&
              345678901234567890_c_int64_t]

    call convert_to_big_endian(buffer_BE, buffer)
    !call iswap(buffer_BE, buffer, 8, 3)

    if (is_little_endian()) then
      do i=1,3
        write(hex(i),'(Z16.16)') transfer(buffer(i),0_c_int64_t)
        write(hex_BE(i),'(Z16.16)') transfer(buffer_BE(i),0_c_int64_t)
        write(0,*) "   ", hex(i), " --> " , hex_BE(i)
      enddo
      if (any(hex_BE /= ["4EF330A64B9BB601","158185D6405A4103","D20A6F122119CC04"])) then
        FAIL("conversion to big_endian failed")
      endif
    else
      if (any(buffer /= buffer_BE) ) then
        FAIL("buffer_BE should be copy of buffer on big_endian architecture")
      endif
    endif
  end subroutine

  subroutine test_convert_to_big_endian_real32()
    integer :: i
    real(c_float) :: buffer(3), buffer_BE(3)
    character(len=8) :: hex(3), hex_BE(3)
    write(0,'(A)') "test_convert_to_big_endian_real32"
    buffer = [1.234_c_float,2.345_c_float,3.456_c_float]

    call convert_to_big_endian(buffer_BE, buffer)
    !call iswap(buffer_BE, buffer, 4, 3)

    if (is_little_endian()) then
      do i=1,3
        write(hex(i),'(Z8.8)') transfer(buffer(i),0_c_int32_t)
        write(hex_BE(i),'(Z8.8)') transfer(buffer_BE(i),0_c_int32_t)
        write(0,*) "   ", hex(i), " --> " , hex_BE(i)
      enddo
      if (any(hex_BE /= ["B6F39D3F","7B141640","1B2F5D40"])) then
        FAIL("conversion to big_endian failed")
      endif
    else
      if (any(buffer /= buffer_BE) ) then
        FAIL("buffer_BE should be copy of buffer on big_endian architecture")
      endif
    endif
  end subroutine

  subroutine test_convert_to_big_endian_real64()
    integer :: i
    real(c_double) :: buffer(3), buffer_BE(3)
    character(len=16) :: hex(3), hex_BE(3)
    write(0,'(A)') "test_convert_to_big_endian_real64"
    buffer = [1.234567890123_c_double, &
              2.345678901234_c_double, &
              3.456789012345_c_double]

    call convert_to_big_endian(buffer_BE, buffer)
    !call iswap(buffer_BE, buffer, 8, 3)

    if (is_little_endian()) then
      do i=1,3
        write(hex(i),'(Z16.16)') transfer(buffer(i),0_c_int64_t)
        write(hex_BE(i),'(Z16.16)') transfer(buffer_BE(i),0_c_int64_t)
        write(0,*) "   ", hex(i), " --> " , hex_BE(i)
      enddo
      if (any(hex_BE /= ["F2518C42CAC0F33F","EABCBD4CF3C30240","238D69FF80A70B40"])) then
        FAIL("conversion to big_endian failed")
      endif
    else
      if (any(buffer /= buffer_BE) ) then
        FAIL("buffer_BE should be copy of buffer on big_endian architecture")
      endif
    endif
  end subroutine

  subroutine test_byteswap_int32()
    integer :: i
    integer(c_int32_t) :: buffer(3), buffer_BE(3)
    character(len=8) :: hex(3), hex_BE(3)
    write(0,'(A)') "test_byteswap_int32"
    buffer = [12345678,23456789,34567890]

    if (is_little_endian()) then
      call byteswap(buffer_BE, buffer)
      !call jswap(buffer_BE, buffer, 4, 3)
    else
      buffer_BE = buffer
    endif

    if (is_little_endian()) then
      do i=1,3
        write(hex(i),'(Z8.8)') transfer(buffer(i),0_c_int32_t)
        write(hex_BE(i),'(Z8.8)') transfer(buffer_BE(i),0_c_int32_t)
        write(0,*) "   ", hex(i), " --> " , hex_BE(i)
      enddo
      if (any(hex_BE /= ["4E61BC00","15EC6501","D2760F02"])) then
        FAIL("conversion to big_endian failed")
      endif
    else
      if (any(buffer /= buffer_BE) ) then
        FAIL("buffer_BE should be copy of buffer on big_endian architecture")
      endif
    endif
  end subroutine

  subroutine test_byteswap_int64()
    integer :: i
    integer(c_int64_t) :: buffer(3), buffer_BE(3)
    character(len=16) :: hex(3), hex_BE(3)
    write(0,'(A)') "test_byteswap_int64"
    buffer = [123456789012345678_c_int64_t,&
              234567890123456789_c_int64_t,&
              345678901234567890_c_int64_t]

    if (is_little_endian()) then
      call byteswap(buffer_BE, buffer)
      !call jswap(buffer_BE, buffer, 8, 3)
    else
      buffer_BE = buffer
    endif

    if (is_little_endian()) then
      do i=1,3
        write(hex(i),'(Z16.16)') transfer(buffer(i),0_c_int64_t)
        write(hex_BE(i),'(Z16.16)') transfer(buffer_BE(i),0_c_int64_t)
        write(0,*) "   ", hex(i), " --> " , hex_BE(i)
      enddo
      if (any(hex_BE /= ["4EF330A64B9BB601","158185D6405A4103","D20A6F122119CC04"])) then
        FAIL("conversion to big_endian failed")
      endif
    else
      if (any(buffer /= buffer_BE) ) then
        FAIL("buffer_BE should be copy of buffer on big_endian architecture")
      endif
    endif
  end subroutine

  subroutine test_byteswap_real32()
    integer :: i
    real(c_float) :: buffer(3), buffer_BE(3)
    character(len=8) :: hex(3), hex_BE(3)
    write(0,'(A)') "test_byteswap_real32"
    buffer = [1.234_c_float,2.345_c_float,3.456_c_float]

    if (is_little_endian()) then
      call byteswap(buffer_BE, buffer)
      !call jswap(buffer_BE, buffer, 4, 3)
    else
      buffer_BE = buffer
    endif

    if (is_little_endian()) then
      do i=1,3
        write(hex(i),'(Z8.8)') transfer(buffer(i),0_c_int32_t)
        write(hex_BE(i),'(Z8.8)') transfer(buffer_BE(i),0_c_int32_t)
        write(0,*) "   ", hex(i), " --> " , hex_BE(i)
      enddo
      if (any(hex_BE /= ["B6F39D3F","7B141640","1B2F5D40"])) then
        FAIL("conversion to big_endian failed")
      endif
    else
      if (any(buffer /= buffer_BE) ) then
        FAIL("buffer_BE should be copy of buffer on big_endian architecture")
      endif
    endif
  end subroutine

  subroutine test_byteswap_real64()
    integer :: i
    real(c_double) :: buffer(3), buffer_BE(3)
    character(len=16) :: hex(3), hex_BE(3)
    write(0,'(A)') "test_byteswap_real64"
    buffer = [1.234567890123_c_double, &
              2.345678901234_c_double, &
              3.456789012345_c_double]

    if (is_little_endian()) then
      call byteswap(buffer_BE, buffer)
      !call jswap(buffer_BE, buffer, 8, 3)
    else
      buffer_BE = buffer
    endif

    if (is_little_endian()) then
      do i=1,3
        write(hex(i),'(Z16.16)') transfer(buffer(i),0_c_int64_t)
        write(hex_BE(i),'(Z16.16)') transfer(buffer_BE(i),0_c_int64_t)
        write(0,*) "   ", hex(i), " --> " , hex_BE(i)
      enddo
      if (any(hex_BE /= ["F2518C42CAC0F33F","EABCBD4CF3C30240","238D69FF80A70B40"])) then
        FAIL("conversion to big_endian failed")
      endif
    else
      if (any(buffer /= buffer_BE) ) then
        FAIL("buffer_BE should be copy of buffer on big_endian architecture")
      endif
    endif
  end subroutine


end program

! (C) Copyright 2005- ECMWF.
! (C) Copyright 2013- Meteo-France.
! 
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!

MODULE MPL_GATHERV_MOD

!**** MPL_GATHERV Gather data to specific processor

!     Purpose.
!     --------
!     Gather data to specific processor
!     The data may be REAL*4, REAL*8,or INTEGER, one dimensional array
!                     REAL*4,or REAL*8, two dimensional array
!                  or INTEGER scalar

!**   Interface.
!     ----------
!        CALL MPL_GATHERV

!        Input required arguments :
!        -------------------------
!           PSENDBUF -  buffer containing message
!                       (can be type REAL*4, REAL*8 or INTEGER)
!           PRECVBUF -  buffer containing message (required from kroot)
!                       (can be type REAL*4, REAL*8 or INTEGER)
!           KRECVCOUNTS-number of elements received from each process
!                       (required from kroot processor)

!        Input optional arguments :
!        -------------------------
!           KROOT    -  rank of receiveing processor (default 1) 
!           KMP_TYPE -  buffering type (see MPL_BUFFER_METHOD)
!                       overrides value provided to MPL_BUFFER_METHOD
!           KCOMM    -  Communicator number if different from MPI_COMM_WORLD 
!                       or from that established as the default 
!                       by an MPL communicator routine
!           KRECVDISPL -displacements in PRECVBUF at which to place 
!                       the incoming data
!           CDSTRING -  Character string for ABORT messages
!                       used when KERROR is not provided

!        Output required arguments :
!        -------------------------
!           none

!        Output optional arguments :
!        -------------------------
!           KREQUEST -  Communication request
!                       required when buffering type is non-blocking
!           KERROR   -  return error code.     If not supplied, 
!                       MPL_GATHERV aborts when an error is detected.
!     Author.
!     -------
!        D.Dent, M.Hamrud     ECMWF

!     Modifications.
!     --------------
!        Original:  2000-11-23
!        M.Hamrud:  2014-10-22 : Add nonblocking option
!        F.Vana:    2015-03-05 : Support for single precision
!        P.Gillies: 2018-06-25 : Add SENDCOUNT argument, needed for zero-length sends
! --- *NOT* THREAD SAFE YET ---

!     ------------------------------------------------------------------

USE EC_PARKIND , ONLY : JPRD, JPIM, JPIB, JPRM
USE OML_MOD   ,ONLY : OML_MY_THREAD

USE MPL_MPIF
USE MPL_DATA_MODULE
USE MPL_STATS_MOD
USE YOMMPLSTATS
USE MPL_MESSAGE_MOD
USE MPL_SEND_MOD
USE MPL_RECV_MOD
USE MPL_MYRANK_MOD
IMPLICIT NONE

PRIVATE


LOGICAL   :: LLABORT=.TRUE.
REAL(KIND=JPRD)    :: ZDUM_JPRD
REAL(KIND=JPRM)    :: ZDUM_JPRM
INTEGER(KIND=JPIM)    :: ZDUM_INT

INTERFACE MPL_GATHERV
MODULE PROCEDURE MPL_GATHERV_REAL8,MPL_GATHERV_REAL4,MPL_GATHERV_CHAR_SCALAR,&
               & MPL_GATHERV_INT,MPL_GATHERV_INT_SCALAR
END INTERFACE

PUBLIC MPL_GATHERV

CONTAINS

SUBROUTINE MPL_GATHERV_PREAMB1(IERROR,IPL_NUMPROC,IPL_MYRANK,ICOMM,IROOT,IMP_TYPE, &
     & KCOMM,KROOT,KMP_TYPE,KREQUEST)


#ifdef USE_8_BYTE_WORDS
  USE MPI4TO8, ONLY : &
    MPI_COMM_SIZE => MPI_COMM_SIZE8
#endif


INTEGER(KIND=JPIM),INTENT(OUT) :: IERROR,IPL_NUMPROC,IPL_MYRANK,ICOMM,IROOT,IMP_TYPE
INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL :: KROOT
INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL :: KCOMM,KMP_TYPE,KREQUEST
INTEGER(KIND=JPIM) :: ITID
ITID = OML_MY_THREAD()
IERROR = 0

IF(MPL_NUMPROC < 1) CALL MPL_MESSAGE( &
  & CDMESSAGE='MPL_GATHERV: MPL NOT INITIALISED ',LDABORT=LLABORT) 

IF(PRESENT(KCOMM)) THEN
  ICOMM=KCOMM
ELSE
  ICOMM=MPL_COMM_OML(ITID)
ENDIF

IF(ICOMM == MPL_COMM_OML(ITID)) THEN
  IPL_NUMPROC = MPL_NUMPROC
  IPL_MYRANK  = MPL_RANK
ELSE
  CALL MPI_COMM_SIZE(ICOMM,IPL_NUMPROC,IERROR)
  IPL_MYRANK  = MPL_MYRANK(ICOMM)
ENDIF

IF(PRESENT(KROOT)) THEN
  IROOT=KROOT
ELSE
  IROOT=1
ENDIF

IF(PRESENT(KMP_TYPE)) THEN
  IMP_TYPE=KMP_TYPE
ELSE
  IMP_TYPE=MPL_METHOD
ENDIF
IF(IMP_TYPE == JP_NON_BLOCKING_STANDARD .OR. IMP_TYPE == JP_NON_BLOCKING_BUFFERED) THEN
  IF(.NOT.PRESENT(KREQUEST)) CALL MPL_MESSAGE(CDMESSAGE='MPL_GATHERV:  KREQUEST MISSING',LDABORT=LLABORT)
ENDIF


END SUBROUTINE MPL_GATHERV_PREAMB1

SUBROUTINE MPL_GATHERV_PREAMB2(IPL_NUMPROC,IPL_MYRANK,IRECVBUFSIZE,ISENDCOUNT,&
     & KRECVCOUNTS,KIRECVDISPL,KRECVDISPL,CDSTRING)

INTEGER(KIND=JPIM),INTENT(IN) :: IPL_NUMPROC,IPL_MYRANK,IRECVBUFSIZE,ISENDCOUNT
INTEGER(KIND=JPIM),INTENT(IN)  :: KRECVCOUNTS(:)
INTEGER(KIND=JPIM),INTENT(OUT) :: KIRECVDISPL(:) 
INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL :: KRECVDISPL(:)
CHARACTER(LEN=*),INTENT(IN),OPTIONAL :: CDSTRING
INTEGER(KIND=JPIM) :: IR


IF(SIZE(KRECVCOUNTS)  < IPL_NUMPROC) THEN
  WRITE(MPL_ERRUNIT,*)'MPL_GATHERV: ERROR KRECVCOUNTS DIMENSION=',&
   & SIZE(KRECVCOUNTS)
  CALL MPL_MESSAGE(CDMESSAGE=&
   & 'MPL_GATHERV: ERROR KRECVCOUNTS DIMENSION IS WRONG',LDABORT=LLABORT)
ENDIF
IF(ISENDCOUNT /= KRECVCOUNTS(IPL_MYRANK)) THEN
  WRITE(MPL_ERRUNIT,*)'MPL_GATHERV: ERROR KRECVCOUNTS INCONSISTENCY ',&
   & ISENDCOUNT,KRECVCOUNTS(IPL_MYRANK)
  CALL MPL_MESSAGE(CDMESSAGE=&
   & 'MPL_GATHERV: ERROR ISENDCOUNT /= KRECVCOUNTS(MPL_RANK) ',LDABORT=LLABORT)
ENDIF

IF(PRESENT(KRECVDISPL)) THEN
  KIRECVDISPL(1:IPL_NUMPROC) = KRECVDISPL(1:IPL_NUMPROC)
ELSE
  KIRECVDISPL(1:IPL_NUMPROC) = 0
  DO IR=2, IPL_NUMPROC
    KIRECVDISPL(IR) = KIRECVDISPL(IR-1) + KRECVCOUNTS(IR-1)
  ENDDO
ENDIF
DO IR=1, IPL_NUMPROC
  IF(KIRECVDISPL(IR)+KRECVCOUNTS(IR) > IRECVBUFSIZE) THEN
    WRITE(MPL_ERRUNIT,'(A,4I10)')'MPL_GATHERV:RECV BUFFER TOO SMALL  ', &
     & IR,KIRECVDISPL(IR),KRECVCOUNTS(IR),IRECVBUFSIZE
    CALL MPL_MESSAGE(CDMESSAGE='MPL_GATHERV',CDSTRING=CDSTRING,LDABORT=LLABORT)
  ENDIF
ENDDO

END SUBROUTINE MPL_GATHERV_PREAMB2

SUBROUTINE MPL_GATHERV_REAL4(PSENDBUF,KROOT,PRECVBUF,KRECVCOUNTS,KSENDCOUNT,KRECVDISPL, &
                            & KMP_TYPE,KCOMM,KERROR,KREQUEST,CDSTRING)


#ifdef USE_8_BYTE_WORDS
  USE MPI4TO8, ONLY : &
    MPI_GATHERV => MPI_GATHERV8
#endif



REAL(KIND=JPRM),INTENT(IN) :: PSENDBUF(:)
INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL :: KROOT
REAL(KIND=JPRM),INTENT(OUT),OPTIONAL  :: PRECVBUF(:)
INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL :: KRECVCOUNTS(:),KSENDCOUNT
INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL :: KRECVDISPL(:),KCOMM,KMP_TYPE
INTEGER(KIND=JPIM),INTENT(OUT),OPTIONAL :: KERROR,KREQUEST
CHARACTER(LEN=*),INTENT(IN),OPTIONAL :: CDSTRING

INTEGER(KIND=JPIM) :: IRECVDISPL(MPL_NUMPROC)
INTEGER(KIND=JPIM) :: IERROR,IPL_NUMPROC,IPL_MYRANK,ICOMM,IROOT,IMP_TYPE
INTEGER(KIND=JPIM) :: IRECVBUFSIZE,ISENDCOUNT

IF(PRESENT(KSENDCOUNT)) THEN
  ISENDCOUNT=KSENDCOUNT
ELSE
  ISENDCOUNT = SIZE(PSENDBUF)
ENDIF
#ifndef NAG
IF( (LOC(PSENDBUF(UBOUND(PSENDBUF,1))) - LOC(PSENDBUF(LBOUND(PSENDBUF,1)))) /= 4_JPIB*(ISENDCOUNT - 1) .AND. &
  & ISENDCOUNT > 0 ) THEN
  CALL MPL_MESSAGE(CDMESSAGE='MPL_GATHERV: SENDBUF NOT CONTIGUOUS ',LDABORT=LLABORT)
ENDIF
#endif

CALL MPL_GATHERV_PREAMB1(IERROR,IPL_NUMPROC,IPL_MYRANK,ICOMM,IROOT,IMP_TYPE,KCOMM,KROOT,KMP_TYPE,KREQUEST)

IF(IPL_MYRANK == IROOT) THEN
  IF( .NOT. PRESENT(PRECVBUF)) CALL MPL_MESSAGE(&
   & CDMESSAGE='MPL_GATHERV:RECVBUF MISSING',CDSTRING=CDSTRING,LDABORT=LLABORT)

  IRECVBUFSIZE = SIZE(PRECVBUF)
#ifndef NAG
  IF( (LOC(PRECVBUF(UBOUND(PRECVBUF,1))) - LOC(PRECVBUF(LBOUND(PRECVBUF,1)))) /= 4_JPIB*(IRECVBUFSIZE - 1) .AND. &
    & IRECVBUFSIZE > 0 ) THEN
    CALL MPL_MESSAGE(CDMESSAGE='MPL_GATHERV: RECVBUF NOT CONTIGUOUS ',LDABORT=LLABORT)
  ENDIF
#endif

  CALL MPL_GATHERV_PREAMB2(IPL_NUMPROC,IPL_MYRANK,IRECVBUFSIZE,ISENDCOUNT,&
       & KRECVCOUNTS,IRECVDISPL,KRECVDISPL,CDSTRING)
  IF(IMP_TYPE == JP_BLOCKING_STANDARD .OR. IMP_TYPE == JP_BLOCKING_BUFFERED) THEN
    CALL MPI_GATHERV(PSENDBUF(1),ISENDCOUNT,INT(MPI_REAL4),PRECVBUF(1),KRECVCOUNTS, &
     &  IRECVDISPL,INT(MPI_REAL4),IROOT-1,ICOMM,IERROR)
  ELSEIF(IMP_TYPE == JP_NON_BLOCKING_STANDARD .OR. IMP_TYPE == JP_NON_BLOCKING_BUFFERED) THEN
    CALL MPI_IGATHERV(PSENDBUF(1),ISENDCOUNT,INT(MPI_REAL4),PRECVBUF(1),KRECVCOUNTS, &
     &  IRECVDISPL,INT(MPI_REAL4),IROOT-1,ICOMM,KREQUEST,IERROR)
  ENDIF
  IF(LMPLSTATS) THEN
    CALL MPL_SENDSTATS(ISENDCOUNT,INT(MPI_REAL4))
    CALL MPL_RECVSTATS(SUM(KRECVCOUNTS),INT(MPI_REAL4))
  ENDIF
ELSE
  IF(IMP_TYPE == JP_BLOCKING_STANDARD .OR. IMP_TYPE == JP_BLOCKING_BUFFERED) THEN
    CALL MPI_GATHERV(PSENDBUF(1),ISENDCOUNT,INT(MPI_REAL4),ZDUM_JPRM,1, &
     &  1,INT(MPI_REAL4),IROOT-1,ICOMM,IERROR)
  ELSEIF(IMP_TYPE == JP_NON_BLOCKING_STANDARD .OR. IMP_TYPE == JP_NON_BLOCKING_BUFFERED) THEN
    CALL MPI_IGATHERV(PSENDBUF(1),ISENDCOUNT,INT(MPI_REAL4),ZDUM_JPRM,1, &
     &  1,INT(MPI_REAL4),IROOT-1,ICOMM,KREQUEST,IERROR)
  ENDIF
  IF(LMPLSTATS) THEN
    CALL MPL_SENDSTATS(ISENDCOUNT,INT(MPI_REAL4))
  ENDIF
ENDIF

IF(PRESENT(KERROR)) THEN
  KERROR=IERROR
ELSE
  IF(IERROR /= 0 ) CALL MPL_MESSAGE(IERROR,'MPL_GATHERV',&
   & CDSTRING,LDABORT=LLABORT)
ENDIF

END SUBROUTINE MPL_GATHERV_REAL4

SUBROUTINE MPL_GATHERV_REAL8(PSENDBUF,KROOT,PRECVBUF,KRECVCOUNTS,KSENDCOUNT,KRECVDISPL, &
                            & KMP_TYPE,KCOMM,KERROR,KREQUEST,CDSTRING)


#ifdef USE_8_BYTE_WORDS
  USE MPI4TO8, ONLY : &
    MPI_GATHERV => MPI_GATHERV8
#endif



REAL(KIND=JPRD)            :: PSENDBUF(:)
INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL :: KRECVCOUNTS(:),KSENDCOUNT
INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL :: KROOT
REAL(KIND=JPRD),OPTIONAL   :: PRECVBUF(:)
INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL :: KRECVDISPL(:),KCOMM,KMP_TYPE
INTEGER(KIND=JPIM),INTENT(OUT),OPTIONAL :: KERROR,KREQUEST
CHARACTER(LEN=*),INTENT(IN),OPTIONAL :: CDSTRING

INTEGER(KIND=JPIM) :: IRECVDISPL(MPL_NUMPROC)
INTEGER(KIND=JPIM) :: IERROR,IPL_NUMPROC,IPL_MYRANK,ICOMM,IROOT,IMP_TYPE
INTEGER(KIND=JPIM) :: IRECVBUFSIZE,ISENDCOUNT
INTEGER(KIND=JPIM) :: IDUM,IST,IEND,JK


IF(PRESENT(KSENDCOUNT)) THEN
  ISENDCOUNT=KSENDCOUNT
ELSE
  ISENDCOUNT = SIZE(PSENDBUF)
ENDIF
#ifndef NAG
IF( (LOC(PSENDBUF(UBOUND(PSENDBUF,1))) - LOC(PSENDBUF(LBOUND(PSENDBUF,1)))) /= 8_JPIB*(ISENDCOUNT - 1) .AND. &
  & ISENDCOUNT > 0 ) THEN
  CALL MPL_MESSAGE(CDMESSAGE='MPL_GATHERV: SENDBUF NOT CONTIGUOUS ',LDABORT=LLABORT)
ENDIF
#endif

CALL MPL_GATHERV_PREAMB1(IERROR,IPL_NUMPROC,IPL_MYRANK,ICOMM,IROOT,IMP_TYPE,KCOMM,KROOT,KMP_TYPE,KREQUEST)

IF(IPL_MYRANK == IROOT) THEN
  IF( .NOT. PRESENT(PRECVBUF)) CALL MPL_MESSAGE(&
   & CDMESSAGE='MPL_GATHERV:RECVBUF MISSING',CDSTRING=CDSTRING,LDABORT=LLABORT)
  IRECVBUFSIZE = SIZE(PRECVBUF)
#ifndef NAG
  IF( (LOC(PRECVBUF(UBOUND(PRECVBUF,1))) - LOC(PRECVBUF(LBOUND(PRECVBUF,1)))) /= 8_JPIB*(IRECVBUFSIZE - 1) .AND. &
    & IRECVBUFSIZE > 0 ) THEN
    CALL MPL_MESSAGE(CDMESSAGE='MPL_GATHERV: RECVBUF NOT CONTIGUOUS ',LDABORT=LLABORT)
  ENDIF
#endif
  CALL MPL_GATHERV_PREAMB2(IPL_NUMPROC,IPL_MYRANK,IRECVBUFSIZE,ISENDCOUNT,&
       & KRECVCOUNTS,IRECVDISPL,KRECVDISPL,CDSTRING)

  IF(IMP_TYPE == JP_BLOCKING_STANDARD .OR. IMP_TYPE == JP_BLOCKING_BUFFERED) THEN
    CALL MPI_GATHERV(PSENDBUF(1),ISENDCOUNT,INT(MPI_REAL8),PRECVBUF(1),KRECVCOUNTS,&
     &  IRECVDISPL,INT(MPI_REAL8),IROOT-1,ICOMM,IERROR)
  ELSEIF(IMP_TYPE == JP_NON_BLOCKING_STANDARD .OR. IMP_TYPE == JP_NON_BLOCKING_BUFFERED) THEN
    CALL MPI_IGATHERV(PSENDBUF(1),ISENDCOUNT,INT(MPI_REAL8),PRECVBUF(1),KRECVCOUNTS,&
     &  IRECVDISPL,INT(MPI_REAL8),IROOT-1,ICOMM,KREQUEST,IERROR)
  ENDIF
  IF(LMPLSTATS) THEN
    CALL MPL_SENDSTATS(ISENDCOUNT,INT(MPI_REAL8))
    CALL MPL_RECVSTATS(SUM(KRECVCOUNTS),INT(MPI_REAL8))
  ENDIF
ELSE
  IF(IMP_TYPE == JP_BLOCKING_STANDARD .OR. IMP_TYPE == JP_BLOCKING_BUFFERED) THEN
    CALL MPI_GATHERV(PSENDBUF(1),ISENDCOUNT,INT(MPI_REAL8),ZDUM_JPRD,1, &
     &  1,INT(MPI_REAL8),IROOT-1,ICOMM,IERROR)
  ELSEIF(IMP_TYPE == JP_NON_BLOCKING_STANDARD .OR. IMP_TYPE == JP_NON_BLOCKING_BUFFERED) THEN
    CALL MPI_IGATHERV(PSENDBUF(1),ISENDCOUNT,INT(MPI_REAL8),ZDUM_JPRD,1, &
     &  1,INT(MPI_REAL8),IROOT-1,ICOMM,KREQUEST,IERROR)
  ENDIF
  IF(LMPLSTATS) THEN
    CALL MPL_SENDSTATS(ISENDCOUNT,INT(MPI_REAL8))
  ENDIF
ENDIF

IF(PRESENT(KERROR)) THEN
  KERROR=IERROR
ELSE
  IF(IERROR /= 0 ) CALL MPL_MESSAGE(IERROR,'MPL_GATHERV',CDSTRING,&
   & LDABORT=LLABORT)
ENDIF

END SUBROUTINE MPL_GATHERV_REAL8

SUBROUTINE MPL_GATHERV_CHAR_SCALAR(CSENDBUF,KROOT,CRECVBUF,KRECVCOUNTS,KSENDCOUNT,KRECVDISPL, &
                            & KMP_TYPE,KCOMM,KERROR,KREQUEST,CDSTRING)


#ifdef USE_8_BYTE_WORDS
  USE MPI4TO8, ONLY : &
    MPI_GATHERV => MPI_GATHERV8
#endif


CHARACTER(LEN=*)                        :: CSENDBUF
INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL  :: KRECVCOUNTS(:),KSENDCOUNT
INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL  :: KROOT
CHARACTER(LEN=*),OPTIONAL               :: CRECVBUF(:)
INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL  :: KRECVDISPL(:),KCOMM,KMP_TYPE
INTEGER(KIND=JPIM),INTENT(OUT),OPTIONAL :: KERROR,KREQUEST
CHARACTER(LEN=*),INTENT(IN),OPTIONAL    :: CDSTRING

INTEGER(KIND=JPIM) :: IRECVDISPL(MPL_NUMPROC)
INTEGER(KIND=JPIM) :: IERROR,IPL_NUMPROC,IPL_MYRANK,ICOMM,IROOT,IMP_TYPE
INTEGER(KIND=JPIM) :: IRECVBUFSIZE,ISENDCOUNT
INTEGER(KIND=JPIM) :: IDUM,IST,IEND,JK !,ICOUNT

IF(PRESENT(KSENDCOUNT)) THEN
  ISENDCOUNT=KSENDCOUNT
ELSE
  ISENDCOUNT = LEN(CSENDBUF)
ENDIF

CALL MPL_GATHERV_PREAMB1(IERROR,IPL_NUMPROC,IPL_MYRANK,ICOMM,IROOT,IMP_TYPE,KCOMM,KROOT,KMP_TYPE,KREQUEST)

IF(IPL_MYRANK == IROOT) THEN
  IF( .NOT. PRESENT(CRECVBUF)) CALL MPL_MESSAGE(&
   & CDMESSAGE='MPL_GATHERV:RECVBUF MISSING',CDSTRING=CDSTRING,LDABORT=LLABORT)
  IRECVBUFSIZE = LEN(CRECVBUF)*SIZE(CRECVBUF)
#ifndef NAG
  IF( (LOC(CRECVBUF(UBOUND(CRECVBUF,1))) - LOC(CRECVBUF(LBOUND(CRECVBUF,1)))) /= (IRECVBUFSIZE-LEN(CRECVBUF) ) .AND. &
    & IRECVBUFSIZE > 0 ) THEN
    CALL MPL_MESSAGE(CDMESSAGE='MPL_GATHERV: RECVBUF NOT CONTIGUOUS ',LDABORT=LLABORT)
  ENDIF
#endif
  CALL MPL_GATHERV_PREAMB2(IPL_NUMPROC,IPL_MYRANK,IRECVBUFSIZE,ISENDCOUNT,&
       & KRECVCOUNTS,IRECVDISPL,KRECVDISPL,CDSTRING)

  IF(IMP_TYPE == JP_BLOCKING_STANDARD .OR. IMP_TYPE == JP_BLOCKING_BUFFERED) THEN
    CALL MPI_GATHERV(CSENDBUF,ISENDCOUNT,INT(MPI_CHARACTER),CRECVBUF(1),KRECVCOUNTS,&
     &  IRECVDISPL,INT(MPI_CHARACTER),IROOT-1,ICOMM,IERROR)
  ELSEIF(IMP_TYPE == JP_NON_BLOCKING_STANDARD .OR. IMP_TYPE == JP_NON_BLOCKING_BUFFERED) THEN
    CALL MPI_IGATHERV(CSENDBUF,ISENDCOUNT,INT(MPI_CHARACTER),CRECVBUF(1),KRECVCOUNTS,&
     &  IRECVDISPL,INT(MPI_CHARACTER),IROOT-1,ICOMM,KREQUEST,IERROR)
  ENDIF
  IF(LMPLSTATS) THEN
    CALL MPL_SENDSTATS(ISENDCOUNT,INT(MPI_CHARACTER))
    CALL MPL_RECVSTATS(SUM(KRECVCOUNTS),INT(MPI_CHARACTER))
  ENDIF
ELSE
  IF(IMP_TYPE == JP_BLOCKING_STANDARD .OR. IMP_TYPE == JP_BLOCKING_BUFFERED) THEN
    CALL MPI_GATHERV(CSENDBUF,ISENDCOUNT,INT(MPI_CHARACTER),ZDUM_JPRD,1, &
     &  1,INT(MPI_CHARACTER),IROOT-1,ICOMM,IERROR)
  ELSEIF(IMP_TYPE == JP_NON_BLOCKING_STANDARD .OR. IMP_TYPE == JP_NON_BLOCKING_BUFFERED) THEN
    CALL MPI_IGATHERV(CSENDBUF,ISENDCOUNT,INT(MPI_CHARACTER),ZDUM_JPRD,1, &
     &  1,INT(MPI_CHARACTER),IROOT-1,ICOMM,KREQUEST,IERROR)
  ENDIF
  IF(LMPLSTATS) THEN
    CALL MPL_SENDSTATS(ISENDCOUNT,INT(MPI_CHARACTER))
  ENDIF
ENDIF

IF(PRESENT(KERROR)) THEN
  KERROR=IERROR
ELSE
  IF(IERROR /= 0 ) CALL MPL_MESSAGE(IERROR,'MPL_GATHERV',CDSTRING,&
   & LDABORT=LLABORT)
ENDIF

END SUBROUTINE MPL_GATHERV_CHAR_SCALAR

SUBROUTINE MPL_GATHERV_INT(KSENDBUF,KROOT,KRECVBUF,KRECVCOUNTS,KSENDCOUNT,KRECVDISPL, &
                            &  KMP_TYPE,KCOMM,KERROR,KREQUEST,CDSTRING)


#ifdef USE_8_BYTE_WORDS
  USE MPI4TO8, ONLY : &
    MPI_GATHERV => MPI_GATHERV8
#endif



INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL :: KROOT
INTEGER(KIND=JPIM),INTENT(IN)         :: KSENDBUF(:)
INTEGER(KIND=JPIM),INTENT(OUT),OPTIONAL :: KRECVBUF(:)
INTEGER(KIND=JPIM),INTENT(IN) :: KRECVCOUNTS(:)
INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL :: KSENDCOUNT,KRECVDISPL(:),KCOMM,KMP_TYPE
INTEGER(KIND=JPIM),INTENT(OUT),OPTIONAL :: KERROR,KREQUEST
CHARACTER(LEN=*),INTENT(IN),OPTIONAL :: CDSTRING

INTEGER(KIND=JPIM) :: IRECVDISPL(MPL_NUMPROC)
INTEGER(KIND=JPIM) :: IERROR,IPL_NUMPROC,IPL_MYRANK,ICOMM,IROOT,IMP_TYPE
INTEGER(KIND=JPIM) :: IRECVBUFSIZE,ISENDCOUNT

IF(PRESENT(KSENDCOUNT)) THEN
  ISENDCOUNT=KSENDCOUNT
ELSE
  ISENDCOUNT = SIZE(KSENDBUF)
ENDIF
#ifndef NAG
IF( (LOC(KSENDBUF(UBOUND(KSENDBUF,1))) - LOC(KSENDBUF(LBOUND(KSENDBUF,1)))) /= 4_JPIB*(ISENDCOUNT - 1) .AND. &
  & ISENDCOUNT > 0 ) THEN
  CALL MPL_MESSAGE(CDMESSAGE='MPL_GATHERV: SENDBUF NOT CONTIGUOUS ',LDABORT=LLABORT)
ENDIF
#endif

CALL MPL_GATHERV_PREAMB1(IERROR,IPL_NUMPROC,IPL_MYRANK,ICOMM,IROOT,IMP_TYPE,KCOMM,KROOT,KMP_TYPE,KREQUEST)

IF(IPL_MYRANK == IROOT) THEN
  IF( .NOT. PRESENT(KRECVBUF)) CALL MPL_MESSAGE(&
   & CDMESSAGE='MPL_GATHERV:RECVBUF MISSING',CDSTRING=CDSTRING,LDABORT=LLABORT)

  IRECVBUFSIZE = SIZE(KRECVBUF)
#ifndef NAG
  IF( (LOC(KRECVBUF(UBOUND(KRECVBUF,1))) - LOC(KRECVBUF(LBOUND(KRECVBUF,1)))) /= 4_JPIB*(IRECVBUFSIZE - 1) .AND. &
    & IRECVBUFSIZE > 0 ) THEN
    CALL MPL_MESSAGE(CDMESSAGE='MPL_GATHERV: RECVBUF NOT CONTIGUOUS ',LDABORT=LLABORT)
  ENDIF
#endif

  CALL MPL_GATHERV_PREAMB2(IPL_NUMPROC,IPL_MYRANK,IRECVBUFSIZE,ISENDCOUNT,&
       & KRECVCOUNTS,IRECVDISPL,KRECVDISPL,CDSTRING)
  IF(IMP_TYPE == JP_BLOCKING_STANDARD .OR. IMP_TYPE == JP_BLOCKING_BUFFERED) THEN
    CALL MPI_GATHERV(KSENDBUF(1),ISENDCOUNT,INT(MPI_INTEGER),KRECVBUF(1),&
     & KRECVCOUNTS,IRECVDISPL,INT(MPI_INTEGER),IROOT-1,ICOMM,IERROR)
  ELSEIF(IMP_TYPE == JP_NON_BLOCKING_STANDARD .OR. IMP_TYPE == JP_NON_BLOCKING_BUFFERED) THEN
    CALL MPI_IGATHERV(KSENDBUF(1),ISENDCOUNT,INT(MPI_INTEGER),KRECVBUF(1),&
     & KRECVCOUNTS,IRECVDISPL,INT(MPI_INTEGER),IROOT-1,ICOMM,KREQUEST,IERROR)
  ENDIF
  IF(LMPLSTATS) THEN
    CALL MPL_SENDSTATS(ISENDCOUNT,INT(MPI_INTEGER))
    CALL MPL_RECVSTATS(SUM(KRECVCOUNTS),INT(MPI_INTEGER))
  ENDIF
ELSE
  IF(IMP_TYPE == JP_BLOCKING_STANDARD .OR. IMP_TYPE == JP_BLOCKING_BUFFERED) THEN
    CALL MPI_GATHERV(KSENDBUF(1),ISENDCOUNT,INT(MPI_INTEGER),ZDUM_INT,1, &
     &  1,INT(MPI_INTEGER),IROOT-1,ICOMM,IERROR)
  ELSEIF(IMP_TYPE == JP_NON_BLOCKING_STANDARD .OR. IMP_TYPE == JP_NON_BLOCKING_BUFFERED) THEN
    CALL MPI_IGATHERV(KSENDBUF(1),ISENDCOUNT,INT(MPI_INTEGER),ZDUM_INT,1, &
     &  1,INT(MPI_INTEGER),IROOT-1,ICOMM,KREQUEST,IERROR)
  ENDIF
  IF(LMPLSTATS) THEN
    CALL MPL_SENDSTATS(ISENDCOUNT,INT(MPI_INTEGER))
  ENDIF
ENDIF

IF(PRESENT(KERROR)) THEN
  KERROR=IERROR
ELSE
  IF(IERROR /= 0 ) CALL MPL_MESSAGE(IERROR,'MPL_GATHERV',CDSTRING,LDABORT=LLABORT)
ENDIF

END SUBROUTINE MPL_GATHERV_INT

SUBROUTINE MPL_GATHERV_INT_SCALAR(KSENDBUF,KROOT,KRECVBUF,KRECVCOUNTS,KSENDCOUNT,&
 & KMP_TYPE,KRECVDISPL,KCOMM,KERROR,KREQUEST,CDSTRING)


#ifdef USE_8_BYTE_WORDS
  USE MPI4TO8, ONLY : &
    MPI_GATHERV => MPI_GATHERV8, MPI_GATHER => MPI_GATHER8
#endif



INTEGER(KIND=JPIM),INTENT(IN) :: KSENDBUF
INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL :: KROOT
INTEGER(KIND=JPIM),INTENT(OUT),OPTIONAL :: KRECVBUF(:)
INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL :: KRECVCOUNTS(:),KSENDCOUNT
INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL :: KRECVDISPL(:),KCOMM,KMP_TYPE
INTEGER(KIND=JPIM),INTENT(OUT),OPTIONAL :: KERROR,KREQUEST
CHARACTER(LEN=*),INTENT(IN),OPTIONAL :: CDSTRING

INTEGER(KIND=JPIM) :: IRECVDISPL(MPL_NUMPROC),IRECVCOUNTS(MPL_NUMPROC)
INTEGER(KIND=JPIM) :: IERROR,IPL_NUMPROC,IPL_MYRANK,ICOMM,IROOT,IMP_TYPE
INTEGER(KIND=JPIM) :: IRECVBUFSIZE,ISENDCOUNT

IF(PRESENT(KSENDCOUNT)) THEN
  ISENDCOUNT=KSENDCOUNT
ELSE
  ISENDCOUNT = 1
ENDIF
IF(PRESENT(KRECVCOUNTS)) THEN
  IRECVCOUNTS=KRECVCOUNTS
ELSE
  IRECVCOUNTS(:) = 1
ENDIF
CALL MPL_GATHERV_PREAMB1(IERROR,IPL_NUMPROC,IPL_MYRANK,ICOMM,IROOT,IMP_TYPE,KCOMM,KROOT,KMP_TYPE,KREQUEST)

IF(IPL_MYRANK == IROOT) THEN
  IF( .NOT. PRESENT(KRECVBUF)) CALL MPL_MESSAGE(&
   & CDMESSAGE='MPL_GATHERV:RECVBUF MISSING',CDSTRING=CDSTRING,LDABORT=LLABORT)
  IRECVBUFSIZE = SIZE(KRECVBUF)
  IF(PRESENT(KRECVDISPL).OR.PRESENT(KSENDCOUNT)) THEN
    IF(.NOT.PRESENT(KSENDCOUNT)) THEN
      IRECVCOUNTS(:) = 1
    ENDIF
    CALL MPL_GATHERV_PREAMB2(IPL_NUMPROC,IPL_MYRANK,IRECVBUFSIZE,ISENDCOUNT,&
         & IRECVCOUNTS,IRECVDISPL,KRECVDISPL,CDSTRING)
    IF(IMP_TYPE == JP_BLOCKING_STANDARD .OR. IMP_TYPE == JP_BLOCKING_BUFFERED) THEN
      CALL MPI_GATHERV(KSENDBUF,ISENDCOUNT,INT(MPI_INTEGER),KRECVBUF(1),&
       & IRECVCOUNTS,IRECVDISPL,INT(MPI_INTEGER),IROOT-1,ICOMM,IERROR)
    ELSEIF(IMP_TYPE == JP_NON_BLOCKING_STANDARD .OR. IMP_TYPE == JP_NON_BLOCKING_BUFFERED) THEN
      CALL MPI_IGATHERV(KSENDBUF,ISENDCOUNT,INT(MPI_INTEGER),KRECVBUF(1),&
       & IRECVCOUNTS,IRECVDISPL,INT(MPI_INTEGER),IROOT-1,ICOMM,KREQUEST,IERROR)
    ENDIF
    IF(LMPLSTATS) THEN
      CALL MPL_SENDSTATS(ISENDCOUNT,INT(MPI_INTEGER))
      CALL MPL_RECVSTATS(SUM(IRECVCOUNTS),INT(MPI_INTEGER))
    ENDIF
  ELSE
    IF(IRECVBUFSIZE < IPL_NUMPROC) THEN
      CALL MPL_MESSAGE(CDMESSAGE='MPL_GATHERV:IRECVBUFSIZE < IPL_NUMPROC',&
       & CDSTRING=CDSTRING,LDABORT=LLABORT)
    ENDIF
    IF(IMP_TYPE == JP_BLOCKING_STANDARD .OR. IMP_TYPE == JP_BLOCKING_BUFFERED) THEN
      CALL MPI_GATHER(KSENDBUF,ISENDCOUNT,INT(MPI_INTEGER),KRECVBUF(1),&
       & ISENDCOUNT,INT(MPI_INTEGER),IROOT-1,ICOMM,IERROR)
    ELSEIF(IMP_TYPE == JP_NON_BLOCKING_STANDARD .OR. IMP_TYPE == JP_NON_BLOCKING_BUFFERED) THEN
      CALL MPI_IGATHER(KSENDBUF,ISENDCOUNT,INT(MPI_INTEGER),KRECVBUF(1),&
       & ISENDCOUNT,INT(MPI_INTEGER),IROOT-1,ICOMM,KREQUEST,IERROR)
    ENDIF
    IF(LMPLSTATS) THEN
      CALL MPL_SENDSTATS(ISENDCOUNT,INT(MPI_INTEGER))
      CALL MPL_RECVSTATS(ISENDCOUNT,INT(MPI_INTEGER))
    ENDIF
  ENDIF
ELSE
  IF(PRESENT(KRECVDISPL).OR.PRESENT(KSENDCOUNT)) THEN
    IF(.NOT.PRESENT(KSENDCOUNT)) THEN
      IRECVCOUNTS(:)=1
    ENDIF
    IF(IMP_TYPE == JP_BLOCKING_STANDARD .OR. IMP_TYPE == JP_BLOCKING_BUFFERED) THEN
      CALL MPI_GATHERV(KSENDBUF,ISENDCOUNT,INT(MPI_INTEGER),ZDUM_INT,KRECVBUF(1), &
       &  IRECVCOUNTS,INT(MPI_INTEGER),IROOT-1,ICOMM,IERROR)
    ELSEIF(IMP_TYPE == JP_NON_BLOCKING_STANDARD .OR. IMP_TYPE == JP_NON_BLOCKING_BUFFERED) THEN
      CALL MPI_IGATHERV(KSENDBUF,ISENDCOUNT,INT(MPI_INTEGER),ZDUM_INT,1, &
       &  1,INT(MPI_INTEGER),IROOT-1,ICOMM,KREQUEST,IERROR)
    ENDIF
    IF(LMPLSTATS) THEN
      CALL MPL_SENDSTATS(ISENDCOUNT,INT(MPI_INTEGER))
    ENDIF
  ELSE
    IF(IMP_TYPE == JP_BLOCKING_STANDARD .OR. IMP_TYPE == JP_BLOCKING_BUFFERED) THEN
      CALL MPI_GATHER(KSENDBUF,ISENDCOUNT,INT(MPI_INTEGER),ZDUM_INT,&
       & 1,INT(MPI_INTEGER),IROOT-1,ICOMM,IERROR)
    ELSEIF(IMP_TYPE == JP_NON_BLOCKING_STANDARD .OR. IMP_TYPE == JP_NON_BLOCKING_BUFFERED) THEN
      CALL MPI_IGATHER(KSENDBUF,ISENDCOUNT,INT(MPI_INTEGER),ZDUM_INT,&
       & 1,INT(MPI_INTEGER),IROOT-1,ICOMM,KREQUEST,IERROR)
    ENDIF
    IF(LMPLSTATS) THEN
      CALL MPL_SENDSTATS(ISENDCOUNT,INT(MPI_INTEGER))
    ENDIF
  ENDIF
ENDIF

IF(PRESENT(KERROR)) THEN
  KERROR=IERROR
ELSE
  IF(IERROR /= 0 ) CALL MPL_MESSAGE(IERROR,'MPL_GATHERV',CDSTRING,LDABORT=LLABORT)
ENDIF

END SUBROUTINE MPL_GATHERV_INT_SCALAR

SUBROUTINE MPL_GATHERV_REAL8_SCALAR(PSENDBUF,KROOT,PRECVBUF,KRECVCOUNTS,&
 &  KRECVDISPL,KMP_TYPE,KCOMM,KERROR,KREQUEST,CDSTRING)


#ifdef USE_8_BYTE_WORDS
  USE MPI4TO8, ONLY : &
    MPI_GATHERV => MPI_GATHERV8, MPI_GATHER => MPI_GATHER8
#endif



REAL(KIND=JPRD),INTENT(IN) :: PSENDBUF
INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL :: KROOT
REAL(KIND=JPRD),INTENT(OUT),OPTIONAL :: PRECVBUF(:)
INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL :: KRECVCOUNTS(:) ! Not used; for compatibility only
INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL :: KRECVDISPL(:),KCOMM,KMP_TYPE
INTEGER(KIND=JPIM),INTENT(OUT),OPTIONAL :: KERROR,KREQUEST
CHARACTER(LEN=*),INTENT(IN),OPTIONAL :: CDSTRING

INTEGER(KIND=JPIM) :: IRECVDISPL(MPL_NUMPROC),IRECVCOUNTS(MPL_NUMPROC)
INTEGER(KIND=JPIM) :: IERROR,IPL_NUMPROC,IPL_MYRANK,ICOMM,IROOT,IMP_TYPE
INTEGER(KIND=JPIM) :: IRECVBUFSIZE,ISENDCOUNT

ISENDCOUNT = 1
CALL MPL_GATHERV_PREAMB1(IERROR,IPL_NUMPROC,IPL_MYRANK,ICOMM,IROOT,IMP_TYPE,KCOMM,KROOT,KMP_TYPE,KREQUEST)

IF(IPL_MYRANK == IROOT) THEN
  IF( .NOT. PRESENT(PRECVBUF)) CALL MPL_MESSAGE(&
   & CDMESSAGE='MPL_GATHERV:RECVBUF MISSING',CDSTRING=CDSTRING,LDABORT=LLABORT)
  IRECVBUFSIZE = SIZE(PRECVBUF)
  IF(PRESENT(KRECVDISPL)) THEN
    IRECVCOUNTS(:) = 1
    CALL MPL_GATHERV_PREAMB2(IPL_NUMPROC,IPL_MYRANK,IRECVBUFSIZE,ISENDCOUNT,&
         & IRECVCOUNTS,IRECVDISPL,KRECVDISPL,CDSTRING)
    IF(IMP_TYPE == JP_BLOCKING_STANDARD .OR. IMP_TYPE == JP_BLOCKING_BUFFERED) THEN
      CALL MPI_GATHERV(PSENDBUF,ISENDCOUNT,INT(MPI_REAL8),PRECVBUF(1),&
       & IRECVCOUNTS,IRECVDISPL,INT(MPI_REAL8),IROOT-1,ICOMM,IERROR)
    ELSEIF(IMP_TYPE == JP_NON_BLOCKING_STANDARD .OR. IMP_TYPE == JP_NON_BLOCKING_BUFFERED) THEN
      CALL MPI_IGATHERV(PSENDBUF,ISENDCOUNT,INT(MPI_REAL8),PRECVBUF(1),&
       & IRECVCOUNTS,IRECVDISPL,INT(MPI_REAL8),IROOT-1,ICOMM,KREQUEST,IERROR)
    ENDIF
    IF(LMPLSTATS) THEN
      CALL MPL_SENDSTATS(ISENDCOUNT,INT(MPI_REAL8))
      CALL MPL_RECVSTATS(SUM(IRECVCOUNTS),INT(MPI_REAL8))
    ENDIF
  ELSE
    IF(IRECVBUFSIZE < IPL_NUMPROC) THEN
      CALL MPL_MESSAGE(CDMESSAGE='MPL_GATHERV:IRECVBUFSIZE < IPL_NUMPROC',&
       & CDSTRING=CDSTRING,LDABORT=LLABORT)
    ENDIF
    IF(IMP_TYPE == JP_BLOCKING_STANDARD .OR. IMP_TYPE == JP_BLOCKING_BUFFERED) THEN
      CALL MPI_GATHER(PSENDBUF,ISENDCOUNT,INT(MPI_REAL8),PRECVBUF(1),&
       & ISENDCOUNT,INT(MPI_REAL8),IROOT-1,ICOMM,IERROR)
    ELSEIF(IMP_TYPE == JP_NON_BLOCKING_STANDARD .OR. IMP_TYPE == JP_NON_BLOCKING_BUFFERED) THEN
      CALL MPI_IGATHER(PSENDBUF,ISENDCOUNT,INT(MPI_REAL8),PRECVBUF(1),&
       & ISENDCOUNT,INT(MPI_REAL8),IROOT-1,ICOMM,KREQUEST,IERROR)
    ENDIF
    IF(LMPLSTATS) THEN
      CALL MPL_SENDSTATS(ISENDCOUNT,INT(MPI_REAL8))
      CALL MPL_RECVSTATS(ISENDCOUNT,INT(MPI_REAL8))
    ENDIF
  ENDIF
ELSE
  IF(PRESENT(KRECVDISPL)) THEN
    IF(IMP_TYPE == JP_BLOCKING_STANDARD .OR. IMP_TYPE == JP_BLOCKING_BUFFERED) THEN
      CALL MPI_GATHERV(PSENDBUF,ISENDCOUNT,INT(MPI_REAL8),ZDUM_JPRD,1, &
       &  1,INT(MPI_REAL8),IROOT-1,ICOMM,IERROR)
    ELSEIF(IMP_TYPE == JP_NON_BLOCKING_STANDARD .OR. IMP_TYPE == JP_NON_BLOCKING_BUFFERED) THEN
      CALL MPI_IGATHERV(PSENDBUF,ISENDCOUNT,INT(MPI_REAL8),ZDUM_JPRD,1, &
       &  1,INT(MPI_REAL8),IROOT-1,ICOMM,KREQUEST,IERROR)
    ENDIF
    IF(LMPLSTATS) THEN
      CALL MPL_SENDSTATS(ISENDCOUNT,INT(MPI_REAL8))
    ENDIF
  ELSE
    IF(IMP_TYPE == JP_BLOCKING_STANDARD .OR. IMP_TYPE == JP_BLOCKING_BUFFERED) THEN
      CALL MPI_GATHER(PSENDBUF,ISENDCOUNT,INT(MPI_REAL8),ZDUM_JPRD,&
       & 1,INT(MPI_REAL8),IROOT-1,ICOMM,IERROR)
    ELSEIF(IMP_TYPE == JP_NON_BLOCKING_STANDARD .OR. IMP_TYPE == JP_NON_BLOCKING_BUFFERED) THEN
      CALL MPI_IGATHER(PSENDBUF,ISENDCOUNT,INT(MPI_REAL8),ZDUM_JPRD,&
       & 1,INT(MPI_REAL8),IROOT-1,ICOMM,KREQUEST,IERROR)
    ENDIF
   IF(LMPLSTATS) THEN
      CALL MPL_SENDSTATS(ISENDCOUNT,INT(MPI_REAL8))
    ENDIF
  ENDIF
ENDIF

IF(PRESENT(KERROR)) THEN
  KERROR=IERROR
ELSE
  IF(IERROR /= 0 ) CALL MPL_MESSAGE(IERROR,'MPL_GATHERV',CDSTRING,LDABORT=LLABORT)
ENDIF

END SUBROUTINE MPL_GATHERV_REAL8_SCALAR

END MODULE MPL_GATHERV_MOD

! (C) Copyright 2005- ECMWF.
! 
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!

!
! Simple Test program
!
subroutine fail_impl(msg,line)
  character(*) :: msg
  integer :: line
  write(0,'(A,I0,A)') "TEST FAILED in test_mpl.F90 @ line ",line," :"
  write(0,*) msg
  stop 1
end subroutine

#define FAIL(msg) call fail_impl(msg,__LINE__)

program test_mpl
use ec_parkind, only : jpim
use mpl_module, only: mpl_init, mpl_end, mpl_rank, linitmpi_via_mpl

implicit none

integer(jpim) :: nprocs
logical :: verbose = .false.

call mpl_init(KPROCS=nprocs,ldinfo=verbose,ldenv=.true.)

if( nprocs == 0 )            FAIL("nprocs must be > 0")
if( mpl_rank == 0 )          FAIL("mpl_rank must be >= 1")
if( .not. linitmpi_via_mpl ) FAIL("linitmpi_via_mpl must be True")

call mpl_end(ldmeminfo=verbose)
! Note that with mpi_serial meminfo will not be printed regardless of ldmeminfo

end program

! (C) Copyright 2005- ECMWF.
! 
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!

SUBROUTINE GETHEAPSTAT(KOUT, CDLABEL)

USE EC_PARKIND  ,ONLY : JPIM     ,JPRD     ,JPIB

USE MPL_MODULE

IMPLICIT NONE

INTEGER(KIND=JPIM), INTENT(IN) :: KOUT
CHARACTER(LEN=*), INTENT(IN) :: CDLABEL
INTEGER(KIND=JPIM) :: I, IMYPROC, INPROC, IRET, IOFFSET, II
INTEGER(KIND=JPIM), PARAMETER :: JP_NPROFILE = 9 ! pls. consult ifsaux/utilities/getcurheap.c
INTEGER(KIND=JPIM), PARAMETER :: ISIZE = JP_NPROFILE+1
INTEGER(KIND=JPIB) ILIMIT(ISIZE)
INTEGER(KIND=JPIB) ICNT(ISIZE)
REAL(KIND=JPRD), ALLOCATABLE :: ZSEND(:), ZRECV(:)
INTEGER(KIND=JPIM), ALLOCATABLE :: ICOUNTS(:)
CHARACTER(LEN=1) CLENV
CHARACTER(LEN=80) CLTEXT(0:4)

CALL GET_ENVIRONMENT_VARIABLE("EC_PROFILE_HEAP", CLENV) ! turn ON by export EC_PROFILE_HEAP=1

IF (KOUT >= 0 .AND. CLENV == '1') THEN
  IMYPROC = MPL_MYRANK()
  INPROC  = MPL_NPROC()

  DO I=1,ISIZE
    ILIMIT(I) = I ! power of 10's ; pls. consult ifsaux/utilities/getcurheap.c
  ENDDO

  ALLOCATE(ZSEND(ISIZE))
  ALLOCATE(ZRECV(ISIZE * INPROC))
  ALLOCATE(ICOUNTS(INPROC))

  CLTEXT(0) = "free()/DEALLOCATE -hits per byte range"
  CLTEXT(1) = "malloc()/ALLOCATE -hits per byte range"
  CLTEXT(2) = "Outstanding malloc()/ALLOCATE -hits per byte range"
  CLTEXT(3) = "Outstanding amount of malloc()/ALLOCATE -bytes per byte range"
  CLTEXT(4) = "Average amount of outstanding malloc()/ALLOCATE -bytes per byte range"

  DO II=0,4
    ICNT(:) = 0
    CALL PROFILE_HEAP_GET(ICNT, ISIZE, II, IRET)

    ZSEND(:) = 0
    DO I=1,IRET
      ZSEND(I) = ICNT(I)
    ENDDO
    ZRECV(:) = -1

    ICOUNTS(:) = ISIZE
    CALL MPL_GATHERV(ZSEND(:), KROOT=1, KRECVCOUNTS=ICOUNTS(:), &
                    &PRECVBUF=ZRECV, CDSTRING='GETHEAPSTAT:')

    IF (IMYPROC == 1) THEN
!     Not more than 132 columns, please :-)
      WRITE(KOUT,9000) TRIM(CLTEXT(II)),TRIM(CDLABEL), "Task", &
                     & (ILIMIT(I),I=1,MIN(JP_NPROFILE,9)), "Larger"
9000  FORMAT(/,"Heap Utilization Profile (",A,"): ",A,&
            &/,126("="),&
            &//,(1X,A4,2X,9(:,2X,4X,"< 10^",I1),:,2X,A10))
      WRITE(KOUT,9001)
9001  FORMAT(1X,4("="),2X,10(2X,10("="))/)
      IOFFSET = 0
      DO I=1,INPROC
        ICNT(:) = ZRECV(IOFFSET+1:IOFFSET+ISIZE)
        WRITE(KOUT,'(i5,2x,(10(:,2x,i10)))') I,ICNT(:)
        IOFFSET = IOFFSET + ISIZE
      ENDDO
    ENDIF
  ENDDO

  IF (IMYPROC == 1) THEN
    WRITE(KOUT,'(/,a,/)') 'End of Heap Utilization Profile'
  ENDIF

  DEALLOCATE(ZSEND)
  DEALLOCATE(ZRECV)
  DEALLOCATE(ICOUNTS)
ENDIF
END SUBROUTINE GETHEAPSTAT

! (C) Copyright 2005- ECMWF.
! 
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!

MODULE SDL_MOD

!    Interface between user applications and system-dependent intrinsic
!    routines, provided by the computer vendors.

!    All routines which wish to call these routines must contain:
!    USE SDL_MOD

! Author :
! ------
!   11-Apr-2005 R. El Khatib  *METEO-FRANCE*
!   26-Apr-2006 S.T.Saarinen  Dr.Hook trace, calls to EC_RAISE, Intel/ifort traceback

USE EC_PARKIND  ,ONLY : JPIM
USE OML_MOD   ,ONLY : OML_MY_THREAD
USE MPL_MPIF
IMPLICIT NONE

SAVE

PRIVATE

INTEGER, PARAMETER :: SIGABRT = 6 ! Hardcoded

PUBLIC :: SDL_SRLABORT, SDL_DISABORT, SDL_TRACEBACK

CONTAINS

!-----------------------------------------------------------------------------
SUBROUTINE SDL_TRACEBACK(KTID)
USE YOMHOOK, ONLY:  DR_HOOK_CALLTREE

! Purpose :
! -------
!   Traceback

!   KTID : thread 

INTEGER(KIND=JPIM), INTENT(IN), OPTIONAL :: KTID

INTEGER(KIND=JPIM) ITID
CHARACTER(LEN=80) :: CLTRBK
INTEGER(KIND=JPIM) :: IERROR,IPROC
LOGICAL :: LMPI_INITIALIZED

IPROC=1
CALL MPI_INITIALIZED(LMPI_INITIALIZED,IERROR) ! always thread safe, see standard !
IF( LMPI_INITIALIZED ) THEN
  CALL MPI_COMM_RANK(MPI_COMM_WORLD,IPROC,IERROR) ! always thread safe, see standard !
  IPROC = IPROC+1 ! 1-based in IFS context
ENDIF

IF (PRESENT(KTID)) THEN
  ITID = KTID
ELSE
  ITID = OML_MY_THREAD()
ENDIF

WRITE(0,'(A,I0,A,I0,A)') 'SDL_TRACEBACK [PROC=',IPROC,',THRD=',ITID,'] ...'
CALL DR_HOOK_CALLTREE(ITID)
#if defined(__INTEL_COMPILER)
CALL INTEL_TRBK()  ! runs LINUX_TRBK as well inside with environment EC_LINUX_TRBK=1 -- See gentrbk.F90
#else
CALL LINUX_TRBK()
CALL GDB_TRBK()    ! needs environment GNUDEBUGGER=1 -- See linuxtrbk.c
CALL DBX_TRBK()    ! needs environment DBXDEBUGGER=1 -- See linuxtrbk.c
#endif
WRITE(0,'(A,I0,A,I0,A)') 'SDL_TRACEBACK [PROC=',IPROC,',THRD=',ITID,'] ... DONE'

END SUBROUTINE SDL_TRACEBACK

!-----------------------------------------------------------------------------
SUBROUTINE SDL_SRLABORT

! Purpose :
! -------
!   To abort in serial environment

CALL EC_RAISE(SIGABRT)
STOP 'SDL_SRLABORT'

END SUBROUTINE SDL_SRLABORT
!-----------------------------------------------------------------------------
SUBROUTINE SDL_DISABORT()

! Purpose :
! -------
!   To abort in distributed environment

USE YOMHOOK, ONLY : LHOOK

INTEGER(KIND=JPIM) :: IRETURN_CODE,IERROR
CHARACTER(LEN=80) :: CLJOBID
CHARACTER(LEN=80) :: CLTRBK

#if defined(__INTEL_COMPILER)
! Intel compiler seems to hang in MPI_ABORT -- on all but the failing task(s)
! ... when linux trbk is used. REK
IF (LHOOK) THEN
  CALL GET_ENVIRONMENT_VARIABLE("EC_LINUX_TRBK",CLTRBK)
  IF (CLTRBK=='1') THEN
    CALL GET_ENVIRONMENT_VARIABLE("SLURM_JOBID",CLJOBID)
    IF (CLJOBID /= ' ') THEN
      CALL SYSTEM("set -x; sleep 10; scancel --signal=TERM "//trim(CLJOBID)//" &")
    ENDIF
  ENDIF
ENDIF
#endif

IRETURN_CODE=SIGABRT
CALL MPI_ABORT(MPI_COMM_WORLD,IRETURN_CODE,IERROR) ! Tracked by the supervisor/process-damager (manager) -- KCOMM /= MPI_COMM_WORLD may hang as sub-communicator

CALL EC_RAISE(SIGABRT) ! In case ever ends up here
STOP 'SDL_DISABORT'

END SUBROUTINE SDL_DISABORT
!-----------------------------------------------------------------------------

END MODULE SDL_MOD

! (C) Copyright 2005- ECMWF.
! 
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!

SUBROUTINE MEMINFO(KOUT,KSTEP)
USE EC_PARKIND, ONLY : JPIM
IMPLICIT NONE
INTEGER(KIND=JPIM), INTENT(IN) :: KOUT, KSTEP
CHARACTER(LEN=32) CLSTEP
INTEGER(KIND=JPIM) :: ICOMM
#include "ec_meminfo.intfb.h"
WRITE(CLSTEP,'(11X,"STEP",I5," :")') KSTEP
ICOMM = -2 ! No headers from EC_MEMINFO by default
IF (KSTEP == 0) ICOMM = -1 ! Print also headers
CALL EC_MEMINFO(KOUT,TRIM(CLSTEP),ICOMM,KBARR=0,KIOTASK=-1,KCALL=-1)
CALL EC_FLUSH(KOUT)
END SUBROUTINE MEMINFO

! (C) Copyright 2025- ECMWF.
!
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.

MODULE MPL_DISPLS_CONTAINER_MOD

!**** MPL_DISPLS_CONTAINER_MOD - Container for the displacements arrays

!     Purpose.
!     --------
!     This module provides a container for the displacements arrays
!     used in the non-blocking collectives when they are not provided by the caller routine.
!
!**   Interface.
!     ----------
!        CALL YDDISPLS%APPEND(REQ, NPROC, SEND_PT, RECV_PT, NO_NEW_NODE)

!        Input optional arguments :
!        -------------------------
!           REQ      -  Request ID
!           NPROC    -  Number of processes in communicator
!           NO_NEW_NODE - If present, the new node is not created, the current node is updated

!        Output optional arguments :
!        -------------------------
!           RECV_PT  -  Pointer to the recv displacements array
!           SEND_PT  -  Pointer to the send displacements array

!**   Interface.
!     ----------
!        CALL YDDISPLS%REMOVE_REQ(REQ)

!        Input required arguments :
!        -------------------------
!           REQ      -  Request ID whose associate node to be removed

!**   Interface.
!     ----------
!        CALL YDDISPLS%TEST_REQ()

!     Author.
!     -------
!        L. Anton

!     Modifications.
!     --------------
!        Original: 2025-04-01

USE EC_PARKIND, ONLY : JPIM
USE MPL_MESSAGE_MOD, ONLY : MPL_MESSAGE
USE MPL_DATA_MODULE, ONLY : MPL_ERRUNIT, MPL_RANK
IMPLICIT NONE
PRIVATE

TYPE, PRIVATE :: DISPLACEMENTS
  INTEGER(KIND=JPIM) :: REQ
  INTEGER(KIND=JPIM) :: NPROC = 0
  INTEGER(KIND=JPIM), ALLOCATABLE :: SEND(:)
  INTEGER(KIND=JPIM), ALLOCATABLE :: RECV(:)
  TYPE(DISPLACEMENTS), POINTER :: PREV
CONTAINS
  PROCEDURE :: INITIALIZE
  PROCEDURE :: GET_SEND
  PROCEDURE :: GET_RECV
  PROCEDURE :: GET_REQ
  PROCEDURE :: GET_NPROC
END TYPE DISPLACEMENTS

TYPE, PUBLIC :: LIST_MANAGER
  TYPE(DISPLACEMENTS), POINTER :: HEAD => NULL()
  INTEGER :: LIST_SIZE = 0
CONTAINS
  PROCEDURE :: APPEND
  PROCEDURE :: REMOVE_FIRST
  PROCEDURE :: REMOVE_REQ1
  PROCEDURE :: REMOVE_REQS
  PROCEDURE :: CLEAR_LIST
  PROCEDURE :: PRINT_LIST
  GENERIC :: REMOVE_REQ => REMOVE_REQ1, REMOVE_REQS
END TYPE LIST_MANAGER

LOGICAL :: LLABORT = .TRUE.
INTEGER, PARAMETER :: ITEST_SIZE = 20!
 ! Drop a warning if the linked list size exceeds this value
 ! It is not expected to have a large number of active displacements in the list

TYPE(LIST_MANAGER),PUBLIC,TARGET :: YDDISPLS_LIST ! the only instance of the list manager

CONTAINS

SUBROUTINE INITIALIZE(THIS, KREQ, KNPROC, KSEND_PT, KRECV_PT)
CLASS(DISPLACEMENTS), TARGET, INTENT(INOUT) :: THIS
INTEGER(KIND=JPIM), INTENT(IN), OPTIONAL :: KREQ, KNPROC
INTEGER(KIND=JPIM), POINTER, INTENT(OUT), OPTIONAL :: KSEND_PT(:), KRECV_PT(:)

IF ( PRESENT(KREQ)) THEN
  THIS%REQ = KREQ
END IF

IF (PRESENT(KNPROC)) THEN
  IF ( THIS%NPROC == 0 ) THEN
    THIS%NPROC = KNPROC
  ELSE
    IF ( KNPROC /= THIS%NPROC) THEN
      CALL MPL_MESSAGE(CDMESSAGE=&
        & 'MPL_DISPLS_CONTAINER_MOD:&
        & Trying to update nproc > 0',&
        & LDABORT=LLABORT)
    END IF
  END IF
END IF

IF (PRESENT(KSEND_PT)) THEN
  IF (THIS%NPROC > 0 ) THEN
    ALLOCATE(THIS%SEND(THIS%NPROC))
    KSEND_PT => THIS%SEND
  ELSE
    CALL MPL_MESSAGE(CDMESSAGE=&
      & 'MPL_DISPLS_CONTAINER_MOD:&
      & Trying to allocate send displs but nproc == 0',&
      & LDABORT=LLABORT)
  END IF
END IF

IF (PRESENT(KRECV_PT)) THEN
  IF (THIS%NPROC > 0 ) THEN
    ALLOCATE(THIS%RECV(THIS%NPROC))
    KRECV_PT => THIS%RECV
  ELSE
    CALL MPL_MESSAGE(CDMESSAGE=&
      & 'MPL_DISPLS_CONTAINER_MOD:&
      & Trying to allocate recv displs but nproc == 0',&
      & LDABORT=LLABORT)
  END IF
END IF

THIS%PREV => NULL()

END SUBROUTINE INITIALIZE


FUNCTION GET_SEND(THIS) RESULT(R)
IMPLICIT NONE
CLASS(DISPLACEMENTS), INTENT(INOUT) :: THIS
INTEGER(KIND=JPIM), ALLOCATABLE ::  R(:)

R = THIS%SEND
END FUNCTION GET_SEND

FUNCTION GET_RECV(THIS) RESULT(R)
IMPLICIT NONE
CLASS(DISPLACEMENTS), INTENT(INOUT) :: THIS
INTEGER(KIND=JPIM), ALLOCATABLE :: R(:)

R = THIS%RECV
END FUNCTION GET_RECV

FUNCTION GET_REQ(THIS) RESULT(R)
IMPLICIT NONE
CLASS(DISPLACEMENTS), INTENT(INOUT) :: THIS
INTEGER(KIND=JPIM) R

R = THIS%REQ
END FUNCTION GET_REQ

FUNCTION GET_NPROC(THIS) RESULT(R)
IMPLICIT NONE
CLASS(DISPLACEMENTS), INTENT(INOUT) :: THIS
INTEGER(KIND=JPIM) R

R = THIS%NPROC
END FUNCTION GET_NPROC


SUBROUTINE APPEND(THIS, KREQ, KNPROC, KSEND_PT, KRECV_PT, NO_NEW_NODE)
CLASS(LIST_MANAGER), TARGET, INTENT(INOUT) :: THIS
INTEGER(KIND=JPIM), INTENT(IN), OPTIONAL :: KREQ, KNPROC
INTEGER(KIND=JPIM), POINTER, INTENT(OUT), OPTIONAL :: KSEND_PT(:), KRECV_PT(:)
LOGICAL, INTENT(IN), OPTIONAL :: NO_NEW_NODE
TYPE(DISPLACEMENTS), POINTER :: YLNEW_NODE, YLTMP
LOGICAL :: LLNEW_NODE

IF(PRESENT(NO_NEW_NODE)) THEN
  LLNEW_NODE = .NOT. NO_NEW_NODE
ELSE
  LLNEW_NODE = .TRUE.
ENDIF

IF (.NOT. ASSOCIATED(THIS%HEAD)) THEN
  IF (.NOT. LLNEW_NODE) THEN
    CALL MPL_MESSAGE(CDMESSAGE=&
      & 'MPL_DISPLS_CONTAINER_MOD:&
      &  APPEND called with NO_NEW_NODE=.TRUE.&
      &  but the internal linked list is empty',&
      & LDABORT=LLABORT)
  END IF
  ALLOCATE(YLNEW_NODE)
  CALL YLNEW_NODE%INITIALIZE(KREQ,KNPROC,KSEND_PT,KRECV_PT)
  THIS%HEAD => YLNEW_NODE
  THIS%LIST_SIZE = THIS%LIST_SIZE + 1
ELSE
  IF (LLNEW_NODE) THEN
    ALLOCATE(YLNEW_NODE)
    CALL YLNEW_NODE%INITIALIZE(KREQ,KNPROC,KSEND_PT,KRECV_PT)
    YLNEW_NODE%PREV => THIS%HEAD
    THIS%HEAD => YLNEW_NODE
    THIS%LIST_SIZE = THIS%LIST_SIZE + 1
  ELSE
    ! Update the curent head
    YLTMP => THIS%HEAD%PREV ! initialise sets prev to NULL
    CALL THIS%HEAD%INITIALIZE(KREQ,KNPROC,KSEND_PT,KRECV_PT)
    THIS%HEAD%PREV => YLTMP
  END IF
END IF

IF (THIS%LIST_SIZE > ITEST_SIZE) THEN
  WRITE(MPL_ERRUNIT,*) 'WARNING: rank ', MPL_RANK, 'The displacements list size ', &
    & THIS%LIST_SIZE, ' > ', ITEST_SIZE
END IF
END SUBROUTINE APPEND

SUBROUTINE REMOVE_FIRST(THIS)
CLASS(LIST_MANAGER), INTENT(INOUT) :: THIS
TYPE(DISPLACEMENTS), POINTER :: TMP

IF (.NOT. ASSOCIATED(THIS%HEAD)) RETURN

TMP => THIS%HEAD
THIS%HEAD => THIS%HEAD%PREV
DEALLOCATE(TMP)
THIS%LIST_SIZE = THIS%LIST_SIZE - 1

END SUBROUTINE REMOVE_FIRST


SUBROUTINE REMOVE_REQ1(THIS,KREQ)
IMPLICIT NONE
CLASS(LIST_MANAGER), INTENT(INOUT) :: THIS
INTEGER, INTENT(IN) :: KREQ
TYPE(DISPLACEMENTS), POINTER :: YLCURRENT, YLCURRENT_, YLTMP

YLCURRENT => THIS%HEAD
DO WHILE (ASSOCIATED(YLCURRENT))
  IF (YLCURRENT%REQ == KREQ) THEN
    IF ( ASSOCIATED(THIS%HEAD, YLCURRENT) ) THEN
      YLTMP => THIS%HEAD
      THIS%HEAD => THIS%HEAD%PREV
      YLCURRENT => THIS%HEAD
    ELSE
      YLTMP => YLCURRENT
      YLCURRENT => YLCURRENT%PREV
      YLCURRENT_%PREV => YLCURRENT
    END IF
    DEALLOCATE(YLTMP)
    THIS%LIST_SIZE = THIS%LIST_SIZE - 1
    EXIT
  ELSE
    YLCURRENT_ => YLCURRENT
    YLCURRENT => YLCURRENT%PREV
  END IF
ENDDO
END SUBROUTINE REMOVE_REQ1

SUBROUTINE REMOVE_REQS(THIS,KREQ)
IMPLICIT NONE
CLASS(LIST_MANAGER), INTENT(INOUT) :: THIS
INTEGER(KIND=JPIM), INTENT(IN) :: KREQ(:)

INTEGER(KIND=JPIM), PARAMETER :: IMAX_WARNINGS  = 10
INTEGER(KIND=JPIM), SAVE :: IWARNING = 0
TYPE(DISPLACEMENTS), POINTER :: CURRENT, CURRENT_, TMP
INTEGER(KIND=JPIM) :: I
LOGICAL :: LLFOUND

IF (THIS%LIST_SIZE == 0) RETURN

 ! This subroutine could be expensive if the requests array is large
 ! This could happen if non-blocking collectives request are mixed
 ! point to point non-blocking requests
 ! The application programmer should avoid this by using different
 ! call to mpl_wait for the different types of requests
IF (IWARNING < IMAX_WARNINGS) THEN
  IF (SIZE(KREQ) > MAX(INT(0.1 * THIS%HEAD%NPROC), 10)) THEN
    WRITE(MPL_ERRUNIT,*) 'WARNING: rank ', MPL_RANK, 'REMOVE_REQ called with a request array of size ', &
      & SIZE(KREQ)
    IWARNING = IWARNING + 1
  ENDIF
ENDIF

CURRENT => THIS%HEAD
DO WHILE (ASSOCIATED(CURRENT))
  LLFOUND = .FALSE.
  ! this loop order will pass unnecessarly over the removed requests
  ! but it does not scan the list multiple times
  DO I=1,SIZE(KREQ)
    IF (KREQ(I) == CURRENT%REQ) THEN
      IF ( ASSOCIATED(THIS%HEAD, CURRENT) ) THEN
        TMP => THIS%HEAD
        THIS%HEAD => THIS%HEAD%PREV
        CURRENT => THIS%HEAD
      ELSE
        CURRENT_%PREV => CURRENT%PREV
        TMP => CURRENT
        CURRENT => CURRENT%PREV
      END IF
      LLFOUND = .TRUE.
      DEALLOCATE(TMP)
      THIS%LIST_SIZE = THIS%LIST_SIZE - 1
      EXIT
    END IF
  END DO
  IF (.NOT. LLFOUND) THEN
    CURRENT_ => CURRENT
    CURRENT => CURRENT%PREV
  END IF
ENDDO
END SUBROUTINE REMOVE_REQS

SUBROUTINE CLEAR_LIST(THIS)
CLASS(LIST_MANAGER), INTENT(INOUT) :: THIS

DO WHILE(ASSOCIATED(THIS%HEAD))
  CALL THIS%REMOVE_FIRST()
END DO

END SUBROUTINE CLEAR_LIST

SUBROUTINE PRINT_LIST(THIS)
CLASS(LIST_MANAGER), INTENT(IN) :: THIS
TYPE(DISPLACEMENTS), POINTER :: CURRENT

CURRENT => THIS%HEAD
WRITE(*,*)'-----------------'
WRITE(*,*) 'Rank', MPL_RANK, 'List size ', THIS%LIST_SIZE
DO WHILE(ASSOCIATED(CURRENT))
  WRITE(*,*) 'REQUEST    ', CURRENT%REQ
  IF (ALLOCATED(CURRENT%SEND)) WRITE(*,*) 'SEND DISPLS', CURRENT%SEND
  IF (ALLOCATED(CURRENT%RECV)) WRITE(*,*) 'RECV DISPLS', CURRENT%RECV
  CURRENT => CURRENT%PREV
END DO
WRITE(*,*)'-----------------'
END SUBROUTINE PRINT_LIST

END MODULE MPL_DISPLS_CONTAINER_MOD

! (C) Copyright 2005- ECMWF.
! (C) Copyright 2013- Meteo-France.
! 
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!

! These functions are to be used within drhook C methods, to avoid having OMP pragmas there.

subroutine drhook_run_omp_parallel_ipfstr(NTIDS, FUNC, CDSTR)
! Usage:
! ------
! void func( const char* string, long strlength ) { ... }
! extern void drhook_run_omp_parallel_ipfstr_(const int *,  void (*func)(const char *, long),
!                                             const char *, /*hidden*/ long);
! drhook_run_omp_parallel_ipfstr_(&ntids,func,string,strlen(string));
use, intrinsic :: iso_c_binding, only : c_char, c_int
implicit none
INTEGER(KIND=C_INT), INTENT(IN) :: NTIDS
EXTERNAL :: FUNC
CHARACTER(LEN=*,KIND=C_CHAR), INTENT(IN) :: CDSTR
!$OMP PARALLEL NUM_THREADS(NTIDS)
CALL FUNC(CDSTR)
!$OMP END PARALLEL
end subroutine drhook_run_omp_parallel_ipfstr

subroutine drhook_run_omp_parallel_ipfipipipdpstr(NTIDS, FUNC, KTIDS, TARGET_OMPTID, TARGET_SIG, START_TIME, CDSTR)
use, intrinsic :: iso_c_binding, only : c_char, c_int, c_double
implicit none
INTEGER(KIND=C_INT), INTENT(IN) :: NTIDS, KTIDS, TARGET_OMPTID, TARGET_SIG
REAL(KIND=C_DOUBLE), INTENT(IN) :: START_TIME
CHARACTER(LEN=*,KIND=C_CHAR), INTENT(IN) :: CDSTR
EXTERNAL :: FUNC
!$OMP PARALLEL NUM_THREADS(NTIDS)
CALL FUNC(KTIDS, TARGET_OMPTID, TARGET_SIG, START_TIME, CDSTR)
!$OMP END PARALLEL
end subroutine drhook_run_omp_parallel_ipfipipipdpstr

subroutine drhook_run_omp_parallel_get_cycles(NTIDS, NCYCLES)
use, intrinsic :: iso_c_binding, only : c_int, c_long_long
use ec_parkind, only : JPIM, JPIB
implicit none
INTEGER(KIND=C_INT), INTENT(IN) :: NTIDS
INTEGER(KIND=C_LONG_LONG), INTENT(INOUT) :: NCYCLES(0:NTIDS-1)
INTEGER(KIND=JPIM) :: IOMPTID
INTEGER(KIND=JPIM) OMP_GET_THREAD_NUM
INTEGER(KIND=C_LONG_LONG), EXTERNAL :: ec_get_cycles ! from ec_get_cycles.c
INTEGER(KIND=C_LONG_LONG) :: ICYCLES
#ifdef _OPENMP
EXTERNAL OMP_GET_THREAD_NUM
#else
OMP_GET_THREAD_NUM() = 0
#endif
!-- Obtain per OpenMP-thread CPU-cycles increment since last call
!$OMP PARALLEL NUM_THREADS(NTIDS) PRIVATE(IOMPTID,ICYCLES) SHARED(NCYCLES)
IOMPTID = OMP_GET_THREAD_NUM()
ICYCLES = ec_get_cycles()
NCYCLES(IOMPTID) = ICYCLES - NCYCLES(IOMPTID)
!$OMP END PARALLEL
end subroutine drhook_run_omp_parallel_get_cycles

! (C) Copyright 2005- ECMWF.
! (C) Copyright 2013- Meteo-France.
! 
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!

SUBROUTINE EC_PMON(ENERGY,POWER)
USE EC_PARKIND, ONLY : JPIM, JPIB
IMPLICIT NONE
INTEGER(KIND=JPIB),INTENT(OUT) :: ENERGY,POWER
INTEGER(KIND=JPIB),SAVE :: ENERGY_START = 0
INTEGER(KIND=JPIM),SAVE :: MONINIT = 0
INTEGER(KIND=JPIM) :: ISTAT
CHARACTER(LEN=1) :: CLEC_PMON
ENERGY = 0
IF (MONINIT >= 0) THEN
   IF (MONINIT == 0) THEN ! The very first time only
      CALL GET_ENVIRONMENT_VARIABLE('EC_PMON',CLEC_PMON)
      IF (CLEC_PMON == '0') MONINIT = -2 ! Never try again
   ENDIF
   IF (MONINIT >= 0) THEN
      OPEN(503,FILE='/sys/cray/pm_counters/energy',IOSTAT=ISTAT,STATUS='old',ACTION='read')
      IF (ISTAT == 0) THEN
         READ(503,*,IOSTAT=ISTAT) ENERGY
         CLOSE(503)
         IF (ISTAT == 0) THEN
            IF (MONINIT == 0) THEN
               ENERGY_START = ENERGY
               MONINIT = 1 ! Ok
            ENDIF
            ENERGY = ENERGY - ENERGY_START
         ENDIF
      ENDIF
      IF (ISTAT /= 0) THEN
         MONINIT = -1 ! Never try again
         ENERGY = 0
      ENDIF
   ENDIF
ENDIF
POWER = 0
IF (MONINIT > 0) THEN
   OPEN(504,FILE='/sys/cray/pm_counters/power',IOSTAT=ISTAT,STATUS='old',ACTION='read')
   IF (ISTAT == 0) THEN
      READ(504,*,IOSTAT=ISTAT) POWER
      CLOSE(504)
   ENDIF
   IF (ISTAT /= 0) POWER = 0
ENDIF
END SUBROUTINE EC_PMON

! (C) Copyright 2005- ECMWF.
! (C) Copyright 2013- Meteo-France.
! 
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!

FUNCTION GETOPT(Y_OPTSTR, Y_OPTARG)

USE EC_PARKIND, ONLY : JPIM
#ifdef NAG
use F90_UNIX, only: GETARG
#endif
IMPLICIT NONE

INTEGER(KIND=JPIM) :: GETOPT
CHARACTER(LEN=*)   :: Y_OPTSTR, Y_OPTARG

INTEGER(KIND=JPIM) :: I,INITIAL,L_OPTSTR
INTEGER(KIND=JPIM) :: N_ARG,N_ARGS,NDX_ARG,NDX_OPT
CHARACTER(LEN=512) :: Y_ARG
CHARACTER(LEN=1)   :: Y_OPT
LOGICAL            :: LL_ENDOPTS

COMMON/GOPT_COM1/ INITIAL  ,N_ARGS  ,N_ARG   ,NDX_ARG ,LL_ENDOPTS
COMMON/GOPT_COM2/ Y_ARG

!  Initialise on 1st. call
!  -----------------------

IF (INITIAL .NE. 123456) THEN
   INITIAL    = 123456
   N_ARGS     = COMMAND_ARGUMENT_COUNT()
   N_ARG      = 0
   NDX_ARG    = 0
   LL_ENDOPTS = .FALSE.
ENDIF

Y_OPTARG = ' '

!  Get length of "y_optstr"
!  ------------------------

L_OPTSTR = 0
DO 10 I = LEN(Y_OPTSTR), 1, -1
IF (Y_OPTSTR(I : I) .NE. ' ') THEN
   L_OPTSTR = I
   GOTO 20
ENDIF
10 CONTINUE
20 CONTINUE

!  If already at end of options, return
!  ------------------------------------

IF ((N_ARG .GT. N_ARGS) .OR. LL_ENDOPTS) THEN
   LL_ENDOPTS = .TRUE.
   GETOPT = -1
   RETURN
ENDIF

!  If we need to get the next argument, do so. Check for end of options
!  --------------------------------------------------------------------

IF (NDX_ARG .EQ. 0) THEN
   N_ARG = N_ARG + 1

   IF (N_ARG .GT. N_ARGS) THEN
      LL_ENDOPTS = .TRUE.
      GETOPT     = -1
      RETURN
   ENDIF

   Y_ARG   = ' '
   CALL GETARG(N_ARG, Y_ARG)
   NDX_ARG = 1

   IF (Y_ARG(1 : 1) .NE. '-') THEN
      LL_ENDOPTS = .TRUE.
      GETOPT     = -1
      RETURN
   ELSE IF (Y_ARG .EQ. '--') THEN
      LL_ENDOPTS = .TRUE.
      N_ARG      = N_ARG + 1
      Y_ARG      = ' '
      IF (N_ARG .LE. N_ARGS) THEN
         CALL GETARG(N_ARG, Y_ARG)
      ENDIF
      GETOPT     = -1
      RETURN
   ENDIF
   NDX_ARG = 2
ENDIF

!  We have an option, now see if it is valid
!  -----------------------------------------

Y_OPT   = Y_ARG(NDX_ARG : NDX_ARG)
NDX_OPT = INDEX(Y_OPTSTR, Y_OPT)

IF (NDX_OPT .EQ. 0) THEN
   NDX_ARG = NDX_ARG + 1
   IF (Y_ARG(NDX_ARG : ) .EQ. ' ') THEN
      NDX_ARG = 0
   ENDIF
   GETOPT = ICHAR(Y_OPT)
   RETURN
ENDIF

!  We have a valid option, see if it should have an argument
!  ---------------------------------------------------------

NDX_ARG = NDX_ARG + 1
IF (Y_ARG(NDX_ARG :) .EQ. ' ') THEN
   NDX_ARG = 0
ENDIF

IF (NDX_OPT .EQ. L_OPTSTR) THEN
   GETOPT = ICHAR(Y_OPT)
   RETURN
ELSE IF (Y_OPTSTR(NDX_OPT + 1 : NDX_OPT + 1) .NE. ':') THEN
   GETOPT = ICHAR(Y_OPT)
   RETURN
ENDIF


!  A valid option with an argument
!  -------------------------------

IF (NDX_ARG .EQ. 0) THEN
   IF (N_ARG .EQ. N_ARGS) THEN
      LL_ENDOPTS = .TRUE.
      GETOPT     = 0
      RETURN
   ENDIF

   N_ARG = N_ARG + 1
   Y_ARG = ' '
   CALL GETARG(N_ARG, Y_ARG)
   NDX_ARG = 1
   LL_ENDOPTS = N_ARG .EQ. N_ARGS
ENDIF

Y_OPTARG = Y_ARG(NDX_ARG : )
NDX_ARG  = 0
GETOPT   = ICHAR(Y_OPT)

ENDFUNCTION GETOPT

! (C) Copyright 2005- ECMWF.
! (C) Copyright 2013- Meteo-France.
! 
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!

MODULE PARKIND2
!
!     *** Define huge kinds for strong typing ***
!
IMPLICIT NONE
SAVE
!
!     Integer Kinds
!     -------------
!
INTEGER, PARAMETER :: JPIH = SELECTED_INT_KIND(18)
!
!     Real Kinds
!     ----------
!
#ifdef REALHUGE
INTEGER, PARAMETER :: JPRH = SELECTED_REAL_KIND(31,291)
#else
INTEGER, PARAMETER :: JPRH = SELECTED_REAL_KIND(13,300)
#endif
!
END MODULE PARKIND2

! (C) Copyright 2005- ECMWF.
! (C) Copyright 2013- Meteo-France.
! 
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!

MODULE MPI4TO8_M
#ifdef USE_8_BYTE_WORDS

USE EC_PARKIND, ONLY : JPIM, JPRM, JPRD
USE MPL_MPIF

IMPLICIT NONE

PRIVATE :: STATUS8
  INTEGER(KIND=8), DIMENSION(MPI_STATUS_SIZE) :: STATUS8

INTERFACE MPI_ALLGATHERV8
  MODULE PROCEDURE MPI_ALLGATHERV8_R4, MPI_ALLGATHERV8_R8, &
                   MPI_ALLGATHERV8_I4, MPI_ALLGATHERV8_I1
END INTERFACE MPI_ALLGATHERV8

INTERFACE MPI_ALLREDUCE8
  MODULE PROCEDURE MPI_ALLREDUCE8_R4, MPI_ALLREDUCE8_R8, &
                   MPI_ALLREDUCE8_I4
END INTERFACE MPI_ALLREDUCE8

INTERFACE MPI_ALLTOALLV8
  MODULE PROCEDURE MPI_ALLTOALLV8_R8, MPI_ALLTOALLV8_I4
END INTERFACE MPI_ALLTOALLV8

INTERFACE MPI_BCAST8
  MODULE PROCEDURE MPI_BCAST8_R4, MPI_BCAST8_R8, &
                   MPI_BCAST8_I4, MPI_BCAST8_I1, &
                   MPI_BCAST8_CH
END INTERFACE MPI_BCAST8

INTERFACE MPI_BSEND8
  MODULE PROCEDURE MPI_BSEND8_R4, MPI_BSEND8_R8, &
                   MPI_BSEND8_R42, MPI_BSEND8_R82, &
                   MPI_BSEND8_I4, MPI_BSEND8_I1, &
                   MPI_BSEND8_CH, MPI_BSEND8_I42, &
                   MPI_BSEND8_R4_1, MPI_BSEND8_R8_1
END INTERFACE MPI_BSEND8

INTERFACE MPI_ISEND8
  MODULE PROCEDURE MPI_ISEND8_R4, MPI_ISEND8_R8, &
                   MPI_ISEND8_R42, MPI_ISEND8_R82, &
                   MPI_ISEND8_I4, MPI_ISEND8_I1, &
                   MPI_ISEND8_CH, MPI_ISEND8_I42, &
                   MPI_ISEND8_R4_1, MPI_ISEND8_R8_1
END INTERFACE MPI_ISEND8

INTERFACE MPI_SEND8
  MODULE PROCEDURE MPI_SEND8_R4, MPI_SEND8_R8, &
                   MPI_SEND8_R42, MPI_SEND8_R82, &
                   MPI_SEND8_I4, MPI_SEND8_I1, &
                   MPI_SEND8_CH, MPI_SEND8_I42, &
                   MPI_SEND8_R4_1, MPI_SEND8_R8_1
END INTERFACE MPI_SEND8

INTERFACE MPI_FILE_IREAD_SHARED8
  MODULE PROCEDURE MPI_FILE_IREAD_SHARED8_R8, MPI_FILE_IREAD_SHARED8_I4
END INTERFACE MPI_FILE_IREAD_SHARED8

INTERFACE MPI_FILE_IWRITE_SHARED8
  MODULE PROCEDURE MPI_FILE_IWRITE_SHARED8_R8, MPI_FILE_IWRITE_SHARED8_I4
END INTERFACE MPI_FILE_IWRITE_SHARED8

INTERFACE MPI_FILE_READ_ORDERED8
  MODULE PROCEDURE MPI_FILE_READ_ORDERED8_R8, MPI_FILE_READ_ORDERED8_I4
END INTERFACE MPI_FILE_READ_ORDERED8

INTERFACE MPI_FILE_READ_ORDERED_BEGIN8
  MODULE PROCEDURE MPI_FREAD_ORDERED_BEGIN8_R8, MPI_FREAD_ORDERED_BEGIN8_I4
END INTERFACE MPI_FILE_READ_ORDERED_BEGIN8

INTERFACE MPI_FILE_READ_ORDERED_END8
  MODULE PROCEDURE MPI_FREAD_ORDERED_END8_R8, MPI_FREAD_ORDERED_END8_I4
END INTERFACE MPI_FILE_READ_ORDERED_END8

INTERFACE MPI_FILE_READ_SHARED8
  MODULE PROCEDURE MPI_FILE_READ_SHARED8_R8, MPI_FILE_READ_SHARED8_I4
END INTERFACE MPI_FILE_READ_SHARED8

INTERFACE MPI_FILE_WRITE_ORDERED8
  MODULE PROCEDURE MPI_FILE_WRITE_ORDERED8_R8, MPI_FILE_WRITE_ORDERED8_I4
END INTERFACE MPI_FILE_WRITE_ORDERED8

INTERFACE MPI_FILE_WRITE_ORDERED_BEGIN8
  MODULE PROCEDURE MPI_FWRITE_ORDERED_BEGIN8_R8, MPI_FWRITE_ORDERED_BEGIN8_I4
END INTERFACE MPI_FILE_WRITE_ORDERED_BEGIN8

INTERFACE MPI_FILE_WRITE_ORDERED_END8
  MODULE PROCEDURE MPI_FWRITE_ORDERED_END8_R8, MPI_FWRITE_ORDERED_END8_I4
END INTERFACE MPI_FILE_WRITE_ORDERED_END8

INTERFACE MPI_FILE_WRITE_SHARED8
  MODULE PROCEDURE MPI_FILE_WRITE_SHARED8_R8, MPI_FILE_WRITE_SHARED8_I4
END INTERFACE MPI_FILE_WRITE_SHARED8

INTERFACE MPI_GATHER8
  MODULE PROCEDURE MPI_GATHER8_I1, MPI_GATHER8_R8_1
END INTERFACE MPI_GATHER8

INTERFACE MPI_GATHERV8
  MODULE PROCEDURE MPI_GATHERV8_R4, MPI_GATHERV8_R8, &
                   MPI_GATHERV8_R4S, MPI_GATHERV8_R8S, &
                   MPI_GATHERV8_I4, MPI_GATHERV8_I1, &
                   MPI_GATHERV8_I4S, MPI_GATHERV8_I4S_1, &
                   MPI_GATHERV8_R8_1, MPI_GATHERV8_R8S_1
END INTERFACE MPI_GATHERV8

INTERFACE MPI_RECV8
  MODULE PROCEDURE MPI_RECV8_R4, MPI_RECV8_R8, &
                   MPI_RECV8_R42, MPI_RECV8_R82, &
                   MPI_RECV8_I4, MPI_RECV8_I1, &
                   MPI_RECV8_R4_1, MPI_RECV8_R8_1, &
                   MPI_RECV8_CH, MPI_RECV8_I42
END INTERFACE MPI_RECV8

INTERFACE MPI_IRECV8
  MODULE PROCEDURE MPI_IRECV8_R4, MPI_IRECV8_R8, &
                   MPI_IRECV8_R42, MPI_IRECV8_R82, &
                   MPI_IRECV8_I4, MPI_IRECV8_I1, &
                   MPI_IRECV8_I42, &
                   MPI_IRECV8_R4_1, MPI_IRECV8_R8_1, &
                   MPI_IRECV8_CH
END INTERFACE MPI_IRECV8

INTERFACE MPI_SCATTERV8
  MODULE PROCEDURE MPI_SCATTERV8_R8, MPI_SCATTERV8_I4, &
                   MPI_SCATTERV8_R8S, MPI_SCATTERV8_I4S
END INTERFACE MPI_SCATTERV8

PUBLIC

CONTAINS

! =========================================================
! ---------------------------------------------------------
SUBROUTINE MPI_ALLREDUCE8_R4(SENDDATA, RECVDATA, COUNT, DATATYPE, OP, &
                             COMM, IERROR)

  REAL(KIND=JPRM), DIMENSION(:), INTENT(IN) :: &
    SENDDATA(:)
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COUNT, DATATYPE, OP, COMM
  REAL(KIND=JPRM), DIMENSION(:), INTENT(OUT) :: &
    RECVDATA(:)
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    IERROR

  REAL(KIND=8), DIMENSION(:), ALLOCATABLE :: &
    SENDDATA8, RECVDATA8
  INTEGER(KIND=8) :: &
    COUNT8, DATATYPE8, OP8, COMM8, IERROR8

  ALLOCATE(SENDDATA8(SIZE(SENDDATA)))
  ALLOCATE(RECVDATA8(SIZE(RECVDATA)))

  SENDDATA8 = SENDDATA
  COUNT8 = COUNT
  DATATYPE8 = DATATYPE
  OP8 = OP
  COMM8 = COMM

  CALL MPI_ALLREDUCE(SENDDATA8, RECVDATA8, COUNT8, DATATYPE8, OP8, COMM8, IERROR8)

  RECVDATA = RECVDATA8
  IERROR = IERROR8

  DEALLOCATE(SENDDATA8)
  DEALLOCATE(RECVDATA8)

END SUBROUTINE MPI_ALLREDUCE8_R4

! ---------------------------------------------------------
SUBROUTINE MPI_ALLREDUCE8_R8(SENDDATA, RECVDATA, COUNT, DATATYPE, OP, &
                             COMM, IERROR)

  REAL(KIND=JPRD), DIMENSION(:), INTENT(IN) :: &
    SENDDATA(:)
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COUNT, DATATYPE, OP, COMM
  REAL(KIND=JPRD), DIMENSION(:), INTENT(OUT) :: &
    RECVDATA(:)
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    IERROR

  INTEGER(KIND=8) :: &
    COUNT8, DATATYPE8, OP8, COMM8, IERROR8

  COUNT8 = COUNT
  DATATYPE8 = DATATYPE
  OP8 = OP
  COMM8 = COMM

  CALL MPI_ALLREDUCE(SENDDATA, RECVDATA, COUNT8, DATATYPE8, OP8, COMM8, IERROR8)

  IERROR = IERROR8

END SUBROUTINE MPI_ALLREDUCE8_R8

! ---------------------------------------------------------
SUBROUTINE MPI_ALLREDUCE8_I4(SENDDATA, RECVDATA, COUNT, DATATYPE, OP, &
                              COMM, IERROR)

  INTEGER(KIND=JPIM), DIMENSION(:), INTENT(IN) :: &
    SENDDATA(:)
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COUNT, DATATYPE, OP, COMM
  INTEGER(KIND=JPIM), DIMENSION(:), INTENT(OUT) :: &
    RECVDATA(:)
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    IERROR

  INTEGER(KIND=8), DIMENSION(:), ALLOCATABLE :: &
    SENDDATA8, RECVDATA8
  INTEGER(KIND=8) :: &
    COUNT8, DATATYPE8, OP8, COMM8, IERROR8

  ALLOCATE(SENDDATA8(SIZE(SENDDATA)))
  ALLOCATE(RECVDATA8(SIZE(RECVDATA)))

  SENDDATA8 = SENDDATA
  COUNT8 = COUNT
  DATATYPE8 = DATATYPE
  OP8 = OP
  COMM8 = COMM

  CALL MPI_ALLREDUCE(SENDDATA8, RECVDATA8, COUNT8, DATATYPE8, OP8, COMM8, IERROR8)

  RECVDATA = RECVDATA8
  IERROR = IERROR8

  DEALLOCATE(SENDDATA8)
  DEALLOCATE(RECVDATA8)

END SUBROUTINE MPI_ALLREDUCE8_I4

! =========================================================
! ---------------------------------------------------------
SUBROUTINE MPI_ALLGATHERV8_R4(SENDAREA, SENDCOUNT, SENDTYPE, RECVAREA, &
                              RECVCOUNTS, DISPLS, RECVTYPE, COMM, IERROR)

  REAL(KIND=JPRM), DIMENSION(:), INTENT(IN) :: &
    SENDAREA
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    SENDCOUNT, SENDTYPE, RECVTYPE, COMM
  REAL(KIND=JPRM), DIMENSION(:), INTENT(OUT) :: &
    RECVAREA
  INTEGER(KIND=JPIM), DIMENSION(:), INTENT(IN) :: &
    RECVCOUNTS, DISPLS
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    IERROR

  REAL(KIND=8), DIMENSION(:), ALLOCATABLE :: &
    SENDAREA8, RECVAREA8
  INTEGER(KIND=8), DIMENSION(:), ALLOCATABLE :: &
    RECVCOUNTS8, DISPLS8
  INTEGER(KIND=8) :: &
    SENDCOUNT8, SENDTYPE8, RECVTYPE8, COMM8, IERROR8

  ALLOCATE(SENDAREA8(SIZE(SENDAREA)))
  ALLOCATE(RECVAREA8(SIZE(RECVAREA)))
  ALLOCATE(RECVCOUNTS8(SIZE(RECVCOUNTS)))
  ALLOCATE(DISPLS8(SIZE(DISPLS)))

  SENDAREA8 = SENDAREA
  SENDCOUNT8 = SENDCOUNT
  SENDTYPE8 = SENDTYPE
  RECVCOUNTS8 = RECVCOUNTS
  DISPLS8 = DISPLS
  RECVTYPE8 = RECVTYPE
  COMM8 = COMM

  CALL MPI_ALLGATHERV(SENDAREA8, SENDCOUNT8, SENDTYPE8, RECVAREA8, &
                      RECVCOUNTS8, DISPLS8, RECVTYPE8, COMM8, IERROR8)

  RECVAREA = RECVAREA8
  IERROR = IERROR8

  DEALLOCATE(SENDAREA8)
  DEALLOCATE(RECVAREA8)
  DEALLOCATE(RECVCOUNTS8)
  DEALLOCATE(DISPLS8)

END SUBROUTINE MPI_ALLGATHERV8_R4

! ---------------------------------------------------------
SUBROUTINE MPI_ALLGATHERV8_R8(SENDAREA, SENDCOUNT, SENDTYPE, RECVAREA, &
                              RECVCOUNTS, DISPLS, RECVTYPE, COMM, IERROR)

  REAL(KIND=JPRD), DIMENSION(:), INTENT(IN) :: &
    SENDAREA
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    SENDCOUNT, SENDTYPE, RECVTYPE, COMM
  REAL(KIND=JPRD), DIMENSION(:), INTENT(OUT) :: &
    RECVAREA
  INTEGER(KIND=JPIM), DIMENSION(:), INTENT(IN) :: &
    RECVCOUNTS, DISPLS
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    IERROR

  INTEGER(KIND=8), DIMENSION(:), ALLOCATABLE :: &
    RECVCOUNTS8, DISPLS8
  INTEGER(KIND=8) :: &
    SENDCOUNT8, SENDTYPE8, RECVTYPE8, COMM8, IERROR8

  ALLOCATE(RECVCOUNTS8(SIZE(RECVCOUNTS)))
  ALLOCATE(DISPLS8(SIZE(DISPLS)))

  SENDCOUNT8 = SENDCOUNT
  SENDTYPE8 = SENDTYPE
  RECVCOUNTS8 = RECVCOUNTS
  DISPLS8 = DISPLS
  RECVTYPE8 = RECVTYPE
  COMM8 = COMM

  CALL MPI_ALLGATHERV(SENDAREA, SENDCOUNT8, SENDTYPE8, RECVAREA, &
                      RECVCOUNTS8, DISPLS8, RECVTYPE8, COMM8, IERROR8)

  IERROR = IERROR8

  DEALLOCATE(RECVCOUNTS8)
  DEALLOCATE(DISPLS8)

END SUBROUTINE MPI_ALLGATHERV8_R8

! ---------------------------------------------------------
SUBROUTINE MPI_ALLGATHERV8_I4(SENDAREA, SENDCOUNT, SENDTYPE, RECVAREA, &
                               RECVCOUNTS, DISPLS, RECVTYPE, COMM, IERROR)

  INTEGER(KIND=JPIM), DIMENSION(:), INTENT(IN) :: &
    SENDAREA, RECVCOUNTS, DISPLS
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    SENDCOUNT, SENDTYPE, RECVTYPE, COMM
  INTEGER(KIND=JPIM), DIMENSION(:), INTENT(OUT) :: &
    RECVAREA
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    IERROR

  INTEGER(KIND=8), DIMENSION(:), ALLOCATABLE :: &
    SENDAREA8, RECVAREA8, RECVCOUNTS8, DISPLS8
  INTEGER(KIND=8) :: &
    SENDCOUNT8, SENDTYPE8, RECVTYPE8, COMM8, IERROR8

  ALLOCATE(SENDAREA8(SIZE(SENDAREA)))
  ALLOCATE(RECVAREA8(SIZE(RECVAREA)))
  ALLOCATE(RECVCOUNTS8(SIZE(RECVCOUNTS)))
  ALLOCATE(DISPLS8(SIZE(DISPLS)))

  SENDAREA8 = SENDAREA
  SENDCOUNT8 = SENDCOUNT
  SENDTYPE8 = SENDTYPE
  RECVCOUNTS8 = RECVCOUNTS
  DISPLS8 = DISPLS
  RECVTYPE8 = RECVTYPE
  COMM8 = COMM

  CALL MPI_ALLGATHERV(SENDAREA8, SENDCOUNT8, SENDTYPE8, RECVAREA8, &
                      RECVCOUNTS8, DISPLS8, RECVTYPE8, COMM8, IERROR8)

  RECVAREA = RECVAREA8
  IERROR = IERROR8

  DEALLOCATE(SENDAREA8)
  DEALLOCATE(RECVAREA8)
  DEALLOCATE(RECVCOUNTS8)
  DEALLOCATE(DISPLS8)

END SUBROUTINE MPI_ALLGATHERV8_I4

! ---------------------------------------------------------
SUBROUTINE MPI_ALLGATHERV8_I1(SENDAREA, SENDCOUNT, SENDTYPE, RECVAREA, &
                               RECVCOUNTS, DISPLS, RECVTYPE, COMM, IERROR)

  INTEGER(KIND=JPIM), INTENT(IN) :: &
    SENDAREA
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    SENDCOUNT, SENDTYPE, RECVTYPE, COMM
  INTEGER(KIND=JPIM), DIMENSION(:), INTENT(IN) :: &
    RECVCOUNTS, DISPLS
  INTEGER(KIND=JPIM), DIMENSION(:), INTENT(OUT) :: &
    RECVAREA
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    IERROR

  INTEGER(KIND=8), DIMENSION(:), ALLOCATABLE :: &
    RECVAREA8, RECVCOUNTS8, DISPLS8
  INTEGER(KIND=8) :: &
    SENDAREA8, SENDCOUNT8, SENDTYPE8, RECVTYPE8, COMM8, IERROR8

  ALLOCATE(RECVAREA8(SIZE(RECVAREA)))
  ALLOCATE(RECVCOUNTS8(SIZE(RECVCOUNTS)))
  ALLOCATE(DISPLS8(SIZE(DISPLS)))

  SENDAREA8 = SENDAREA
  SENDCOUNT8 = SENDCOUNT
  SENDTYPE8 = SENDTYPE
  RECVCOUNTS8 = RECVCOUNTS
  DISPLS8 = DISPLS
  RECVTYPE8 = RECVTYPE
  COMM8 = COMM

  CALL MPI_ALLGATHERV(SENDAREA8, SENDCOUNT8, SENDTYPE8, RECVAREA8, &
                      RECVCOUNTS8, DISPLS8, RECVTYPE8, COMM8, IERROR8)

  RECVAREA = RECVAREA8
  IERROR = IERROR8

  DEALLOCATE(RECVAREA8)
  DEALLOCATE(RECVCOUNTS8)
  DEALLOCATE(DISPLS8)

END SUBROUTINE MPI_ALLGATHERV8_I1

! =========================================================
! ---------------------------------------------------------
SUBROUTINE MPI_ALLTOALLV8_R8(SENDAREA, SENDCOUNTS, SDISPLS, SENDTYPE, &
                             RECVAREA, RECVCOUNTS, RDISPLS, RECVTYPE, &
                             COMM, IERROR)

  REAL(KIND=JPRD), DIMENSION(:), INTENT(IN) :: &
    SENDAREA
  INTEGER(KIND=JPIM), DIMENSION(:), INTENT(IN) :: &
    SENDCOUNTS, SDISPLS, RECVCOUNTS, RDISPLS
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    SENDTYPE, RECVTYPE, COMM
  REAL(KIND=JPRD), DIMENSION(:), INTENT(OUT) :: &
    RECVAREA
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    IERROR

  INTEGER(KIND=8), DIMENSION(:), ALLOCATABLE :: &
    SENDCOUNTS8, SDISPLS8, RECVCOUNTS8, RDISPLS8
  INTEGER(KIND=8) :: &
    SENDTYPE8, RECVTYPE8, COMM8, IERROR8

  ALLOCATE(SENDCOUNTS8(SIZE(SENDCOUNTS)))
  ALLOCATE(SDISPLS8(SIZE(SDISPLS)))
  ALLOCATE(RECVCOUNTS8(SIZE(RECVCOUNTS)))
  ALLOCATE(RDISPLS8(SIZE(RDISPLS)))

  SENDCOUNTS8 = SENDCOUNTS
  SDISPLS8 = SDISPLS
  SENDTYPE8 = SENDTYPE
  RECVCOUNTS8 = RECVCOUNTS
  RDISPLS8 = RDISPLS
  RECVTYPE8 = RECVTYPE
  COMM8 = COMM

  CALL MPI_ALLTOALLV(SENDAREA, SENDCOUNTS8, SDISPLS8, SENDTYPE8, RECVAREA, &
                     RECVCOUNTS8, RDISPLS8, RECVTYPE8, COMM8, IERROR8)

  IERROR = IERROR8

  DEALLOCATE(SENDCOUNTS8)
  DEALLOCATE(SDISPLS8)
  DEALLOCATE(RECVCOUNTS8)
  DEALLOCATE(RDISPLS8)

END SUBROUTINE MPI_ALLTOALLV8_R8

! ---------------------------------------------------------
SUBROUTINE MPI_ALLTOALLV8_I4(SENDAREA, SENDCOUNTS, SDISPLS, SENDTYPE, &
                              RECVAREA, RECVCOUNTS, RDISPLS, RECVTYPE, &
                              COMM, IERROR)

  INTEGER(KIND=JPIM), DIMENSION(:), INTENT(IN) :: &
    SENDAREA, SENDCOUNTS, SDISPLS, RECVCOUNTS, RDISPLS
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    SENDTYPE, RECVTYPE, COMM
  INTEGER(KIND=JPIM), DIMENSION(:), INTENT(OUT) :: &
    RECVAREA
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    IERROR

  INTEGER(KIND=8), DIMENSION(:), ALLOCATABLE :: &
    SENDAREA8, SENDCOUNTS8, SDISPLS8, RECVAREA8, RECVCOUNTS8, RDISPLS8
  INTEGER(KIND=8) :: &
    SENDTYPE8, RECVTYPE8, COMM8, IERROR8

  ALLOCATE(SENDAREA8(SIZE(SENDAREA)))
  ALLOCATE(SENDCOUNTS8(SIZE(SENDCOUNTS)))
  ALLOCATE(SDISPLS8(SIZE(SDISPLS)))
  ALLOCATE(RECVAREA8(SIZE(RECVAREA)))
  ALLOCATE(RECVCOUNTS8(SIZE(RECVCOUNTS)))
  ALLOCATE(RDISPLS8(SIZE(RDISPLS)))

  SENDAREA8 = SENDAREA
  SENDCOUNTS8 = SENDCOUNTS
  SDISPLS8 = SDISPLS
  SENDTYPE8 = SENDTYPE
  RECVCOUNTS8 = RECVCOUNTS
  RDISPLS8 = RDISPLS
  RECVTYPE8 = RECVTYPE
  COMM8 = COMM

  CALL MPI_ALLTOALLV(SENDAREA8, SENDCOUNTS8, SDISPLS8, SENDTYPE8, RECVAREA8, &
                     RECVCOUNTS8, RDISPLS8, RECVTYPE8, COMM8, IERROR8)

  RECVAREA = RECVAREA8
  IERROR = IERROR8

  DEALLOCATE(SENDAREA8)
  DEALLOCATE(SENDCOUNTS8)
  DEALLOCATE(SDISPLS8)
  DEALLOCATE(RECVAREA8)
  DEALLOCATE(RECVCOUNTS8)
  DEALLOCATE(RDISPLS8)

END SUBROUTINE MPI_ALLTOALLV8_I4

! =========================================================
! ---------------------------------------------------------
SUBROUTINE MPI_BCAST8_R4(DATA, COUNT, DATATYPE, ROOT, COMM, IERROR)

  REAL(KIND=JPRM), DIMENSION(:), INTENT(INOUT) :: &
    DATA
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COUNT, DATATYPE, ROOT, COMM
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    IERROR

  REAL(KIND=8), DIMENSION(:), ALLOCATABLE :: &
    DATA8
  INTEGER(KIND=8) :: &
    COUNT8, DATATYPE8, ROOT8, COMM8, IERROR8

  ALLOCATE(DATA8(SIZE(DATA)))

  DATA8 = DATA
  COUNT8 = COUNT
  DATATYPE8 = DATATYPE
  ROOT8 = ROOT
  COMM8 = COMM

  CALL MPI_BCAST(DATA8, COUNT8, DATATYPE8, ROOT8, COMM8, IERROR8)

  DATA = DATA8
  IERROR = IERROR8

  DEALLOCATE(DATA8)

END SUBROUTINE MPI_BCAST8_R4

! ---------------------------------------------------------
SUBROUTINE MPI_BCAST8_R8(DATA, COUNT, DATATYPE, ROOT, COMM, IERROR)

  REAL(KIND=JPRD), DIMENSION(:), INTENT(INOUT) :: &
    DATA
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COUNT, DATATYPE, ROOT, COMM
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    IERROR

  INTEGER(KIND=8) :: &
    COUNT8, DATATYPE8, ROOT8, COMM8, IERROR8

  COUNT8 = COUNT
  DATATYPE8 = DATATYPE
  ROOT8 = ROOT
  COMM8 = COMM

  CALL MPI_BCAST(DATA, COUNT8, DATATYPE8, ROOT8, COMM8, IERROR8)

  IERROR = IERROR8

END SUBROUTINE MPI_BCAST8_R8

! ---------------------------------------------------------
SUBROUTINE MPI_BCAST8_I4(DATA, COUNT, DATATYPE, ROOT, COMM, IERROR)

  INTEGER(KIND=JPIM), DIMENSION(:), INTENT(INOUT) :: &
    DATA
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COUNT, DATATYPE, ROOT, COMM
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    IERROR

  INTEGER(KIND=8), DIMENSION(:), ALLOCATABLE :: &
    DATA8
  INTEGER(KIND=8) :: &
    COUNT8, DATATYPE8, ROOT8, COMM8, IERROR8

  ALLOCATE(DATA8(SIZE(DATA)))

  DATA8 = DATA
  COUNT8 = COUNT
  DATATYPE8 = DATATYPE
  ROOT8 = ROOT
  COMM8 = COMM

  CALL MPI_BCAST(DATA8, COUNT8, DATATYPE8, ROOT8, COMM8, IERROR8)

  DATA = DATA8
  IERROR = IERROR8

  DEALLOCATE(DATA8)

END SUBROUTINE MPI_BCAST8_I4

! ---------------------------------------------------------
SUBROUTINE MPI_BCAST8_I1(DATA, COUNT, DATATYPE, ROOT, COMM, IERROR)

  INTEGER(KIND=JPIM), INTENT(INOUT) :: &
    DATA
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COUNT, DATATYPE, ROOT, COMM
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    IERROR

  INTEGER(KIND=8) :: &
    DATA8, COUNT8, DATATYPE8, ROOT8, COMM8, IERROR8

  DATA8 = DATA
  COUNT8 = COUNT
  DATATYPE8 = DATATYPE
  ROOT8 = ROOT
  COMM8 = COMM

  CALL MPI_BCAST(DATA8, COUNT8, DATATYPE8, ROOT8, COMM8, IERROR8)

  DATA = DATA8
  IERROR = IERROR8

END SUBROUTINE MPI_BCAST8_I1

! ---------------------------------------------------------
SUBROUTINE MPI_BCAST8_CH(DATA, COUNT, DATATYPE, ROOT, COMM, IERROR)

  CHARACTER(LEN=*), INTENT(INOUT) :: &
    DATA
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COUNT, DATATYPE, ROOT, COMM
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    IERROR

  INTEGER(KIND=8) :: &
    COUNT8, DATATYPE8, ROOT8, COMM8, IERROR8

  COUNT8 = COUNT
  DATATYPE8 = DATATYPE
  ROOT8 = ROOT
  COMM8 = COMM

  CALL MPI_BCAST(DATA, COUNT8, DATATYPE8, ROOT8, COMM8, IERROR8)

  IERROR = IERROR8

END SUBROUTINE MPI_BCAST8_CH

! =========================================================
! ---------------------------------------------------------
SUBROUTINE MPI_BSEND8_R4(DATA, COUNT, DATATYPE, DEST, TAG, COMM, IERROR)

  REAL(KIND=JPRM), DIMENSION(:), INTENT(IN) :: &
    DATA
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COUNT, DATATYPE, DEST, TAG, COMM
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    IERROR

  REAL(KIND=8), DIMENSION(:), ALLOCATABLE :: &
    DATA8
  INTEGER(KIND=8) :: &
    COUNT8, DATATYPE8, DEST8, TAG8, COMM8, IERROR8

  ALLOCATE(DATA8(SIZE(DATA)))

  DATA8 = DATA
  COUNT8 = COUNT
  DATATYPE8 = DATATYPE
  DEST8 = DEST
  TAG8 = TAG
  COMM8 = COMM

  CALL MPI_BSEND(DATA8, COUNT8, DATATYPE8, DEST8, TAG8, COMM8, IERROR8)

  IERROR = IERROR8

  DEALLOCATE(DATA8)

END SUBROUTINE MPI_BSEND8_R4

! =========================================================
! ---------------------------------------------------------
SUBROUTINE MPI_BSEND8_R8(DATA, COUNT, DATATYPE, DEST, TAG, COMM, IERROR)

  REAL(KIND=JPRD), DIMENSION(:), INTENT(IN) :: &
    DATA
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COUNT, DATATYPE, DEST, TAG, COMM
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    IERROR

  INTEGER(KIND=8) :: &
    COUNT8, DATATYPE8, DEST8, TAG8, COMM8, IERROR8

  COUNT8 = COUNT
  DATATYPE8 = DATATYPE
  DEST8 = DEST
  TAG8 = TAG
  COMM8 = COMM

  CALL MPI_BSEND(DATA, COUNT8, DATATYPE8, DEST8, TAG8, COMM8, IERROR8)

  IERROR = IERROR8

END SUBROUTINE MPI_BSEND8_R8

! ---------------------------------------------------------
SUBROUTINE MPI_BSEND8_R42(DATA, COUNT, DATATYPE, DEST, TAG, COMM, IERROR)

  REAL(KIND=JPRM), DIMENSION(:,:), INTENT(IN) :: &
    DATA
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COUNT, DATATYPE, DEST, TAG, COMM
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    IERROR

  REAL(KIND=8), DIMENSION(:,:), ALLOCATABLE :: &
    DATA8
  INTEGER(KIND=8) :: &
    COUNT8, DATATYPE8, DEST8, TAG8, COMM8, IERROR8

  ALLOCATE(DATA8(SIZE(DATA,DIM=1),SIZE(DATA,DIM=2)))

  DATA8 = DATA
  COUNT8 = COUNT
  DATATYPE8 = DATATYPE
  DEST8 = DEST
  TAG8 = TAG
  COMM8 = COMM

  CALL MPI_BSEND(DATA8, COUNT8, DATATYPE8, DEST8, TAG8, COMM8, IERROR8)

  IERROR = IERROR8

  DEALLOCATE(DATA8)

END SUBROUTINE MPI_BSEND8_R42

! =========================================================
SUBROUTINE MPI_BSEND8_I42(DATA, COUNT, DATATYPE, DEST, TAG, COMM, IERROR)

  INTEGER(KIND=JPRM), DIMENSION(:,:), INTENT(IN) :: &
    DATA
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COUNT, DATATYPE, DEST, TAG, COMM
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    IERROR

  INTEGER(KIND=8), DIMENSION(:,:), ALLOCATABLE :: &
    DATA8
  INTEGER(KIND=8) :: &
    COUNT8, DATATYPE8, DEST8, TAG8, COMM8, IERROR8

  ALLOCATE(DATA8(SIZE(DATA,DIM=1),SIZE(DATA,DIM=2)))

  DATA8 = DATA
  COUNT8 = COUNT
  DATATYPE8 = DATATYPE
  DEST8 = DEST
  TAG8 = TAG
  COMM8 = COMM

  CALL MPI_BSEND(DATA8, COUNT8, DATATYPE8, DEST8, TAG8, COMM8, IERROR8)

  IERROR = IERROR8

  DEALLOCATE(DATA8)

END SUBROUTINE MPI_BSEND8_I42

! =========================================================
! ---------------------------------------------------------
SUBROUTINE MPI_BSEND8_R82(DATA, COUNT, DATATYPE, DEST, TAG, COMM, IERROR)

  REAL(KIND=JPRD), DIMENSION(:,:), INTENT(IN) :: &
    DATA
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COUNT, DATATYPE, DEST, TAG, COMM
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    IERROR

  INTEGER(KIND=8) :: &
    COUNT8, DATATYPE8, DEST8, TAG8, COMM8, IERROR8

  COUNT8 = COUNT
  DATATYPE8 = DATATYPE
  DEST8 = DEST
  TAG8 = TAG
  COMM8 = COMM

  CALL MPI_BSEND(DATA, COUNT8, DATATYPE8, DEST8, TAG8, COMM8, IERROR8)

  IERROR = IERROR8

END SUBROUTINE MPI_BSEND8_R82

! =========================================================
! ---------------------------------------------------------
SUBROUTINE MPI_BSEND8_I4(DATA, COUNT, DATATYPE, DEST, TAG, COMM, IERROR)

  INTEGER(KIND=JPIM), DIMENSION(:), INTENT(IN) :: &
    DATA
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COUNT, DATATYPE, DEST, TAG, COMM
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    IERROR

  INTEGER(KIND=8), DIMENSION(:), ALLOCATABLE :: &
    DATA8
  INTEGER(KIND=8) :: &
    COUNT8, DATATYPE8, DEST8, TAG8, COMM8, IERROR8

  ALLOCATE(DATA8(SIZE(DATA)))

  DATA8 = DATA
  COUNT8 = COUNT
  DATATYPE8 = DATATYPE
  DEST8 = DEST
  TAG8 = TAG
  COMM8 = COMM

  CALL MPI_BSEND(DATA8, COUNT8, DATATYPE8, DEST8, TAG8, COMM8, IERROR8)

  IERROR = IERROR8

  DEALLOCATE(DATA8)

END SUBROUTINE MPI_BSEND8_I4

! =========================================================
! ---------------------------------------------------------
SUBROUTINE MPI_BSEND8_I1(DATA, COUNT, DATATYPE, DEST, TAG, COMM, IERROR)

  INTEGER(KIND=JPIM), INTENT(IN) :: &
    DATA
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COUNT, DATATYPE, DEST, TAG, COMM
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    IERROR

  INTEGER(KIND=8) :: &
    DATA8, COUNT8, DATATYPE8, DEST8, TAG8, COMM8, IERROR8

  DATA8 = DATA
  COUNT8 = COUNT
  DATATYPE8 = DATATYPE
  DEST8 = DEST
  TAG8 = TAG
  COMM8 = COMM

  CALL MPI_BSEND(DATA8, COUNT8, DATATYPE8, DEST8, TAG8, COMM8, IERROR8)

  IERROR = IERROR8

END SUBROUTINE MPI_BSEND8_I1

! =========================================================
SUBROUTINE MPI_BSEND8_R4_1(DATA, COUNT, DATATYPE, DEST, TAG, COMM, IERROR)

  REAL(KIND=JPRM), INTENT(IN) :: &
    DATA
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COUNT, DATATYPE, DEST, TAG, COMM
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    IERROR

  INTEGER(KIND=8) :: DATA8
  INTEGER(KIND=8) :: &
    COUNT8, DATATYPE8, DEST8, TAG8, COMM8, IERROR8

  DATA8 = DATA
  COUNT8 = COUNT
  DATATYPE8 = DATATYPE
  DEST8 = DEST
  TAG8 = TAG
  COMM8 = COMM

  CALL MPI_BSEND(DATA8, COUNT8, DATATYPE8, DEST8, TAG8, COMM8, IERROR8)

  IERROR = IERROR8

END SUBROUTINE MPI_BSEND8_R4_1

! =========================================================
SUBROUTINE MPI_BSEND8_R8_1(DATA, COUNT, DATATYPE, DEST, TAG, COMM, IERROR)

  REAL(KIND=JPRD), INTENT(IN) :: &
    DATA
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COUNT, DATATYPE, DEST, TAG, COMM
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    IERROR

  INTEGER(KIND=8) :: DATA8
  INTEGER(KIND=8) :: &
    COUNT8, DATATYPE8, DEST8, TAG8, COMM8, IERROR8

  DATA8 = DATA
  COUNT8 = COUNT
  DATATYPE8 = DATATYPE
  DEST8 = DEST
  TAG8 = TAG
  COMM8 = COMM

  CALL MPI_BSEND(DATA8, COUNT8, DATATYPE8, DEST8, TAG8, COMM8, IERROR8)

  IERROR = IERROR8

END SUBROUTINE MPI_BSEND8_R8_1

! =========================================================
! ---------------------------------------------------------
SUBROUTINE MPI_BSEND8_CH(DATA, COUNT, DATATYPE, DEST, TAG, COMM, IERROR)

  CHARACTER(LEN=*), INTENT(IN) :: &
    DATA
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COUNT, DATATYPE, DEST, TAG, COMM
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    IERROR

  INTEGER(KIND=8) :: &
    COUNT8, DATATYPE8, DEST8, TAG8, COMM8, IERROR8

  COUNT8 = COUNT
  DATATYPE8 = DATATYPE
  DEST8 = DEST
  TAG8 = TAG
  COMM8 = COMM

  CALL MPI_BSEND(DATA, COUNT8, DATATYPE8, DEST8, TAG8, COMM8, IERROR8)

  IERROR = IERROR8

END SUBROUTINE MPI_BSEND8_CH

! =========================================================
! ---------------------------------------------------------
SUBROUTINE MPI_ISEND8_R4(DATA, COUNT, DATATYPE, DEST, TAG, COMM, REQUEST, IERROR)

  REAL(KIND=JPRM), DIMENSION(:), INTENT(IN) :: &
    DATA
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COUNT, DATATYPE, DEST, TAG, COMM
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    REQUEST, IERROR

  REAL(KIND=8), DIMENSION(:), ALLOCATABLE :: &
    DATA8
  INTEGER(KIND=8) :: &
    COUNT8, DATATYPE8, DEST8, TAG8, COMM8, REQUEST8, IERROR8

  ALLOCATE(DATA8(SIZE(DATA)))

  DATA8 = DATA
  COUNT8 = COUNT
  DATATYPE8 = DATATYPE
  DEST8 = DEST
  TAG8 = TAG
  COMM8 = COMM

  CALL MPI_ISEND(DATA8, COUNT8, DATATYPE8, DEST8, TAG8, COMM8, REQUEST8, IERROR8)

  REQUEST = REQUEST8
  IERROR = IERROR8

  DEALLOCATE(DATA8)

END SUBROUTINE MPI_ISEND8_R4

! =========================================================
! ---------------------------------------------------------
SUBROUTINE MPI_ISEND8_R8(DATA, COUNT, DATATYPE, DEST, TAG, COMM, REQUEST, IERROR)

  REAL(KIND=JPRD), DIMENSION(:), INTENT(IN) :: &
    DATA
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COUNT, DATATYPE, DEST, TAG, COMM
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    REQUEST, IERROR

  INTEGER(KIND=8) :: &
    COUNT8, DATATYPE8, DEST8, TAG8, COMM8, REQUEST8, IERROR8

  COUNT8 = COUNT
  DATATYPE8 = DATATYPE
  DEST8 = DEST
  TAG8 = TAG
  COMM8 = COMM

  CALL MPI_ISEND(DATA, COUNT8, DATATYPE8, DEST8, TAG8, COMM8, REQUEST8, IERROR8)

  REQUEST = REQUEST8
  IERROR = IERROR8

END SUBROUTINE MPI_ISEND8_R8

! ---------------------------------------------------------
SUBROUTINE MPI_ISEND8_R42(DATA, COUNT, DATATYPE, DEST, TAG, COMM, REQUEST, IERROR)

  REAL(KIND=JPRM), DIMENSION(:,:), INTENT(IN) :: &
    DATA
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COUNT, DATATYPE, DEST, TAG, COMM
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    REQUEST, IERROR

  REAL(KIND=8), DIMENSION(:,:), ALLOCATABLE :: &
    DATA8
  INTEGER(KIND=8) :: &
    COUNT8, DATATYPE8, DEST8, TAG8, COMM8, REQUEST8, IERROR8

  ALLOCATE(DATA8(SIZE(DATA,DIM=1),SIZE(DATA,DIM=2)))

  DATA8 = DATA
  COUNT8 = COUNT
  DATATYPE8 = DATATYPE
  DEST8 = DEST
  TAG8 = TAG
  COMM8 = COMM

  CALL MPI_ISEND(DATA8, COUNT8, DATATYPE8, DEST8, TAG8, COMM8, REQUEST8, IERROR8)

  REQUEST = REQUEST8
  IERROR = IERROR8

  DEALLOCATE(DATA8)

END SUBROUTINE MPI_ISEND8_R42

! =========================================================
SUBROUTINE MPI_ISEND8_I42(DATA, COUNT, DATATYPE, DEST, TAG, COMM, REQUEST, IERROR)

  INTEGER(KIND=JPRM), DIMENSION(:,:), INTENT(IN) :: &
    DATA
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COUNT, DATATYPE, DEST, TAG, COMM
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    REQUEST, IERROR

  INTEGER(KIND=8), DIMENSION(:,:), ALLOCATABLE :: &
    DATA8
  INTEGER(KIND=8) :: &
    COUNT8, DATATYPE8, DEST8, TAG8, COMM8, REQUEST8, IERROR8

  ALLOCATE(DATA8(SIZE(DATA,DIM=1),SIZE(DATA,DIM=2)))

  DATA8 = DATA
  COUNT8 = COUNT
  DATATYPE8 = DATATYPE
  DEST8 = DEST
  TAG8 = TAG
  COMM8 = COMM

  CALL MPI_ISEND(DATA8, COUNT8, DATATYPE8, DEST8, TAG8, COMM8, REQUEST8, IERROR8)

  REQUEST = REQUEST8
  IERROR = IERROR8

  DEALLOCATE(DATA8)

END SUBROUTINE MPI_ISEND8_I42

! =========================================================
! ---------------------------------------------------------
SUBROUTINE MPI_ISEND8_R82(DATA, COUNT, DATATYPE, DEST, TAG, COMM, REQUEST, IERROR)

  REAL(KIND=JPRD), DIMENSION(:,:), INTENT(IN) :: &
    DATA
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COUNT, DATATYPE, DEST, TAG, COMM
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    REQUEST, IERROR

  INTEGER(KIND=8) :: &
    COUNT8, DATATYPE8, DEST8, TAG8, COMM8, REQUEST8, IERROR8

  COUNT8 = COUNT
  DATATYPE8 = DATATYPE
  DEST8 = DEST
  TAG8 = TAG
  COMM8 = COMM

  CALL MPI_ISEND(DATA, COUNT8, DATATYPE8, DEST8, TAG8, COMM8, REQUEST8, IERROR8)

  REQUEST = REQUEST8
  IERROR = IERROR8

END SUBROUTINE MPI_ISEND8_R82

! =========================================================
! ---------------------------------------------------------
SUBROUTINE MPI_ISEND8_I4(DATA, COUNT, DATATYPE, DEST, TAG, COMM, REQUEST, IERROR)

  INTEGER(KIND=JPIM), DIMENSION(:), INTENT(IN) :: &
    DATA
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COUNT, DATATYPE, DEST, TAG, COMM
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    REQUEST, IERROR

  INTEGER(KIND=8), DIMENSION(:), ALLOCATABLE :: &
    DATA8
  INTEGER(KIND=8) :: &
    COUNT8, DATATYPE8, DEST8, TAG8, COMM8, REQUEST8, IERROR8

  ALLOCATE(DATA8(SIZE(DATA)))

  DATA8 = DATA
  COUNT8 = COUNT
  DATATYPE8 = DATATYPE
  DEST8 = DEST
  TAG8 = TAG
  COMM8 = COMM

  CALL MPI_ISEND(DATA8, COUNT8, DATATYPE8, DEST8, TAG8, COMM8, REQUEST8, IERROR8)

  REQUEST = REQUEST8
  IERROR = IERROR8

  DEALLOCATE(DATA8)

END SUBROUTINE MPI_ISEND8_I4

! =========================================================
SUBROUTINE MPI_ISEND8_R4_1(DATA, COUNT, DATATYPE, DEST, TAG, COMM, REQUEST, IERROR)

  REAL(KIND=JPRM), INTENT(IN) :: &
    DATA
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COUNT, DATATYPE, DEST, TAG, COMM
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    REQUEST, IERROR

  REAL(KIND=8):: &
    DATA8
  INTEGER(KIND=8) :: &
    COUNT8, DATATYPE8, DEST8, TAG8, COMM8, REQUEST8, IERROR8

  DATA8 = DATA
  COUNT8 = COUNT
  DATATYPE8 = DATATYPE
  DEST8 = DEST
  TAG8 = TAG
  COMM8 = COMM

  CALL MPI_ISEND(DATA8, COUNT8, DATATYPE8, DEST8, TAG8, COMM8, REQUEST8, IERROR8)

  REQUEST = REQUEST8
  IERROR = IERROR8

END SUBROUTINE MPI_ISEND8_R4_1

! =========================================================
SUBROUTINE MPI_ISEND8_R8_1(DATA, COUNT, DATATYPE, DEST, TAG, COMM, REQUEST, IERROR)

  REAL(KIND=JPRD), INTENT(IN) :: &
    DATA
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COUNT, DATATYPE, DEST, TAG, COMM
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    REQUEST, IERROR

  REAL(KIND=8) :: &
    DATA8
  INTEGER(KIND=8) :: &
    COUNT8, DATATYPE8, DEST8, TAG8, COMM8, REQUEST8, IERROR8

  DATA8 = DATA
  COUNT8 = COUNT
  DATATYPE8 = DATATYPE
  DEST8 = DEST
  TAG8 = TAG
  COMM8 = COMM

  CALL MPI_ISEND(DATA8, COUNT8, DATATYPE8, DEST8, TAG8, COMM8, REQUEST8, IERROR8)

  REQUEST = REQUEST8
  IERROR = IERROR8

END SUBROUTINE MPI_ISEND8_R8_1

! =========================================================
! ---------------------------------------------------------
SUBROUTINE MPI_ISEND8_I1(DATA, COUNT, DATATYPE, DEST, TAG, COMM, REQUEST, IERROR)

  INTEGER(KIND=JPIM), INTENT(IN) :: &
    DATA
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COUNT, DATATYPE, DEST, TAG, COMM
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    REQUEST, IERROR

  INTEGER(KIND=8) :: &
    DATA8, COUNT8, DATATYPE8, DEST8, TAG8, COMM8, REQUEST8, IERROR8

  DATA8 = DATA
  COUNT8 = COUNT
  DATATYPE8 = DATATYPE
  DEST8 = DEST
  TAG8 = TAG
  COMM8 = COMM

  CALL MPI_ISEND(DATA8, COUNT8, DATATYPE8, DEST8, TAG8, COMM8, REQUEST8, IERROR8)

  REQUEST = REQUEST8
  IERROR = IERROR8

END SUBROUTINE MPI_ISEND8_I1

! =========================================================
! ---------------------------------------------------------
SUBROUTINE MPI_ISEND8_CH(DATA, COUNT, DATATYPE, DEST, TAG, COMM, REQUEST, IERROR)

  CHARACTER(LEN=*), INTENT(IN) :: &
    DATA
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COUNT, DATATYPE, DEST, TAG, COMM
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    REQUEST, IERROR

  INTEGER(KIND=8) :: &
    COUNT8, DATATYPE8, DEST8, TAG8, COMM8, REQUEST8, IERROR8

  COUNT8 = COUNT
  DATATYPE8 = DATATYPE
  DEST8 = DEST
  TAG8 = TAG
  COMM8 = COMM

  CALL MPI_ISEND(DATA, COUNT8, DATATYPE8, DEST8, TAG8, COMM8, REQUEST8, IERROR8)

  REQUEST = REQUEST8
  IERROR = IERROR8

END SUBROUTINE MPI_ISEND8_CH

! =========================================================
! ---------------------------------------------------------
SUBROUTINE MPI_SEND8_R4(DATA, COUNT, DATATYPE, DEST, TAG, COMM, IERROR)

  REAL(KIND=JPRM), DIMENSION(:), INTENT(IN) :: &
    DATA
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COUNT, DATATYPE, DEST, TAG, COMM
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    IERROR

  REAL(KIND=8), DIMENSION(:), ALLOCATABLE :: &
    DATA8
  INTEGER(KIND=8) :: &
    COUNT8, DATATYPE8, DEST8, TAG8, COMM8, IERROR8

  ALLOCATE(DATA8(SIZE(DATA)))

  DATA8 = DATA
  COUNT8 = COUNT
  DATATYPE8 = DATATYPE
  DEST8 = DEST
  TAG8 = TAG
  COMM8 = COMM

  CALL MPI_SEND(DATA8, COUNT8, DATATYPE8, DEST8, TAG8, COMM8, IERROR8)

  IERROR = IERROR8

  DEALLOCATE(DATA8)

END SUBROUTINE MPI_SEND8_R4

! =========================================================
! ---------------------------------------------------------
SUBROUTINE MPI_SEND8_R8(DATA, COUNT, DATATYPE, DEST, TAG, COMM, IERROR)

  REAL(KIND=JPRD), DIMENSION(:), INTENT(IN) :: &
    DATA
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COUNT, DATATYPE, DEST, TAG, COMM
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    IERROR

  INTEGER(KIND=8) :: &
    COUNT8, DATATYPE8, DEST8, TAG8, COMM8, IERROR8

  COUNT8 = COUNT
  DATATYPE8 = DATATYPE
  DEST8 = DEST
  TAG8 = TAG
  COMM8 = COMM

  CALL MPI_SEND(DATA, COUNT8, DATATYPE8, DEST8, TAG8, COMM8, IERROR8)

  IERROR = IERROR8

END SUBROUTINE MPI_SEND8_R8

! ---------------------------------------------------------
SUBROUTINE MPI_SEND8_R42(DATA, COUNT, DATATYPE, DEST, TAG, COMM, IERROR)

  REAL(KIND=JPRM), DIMENSION(:,:), INTENT(IN) :: &
    DATA
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COUNT, DATATYPE, DEST, TAG, COMM
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    IERROR

  REAL(KIND=8), DIMENSION(:,:), ALLOCATABLE :: &
    DATA8
  INTEGER(KIND=8) :: &
    COUNT8, DATATYPE8, DEST8, TAG8, COMM8, IERROR8

  ALLOCATE(DATA8(SIZE(DATA,DIM=1),SIZE(DATA,DIM=2)))

  DATA8 = DATA
  COUNT8 = COUNT
  DATATYPE8 = DATATYPE
  DEST8 = DEST
  TAG8 = TAG
  COMM8 = COMM

  CALL MPI_SEND(DATA8, COUNT8, DATATYPE8, DEST8, TAG8, COMM8, IERROR8)

  IERROR = IERROR8

  DEALLOCATE(DATA8)

END SUBROUTINE MPI_SEND8_R42

! ---------------------------------------------------------
SUBROUTINE MPI_SEND8_I42(DATA, COUNT, DATATYPE, DEST, TAG, COMM, IERROR)

  INTEGER(KIND=JPIM), DIMENSION(:,:), INTENT(IN) :: &
    DATA
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COUNT, DATATYPE, DEST, TAG, COMM
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    IERROR

  INTEGER(KIND=8), DIMENSION(:,:), ALLOCATABLE :: &
    DATA8
  INTEGER(KIND=8) :: &
    COUNT8, DATATYPE8, DEST8, TAG8, COMM8, IERROR8

  ALLOCATE(DATA8(SIZE(DATA,DIM=1),SIZE(DATA,DIM=2)))

  DATA8 = DATA
  COUNT8 = COUNT
  DATATYPE8 = DATATYPE
  DEST8 = DEST
  TAG8 = TAG
  COMM8 = COMM

  CALL MPI_SEND(DATA8, COUNT8, DATATYPE8, DEST8, TAG8, COMM8, IERROR8)

  IERROR = IERROR8

  DEALLOCATE(DATA8)

END SUBROUTINE MPI_SEND8_I42

! =========================================================
! ---------------------------------------------------------
SUBROUTINE MPI_SEND8_R82(DATA, COUNT, DATATYPE, DEST, TAG, COMM, IERROR)

  REAL(KIND=JPRD), DIMENSION(:,:), INTENT(IN) :: &
    DATA
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COUNT, DATATYPE, DEST, TAG, COMM
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    IERROR

  INTEGER(KIND=8) :: &
    COUNT8, DATATYPE8, DEST8, TAG8, COMM8, IERROR8

  COUNT8 = COUNT
  DATATYPE8 = DATATYPE
  DEST8 = DEST
  TAG8 = TAG
  COMM8 = COMM

  CALL MPI_SEND(DATA, COUNT8, DATATYPE8, DEST8, TAG8, COMM8, IERROR8)

  IERROR = IERROR8

END SUBROUTINE MPI_SEND8_R82

! =========================================================
! ---------------------------------------------------------
SUBROUTINE MPI_SEND8_I4(DATA, COUNT, DATATYPE, DEST, TAG, COMM, IERROR)

  INTEGER(KIND=JPIM), DIMENSION(:), INTENT(IN) :: &
    DATA
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COUNT, DATATYPE, DEST, TAG, COMM
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    IERROR

  INTEGER(KIND=8), DIMENSION(:), ALLOCATABLE :: &
    DATA8
  INTEGER(KIND=8) :: &
    COUNT8, DATATYPE8, DEST8, TAG8, COMM8, IERROR8

  ALLOCATE(DATA8(SIZE(DATA)))

  DATA8 = DATA
  COUNT8 = COUNT
  DATATYPE8 = DATATYPE
  DEST8 = DEST
  TAG8 = TAG
  COMM8 = COMM

  CALL MPI_SEND(DATA8, COUNT8, DATATYPE8, DEST8, TAG8, COMM8, IERROR8)

  IERROR = IERROR8

  DEALLOCATE(DATA8)

END SUBROUTINE MPI_SEND8_I4

! =========================================================
! ---------------------------------------------------------
SUBROUTINE MPI_SEND8_I1(DATA, COUNT, DATATYPE, DEST, TAG, COMM, IERROR)

  INTEGER(KIND=JPIM), INTENT(IN) :: &
    DATA
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COUNT, DATATYPE, DEST, TAG, COMM
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    IERROR

  INTEGER(KIND=8) :: &
    DATA8, COUNT8, DATATYPE8, DEST8, TAG8, COMM8, IERROR8

  DATA8 = DATA
  COUNT8 = COUNT
  DATATYPE8 = DATATYPE
  DEST8 = DEST
  TAG8 = TAG
  COMM8 = COMM

  CALL MPI_SEND(DATA8, COUNT8, DATATYPE8, DEST8, TAG8, COMM8, IERROR8)

  IERROR = IERROR8

END SUBROUTINE MPI_SEND8_I1

! =========================================================
SUBROUTINE MPI_SEND8_R4_1(DATA, COUNT, DATATYPE, DEST, TAG, COMM, IERROR)

  REAL(KIND=JPRM), INTENT(IN) :: &
    DATA
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COUNT, DATATYPE, DEST, TAG, COMM
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    IERROR

  REAL(KIND=8) :: DATA8
  INTEGER(KIND=8) :: &
    COUNT8, DATATYPE8, DEST8, TAG8, COMM8, IERROR8

  DATA8 = DATA
  COUNT8 = COUNT
  DATATYPE8 = DATATYPE
  DEST8 = DEST
  TAG8 = TAG
  COMM8 = COMM

  CALL MPI_SEND(DATA8, COUNT8, DATATYPE8, DEST8, TAG8, COMM8, IERROR8)

  IERROR = IERROR8

END SUBROUTINE MPI_SEND8_R4_1

! =========================================================
SUBROUTINE MPI_SEND8_R8_1(DATA, COUNT, DATATYPE, DEST, TAG, COMM, IERROR)

  REAL(KIND=JPRD), INTENT(IN) :: &
    DATA
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COUNT, DATATYPE, DEST, TAG, COMM
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    IERROR

  REAL(KIND=8) :: DATA8
  INTEGER(KIND=8) :: &
    COUNT8, DATATYPE8, DEST8, TAG8, COMM8, IERROR8

  DATA8 = DATA
  COUNT8 = COUNT
  DATATYPE8 = DATATYPE
  DEST8 = DEST
  TAG8 = TAG
  COMM8 = COMM

  CALL MPI_SEND(DATA8, COUNT8, DATATYPE8, DEST8, TAG8, COMM8, IERROR8)

  IERROR = IERROR8

END SUBROUTINE MPI_SEND8_R8_1

! =========================================================
! ---------------------------------------------------------
SUBROUTINE MPI_SEND8_CH(DATA, COUNT, DATATYPE, DEST, TAG, COMM, IERROR)

  CHARACTER(LEN=*), INTENT(IN) :: &
    DATA
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COUNT, DATATYPE, DEST, TAG, COMM
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    IERROR

  INTEGER(KIND=8) :: &
    COUNT8, DATATYPE8, DEST8, TAG8, COMM8, IERROR8

  COUNT8 = COUNT
  DATATYPE8 = DATATYPE
  DEST8 = DEST
  TAG8 = TAG
  COMM8 = COMM

  CALL MPI_SEND(DATA, COUNT8, DATATYPE8, DEST8, TAG8, COMM8, IERROR8)

  IERROR = IERROR8

END SUBROUTINE MPI_SEND8_CH

! =========================================================
! ---------------------------------------------------------
SUBROUTINE MPI_FILE_IREAD_SHARED8_R8(FH, BUF, COUNT, DATATYPE, REQUEST, IERROR)

  INTEGER(KIND=JPIM), INTENT(IN) :: &
    FH, COUNT, DATATYPE
  REAL(KIND=JPRD), DIMENSION(:), INTENT(OUT) :: &
    BUF
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    REQUEST, IERROR

  INTEGER(KIND=8) :: &
    FH8, COUNT8, DATATYPE8, REQUEST8, IERROR8

  FH8 = FH
  COUNT8 = COUNT
  DATATYPE8 = DATATYPE

  CALL MPI_FILE_IREAD_SHARED(FH8, BUF, COUNT8, DATATYPE8, REQUEST8, IERROR8)

  REQUEST = REQUEST8
  IERROR = IERROR8

END SUBROUTINE MPI_FILE_IREAD_SHARED8_R8

! ---------------------------------------------------------
SUBROUTINE MPI_FILE_IREAD_SHARED8_I4(FH, BUF, COUNT, DATATYPE, REQUEST, IERROR)

  INTEGER(KIND=JPIM), INTENT(IN) :: &
    FH, COUNT, DATATYPE
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    BUF(:), REQUEST, IERROR

  INTEGER(KIND=8), DIMENSION(:), ALLOCATABLE :: &
    BUF8
  INTEGER(KIND=8) :: &
    FH8, COUNT8, DATATYPE8, REQUEST8, IERROR8

  ALLOCATE(BUF8(SIZE(BUF)))

  FH8 = FH
  COUNT8 = COUNT
  DATATYPE8 = DATATYPE

  CALL MPI_FILE_IREAD_SHARED(FH8, BUF8, COUNT8, DATATYPE8, REQUEST8, IERROR8)

  BUF = BUF8
  REQUEST = REQUEST8
  IERROR = IERROR8

  DEALLOCATE(BUF8)

END SUBROUTINE MPI_FILE_IREAD_SHARED8_I4

! =========================================================
! ---------------------------------------------------------
SUBROUTINE MPI_FILE_IWRITE_SHARED8_R8(FH, BUF, COUNT, DATATYPE, REQUEST, IERROR)

  REAL(KIND=JPRD), DIMENSION(:), INTENT(IN) :: &
    BUF
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    FH, COUNT, DATATYPE
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    REQUEST, IERROR

  INTEGER(KIND=8) :: &
    FH8, COUNT8, DATATYPE8, REQUEST8, IERROR8

  FH8 = FH
  COUNT8 = COUNT
  DATATYPE8 = DATATYPE

  CALL MPI_FILE_IWRITE_SHARED(FH8, BUF, COUNT8, DATATYPE8, REQUEST8, IERROR8)

  REQUEST = REQUEST8
  IERROR = IERROR8

END SUBROUTINE MPI_FILE_IWRITE_SHARED8_R8

! ---------------------------------------------------------
SUBROUTINE MPI_FILE_IWRITE_SHARED8_I4(FH, BUF, COUNT, DATATYPE, REQUEST, IERROR)

  INTEGER(KIND=JPIM), INTENT(IN) :: &
    FH, BUF(:), COUNT, DATATYPE
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    REQUEST, IERROR

  INTEGER(KIND=8), DIMENSION(:), ALLOCATABLE :: &
    BUF8
  INTEGER(KIND=8) :: &
    FH8, COUNT8, DATATYPE8, REQUEST8, IERROR8

  ALLOCATE(BUF8(SIZE(BUF)))

  FH8 = FH
  BUF8 = BUF
  COUNT8 = COUNT
  DATATYPE8 = DATATYPE

  CALL MPI_FILE_IWRITE_SHARED(FH8, BUF8, COUNT8, DATATYPE8, REQUEST8, IERROR8)

  REQUEST = REQUEST8
  IERROR = IERROR8

  DEALLOCATE(BUF8)

END SUBROUTINE MPI_FILE_IWRITE_SHARED8_I4

! =========================================================
! ---------------------------------------------------------
SUBROUTINE MPI_FILE_READ_ORDERED8_R8(FH, BUF, COUNT, DATATYPE, STATUS, IERROR)

  INTEGER(KIND=JPIM), INTENT(IN) :: &
    FH, COUNT, DATATYPE
  REAL(KIND=JPRD), DIMENSION(:), INTENT(OUT) :: &
    BUF
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    STATUS(:), IERROR

  INTEGER(KIND=8) :: &
    FH8, COUNT8, DATATYPE8, IERROR8

  FH8 = FH
  COUNT8 = COUNT
  DATATYPE8 = DATATYPE

  CALL MPI_FILE_READ_ORDERED(FH8, BUF, COUNT8, DATATYPE8, STATUS8, IERROR8)

  STATUS = STATUS8
  IERROR = IERROR8

END SUBROUTINE MPI_FILE_READ_ORDERED8_R8

! ---------------------------------------------------------
SUBROUTINE MPI_FILE_READ_ORDERED8_I4(FH, BUF, COUNT, DATATYPE, STATUS, IERROR)

  INTEGER(KIND=JPIM), INTENT(IN) :: &
    FH, COUNT, DATATYPE
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    BUF(:), STATUS(:), IERROR

  INTEGER(KIND=8), DIMENSION(:), ALLOCATABLE :: &
    BUF8
  INTEGER(KIND=8) :: &
    FH8, COUNT8, DATATYPE8, IERROR8

  ALLOCATE(BUF8(SIZE(BUF)))

  FH8 = FH
  COUNT8 = COUNT
  DATATYPE8 = DATATYPE

  CALL MPI_FILE_READ_ORDERED(FH8, BUF8, COUNT8, DATATYPE8, STATUS8, IERROR8)

  BUF = BUF8
  STATUS = STATUS8
  IERROR = IERROR8

  DEALLOCATE(BUF8)

END SUBROUTINE MPI_FILE_READ_ORDERED8_I4

! =========================================================
! ---------------------------------------------------------
SUBROUTINE MPI_FREAD_ORDERED_BEGIN8_R8(FH, BUF, COUNT, DATATYPE, IERROR)

  INTEGER(KIND=JPIM), INTENT(IN) :: &
    FH, COUNT, DATATYPE
  REAL(KIND=JPRD), DIMENSION(:), INTENT(OUT) :: &
    BUF
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    IERROR

  INTEGER(KIND=8) :: &
    FH8, COUNT8, DATATYPE8, IERROR8

  FH8 = FH
  COUNT8 = COUNT
  DATATYPE8 = DATATYPE

  CALL MPI_FILE_READ_ORDERED_BEGIN(FH8, BUF, COUNT8, DATATYPE8, IERROR8)

  IERROR = IERROR8

END SUBROUTINE MPI_FREAD_ORDERED_BEGIN8_R8

! ---------------------------------------------------------
SUBROUTINE MPI_FREAD_ORDERED_BEGIN8_I4(FH, BUF, COUNT, DATATYPE, IERROR)

  INTEGER(KIND=JPIM), INTENT(IN) :: &
    FH, COUNT, DATATYPE
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    BUF(:), IERROR

  INTEGER(KIND=8), DIMENSION(:), ALLOCATABLE :: &
    BUF8
  INTEGER(KIND=8) :: &
    FH8, COUNT8, DATATYPE8, IERROR8

  ALLOCATE(BUF8(SIZE(BUF)))

  FH8 = FH
  COUNT8 = COUNT
  DATATYPE8 = DATATYPE

  CALL MPI_FILE_READ_ORDERED_BEGIN(FH8, BUF8, COUNT8, DATATYPE8, IERROR8)

  BUF = BUF8
  IERROR = IERROR8

  DEALLOCATE(BUF8)

END SUBROUTINE MPI_FREAD_ORDERED_BEGIN8_I4

! =========================================================
! ---------------------------------------------------------
SUBROUTINE MPI_FREAD_ORDERED_END8_R8(FH, BUF, STATUS, IERROR)

  INTEGER(KIND=JPIM), INTENT(IN) :: &
    FH
  REAL(KIND=JPRD), DIMENSION(:), INTENT(OUT) :: &
    BUF
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    STATUS(:), IERROR

  INTEGER(KIND=8) :: &
    FH8, IERROR8

  FH8 = FH

  CALL MPI_FILE_READ_ORDERED_END(FH8, BUF, STATUS8, IERROR8)

  STATUS = STATUS8
  IERROR = IERROR8

END SUBROUTINE MPI_FREAD_ORDERED_END8_R8

! ---------------------------------------------------------
SUBROUTINE MPI_FREAD_ORDERED_END8_I4(FH, BUF, STATUS, IERROR)

  INTEGER(KIND=JPIM), INTENT(IN) :: &
    FH
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    BUF(:), STATUS(:), IERROR

  INTEGER(KIND=8), DIMENSION(:), ALLOCATABLE :: &
    BUF8
  INTEGER(KIND=8) :: &
    FH8, IERROR8

  ALLOCATE(BUF8(SIZE(BUF)))

  FH8 = FH

  CALL MPI_FILE_READ_ORDERED_END(FH8, BUF8, STATUS8, IERROR8)

  BUF = BUF8
  STATUS = STATUS8
  IERROR = IERROR8

  DEALLOCATE(BUF8)

END SUBROUTINE MPI_FREAD_ORDERED_END8_I4

! =========================================================
! ---------------------------------------------------------
SUBROUTINE MPI_FILE_READ_SHARED8_R8(FH, BUF, COUNT, DATATYPE, STATUS, IERROR)

  INTEGER(KIND=JPIM), INTENT(IN) :: &
    FH, COUNT, DATATYPE
  REAL(KIND=JPRD), DIMENSION(:), INTENT(OUT) :: &
    BUF
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    STATUS(:), IERROR

  INTEGER(KIND=8) :: &
    FH8, COUNT8, DATATYPE8, IERROR8

  FH8 = FH
  COUNT8 = COUNT
  DATATYPE8 = DATATYPE

  CALL MPI_FILE_READ_SHARED(FH8, BUF, COUNT8, DATATYPE8, STATUS8, IERROR8)

  STATUS = STATUS8
  IERROR = IERROR8

END SUBROUTINE MPI_FILE_READ_SHARED8_R8

! ---------------------------------------------------------
SUBROUTINE MPI_FILE_READ_SHARED8_I4(FH, BUF, COUNT, DATATYPE, STATUS, IERROR)

  INTEGER(KIND=JPIM), INTENT(IN) :: &
    FH, COUNT, DATATYPE
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    BUF(:), STATUS(:), IERROR

  INTEGER(KIND=8), DIMENSION(:), ALLOCATABLE :: &
    BUF8
  INTEGER(KIND=8) :: &
    FH8, COUNT8, DATATYPE8, IERROR8

  ALLOCATE(BUF8(SIZE(BUF)))

  FH8 = FH
  COUNT8 = COUNT
  DATATYPE8 = DATATYPE

  CALL MPI_FILE_READ_SHARED(FH8, BUF8, COUNT8, DATATYPE8, STATUS8, IERROR8)

  BUF = BUF8
  STATUS = STATUS8
  IERROR = IERROR8

  DEALLOCATE(BUF8)

END SUBROUTINE MPI_FILE_READ_SHARED8_I4

! =========================================================
! ---------------------------------------------------------
SUBROUTINE MPI_FILE_WRITE_ORDERED8_R8(FH, BUF, COUNT, DATATYPE, STATUS, IERROR)

  REAL(KIND=JPRD), DIMENSION(:), INTENT(IN) :: &
    BUF
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    FH, COUNT, DATATYPE
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    STATUS(:), IERROR

  INTEGER(KIND=8) :: &
    FH8, COUNT8, DATATYPE8, IERROR8

  FH8 = FH
  COUNT8 = COUNT
  DATATYPE8 = DATATYPE

  CALL MPI_FILE_WRITE_ORDERED(FH8, BUF, COUNT8, DATATYPE8, STATUS8, IERROR8)

  STATUS = STATUS8
  IERROR = IERROR8

END SUBROUTINE MPI_FILE_WRITE_ORDERED8_R8

! ---------------------------------------------------------
SUBROUTINE MPI_FILE_WRITE_ORDERED8_I4(FH, BUF, COUNT, DATATYPE, STATUS, IERROR)

  INTEGER(KIND=JPIM), INTENT(IN) :: &
    FH, BUF(:), COUNT, DATATYPE
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    STATUS(:), IERROR

  INTEGER(KIND=8), DIMENSION(:), ALLOCATABLE :: &
    BUF8
  INTEGER(KIND=8) :: &
    FH8, COUNT8, DATATYPE8, IERROR8

  ALLOCATE(BUF8(SIZE(BUF)))

  FH8 = FH
  BUF8 = BUF
  COUNT8 = COUNT
  DATATYPE8 = DATATYPE

  CALL MPI_FILE_WRITE_ORDERED(FH8, BUF8, COUNT8, DATATYPE8, STATUS8, IERROR8)

  STATUS = STATUS8
  IERROR = IERROR8

  DEALLOCATE(BUF8)

END SUBROUTINE MPI_FILE_WRITE_ORDERED8_I4

! =========================================================
! ---------------------------------------------------------
SUBROUTINE MPI_FWRITE_ORDERED_BEGIN8_R8(FH, BUF, COUNT, DATATYPE, IERROR)

  INTEGER(KIND=JPIM), INTENT(IN) :: &
    FH, COUNT, DATATYPE
  REAL(KIND=JPRD), DIMENSION(:), INTENT(OUT) :: &
    BUF
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    IERROR

  INTEGER(KIND=8) :: &
    FH8, COUNT8, DATATYPE8, IERROR8

  FH8 = FH
  COUNT8 = COUNT
  DATATYPE8 = DATATYPE

  CALL MPI_FILE_WRITE_ORDERED_BEGIN(FH8, BUF, COUNT8, DATATYPE8, IERROR8)

  IERROR = IERROR8

END SUBROUTINE MPI_FWRITE_ORDERED_BEGIN8_R8

! ---------------------------------------------------------
SUBROUTINE MPI_FWRITE_ORDERED_BEGIN8_I4(FH, BUF, COUNT, DATATYPE, IERROR)

  INTEGER(KIND=JPIM), INTENT(IN) :: &
    FH, COUNT, DATATYPE
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    BUF(:), IERROR

  INTEGER(KIND=8), DIMENSION(:), ALLOCATABLE :: &
    BUF8
  INTEGER(KIND=8) :: &
    FH8, COUNT8, DATATYPE8, IERROR8

  ALLOCATE(BUF8(SIZE(BUF)))

  FH8 = FH
  COUNT8 = COUNT
  DATATYPE8 = DATATYPE

  CALL MPI_FILE_WRITE_ORDERED_BEGIN(FH8, BUF8, COUNT8, DATATYPE8, IERROR8)

  BUF = BUF8
  IERROR = IERROR8

  DEALLOCATE(BUF8)

END SUBROUTINE MPI_FWRITE_ORDERED_BEGIN8_I4

! =========================================================
! ---------------------------------------------------------
SUBROUTINE MPI_FWRITE_ORDERED_END8_R8(FH, BUF, STATUS, IERROR)

  INTEGER(KIND=JPIM), INTENT(IN) :: &
    FH, STATUS(:)
  REAL(KIND=JPRD), DIMENSION(:), INTENT(OUT) :: &
    BUF
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    IERROR

  INTEGER(KIND=8) :: &
    FH8, IERROR8

  FH8 = FH
  STATUS8 = STATUS

  CALL MPI_FILE_WRITE_ORDERED_END(FH8, BUF, STATUS8, IERROR8)

  IERROR = IERROR8

END SUBROUTINE MPI_FWRITE_ORDERED_END8_R8

! ---------------------------------------------------------
SUBROUTINE MPI_FWRITE_ORDERED_END8_I4(FH, BUF, STATUS, IERROR)

  INTEGER(KIND=JPIM), INTENT(IN) :: &
    FH, STATUS(:)
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    BUF(:), IERROR

  INTEGER(KIND=8), DIMENSION(:), ALLOCATABLE :: &
    BUF8
  INTEGER(KIND=8) :: &
    FH8, IERROR8

  ALLOCATE(BUF8(SIZE(BUF)))

  FH8 = FH
  STATUS8 = STATUS

  CALL MPI_FILE_WRITE_ORDERED_END(FH8, BUF8, STATUS8, IERROR8)

  BUF = BUF8
  IERROR = IERROR8

  DEALLOCATE(BUF8)

END SUBROUTINE MPI_FWRITE_ORDERED_END8_I4

! =========================================================
! ---------------------------------------------------------
SUBROUTINE MPI_FILE_WRITE_SHARED8_R8(FH, BUF, COUNT, DATATYPE, STATUS, IERROR)

  REAL(KIND=JPRD), DIMENSION(:), INTENT(IN) :: &
    BUF
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    FH, COUNT, DATATYPE
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    STATUS(:), IERROR

  INTEGER(KIND=8) :: &
    FH8, COUNT8, DATATYPE8, IERROR8

  FH8 = FH
  COUNT8 = COUNT
  DATATYPE8 = DATATYPE

  CALL MPI_FILE_WRITE_SHARED(FH8, BUF, COUNT8, DATATYPE8, STATUS8, IERROR8)

  STATUS = STATUS8
  IERROR = IERROR8

END SUBROUTINE MPI_FILE_WRITE_SHARED8_R8

! ---------------------------------------------------------
SUBROUTINE MPI_FILE_WRITE_SHARED8_I4(FH, BUF, COUNT, DATATYPE, STATUS, IERROR)

  INTEGER(KIND=JPIM), INTENT(IN) :: &
    FH, BUF(:), COUNT, DATATYPE
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    STATUS(:), IERROR

  INTEGER(KIND=8), DIMENSION(:), ALLOCATABLE :: &
    BUF8
  INTEGER(KIND=8) :: &
    FH8, COUNT8, DATATYPE8, IERROR8

  ALLOCATE(BUF8(SIZE(BUF)))

  FH8 = FH
  BUF8 = BUF
  COUNT8 = COUNT
  DATATYPE8 = DATATYPE

  CALL MPI_FILE_WRITE_SHARED(FH8, BUF8, COUNT8, DATATYPE8, STATUS8, IERROR8)

  STATUS = STATUS8
  IERROR = IERROR8

  DEALLOCATE(BUF8)

END SUBROUTINE MPI_FILE_WRITE_SHARED8_I4

! =========================================================
! ---------------------------------------------------------
SUBROUTINE MPI_GATHER8_R8_1(SENDDATA, SENDCOUNT, SENDTYPE, RECVAREA, &
                            RECVCOUNT, RECVTYPE, ROOT, COMM, IERROR)

  REAL(KIND=JPRD), INTENT(IN) :: &
    SENDDATA
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    SENDCOUNT, SENDTYPE, RECVCOUNT, RECVTYPE, ROOT, COMM
  REAL(KIND=JPRD), INTENT(OUT) :: &
    RECVAREA
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    IERROR

  INTEGER(KIND=8) :: &
    SENDCOUNT8, SENDTYPE8, RECVCOUNT8, RECVTYPE8, ROOT8, COMM8, IERROR8

  SENDCOUNT8 = SENDCOUNT
  SENDTYPE8 = SENDTYPE
  RECVCOUNT8 = RECVCOUNT
  RECVTYPE8 = RECVTYPE
  ROOT8 = ROOT
  COMM8 = COMM

  CALL MPI_GATHER(SENDDATA, SENDCOUNT8, SENDTYPE8, RECVAREA, &
                  RECVCOUNT8, RECVTYPE8, ROOT8, COMM8, IERROR8)

  IERROR = IERROR8

END SUBROUTINE MPI_GATHER8_R8_1

! ---------------------------------------------------------
SUBROUTINE MPI_GATHER8_I1(SENDDATA, SENDCOUNT, SENDTYPE, RECVAREA, &
                          RECVCOUNT, RECVTYPE, ROOT, COMM, IERROR)

  INTEGER(KIND=JPIM), INTENT(IN) :: &
    SENDDATA, SENDCOUNT, SENDTYPE, RECVCOUNT, RECVTYPE, ROOT, COMM
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    RECVAREA, IERROR

  INTEGER(KIND=8) :: &
    SENDDATA8, RECVAREA8
  INTEGER(KIND=8) :: &
    SENDCOUNT8, SENDTYPE8, RECVCOUNT8, RECVTYPE8, ROOT8, COMM8, IERROR8

  SENDDATA8 = SENDDATA
  SENDCOUNT8 = SENDCOUNT
  SENDTYPE8 = SENDTYPE
  RECVCOUNT8 = RECVCOUNT
  RECVTYPE8 = RECVTYPE
  ROOT8 = ROOT
  COMM8 = COMM

  CALL MPI_GATHER(SENDDATA8, SENDCOUNT8, SENDTYPE8, RECVAREA8, &
                  RECVCOUNT8, RECVTYPE8, ROOT8, COMM8, IERROR8)

  RECVAREA = RECVAREA8
  IERROR = IERROR8

END SUBROUTINE MPI_GATHER8_I1

! =========================================================
! ---------------------------------------------------------
SUBROUTINE MPI_GATHERV8_R8(SENDDATA, SENDCOUNT, SENDTYPE, RECVAREA, &
                           RECVCOUNTS, DISPLS, RECVTYPE, ROOT, COMM, IERROR)

  REAL(KIND=JPRD), DIMENSION(:), INTENT(IN) :: &
    SENDDATA
  INTEGER(KIND=JPIM), DIMENSION(:), INTENT(IN) :: &
    RECVCOUNTS, DISPLS
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    SENDCOUNT, SENDTYPE, RECVTYPE, ROOT, COMM
  REAL(KIND=JPRD), DIMENSION(:), INTENT(OUT) :: &
    RECVAREA
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    IERROR

  INTEGER(KIND=8), DIMENSION(:), ALLOCATABLE :: &
    RECVCOUNTS8, DISPLS8
  INTEGER(KIND=8) :: &
    SENDCOUNT8, SENDTYPE8, RECVTYPE8, ROOT8, COMM8, IERROR8

  ALLOCATE(RECVCOUNTS8(SIZE(RECVCOUNTS)))
  ALLOCATE(DISPLS8(SIZE(DISPLS)))

  SENDCOUNT8 = SENDCOUNT
  SENDTYPE8 = SENDTYPE
  RECVCOUNTS8 = RECVCOUNTS
  DISPLS8 = DISPLS
  RECVTYPE8 = RECVTYPE
  ROOT8 = ROOT
  COMM8 = COMM

  CALL MPI_GATHERV(SENDDATA, SENDCOUNT8, SENDTYPE8, RECVAREA, &
                   RECVCOUNTS8, DISPLS8, RECVTYPE8, ROOT8, COMM8, IERROR8)

  IERROR = IERROR8

  DEALLOCATE(RECVCOUNTS8)
  DEALLOCATE(DISPLS8)

END SUBROUTINE MPI_GATHERV8_R8

! ---------------------------------------------------------
SUBROUTINE MPI_GATHERV8_R8S(SENDDATA, SENDCOUNT, SENDTYPE, RECVAREA, &
                           RECVCOUNTS, DISPLS, RECVTYPE, ROOT, COMM, IERROR)

  REAL(KIND=JPRD), DIMENSION(:), INTENT(IN) :: &
    SENDDATA
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    RECVCOUNTS, DISPLS
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    SENDCOUNT, SENDTYPE, RECVTYPE, ROOT, COMM
  REAL(KIND=JPRD), INTENT(OUT) :: &
    RECVAREA
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    IERROR

  INTEGER(KIND=8) :: RECVCOUNTS8, DISPLS8
  INTEGER(KIND=8) :: &
    SENDCOUNT8, SENDTYPE8, RECVTYPE8, ROOT8, COMM8, IERROR8

  SENDCOUNT8 = SENDCOUNT
  SENDTYPE8 = SENDTYPE
  RECVCOUNTS8 = RECVCOUNTS
  DISPLS8 = DISPLS
  RECVTYPE8 = RECVTYPE
  ROOT8 = ROOT
  COMM8 = COMM

  CALL MPI_GATHERV(SENDDATA, SENDCOUNT8, SENDTYPE8, RECVAREA, &
                   RECVCOUNTS8, DISPLS8, RECVTYPE8, ROOT8, COMM8, IERROR8)

  IERROR = IERROR8

END SUBROUTINE MPI_GATHERV8_R8S

! ---------------------------------------------------------
SUBROUTINE MPI_GATHERV8_R4(SENDDATA, SENDCOUNT, SENDTYPE, RECVAREA, &
                           RECVCOUNTS, DISPLS, RECVTYPE, ROOT, COMM, IERROR)

  REAL(KIND=JPRM), DIMENSION(:), INTENT(IN) :: &
    SENDDATA
  INTEGER(KIND=JPIM), DIMENSION(:), INTENT(IN) :: &
    RECVCOUNTS, DISPLS
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    SENDCOUNT, SENDTYPE, RECVTYPE, ROOT, COMM
  REAL(KIND=JPRM), DIMENSION(:), INTENT(OUT) :: &
    RECVAREA
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    IERROR

  REAL(KIND=8), DIMENSION(:), ALLOCATABLE :: &
    SENDDATA8, RECVAREA8
  INTEGER(KIND=8), DIMENSION(:), ALLOCATABLE :: &
    RECVCOUNTS8, DISPLS8
  INTEGER(KIND=8) :: &
    SENDCOUNT8, SENDTYPE8, RECVTYPE8, ROOT8, COMM8, IERROR8

  ALLOCATE(SENDDATA8(SIZE(SENDDATA)))
  ALLOCATE(RECVAREA8(SIZE(RECVAREA)))
  ALLOCATE(RECVCOUNTS8(SIZE(RECVCOUNTS)))
  ALLOCATE(DISPLS8(SIZE(DISPLS)))

  SENDDATA8 = SENDDATA
  SENDCOUNT8 = SENDCOUNT
  SENDTYPE8 = SENDTYPE
  RECVCOUNTS8 = RECVCOUNTS
  DISPLS8 = DISPLS
  RECVTYPE8 = RECVTYPE
  ROOT8 = ROOT
  COMM8 = COMM

  CALL MPI_GATHERV(SENDDATA8, SENDCOUNT8, SENDTYPE8, RECVAREA8, &
                   RECVCOUNTS8, DISPLS8, RECVTYPE8, ROOT8, COMM8, IERROR8)

  RECVAREA = RECVAREA8
  IERROR = IERROR8

  DEALLOCATE(SENDDATA8)
  DEALLOCATE(RECVAREA8)
  DEALLOCATE(RECVCOUNTS8)
  DEALLOCATE(DISPLS8)

END SUBROUTINE MPI_GATHERV8_R4

! ---------------------------------------------------------
SUBROUTINE MPI_GATHERV8_R4S(SENDDATA, SENDCOUNT, SENDTYPE, RECVAREA, &
                           RECVCOUNTS, DISPLS, RECVTYPE, ROOT, COMM, IERROR)

  REAL(KIND=JPRM), DIMENSION(:), INTENT(IN) :: &
    SENDDATA
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    RECVCOUNTS, DISPLS
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    SENDCOUNT, SENDTYPE, RECVTYPE, ROOT, COMM
  REAL(KIND=JPRM), INTENT(OUT) :: &
    RECVAREA
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    IERROR

  REAL(KIND=8), DIMENSION(:), ALLOCATABLE :: &
    SENDDATA8
  REAL(KIND=8) :: RECVAREA8
  INTEGER(KIND=8) :: RECVCOUNTS8, DISPLS8
  INTEGER(KIND=8) :: &
    SENDCOUNT8, SENDTYPE8, RECVTYPE8, ROOT8, COMM8, IERROR8

  ALLOCATE(SENDDATA8(SIZE(SENDDATA)))

  SENDDATA8 = SENDDATA
  SENDCOUNT8 = SENDCOUNT
  SENDTYPE8 = SENDTYPE
  RECVCOUNTS8 = RECVCOUNTS
  DISPLS8 = DISPLS
  RECVTYPE8 = RECVTYPE
  ROOT8 = ROOT
  COMM8 = COMM

  CALL MPI_GATHERV(SENDDATA8, SENDCOUNT8, SENDTYPE8, RECVAREA8, &
                   RECVCOUNTS8, DISPLS8, RECVTYPE8, ROOT8, COMM8, IERROR8)

  RECVAREA = RECVAREA8
  IERROR = IERROR8

  DEALLOCATE(SENDDATA8)

END SUBROUTINE MPI_GATHERV8_R4S

! ---------------------------------------------------------
SUBROUTINE MPI_GATHERV8_I4(SENDDATA, SENDCOUNT, SENDTYPE, RECVAREA, &
                           RECVCOUNTS, DISPLS, RECVTYPE, ROOT, COMM, IERROR)

  INTEGER(KIND=JPIM), DIMENSION(:), INTENT(IN) :: &
    SENDDATA, RECVCOUNTS, DISPLS
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    SENDCOUNT, SENDTYPE, RECVTYPE, ROOT, COMM
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    RECVAREA(:), IERROR

  INTEGER(KIND=8), DIMENSION(:), ALLOCATABLE :: &
    SENDDATA8, RECVAREA8, RECVCOUNTS8, DISPLS8
  INTEGER(KIND=8) :: &
    SENDCOUNT8, SENDTYPE8, RECVTYPE8, ROOT8, COMM8, IERROR8

  ALLOCATE(SENDDATA8(SIZE(SENDDATA)))
  ALLOCATE(RECVAREA8(SIZE(RECVAREA)))
  ALLOCATE(RECVCOUNTS8(SIZE(RECVCOUNTS)))
  ALLOCATE(DISPLS8(SIZE(DISPLS)))

  SENDDATA8 = SENDDATA
  SENDCOUNT8 = SENDCOUNT
  SENDTYPE8 = SENDTYPE
  RECVCOUNTS8 = RECVCOUNTS
  DISPLS8 = DISPLS
  RECVTYPE8 = RECVTYPE
  ROOT8 = ROOT
  COMM8 = COMM

  CALL MPI_GATHERV(SENDDATA8, SENDCOUNT8, SENDTYPE8, RECVAREA8, &
                   RECVCOUNTS8, DISPLS8, RECVTYPE8, ROOT8, COMM8, IERROR8)

  RECVAREA = RECVAREA8
  IERROR = IERROR8

  DEALLOCATE(SENDDATA8)
  DEALLOCATE(RECVAREA8)
  DEALLOCATE(RECVCOUNTS8)
  DEALLOCATE(DISPLS8)

END SUBROUTINE MPI_GATHERV8_I4

! ---------------------------------------------------------
SUBROUTINE MPI_GATHERV8_I4S(SENDDATA, SENDCOUNT, SENDTYPE, RECVAREA, &
                           RECVCOUNTS, DISPLS, RECVTYPE, ROOT, COMM, IERROR)

  INTEGER(KIND=JPIM), DIMENSION(:), INTENT(IN) :: &
    SENDDATA
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    SENDCOUNT, SENDTYPE, RECVTYPE, ROOT, COMM, RECVCOUNTS, DISPLS
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    RECVAREA, IERROR

  INTEGER(KIND=8), DIMENSION(:), ALLOCATABLE :: &
    SENDDATA8
  INTEGER(KIND=8) :: &
    RECVAREA8, RECVCOUNTS8, DISPLS8
  INTEGER(KIND=8) :: &
    SENDCOUNT8, SENDTYPE8, RECVTYPE8, ROOT8, COMM8, IERROR8

  ALLOCATE(SENDDATA8(SIZE(SENDDATA)))

  SENDDATA8 = SENDDATA
  SENDCOUNT8 = SENDCOUNT
  SENDTYPE8 = SENDTYPE
  RECVCOUNTS8 = RECVCOUNTS
  DISPLS8 = DISPLS
  RECVTYPE8 = RECVTYPE
  ROOT8 = ROOT
  COMM8 = COMM

  CALL MPI_GATHERV(SENDDATA8, SENDCOUNT8, SENDTYPE8, RECVAREA8, &
                   RECVCOUNTS8, DISPLS8, RECVTYPE8, ROOT8, COMM8, IERROR8)

  RECVAREA = RECVAREA8
  IERROR = IERROR8

  DEALLOCATE(SENDDATA8)

END SUBROUTINE MPI_GATHERV8_I4S

! ---------------------------------------------------------
SUBROUTINE MPI_GATHERV8_I4S_1(SENDDATA, SENDCOUNT, SENDTYPE, RECVAREA, &
                           RECVCOUNTS, DISPLS, RECVTYPE, ROOT, COMM, IERROR)

  INTEGER(KIND=JPIM), INTENT(IN) :: &
    SENDDATA
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    SENDCOUNT, SENDTYPE, RECVTYPE, ROOT, COMM, RECVCOUNTS, DISPLS
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    RECVAREA, IERROR

  INTEGER(KIND=8) :: &
    SENDDATA8
  INTEGER(KIND=8) :: &
    RECVAREA8, RECVCOUNTS8, DISPLS8
  INTEGER(KIND=8) :: &
    SENDCOUNT8, SENDTYPE8, RECVTYPE8, ROOT8, COMM8, IERROR8

  SENDDATA8 = SENDDATA
  SENDCOUNT8 = SENDCOUNT
  SENDTYPE8 = SENDTYPE
  RECVCOUNTS8 = RECVCOUNTS
  DISPLS8 = DISPLS
  RECVTYPE8 = RECVTYPE
  ROOT8 = ROOT
  COMM8 = COMM

  CALL MPI_GATHERV(SENDDATA8, SENDCOUNT8, SENDTYPE8, RECVAREA8, &
                   RECVCOUNTS8, DISPLS8, RECVTYPE8, ROOT8, COMM8, IERROR8)

  RECVAREA = RECVAREA8
  IERROR = IERROR8

END SUBROUTINE MPI_GATHERV8_I4S_1

! ---------------------------------------------------------
SUBROUTINE MPI_GATHERV8_I1(SENDDATA, SENDCOUNT, SENDTYPE, RECVAREA, &
                           RECVCOUNTS, DISPLS, RECVTYPE, ROOT, COMM, IERROR)

  INTEGER(KIND=JPIM), DIMENSION(:), INTENT(IN) :: &
    RECVCOUNTS, DISPLS
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    SENDDATA, SENDCOUNT, SENDTYPE, RECVTYPE, ROOT, COMM
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    RECVAREA, IERROR

  INTEGER(KIND=8) :: &
    SENDDATA8, RECVAREA8
  INTEGER(KIND=8), DIMENSION(:), ALLOCATABLE :: &
    RECVCOUNTS8, DISPLS8
  INTEGER(KIND=8) :: &
    SENDCOUNT8, SENDTYPE8, RECVTYPE8, ROOT8, COMM8, IERROR8

  ALLOCATE(RECVCOUNTS8(SIZE(RECVCOUNTS)))
  ALLOCATE(DISPLS8(SIZE(DISPLS)))

  SENDDATA8 = SENDDATA
  SENDCOUNT8 = SENDCOUNT
  SENDTYPE8 = SENDTYPE
  RECVCOUNTS8 = RECVCOUNTS
  DISPLS8 = DISPLS
  RECVTYPE8 = RECVTYPE
  ROOT8 = ROOT
  COMM8 = COMM

  CALL MPI_GATHERV(SENDDATA8, SENDCOUNT8, SENDTYPE8, RECVAREA8, &
                   RECVCOUNTS8, DISPLS8, RECVTYPE8, ROOT8, COMM8, IERROR8)

  RECVAREA = RECVAREA8
  IERROR = IERROR8

  DEALLOCATE(RECVCOUNTS8)
  DEALLOCATE(DISPLS8)

END SUBROUTINE MPI_GATHERV8_I1

! ---------------------------------------------------------
SUBROUTINE MPI_GATHERV8_R8_1(SENDDATA, SENDCOUNT, SENDTYPE, RECVAREA, &
                             RECVCOUNTS, DISPLS, RECVTYPE, ROOT, COMM, IERROR)

  REAL(KIND=JPRD), INTENT(IN) :: &
    SENDDATA
  INTEGER(KIND=JPIM), DIMENSION(:), INTENT(IN) :: &
    RECVCOUNTS, DISPLS
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    SENDCOUNT, SENDTYPE, RECVTYPE, ROOT, COMM
  REAL(KIND=JPRD), INTENT(OUT) :: &
    RECVAREA
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    IERROR

  INTEGER(KIND=8), DIMENSION(:), ALLOCATABLE :: &
    RECVCOUNTS8, DISPLS8
  INTEGER(KIND=8) :: &
    SENDCOUNT8, SENDTYPE8, RECVTYPE8, ROOT8, COMM8, IERROR8

  ALLOCATE(RECVCOUNTS8(SIZE(RECVCOUNTS)))
  ALLOCATE(DISPLS8(SIZE(DISPLS)))

  SENDCOUNT8 = SENDCOUNT
  SENDTYPE8 = SENDTYPE
  RECVCOUNTS8 = RECVCOUNTS
  DISPLS8 = DISPLS
  RECVTYPE8 = RECVTYPE
  ROOT8 = ROOT
  COMM8 = COMM

  CALL MPI_GATHERV(SENDDATA, SENDCOUNT8, SENDTYPE8, RECVAREA, &
                   RECVCOUNTS8, DISPLS8, RECVTYPE8, ROOT8, COMM8, IERROR8)

  IERROR = IERROR8

  DEALLOCATE(RECVCOUNTS8)
  DEALLOCATE(DISPLS8)

END SUBROUTINE MPI_GATHERV8_R8_1

! =========================================================
SUBROUTINE MPI_GATHERV8_R8S_1(SENDDATA, SENDCOUNT, SENDTYPE, RECVAREA, &
                             RECVCOUNTS, DISPLS, RECVTYPE, ROOT, COMM, IERROR)

  REAL(KIND=JPRD), INTENT(IN) :: &
    SENDDATA
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    RECVCOUNTS, DISPLS
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    SENDCOUNT, SENDTYPE, RECVTYPE, ROOT, COMM
  REAL(KIND=JPRD), INTENT(OUT) :: &
    RECVAREA
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    IERROR

  INTEGER(KIND=8) :: &
    RECVCOUNTS8, DISPLS8
  INTEGER(KIND=8) :: &
    SENDCOUNT8, SENDTYPE8, RECVTYPE8, ROOT8, COMM8, IERROR8

  SENDCOUNT8 = SENDCOUNT
  SENDTYPE8 = SENDTYPE
  RECVCOUNTS8 = RECVCOUNTS
  DISPLS8 = DISPLS
  RECVTYPE8 = RECVTYPE
  ROOT8 = ROOT
  COMM8 = COMM

  CALL MPI_GATHERV(SENDDATA, SENDCOUNT8, SENDTYPE8, RECVAREA, &
                   RECVCOUNTS8, DISPLS8, RECVTYPE8, ROOT8, COMM8, IERROR8)

  IERROR = IERROR8

END SUBROUTINE MPI_GATHERV8_R8S_1

! =========================================================
! ---------------------------------------------------------
SUBROUTINE MPI_RECV8_R4(DATA, COUNT, DATATYPE, SOURCE, TAG, COMM, STATUS, IERROR)

  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COUNT, DATATYPE, SOURCE, TAG, COMM
  REAL(KIND=JPRM), DIMENSION(:), INTENT(OUT) :: &
    DATA
  INTEGER(KIND=JPIM), DIMENSION(:), INTENT(OUT) :: &
    STATUS
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    IERROR

  REAL(KIND=8), DIMENSION(:), ALLOCATABLE :: &
    DATA8
  INTEGER(KIND=8) :: &
    COUNT8, DATATYPE8, SOURCE8, TAG8, COMM8, IERROR8

  ALLOCATE(DATA8(SIZE(DATA)))

  COUNT8 = COUNT
  DATATYPE8 = DATATYPE
  SOURCE8 = SOURCE
  TAG8 = TAG
  COMM8 = COMM

  CALL MPI_RECV(DATA8, COUNT8, DATATYPE8, SOURCE8, TAG8, COMM8, STATUS8, IERROR8)

  DATA = DATA8
  STATUS = STATUS8
  IERROR = IERROR8

  DEALLOCATE(DATA8)

END SUBROUTINE MPI_RECV8_R4

! ---------------------------------------------------------
SUBROUTINE MPI_RECV8_R8(DATA, COUNT, DATATYPE, SOURCE, TAG, COMM, STATUS, IERROR)

  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COUNT, DATATYPE, SOURCE, TAG, COMM
  REAL(KIND=JPRD), DIMENSION(:), INTENT(OUT) :: &
    DATA
  INTEGER(KIND=JPIM), DIMENSION(:), INTENT(OUT) :: &
    STATUS
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    IERROR

  INTEGER(KIND=8) :: &
    COUNT8, DATATYPE8, SOURCE8, TAG8, COMM8, IERROR8

  COUNT8 = COUNT
  DATATYPE8 = DATATYPE
  SOURCE8 = SOURCE
  TAG8 = TAG
  COMM8 = COMM

  CALL MPI_RECV(DATA, COUNT8, DATATYPE8, SOURCE8, TAG8, COMM8, STATUS8, IERROR8)

  STATUS = STATUS8
  IERROR = IERROR8

END SUBROUTINE MPI_RECV8_R8

! ---------------------------------------------------------
SUBROUTINE MPI_RECV8_R42(DATA, COUNT, DATATYPE, SOURCE, TAG, COMM, STATUS, IERROR)

  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COUNT, DATATYPE, SOURCE, TAG, COMM
  REAL(KIND=JPRM), DIMENSION(:,:), INTENT(OUT) :: &
    DATA
  INTEGER(KIND=JPIM), DIMENSION(:), INTENT(OUT) :: &
    STATUS
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    IERROR

  REAL(KIND=8), DIMENSION(:,:), ALLOCATABLE :: &
    DATA8
  INTEGER(KIND=8) :: &
    COUNT8, DATATYPE8, SOURCE8, TAG8, COMM8, IERROR8

  ALLOCATE(DATA8(SIZE(DATA,DIM=1),SIZE(DATA,DIM=2)))

  COUNT8 = COUNT
  DATATYPE8 = DATATYPE
  SOURCE8 = SOURCE
  TAG8 = TAG
  COMM8 = COMM

  CALL MPI_RECV(DATA8, COUNT8, DATATYPE8, SOURCE8, TAG8, COMM8, STATUS8, IERROR8)

  DATA = DATA8
  STATUS = STATUS8
  IERROR = IERROR8

  DEALLOCATE(DATA8)

END SUBROUTINE MPI_RECV8_R42

! ---------------------------------------------------------
SUBROUTINE MPI_RECV8_I42(DATA, COUNT, DATATYPE, SOURCE, TAG, COMM, STATUS, IERROR)

  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COUNT, DATATYPE, SOURCE, TAG, COMM
  INTEGER(KIND=JPIM), DIMENSION(:,:), INTENT(OUT) :: &
    DATA
  INTEGER(KIND=JPIM), DIMENSION(:), INTENT(OUT) :: &
    STATUS
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    IERROR

  INTEGER(KIND=8), DIMENSION(:,:), ALLOCATABLE :: &
    DATA8
  INTEGER(KIND=8) :: &
    COUNT8, DATATYPE8, SOURCE8, TAG8, COMM8, IERROR8

  ALLOCATE(DATA8(SIZE(DATA,DIM=1),SIZE(DATA,DIM=2)))

  COUNT8 = COUNT
  DATATYPE8 = DATATYPE
  SOURCE8 = SOURCE
  TAG8 = TAG
  COMM8 = COMM

  CALL MPI_RECV(DATA8, COUNT8, DATATYPE8, SOURCE8, TAG8, COMM8, STATUS8, IERROR8)

  DATA = DATA8
  STATUS = STATUS8
  IERROR = IERROR8

  DEALLOCATE(DATA8)

END SUBROUTINE MPI_RECV8_I42

! ---------------------------------------------------------
SUBROUTINE MPI_RECV8_R82(DATA, COUNT, DATATYPE, SOURCE, TAG, COMM, STATUS, IERROR)

  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COUNT, DATATYPE, SOURCE, TAG, COMM
  REAL(KIND=JPRD), DIMENSION(:,:), INTENT(OUT) :: &
    DATA
  INTEGER(KIND=JPIM), DIMENSION(:), INTENT(OUT) :: &
    STATUS
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    IERROR

  INTEGER(KIND=8) :: &
    COUNT8, DATATYPE8, SOURCE8, TAG8, COMM8, IERROR8

  COUNT8 = COUNT
  DATATYPE8 = DATATYPE
  SOURCE8 = SOURCE
  TAG8 = TAG
  COMM8 = COMM

  CALL MPI_RECV(DATA, COUNT8, DATATYPE8, SOURCE8, TAG8, COMM8, STATUS8, IERROR8)

  STATUS = STATUS8
  IERROR = IERROR8

END SUBROUTINE MPI_RECV8_R82

! ---------------------------------------------------------
SUBROUTINE MPI_RECV8_I4(DATA, COUNT, DATATYPE, SOURCE, TAG, COMM, STATUS, IERROR)

  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COUNT, DATATYPE, SOURCE, TAG, COMM
  INTEGER(KIND=JPIM), DIMENSION(:), INTENT(OUT) :: &
    DATA, STATUS
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    IERROR

  INTEGER(KIND=8), DIMENSION(:), ALLOCATABLE :: &
    DATA8
  INTEGER(KIND=8) :: &
    COUNT8, DATATYPE8, SOURCE8, TAG8, COMM8, IERROR8

  ALLOCATE(DATA8(SIZE(DATA)))

  COUNT8 = COUNT
  DATATYPE8 = DATATYPE
  SOURCE8 = SOURCE
  TAG8 = TAG
  COMM8 = COMM

  CALL MPI_RECV(DATA8, COUNT8, DATATYPE8, SOURCE8, TAG8, COMM8, STATUS8, IERROR8)

  DATA = DATA8
  STATUS = STATUS8
  IERROR = IERROR8

  DEALLOCATE(DATA8)

END SUBROUTINE MPI_RECV8_I4

! ---------------------------------------------------------
SUBROUTINE MPI_RECV8_I1(DATA, COUNT, DATATYPE, SOURCE, TAG, COMM, STATUS, IERROR)

  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COUNT, DATATYPE, SOURCE, TAG, COMM
  INTEGER(KIND=JPIM), DIMENSION(:), INTENT(OUT) :: &
    STATUS
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    DATA, IERROR

  INTEGER(KIND=8) :: &
    DATA8, COUNT8, DATATYPE8, SOURCE8, TAG8, COMM8, IERROR8

  COUNT8 = COUNT
  DATATYPE8 = DATATYPE
  SOURCE8 = SOURCE
  TAG8 = TAG
  COMM8 = COMM

  CALL MPI_RECV(DATA8, COUNT8, DATATYPE8, SOURCE8, TAG8, COMM8, STATUS8, IERROR8)

  DATA = DATA8
  STATUS = STATUS8
  IERROR = IERROR8

END SUBROUTINE MPI_RECV8_I1

! ---------------------------------------------------------
SUBROUTINE MPI_RECV8_R4_1(DATA, COUNT, DATATYPE, SOURCE, TAG, COMM, STATUS, IERROR)

  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COUNT, DATATYPE, SOURCE, TAG, COMM
  INTEGER(KIND=JPIM), DIMENSION(:), INTENT(OUT) :: &
    STATUS
  REAL(KIND=JPRM), INTENT(OUT) :: &
    DATA
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    IERROR

  REAL(KIND=8) :: &
    DATA8
  INTEGER(KIND=8) :: &
    COUNT8, DATATYPE8, SOURCE8, TAG8, COMM8, IERROR8

  COUNT8 = COUNT
  DATATYPE8 = DATATYPE
  SOURCE8 = SOURCE
  TAG8 = TAG
  COMM8 = COMM

  CALL MPI_RECV(DATA8, COUNT8, DATATYPE8, SOURCE8, TAG8, COMM8, STATUS8, IERROR8)

  DATA = DATA8
  STATUS = STATUS8
  IERROR = IERROR8

END SUBROUTINE MPI_RECV8_R4_1

! ---------------------------------------------------------
SUBROUTINE MPI_RECV8_R8_1(DATA, COUNT, DATATYPE, SOURCE, TAG, COMM, STATUS, IERROR)

  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COUNT, DATATYPE, SOURCE, TAG, COMM
  INTEGER(KIND=JPIM), DIMENSION(:), INTENT(OUT) :: &
    STATUS
  REAL(KIND=JPRD), INTENT(OUT) :: &
    DATA
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    IERROR

  INTEGER(KIND=8) :: &
    COUNT8, DATATYPE8, SOURCE8, TAG8, COMM8, IERROR8

  COUNT8 = COUNT
  DATATYPE8 = DATATYPE
  SOURCE8 = SOURCE
  TAG8 = TAG
  COMM8 = COMM

  CALL MPI_RECV(DATA, COUNT8, DATATYPE8, SOURCE8, TAG8, COMM8, STATUS8, IERROR8)

  STATUS = STATUS8
  IERROR = IERROR8

END SUBROUTINE MPI_RECV8_R8_1

! ---------------------------------------------------------
SUBROUTINE MPI_RECV8_CH(DATA, COUNT, DATATYPE, SOURCE, TAG, COMM, STATUS, IERROR)

  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COUNT, DATATYPE, SOURCE, TAG, COMM
  INTEGER(KIND=JPIM), DIMENSION(:), INTENT(OUT) :: &
    STATUS
  CHARACTER(LEN=*), INTENT(OUT) :: &
    DATA
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    IERROR

  INTEGER(KIND=8) :: &
    COUNT8, DATATYPE8, SOURCE8, TAG8, COMM8, IERROR8

  COUNT8 = COUNT
  DATATYPE8 = DATATYPE
  SOURCE8 = SOURCE
  TAG8 = TAG
  COMM8 = COMM

  CALL MPI_RECV(DATA, COUNT8, DATATYPE8, SOURCE8, TAG8, COMM8, STATUS8, IERROR8)

  STATUS = STATUS8
  IERROR = IERROR8

END SUBROUTINE MPI_RECV8_CH

! ---------------------------------------------------------
SUBROUTINE MPI_IRECV8_R4(DATA, COUNT, DATATYPE, SOURCE, TAG, COMM, REQUEST, IERROR)

  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COUNT, DATATYPE, SOURCE, TAG, COMM
  REAL(KIND=JPRM), DIMENSION(:), INTENT(OUT) :: &
    DATA
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    REQUEST, IERROR

  REAL(KIND=8), DIMENSION(:), ALLOCATABLE :: &
    DATA8
  INTEGER(KIND=8) :: &
    COUNT8, DATATYPE8, SOURCE8, TAG8, COMM8, REQUEST8, IERROR8

  ALLOCATE(DATA8(SIZE(DATA)))

  COUNT8 = COUNT
  DATATYPE8 = DATATYPE
  SOURCE8 = SOURCE
  TAG8 = TAG
  COMM8 = COMM

  CALL MPI_IRECV(DATA8, COUNT8, DATATYPE8, SOURCE8, TAG8, COMM8, REQUEST8, IERROR8)

  DATA = DATA8
  REQUEST = REQUEST8
  IERROR = IERROR8

  DEALLOCATE(DATA8)

END SUBROUTINE MPI_IRECV8_R4

! ---------------------------------------------------------
SUBROUTINE MPI_IRECV8_R8(DATA, COUNT, DATATYPE, SOURCE, TAG, COMM, REQUEST, IERROR)

  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COUNT, DATATYPE, SOURCE, TAG, COMM
  REAL(KIND=JPRD), DIMENSION(:), INTENT(OUT) :: &
    DATA
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    REQUEST, IERROR

  INTEGER(KIND=8) :: &
    COUNT8, DATATYPE8, SOURCE8, TAG8, COMM8, REQUEST8, IERROR8

  COUNT8 = COUNT
  DATATYPE8 = DATATYPE
  SOURCE8 = SOURCE
  TAG8 = TAG
  COMM8 = COMM

  CALL MPI_IRECV(DATA, COUNT8, DATATYPE8, SOURCE8, TAG8, COMM8, REQUEST8, IERROR8)

  REQUEST = REQUEST8
  IERROR = IERROR8

END SUBROUTINE MPI_IRECV8_R8

! ---------------------------------------------------------
SUBROUTINE MPI_IRECV8_R42(DATA, COUNT, DATATYPE, SOURCE, TAG, COMM, REQUEST, IERROR)

  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COUNT, DATATYPE, SOURCE, TAG, COMM
  REAL(KIND=JPRM), DIMENSION(:,:), INTENT(OUT) :: &
    DATA
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    REQUEST, IERROR

  REAL(KIND=8), DIMENSION(:,:), ALLOCATABLE :: &
    DATA8
  INTEGER(KIND=8) :: &
    COUNT8, DATATYPE8, SOURCE8, TAG8, COMM8, REQUEST8, IERROR8

  ALLOCATE(DATA8(SIZE(DATA,DIM=1),SIZE(DATA,DIM=2)))

  COUNT8 = COUNT
  DATATYPE8 = DATATYPE
  SOURCE8 = SOURCE
  TAG8 = TAG
  COMM8 = COMM

  CALL MPI_IRECV(DATA8, COUNT8, DATATYPE8, SOURCE8, TAG8, COMM8, REQUEST8, IERROR8)

  DATA = DATA8
  REQUEST = REQUEST8
  IERROR = IERROR8

  DEALLOCATE(DATA8)

END SUBROUTINE MPI_IRECV8_R42

! ---------------------------------------------------------
SUBROUTINE MPI_IRECV8_R82(DATA, COUNT, DATATYPE, SOURCE, TAG, COMM, REQUEST, IERROR)

  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COUNT, DATATYPE, SOURCE, TAG, COMM
  REAL(KIND=JPRD), DIMENSION(:,:), INTENT(OUT) :: &
    DATA
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    REQUEST, IERROR

  INTEGER(KIND=8) :: &
    COUNT8, DATATYPE8, SOURCE8, TAG8, COMM8, REQUEST8, IERROR8

  COUNT8 = COUNT
  DATATYPE8 = DATATYPE
  SOURCE8 = SOURCE
  TAG8 = TAG
  COMM8 = COMM

  CALL MPI_IRECV(DATA, COUNT8, DATATYPE8, SOURCE8, TAG8, COMM8, REQUEST8, IERROR8)

  REQUEST = REQUEST8
  IERROR = IERROR8

END SUBROUTINE MPI_IRECV8_R82

! ---------------------------------------------------------
SUBROUTINE MPI_IRECV8_I4(DATA, COUNT, DATATYPE, SOURCE, TAG, COMM, REQUEST, IERROR)

  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COUNT, DATATYPE, SOURCE, TAG, COMM
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    DATA(:), REQUEST, IERROR

  INTEGER(KIND=8), DIMENSION(:), ALLOCATABLE :: &
    DATA8
  INTEGER(KIND=8) :: &
    COUNT8, DATATYPE8, SOURCE8, TAG8, COMM8, REQUEST8, IERROR8

  ALLOCATE(DATA8(SIZE(DATA)))

  COUNT8 = COUNT
  DATATYPE8 = DATATYPE
  SOURCE8 = SOURCE
  TAG8 = TAG
  COMM8 = COMM

  CALL MPI_IRECV(DATA8, COUNT8, DATATYPE8, SOURCE8, TAG8, COMM8, REQUEST8, IERROR8)

  DATA = DATA8
  REQUEST = REQUEST8
  IERROR = IERROR8

  DEALLOCATE(DATA8)

END SUBROUTINE MPI_IRECV8_I4

! ---------------------------------------------------------
SUBROUTINE MPI_IRECV8_I42(DATA, COUNT, DATATYPE, SOURCE, TAG, COMM, REQUEST, IERROR)

  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COUNT, DATATYPE, SOURCE, TAG, COMM
  INTEGER(KIND=JPIM), DIMENSION(:,:), INTENT(OUT) :: &
    DATA
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    REQUEST, IERROR

  INTEGER(KIND=8), DIMENSION(:,:), ALLOCATABLE :: &
    DATA8
  INTEGER(KIND=8) :: &
    COUNT8, DATATYPE8, SOURCE8, TAG8, COMM8, REQUEST8, IERROR8

  ALLOCATE(DATA8(SIZE(DATA,DIM=1),SIZE(DATA,DIM=2)))

  COUNT8 = COUNT
  DATATYPE8 = DATATYPE
  SOURCE8 = SOURCE
  TAG8 = TAG
  COMM8 = COMM

  CALL MPI_IRECV(DATA8, COUNT8, DATATYPE8, SOURCE8, TAG8, COMM8, REQUEST8, IERROR8)

  DATA = DATA8
  REQUEST = REQUEST8
  IERROR = IERROR8

  DEALLOCATE(DATA8)

END SUBROUTINE MPI_IRECV8_I42

! ---------------------------------------------------------
SUBROUTINE MPI_IRECV8_I1(DATA, COUNT, DATATYPE, SOURCE, TAG, COMM, REQUEST, IERROR)

  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COUNT, DATATYPE, SOURCE, TAG, COMM
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    DATA, REQUEST, IERROR

  INTEGER(KIND=8) :: &
    DATA8, COUNT8, DATATYPE8, SOURCE8, TAG8, COMM8, REQUEST8, IERROR8

  COUNT8 = COUNT
  DATATYPE8 = DATATYPE
  SOURCE8 = SOURCE
  TAG8 = TAG
  COMM8 = COMM

  CALL MPI_IRECV(DATA8, COUNT8, DATATYPE8, SOURCE8, TAG8, COMM8, REQUEST8, IERROR8)

  DATA = DATA8
  REQUEST = REQUEST8
  IERROR = IERROR8

END SUBROUTINE MPI_IRECV8_I1

! ---------------------------------------------------------
SUBROUTINE MPI_IRECV8_R4_1(DATA, COUNT, DATATYPE, SOURCE, TAG, COMM, REQUEST, IERROR)

  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COUNT, DATATYPE, SOURCE, TAG, COMM
  REAL(KIND=JPRM), INTENT(OUT) :: &
    DATA
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    REQUEST, IERROR

  REAL(KIND=8) :: &
    DATA8
  INTEGER(KIND=8) :: &
    COUNT8, DATATYPE8, SOURCE8, TAG8, COMM8, REQUEST8, IERROR8

  COUNT8 = COUNT
  DATATYPE8 = DATATYPE
  SOURCE8 = SOURCE
  TAG8 = TAG
  COMM8 = COMM

  CALL MPI_IRECV(DATA8, COUNT8, DATATYPE8, SOURCE8, TAG8, COMM8, REQUEST8, IERROR8)

  DATA = DATA8
  REQUEST = REQUEST8
  IERROR = IERROR8

END SUBROUTINE MPI_IRECV8_R4_1

! ---------------------------------------------------------
SUBROUTINE MPI_IRECV8_R8_1(DATA, COUNT, DATATYPE, SOURCE, TAG, COMM, REQUEST, IERROR)

  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COUNT, DATATYPE, SOURCE, TAG, COMM
  REAL(KIND=JPRD), INTENT(OUT) :: &
    DATA
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    REQUEST, IERROR

  INTEGER(KIND=8) :: &
    COUNT8, DATATYPE8, SOURCE8, TAG8, COMM8, REQUEST8, IERROR8

  COUNT8 = COUNT
  DATATYPE8 = DATATYPE
  SOURCE8 = SOURCE
  TAG8 = TAG
  COMM8 = COMM

  CALL MPI_IRECV(DATA, COUNT8, DATATYPE8, SOURCE8, TAG8, COMM8, REQUEST8, IERROR8)

  REQUEST = REQUEST8
  IERROR = IERROR8

END SUBROUTINE MPI_IRECV8_R8_1

! ---------------------------------------------------------
SUBROUTINE MPI_IRECV8_CH(DATA, COUNT, DATATYPE, SOURCE, TAG, COMM, REQUEST, IERROR)

  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COUNT, DATATYPE, SOURCE, TAG, COMM
  CHARACTER(LEN=*), INTENT(OUT) :: &
    DATA
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    REQUEST, IERROR

  INTEGER(KIND=8) :: &
    COUNT8, DATATYPE8, SOURCE8, TAG8, COMM8, REQUEST8, IERROR8

  COUNT8 = COUNT
  DATATYPE8 = DATATYPE
  SOURCE8 = SOURCE
  TAG8 = TAG
  COMM8 = COMM

  CALL MPI_IRECV(DATA, COUNT8, DATATYPE8, SOURCE8, TAG8, COMM8, REQUEST8, IERROR8)

  REQUEST = REQUEST8
  IERROR = IERROR8

END SUBROUTINE MPI_IRECV8_CH

! =========================================================
! ---------------------------------------------------------
SUBROUTINE MPI_SCATTERV8_R8(SENDAREA, SENDCOUNTS, DISPLS, SENDTYPE, &
                            RECVDATA, RECVCOUNT, RECVTYPE, ROOT, COMM, IERROR)
  
  REAL(KIND=JPRD), DIMENSION(:), INTENT(IN) :: &
    SENDAREA
  INTEGER(KIND=JPIM), DIMENSION(:), INTENT(IN) :: &
    SENDCOUNTS, DISPLS
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    SENDTYPE, RECVCOUNT, RECVTYPE, ROOT, COMM
  REAL(KIND=JPRD), DIMENSION(:), INTENT(OUT) :: &
    RECVDATA
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    IERROR

  REAL(KIND=8), DIMENSION(:), ALLOCATABLE :: &
    SENDAREA8, RECVDATA8
  INTEGER(KIND=8), DIMENSION(:), ALLOCATABLE :: &
    SENDCOUNTS8, DISPLS8
  INTEGER(KIND=8) :: &
    SENDTYPE8, RECVCOUNT8, RECVTYPE8, ROOT8, COMM8, IERROR8

  ALLOCATE(SENDAREA8(SIZE(SENDAREA)))
  ALLOCATE(SENDCOUNTS8(SIZE(SENDCOUNTS)))
  ALLOCATE(DISPLS8(SIZE(DISPLS)))
  ALLOCATE(RECVDATA8(SIZE(RECVDATA)))

  SENDAREA8 = SENDAREA
  SENDCOUNTS8 = SENDCOUNTS
  DISPLS8 = DISPLS
  SENDTYPE8 = SENDTYPE
  RECVCOUNT8 = RECVCOUNT
  RECVTYPE8 = RECVTYPE
  ROOT8 = ROOT
  COMM8 = COMM

  CALL MPI_SCATTERV(SENDAREA8, SENDCOUNTS8, DISPLS8, SENDTYPE8, &
                    RECVDATA8, RECVCOUNT8, RECVTYPE8, ROOT8, COMM8, IERROR8)

  RECVDATA = RECVDATA8
  IERROR = IERROR8

  DEALLOCATE(SENDAREA8)
  DEALLOCATE(SENDCOUNTS8)
  DEALLOCATE(DISPLS8)
  DEALLOCATE(RECVDATA8)

END SUBROUTINE MPI_SCATTERV8_R8

! ---------------------------------------------------------
SUBROUTINE MPI_SCATTERV8_R8S(SENDAREA, SENDCOUNTS, DISPLS, SENDTYPE, &
                            RECVDATA, RECVCOUNT, RECVTYPE, ROOT, COMM, IERROR)
  
  REAL(KIND=JPRD), INTENT(IN) :: &
    SENDAREA
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    SENDTYPE, RECVCOUNT, RECVTYPE, ROOT, COMM, SENDCOUNTS, DISPLS
  REAL(KIND=JPRD), DIMENSION(:), INTENT(OUT) :: &
    RECVDATA
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    IERROR

  REAL(KIND=8), DIMENSION(:), ALLOCATABLE :: &
    RECVDATA8
  REAL(KIND=8) :: &
    SENDAREA8
  INTEGER(KIND=8) :: &
    SENDCOUNTS8, DISPLS8
  INTEGER(KIND=8) :: &
    SENDTYPE8, RECVCOUNT8, RECVTYPE8, ROOT8, COMM8, IERROR8

  ALLOCATE(RECVDATA8(SIZE(RECVDATA)))

  SENDAREA8 = SENDAREA
  SENDCOUNTS8 = SENDCOUNTS
  DISPLS8 = DISPLS
  SENDTYPE8 = SENDTYPE
  RECVCOUNT8 = RECVCOUNT
  RECVTYPE8 = RECVTYPE
  ROOT8 = ROOT
  COMM8 = COMM

  CALL MPI_SCATTERV(SENDAREA8, SENDCOUNTS8, DISPLS8, SENDTYPE8, &
                    RECVDATA8, RECVCOUNT8, RECVTYPE8, ROOT8, COMM8, IERROR8)

  RECVDATA = RECVDATA8
  IERROR = IERROR8

  DEALLOCATE(RECVDATA8)

END SUBROUTINE MPI_SCATTERV8_R8S

! ---------------------------------------------------------
SUBROUTINE MPI_SCATTERV8_I4(SENDAREA, SENDCOUNTS, DISPLS, SENDTYPE, &
                            RECVDATA, RECVCOUNT, RECVTYPE, ROOT, COMM, IERROR)
  
  INTEGER(KIND=JPIM), DIMENSION(:), INTENT(IN) :: &
    SENDAREA, SENDCOUNTS, DISPLS
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    SENDTYPE, RECVCOUNT, RECVTYPE, ROOT, COMM
  INTEGER(KIND=JPIM), DIMENSION(:), INTENT(OUT) :: &
    RECVDATA
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    IERROR

  INTEGER(KIND=8), DIMENSION(:), ALLOCATABLE :: &
    SENDAREA8, SENDCOUNTS8, DISPLS8, RECVDATA8
  INTEGER(KIND=8) :: &
    SENDTYPE8, RECVCOUNT8, RECVTYPE8, ROOT8, COMM8, IERROR8

  ALLOCATE(SENDAREA8(SIZE(SENDAREA)))
  ALLOCATE(SENDCOUNTS8(SIZE(SENDCOUNTS)))
  ALLOCATE(DISPLS8(SIZE(DISPLS)))
  ALLOCATE(RECVDATA8(SIZE(RECVDATA)))

  SENDAREA8 = SENDAREA
  SENDCOUNTS8 = SENDCOUNTS
  DISPLS8 = DISPLS
  SENDTYPE8 = SENDTYPE
  RECVCOUNT8 = RECVCOUNT
  RECVTYPE8 = RECVTYPE
  ROOT8 = ROOT
  COMM8 = COMM

  CALL MPI_SCATTERV(SENDAREA8, SENDCOUNTS8, DISPLS8, SENDTYPE8, &
                    RECVDATA8, RECVCOUNT8, RECVTYPE8, ROOT8, COMM8, IERROR8)

  RECVDATA = RECVDATA8
  IERROR = IERROR8

  DEALLOCATE(SENDAREA8)
  DEALLOCATE(SENDCOUNTS8)
  DEALLOCATE(DISPLS8)
  DEALLOCATE(RECVDATA8)

END SUBROUTINE MPI_SCATTERV8_I4

! =========================================================
SUBROUTINE MPI_SCATTERV8_I4S(SENDAREA, SENDCOUNTS, DISPLS, SENDTYPE, &
                            RECVDATA, RECVCOUNT, RECVTYPE, ROOT, COMM, IERROR)
  
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    SENDAREA, SENDCOUNTS, DISPLS
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    SENDTYPE, RECVCOUNT, RECVTYPE, ROOT, COMM
  INTEGER(KIND=JPIM), DIMENSION(:), INTENT(OUT) :: &
    RECVDATA
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    IERROR

  INTEGER(KIND=8) :: &
    SENDAREA8, SENDCOUNTS8, DISPLS8
  INTEGER(KIND=8), DIMENSION(:), ALLOCATABLE :: &
    RECVDATA8
  INTEGER(KIND=8) :: &
    SENDTYPE8, RECVCOUNT8, RECVTYPE8, ROOT8, COMM8, IERROR8

  ALLOCATE(RECVDATA8(SIZE(RECVDATA)))

  SENDAREA8 = SENDAREA
  SENDCOUNTS8 = SENDCOUNTS
  DISPLS8 = DISPLS
  SENDTYPE8 = SENDTYPE
  RECVCOUNT8 = RECVCOUNT
  RECVTYPE8 = RECVTYPE
  ROOT8 = ROOT
  COMM8 = COMM

  CALL MPI_SCATTERV(SENDAREA8, SENDCOUNTS8, DISPLS8, SENDTYPE8, &
                    RECVDATA8, RECVCOUNT8, RECVTYPE8, ROOT8, COMM8, IERROR8)

  RECVDATA = RECVDATA8
  IERROR = IERROR8

  DEALLOCATE(RECVDATA8)

END SUBROUTINE MPI_SCATTERV8_I4S

! =========================================================
! =========================================================
! =========================================================

#endif
END MODULE MPI4TO8_M

! (C) Copyright 2005- ECMWF.
! (C) Copyright 2013- Meteo-France.
! 
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!

MODULE MPI4TO8_M
#ifdef USE_8_BYTE_WORDS

USE EC_PARKIND, ONLY : JPIM, JPRM, JPRD
USE MPL_MPIF

IMPLICIT NONE

PRIVATE :: STATUS8
  INTEGER(KIND=8), DIMENSION(MPI_STATUS_SIZE) :: STATUS8

INTERFACE MPI_ALLGATHERV8
  MODULE PROCEDURE MPI_ALLGATHERV8_R4, MPI_ALLGATHERV8_R8, &
                   MPI_ALLGATHERV8_I4, MPI_ALLGATHERV8_I1
END INTERFACE MPI_ALLGATHERV8

INTERFACE MPI_ALLREDUCE8
  MODULE PROCEDURE MPI_ALLREDUCE8_R4, MPI_ALLREDUCE8_R8, &
                   MPI_ALLREDUCE8_I4, MPI_ALLREDUCE8_R4_2D, &
                   MPI_ALLREDUCE8_R8_2D
END INTERFACE MPI_ALLREDUCE8

INTERFACE MPI_ALLTOALLV8
  MODULE PROCEDURE MPI_ALLTOALLV8_R8, MPI_ALLTOALLV8_I4
END INTERFACE MPI_ALLTOALLV8

INTERFACE MPI_BCAST8
  MODULE PROCEDURE MPI_BCAST8_R4, MPI_BCAST8_R8, &
                   MPI_BCAST8_I4, MPI_BCAST8_I1, &
                   MPI_BCAST8_CH
END INTERFACE MPI_BCAST8

INTERFACE MPI_BSEND8
  MODULE PROCEDURE MPI_BSEND8_R4, MPI_BSEND8_R8, &
                   MPI_BSEND8_R42, MPI_BSEND8_R82, &
                   MPI_BSEND8_I4, MPI_BSEND8_I1, &
                   MPI_BSEND8_CH, MPI_BSEND8_I42, &
                   MPI_BSEND8_R4_1, MPI_BSEND8_R8_1
END INTERFACE MPI_BSEND8

INTERFACE MPI_ISEND8
  MODULE PROCEDURE MPI_ISEND8_R4, MPI_ISEND8_R8, &
                   MPI_ISEND8_R42, MPI_ISEND8_R82, &
                   MPI_ISEND8_I4, MPI_ISEND8_I1, &
                   MPI_ISEND8_CH, MPI_ISEND8_I42, &
                   MPI_ISEND8_R4_1, MPI_ISEND8_R8_1
END INTERFACE MPI_ISEND8

INTERFACE MPI_SEND8
  MODULE PROCEDURE MPI_SEND8_R4, MPI_SEND8_R8, &
                   MPI_SEND8_R42, MPI_SEND8_R82, &
                   MPI_SEND8_I4, MPI_SEND8_I1, &
                   MPI_SEND8_CH, MPI_SEND8_I42, &
                   MPI_SEND8_R4_1, MPI_SEND8_R8_1
END INTERFACE MPI_SEND8

INTERFACE MPI_FILE_IREAD_SHARED8
  MODULE PROCEDURE MPI_FILE_IREAD_SHARED8_R8, MPI_FILE_IREAD_SHARED8_I4
END INTERFACE MPI_FILE_IREAD_SHARED8

INTERFACE MPI_FILE_IWRITE_SHARED8
  MODULE PROCEDURE MPI_FILE_IWRITE_SHARED8_R8, MPI_FILE_IWRITE_SHARED8_I4
END INTERFACE MPI_FILE_IWRITE_SHARED8

INTERFACE MPI_FILE_READ_ORDERED8
  MODULE PROCEDURE MPI_FILE_READ_ORDERED8_R8, MPI_FILE_READ_ORDERED8_I4
END INTERFACE MPI_FILE_READ_ORDERED8

INTERFACE MPI_FILE_READ_ORDERED_BEGIN8
  MODULE PROCEDURE MPI_FREAD_ORDERED_BEGIN8_R8, MPI_FREAD_ORDERED_BEGIN8_I4
END INTERFACE MPI_FILE_READ_ORDERED_BEGIN8

INTERFACE MPI_FILE_READ_ORDERED_END8
  MODULE PROCEDURE MPI_FREAD_ORDERED_END8_R8, MPI_FREAD_ORDERED_END8_I4
END INTERFACE MPI_FILE_READ_ORDERED_END8

INTERFACE MPI_FILE_READ_SHARED8
  MODULE PROCEDURE MPI_FILE_READ_SHARED8_R8, MPI_FILE_READ_SHARED8_I4
END INTERFACE MPI_FILE_READ_SHARED8

INTERFACE MPI_FILE_WRITE_ORDERED8
  MODULE PROCEDURE MPI_FILE_WRITE_ORDERED8_R8, MPI_FILE_WRITE_ORDERED8_I4
END INTERFACE MPI_FILE_WRITE_ORDERED8

INTERFACE MPI_FILE_WRITE_ORDERED_BEGIN8
  MODULE PROCEDURE MPI_FWRITE_ORDERED_BEGIN8_R8, MPI_FWRITE_ORDERED_BEGIN8_I4
END INTERFACE MPI_FILE_WRITE_ORDERED_BEGIN8

INTERFACE MPI_FILE_WRITE_ORDERED_END8
  MODULE PROCEDURE MPI_FWRITE_ORDERED_END8_R8, MPI_FWRITE_ORDERED_END8_I4
END INTERFACE MPI_FILE_WRITE_ORDERED_END8

INTERFACE MPI_FILE_WRITE_SHARED8
  MODULE PROCEDURE MPI_FILE_WRITE_SHARED8_R8, MPI_FILE_WRITE_SHARED8_I4
END INTERFACE MPI_FILE_WRITE_SHARED8

INTERFACE MPI_GATHER8
  MODULE PROCEDURE MPI_GATHER8_I1, MPI_GATHER8_R8_1
END INTERFACE MPI_GATHER8

INTERFACE MPI_GATHERV8
  MODULE PROCEDURE MPI_GATHERV8_R4, MPI_GATHERV8_R8, &
                   MPI_GATHERV8_R4S, MPI_GATHERV8_R8S, &
                   MPI_GATHERV8_I4, MPI_GATHERV8_I1, &
                   MPI_GATHERV8_I4S, MPI_GATHERV8_I4S_1, &
                   MPI_GATHERV8_R8_1, MPI_GATHERV8_R8S_1
END INTERFACE MPI_GATHERV8

INTERFACE MPI_RECV8
  MODULE PROCEDURE MPI_RECV8_R4, MPI_RECV8_R8, &
                   MPI_RECV8_R42, MPI_RECV8_R82, &
                   MPI_RECV8_I4, MPI_RECV8_I1, &
                   MPI_RECV8_R4_1, MPI_RECV8_R8_1, &
                   MPI_RECV8_CH, MPI_RECV8_I42
END INTERFACE MPI_RECV8

INTERFACE MPI_IRECV8
  MODULE PROCEDURE MPI_IRECV8_R4, MPI_IRECV8_R8, &
                   MPI_IRECV8_R42, MPI_IRECV8_R82, &
                   MPI_IRECV8_I4, MPI_IRECV8_I1, &
                   MPI_IRECV8_I42, &
                   MPI_IRECV8_R4_1, MPI_IRECV8_R8_1, &
                   MPI_IRECV8_CH
END INTERFACE MPI_IRECV8

INTERFACE MPI_SCATTERV8
  MODULE PROCEDURE MPI_SCATTERV8_R8, MPI_SCATTERV8_I4, &
                   MPI_SCATTERV8_R8S, MPI_SCATTERV8_I4S
END INTERFACE MPI_SCATTERV8

PUBLIC

CONTAINS

! =========================================================
! ---------------------------------------------------------
SUBROUTINE MPI_ALLREDUCE8_R4(SENDDATA, RECVDATA, COUNT, DATATYPE, OP, &
                             COMM, IERROR)

  REAL(KIND=JPRM), DIMENSION(:), INTENT(IN) :: &
    SENDDATA(:)
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COUNT, DATATYPE, OP, COMM
  REAL(KIND=JPRM), DIMENSION(:), INTENT(OUT) :: &
    RECVDATA(:)
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    IERROR

  REAL(KIND=8), DIMENSION(:), ALLOCATABLE :: &
    SENDDATA8, RECVDATA8
  INTEGER(KIND=8) :: &
    COUNT8, DATATYPE8, OP8, COMM8, IERROR8

  ALLOCATE(SENDDATA8(SIZE(SENDDATA)))
  ALLOCATE(RECVDATA8(SIZE(RECVDATA)))

  SENDDATA8 = SENDDATA
  COUNT8 = COUNT
  DATATYPE8 = DATATYPE
  OP8 = OP
  COMM8 = COMM

  CALL MPI_ALLREDUCE(SENDDATA8, RECVDATA8, COUNT8, DATATYPE8, OP8, COMM8, IERROR8)

  RECVDATA = RECVDATA8
  IERROR = IERROR8

  DEALLOCATE(SENDDATA8)
  DEALLOCATE(RECVDATA8)

END SUBROUTINE MPI_ALLREDUCE8_R4

SUBROUTINE MPI_ALLREDUCE8_R4_2D(SENDDATA, RECVDATA, COUNT, DATATYPE, OP, &
                             COMM, IERROR)

  REAL(KIND=JPRM), DIMENSION(:,:), INTENT(IN) :: &
    SENDDATA(:,:)
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COUNT, DATATYPE, OP, COMM
  REAL(KIND=JPRM), DIMENSION(:,:), INTENT(OUT) :: &
    RECVDATA(:.:)
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    IERROR

  REAL(KIND=8), DIMENSION(:,:), ALLOCATABLE :: &
    SENDDATA8, RECVDATA8
  INTEGER(KIND=8) :: &
    COUNT8, DATATYPE8, OP8, COMM8, IERROR8

  ALLOCATE(SENDDATA8(SIZE(SENDDATA)))
  ALLOCATE(RECVDATA8(SIZE(RECVDATA)))

  SENDDATA8 = SENDDATA
  COUNT8 = COUNT
  DATATYPE8 = DATATYPE
  OP8 = OP
  COMM8 = COMM

  CALL MPI_ALLREDUCE(SENDDATA8, RECVDATA8, COUNT8, DATATYPE8, OP8, COMM8, IERROR8)

  RECVDATA = RECVDATA8
  IERROR = IERROR8

  DEALLOCATE(SENDDATA8)
  DEALLOCATE(RECVDATA8)

END SUBROUTINE MPI_ALLREDUCE8_R4_2D


! ---------------------------------------------------------
SUBROUTINE MPI_ALLREDUCE8_R8(SENDDATA, RECVDATA, COUNT, DATATYPE, OP, &
                             COMM, IERROR)

  REAL(KIND=JPRD), DIMENSION(:), INTENT(IN) :: &
    SENDDATA(:)
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COUNT, DATATYPE, OP, COMM
  REAL(KIND=JPRD), DIMENSION(:), INTENT(OUT) :: &
    RECVDATA(:)
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    IERROR

  INTEGER(KIND=8) :: &
    COUNT8, DATATYPE8, OP8, COMM8, IERROR8

  COUNT8 = COUNT
  DATATYPE8 = DATATYPE
  OP8 = OP
  COMM8 = COMM

  CALL MPI_ALLREDUCE(SENDDATA, RECVDATA, COUNT8, DATATYPE8, OP8, COMM8, IERROR8)

  IERROR = IERROR8

END SUBROUTINE MPI_ALLREDUCE8_R8

SUBROUTINE MPI_ALLREDUCE8_R8_2D(SENDDATA, RECVDATA, COUNT, DATATYPE, OP, &
                             COMM, IERROR)

  REAL(KIND=JPRD), DIMENSION(:,:), INTENT(IN) :: &
    SENDDATA(:,:)
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COUNT, DATATYPE, OP, COMM
  REAL(KIND=JPRD), DIMENSION(:,:), INTENT(OUT) :: &
    RECVDATA(:,:)
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    IERROR

  INTEGER(KIND=8) :: &
    COUNT8, DATATYPE8, OP8, COMM8, IERROR8

  COUNT8 = COUNT
  DATATYPE8 = DATATYPE
  OP8 = OP
  COMM8 = COMM

  CALL MPI_ALLREDUCE(SENDDATA, RECVDATA, COUNT8, DATATYPE8, OP8, COMM8, IERROR8)

  IERROR = IERROR8

END SUBROUTINE MPI_ALLREDUCE8_R8


! ---------------------------------------------------------
SUBROUTINE MPI_ALLREDUCE8_I4(SENDDATA, RECVDATA, COUNT, DATATYPE, OP, &
                              COMM, IERROR)

  INTEGER(KIND=JPIM), DIMENSION(:), INTENT(IN) :: &
    SENDDATA(:)
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COUNT, DATATYPE, OP, COMM
  INTEGER(KIND=JPIM), DIMENSION(:), INTENT(OUT) :: &
    RECVDATA(:)
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    IERROR

  INTEGER(KIND=8), DIMENSION(:), ALLOCATABLE :: &
    SENDDATA8, RECVDATA8
  INTEGER(KIND=8) :: &
    COUNT8, DATATYPE8, OP8, COMM8, IERROR8

  ALLOCATE(SENDDATA8(SIZE(SENDDATA)))
  ALLOCATE(RECVDATA8(SIZE(RECVDATA)))

  SENDDATA8 = SENDDATA
  COUNT8 = COUNT
  DATATYPE8 = DATATYPE
  OP8 = OP
  COMM8 = COMM

  CALL MPI_ALLREDUCE(SENDDATA8, RECVDATA8, COUNT8, DATATYPE8, OP8, COMM8, IERROR8)

  RECVDATA = RECVDATA8
  IERROR = IERROR8

  DEALLOCATE(SENDDATA8)
  DEALLOCATE(RECVDATA8)

END SUBROUTINE MPI_ALLREDUCE8_I4

! =========================================================
! ---------------------------------------------------------
SUBROUTINE MPI_ALLGATHERV8_R4(SENDAREA, SENDCOUNT, SENDTYPE, RECVAREA, &
                              RECVCOUNTS, DISPLS, RECVTYPE, COMM, IERROR)

  REAL(KIND=JPRM), DIMENSION(:), INTENT(IN) :: &
    SENDAREA
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    SENDCOUNT, SENDTYPE, RECVTYPE, COMM
  REAL(KIND=JPRM), DIMENSION(:), INTENT(OUT) :: &
    RECVAREA
  INTEGER(KIND=JPIM), DIMENSION(:), INTENT(IN) :: &
    RECVCOUNTS, DISPLS
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    IERROR

  REAL(KIND=8), DIMENSION(:), ALLOCATABLE :: &
    SENDAREA8, RECVAREA8
  INTEGER(KIND=8), DIMENSION(:), ALLOCATABLE :: &
    RECVCOUNTS8, DISPLS8
  INTEGER(KIND=8) :: &
    SENDCOUNT8, SENDTYPE8, RECVTYPE8, COMM8, IERROR8

  ALLOCATE(SENDAREA8(SIZE(SENDAREA)))
  ALLOCATE(RECVAREA8(SIZE(RECVAREA)))
  ALLOCATE(RECVCOUNTS8(SIZE(RECVCOUNTS)))
  ALLOCATE(DISPLS8(SIZE(DISPLS)))

  SENDAREA8 = SENDAREA
  SENDCOUNT8 = SENDCOUNT
  SENDTYPE8 = SENDTYPE
  RECVCOUNTS8 = RECVCOUNTS
  DISPLS8 = DISPLS
  RECVTYPE8 = RECVTYPE
  COMM8 = COMM

  CALL MPI_ALLGATHERV(SENDAREA8, SENDCOUNT8, SENDTYPE8, RECVAREA8, &
                      RECVCOUNTS8, DISPLS8, RECVTYPE8, COMM8, IERROR8)

  RECVAREA = RECVAREA8
  IERROR = IERROR8

  DEALLOCATE(SENDAREA8)
  DEALLOCATE(RECVAREA8)
  DEALLOCATE(RECVCOUNTS8)
  DEALLOCATE(DISPLS8)

END SUBROUTINE MPI_ALLGATHERV8_R4

! ---------------------------------------------------------
SUBROUTINE MPI_ALLGATHERV8_R8(SENDAREA, SENDCOUNT, SENDTYPE, RECVAREA, &
                              RECVCOUNTS, DISPLS, RECVTYPE, COMM, IERROR)

  REAL(KIND=JPRD), DIMENSION(:), INTENT(IN) :: &
    SENDAREA
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    SENDCOUNT, SENDTYPE, RECVTYPE, COMM
  REAL(KIND=JPRD), DIMENSION(:), INTENT(OUT) :: &
    RECVAREA
  INTEGER(KIND=JPIM), DIMENSION(:), INTENT(IN) :: &
    RECVCOUNTS, DISPLS
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    IERROR

  INTEGER(KIND=8), DIMENSION(:), ALLOCATABLE :: &
    RECVCOUNTS8, DISPLS8
  INTEGER(KIND=8) :: &
    SENDCOUNT8, SENDTYPE8, RECVTYPE8, COMM8, IERROR8

  ALLOCATE(RECVCOUNTS8(SIZE(RECVCOUNTS)))
  ALLOCATE(DISPLS8(SIZE(DISPLS)))

  SENDCOUNT8 = SENDCOUNT
  SENDTYPE8 = SENDTYPE
  RECVCOUNTS8 = RECVCOUNTS
  DISPLS8 = DISPLS
  RECVTYPE8 = RECVTYPE
  COMM8 = COMM

  CALL MPI_ALLGATHERV(SENDAREA, SENDCOUNT8, SENDTYPE8, RECVAREA, &
                      RECVCOUNTS8, DISPLS8, RECVTYPE8, COMM8, IERROR8)

  IERROR = IERROR8

  DEALLOCATE(RECVCOUNTS8)
  DEALLOCATE(DISPLS8)

END SUBROUTINE MPI_ALLGATHERV8_R8

! ---------------------------------------------------------
SUBROUTINE MPI_ALLGATHERV8_I4(SENDAREA, SENDCOUNT, SENDTYPE, RECVAREA, &
                               RECVCOUNTS, DISPLS, RECVTYPE, COMM, IERROR)

  INTEGER(KIND=JPIM), DIMENSION(:), INTENT(IN) :: &
    SENDAREA, RECVCOUNTS, DISPLS
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    SENDCOUNT, SENDTYPE, RECVTYPE, COMM
  INTEGER(KIND=JPIM), DIMENSION(:), INTENT(OUT) :: &
    RECVAREA
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    IERROR

  INTEGER(KIND=8), DIMENSION(:), ALLOCATABLE :: &
    SENDAREA8, RECVAREA8, RECVCOUNTS8, DISPLS8
  INTEGER(KIND=8) :: &
    SENDCOUNT8, SENDTYPE8, RECVTYPE8, COMM8, IERROR8

  ALLOCATE(SENDAREA8(SIZE(SENDAREA)))
  ALLOCATE(RECVAREA8(SIZE(RECVAREA)))
  ALLOCATE(RECVCOUNTS8(SIZE(RECVCOUNTS)))
  ALLOCATE(DISPLS8(SIZE(DISPLS)))

  SENDAREA8 = SENDAREA
  SENDCOUNT8 = SENDCOUNT
  SENDTYPE8 = SENDTYPE
  RECVCOUNTS8 = RECVCOUNTS
  DISPLS8 = DISPLS
  RECVTYPE8 = RECVTYPE
  COMM8 = COMM

  CALL MPI_ALLGATHERV(SENDAREA8, SENDCOUNT8, SENDTYPE8, RECVAREA8, &
                      RECVCOUNTS8, DISPLS8, RECVTYPE8, COMM8, IERROR8)

  RECVAREA = RECVAREA8
  IERROR = IERROR8

  DEALLOCATE(SENDAREA8)
  DEALLOCATE(RECVAREA8)
  DEALLOCATE(RECVCOUNTS8)
  DEALLOCATE(DISPLS8)

END SUBROUTINE MPI_ALLGATHERV8_I4

! ---------------------------------------------------------
SUBROUTINE MPI_ALLGATHERV8_I1(SENDAREA, SENDCOUNT, SENDTYPE, RECVAREA, &
                               RECVCOUNTS, DISPLS, RECVTYPE, COMM, IERROR)

  INTEGER(KIND=JPIM), INTENT(IN) :: &
    SENDAREA
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    SENDCOUNT, SENDTYPE, RECVTYPE, COMM
  INTEGER(KIND=JPIM), DIMENSION(:), INTENT(IN) :: &
    RECVCOUNTS, DISPLS
  INTEGER(KIND=JPIM), DIMENSION(:), INTENT(OUT) :: &
    RECVAREA
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    IERROR

  INTEGER(KIND=8), DIMENSION(:), ALLOCATABLE :: &
    RECVAREA8, RECVCOUNTS8, DISPLS8
  INTEGER(KIND=8) :: &
    SENDAREA8, SENDCOUNT8, SENDTYPE8, RECVTYPE8, COMM8, IERROR8

  ALLOCATE(RECVAREA8(SIZE(RECVAREA)))
  ALLOCATE(RECVCOUNTS8(SIZE(RECVCOUNTS)))
  ALLOCATE(DISPLS8(SIZE(DISPLS)))

  SENDAREA8 = SENDAREA
  SENDCOUNT8 = SENDCOUNT
  SENDTYPE8 = SENDTYPE
  RECVCOUNTS8 = RECVCOUNTS
  DISPLS8 = DISPLS
  RECVTYPE8 = RECVTYPE
  COMM8 = COMM

  CALL MPI_ALLGATHERV(SENDAREA8, SENDCOUNT8, SENDTYPE8, RECVAREA8, &
                      RECVCOUNTS8, DISPLS8, RECVTYPE8, COMM8, IERROR8)

  RECVAREA = RECVAREA8
  IERROR = IERROR8

  DEALLOCATE(RECVAREA8)
  DEALLOCATE(RECVCOUNTS8)
  DEALLOCATE(DISPLS8)

END SUBROUTINE MPI_ALLGATHERV8_I1

! =========================================================
! ---------------------------------------------------------
SUBROUTINE MPI_ALLTOALLV8_R8(SENDAREA, SENDCOUNTS, SDISPLS, SENDTYPE, &
                             RECVAREA, RECVCOUNTS, RDISPLS, RECVTYPE, &
                             COMM, IERROR)

  REAL(KIND=JPRD), DIMENSION(:), INTENT(IN) :: &
    SENDAREA
  INTEGER(KIND=JPIM), DIMENSION(:), INTENT(IN) :: &
    SENDCOUNTS, SDISPLS, RECVCOUNTS, RDISPLS
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    SENDTYPE, RECVTYPE, COMM
  REAL(KIND=JPRD), DIMENSION(:), INTENT(OUT) :: &
    RECVAREA
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    IERROR

  INTEGER(KIND=8), DIMENSION(:), ALLOCATABLE :: &
    SENDCOUNTS8, SDISPLS8, RECVCOUNTS8, RDISPLS8
  INTEGER(KIND=8) :: &
    SENDTYPE8, RECVTYPE8, COMM8, IERROR8

  ALLOCATE(SENDCOUNTS8(SIZE(SENDCOUNTS)))
  ALLOCATE(SDISPLS8(SIZE(SDISPLS)))
  ALLOCATE(RECVCOUNTS8(SIZE(RECVCOUNTS)))
  ALLOCATE(RDISPLS8(SIZE(RDISPLS)))

  SENDCOUNTS8 = SENDCOUNTS
  SDISPLS8 = SDISPLS
  SENDTYPE8 = SENDTYPE
  RECVCOUNTS8 = RECVCOUNTS
  RDISPLS8 = RDISPLS
  RECVTYPE8 = RECVTYPE
  COMM8 = COMM

  CALL MPI_ALLTOALLV(SENDAREA, SENDCOUNTS8, SDISPLS8, SENDTYPE8, RECVAREA, &
                     RECVCOUNTS8, RDISPLS8, RECVTYPE8, COMM8, IERROR8)

  IERROR = IERROR8

  DEALLOCATE(SENDCOUNTS8)
  DEALLOCATE(SDISPLS8)
  DEALLOCATE(RECVCOUNTS8)
  DEALLOCATE(RDISPLS8)

END SUBROUTINE MPI_ALLTOALLV8_R8

! ---------------------------------------------------------
SUBROUTINE MPI_ALLTOALLV8_I4(SENDAREA, SENDCOUNTS, SDISPLS, SENDTYPE, &
                              RECVAREA, RECVCOUNTS, RDISPLS, RECVTYPE, &
                              COMM, IERROR)

  INTEGER(KIND=JPIM), DIMENSION(:), INTENT(IN) :: &
    SENDAREA, SENDCOUNTS, SDISPLS, RECVCOUNTS, RDISPLS
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    SENDTYPE, RECVTYPE, COMM
  INTEGER(KIND=JPIM), DIMENSION(:), INTENT(OUT) :: &
    RECVAREA
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    IERROR

  INTEGER(KIND=8), DIMENSION(:), ALLOCATABLE :: &
    SENDAREA8, SENDCOUNTS8, SDISPLS8, RECVAREA8, RECVCOUNTS8, RDISPLS8
  INTEGER(KIND=8) :: &
    SENDTYPE8, RECVTYPE8, COMM8, IERROR8

  ALLOCATE(SENDAREA8(SIZE(SENDAREA)))
  ALLOCATE(SENDCOUNTS8(SIZE(SENDCOUNTS)))
  ALLOCATE(SDISPLS8(SIZE(SDISPLS)))
  ALLOCATE(RECVAREA8(SIZE(RECVAREA)))
  ALLOCATE(RECVCOUNTS8(SIZE(RECVCOUNTS)))
  ALLOCATE(RDISPLS8(SIZE(RDISPLS)))

  SENDAREA8 = SENDAREA
  SENDCOUNTS8 = SENDCOUNTS
  SDISPLS8 = SDISPLS
  SENDTYPE8 = SENDTYPE
  RECVCOUNTS8 = RECVCOUNTS
  RDISPLS8 = RDISPLS
  RECVTYPE8 = RECVTYPE
  COMM8 = COMM

  CALL MPI_ALLTOALLV(SENDAREA8, SENDCOUNTS8, SDISPLS8, SENDTYPE8, RECVAREA8, &
                     RECVCOUNTS8, RDISPLS8, RECVTYPE8, COMM8, IERROR8)

  RECVAREA = RECVAREA8
  IERROR = IERROR8

  DEALLOCATE(SENDAREA8)
  DEALLOCATE(SENDCOUNTS8)
  DEALLOCATE(SDISPLS8)
  DEALLOCATE(RECVAREA8)
  DEALLOCATE(RECVCOUNTS8)
  DEALLOCATE(RDISPLS8)

END SUBROUTINE MPI_ALLTOALLV8_I4

! =========================================================
! ---------------------------------------------------------
SUBROUTINE MPI_BCAST8_R4(DATA, COUNT, DATATYPE, ROOT, COMM, IERROR)

  REAL(KIND=JPRM), DIMENSION(:), INTENT(INOUT) :: &
    DATA
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COUNT, DATATYPE, ROOT, COMM
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    IERROR

  REAL(KIND=8), DIMENSION(:), ALLOCATABLE :: &
    DATA8
  INTEGER(KIND=8) :: &
    COUNT8, DATATYPE8, ROOT8, COMM8, IERROR8

  ALLOCATE(DATA8(SIZE(DATA)))

  DATA8 = DATA
  COUNT8 = COUNT
  DATATYPE8 = DATATYPE
  ROOT8 = ROOT
  COMM8 = COMM

  CALL MPI_BCAST(DATA8, COUNT8, DATATYPE8, ROOT8, COMM8, IERROR8)

  DATA = DATA8
  IERROR = IERROR8

  DEALLOCATE(DATA8)

END SUBROUTINE MPI_BCAST8_R4

! ---------------------------------------------------------
SUBROUTINE MPI_BCAST8_R8(DATA, COUNT, DATATYPE, ROOT, COMM, IERROR)

  REAL(KIND=JPRD), DIMENSION(:), INTENT(INOUT) :: &
    DATA
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COUNT, DATATYPE, ROOT, COMM
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    IERROR

  INTEGER(KIND=8) :: &
    COUNT8, DATATYPE8, ROOT8, COMM8, IERROR8

  COUNT8 = COUNT
  DATATYPE8 = DATATYPE
  ROOT8 = ROOT
  COMM8 = COMM

  CALL MPI_BCAST(DATA, COUNT8, DATATYPE8, ROOT8, COMM8, IERROR8)

  IERROR = IERROR8

END SUBROUTINE MPI_BCAST8_R8

! ---------------------------------------------------------
SUBROUTINE MPI_BCAST8_I4(DATA, COUNT, DATATYPE, ROOT, COMM, IERROR)

  INTEGER(KIND=JPIM), DIMENSION(:), INTENT(INOUT) :: &
    DATA
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COUNT, DATATYPE, ROOT, COMM
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    IERROR

  INTEGER(KIND=8), DIMENSION(:), ALLOCATABLE :: &
    DATA8
  INTEGER(KIND=8) :: &
    COUNT8, DATATYPE8, ROOT8, COMM8, IERROR8

  ALLOCATE(DATA8(SIZE(DATA)))

  DATA8 = DATA
  COUNT8 = COUNT
  DATATYPE8 = DATATYPE
  ROOT8 = ROOT
  COMM8 = COMM

  CALL MPI_BCAST(DATA8, COUNT8, DATATYPE8, ROOT8, COMM8, IERROR8)

  DATA = DATA8
  IERROR = IERROR8

  DEALLOCATE(DATA8)

END SUBROUTINE MPI_BCAST8_I4

! ---------------------------------------------------------
SUBROUTINE MPI_BCAST8_I1(DATA, COUNT, DATATYPE, ROOT, COMM, IERROR)

  INTEGER(KIND=JPIM), INTENT(INOUT) :: &
    DATA
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COUNT, DATATYPE, ROOT, COMM
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    IERROR

  INTEGER(KIND=8) :: &
    DATA8, COUNT8, DATATYPE8, ROOT8, COMM8, IERROR8

  DATA8 = DATA
  COUNT8 = COUNT
  DATATYPE8 = DATATYPE
  ROOT8 = ROOT
  COMM8 = COMM

  CALL MPI_BCAST(DATA8, COUNT8, DATATYPE8, ROOT8, COMM8, IERROR8)

  DATA = DATA8
  IERROR = IERROR8

END SUBROUTINE MPI_BCAST8_I1

! ---------------------------------------------------------
SUBROUTINE MPI_BCAST8_CH(DATA, COUNT, DATATYPE, ROOT, COMM, IERROR)

  CHARACTER(LEN=*), INTENT(INOUT) :: &
    DATA
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COUNT, DATATYPE, ROOT, COMM
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    IERROR

  INTEGER(KIND=8) :: &
    COUNT8, DATATYPE8, ROOT8, COMM8, IERROR8

  COUNT8 = COUNT
  DATATYPE8 = DATATYPE
  ROOT8 = ROOT
  COMM8 = COMM

  CALL MPI_BCAST(DATA, COUNT8, DATATYPE8, ROOT8, COMM8, IERROR8)

  IERROR = IERROR8

END SUBROUTINE MPI_BCAST8_CH

! =========================================================
! ---------------------------------------------------------
SUBROUTINE MPI_BSEND8_R4(DATA, COUNT, DATATYPE, DEST, TAG, COMM, IERROR)

  REAL(KIND=JPRM), DIMENSION(:), INTENT(IN) :: &
    DATA
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COUNT, DATATYPE, DEST, TAG, COMM
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    IERROR

  REAL(KIND=8), DIMENSION(:), ALLOCATABLE :: &
    DATA8
  INTEGER(KIND=8) :: &
    COUNT8, DATATYPE8, DEST8, TAG8, COMM8, IERROR8

  ALLOCATE(DATA8(SIZE(DATA)))

  DATA8 = DATA
  COUNT8 = COUNT
  DATATYPE8 = DATATYPE
  DEST8 = DEST
  TAG8 = TAG
  COMM8 = COMM

  CALL MPI_BSEND(DATA8, COUNT8, DATATYPE8, DEST8, TAG8, COMM8, IERROR8)

  IERROR = IERROR8

  DEALLOCATE(DATA8)

END SUBROUTINE MPI_BSEND8_R4

! =========================================================
! ---------------------------------------------------------
SUBROUTINE MPI_BSEND8_R8(DATA, COUNT, DATATYPE, DEST, TAG, COMM, IERROR)

  REAL(KIND=JPRD), DIMENSION(:), INTENT(IN) :: &
    DATA
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COUNT, DATATYPE, DEST, TAG, COMM
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    IERROR

  INTEGER(KIND=8) :: &
    COUNT8, DATATYPE8, DEST8, TAG8, COMM8, IERROR8

  COUNT8 = COUNT
  DATATYPE8 = DATATYPE
  DEST8 = DEST
  TAG8 = TAG
  COMM8 = COMM

  CALL MPI_BSEND(DATA, COUNT8, DATATYPE8, DEST8, TAG8, COMM8, IERROR8)

  IERROR = IERROR8

END SUBROUTINE MPI_BSEND8_R8

! ---------------------------------------------------------
SUBROUTINE MPI_BSEND8_R42(DATA, COUNT, DATATYPE, DEST, TAG, COMM, IERROR)

  REAL(KIND=JPRM), DIMENSION(:,:), INTENT(IN) :: &
    DATA
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COUNT, DATATYPE, DEST, TAG, COMM
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    IERROR

  REAL(KIND=8), DIMENSION(:,:), ALLOCATABLE :: &
    DATA8
  INTEGER(KIND=8) :: &
    COUNT8, DATATYPE8, DEST8, TAG8, COMM8, IERROR8

  ALLOCATE(DATA8(SIZE(DATA,DIM=1),SIZE(DATA,DIM=2)))

  DATA8 = DATA
  COUNT8 = COUNT
  DATATYPE8 = DATATYPE
  DEST8 = DEST
  TAG8 = TAG
  COMM8 = COMM

  CALL MPI_BSEND(DATA8, COUNT8, DATATYPE8, DEST8, TAG8, COMM8, IERROR8)

  IERROR = IERROR8

  DEALLOCATE(DATA8)

END SUBROUTINE MPI_BSEND8_R42

! =========================================================
SUBROUTINE MPI_BSEND8_I42(DATA, COUNT, DATATYPE, DEST, TAG, COMM, IERROR)

  INTEGER(KIND=JPRM), DIMENSION(:,:), INTENT(IN) :: &
    DATA
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COUNT, DATATYPE, DEST, TAG, COMM
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    IERROR

  INTEGER(KIND=8), DIMENSION(:,:), ALLOCATABLE :: &
    DATA8
  INTEGER(KIND=8) :: &
    COUNT8, DATATYPE8, DEST8, TAG8, COMM8, IERROR8

  ALLOCATE(DATA8(SIZE(DATA,DIM=1),SIZE(DATA,DIM=2)))

  DATA8 = DATA
  COUNT8 = COUNT
  DATATYPE8 = DATATYPE
  DEST8 = DEST
  TAG8 = TAG
  COMM8 = COMM

  CALL MPI_BSEND(DATA8, COUNT8, DATATYPE8, DEST8, TAG8, COMM8, IERROR8)

  IERROR = IERROR8

  DEALLOCATE(DATA8)

END SUBROUTINE MPI_BSEND8_I42

! =========================================================
! ---------------------------------------------------------
SUBROUTINE MPI_BSEND8_R82(DATA, COUNT, DATATYPE, DEST, TAG, COMM, IERROR)

  REAL(KIND=JPRD), DIMENSION(:,:), INTENT(IN) :: &
    DATA
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COUNT, DATATYPE, DEST, TAG, COMM
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    IERROR

  INTEGER(KIND=8) :: &
    COUNT8, DATATYPE8, DEST8, TAG8, COMM8, IERROR8

  COUNT8 = COUNT
  DATATYPE8 = DATATYPE
  DEST8 = DEST
  TAG8 = TAG
  COMM8 = COMM

  CALL MPI_BSEND(DATA, COUNT8, DATATYPE8, DEST8, TAG8, COMM8, IERROR8)

  IERROR = IERROR8

END SUBROUTINE MPI_BSEND8_R82

! =========================================================
! ---------------------------------------------------------
SUBROUTINE MPI_BSEND8_I4(DATA, COUNT, DATATYPE, DEST, TAG, COMM, IERROR)

  INTEGER(KIND=JPIM), DIMENSION(:), INTENT(IN) :: &
    DATA
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COUNT, DATATYPE, DEST, TAG, COMM
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    IERROR

  INTEGER(KIND=8), DIMENSION(:), ALLOCATABLE :: &
    DATA8
  INTEGER(KIND=8) :: &
    COUNT8, DATATYPE8, DEST8, TAG8, COMM8, IERROR8

  ALLOCATE(DATA8(SIZE(DATA)))

  DATA8 = DATA
  COUNT8 = COUNT
  DATATYPE8 = DATATYPE
  DEST8 = DEST
  TAG8 = TAG
  COMM8 = COMM

  CALL MPI_BSEND(DATA8, COUNT8, DATATYPE8, DEST8, TAG8, COMM8, IERROR8)

  IERROR = IERROR8

  DEALLOCATE(DATA8)

END SUBROUTINE MPI_BSEND8_I4

! =========================================================
! ---------------------------------------------------------
SUBROUTINE MPI_BSEND8_I1(DATA, COUNT, DATATYPE, DEST, TAG, COMM, IERROR)

  INTEGER(KIND=JPIM), INTENT(IN) :: &
    DATA
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COUNT, DATATYPE, DEST, TAG, COMM
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    IERROR

  INTEGER(KIND=8) :: &
    DATA8, COUNT8, DATATYPE8, DEST8, TAG8, COMM8, IERROR8

  DATA8 = DATA
  COUNT8 = COUNT
  DATATYPE8 = DATATYPE
  DEST8 = DEST
  TAG8 = TAG
  COMM8 = COMM

  CALL MPI_BSEND(DATA8, COUNT8, DATATYPE8, DEST8, TAG8, COMM8, IERROR8)

  IERROR = IERROR8

END SUBROUTINE MPI_BSEND8_I1

! =========================================================
SUBROUTINE MPI_BSEND8_R4_1(DATA, COUNT, DATATYPE, DEST, TAG, COMM, IERROR)

  REAL(KIND=JPRM), INTENT(IN) :: &
    DATA
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COUNT, DATATYPE, DEST, TAG, COMM
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    IERROR

  INTEGER(KIND=8) :: DATA8
  INTEGER(KIND=8) :: &
    COUNT8, DATATYPE8, DEST8, TAG8, COMM8, IERROR8

  DATA8 = DATA
  COUNT8 = COUNT
  DATATYPE8 = DATATYPE
  DEST8 = DEST
  TAG8 = TAG
  COMM8 = COMM

  CALL MPI_BSEND(DATA8, COUNT8, DATATYPE8, DEST8, TAG8, COMM8, IERROR8)

  IERROR = IERROR8

END SUBROUTINE MPI_BSEND8_R4_1

! =========================================================
SUBROUTINE MPI_BSEND8_R8_1(DATA, COUNT, DATATYPE, DEST, TAG, COMM, IERROR)

  REAL(KIND=JPRD), INTENT(IN) :: &
    DATA
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COUNT, DATATYPE, DEST, TAG, COMM
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    IERROR

  INTEGER(KIND=8) :: DATA8
  INTEGER(KIND=8) :: &
    COUNT8, DATATYPE8, DEST8, TAG8, COMM8, IERROR8

  DATA8 = DATA
  COUNT8 = COUNT
  DATATYPE8 = DATATYPE
  DEST8 = DEST
  TAG8 = TAG
  COMM8 = COMM

  CALL MPI_BSEND(DATA8, COUNT8, DATATYPE8, DEST8, TAG8, COMM8, IERROR8)

  IERROR = IERROR8

END SUBROUTINE MPI_BSEND8_R8_1

! =========================================================
! ---------------------------------------------------------
SUBROUTINE MPI_BSEND8_CH(DATA, COUNT, DATATYPE, DEST, TAG, COMM, IERROR)

  CHARACTER(LEN=*), INTENT(IN) :: &
    DATA
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COUNT, DATATYPE, DEST, TAG, COMM
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    IERROR

  INTEGER(KIND=8) :: &
    COUNT8, DATATYPE8, DEST8, TAG8, COMM8, IERROR8

  COUNT8 = COUNT
  DATATYPE8 = DATATYPE
  DEST8 = DEST
  TAG8 = TAG
  COMM8 = COMM

  CALL MPI_BSEND(DATA, COUNT8, DATATYPE8, DEST8, TAG8, COMM8, IERROR8)

  IERROR = IERROR8

END SUBROUTINE MPI_BSEND8_CH

! =========================================================
! ---------------------------------------------------------
SUBROUTINE MPI_ISEND8_R4(DATA, COUNT, DATATYPE, DEST, TAG, COMM, REQUEST, IERROR)

  REAL(KIND=JPRM), DIMENSION(:), INTENT(IN) :: &
    DATA
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COUNT, DATATYPE, DEST, TAG, COMM
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    REQUEST, IERROR

  REAL(KIND=8), DIMENSION(:), ALLOCATABLE :: &
    DATA8
  INTEGER(KIND=8) :: &
    COUNT8, DATATYPE8, DEST8, TAG8, COMM8, REQUEST8, IERROR8

  ALLOCATE(DATA8(SIZE(DATA)))

  DATA8 = DATA
  COUNT8 = COUNT
  DATATYPE8 = DATATYPE
  DEST8 = DEST
  TAG8 = TAG
  COMM8 = COMM

  CALL MPI_ISEND(DATA8, COUNT8, DATATYPE8, DEST8, TAG8, COMM8, REQUEST8, IERROR8)

  REQUEST = REQUEST8
  IERROR = IERROR8

  DEALLOCATE(DATA8)

END SUBROUTINE MPI_ISEND8_R4

! =========================================================
! ---------------------------------------------------------
SUBROUTINE MPI_ISEND8_R8(DATA, COUNT, DATATYPE, DEST, TAG, COMM, REQUEST, IERROR)

  REAL(KIND=JPRD), DIMENSION(:), INTENT(IN) :: &
    DATA
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COUNT, DATATYPE, DEST, TAG, COMM
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    REQUEST, IERROR

  INTEGER(KIND=8) :: &
    COUNT8, DATATYPE8, DEST8, TAG8, COMM8, REQUEST8, IERROR8

  COUNT8 = COUNT
  DATATYPE8 = DATATYPE
  DEST8 = DEST
  TAG8 = TAG
  COMM8 = COMM

  CALL MPI_ISEND(DATA, COUNT8, DATATYPE8, DEST8, TAG8, COMM8, REQUEST8, IERROR8)

  REQUEST = REQUEST8
  IERROR = IERROR8

END SUBROUTINE MPI_ISEND8_R8

! ---------------------------------------------------------
SUBROUTINE MPI_ISEND8_R42(DATA, COUNT, DATATYPE, DEST, TAG, COMM, REQUEST, IERROR)

  REAL(KIND=JPRM), DIMENSION(:,:), INTENT(IN) :: &
    DATA
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COUNT, DATATYPE, DEST, TAG, COMM
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    REQUEST, IERROR

  REAL(KIND=8), DIMENSION(:,:), ALLOCATABLE :: &
    DATA8
  INTEGER(KIND=8) :: &
    COUNT8, DATATYPE8, DEST8, TAG8, COMM8, REQUEST8, IERROR8

  ALLOCATE(DATA8(SIZE(DATA,DIM=1),SIZE(DATA,DIM=2)))

  DATA8 = DATA
  COUNT8 = COUNT
  DATATYPE8 = DATATYPE
  DEST8 = DEST
  TAG8 = TAG
  COMM8 = COMM

  CALL MPI_ISEND(DATA8, COUNT8, DATATYPE8, DEST8, TAG8, COMM8, REQUEST8, IERROR8)

  REQUEST = REQUEST8
  IERROR = IERROR8

  DEALLOCATE(DATA8)

END SUBROUTINE MPI_ISEND8_R42

! =========================================================
SUBROUTINE MPI_ISEND8_I42(DATA, COUNT, DATATYPE, DEST, TAG, COMM, REQUEST, IERROR)

  INTEGER(KIND=JPRM), DIMENSION(:,:), INTENT(IN) :: &
    DATA
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COUNT, DATATYPE, DEST, TAG, COMM
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    REQUEST, IERROR

  INTEGER(KIND=8), DIMENSION(:,:), ALLOCATABLE :: &
    DATA8
  INTEGER(KIND=8) :: &
    COUNT8, DATATYPE8, DEST8, TAG8, COMM8, REQUEST8, IERROR8

  ALLOCATE(DATA8(SIZE(DATA,DIM=1),SIZE(DATA,DIM=2)))

  DATA8 = DATA
  COUNT8 = COUNT
  DATATYPE8 = DATATYPE
  DEST8 = DEST
  TAG8 = TAG
  COMM8 = COMM

  CALL MPI_ISEND(DATA8, COUNT8, DATATYPE8, DEST8, TAG8, COMM8, REQUEST8, IERROR8)

  REQUEST = REQUEST8
  IERROR = IERROR8

  DEALLOCATE(DATA8)

END SUBROUTINE MPI_ISEND8_I42

! =========================================================
! ---------------------------------------------------------
SUBROUTINE MPI_ISEND8_R82(DATA, COUNT, DATATYPE, DEST, TAG, COMM, REQUEST, IERROR)

  REAL(KIND=JPRD), DIMENSION(:,:), INTENT(IN) :: &
    DATA
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COUNT, DATATYPE, DEST, TAG, COMM
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    REQUEST, IERROR

  INTEGER(KIND=8) :: &
    COUNT8, DATATYPE8, DEST8, TAG8, COMM8, REQUEST8, IERROR8

  COUNT8 = COUNT
  DATATYPE8 = DATATYPE
  DEST8 = DEST
  TAG8 = TAG
  COMM8 = COMM

  CALL MPI_ISEND(DATA, COUNT8, DATATYPE8, DEST8, TAG8, COMM8, REQUEST8, IERROR8)

  REQUEST = REQUEST8
  IERROR = IERROR8

END SUBROUTINE MPI_ISEND8_R82

! =========================================================
! ---------------------------------------------------------
SUBROUTINE MPI_ISEND8_I4(DATA, COUNT, DATATYPE, DEST, TAG, COMM, REQUEST, IERROR)

  INTEGER(KIND=JPIM), DIMENSION(:), INTENT(IN) :: &
    DATA
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COUNT, DATATYPE, DEST, TAG, COMM
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    REQUEST, IERROR

  INTEGER(KIND=8), DIMENSION(:), ALLOCATABLE :: &
    DATA8
  INTEGER(KIND=8) :: &
    COUNT8, DATATYPE8, DEST8, TAG8, COMM8, REQUEST8, IERROR8

  ALLOCATE(DATA8(SIZE(DATA)))

  DATA8 = DATA
  COUNT8 = COUNT
  DATATYPE8 = DATATYPE
  DEST8 = DEST
  TAG8 = TAG
  COMM8 = COMM

  CALL MPI_ISEND(DATA8, COUNT8, DATATYPE8, DEST8, TAG8, COMM8, REQUEST8, IERROR8)

  REQUEST = REQUEST8
  IERROR = IERROR8

  DEALLOCATE(DATA8)

END SUBROUTINE MPI_ISEND8_I4

! =========================================================
SUBROUTINE MPI_ISEND8_R4_1(DATA, COUNT, DATATYPE, DEST, TAG, COMM, REQUEST, IERROR)

  REAL(KIND=JPRM), INTENT(IN) :: &
    DATA
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COUNT, DATATYPE, DEST, TAG, COMM
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    REQUEST, IERROR

  REAL(KIND=8):: &
    DATA8
  INTEGER(KIND=8) :: &
    COUNT8, DATATYPE8, DEST8, TAG8, COMM8, REQUEST8, IERROR8

  DATA8 = DATA
  COUNT8 = COUNT
  DATATYPE8 = DATATYPE
  DEST8 = DEST
  TAG8 = TAG
  COMM8 = COMM

  CALL MPI_ISEND(DATA8, COUNT8, DATATYPE8, DEST8, TAG8, COMM8, REQUEST8, IERROR8)

  REQUEST = REQUEST8
  IERROR = IERROR8

END SUBROUTINE MPI_ISEND8_R4_1

! =========================================================
SUBROUTINE MPI_ISEND8_R8_1(DATA, COUNT, DATATYPE, DEST, TAG, COMM, REQUEST, IERROR)

  REAL(KIND=JPRD), INTENT(IN) :: &
    DATA
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COUNT, DATATYPE, DEST, TAG, COMM
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    REQUEST, IERROR

  REAL(KIND=8) :: &
    DATA8
  INTEGER(KIND=8) :: &
    COUNT8, DATATYPE8, DEST8, TAG8, COMM8, REQUEST8, IERROR8

  DATA8 = DATA
  COUNT8 = COUNT
  DATATYPE8 = DATATYPE
  DEST8 = DEST
  TAG8 = TAG
  COMM8 = COMM

  CALL MPI_ISEND(DATA8, COUNT8, DATATYPE8, DEST8, TAG8, COMM8, REQUEST8, IERROR8)

  REQUEST = REQUEST8
  IERROR = IERROR8

END SUBROUTINE MPI_ISEND8_R8_1

! =========================================================
! ---------------------------------------------------------
SUBROUTINE MPI_ISEND8_I1(DATA, COUNT, DATATYPE, DEST, TAG, COMM, REQUEST, IERROR)

  INTEGER(KIND=JPIM), INTENT(IN) :: &
    DATA
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COUNT, DATATYPE, DEST, TAG, COMM
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    REQUEST, IERROR

  INTEGER(KIND=8) :: &
    DATA8, COUNT8, DATATYPE8, DEST8, TAG8, COMM8, REQUEST8, IERROR8

  DATA8 = DATA
  COUNT8 = COUNT
  DATATYPE8 = DATATYPE
  DEST8 = DEST
  TAG8 = TAG
  COMM8 = COMM

  CALL MPI_ISEND(DATA8, COUNT8, DATATYPE8, DEST8, TAG8, COMM8, REQUEST8, IERROR8)

  REQUEST = REQUEST8
  IERROR = IERROR8

END SUBROUTINE MPI_ISEND8_I1

! =========================================================
! ---------------------------------------------------------
SUBROUTINE MPI_ISEND8_CH(DATA, COUNT, DATATYPE, DEST, TAG, COMM, REQUEST, IERROR)

  CHARACTER(LEN=*), INTENT(IN) :: &
    DATA
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COUNT, DATATYPE, DEST, TAG, COMM
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    REQUEST, IERROR

  INTEGER(KIND=8) :: &
    COUNT8, DATATYPE8, DEST8, TAG8, COMM8, REQUEST8, IERROR8

  COUNT8 = COUNT
  DATATYPE8 = DATATYPE
  DEST8 = DEST
  TAG8 = TAG
  COMM8 = COMM

  CALL MPI_ISEND(DATA, COUNT8, DATATYPE8, DEST8, TAG8, COMM8, REQUEST8, IERROR8)

  REQUEST = REQUEST8
  IERROR = IERROR8

END SUBROUTINE MPI_ISEND8_CH

! =========================================================
! ---------------------------------------------------------
SUBROUTINE MPI_SEND8_R4(DATA, COUNT, DATATYPE, DEST, TAG, COMM, IERROR)

  REAL(KIND=JPRM), DIMENSION(:), INTENT(IN) :: &
    DATA
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COUNT, DATATYPE, DEST, TAG, COMM
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    IERROR

  REAL(KIND=8), DIMENSION(:), ALLOCATABLE :: &
    DATA8
  INTEGER(KIND=8) :: &
    COUNT8, DATATYPE8, DEST8, TAG8, COMM8, IERROR8

  ALLOCATE(DATA8(SIZE(DATA)))

  DATA8 = DATA
  COUNT8 = COUNT
  DATATYPE8 = DATATYPE
  DEST8 = DEST
  TAG8 = TAG
  COMM8 = COMM

  CALL MPI_SEND(DATA8, COUNT8, DATATYPE8, DEST8, TAG8, COMM8, IERROR8)

  IERROR = IERROR8

  DEALLOCATE(DATA8)

END SUBROUTINE MPI_SEND8_R4

! =========================================================
! ---------------------------------------------------------
SUBROUTINE MPI_SEND8_R8(DATA, COUNT, DATATYPE, DEST, TAG, COMM, IERROR)

  REAL(KIND=JPRD), DIMENSION(:), INTENT(IN) :: &
    DATA
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COUNT, DATATYPE, DEST, TAG, COMM
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    IERROR

  INTEGER(KIND=8) :: &
    COUNT8, DATATYPE8, DEST8, TAG8, COMM8, IERROR8

  COUNT8 = COUNT
  DATATYPE8 = DATATYPE
  DEST8 = DEST
  TAG8 = TAG
  COMM8 = COMM

  CALL MPI_SEND(DATA, COUNT8, DATATYPE8, DEST8, TAG8, COMM8, IERROR8)

  IERROR = IERROR8

END SUBROUTINE MPI_SEND8_R8

! ---------------------------------------------------------
SUBROUTINE MPI_SEND8_R42(DATA, COUNT, DATATYPE, DEST, TAG, COMM, IERROR)

  REAL(KIND=JPRM), DIMENSION(:,:), INTENT(IN) :: &
    DATA
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COUNT, DATATYPE, DEST, TAG, COMM
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    IERROR

  REAL(KIND=8), DIMENSION(:,:), ALLOCATABLE :: &
    DATA8
  INTEGER(KIND=8) :: &
    COUNT8, DATATYPE8, DEST8, TAG8, COMM8, IERROR8

  ALLOCATE(DATA8(SIZE(DATA,DIM=1),SIZE(DATA,DIM=2)))

  DATA8 = DATA
  COUNT8 = COUNT
  DATATYPE8 = DATATYPE
  DEST8 = DEST
  TAG8 = TAG
  COMM8 = COMM

  CALL MPI_SEND(DATA8, COUNT8, DATATYPE8, DEST8, TAG8, COMM8, IERROR8)

  IERROR = IERROR8

  DEALLOCATE(DATA8)

END SUBROUTINE MPI_SEND8_R42

! ---------------------------------------------------------
SUBROUTINE MPI_SEND8_I42(DATA, COUNT, DATATYPE, DEST, TAG, COMM, IERROR)

  INTEGER(KIND=JPIM), DIMENSION(:,:), INTENT(IN) :: &
    DATA
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COUNT, DATATYPE, DEST, TAG, COMM
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    IERROR

  INTEGER(KIND=8), DIMENSION(:,:), ALLOCATABLE :: &
    DATA8
  INTEGER(KIND=8) :: &
    COUNT8, DATATYPE8, DEST8, TAG8, COMM8, IERROR8

  ALLOCATE(DATA8(SIZE(DATA,DIM=1),SIZE(DATA,DIM=2)))

  DATA8 = DATA
  COUNT8 = COUNT
  DATATYPE8 = DATATYPE
  DEST8 = DEST
  TAG8 = TAG
  COMM8 = COMM

  CALL MPI_SEND(DATA8, COUNT8, DATATYPE8, DEST8, TAG8, COMM8, IERROR8)

  IERROR = IERROR8

  DEALLOCATE(DATA8)

END SUBROUTINE MPI_SEND8_I42

! =========================================================
! ---------------------------------------------------------
SUBROUTINE MPI_SEND8_R82(DATA, COUNT, DATATYPE, DEST, TAG, COMM, IERROR)

  REAL(KIND=JPRD), DIMENSION(:,:), INTENT(IN) :: &
    DATA
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COUNT, DATATYPE, DEST, TAG, COMM
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    IERROR

  INTEGER(KIND=8) :: &
    COUNT8, DATATYPE8, DEST8, TAG8, COMM8, IERROR8

  COUNT8 = COUNT
  DATATYPE8 = DATATYPE
  DEST8 = DEST
  TAG8 = TAG
  COMM8 = COMM

  CALL MPI_SEND(DATA, COUNT8, DATATYPE8, DEST8, TAG8, COMM8, IERROR8)

  IERROR = IERROR8

END SUBROUTINE MPI_SEND8_R82

! =========================================================
! ---------------------------------------------------------
SUBROUTINE MPI_SEND8_I4(DATA, COUNT, DATATYPE, DEST, TAG, COMM, IERROR)

  INTEGER(KIND=JPIM), DIMENSION(:), INTENT(IN) :: &
    DATA
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COUNT, DATATYPE, DEST, TAG, COMM
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    IERROR

  INTEGER(KIND=8), DIMENSION(:), ALLOCATABLE :: &
    DATA8
  INTEGER(KIND=8) :: &
    COUNT8, DATATYPE8, DEST8, TAG8, COMM8, IERROR8

  ALLOCATE(DATA8(SIZE(DATA)))

  DATA8 = DATA
  COUNT8 = COUNT
  DATATYPE8 = DATATYPE
  DEST8 = DEST
  TAG8 = TAG
  COMM8 = COMM

  CALL MPI_SEND(DATA8, COUNT8, DATATYPE8, DEST8, TAG8, COMM8, IERROR8)

  IERROR = IERROR8

  DEALLOCATE(DATA8)

END SUBROUTINE MPI_SEND8_I4

! =========================================================
! ---------------------------------------------------------
SUBROUTINE MPI_SEND8_I1(DATA, COUNT, DATATYPE, DEST, TAG, COMM, IERROR)

  INTEGER(KIND=JPIM), INTENT(IN) :: &
    DATA
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COUNT, DATATYPE, DEST, TAG, COMM
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    IERROR

  INTEGER(KIND=8) :: &
    DATA8, COUNT8, DATATYPE8, DEST8, TAG8, COMM8, IERROR8

  DATA8 = DATA
  COUNT8 = COUNT
  DATATYPE8 = DATATYPE
  DEST8 = DEST
  TAG8 = TAG
  COMM8 = COMM

  CALL MPI_SEND(DATA8, COUNT8, DATATYPE8, DEST8, TAG8, COMM8, IERROR8)

  IERROR = IERROR8

END SUBROUTINE MPI_SEND8_I1

! =========================================================
SUBROUTINE MPI_SEND8_R4_1(DATA, COUNT, DATATYPE, DEST, TAG, COMM, IERROR)

  REAL(KIND=JPRM), INTENT(IN) :: &
    DATA
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COUNT, DATATYPE, DEST, TAG, COMM
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    IERROR

  REAL(KIND=8) :: DATA8
  INTEGER(KIND=8) :: &
    COUNT8, DATATYPE8, DEST8, TAG8, COMM8, IERROR8

  DATA8 = DATA
  COUNT8 = COUNT
  DATATYPE8 = DATATYPE
  DEST8 = DEST
  TAG8 = TAG
  COMM8 = COMM

  CALL MPI_SEND(DATA8, COUNT8, DATATYPE8, DEST8, TAG8, COMM8, IERROR8)

  IERROR = IERROR8

END SUBROUTINE MPI_SEND8_R4_1

! =========================================================
SUBROUTINE MPI_SEND8_R8_1(DATA, COUNT, DATATYPE, DEST, TAG, COMM, IERROR)

  REAL(KIND=JPRD), INTENT(IN) :: &
    DATA
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COUNT, DATATYPE, DEST, TAG, COMM
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    IERROR

  REAL(KIND=8) :: DATA8
  INTEGER(KIND=8) :: &
    COUNT8, DATATYPE8, DEST8, TAG8, COMM8, IERROR8

  DATA8 = DATA
  COUNT8 = COUNT
  DATATYPE8 = DATATYPE
  DEST8 = DEST
  TAG8 = TAG
  COMM8 = COMM

  CALL MPI_SEND(DATA8, COUNT8, DATATYPE8, DEST8, TAG8, COMM8, IERROR8)

  IERROR = IERROR8

END SUBROUTINE MPI_SEND8_R8_1

! =========================================================
! ---------------------------------------------------------
SUBROUTINE MPI_SEND8_CH(DATA, COUNT, DATATYPE, DEST, TAG, COMM, IERROR)

  CHARACTER(LEN=*), INTENT(IN) :: &
    DATA
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COUNT, DATATYPE, DEST, TAG, COMM
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    IERROR

  INTEGER(KIND=8) :: &
    COUNT8, DATATYPE8, DEST8, TAG8, COMM8, IERROR8

  COUNT8 = COUNT
  DATATYPE8 = DATATYPE
  DEST8 = DEST
  TAG8 = TAG
  COMM8 = COMM

  CALL MPI_SEND(DATA, COUNT8, DATATYPE8, DEST8, TAG8, COMM8, IERROR8)

  IERROR = IERROR8

END SUBROUTINE MPI_SEND8_CH

! =========================================================
! ---------------------------------------------------------
SUBROUTINE MPI_FILE_IREAD_SHARED8_R8(FH, BUF, COUNT, DATATYPE, REQUEST, IERROR)

  INTEGER(KIND=JPIM), INTENT(IN) :: &
    FH, COUNT, DATATYPE
  REAL(KIND=JPRD), DIMENSION(:), INTENT(OUT) :: &
    BUF
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    REQUEST, IERROR

  INTEGER(KIND=8) :: &
    FH8, COUNT8, DATATYPE8, REQUEST8, IERROR8

  FH8 = FH
  COUNT8 = COUNT
  DATATYPE8 = DATATYPE

  CALL MPI_FILE_IREAD_SHARED(FH8, BUF, COUNT8, DATATYPE8, REQUEST8, IERROR8)

  REQUEST = REQUEST8
  IERROR = IERROR8

END SUBROUTINE MPI_FILE_IREAD_SHARED8_R8

! ---------------------------------------------------------
SUBROUTINE MPI_FILE_IREAD_SHARED8_I4(FH, BUF, COUNT, DATATYPE, REQUEST, IERROR)

  INTEGER(KIND=JPIM), INTENT(IN) :: &
    FH, COUNT, DATATYPE
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    BUF(:), REQUEST, IERROR

  INTEGER(KIND=8), DIMENSION(:), ALLOCATABLE :: &
    BUF8
  INTEGER(KIND=8) :: &
    FH8, COUNT8, DATATYPE8, REQUEST8, IERROR8

  ALLOCATE(BUF8(SIZE(BUF)))

  FH8 = FH
  COUNT8 = COUNT
  DATATYPE8 = DATATYPE

  CALL MPI_FILE_IREAD_SHARED(FH8, BUF8, COUNT8, DATATYPE8, REQUEST8, IERROR8)

  BUF = BUF8
  REQUEST = REQUEST8
  IERROR = IERROR8

  DEALLOCATE(BUF8)

END SUBROUTINE MPI_FILE_IREAD_SHARED8_I4

! =========================================================
! ---------------------------------------------------------
SUBROUTINE MPI_FILE_IWRITE_SHARED8_R8(FH, BUF, COUNT, DATATYPE, REQUEST, IERROR)

  REAL(KIND=JPRD), DIMENSION(:), INTENT(IN) :: &
    BUF
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    FH, COUNT, DATATYPE
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    REQUEST, IERROR

  INTEGER(KIND=8) :: &
    FH8, COUNT8, DATATYPE8, REQUEST8, IERROR8

  FH8 = FH
  COUNT8 = COUNT
  DATATYPE8 = DATATYPE

  CALL MPI_FILE_IWRITE_SHARED(FH8, BUF, COUNT8, DATATYPE8, REQUEST8, IERROR8)

  REQUEST = REQUEST8
  IERROR = IERROR8

END SUBROUTINE MPI_FILE_IWRITE_SHARED8_R8

! ---------------------------------------------------------
SUBROUTINE MPI_FILE_IWRITE_SHARED8_I4(FH, BUF, COUNT, DATATYPE, REQUEST, IERROR)

  INTEGER(KIND=JPIM), INTENT(IN) :: &
    FH, BUF(:), COUNT, DATATYPE
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    REQUEST, IERROR

  INTEGER(KIND=8), DIMENSION(:), ALLOCATABLE :: &
    BUF8
  INTEGER(KIND=8) :: &
    FH8, COUNT8, DATATYPE8, REQUEST8, IERROR8

  ALLOCATE(BUF8(SIZE(BUF)))

  FH8 = FH
  BUF8 = BUF
  COUNT8 = COUNT
  DATATYPE8 = DATATYPE

  CALL MPI_FILE_IWRITE_SHARED(FH8, BUF8, COUNT8, DATATYPE8, REQUEST8, IERROR8)

  REQUEST = REQUEST8
  IERROR = IERROR8

  DEALLOCATE(BUF8)

END SUBROUTINE MPI_FILE_IWRITE_SHARED8_I4

! =========================================================
! ---------------------------------------------------------
SUBROUTINE MPI_FILE_READ_ORDERED8_R8(FH, BUF, COUNT, DATATYPE, STATUS, IERROR)

  INTEGER(KIND=JPIM), INTENT(IN) :: &
    FH, COUNT, DATATYPE
  REAL(KIND=JPRD), DIMENSION(:), INTENT(OUT) :: &
    BUF
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    STATUS(:), IERROR

  INTEGER(KIND=8) :: &
    FH8, COUNT8, DATATYPE8, IERROR8

  FH8 = FH
  COUNT8 = COUNT
  DATATYPE8 = DATATYPE

  CALL MPI_FILE_READ_ORDERED(FH8, BUF, COUNT8, DATATYPE8, STATUS8, IERROR8)

  STATUS = STATUS8
  IERROR = IERROR8

END SUBROUTINE MPI_FILE_READ_ORDERED8_R8

! ---------------------------------------------------------
SUBROUTINE MPI_FILE_READ_ORDERED8_I4(FH, BUF, COUNT, DATATYPE, STATUS, IERROR)

  INTEGER(KIND=JPIM), INTENT(IN) :: &
    FH, COUNT, DATATYPE
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    BUF(:), STATUS(:), IERROR

  INTEGER(KIND=8), DIMENSION(:), ALLOCATABLE :: &
    BUF8
  INTEGER(KIND=8) :: &
    FH8, COUNT8, DATATYPE8, IERROR8

  ALLOCATE(BUF8(SIZE(BUF)))

  FH8 = FH
  COUNT8 = COUNT
  DATATYPE8 = DATATYPE

  CALL MPI_FILE_READ_ORDERED(FH8, BUF8, COUNT8, DATATYPE8, STATUS8, IERROR8)

  BUF = BUF8
  STATUS = STATUS8
  IERROR = IERROR8

  DEALLOCATE(BUF8)

END SUBROUTINE MPI_FILE_READ_ORDERED8_I4

! =========================================================
! ---------------------------------------------------------
SUBROUTINE MPI_FREAD_ORDERED_BEGIN8_R8(FH, BUF, COUNT, DATATYPE, IERROR)

  INTEGER(KIND=JPIM), INTENT(IN) :: &
    FH, COUNT, DATATYPE
  REAL(KIND=JPRD), DIMENSION(:), INTENT(OUT) :: &
    BUF
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    IERROR

  INTEGER(KIND=8) :: &
    FH8, COUNT8, DATATYPE8, IERROR8

  FH8 = FH
  COUNT8 = COUNT
  DATATYPE8 = DATATYPE

  CALL MPI_FILE_READ_ORDERED_BEGIN(FH8, BUF, COUNT8, DATATYPE8, IERROR8)

  IERROR = IERROR8

END SUBROUTINE MPI_FREAD_ORDERED_BEGIN8_R8

! ---------------------------------------------------------
SUBROUTINE MPI_FREAD_ORDERED_BEGIN8_I4(FH, BUF, COUNT, DATATYPE, IERROR)

  INTEGER(KIND=JPIM), INTENT(IN) :: &
    FH, COUNT, DATATYPE
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    BUF(:), IERROR

  INTEGER(KIND=8), DIMENSION(:), ALLOCATABLE :: &
    BUF8
  INTEGER(KIND=8) :: &
    FH8, COUNT8, DATATYPE8, IERROR8

  ALLOCATE(BUF8(SIZE(BUF)))

  FH8 = FH
  COUNT8 = COUNT
  DATATYPE8 = DATATYPE

  CALL MPI_FILE_READ_ORDERED_BEGIN(FH8, BUF8, COUNT8, DATATYPE8, IERROR8)

  BUF = BUF8
  IERROR = IERROR8

  DEALLOCATE(BUF8)

END SUBROUTINE MPI_FREAD_ORDERED_BEGIN8_I4

! =========================================================
! ---------------------------------------------------------
SUBROUTINE MPI_FREAD_ORDERED_END8_R8(FH, BUF, STATUS, IERROR)

  INTEGER(KIND=JPIM), INTENT(IN) :: &
    FH
  REAL(KIND=JPRD), DIMENSION(:), INTENT(OUT) :: &
    BUF
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    STATUS(:), IERROR

  INTEGER(KIND=8) :: &
    FH8, IERROR8

  FH8 = FH

  CALL MPI_FILE_READ_ORDERED_END(FH8, BUF, STATUS8, IERROR8)

  STATUS = STATUS8
  IERROR = IERROR8

END SUBROUTINE MPI_FREAD_ORDERED_END8_R8

! ---------------------------------------------------------
SUBROUTINE MPI_FREAD_ORDERED_END8_I4(FH, BUF, STATUS, IERROR)

  INTEGER(KIND=JPIM), INTENT(IN) :: &
    FH
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    BUF(:), STATUS(:), IERROR

  INTEGER(KIND=8), DIMENSION(:), ALLOCATABLE :: &
    BUF8
  INTEGER(KIND=8) :: &
    FH8, IERROR8

  ALLOCATE(BUF8(SIZE(BUF)))

  FH8 = FH

  CALL MPI_FILE_READ_ORDERED_END(FH8, BUF8, STATUS8, IERROR8)

  BUF = BUF8
  STATUS = STATUS8
  IERROR = IERROR8

  DEALLOCATE(BUF8)

END SUBROUTINE MPI_FREAD_ORDERED_END8_I4

! =========================================================
! ---------------------------------------------------------
SUBROUTINE MPI_FILE_READ_SHARED8_R8(FH, BUF, COUNT, DATATYPE, STATUS, IERROR)

  INTEGER(KIND=JPIM), INTENT(IN) :: &
    FH, COUNT, DATATYPE
  REAL(KIND=JPRD), DIMENSION(:), INTENT(OUT) :: &
    BUF
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    STATUS(:), IERROR

  INTEGER(KIND=8) :: &
    FH8, COUNT8, DATATYPE8, IERROR8

  FH8 = FH
  COUNT8 = COUNT
  DATATYPE8 = DATATYPE

  CALL MPI_FILE_READ_SHARED(FH8, BUF, COUNT8, DATATYPE8, STATUS8, IERROR8)

  STATUS = STATUS8
  IERROR = IERROR8

END SUBROUTINE MPI_FILE_READ_SHARED8_R8

! ---------------------------------------------------------
SUBROUTINE MPI_FILE_READ_SHARED8_I4(FH, BUF, COUNT, DATATYPE, STATUS, IERROR)

  INTEGER(KIND=JPIM), INTENT(IN) :: &
    FH, COUNT, DATATYPE
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    BUF(:), STATUS(:), IERROR

  INTEGER(KIND=8), DIMENSION(:), ALLOCATABLE :: &
    BUF8
  INTEGER(KIND=8) :: &
    FH8, COUNT8, DATATYPE8, IERROR8

  ALLOCATE(BUF8(SIZE(BUF)))

  FH8 = FH
  COUNT8 = COUNT
  DATATYPE8 = DATATYPE

  CALL MPI_FILE_READ_SHARED(FH8, BUF8, COUNT8, DATATYPE8, STATUS8, IERROR8)

  BUF = BUF8
  STATUS = STATUS8
  IERROR = IERROR8

  DEALLOCATE(BUF8)

END SUBROUTINE MPI_FILE_READ_SHARED8_I4

! =========================================================
! ---------------------------------------------------------
SUBROUTINE MPI_FILE_WRITE_ORDERED8_R8(FH, BUF, COUNT, DATATYPE, STATUS, IERROR)

  REAL(KIND=JPRD), DIMENSION(:), INTENT(IN) :: &
    BUF
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    FH, COUNT, DATATYPE
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    STATUS(:), IERROR

  INTEGER(KIND=8) :: &
    FH8, COUNT8, DATATYPE8, IERROR8

  FH8 = FH
  COUNT8 = COUNT
  DATATYPE8 = DATATYPE

  CALL MPI_FILE_WRITE_ORDERED(FH8, BUF, COUNT8, DATATYPE8, STATUS8, IERROR8)

  STATUS = STATUS8
  IERROR = IERROR8

END SUBROUTINE MPI_FILE_WRITE_ORDERED8_R8

! ---------------------------------------------------------
SUBROUTINE MPI_FILE_WRITE_ORDERED8_I4(FH, BUF, COUNT, DATATYPE, STATUS, IERROR)

  INTEGER(KIND=JPIM), INTENT(IN) :: &
    FH, BUF(:), COUNT, DATATYPE
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    STATUS(:), IERROR

  INTEGER(KIND=8), DIMENSION(:), ALLOCATABLE :: &
    BUF8
  INTEGER(KIND=8) :: &
    FH8, COUNT8, DATATYPE8, IERROR8

  ALLOCATE(BUF8(SIZE(BUF)))

  FH8 = FH
  BUF8 = BUF
  COUNT8 = COUNT
  DATATYPE8 = DATATYPE

  CALL MPI_FILE_WRITE_ORDERED(FH8, BUF8, COUNT8, DATATYPE8, STATUS8, IERROR8)

  STATUS = STATUS8
  IERROR = IERROR8

  DEALLOCATE(BUF8)

END SUBROUTINE MPI_FILE_WRITE_ORDERED8_I4

! =========================================================
! ---------------------------------------------------------
SUBROUTINE MPI_FWRITE_ORDERED_BEGIN8_R8(FH, BUF, COUNT, DATATYPE, IERROR)

  INTEGER(KIND=JPIM), INTENT(IN) :: &
    FH, COUNT, DATATYPE
  REAL(KIND=JPRD), DIMENSION(:), INTENT(OUT) :: &
    BUF
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    IERROR

  INTEGER(KIND=8) :: &
    FH8, COUNT8, DATATYPE8, IERROR8

  FH8 = FH
  COUNT8 = COUNT
  DATATYPE8 = DATATYPE

  CALL MPI_FILE_WRITE_ORDERED_BEGIN(FH8, BUF, COUNT8, DATATYPE8, IERROR8)

  IERROR = IERROR8

END SUBROUTINE MPI_FWRITE_ORDERED_BEGIN8_R8

! ---------------------------------------------------------
SUBROUTINE MPI_FWRITE_ORDERED_BEGIN8_I4(FH, BUF, COUNT, DATATYPE, IERROR)

  INTEGER(KIND=JPIM), INTENT(IN) :: &
    FH, COUNT, DATATYPE
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    BUF(:), IERROR

  INTEGER(KIND=8), DIMENSION(:), ALLOCATABLE :: &
    BUF8
  INTEGER(KIND=8) :: &
    FH8, COUNT8, DATATYPE8, IERROR8

  ALLOCATE(BUF8(SIZE(BUF)))

  FH8 = FH
  COUNT8 = COUNT
  DATATYPE8 = DATATYPE

  CALL MPI_FILE_WRITE_ORDERED_BEGIN(FH8, BUF8, COUNT8, DATATYPE8, IERROR8)

  BUF = BUF8
  IERROR = IERROR8

  DEALLOCATE(BUF8)

END SUBROUTINE MPI_FWRITE_ORDERED_BEGIN8_I4

! =========================================================
! ---------------------------------------------------------
SUBROUTINE MPI_FWRITE_ORDERED_END8_R8(FH, BUF, STATUS, IERROR)

  INTEGER(KIND=JPIM), INTENT(IN) :: &
    FH, STATUS(:)
  REAL(KIND=JPRD), DIMENSION(:), INTENT(OUT) :: &
    BUF
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    IERROR

  INTEGER(KIND=8) :: &
    FH8, IERROR8

  FH8 = FH
  STATUS8 = STATUS

  CALL MPI_FILE_WRITE_ORDERED_END(FH8, BUF, STATUS8, IERROR8)

  IERROR = IERROR8

END SUBROUTINE MPI_FWRITE_ORDERED_END8_R8

! ---------------------------------------------------------
SUBROUTINE MPI_FWRITE_ORDERED_END8_I4(FH, BUF, STATUS, IERROR)

  INTEGER(KIND=JPIM), INTENT(IN) :: &
    FH, STATUS(:)
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    BUF(:), IERROR

  INTEGER(KIND=8), DIMENSION(:), ALLOCATABLE :: &
    BUF8
  INTEGER(KIND=8) :: &
    FH8, IERROR8

  ALLOCATE(BUF8(SIZE(BUF)))

  FH8 = FH
  STATUS8 = STATUS

  CALL MPI_FILE_WRITE_ORDERED_END(FH8, BUF8, STATUS8, IERROR8)

  BUF = BUF8
  IERROR = IERROR8

  DEALLOCATE(BUF8)

END SUBROUTINE MPI_FWRITE_ORDERED_END8_I4

! =========================================================
! ---------------------------------------------------------
SUBROUTINE MPI_FILE_WRITE_SHARED8_R8(FH, BUF, COUNT, DATATYPE, STATUS, IERROR)

  REAL(KIND=JPRD), DIMENSION(:), INTENT(IN) :: &
    BUF
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    FH, COUNT, DATATYPE
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    STATUS(:), IERROR

  INTEGER(KIND=8) :: &
    FH8, COUNT8, DATATYPE8, IERROR8

  FH8 = FH
  COUNT8 = COUNT
  DATATYPE8 = DATATYPE

  CALL MPI_FILE_WRITE_SHARED(FH8, BUF, COUNT8, DATATYPE8, STATUS8, IERROR8)

  STATUS = STATUS8
  IERROR = IERROR8

END SUBROUTINE MPI_FILE_WRITE_SHARED8_R8

! ---------------------------------------------------------
SUBROUTINE MPI_FILE_WRITE_SHARED8_I4(FH, BUF, COUNT, DATATYPE, STATUS, IERROR)

  INTEGER(KIND=JPIM), INTENT(IN) :: &
    FH, BUF(:), COUNT, DATATYPE
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    STATUS(:), IERROR

  INTEGER(KIND=8), DIMENSION(:), ALLOCATABLE :: &
    BUF8
  INTEGER(KIND=8) :: &
    FH8, COUNT8, DATATYPE8, IERROR8

  ALLOCATE(BUF8(SIZE(BUF)))

  FH8 = FH
  BUF8 = BUF
  COUNT8 = COUNT
  DATATYPE8 = DATATYPE

  CALL MPI_FILE_WRITE_SHARED(FH8, BUF8, COUNT8, DATATYPE8, STATUS8, IERROR8)

  STATUS = STATUS8
  IERROR = IERROR8

  DEALLOCATE(BUF8)

END SUBROUTINE MPI_FILE_WRITE_SHARED8_I4

! =========================================================
! ---------------------------------------------------------
SUBROUTINE MPI_GATHER8_R8_1(SENDDATA, SENDCOUNT, SENDTYPE, RECVAREA, &
                            RECVCOUNT, RECVTYPE, ROOT, COMM, IERROR)

  REAL(KIND=JPRD), INTENT(IN) :: &
    SENDDATA
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    SENDCOUNT, SENDTYPE, RECVCOUNT, RECVTYPE, ROOT, COMM
  REAL(KIND=JPRD), INTENT(OUT) :: &
    RECVAREA
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    IERROR

  INTEGER(KIND=8) :: &
    SENDCOUNT8, SENDTYPE8, RECVCOUNT8, RECVTYPE8, ROOT8, COMM8, IERROR8

  SENDCOUNT8 = SENDCOUNT
  SENDTYPE8 = SENDTYPE
  RECVCOUNT8 = RECVCOUNT
  RECVTYPE8 = RECVTYPE
  ROOT8 = ROOT
  COMM8 = COMM

  CALL MPI_GATHER(SENDDATA, SENDCOUNT8, SENDTYPE8, RECVAREA, &
                  RECVCOUNT8, RECVTYPE8, ROOT8, COMM8, IERROR8)

  IERROR = IERROR8

END SUBROUTINE MPI_GATHER8_R8_1

! ---------------------------------------------------------
SUBROUTINE MPI_GATHER8_I1(SENDDATA, SENDCOUNT, SENDTYPE, RECVAREA, &
                          RECVCOUNT, RECVTYPE, ROOT, COMM, IERROR)

  INTEGER(KIND=JPIM), INTENT(IN) :: &
    SENDDATA, SENDCOUNT, SENDTYPE, RECVCOUNT, RECVTYPE, ROOT, COMM
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    RECVAREA, IERROR

  INTEGER(KIND=8) :: &
    SENDDATA8, RECVAREA8
  INTEGER(KIND=8) :: &
    SENDCOUNT8, SENDTYPE8, RECVCOUNT8, RECVTYPE8, ROOT8, COMM8, IERROR8

  SENDDATA8 = SENDDATA
  SENDCOUNT8 = SENDCOUNT
  SENDTYPE8 = SENDTYPE
  RECVCOUNT8 = RECVCOUNT
  RECVTYPE8 = RECVTYPE
  ROOT8 = ROOT
  COMM8 = COMM

  CALL MPI_GATHER(SENDDATA8, SENDCOUNT8, SENDTYPE8, RECVAREA8, &
                  RECVCOUNT8, RECVTYPE8, ROOT8, COMM8, IERROR8)

  RECVAREA = RECVAREA8
  IERROR = IERROR8

END SUBROUTINE MPI_GATHER8_I1

! =========================================================
! ---------------------------------------------------------
SUBROUTINE MPI_GATHERV8_R8(SENDDATA, SENDCOUNT, SENDTYPE, RECVAREA, &
                           RECVCOUNTS, DISPLS, RECVTYPE, ROOT, COMM, IERROR)

  REAL(KIND=JPRD), DIMENSION(:), INTENT(IN) :: &
    SENDDATA
  INTEGER(KIND=JPIM), DIMENSION(:), INTENT(IN) :: &
    RECVCOUNTS, DISPLS
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    SENDCOUNT, SENDTYPE, RECVTYPE, ROOT, COMM
  REAL(KIND=JPRD), DIMENSION(:), INTENT(OUT) :: &
    RECVAREA
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    IERROR

  INTEGER(KIND=8), DIMENSION(:), ALLOCATABLE :: &
    RECVCOUNTS8, DISPLS8
  INTEGER(KIND=8) :: &
    SENDCOUNT8, SENDTYPE8, RECVTYPE8, ROOT8, COMM8, IERROR8

  ALLOCATE(RECVCOUNTS8(SIZE(RECVCOUNTS)))
  ALLOCATE(DISPLS8(SIZE(DISPLS)))

  SENDCOUNT8 = SENDCOUNT
  SENDTYPE8 = SENDTYPE
  RECVCOUNTS8 = RECVCOUNTS
  DISPLS8 = DISPLS
  RECVTYPE8 = RECVTYPE
  ROOT8 = ROOT
  COMM8 = COMM

  CALL MPI_GATHERV(SENDDATA, SENDCOUNT8, SENDTYPE8, RECVAREA, &
                   RECVCOUNTS8, DISPLS8, RECVTYPE8, ROOT8, COMM8, IERROR8)

  IERROR = IERROR8

  DEALLOCATE(RECVCOUNTS8)
  DEALLOCATE(DISPLS8)

END SUBROUTINE MPI_GATHERV8_R8

! ---------------------------------------------------------
SUBROUTINE MPI_GATHERV8_R8S(SENDDATA, SENDCOUNT, SENDTYPE, RECVAREA, &
                           RECVCOUNTS, DISPLS, RECVTYPE, ROOT, COMM, IERROR)

  REAL(KIND=JPRD), DIMENSION(:), INTENT(IN) :: &
    SENDDATA
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    RECVCOUNTS, DISPLS
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    SENDCOUNT, SENDTYPE, RECVTYPE, ROOT, COMM
  REAL(KIND=JPRD), INTENT(OUT) :: &
    RECVAREA
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    IERROR

  INTEGER(KIND=8) :: RECVCOUNTS8, DISPLS8
  INTEGER(KIND=8) :: &
    SENDCOUNT8, SENDTYPE8, RECVTYPE8, ROOT8, COMM8, IERROR8

  SENDCOUNT8 = SENDCOUNT
  SENDTYPE8 = SENDTYPE
  RECVCOUNTS8 = RECVCOUNTS
  DISPLS8 = DISPLS
  RECVTYPE8 = RECVTYPE
  ROOT8 = ROOT
  COMM8 = COMM

  CALL MPI_GATHERV(SENDDATA, SENDCOUNT8, SENDTYPE8, RECVAREA, &
                   RECVCOUNTS8, DISPLS8, RECVTYPE8, ROOT8, COMM8, IERROR8)

  IERROR = IERROR8

END SUBROUTINE MPI_GATHERV8_R8S

! ---------------------------------------------------------
SUBROUTINE MPI_GATHERV8_R4(SENDDATA, SENDCOUNT, SENDTYPE, RECVAREA, &
                           RECVCOUNTS, DISPLS, RECVTYPE, ROOT, COMM, IERROR)

  REAL(KIND=JPRM), DIMENSION(:), INTENT(IN) :: &
    SENDDATA
  INTEGER(KIND=JPIM), DIMENSION(:), INTENT(IN) :: &
    RECVCOUNTS, DISPLS
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    SENDCOUNT, SENDTYPE, RECVTYPE, ROOT, COMM
  REAL(KIND=JPRM), DIMENSION(:), INTENT(OUT) :: &
    RECVAREA
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    IERROR

  REAL(KIND=8), DIMENSION(:), ALLOCATABLE :: &
    SENDDATA8, RECVAREA8
  INTEGER(KIND=8), DIMENSION(:), ALLOCATABLE :: &
    RECVCOUNTS8, DISPLS8
  INTEGER(KIND=8) :: &
    SENDCOUNT8, SENDTYPE8, RECVTYPE8, ROOT8, COMM8, IERROR8

  ALLOCATE(SENDDATA8(SIZE(SENDDATA)))
  ALLOCATE(RECVAREA8(SIZE(RECVAREA)))
  ALLOCATE(RECVCOUNTS8(SIZE(RECVCOUNTS)))
  ALLOCATE(DISPLS8(SIZE(DISPLS)))

  SENDDATA8 = SENDDATA
  SENDCOUNT8 = SENDCOUNT
  SENDTYPE8 = SENDTYPE
  RECVCOUNTS8 = RECVCOUNTS
  DISPLS8 = DISPLS
  RECVTYPE8 = RECVTYPE
  ROOT8 = ROOT
  COMM8 = COMM

  CALL MPI_GATHERV(SENDDATA8, SENDCOUNT8, SENDTYPE8, RECVAREA8, &
                   RECVCOUNTS8, DISPLS8, RECVTYPE8, ROOT8, COMM8, IERROR8)

  RECVAREA = RECVAREA8
  IERROR = IERROR8

  DEALLOCATE(SENDDATA8)
  DEALLOCATE(RECVAREA8)
  DEALLOCATE(RECVCOUNTS8)
  DEALLOCATE(DISPLS8)

END SUBROUTINE MPI_GATHERV8_R4

! ---------------------------------------------------------
SUBROUTINE MPI_GATHERV8_R4S(SENDDATA, SENDCOUNT, SENDTYPE, RECVAREA, &
                           RECVCOUNTS, DISPLS, RECVTYPE, ROOT, COMM, IERROR)

  REAL(KIND=JPRM), DIMENSION(:), INTENT(IN) :: &
    SENDDATA
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    RECVCOUNTS, DISPLS
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    SENDCOUNT, SENDTYPE, RECVTYPE, ROOT, COMM
  REAL(KIND=JPRM), INTENT(OUT) :: &
    RECVAREA
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    IERROR

  REAL(KIND=8), DIMENSION(:), ALLOCATABLE :: &
    SENDDATA8
  REAL(KIND=8) :: RECVAREA8
  INTEGER(KIND=8) :: RECVCOUNTS8, DISPLS8
  INTEGER(KIND=8) :: &
    SENDCOUNT8, SENDTYPE8, RECVTYPE8, ROOT8, COMM8, IERROR8

  ALLOCATE(SENDDATA8(SIZE(SENDDATA)))

  SENDDATA8 = SENDDATA
  SENDCOUNT8 = SENDCOUNT
  SENDTYPE8 = SENDTYPE
  RECVCOUNTS8 = RECVCOUNTS
  DISPLS8 = DISPLS
  RECVTYPE8 = RECVTYPE
  ROOT8 = ROOT
  COMM8 = COMM

  CALL MPI_GATHERV(SENDDATA8, SENDCOUNT8, SENDTYPE8, RECVAREA8, &
                   RECVCOUNTS8, DISPLS8, RECVTYPE8, ROOT8, COMM8, IERROR8)

  RECVAREA = RECVAREA8
  IERROR = IERROR8

  DEALLOCATE(SENDDATA8)

END SUBROUTINE MPI_GATHERV8_R4S

! ---------------------------------------------------------
SUBROUTINE MPI_GATHERV8_I4(SENDDATA, SENDCOUNT, SENDTYPE, RECVAREA, &
                           RECVCOUNTS, DISPLS, RECVTYPE, ROOT, COMM, IERROR)

  INTEGER(KIND=JPIM), DIMENSION(:), INTENT(IN) :: &
    SENDDATA, RECVCOUNTS, DISPLS
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    SENDCOUNT, SENDTYPE, RECVTYPE, ROOT, COMM
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    RECVAREA(:), IERROR

  INTEGER(KIND=8), DIMENSION(:), ALLOCATABLE :: &
    SENDDATA8, RECVAREA8, RECVCOUNTS8, DISPLS8
  INTEGER(KIND=8) :: &
    SENDCOUNT8, SENDTYPE8, RECVTYPE8, ROOT8, COMM8, IERROR8

  ALLOCATE(SENDDATA8(SIZE(SENDDATA)))
  ALLOCATE(RECVAREA8(SIZE(RECVAREA)))
  ALLOCATE(RECVCOUNTS8(SIZE(RECVCOUNTS)))
  ALLOCATE(DISPLS8(SIZE(DISPLS)))

  SENDDATA8 = SENDDATA
  SENDCOUNT8 = SENDCOUNT
  SENDTYPE8 = SENDTYPE
  RECVCOUNTS8 = RECVCOUNTS
  DISPLS8 = DISPLS
  RECVTYPE8 = RECVTYPE
  ROOT8 = ROOT
  COMM8 = COMM

  CALL MPI_GATHERV(SENDDATA8, SENDCOUNT8, SENDTYPE8, RECVAREA8, &
                   RECVCOUNTS8, DISPLS8, RECVTYPE8, ROOT8, COMM8, IERROR8)

  RECVAREA = RECVAREA8
  IERROR = IERROR8

  DEALLOCATE(SENDDATA8)
  DEALLOCATE(RECVAREA8)
  DEALLOCATE(RECVCOUNTS8)
  DEALLOCATE(DISPLS8)

END SUBROUTINE MPI_GATHERV8_I4

! ---------------------------------------------------------
SUBROUTINE MPI_GATHERV8_I4S(SENDDATA, SENDCOUNT, SENDTYPE, RECVAREA, &
                           RECVCOUNTS, DISPLS, RECVTYPE, ROOT, COMM, IERROR)

  INTEGER(KIND=JPIM), DIMENSION(:), INTENT(IN) :: &
    SENDDATA
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    SENDCOUNT, SENDTYPE, RECVTYPE, ROOT, COMM, RECVCOUNTS, DISPLS
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    RECVAREA, IERROR

  INTEGER(KIND=8), DIMENSION(:), ALLOCATABLE :: &
    SENDDATA8
  INTEGER(KIND=8) :: &
    RECVAREA8, RECVCOUNTS8, DISPLS8
  INTEGER(KIND=8) :: &
    SENDCOUNT8, SENDTYPE8, RECVTYPE8, ROOT8, COMM8, IERROR8

  ALLOCATE(SENDDATA8(SIZE(SENDDATA)))

  SENDDATA8 = SENDDATA
  SENDCOUNT8 = SENDCOUNT
  SENDTYPE8 = SENDTYPE
  RECVCOUNTS8 = RECVCOUNTS
  DISPLS8 = DISPLS
  RECVTYPE8 = RECVTYPE
  ROOT8 = ROOT
  COMM8 = COMM

  CALL MPI_GATHERV(SENDDATA8, SENDCOUNT8, SENDTYPE8, RECVAREA8, &
                   RECVCOUNTS8, DISPLS8, RECVTYPE8, ROOT8, COMM8, IERROR8)

  RECVAREA = RECVAREA8
  IERROR = IERROR8

  DEALLOCATE(SENDDATA8)

END SUBROUTINE MPI_GATHERV8_I4S

! ---------------------------------------------------------
SUBROUTINE MPI_GATHERV8_I4S_1(SENDDATA, SENDCOUNT, SENDTYPE, RECVAREA, &
                           RECVCOUNTS, DISPLS, RECVTYPE, ROOT, COMM, IERROR)

  INTEGER(KIND=JPIM), INTENT(IN) :: &
    SENDDATA
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    SENDCOUNT, SENDTYPE, RECVTYPE, ROOT, COMM, RECVCOUNTS, DISPLS
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    RECVAREA, IERROR

  INTEGER(KIND=8) :: &
    SENDDATA8
  INTEGER(KIND=8) :: &
    RECVAREA8, RECVCOUNTS8, DISPLS8
  INTEGER(KIND=8) :: &
    SENDCOUNT8, SENDTYPE8, RECVTYPE8, ROOT8, COMM8, IERROR8

  SENDDATA8 = SENDDATA
  SENDCOUNT8 = SENDCOUNT
  SENDTYPE8 = SENDTYPE
  RECVCOUNTS8 = RECVCOUNTS
  DISPLS8 = DISPLS
  RECVTYPE8 = RECVTYPE
  ROOT8 = ROOT
  COMM8 = COMM

  CALL MPI_GATHERV(SENDDATA8, SENDCOUNT8, SENDTYPE8, RECVAREA8, &
                   RECVCOUNTS8, DISPLS8, RECVTYPE8, ROOT8, COMM8, IERROR8)

  RECVAREA = RECVAREA8
  IERROR = IERROR8

END SUBROUTINE MPI_GATHERV8_I4S_1

! ---------------------------------------------------------
SUBROUTINE MPI_GATHERV8_I1(SENDDATA, SENDCOUNT, SENDTYPE, RECVAREA, &
                           RECVCOUNTS, DISPLS, RECVTYPE, ROOT, COMM, IERROR)

  INTEGER(KIND=JPIM), DIMENSION(:), INTENT(IN) :: &
    RECVCOUNTS, DISPLS
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    SENDDATA, SENDCOUNT, SENDTYPE, RECVTYPE, ROOT, COMM
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    RECVAREA, IERROR

  INTEGER(KIND=8) :: &
    SENDDATA8, RECVAREA8
  INTEGER(KIND=8), DIMENSION(:), ALLOCATABLE :: &
    RECVCOUNTS8, DISPLS8
  INTEGER(KIND=8) :: &
    SENDCOUNT8, SENDTYPE8, RECVTYPE8, ROOT8, COMM8, IERROR8

  ALLOCATE(RECVCOUNTS8(SIZE(RECVCOUNTS)))
  ALLOCATE(DISPLS8(SIZE(DISPLS)))

  SENDDATA8 = SENDDATA
  SENDCOUNT8 = SENDCOUNT
  SENDTYPE8 = SENDTYPE
  RECVCOUNTS8 = RECVCOUNTS
  DISPLS8 = DISPLS
  RECVTYPE8 = RECVTYPE
  ROOT8 = ROOT
  COMM8 = COMM

  CALL MPI_GATHERV(SENDDATA8, SENDCOUNT8, SENDTYPE8, RECVAREA8, &
                   RECVCOUNTS8, DISPLS8, RECVTYPE8, ROOT8, COMM8, IERROR8)

  RECVAREA = RECVAREA8
  IERROR = IERROR8

  DEALLOCATE(RECVCOUNTS8)
  DEALLOCATE(DISPLS8)

END SUBROUTINE MPI_GATHERV8_I1

! ---------------------------------------------------------
SUBROUTINE MPI_GATHERV8_R8_1(SENDDATA, SENDCOUNT, SENDTYPE, RECVAREA, &
                             RECVCOUNTS, DISPLS, RECVTYPE, ROOT, COMM, IERROR)

  REAL(KIND=JPRD), INTENT(IN) :: &
    SENDDATA
  INTEGER(KIND=JPIM), DIMENSION(:), INTENT(IN) :: &
    RECVCOUNTS, DISPLS
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    SENDCOUNT, SENDTYPE, RECVTYPE, ROOT, COMM
  REAL(KIND=JPRD), INTENT(OUT) :: &
    RECVAREA
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    IERROR

  INTEGER(KIND=8), DIMENSION(:), ALLOCATABLE :: &
    RECVCOUNTS8, DISPLS8
  INTEGER(KIND=8) :: &
    SENDCOUNT8, SENDTYPE8, RECVTYPE8, ROOT8, COMM8, IERROR8

  ALLOCATE(RECVCOUNTS8(SIZE(RECVCOUNTS)))
  ALLOCATE(DISPLS8(SIZE(DISPLS)))

  SENDCOUNT8 = SENDCOUNT
  SENDTYPE8 = SENDTYPE
  RECVCOUNTS8 = RECVCOUNTS
  DISPLS8 = DISPLS
  RECVTYPE8 = RECVTYPE
  ROOT8 = ROOT
  COMM8 = COMM

  CALL MPI_GATHERV(SENDDATA, SENDCOUNT8, SENDTYPE8, RECVAREA, &
                   RECVCOUNTS8, DISPLS8, RECVTYPE8, ROOT8, COMM8, IERROR8)

  IERROR = IERROR8

  DEALLOCATE(RECVCOUNTS8)
  DEALLOCATE(DISPLS8)

END SUBROUTINE MPI_GATHERV8_R8_1

! =========================================================
SUBROUTINE MPI_GATHERV8_R8S_1(SENDDATA, SENDCOUNT, SENDTYPE, RECVAREA, &
                             RECVCOUNTS, DISPLS, RECVTYPE, ROOT, COMM, IERROR)

  REAL(KIND=JPRD), INTENT(IN) :: &
    SENDDATA
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    RECVCOUNTS, DISPLS
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    SENDCOUNT, SENDTYPE, RECVTYPE, ROOT, COMM
  REAL(KIND=JPRD), INTENT(OUT) :: &
    RECVAREA
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    IERROR

  INTEGER(KIND=8) :: &
    RECVCOUNTS8, DISPLS8
  INTEGER(KIND=8) :: &
    SENDCOUNT8, SENDTYPE8, RECVTYPE8, ROOT8, COMM8, IERROR8

  SENDCOUNT8 = SENDCOUNT
  SENDTYPE8 = SENDTYPE
  RECVCOUNTS8 = RECVCOUNTS
  DISPLS8 = DISPLS
  RECVTYPE8 = RECVTYPE
  ROOT8 = ROOT
  COMM8 = COMM

  CALL MPI_GATHERV(SENDDATA, SENDCOUNT8, SENDTYPE8, RECVAREA, &
                   RECVCOUNTS8, DISPLS8, RECVTYPE8, ROOT8, COMM8, IERROR8)

  IERROR = IERROR8

END SUBROUTINE MPI_GATHERV8_R8S_1

! =========================================================
! ---------------------------------------------------------
SUBROUTINE MPI_RECV8_R4(DATA, COUNT, DATATYPE, SOURCE, TAG, COMM, STATUS, IERROR)

  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COUNT, DATATYPE, SOURCE, TAG, COMM
  REAL(KIND=JPRM), DIMENSION(:), INTENT(OUT) :: &
    DATA
  INTEGER(KIND=JPIM), DIMENSION(:), INTENT(OUT) :: &
    STATUS
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    IERROR

  REAL(KIND=8), DIMENSION(:), ALLOCATABLE :: &
    DATA8
  INTEGER(KIND=8) :: &
    COUNT8, DATATYPE8, SOURCE8, TAG8, COMM8, IERROR8

  ALLOCATE(DATA8(SIZE(DATA)))

  COUNT8 = COUNT
  DATATYPE8 = DATATYPE
  SOURCE8 = SOURCE
  TAG8 = TAG
  COMM8 = COMM

  CALL MPI_RECV(DATA8, COUNT8, DATATYPE8, SOURCE8, TAG8, COMM8, STATUS8, IERROR8)

  DATA = DATA8
  STATUS = STATUS8
  IERROR = IERROR8

  DEALLOCATE(DATA8)

END SUBROUTINE MPI_RECV8_R4

! ---------------------------------------------------------
SUBROUTINE MPI_RECV8_R8(DATA, COUNT, DATATYPE, SOURCE, TAG, COMM, STATUS, IERROR)

  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COUNT, DATATYPE, SOURCE, TAG, COMM
  REAL(KIND=JPRD), DIMENSION(:), INTENT(OUT) :: &
    DATA
  INTEGER(KIND=JPIM), DIMENSION(:), INTENT(OUT) :: &
    STATUS
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    IERROR

  INTEGER(KIND=8) :: &
    COUNT8, DATATYPE8, SOURCE8, TAG8, COMM8, IERROR8

  COUNT8 = COUNT
  DATATYPE8 = DATATYPE
  SOURCE8 = SOURCE
  TAG8 = TAG
  COMM8 = COMM

  CALL MPI_RECV(DATA, COUNT8, DATATYPE8, SOURCE8, TAG8, COMM8, STATUS8, IERROR8)

  STATUS = STATUS8
  IERROR = IERROR8

END SUBROUTINE MPI_RECV8_R8

! ---------------------------------------------------------
SUBROUTINE MPI_RECV8_R42(DATA, COUNT, DATATYPE, SOURCE, TAG, COMM, STATUS, IERROR)

  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COUNT, DATATYPE, SOURCE, TAG, COMM
  REAL(KIND=JPRM), DIMENSION(:,:), INTENT(OUT) :: &
    DATA
  INTEGER(KIND=JPIM), DIMENSION(:), INTENT(OUT) :: &
    STATUS
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    IERROR

  REAL(KIND=8), DIMENSION(:,:), ALLOCATABLE :: &
    DATA8
  INTEGER(KIND=8) :: &
    COUNT8, DATATYPE8, SOURCE8, TAG8, COMM8, IERROR8

  ALLOCATE(DATA8(SIZE(DATA,DIM=1),SIZE(DATA,DIM=2)))

  COUNT8 = COUNT
  DATATYPE8 = DATATYPE
  SOURCE8 = SOURCE
  TAG8 = TAG
  COMM8 = COMM

  CALL MPI_RECV(DATA8, COUNT8, DATATYPE8, SOURCE8, TAG8, COMM8, STATUS8, IERROR8)

  DATA = DATA8
  STATUS = STATUS8
  IERROR = IERROR8

  DEALLOCATE(DATA8)

END SUBROUTINE MPI_RECV8_R42

! ---------------------------------------------------------
SUBROUTINE MPI_RECV8_I42(DATA, COUNT, DATATYPE, SOURCE, TAG, COMM, STATUS, IERROR)

  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COUNT, DATATYPE, SOURCE, TAG, COMM
  INTEGER(KIND=JPIM), DIMENSION(:,:), INTENT(OUT) :: &
    DATA
  INTEGER(KIND=JPIM), DIMENSION(:), INTENT(OUT) :: &
    STATUS
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    IERROR

  INTEGER(KIND=8), DIMENSION(:,:), ALLOCATABLE :: &
    DATA8
  INTEGER(KIND=8) :: &
    COUNT8, DATATYPE8, SOURCE8, TAG8, COMM8, IERROR8

  ALLOCATE(DATA8(SIZE(DATA,DIM=1),SIZE(DATA,DIM=2)))

  COUNT8 = COUNT
  DATATYPE8 = DATATYPE
  SOURCE8 = SOURCE
  TAG8 = TAG
  COMM8 = COMM

  CALL MPI_RECV(DATA8, COUNT8, DATATYPE8, SOURCE8, TAG8, COMM8, STATUS8, IERROR8)

  DATA = DATA8
  STATUS = STATUS8
  IERROR = IERROR8

  DEALLOCATE(DATA8)

END SUBROUTINE MPI_RECV8_I42

! ---------------------------------------------------------
SUBROUTINE MPI_RECV8_R82(DATA, COUNT, DATATYPE, SOURCE, TAG, COMM, STATUS, IERROR)

  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COUNT, DATATYPE, SOURCE, TAG, COMM
  REAL(KIND=JPRD), DIMENSION(:,:), INTENT(OUT) :: &
    DATA
  INTEGER(KIND=JPIM), DIMENSION(:), INTENT(OUT) :: &
    STATUS
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    IERROR

  INTEGER(KIND=8) :: &
    COUNT8, DATATYPE8, SOURCE8, TAG8, COMM8, IERROR8

  COUNT8 = COUNT
  DATATYPE8 = DATATYPE
  SOURCE8 = SOURCE
  TAG8 = TAG
  COMM8 = COMM

  CALL MPI_RECV(DATA, COUNT8, DATATYPE8, SOURCE8, TAG8, COMM8, STATUS8, IERROR8)

  STATUS = STATUS8
  IERROR = IERROR8

END SUBROUTINE MPI_RECV8_R82

! ---------------------------------------------------------
SUBROUTINE MPI_RECV8_I4(DATA, COUNT, DATATYPE, SOURCE, TAG, COMM, STATUS, IERROR)

  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COUNT, DATATYPE, SOURCE, TAG, COMM
  INTEGER(KIND=JPIM), DIMENSION(:), INTENT(OUT) :: &
    DATA, STATUS
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    IERROR

  INTEGER(KIND=8), DIMENSION(:), ALLOCATABLE :: &
    DATA8
  INTEGER(KIND=8) :: &
    COUNT8, DATATYPE8, SOURCE8, TAG8, COMM8, IERROR8

  ALLOCATE(DATA8(SIZE(DATA)))

  COUNT8 = COUNT
  DATATYPE8 = DATATYPE
  SOURCE8 = SOURCE
  TAG8 = TAG
  COMM8 = COMM

  CALL MPI_RECV(DATA8, COUNT8, DATATYPE8, SOURCE8, TAG8, COMM8, STATUS8, IERROR8)

  DATA = DATA8
  STATUS = STATUS8
  IERROR = IERROR8

  DEALLOCATE(DATA8)

END SUBROUTINE MPI_RECV8_I4

! ---------------------------------------------------------
SUBROUTINE MPI_RECV8_I1(DATA, COUNT, DATATYPE, SOURCE, TAG, COMM, STATUS, IERROR)

  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COUNT, DATATYPE, SOURCE, TAG, COMM
  INTEGER(KIND=JPIM), DIMENSION(:), INTENT(OUT) :: &
    STATUS
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    DATA, IERROR

  INTEGER(KIND=8) :: &
    DATA8, COUNT8, DATATYPE8, SOURCE8, TAG8, COMM8, IERROR8

  COUNT8 = COUNT
  DATATYPE8 = DATATYPE
  SOURCE8 = SOURCE
  TAG8 = TAG
  COMM8 = COMM

  CALL MPI_RECV(DATA8, COUNT8, DATATYPE8, SOURCE8, TAG8, COMM8, STATUS8, IERROR8)

  DATA = DATA8
  STATUS = STATUS8
  IERROR = IERROR8

END SUBROUTINE MPI_RECV8_I1

! ---------------------------------------------------------
SUBROUTINE MPI_RECV8_R4_1(DATA, COUNT, DATATYPE, SOURCE, TAG, COMM, STATUS, IERROR)

  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COUNT, DATATYPE, SOURCE, TAG, COMM
  INTEGER(KIND=JPIM), DIMENSION(:), INTENT(OUT) :: &
    STATUS
  REAL(KIND=JPRM), INTENT(OUT) :: &
    DATA
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    IERROR

  REAL(KIND=8) :: &
    DATA8
  INTEGER(KIND=8) :: &
    COUNT8, DATATYPE8, SOURCE8, TAG8, COMM8, IERROR8

  COUNT8 = COUNT
  DATATYPE8 = DATATYPE
  SOURCE8 = SOURCE
  TAG8 = TAG
  COMM8 = COMM

  CALL MPI_RECV(DATA8, COUNT8, DATATYPE8, SOURCE8, TAG8, COMM8, STATUS8, IERROR8)

  DATA = DATA8
  STATUS = STATUS8
  IERROR = IERROR8

END SUBROUTINE MPI_RECV8_R4_1

! ---------------------------------------------------------
SUBROUTINE MPI_RECV8_R8_1(DATA, COUNT, DATATYPE, SOURCE, TAG, COMM, STATUS, IERROR)

  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COUNT, DATATYPE, SOURCE, TAG, COMM
  INTEGER(KIND=JPIM), DIMENSION(:), INTENT(OUT) :: &
    STATUS
  REAL(KIND=JPRD), INTENT(OUT) :: &
    DATA
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    IERROR

  INTEGER(KIND=8) :: &
    COUNT8, DATATYPE8, SOURCE8, TAG8, COMM8, IERROR8

  COUNT8 = COUNT
  DATATYPE8 = DATATYPE
  SOURCE8 = SOURCE
  TAG8 = TAG
  COMM8 = COMM

  CALL MPI_RECV(DATA, COUNT8, DATATYPE8, SOURCE8, TAG8, COMM8, STATUS8, IERROR8)

  STATUS = STATUS8
  IERROR = IERROR8

END SUBROUTINE MPI_RECV8_R8_1

! ---------------------------------------------------------
SUBROUTINE MPI_RECV8_CH(DATA, COUNT, DATATYPE, SOURCE, TAG, COMM, STATUS, IERROR)

  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COUNT, DATATYPE, SOURCE, TAG, COMM
  INTEGER(KIND=JPIM), DIMENSION(:), INTENT(OUT) :: &
    STATUS
  CHARACTER(LEN=*), INTENT(OUT) :: &
    DATA
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    IERROR

  INTEGER(KIND=8) :: &
    COUNT8, DATATYPE8, SOURCE8, TAG8, COMM8, IERROR8

  COUNT8 = COUNT
  DATATYPE8 = DATATYPE
  SOURCE8 = SOURCE
  TAG8 = TAG
  COMM8 = COMM

  CALL MPI_RECV(DATA, COUNT8, DATATYPE8, SOURCE8, TAG8, COMM8, STATUS8, IERROR8)

  STATUS = STATUS8
  IERROR = IERROR8

END SUBROUTINE MPI_RECV8_CH

! ---------------------------------------------------------
SUBROUTINE MPI_IRECV8_R4(DATA, COUNT, DATATYPE, SOURCE, TAG, COMM, REQUEST, IERROR)

  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COUNT, DATATYPE, SOURCE, TAG, COMM
  REAL(KIND=JPRM), DIMENSION(:), INTENT(OUT) :: &
    DATA
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    REQUEST, IERROR

  REAL(KIND=8), DIMENSION(:), ALLOCATABLE :: &
    DATA8
  INTEGER(KIND=8) :: &
    COUNT8, DATATYPE8, SOURCE8, TAG8, COMM8, REQUEST8, IERROR8

  ALLOCATE(DATA8(SIZE(DATA)))

  COUNT8 = COUNT
  DATATYPE8 = DATATYPE
  SOURCE8 = SOURCE
  TAG8 = TAG
  COMM8 = COMM

  CALL MPI_IRECV(DATA8, COUNT8, DATATYPE8, SOURCE8, TAG8, COMM8, REQUEST8, IERROR8)

  DATA = DATA8
  REQUEST = REQUEST8
  IERROR = IERROR8

  DEALLOCATE(DATA8)

END SUBROUTINE MPI_IRECV8_R4

! ---------------------------------------------------------
SUBROUTINE MPI_IRECV8_R8(DATA, COUNT, DATATYPE, SOURCE, TAG, COMM, REQUEST, IERROR)

  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COUNT, DATATYPE, SOURCE, TAG, COMM
  REAL(KIND=JPRD), DIMENSION(:), INTENT(OUT) :: &
    DATA
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    REQUEST, IERROR

  INTEGER(KIND=8) :: &
    COUNT8, DATATYPE8, SOURCE8, TAG8, COMM8, REQUEST8, IERROR8

  COUNT8 = COUNT
  DATATYPE8 = DATATYPE
  SOURCE8 = SOURCE
  TAG8 = TAG
  COMM8 = COMM

  CALL MPI_IRECV(DATA, COUNT8, DATATYPE8, SOURCE8, TAG8, COMM8, REQUEST8, IERROR8)

  REQUEST = REQUEST8
  IERROR = IERROR8

END SUBROUTINE MPI_IRECV8_R8

! ---------------------------------------------------------
SUBROUTINE MPI_IRECV8_R42(DATA, COUNT, DATATYPE, SOURCE, TAG, COMM, REQUEST, IERROR)

  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COUNT, DATATYPE, SOURCE, TAG, COMM
  REAL(KIND=JPRM), DIMENSION(:,:), INTENT(OUT) :: &
    DATA
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    REQUEST, IERROR

  REAL(KIND=8), DIMENSION(:,:), ALLOCATABLE :: &
    DATA8
  INTEGER(KIND=8) :: &
    COUNT8, DATATYPE8, SOURCE8, TAG8, COMM8, REQUEST8, IERROR8

  ALLOCATE(DATA8(SIZE(DATA,DIM=1),SIZE(DATA,DIM=2)))

  COUNT8 = COUNT
  DATATYPE8 = DATATYPE
  SOURCE8 = SOURCE
  TAG8 = TAG
  COMM8 = COMM

  CALL MPI_IRECV(DATA8, COUNT8, DATATYPE8, SOURCE8, TAG8, COMM8, REQUEST8, IERROR8)

  DATA = DATA8
  REQUEST = REQUEST8
  IERROR = IERROR8

  DEALLOCATE(DATA8)

END SUBROUTINE MPI_IRECV8_R42

! ---------------------------------------------------------
SUBROUTINE MPI_IRECV8_R82(DATA, COUNT, DATATYPE, SOURCE, TAG, COMM, REQUEST, IERROR)

  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COUNT, DATATYPE, SOURCE, TAG, COMM
  REAL(KIND=JPRD), DIMENSION(:,:), INTENT(OUT) :: &
    DATA
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    REQUEST, IERROR

  INTEGER(KIND=8) :: &
    COUNT8, DATATYPE8, SOURCE8, TAG8, COMM8, REQUEST8, IERROR8

  COUNT8 = COUNT
  DATATYPE8 = DATATYPE
  SOURCE8 = SOURCE
  TAG8 = TAG
  COMM8 = COMM

  CALL MPI_IRECV(DATA, COUNT8, DATATYPE8, SOURCE8, TAG8, COMM8, REQUEST8, IERROR8)

  REQUEST = REQUEST8
  IERROR = IERROR8

END SUBROUTINE MPI_IRECV8_R82

! ---------------------------------------------------------
SUBROUTINE MPI_IRECV8_I4(DATA, COUNT, DATATYPE, SOURCE, TAG, COMM, REQUEST, IERROR)

  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COUNT, DATATYPE, SOURCE, TAG, COMM
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    DATA(:), REQUEST, IERROR

  INTEGER(KIND=8), DIMENSION(:), ALLOCATABLE :: &
    DATA8
  INTEGER(KIND=8) :: &
    COUNT8, DATATYPE8, SOURCE8, TAG8, COMM8, REQUEST8, IERROR8

  ALLOCATE(DATA8(SIZE(DATA)))

  COUNT8 = COUNT
  DATATYPE8 = DATATYPE
  SOURCE8 = SOURCE
  TAG8 = TAG
  COMM8 = COMM

  CALL MPI_IRECV(DATA8, COUNT8, DATATYPE8, SOURCE8, TAG8, COMM8, REQUEST8, IERROR8)

  DATA = DATA8
  REQUEST = REQUEST8
  IERROR = IERROR8

  DEALLOCATE(DATA8)

END SUBROUTINE MPI_IRECV8_I4

! ---------------------------------------------------------
SUBROUTINE MPI_IRECV8_I42(DATA, COUNT, DATATYPE, SOURCE, TAG, COMM, REQUEST, IERROR)

  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COUNT, DATATYPE, SOURCE, TAG, COMM
  INTEGER(KIND=JPIM), DIMENSION(:,:), INTENT(OUT) :: &
    DATA
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    REQUEST, IERROR

  INTEGER(KIND=8), DIMENSION(:,:), ALLOCATABLE :: &
    DATA8
  INTEGER(KIND=8) :: &
    COUNT8, DATATYPE8, SOURCE8, TAG8, COMM8, REQUEST8, IERROR8

  ALLOCATE(DATA8(SIZE(DATA,DIM=1),SIZE(DATA,DIM=2)))

  COUNT8 = COUNT
  DATATYPE8 = DATATYPE
  SOURCE8 = SOURCE
  TAG8 = TAG
  COMM8 = COMM

  CALL MPI_IRECV(DATA8, COUNT8, DATATYPE8, SOURCE8, TAG8, COMM8, REQUEST8, IERROR8)

  DATA = DATA8
  REQUEST = REQUEST8
  IERROR = IERROR8

  DEALLOCATE(DATA8)

END SUBROUTINE MPI_IRECV8_I42

! ---------------------------------------------------------
SUBROUTINE MPI_IRECV8_I1(DATA, COUNT, DATATYPE, SOURCE, TAG, COMM, REQUEST, IERROR)

  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COUNT, DATATYPE, SOURCE, TAG, COMM
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    DATA, REQUEST, IERROR

  INTEGER(KIND=8) :: &
    DATA8, COUNT8, DATATYPE8, SOURCE8, TAG8, COMM8, REQUEST8, IERROR8

  COUNT8 = COUNT
  DATATYPE8 = DATATYPE
  SOURCE8 = SOURCE
  TAG8 = TAG
  COMM8 = COMM

  CALL MPI_IRECV(DATA8, COUNT8, DATATYPE8, SOURCE8, TAG8, COMM8, REQUEST8, IERROR8)

  DATA = DATA8
  REQUEST = REQUEST8
  IERROR = IERROR8

END SUBROUTINE MPI_IRECV8_I1

! ---------------------------------------------------------
SUBROUTINE MPI_IRECV8_R4_1(DATA, COUNT, DATATYPE, SOURCE, TAG, COMM, REQUEST, IERROR)

  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COUNT, DATATYPE, SOURCE, TAG, COMM
  REAL(KIND=JPRM), INTENT(OUT) :: &
    DATA
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    REQUEST, IERROR

  REAL(KIND=8) :: &
    DATA8
  INTEGER(KIND=8) :: &
    COUNT8, DATATYPE8, SOURCE8, TAG8, COMM8, REQUEST8, IERROR8

  COUNT8 = COUNT
  DATATYPE8 = DATATYPE
  SOURCE8 = SOURCE
  TAG8 = TAG
  COMM8 = COMM

  CALL MPI_IRECV(DATA8, COUNT8, DATATYPE8, SOURCE8, TAG8, COMM8, REQUEST8, IERROR8)

  DATA = DATA8
  REQUEST = REQUEST8
  IERROR = IERROR8

END SUBROUTINE MPI_IRECV8_R4_1

! ---------------------------------------------------------
SUBROUTINE MPI_IRECV8_R8_1(DATA, COUNT, DATATYPE, SOURCE, TAG, COMM, REQUEST, IERROR)

  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COUNT, DATATYPE, SOURCE, TAG, COMM
  REAL(KIND=JPRD), INTENT(OUT) :: &
    DATA
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    REQUEST, IERROR

  INTEGER(KIND=8) :: &
    COUNT8, DATATYPE8, SOURCE8, TAG8, COMM8, REQUEST8, IERROR8

  COUNT8 = COUNT
  DATATYPE8 = DATATYPE
  SOURCE8 = SOURCE
  TAG8 = TAG
  COMM8 = COMM

  CALL MPI_IRECV(DATA, COUNT8, DATATYPE8, SOURCE8, TAG8, COMM8, REQUEST8, IERROR8)

  REQUEST = REQUEST8
  IERROR = IERROR8

END SUBROUTINE MPI_IRECV8_R8_1

! ---------------------------------------------------------
SUBROUTINE MPI_IRECV8_CH(DATA, COUNT, DATATYPE, SOURCE, TAG, COMM, REQUEST, IERROR)

  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COUNT, DATATYPE, SOURCE, TAG, COMM
  CHARACTER(LEN=*), INTENT(OUT) :: &
    DATA
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    REQUEST, IERROR

  INTEGER(KIND=8) :: &
    COUNT8, DATATYPE8, SOURCE8, TAG8, COMM8, REQUEST8, IERROR8

  COUNT8 = COUNT
  DATATYPE8 = DATATYPE
  SOURCE8 = SOURCE
  TAG8 = TAG
  COMM8 = COMM

  CALL MPI_IRECV(DATA, COUNT8, DATATYPE8, SOURCE8, TAG8, COMM8, REQUEST8, IERROR8)

  REQUEST = REQUEST8
  IERROR = IERROR8

END SUBROUTINE MPI_IRECV8_CH

! =========================================================
! ---------------------------------------------------------
SUBROUTINE MPI_SCATTERV8_R8(SENDAREA, SENDCOUNTS, DISPLS, SENDTYPE, &
                            RECVDATA, RECVCOUNT, RECVTYPE, ROOT, COMM, IERROR)
  
  REAL(KIND=JPRD), DIMENSION(:), INTENT(IN) :: &
    SENDAREA
  INTEGER(KIND=JPIM), DIMENSION(:), INTENT(IN) :: &
    SENDCOUNTS, DISPLS
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    SENDTYPE, RECVCOUNT, RECVTYPE, ROOT, COMM
  REAL(KIND=JPRD), DIMENSION(:), INTENT(OUT) :: &
    RECVDATA
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    IERROR

  REAL(KIND=8), DIMENSION(:), ALLOCATABLE :: &
    SENDAREA8, RECVDATA8
  INTEGER(KIND=8), DIMENSION(:), ALLOCATABLE :: &
    SENDCOUNTS8, DISPLS8
  INTEGER(KIND=8) :: &
    SENDTYPE8, RECVCOUNT8, RECVTYPE8, ROOT8, COMM8, IERROR8

  ALLOCATE(SENDAREA8(SIZE(SENDAREA)))
  ALLOCATE(SENDCOUNTS8(SIZE(SENDCOUNTS)))
  ALLOCATE(DISPLS8(SIZE(DISPLS)))
  ALLOCATE(RECVDATA8(SIZE(RECVDATA)))

  SENDAREA8 = SENDAREA
  SENDCOUNTS8 = SENDCOUNTS
  DISPLS8 = DISPLS
  SENDTYPE8 = SENDTYPE
  RECVCOUNT8 = RECVCOUNT
  RECVTYPE8 = RECVTYPE
  ROOT8 = ROOT
  COMM8 = COMM

  CALL MPI_SCATTERV(SENDAREA8, SENDCOUNTS8, DISPLS8, SENDTYPE8, &
                    RECVDATA8, RECVCOUNT8, RECVTYPE8, ROOT8, COMM8, IERROR8)

  RECVDATA = RECVDATA8
  IERROR = IERROR8

  DEALLOCATE(SENDAREA8)
  DEALLOCATE(SENDCOUNTS8)
  DEALLOCATE(DISPLS8)
  DEALLOCATE(RECVDATA8)

END SUBROUTINE MPI_SCATTERV8_R8

! ---------------------------------------------------------
SUBROUTINE MPI_SCATTERV8_R8S(SENDAREA, SENDCOUNTS, DISPLS, SENDTYPE, &
                            RECVDATA, RECVCOUNT, RECVTYPE, ROOT, COMM, IERROR)
  
  REAL(KIND=JPRD), INTENT(IN) :: &
    SENDAREA
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    SENDTYPE, RECVCOUNT, RECVTYPE, ROOT, COMM, SENDCOUNTS, DISPLS
  REAL(KIND=JPRD), DIMENSION(:), INTENT(OUT) :: &
    RECVDATA
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    IERROR

  REAL(KIND=8), DIMENSION(:), ALLOCATABLE :: &
    RECVDATA8
  REAL(KIND=8) :: &
    SENDAREA8
  INTEGER(KIND=8) :: &
    SENDCOUNTS8, DISPLS8
  INTEGER(KIND=8) :: &
    SENDTYPE8, RECVCOUNT8, RECVTYPE8, ROOT8, COMM8, IERROR8

  ALLOCATE(RECVDATA8(SIZE(RECVDATA)))

  SENDAREA8 = SENDAREA
  SENDCOUNTS8 = SENDCOUNTS
  DISPLS8 = DISPLS
  SENDTYPE8 = SENDTYPE
  RECVCOUNT8 = RECVCOUNT
  RECVTYPE8 = RECVTYPE
  ROOT8 = ROOT
  COMM8 = COMM

  CALL MPI_SCATTERV(SENDAREA8, SENDCOUNTS8, DISPLS8, SENDTYPE8, &
                    RECVDATA8, RECVCOUNT8, RECVTYPE8, ROOT8, COMM8, IERROR8)

  RECVDATA = RECVDATA8
  IERROR = IERROR8

  DEALLOCATE(RECVDATA8)

END SUBROUTINE MPI_SCATTERV8_R8S

! ---------------------------------------------------------
SUBROUTINE MPI_SCATTERV8_I4(SENDAREA, SENDCOUNTS, DISPLS, SENDTYPE, &
                            RECVDATA, RECVCOUNT, RECVTYPE, ROOT, COMM, IERROR)
  
  INTEGER(KIND=JPIM), DIMENSION(:), INTENT(IN) :: &
    SENDAREA, SENDCOUNTS, DISPLS
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    SENDTYPE, RECVCOUNT, RECVTYPE, ROOT, COMM
  INTEGER(KIND=JPIM), DIMENSION(:), INTENT(OUT) :: &
    RECVDATA
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    IERROR

  INTEGER(KIND=8), DIMENSION(:), ALLOCATABLE :: &
    SENDAREA8, SENDCOUNTS8, DISPLS8, RECVDATA8
  INTEGER(KIND=8) :: &
    SENDTYPE8, RECVCOUNT8, RECVTYPE8, ROOT8, COMM8, IERROR8

  ALLOCATE(SENDAREA8(SIZE(SENDAREA)))
  ALLOCATE(SENDCOUNTS8(SIZE(SENDCOUNTS)))
  ALLOCATE(DISPLS8(SIZE(DISPLS)))
  ALLOCATE(RECVDATA8(SIZE(RECVDATA)))

  SENDAREA8 = SENDAREA
  SENDCOUNTS8 = SENDCOUNTS
  DISPLS8 = DISPLS
  SENDTYPE8 = SENDTYPE
  RECVCOUNT8 = RECVCOUNT
  RECVTYPE8 = RECVTYPE
  ROOT8 = ROOT
  COMM8 = COMM

  CALL MPI_SCATTERV(SENDAREA8, SENDCOUNTS8, DISPLS8, SENDTYPE8, &
                    RECVDATA8, RECVCOUNT8, RECVTYPE8, ROOT8, COMM8, IERROR8)

  RECVDATA = RECVDATA8
  IERROR = IERROR8

  DEALLOCATE(SENDAREA8)
  DEALLOCATE(SENDCOUNTS8)
  DEALLOCATE(DISPLS8)
  DEALLOCATE(RECVDATA8)

END SUBROUTINE MPI_SCATTERV8_I4

! =========================================================
SUBROUTINE MPI_SCATTERV8_I4S(SENDAREA, SENDCOUNTS, DISPLS, SENDTYPE, &
                            RECVDATA, RECVCOUNT, RECVTYPE, ROOT, COMM, IERROR)
  
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    SENDAREA, SENDCOUNTS, DISPLS
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    SENDTYPE, RECVCOUNT, RECVTYPE, ROOT, COMM
  INTEGER(KIND=JPIM), DIMENSION(:), INTENT(OUT) :: &
    RECVDATA
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    IERROR

  INTEGER(KIND=8) :: &
    SENDAREA8, SENDCOUNTS8, DISPLS8
  INTEGER(KIND=8), DIMENSION(:), ALLOCATABLE :: &
    RECVDATA8
  INTEGER(KIND=8) :: &
    SENDTYPE8, RECVCOUNT8, RECVTYPE8, ROOT8, COMM8, IERROR8

  ALLOCATE(RECVDATA8(SIZE(RECVDATA)))

  SENDAREA8 = SENDAREA
  SENDCOUNTS8 = SENDCOUNTS
  DISPLS8 = DISPLS
  SENDTYPE8 = SENDTYPE
  RECVCOUNT8 = RECVCOUNT
  RECVTYPE8 = RECVTYPE
  ROOT8 = ROOT
  COMM8 = COMM

  CALL MPI_SCATTERV(SENDAREA8, SENDCOUNTS8, DISPLS8, SENDTYPE8, &
                    RECVDATA8, RECVCOUNT8, RECVTYPE8, ROOT8, COMM8, IERROR8)

  RECVDATA = RECVDATA8
  IERROR = IERROR8

  DEALLOCATE(RECVDATA8)

END SUBROUTINE MPI_SCATTERV8_I4S

! =========================================================
! =========================================================
! =========================================================

#endif
END MODULE MPI4TO8_M

! (C) Copyright 2005- ECMWF.
! 
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!

SUBROUTINE GETMEMVALS(N, KEY, KVAL)
USE EC_PARKIND  ,ONLY : JPIM, JPIB
IMPLICIT NONE
INTEGER(KIND=JPIM), INTENT(IN) :: N, KEY(N)
INTEGER(KIND=JPIB), INTENT(OUT):: KVAL(N)
!--------------------------------- key ----------------------------------------------
INTEGER(KIND=JPIB), EXTERNAL :: GETHWM    !  1  High Water Mark for HEAP-alloc
INTEGER(KIND=JPIB), EXTERNAL :: GETMAXRSS !  2  Maximum resident memory so far
INTEGER(KIND=JPIB), EXTERNAL :: GETCURHEAP!  3  Instantaneous allocation from ALLOCATE/malloc
INTEGER(KIND=JPIB), EXTERNAL :: GETSTK    !  4  Instantaneous stack usage
INTEGER(KIND=JPIB), EXTERNAL :: GETMAXSTK !  5  Maximum stack usage so far
INTEGER(KIND=JPIB), EXTERNAL :: GETPAG    !  6  I/O caused by paging
! -- add more as required (all 64-bit integers upon return, though) --

INTEGER(KIND=JPIM) J

DO J=1,N
  IF (KEY(J) == 1) THEN
    KVAL(J) = GETHWM()
  ELSE IF (KEY(J) == 2) THEN
    KVAL(J) = GETMAXRSS()
  ELSE IF (KEY(J) == 3) THEN
    KVAL(J) = GETCURHEAP()
  ELSE IF (KEY(J) == 4) THEN
    KVAL(J) = GETSTK()
  ELSE IF (KEY(J) == 5) THEN
    KVAL(J) = GETMAXSTK()
  ELSE IF (KEY(J) == 6) THEN
    KVAL(J) = GETPAG()
  ENDIF
ENDDO

END SUBROUTINE GETMEMVALS

! (C) Copyright 2005- ECMWF.
! (C) Copyright 2013- Meteo-France.
! 
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!

MODULE MPL_MPI
#include "mpif.h"
END MODULE

! (C) Copyright 2005- ECMWF.
! (C) Copyright 2013- Meteo-France.
! 
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!

MODULE MPL_MYRANK_MOD

!**** MPL_MYRANK - Find rank

!     Purpose.
!     --------
!     Returns the rank of the calling process 
!     in the currently active communicator

!**   Interface.
!     ----------
!        IRANK=MPL_MYRANK(KCOMM)

!        Input optional arguments :
!        -------------------------
!           KCOMM    -  Communicator number if different from MPI_COMM_WORLD 

!        Input required arguments :
!        -------------------------

!        Input optional arguments :
!        -------------------------
!           none

!        Output required arguments :
!        -------------------------
!           none

!        Output optional arguments :
!        -------------------------
!           none
!     Author.
!     -------
!        D.Dent, M.Hamrud     ECMWF

!     Modifications.
!     --------------
!        Original: 2000-09-01

!     ------------------------------------------------------------------

USE EC_PARKIND  ,ONLY : JPIM

USE MPL_DATA_MODULE
USE MPL_MESSAGE_MOD

IMPLICIT NONE
PRIVATE
PUBLIC MPL_MYRANK

CONTAINS 

FUNCTION MPL_MYRANK(KCOMM)

#ifdef USE_8_BYTE_WORDS
  USE MPI4TO8, ONLY : &
    MPI_COMM_RANK => MPI_COMM_RANK8
#endif

INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL :: KCOMM
INTEGER(KIND=JPIM) :: MPL_MYRANK

INTEGER(KIND=JPIM) IRANK,IERROR,ICOMM
LOGICAL :: LLABORT=.TRUE.

IF(MPL_NUMPROC < 1) CALL MPL_MESSAGE( &
  & CDMESSAGE='MPL_MYRANK: MPL NOT INITIALISED ',LDABORT=LLABORT) 

IF(PRESENT(KCOMM)) THEN
  CALL MPI_COMM_RANK(KCOMM, IRANK, IERROR)
  IF(IERROR /= 0 ) CALL MPL_MESSAGE(IERROR,&
   &'MPL_MYRANK: ERROR FROM MPI_COMM_RANK')
  MPL_MYRANK=IRANK+1
ELSE
  MPL_MYRANK=MPL_RANK
ENDIF

END FUNCTION MPL_MYRANK

END MODULE MPL_MYRANK_MOD

! (C) Copyright 2005- ECMWF.
!
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
!
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.

program drhook_ex1
use yomhook, only : jphook, dr_hook
implicit none
integer(4), parameter :: n = 100
real(8)    :: a(n)
integer(4) :: j
real(jphook) :: zhook_handle
call dr_hook('drhook_ex1',0,zhook_handle)
do j=1,n
  a(j) = j-1
enddo
call sub1(a,n)
call dr_hook('drhook_ex1',1,zhook_handle)
end program drhook_ex1

subroutine sub1(a,n)
use yomhook, only : jphook, dr_hook
implicit none
integer(4), intent(in) :: n
real(8), intent(inout) :: a(n)
real(jphook) :: zhook_handle
call dr_hook('sub1',0,zhook_handle)
if (n > 0) call sub2(a(1))
call dr_hook('sub1',1,zhook_handle)
end subroutine sub1

subroutine sub2(s)
use yomhook, only : jphook, dr_hook
implicit none
real(8), intent(inout) :: s
real(jphook) :: zhook_handle
call dr_hook('sub2',0,zhook_handle)
write(0,*) s
s = 1._8/s ! divide by zero
call dr_hook('sub2',1,zhook_handle)
end subroutine sub2

! (C) Copyright 2005- ECMWF.
! (C) Copyright 2013- Meteo-France.
! 
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!

#if defined ( _CRAYFTN )
      REAL*8 FUNCTION TIMEF()
      INTEGER*8 I_TIME1,I_RATE
      REAL*8 ZTIMEF,ZFIRST
      DATA IFIRST/0/
      SAVE IFIRST,ZFIRST

!     THIS IS A REAL TIME CLOCK IN MILLISECONDS.
!     USAGE OF FORTRAN90 INTRINSIC FUNCTION.
      CALL SYSTEM_CLOCK (COUNT=I_TIME1,COUNT_RATE=I_RATE)
      ZTIMEF=DFLOAT(I_TIME1)/DFLOAT(I_RATE)

      IF(IFIRST.EQ.0) THEN
         IFIRST=1
         ZFIRST=ZTIMEF
         TIMEF=0.0
      ELSE
         TIMEF=1000.0*(ZTIMEF-ZFIRST)
      ENDIF

      RETURN
      ENDFUNCTION TIMEF

#else

      FUNCTION TIMEF()
!ss: Uses util_walltime_() from DrHook -- 
!    Should now have higher precision (avoiding negative accum. wall-time in ifs.stat (see opdis.F90))
      USE EC_PARKIND, ONLY : JPIM, JPRD
      IMPLICIT NONE
      REAL(KIND=JPRD)           :: TIMEF
      REAL(KIND=JPRD)           :: ZTIMEF
      REAL(KIND=JPRD),SAVE      :: ZFIRST
      INTEGER(KIND=JPIM),SAVE   :: IFIRST = 0
      REAL(KIND=JPRD), EXTERNAL :: UTIL_WALLTIME ! ifsaux/support/drhook.c
      ZTIMEF = UTIL_WALLTIME()
      IF(IFIRST.EQ.0) THEN
         IFIRST=1
         ZFIRST=ZTIMEF
         TIMEF=0.0_JPRD
      ELSE
         TIMEF=1000.0_JPRD * (ZTIMEF-ZFIRST)
      ENDIF
      ENDFUNCTION TIMEF

#endif

! (C) Copyright 2005- ECMWF.
! (C) Copyright 2013- Meteo-France.
! 
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!

MODULE MPL_READ_MOD

!
!     Purpose.  read from an MPIIO file 
!     --------
!
!
!     Interface.
!     ----------
!        call mpl_read(...)
!
!        Explicit arguments :
!        --------------------
!
!        input arguments:
!        kfptr   - handle for file
!        kop     - requested operation 
!        kbuf    - buffer containing data to be written
!        klen    - length of buffer in words
!        input/output arguements:
!        kreq    - request handle for non-blocking operations
!        output arguments:
!        kerror  - error code
!
!        Implicit arguments :
!        --------------------
!
!     Method.
!     -------
!     MPL supports 4 styles of MPIIO
!
!     kop = 1    -  Blocking, non collective, shared file pointer
!                   using MPI_FILE_WRITE_SHARED,
!                         MPI_FILE_READ_SHARED
!     kop = 2    -  Blocking, collective, ordered, shared file pointer
!                   using MPI_FILE_WRITE_ORDERED,
!                         MPI_FILE_READ_ORDERED
!     kop = 3    -  Non Blocking, non collective, shared file pointer
!                   using MPI_FILE_IWRITE_SHARED,
!                         MPI_FILE_IREAD_SHARED
!                   and MPI_WAIT
!     kop = 4    -  Non Blocking, collective, ordered, shared file pointer
!                   using MPI_FILE_WRITE_ORDERED_BEGIN/END,
!                         MPI_FILE_READ_ORDERED_BEGIN/END
!
!     Externals.
!     ----------
!
!     Reference.
!     ----------
!        none yet
!
!     Author.
!     -------
!        G.Mozdzynski
!
!     Modifications.
!     --------------
!        Original : 2000-12-11
!        R. EL Khatib 24-May-2011 Change ifdef MPI2 into ifndef MPI1
!     -----------------------------------------------------------------
!
USE EC_PARKIND  ,ONLY : JPIM, JPRM

USE MPL_MPIF
USE MPL_DATA_MODULE
USE MPL_MESSAGE_MOD
USE MPL_IOINIT_MOD

IMPLICIT NONE

INTERFACE MPL_READ
MODULE PROCEDURE MPL_READ_INT,MPL_READ_REAL8
END INTERFACE

PRIVATE
PUBLIC MPL_READ

CONTAINS

SUBROUTINE MPL_READ_INT(KFPTR,KOP,KBUF,KLEN,KREQ,KERROR)


#ifdef USE_8_BYTE_WORDS
  USE MPI4TO8, ONLY : &
    MPI_FILE_READ_SHARED => MPI_FILE_READ_SHARED8, &
    MPI_FILE_READ_ORDERED => MPI_FILE_READ_ORDERED8, &
    MPI_FILE_IREAD_SHARED => MPI_FILE_IREAD_SHARED8, &
    MPI_FILE_READ_ORDERED_BEGIN => MPI_FILE_READ_ORDERED_BEGIN8, &
    MPI_WAIT => MPI_WAIT8, MPI_FILE_READ_ORDERED_END => MPI_FILE_READ_ORDERED_END8
#endif

INTEGER(KIND=JPIM),INTENT(IN) :: KFPTR,KOP,KLEN
INTEGER(KIND=JPIM),INTENT(OUT) :: KERROR
INTEGER(KIND=JPIM) KBUF(:)
INTEGER(KIND=JPIM) KREQ


INTEGER(KIND=JPIM) STATUS(MPI_STATUS_SIZE)
!
#ifndef MPI1

!     -----------------------------------------------------------------
!
!     1.    Preamble 
!           --------

IF( MPL_RANK > MPL_NUMIO ) THEN
  KERROR = -1
  RETURN
ENDIF

IF( KOP >= 1.AND.KOP <= 4 ) THEN

  IF( KOP /= MPL_IOP ) THEN
    KERROR = -1
    RETURN
  ENDIF

ENDIF
!     -----------------------------------------------------------------
!
!     2.    Check style and take appropriate action 
!           ---------------------------------------


IF( KOP == 1 ) THEN

! blocking read, non collective, shared file pointer
        
  CALL MPI_FILE_READ_SHARED(KFPTR,&
                           & KBUF,&
                           & KLEN,&
                           & MPI_INTEGER,&
                           & STATUS,&
                           & KERROR)

ELSEIF( KOP == 2 ) THEN

! blocking read, collective, ordered with shared file pointer

  CALL MPI_FILE_READ_ORDERED(KFPTR,&
                            & KBUF,&
                            & KLEN,&
                            & MPI_INTEGER,&
                            & STATUS,&
                            & KERROR)

ELSEIF( KOP == 3 ) THEN

! non blocking read, non collective, shared file pointer

  CALL MPI_FILE_IREAD_SHARED(KFPTR,&
                            & KBUF,&
                            & KLEN,&
                            & MPI_INTEGER,&
                            & KREQ,&
                            & KERROR)

ELSEIF( KOP == 4 ) THEN

! non blocking read, collective, ordered with shared file pointer

  CALL MPI_FILE_READ_ORDERED_BEGIN(KFPTR,&
                                  & KBUF,&
                                  & KLEN,&
                                  & MPI_INTEGER,&
                                  & KERROR)

ELSEIF( KOP == 5 ) THEN

  CALL MPI_WAIT(KREQ,&
              & STATUS,&
              & KERROR )

ELSEIF( KOP == 6 ) THEN

  CALL MPI_FILE_READ_ORDERED_END(KFPTR,&
                                & KBUF,&
                                & STATUS,&
                                & KERROR)
 
ELSE

  KERROR =-1
  RETURN

ENDIF

#else

CALL ABOR1('MPL_READ_INT not build with MPI2')

#endif
!
!     -----------------------------------------------------------------
RETURN
END SUBROUTINE MPL_READ_INT

SUBROUTINE MPL_READ_REAL8(KFPTR,KOP,PBUF,KLEN,KREQ,KERROR)


#ifdef USE_8_BYTE_WORDS
  USE MPI4TO8, ONLY : &
    MPI_FILE_READ_SHARED => MPI_FILE_READ_SHARED8, &
    MPI_FILE_READ_ORDERED => MPI_FILE_READ_ORDERED8, &
    MPI_FILE_IREAD_SHARED => MPI_FILE_IREAD_SHARED8, &
    MPI_FILE_READ_ORDERED_BEGIN => MPI_FILE_READ_ORDERED_BEGIN8, &
    MPI_WAIT => MPI_WAIT8, MPI_FILE_READ_ORDERED_END => MPI_FILE_READ_ORDERED_END8
#endif

INTEGER(KIND=JPIM),INTENT(IN) :: KFPTR,KOP,KLEN
INTEGER(KIND=JPIM),INTENT(OUT) :: KERROR
REAL(KIND=JPRM) PBUF(:)
INTEGER(KIND=JPIM) KREQ


INTEGER(KIND=JPIM) STATUS(MPI_STATUS_SIZE)
!
#ifndef MPI1

!     -----------------------------------------------------------------
!
!     1.    Preamble 
!           --------

IF( MPL_RANK > MPL_NUMIO ) THEN
  KERROR = -1
  RETURN
ENDIF

IF( KOP >= 1.AND.KOP <= 4 ) THEN

  IF( KOP /= MPL_IOP ) THEN
    KERROR = -1
    RETURN
  ENDIF

ENDIF
!     -----------------------------------------------------------------
!
!     2.    Check style and take appropriate action 
!           ---------------------------------------


IF( KOP == 1 ) THEN

! blocking read, non collective, shared file pointer
        
  CALL MPI_FILE_READ_SHARED(KFPTR,&
                           & PBUF,&
                           & KLEN,&
                           & MPI_REAL8,&
                           & STATUS,&
                           & KERROR)

ELSEIF( KOP == 2 ) THEN

! blocking read, collective, ordered with shared file pointer

  CALL MPI_FILE_READ_ORDERED(KFPTR,&
                            & PBUF,&
                            & KLEN,&
                            & MPI_REAL8,&
                            & STATUS,&
                            & KERROR)

ELSEIF( KOP == 3 ) THEN

! non blocking read, non collective, shared file pointer

  CALL MPI_FILE_IREAD_SHARED(KFPTR,&
                            & PBUF,&
                            & KLEN,&
                            & MPI_REAL8,&
                            & KREQ,&
                            & KERROR)

ELSEIF( KOP == 4 ) THEN

! non blocking read, collective, ordered with shared file pointer

  CALL MPI_FILE_READ_ORDERED_BEGIN(KFPTR,&
                                  & PBUF,&
                                  & KLEN,&
                                  & MPI_REAL8,&
                                  & KERROR)

ELSEIF( KOP == 5 ) THEN

  CALL MPI_WAIT(KREQ,&
              & STATUS,&
              & KERROR )

ELSEIF( KOP == 6 ) THEN

  CALL MPI_FILE_READ_ORDERED_END(KFPTR,&
                                & PBUF,&
                                & STATUS,&
                                & KERROR)
 
ELSE

  KERROR =-1
  RETURN

ENDIF

!
!     -----------------------------------------------------------------
#else

CALL ABOR1('MPL_READ_REAL8 not build with MPI2')

#endif

RETURN
END SUBROUTINE MPL_READ_REAL8

END MODULE MPL_READ_MOD

! (C) Copyright 2005- ECMWF.
! (C) Copyright 2013- Meteo-France.
! 
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!

MODULE MPL_BYTES_MOD

USE EC_PARKIND, ONLY : JPIM, JPIB, JPRM, JPRD

IMPLICIT NONE

PRIVATE

PUBLIC :: MPL_BYTES

INTERFACE MPL_BYTES
MODULE PROCEDURE &
     & MPL_BYTES_IM, MPL_BYTES_IB, &
     & MPL_BYTES_RM, MPL_BYTES_RD
END INTERFACE MPL_BYTES

CONTAINS

! INTEGER*4
FUNCTION MPL_BYTES_IM(KVAR)
INTEGER(KIND=JPIM), INTENT(IN) :: KVAR
INTEGER(KIND=JPIM) MPL_BYTES_IM
MPL_BYTES_IM = SIZE(TRANSFER(KVAR, (/'A'/)))
END FUNCTION MPL_BYTES_IM

! INTEGER*8
FUNCTION MPL_BYTES_IB(KVAR)
INTEGER(KIND=JPIB), INTENT(IN) :: KVAR
INTEGER(KIND=JPIM) MPL_BYTES_IB
MPL_BYTES_IB = SIZE(TRANSFER(KVAR, (/'A'/)))
END FUNCTION MPL_BYTES_IB

! REAL*4
FUNCTION MPL_BYTES_RM(PVAR)
REAL(KIND=JPRM), INTENT(IN) :: PVAR
INTEGER(KIND=JPIM) MPL_BYTES_RM
MPL_BYTES_RM = SIZE(TRANSFER(PVAR, (/'A'/)))
END FUNCTION MPL_BYTES_RM

! REAL*8
FUNCTION MPL_BYTES_RD(PVAR)
REAL(KIND=JPRD), INTENT(IN) :: PVAR
INTEGER(KIND=JPIM) MPL_BYTES_RD
MPL_BYTES_RD = SIZE(TRANSFER(PVAR, (/'A'/)))
END FUNCTION MPL_BYTES_RD

END MODULE MPL_BYTES_MOD

! (C) Copyright 2005- ECMWF.
! 
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!

module ec_env_mod

!**** Interface to ec_env environment handling
!
!     Purpose.
!     --------
!     Fortran 90 Interface to setting and getting environment variables
! 
!     Author.
!     -------
!        W.Deconinck, ECMWF
!
!     Modifications.
!     --------------
!        Original: 2021-05-18
!
!     ------------------------------------------------------------------
implicit none

private
public :: ec_putenv, ec_getenv, ec_setenv, ec_numenv, ec_environ

interface
    !! ISO-C bindings from file ec_env.c
    subroutine ec_putenv_overwrite_bind_c(env,env_len) bind(C)
      use, intrinsic :: iso_c_binding, only : c_int, c_char
      character(kind=c_char),     intent(in) :: env(*)
      integer(kind=c_int), value, intent(in) :: env_len
    end subroutine
    subroutine ec_putenv_nooverwrite_bind_c(env,env_len) bind(C)
      use, intrinsic :: iso_c_binding, only : c_int, c_char
      character(kind=c_char),     intent(in) :: env(*)
      integer(kind=c_int), value, intent(in) :: env_len
    end subroutine
    subroutine ec_getenv_bind_c(key,value,key_len,value_len) bind(C)
      use, intrinsic :: iso_c_binding, only : c_int, c_char
      character(kind=c_char),     intent(in)    :: key(*)
      character(kind=c_char),     intent(inout) :: value(*)
      integer(kind=c_int), value, intent(in)    :: key_len
      integer(kind=c_int), value, intent(in)    :: value_len
    end subroutine
    subroutine ec_numenv_bind_c(value) bind(C)
      use, intrinsic :: iso_c_binding, only : c_int
      integer(kind=c_int), intent(out) :: value
    end subroutine
    subroutine ec_environ_bind_c(i,value,value_len) bind(C)
      use, intrinsic :: iso_c_binding, only : c_int, c_char
      integer(kind=c_int),        intent(in)    :: i
      character(kind=c_char),     intent(inout) :: value(*)
      integer(kind=c_int), value, intent(in)    :: value_len
    end subroutine
end interface

contains

subroutine ec_putenv(env, overwrite)
  !! Set environment. Add optional argument 'OVERWRITE=.false.' to avoid overwriting if already set.
  !! Example:
  !!   call ec_putenv("DR_HOOK=1")                    ! Forces overwrite (default: OVERWRITE=.TRUE.)
  !!   call ec_putenv("DR_HOOK=0",OVERWRITE=.FALSE)   ! Will have no effect as DR_HOOK=1 already exists
  !!
  character(len=*), intent(in) :: env
  logical, optional, intent(in) :: overwrite ! assume true if not present
  if( present(overwrite) ) then
    if( overwrite ) then
      call ec_putenv_overwrite_bind_c(env,len(env))
    else
      call ec_putenv_nooverwrite_bind_c(env,len(env))  
    endif
  else
    call ec_putenv_overwrite_bind_c(env,len(env))
  endif
end subroutine

subroutine ec_setenv(key, value, overwrite)
  !! Set environment, with non-optional 'overwrite' argument which can be used to force or avoid overwriting if already set.
  !! Example:
  !!   call ec_setenv("DR_HOOK","1",OVERWRITE=.TRUE.)   ! Forces overwrite
  !!   call ec_putenv("DR_HOOK","0",OVERWRITE=.FALSE)   ! Will have no effect as DR_HOOK=1 already exists
  !!
  character(len=*), intent(in) :: key
  character(len=*), intent(in) :: value
  logical, intent(in) :: overwrite
  character(len=:), allocatable :: env
  env = trim(key)//'='//trim(value)
  if( overwrite ) then
    call ec_putenv_overwrite_bind_c(env,len(env))
  else
    call ec_putenv_nooverwrite_bind_c(env,len(env))  
  endif
end subroutine

subroutine ec_getenv(key, value)
  !! Get environment variable by key. If key is not available, value argument will be filled with spaces.
  !! Example:
  !!   CHARACTER(len=255) :: CENV_DR_HOOK
  !!   call ec_getenv("DR_HOOK",CENV_DR_HOOK)
  !!
  character(len=*), intent(in) :: key
  character(len=*), intent(inout) :: value
  call ec_getenv_bind_c(key,value,len(key),len(value))
end subroutine

function ec_numenv() result(value)
  !! Return number of environment variables
  !!
  use, intrinsic :: iso_c_binding, only : c_int
  integer(kind=c_int) :: value
  call ec_numenv_bind_c(value)
end function

subroutine ec_environ(i,value)
  !! Set value to entry of the unix "environ" variable with index 1..ec_numenv
  !! The content of value will be of form "KEY=VALUE", as in ec_putenv
  use, intrinsic :: iso_c_binding, only : c_int
  integer(kind=c_int), intent(in) :: i
  character(len=*), intent(inout) :: value
  call ec_environ_bind_c(i,value,len(value))
end subroutine

end module

! (C) Copyright 2005- ECMWF.
! (C) Copyright 2013- Meteo-France.
! 
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!

MODULE MPL_SEND_MOD

!**** MPL_SEND Send a message

!     Purpose.
!     --------
!     Send a message to a named source from a buffer.
!     The data may be REAL*4, REAL*8,or INTEGER, one dimensional array
!                     REAL*4,or REAL*8, two dimensional array
!                  or INTEGER scalar

!**   Interface.
!     ----------
!        CALL MPL_SEND

!        Input required arguments :
!        -------------------------
!           PBUF     -  buffer containing message
!                       (can be type REAL*4, REAL*8 or INTEGER)
!           KTAG     -  message tag
!           KDEST    -  rank of process to receive the message

!        Input optional arguments :
!        -------------------------
!           KCOMM    -  Communicator number if different from MPI_COMM_WORLD 
!                       or from that established as the default 
!                       by an MPL communicator routine
!           KMP_TYPE -  buffering type (see MPL_BUFFER_METHOD)
!                       overrides value provided to MPL_BUFFER_METHOD
!           CDSTRING -  Character string for ABORT messages
!                       used when KERROR is not provided

!        Output required arguments :
!        -------------------------
!           none

!        Output optional arguments :
!        -------------------------
!           KREQUEST -  Communication request
!                       required when buffering type is non-blocking
!           KERROR   -  return error code.     If not supplied, 
!                       MPL_SEND aborts when an error is detected.
!     Author.
!     -------
!        D.Dent, M.Hamrud     ECMWF

!     Modifications.
!     --------------
!        Original: 2000-09-01
!        P. Marguinaud : 01-Jan-2011 : Do not raise an error when
!                        the numproc is beyond model limits and KCOMM is passed
!                        as argument
!      F. Vana  05-Mar-2015  Support for single precision
!     ------------------------------------------------------------------

USE EC_PARKIND , ONLY : JPRD, JPIM, JPIB, JPRM
USE OML_MOD   ,ONLY : OML_MY_THREAD

USE MPL_MPIF
USE MPL_DATA_MODULE
USE MPL_MESSAGE_MOD
USE MPL_NPROC_MOD
USE MPL_STATS_MOD
USE YOMMPLSTATS

IMPLICIT NONE

PRIVATE

!---Moved into subroutines to keep threadsafe----
! INTEGER(KIND=JPIM) :: ICOUNT,IMP_TYPE,ICOMM,IERROR
! LOGICAL :: LLABORT=.TRUE.

INTERFACE MPL_SEND
MODULE PROCEDURE MPL_SEND_REAL4, MPL_SEND_REAL8,&
               & MPL_SEND_INT,   MPL_SEND_REAL42, MPL_SEND_REAL43, &
               & MPL_SEND_REAL82,MPL_SEND_REAL83, MPL_SEND_INT_SCALAR, &
               & MPL_SEND_INT2,  MPL_SEND_CHAR_SCALAR, &
               & MPL_SEND_REAL4_SCALAR, MPL_SEND_REAL8_SCALAR, &
               & MPL_SEND_INT8,  MPL_SEND_CHAR
END INTERFACE

PUBLIC MPL_SEND

CONTAINS

SUBROUTINE MPL_SEND_REAL4(PBUF,KDEST,KTAG,KCOMM,KMP_TYPE,KERROR,KREQUEST,CDSTRING)


#ifdef USE_8_BYTE_WORDS
  USE MPI4TO8, ONLY : &
    MPI_SEND => MPI_SEND8, MPI_BSEND => MPI_BSEND8, MPI_ISEND => MPI_ISEND8
#endif


! real_m,intent(in) :: PBUF(:)
REAL(KIND=JPRM)            :: PBUF(:)
INTEGER(KIND=JPIM),INTENT(IN) :: KDEST,KTAG
INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL :: KCOMM,KMP_TYPE
INTEGER(KIND=JPIM),INTENT(OUT),OPTIONAL :: KREQUEST,KERROR
CHARACTER(LEN=*),INTENT(IN),OPTIONAL :: CDSTRING

INTEGER(KIND=JPIM) :: ICOUNT,IMP_TYPE,ICOMM,IERROR
LOGICAL :: LLABORT=.TRUE.
INTEGER(KIND=JPIM) :: ITID
REAL(KIND=JPRM)    :: ZDUM(1:0)
ITID = OML_MY_THREAD()

IF(MPL_NUMPROC < 1) CALL MPL_MESSAGE( &
  & CDMESSAGE='MPL_SEND: MPL NOT INITIALISED ',LDABORT=LLABORT) 
  
IF(PRESENT(KMP_TYPE)) THEN
  IMP_TYPE=KMP_TYPE
ELSE
  IMP_TYPE=MPL_METHOD
ENDIF
IF(PRESENT(KCOMM)) THEN
  ICOMM=KCOMM
ELSE
  ICOMM=MPL_COMM_OML(ITID)
ENDIF
IF((KDEST < 1 .OR. KDEST >MPL_NPROC(ICOMM)) .AND. (.NOT. PRESENT (KCOMM))) THEN
  WRITE(MPL_ERRUNIT,*)'MPL_SEND: ERROR KDEST=',KDEST
  CALL MPL_MESSAGE(CDMESSAGE='MPL_SEND:ILLEGAL KDEST ',LDABORT=LLABORT)
ENDIF

ICOUNT = SIZE(PBUF)
#ifndef NAG
IF (ICOUNT > 0) THEN
  IF( (LOC(PBUF(UBOUND(PBUF,1))) - LOC(PBUF(LBOUND(PBUF,1)))) /= 4_JPIB*(ICOUNT - 1) ) THEN
    CALL MPL_MESSAGE(CDMESSAGE='MPL_SEND: BUFFER NOT CONTIGUOUS ',LDABORT=LLABORT)
  ENDIF
ENDIF
#endif

IF(LMPLSTATS) THEN
  CALL MPL_SENDSTATS(ICOUNT,INT(MPI_REAL4))
ENDIF

IF (ICOUNT == 0) THEN
  IF(IMP_TYPE == JP_BLOCKING_STANDARD) THEN
    CALL MPI_SEND(ZDUM,ICOUNT,INT(MPI_REAL4),KDEST-1,KTAG,ICOMM,IERROR)
  ELSE IF(IMP_TYPE == JP_BLOCKING_BUFFERED) THEN
    CALL MPI_BSEND(ZDUM,ICOUNT,INT(MPI_REAL4),KDEST-1,KTAG,ICOMM,IERROR)
  ELSE IF(IMP_TYPE == JP_NON_BLOCKING_STANDARD) THEN
    CALL MPI_ISEND(ZDUM,ICOUNT,INT(MPI_REAL4),KDEST-1,KTAG,ICOMM, &
      & KREQUEST,IERROR)
  ELSE IF(IMP_TYPE == JP_NON_BLOCKING_BUFFERED) THEN
    CALL MPI_IBSEND(ZDUM,ICOUNT,INT(MPI_REAL4),KDEST-1,KTAG,ICOMM, &
      & KREQUEST,IERROR)
  ELSE IF(IMP_TYPE == JP_BLOCKING_SYNCHRONOUS) THEN
    CALL MPI_SSEND(ZDUM,ICOUNT,INT(MPI_REAL4),KDEST-1,KTAG,ICOMM,IERROR)
  ELSE
    IF(PRESENT(KERROR)) THEN
      KERROR=1
    ELSE
      CALL MPL_MESSAGE(KERROR,'MPL_SEND',' INVALID METHOD',LDABORT=LLABORT)
    ENDIF
  ENDIF
ELSE
  IF(IMP_TYPE == JP_BLOCKING_STANDARD) THEN
    CALL MPI_SEND(PBUF(1),ICOUNT,INT(MPI_REAL4),KDEST-1,KTAG,ICOMM,IERROR)
  ELSE IF(IMP_TYPE == JP_BLOCKING_BUFFERED) THEN
    CALL MPI_BSEND(PBUF(1),ICOUNT,INT(MPI_REAL4),KDEST-1,KTAG,ICOMM,IERROR)
  ELSE IF(IMP_TYPE == JP_NON_BLOCKING_STANDARD) THEN
    CALL MPI_ISEND(PBUF(1),ICOUNT,INT(MPI_REAL4),KDEST-1,KTAG,ICOMM, &
      & KREQUEST,IERROR)
  ELSE IF(IMP_TYPE == JP_NON_BLOCKING_BUFFERED) THEN
    CALL MPI_IBSEND(PBUF(1),ICOUNT,INT(MPI_REAL4),KDEST-1,KTAG,ICOMM, &
      & KREQUEST,IERROR)
  ELSE IF(IMP_TYPE == JP_BLOCKING_SYNCHRONOUS) THEN
    CALL MPI_SSEND(PBUF(1),ICOUNT,INT(MPI_REAL4),KDEST-1,KTAG,ICOMM,IERROR)
  ELSE
    IF(PRESENT(KERROR)) THEN
      KERROR=1
    ELSE
      CALL MPL_MESSAGE(KERROR,'MPL_SEND',' INVALID METHOD',LDABORT=LLABORT)
    ENDIF
  ENDIF
ENDIF
IF(MPL_OUTPUT > 1 )THEN
  WRITE(MPL_UNIT,'(A,5I8)') ' MPL_SEND ',ICOUNT,IMP_TYPE,KDEST,KTAG,ICOMM
ENDIF
IF(PRESENT(KERROR)) THEN
  KERROR=IERROR
ELSE
  IF(IERROR /= 0 ) CALL MPL_MESSAGE(IERROR,'MPL_SEND',CDSTRING,LDABORT=LLABORT)
ENDIF

END SUBROUTINE MPL_SEND_REAL4  

SUBROUTINE MPL_SEND_REAL8(PBUF,KDEST,KTAG,KCOMM,KMP_TYPE,KERROR,KREQUEST,CDSTRING)

#ifdef USE_8_BYTE_WORDS
  USE MPI4TO8, ONLY : &
    MPI_SEND => MPI_SEND8, MPI_BSEND => MPI_BSEND8, MPI_ISEND => MPI_ISEND8
#endif

! real_b,intent(in) :: PBUF(:)
REAL(KIND=JPRD)            :: PBUF(:)
INTEGER(KIND=JPIM),INTENT(IN) :: KDEST,KTAG
INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL :: KCOMM,KMP_TYPE
INTEGER(KIND=JPIM),INTENT(OUT),OPTIONAL :: KREQUEST,KERROR
CHARACTER(LEN=*),INTENT(IN),OPTIONAL :: CDSTRING


INTEGER(KIND=JPIM) :: ICOUNT,IMP_TYPE,ICOMM,IERROR
LOGICAL :: LLABORT=.TRUE.
INTEGER(KIND=JPIM) :: ITID
REAL(KIND=JPRD)    :: ZDUM(1:0)
ITID = OML_MY_THREAD()

IF(MPL_NUMPROC < 1) CALL MPL_MESSAGE( &
  & CDMESSAGE='MPL_SEND: MPL NOT INITIALISED ',LDABORT=LLABORT) 

IF(PRESENT(KMP_TYPE)) THEN
  IMP_TYPE=KMP_TYPE
ELSE
  IMP_TYPE=MPL_METHOD
ENDIF
IF(PRESENT(KCOMM)) THEN
  ICOMM=KCOMM
ELSE
  ICOMM=MPL_COMM_OML(ITID)
ENDIF
IF((KDEST < 1 .OR. KDEST >MPL_NPROC(ICOMM)) .AND. (.NOT. PRESENT (KCOMM))) THEN
  WRITE(MPL_ERRUNIT,*)'MPL_SEND: ERROR KDEST=',KDEST
  CALL MPL_MESSAGE(CDMESSAGE='MPL_SEND:ILLEGAL KDEST ',LDABORT=LLABORT)
ENDIF

ICOUNT = SIZE(PBUF)
#ifndef NAG
IF (ICOUNT > 0) THEN
  IF( (LOC(PBUF(UBOUND(PBUF,1))) - LOC(PBUF(LBOUND(PBUF,1)))) /= 8_JPIB*(ICOUNT - 1) ) THEN
    CALL MPL_MESSAGE(CDMESSAGE='MPL_SEND: BUFFER NOT CONTIGUOUS ',LDABORT=LLABORT)
  ENDIF
ENDIF
#endif

IF(LMPLSTATS) THEN
  CALL MPL_SENDSTATS(ICOUNT,INT(MPI_REAL8))
ENDIF

IF (ICOUNT == 0) THEN
  IF(IMP_TYPE == JP_BLOCKING_STANDARD) THEN
    CALL MPI_SEND(ZDUM,ICOUNT,INT(MPI_REAL8),KDEST-1,KTAG,ICOMM,IERROR)
  ELSE IF(IMP_TYPE == JP_BLOCKING_BUFFERED) THEN
    CALL MPI_BSEND(ZDUM,ICOUNT,INT(MPI_REAL8),KDEST-1,KTAG,ICOMM,IERROR)
  ELSE IF(IMP_TYPE == JP_NON_BLOCKING_STANDARD) THEN
    CALL MPI_ISEND(ZDUM,ICOUNT,INT(MPI_REAL8),KDEST-1,KTAG,ICOMM, &
      & KREQUEST,IERROR)
  ELSE IF(IMP_TYPE == JP_NON_BLOCKING_BUFFERED) THEN
    CALL MPI_IBSEND(ZDUM,ICOUNT,INT(MPI_REAL8),KDEST-1,KTAG,ICOMM, &
      & KREQUEST,IERROR)
  ELSE IF(IMP_TYPE == JP_BLOCKING_SYNCHRONOUS) THEN
    CALL MPI_SSEND(ZDUM,ICOUNT,INT(MPI_REAL8),KDEST-1,KTAG,ICOMM,IERROR)
  ELSE
    IF(PRESENT(KERROR)) THEN
      KERROR=1
    ELSE
      CALL MPL_MESSAGE(KERROR,'MPL_SEND',' INVALID METHOD',LDABORT=LLABORT)
    ENDIF
  ENDIF
ELSE
  IF(IMP_TYPE == JP_BLOCKING_STANDARD) THEN
    CALL MPI_SEND(PBUF(1),ICOUNT,INT(MPI_REAL8),KDEST-1,KTAG,ICOMM,IERROR)
  ELSE IF(IMP_TYPE == JP_BLOCKING_BUFFERED) THEN
    CALL MPI_BSEND(PBUF(1),ICOUNT,INT(MPI_REAL8),KDEST-1,KTAG,ICOMM,IERROR)
  ELSE IF(IMP_TYPE == JP_NON_BLOCKING_STANDARD) THEN
    CALL MPI_ISEND(PBUF(1),ICOUNT,INT(MPI_REAL8),KDEST-1,KTAG,ICOMM, &
      & KREQUEST,IERROR)
  ELSE IF(IMP_TYPE == JP_NON_BLOCKING_BUFFERED) THEN
    CALL MPI_IBSEND(PBUF(1),ICOUNT,INT(MPI_REAL8),KDEST-1,KTAG,ICOMM, &
      & KREQUEST,IERROR)
  ELSE IF(IMP_TYPE == JP_BLOCKING_SYNCHRONOUS) THEN
    CALL MPI_SSEND(PBUF(1),ICOUNT,INT(MPI_REAL8),KDEST-1,KTAG,ICOMM,IERROR)
  ELSE
    IF(PRESENT(KERROR)) THEN
      KERROR=1
    ELSE
      CALL MPL_MESSAGE(KERROR,'MPL_SEND',' INVALID METHOD',LDABORT=LLABORT)
    ENDIF
  ENDIF
ENDIF
IF(MPL_OUTPUT > 1 )THEN
  WRITE(MPL_UNIT,'(A,5I8)') ' MPL_SEND ',ICOUNT,IMP_TYPE,KDEST,KTAG,ICOMM
ENDIF
IF(PRESENT(KERROR)) THEN
  KERROR=IERROR
ELSE
  IF(IERROR /= 0 ) CALL MPL_MESSAGE(IERROR,'MPL_SEND',CDSTRING,LDABORT=LLABORT)
ENDIF

END SUBROUTINE MPL_SEND_REAL8

SUBROUTINE MPL_SEND_INT(KBUF,KDEST,KTAG,KCOMM,KMP_TYPE,KERROR,KREQUEST,CDSTRING)

#ifdef USE_8_BYTE_WORDS
  USE MPI4TO8, ONLY : &
    MPI_SEND => MPI_SEND8, MPI_BSEND => MPI_BSEND8, MPI_ISEND => MPI_ISEND8
#endif

INTEGER(KIND=JPIM)           :: KBUF(:)
INTEGER(KIND=JPIM),INTENT(IN) :: KDEST,KTAG
INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL :: KCOMM,KMP_TYPE
INTEGER(KIND=JPIM),INTENT(OUT),OPTIONAL :: KREQUEST,KERROR
CHARACTER(LEN=*),INTENT(IN),OPTIONAL :: CDSTRING

INTEGER(KIND=JPIM) :: ICOUNT,IMP_TYPE,ICOMM,IERROR
LOGICAL :: LLABORT=.TRUE.
INTEGER(KIND=JPIM) :: ITID,IDUM(1:0)
ITID = OML_MY_THREAD()

IF(MPL_NUMPROC < 1) CALL MPL_MESSAGE( &
  & CDMESSAGE='MPL_SEND: MPL NOT INITIALISED ',LDABORT=LLABORT) 

IF(PRESENT(KMP_TYPE)) THEN
  IMP_TYPE=KMP_TYPE
ELSE
  IMP_TYPE=MPL_METHOD
ENDIF
IF(PRESENT(KCOMM)) THEN
  ICOMM=KCOMM
ELSE
  ICOMM=MPL_COMM_OML(ITID)
ENDIF
IF((KDEST < 1 .OR. KDEST >MPL_NPROC(ICOMM)) .AND. (.NOT. PRESENT (KCOMM))) THEN
  WRITE(MPL_ERRUNIT,*)'MPL_SEND: ERROR KDEST=',KDEST
  CALL MPL_MESSAGE(CDMESSAGE='MPL_SEND:ILLEGAL KDEST ',LDABORT=LLABORT)
ENDIF

ICOUNT = SIZE(KBUF)
#ifndef NAG
IF (ICOUNT > 0) THEN
  IF( (LOC(KBUF(UBOUND(KBUF,1)))-LOC(KBUF(LBOUND(KBUF,1)))) /= 4_JPIB*(ICOUNT - 1) ) THEN
    CALL MPL_MESSAGE(CDMESSAGE='MPL_SEND: BUFFER NOT CONTIGUOUS ',LDABORT=LLABORT)
  ENDIF
ENDIF
#endif

IF(LMPLSTATS) THEN
  CALL MPL_SENDSTATS(ICOUNT,INT(MPI_INTEGER))
ENDIF

IF (ICOUNT == 0) THEN
 IF(IMP_TYPE == JP_BLOCKING_STANDARD) THEN
    CALL MPI_SEND(IDUM,ICOUNT,INT(MPI_INTEGER),KDEST-1,KTAG,ICOMM,IERROR)
  ELSE IF(IMP_TYPE == JP_BLOCKING_BUFFERED) THEN
    CALL MPI_BSEND(IDUM,ICOUNT,INT(MPI_INTEGER),KDEST-1,KTAG,ICOMM,IERROR)
  ELSE IF(IMP_TYPE == JP_NON_BLOCKING_STANDARD) THEN
    CALL MPI_ISEND(IDUM,ICOUNT,INT(MPI_INTEGER),KDEST-1,KTAG,ICOMM, &
      & KREQUEST,IERROR)
  ELSE IF(IMP_TYPE == JP_NON_BLOCKING_BUFFERED) THEN
    CALL MPI_IBSEND(IDUM,ICOUNT,INT(MPI_INTEGER),KDEST-1,KTAG,ICOMM, &
      & KREQUEST,IERROR)
  ELSE IF(IMP_TYPE == JP_BLOCKING_SYNCHRONOUS) THEN
    CALL MPI_SSEND(IDUM,ICOUNT,INT(MPI_INTEGER),KDEST-1,KTAG,ICOMM,IERROR)
  ELSE
    IF(PRESENT(KERROR)) THEN
      KERROR=1
    ELSE
      CALL MPL_MESSAGE(KERROR,'MPL_SEND',' INVALID METHOD',LDABORT=LLABORT)
    ENDIF
  ENDIF
ELSE
  IF(IMP_TYPE == JP_BLOCKING_STANDARD) THEN
    CALL MPI_SEND(KBUF(1),ICOUNT,INT(MPI_INTEGER),KDEST-1,KTAG,ICOMM,IERROR)
  ELSE IF(IMP_TYPE == JP_BLOCKING_BUFFERED) THEN
    CALL MPI_BSEND(KBUF(1),ICOUNT,INT(MPI_INTEGER),KDEST-1,KTAG,ICOMM,IERROR)
  ELSE IF(IMP_TYPE == JP_NON_BLOCKING_STANDARD) THEN
    CALL MPI_ISEND(KBUF(1),ICOUNT,INT(MPI_INTEGER),KDEST-1,KTAG,ICOMM, &
      & KREQUEST,IERROR)
  ELSE IF(IMP_TYPE == JP_NON_BLOCKING_BUFFERED) THEN
    CALL MPI_IBSEND(KBUF(1),ICOUNT,INT(MPI_INTEGER),KDEST-1,KTAG,ICOMM, &
      & KREQUEST,IERROR)
  ELSE IF(IMP_TYPE == JP_BLOCKING_SYNCHRONOUS) THEN
    CALL MPI_SSEND(KBUF(1),ICOUNT,INT(MPI_INTEGER),KDEST-1,KTAG,ICOMM,IERROR)
  ELSE
    IF(PRESENT(KERROR)) THEN
      KERROR=1
    ELSE
      CALL MPL_MESSAGE(KERROR,'MPL_SEND',' INVALID METHOD',LDABORT=LLABORT)
    ENDIF
  ENDIF
ENDIF
IF(MPL_OUTPUT > 1 )THEN
  WRITE(MPL_UNIT,'(A,5I8)') ' MPL_SEND ',ICOUNT,IMP_TYPE,KDEST,KTAG,ICOMM
ENDIF
IF(PRESENT(KERROR)) THEN
  KERROR=IERROR
ELSE
  IF(IERROR /= 0 ) CALL MPL_MESSAGE(IERROR,'MPL_SEND',CDSTRING,LDABORT=LLABORT)
ENDIF

END SUBROUTINE MPL_SEND_INT

SUBROUTINE MPL_SEND_INT2(KBUF,KDEST,KTAG,KCOMM,KMP_TYPE,KERROR,KREQUEST,CDSTRING)

#ifdef USE_8_BYTE_WORDS
  USE MPI4TO8, ONLY : &
    MPI_SEND => MPI_SEND8, MPI_BSEND => MPI_BSEND8, MPI_ISEND => MPI_ISEND8
#endif

INTEGER(KIND=JPIM)           :: KBUF(:,:)
INTEGER(KIND=JPIM),INTENT(IN) :: KDEST,KTAG
INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL :: KCOMM,KMP_TYPE
INTEGER(KIND=JPIM),INTENT(OUT),OPTIONAL :: KREQUEST,KERROR
CHARACTER(LEN=*),INTENT(IN),OPTIONAL :: CDSTRING

INTEGER(KIND=JPIM) :: ICOUNT,IMP_TYPE,ICOMM,IERROR
LOGICAL :: LLABORT=.TRUE.
INTEGER(KIND=JPIM) :: ITID,IDUM(1:0)
ITID = OML_MY_THREAD()

IF(MPL_NUMPROC < 1) CALL MPL_MESSAGE( &
  & CDMESSAGE='MPL_SEND: MPL NOT INITIALISED ',LDABORT=LLABORT) 

IF(PRESENT(KMP_TYPE)) THEN
  IMP_TYPE=KMP_TYPE
ELSE
  IMP_TYPE=MPL_METHOD
ENDIF
IF(PRESENT(KCOMM)) THEN
  ICOMM=KCOMM
ELSE
  ICOMM=MPL_COMM_OML(ITID)
ENDIF
IF((KDEST < 1 .OR. KDEST >MPL_NPROC(ICOMM)) .AND. (.NOT. PRESENT (KCOMM))) THEN
  WRITE(MPL_ERRUNIT,*)'MPL_SEND: ERROR KDEST=',KDEST
  CALL MPL_MESSAGE(CDMESSAGE='MPL_SEND:ILLEGAL KDEST ',LDABORT=LLABORT)
ENDIF

ICOUNT = SIZE(KBUF)
#ifndef NAG
IF (ICOUNT > 0) THEN
  IF( (LOC(KBUF(UBOUND(KBUF,1),UBOUND(KBUF,2))) - &
     & LOC(KBUF(LBOUND(KBUF,1),LBOUND(KBUF,2)))) /= 4_JPIB*(ICOUNT - 1) ) THEN
    CALL MPL_MESSAGE(CDMESSAGE='MPL_SEND: BUFFER NOT CONTIGUOUS ',LDABORT=LLABORT)
  ENDIF
ENDIF
#endif

IF(LMPLSTATS) THEN
  CALL MPL_SENDSTATS(ICOUNT,INT(MPI_INTEGER))
ENDIF

IF (ICOUNT == 0) THEN
  IF(IMP_TYPE == JP_BLOCKING_STANDARD) THEN
    CALL MPI_SEND(IDUM,ICOUNT,INT(MPI_INTEGER),KDEST-1,KTAG,ICOMM,IERROR)
  ELSE IF(IMP_TYPE == JP_BLOCKING_BUFFERED) THEN
    CALL MPI_BSEND(IDUM,ICOUNT,INT(MPI_INTEGER),KDEST-1,KTAG,ICOMM,IERROR)
  ELSE IF(IMP_TYPE == JP_NON_BLOCKING_STANDARD) THEN
    CALL MPI_ISEND(IDUM,ICOUNT,INT(MPI_INTEGER),KDEST-1,KTAG,ICOMM, &
      & KREQUEST,IERROR)
  ELSE IF(IMP_TYPE == JP_NON_BLOCKING_BUFFERED) THEN
    CALL MPI_IBSEND(IDUM,ICOUNT,INT(MPI_INTEGER),KDEST-1,KTAG,ICOMM, &
      & KREQUEST,IERROR)
  ELSE IF(IMP_TYPE == JP_BLOCKING_SYNCHRONOUS) THEN
    CALL MPI_SSEND(IDUM,ICOUNT,INT(MPI_INTEGER),KDEST-1,KTAG,ICOMM,IERROR)
  ELSE
    IF(PRESENT(KERROR)) THEN
      KERROR=1
    ELSE
      CALL MPL_MESSAGE(KERROR,'MPL_SEND',' INVALID METHOD',LDABORT=LLABORT)
    ENDIF
  ENDIF
ELSE
  IF(IMP_TYPE == JP_BLOCKING_STANDARD) THEN
    CALL MPI_SEND(KBUF(1,1),ICOUNT,INT(MPI_INTEGER),KDEST-1,KTAG,ICOMM,IERROR)
  ELSE IF(IMP_TYPE == JP_BLOCKING_BUFFERED) THEN
    CALL MPI_BSEND(KBUF(1,1),ICOUNT,INT(MPI_INTEGER),KDEST-1,KTAG,ICOMM,IERROR)
  ELSE IF(IMP_TYPE == JP_NON_BLOCKING_STANDARD) THEN
    CALL MPI_ISEND(KBUF(1,1),ICOUNT,INT(MPI_INTEGER),KDEST-1,KTAG,ICOMM, &
      & KREQUEST,IERROR)
  ELSE IF(IMP_TYPE == JP_NON_BLOCKING_BUFFERED) THEN
    CALL MPI_IBSEND(KBUF(1,1),ICOUNT,INT(MPI_INTEGER),KDEST-1,KTAG,ICOMM, &
      & KREQUEST,IERROR)
  ELSE IF(IMP_TYPE == JP_BLOCKING_SYNCHRONOUS) THEN
    CALL MPI_SSEND(KBUF(1,1),ICOUNT,INT(MPI_INTEGER),KDEST-1,KTAG,ICOMM,IERROR)
  ELSE
    IF(PRESENT(KERROR)) THEN
      KERROR=1
    ELSE
      CALL MPL_MESSAGE(KERROR,'MPL_SEND',' INVALID METHOD',LDABORT=LLABORT)
    ENDIF
  ENDIF
ENDIF
IF(MPL_OUTPUT > 1 )THEN
  WRITE(MPL_UNIT,'(A,5I8)') ' MPL_SEND ',ICOUNT,IMP_TYPE,KDEST,KTAG,ICOMM
ENDIF
IF(PRESENT(KERROR)) THEN
  KERROR=IERROR
ELSE
  IF(IERROR /= 0 ) CALL MPL_MESSAGE(IERROR,'MPL_SEND',CDSTRING,LDABORT=LLABORT)
ENDIF

END SUBROUTINE MPL_SEND_INT2

SUBROUTINE MPL_SEND_INT8(KBUF,KDEST,KTAG,KCOMM,KMP_TYPE,KERROR,KREQUEST,CDSTRING)

#ifdef USE_8_BYTE_WORDS
  USE MPI4TO8, ONLY : &
    MPI_SEND => MPI_SEND8, MPI_BSEND => MPI_BSEND8, MPI_ISEND => MPI_ISEND8
#endif

INTEGER(KIND=JPIB)            :: KBUF(:)
INTEGER(KIND=JPIM),INTENT(IN) :: KDEST,KTAG
INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL :: KCOMM,KMP_TYPE
INTEGER(KIND=JPIM),INTENT(OUT),OPTIONAL :: KREQUEST,KERROR
CHARACTER(LEN=*),INTENT(IN),OPTIONAL :: CDSTRING

INTEGER(KIND=JPIM) :: ICOUNT,IMP_TYPE,ICOMM,IERROR
LOGICAL :: LLABORT=.TRUE.
INTEGER(KIND=JPIM) :: ITID
INTEGER(KIND=JPIB) :: IDUM(1:0)
ITID = OML_MY_THREAD()

IF(MPL_NUMPROC < 1) CALL MPL_MESSAGE( &
  & CDMESSAGE='MPL_SEND: MPL NOT INITIALISED ',LDABORT=LLABORT) 

IF(PRESENT(KMP_TYPE)) THEN
  IMP_TYPE=KMP_TYPE
ELSE
  IMP_TYPE=MPL_METHOD
ENDIF
IF(PRESENT(KCOMM)) THEN
  ICOMM=KCOMM
ELSE
  ICOMM=MPL_COMM_OML(ITID)
ENDIF
IF((KDEST < 1 .OR. KDEST >MPL_NPROC(ICOMM)) .AND. (.NOT. PRESENT (KCOMM))) THEN
  WRITE(MPL_ERRUNIT,*)'MPL_SEND: ERROR KDEST=',KDEST
  CALL MPL_MESSAGE(CDMESSAGE='MPL_SEND:ILLEGAL KDEST ',LDABORT=LLABORT)
ENDIF

ICOUNT = SIZE(KBUF)
#ifndef NAG
IF (ICOUNT > 0) THEN
  IF( (LOC(KBUF(UBOUND(KBUF,1))) - LOC(KBUF(LBOUND(KBUF,1)))) /= 8_JPIB*(ICOUNT - 1) ) THEN
    CALL MPL_MESSAGE(CDMESSAGE='MPL_SEND: BUFFER NOT CONTIGUOUS ',LDABORT=LLABORT)
  ENDIF
ENDIF
#endif
IF(LMPLSTATS) THEN
  CALL MPL_SENDSTATS(ICOUNT,INT(MPI_INTEGER8))
ENDIF

IF (ICOUNT == 0) THEN
  IF(IMP_TYPE == JP_BLOCKING_STANDARD) THEN
    CALL MPI_SEND(IDUM,ICOUNT,INT(MPI_INTEGER8),KDEST-1,KTAG,ICOMM,IERROR)
  ELSE IF(IMP_TYPE == JP_BLOCKING_BUFFERED) THEN
    CALL MPI_BSEND(IDUM,ICOUNT,INT(MPI_INTEGER8),KDEST-1,KTAG,ICOMM,IERROR)
  ELSE IF(IMP_TYPE == JP_NON_BLOCKING_STANDARD) THEN
    CALL MPI_ISEND(IDUM,ICOUNT,INT(MPI_INTEGER8),KDEST-1,KTAG,ICOMM, &
      & KREQUEST,IERROR)
  ELSE IF(IMP_TYPE == JP_NON_BLOCKING_BUFFERED) THEN
    CALL MPI_IBSEND(IDUM,ICOUNT,INT(MPI_INTEGER8),KDEST-1,KTAG,ICOMM, &
      & KREQUEST,IERROR)
  ELSE IF(IMP_TYPE == JP_BLOCKING_SYNCHRONOUS) THEN
    CALL MPI_SSEND(IDUM,ICOUNT,INT(MPI_INTEGER8),KDEST-1,KTAG,ICOMM,IERROR)
  ELSE
    IF(PRESENT(KERROR)) THEN
      KERROR=1
    ELSE
      CALL MPL_MESSAGE(KERROR,'MPL_SEND',' INVALID METHOD',LDABORT=LLABORT)
    ENDIF
  ENDIF
ELSE
  IF(IMP_TYPE == JP_BLOCKING_STANDARD) THEN
    CALL MPI_SEND(KBUF(1),ICOUNT,INT(MPI_INTEGER8),KDEST-1,KTAG,ICOMM,IERROR)
  ELSE IF(IMP_TYPE == JP_BLOCKING_BUFFERED) THEN
    CALL MPI_BSEND(KBUF(1),ICOUNT,INT(MPI_INTEGER8),KDEST-1,KTAG,ICOMM,IERROR)
  ELSE IF(IMP_TYPE == JP_NON_BLOCKING_STANDARD) THEN
    CALL MPI_ISEND(KBUF(1),ICOUNT,INT(MPI_INTEGER8),KDEST-1,KTAG,ICOMM, &
      & KREQUEST,IERROR)
  ELSE IF(IMP_TYPE == JP_NON_BLOCKING_BUFFERED) THEN
    CALL MPI_IBSEND(KBUF(1),ICOUNT,INT(MPI_INTEGER8),KDEST-1,KTAG,ICOMM, &
      & KREQUEST,IERROR)
  ELSE IF(IMP_TYPE == JP_BLOCKING_SYNCHRONOUS) THEN
    CALL MPI_SSEND(KBUF(1),ICOUNT,INT(MPI_INTEGER8),KDEST-1,KTAG,ICOMM,IERROR)
  ELSE
    IF(PRESENT(KERROR)) THEN
      KERROR=1
    ELSE
      CALL MPL_MESSAGE(KERROR,'MPL_SEND',' INVALID METHOD',LDABORT=LLABORT)
    ENDIF
  ENDIF
ENDIF
IF(MPL_OUTPUT > 1 )THEN
  WRITE(MPL_UNIT,'(A,5I8)') ' MPL_SEND ',ICOUNT,IMP_TYPE,KDEST,KTAG,ICOMM
ENDIF
IF(PRESENT(KERROR)) THEN
  KERROR=IERROR
ELSE
  IF(IERROR /= 0 ) CALL MPL_MESSAGE(IERROR,'MPL_SEND',CDSTRING,LDABORT=LLABORT)
ENDIF

END SUBROUTINE MPL_SEND_INT8

SUBROUTINE MPL_SEND_INT_SCALAR(KINT,KDEST,KTAG,KCOMM,KMP_TYPE,KERROR,KREQUEST,CDSTRING)

#ifdef USE_8_BYTE_WORDS
  USE MPI4TO8, ONLY : &
    MPI_SEND => MPI_SEND8, MPI_BSEND => MPI_BSEND8, MPI_ISEND => MPI_ISEND8
#endif

INTEGER(KIND=JPIM)           :: KINT     
INTEGER(KIND=JPIM),INTENT(IN) :: KDEST,KTAG
INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL :: KCOMM,KMP_TYPE
INTEGER(KIND=JPIM),INTENT(OUT),OPTIONAL :: KREQUEST,KERROR
CHARACTER(LEN=*),INTENT(IN),OPTIONAL :: CDSTRING

INTEGER(KIND=JPIM) :: ICOUNT,IMP_TYPE,ICOMM,IERROR
LOGICAL :: LLABORT=.TRUE.
INTEGER(KIND=JPIM) :: ITID
ITID = OML_MY_THREAD()

IF(MPL_NUMPROC < 1) CALL MPL_MESSAGE( &
  & CDMESSAGE='MPL_SEND: MPL NOT INITIALISED ',LDABORT=LLABORT) 

IF(PRESENT(KMP_TYPE)) THEN
  IMP_TYPE=KMP_TYPE
ELSE
  IMP_TYPE=MPL_METHOD
ENDIF
IF(PRESENT(KCOMM)) THEN
  ICOMM=KCOMM
ELSE
  ICOMM=MPL_COMM_OML(ITID)
ENDIF
IF((KDEST < 1 .OR. KDEST >MPL_NPROC(ICOMM)) .AND. (.NOT. PRESENT (KCOMM))) THEN
  WRITE(MPL_ERRUNIT,*)'MPL_SEND: ERROR KDEST=',KDEST
  CALL MPL_MESSAGE(CDMESSAGE='MPL_SEND:ILLEGAL KDEST ',LDABORT=LLABORT)
ENDIF

ICOUNT = 1

IF(LMPLSTATS) THEN
  CALL MPL_SENDSTATS(ICOUNT,INT(MPI_INTEGER))
ENDIF

IF(IMP_TYPE == JP_BLOCKING_STANDARD) THEN
  CALL MPI_SEND(KINT,ICOUNT,INT(MPI_INTEGER),KDEST-1,KTAG,ICOMM,IERROR)
ELSE IF(IMP_TYPE == JP_BLOCKING_BUFFERED) THEN
  CALL MPI_BSEND(KINT,ICOUNT,INT(MPI_INTEGER),KDEST-1,KTAG,ICOMM,IERROR)
ELSE IF(IMP_TYPE == JP_NON_BLOCKING_STANDARD) THEN
  CALL MPI_ISEND(KINT,ICOUNT,INT(MPI_INTEGER),KDEST-1,KTAG,ICOMM, &
    & KREQUEST,IERROR)
ELSE IF(IMP_TYPE == JP_NON_BLOCKING_BUFFERED) THEN
  CALL MPI_IBSEND(KINT,ICOUNT,INT(MPI_INTEGER),KDEST-1,KTAG,ICOMM, &
    & KREQUEST,IERROR)
ELSE IF(IMP_TYPE == JP_BLOCKING_SYNCHRONOUS) THEN
  CALL MPI_SSEND(KINT,ICOUNT,INT(MPI_INTEGER),KDEST-1,KTAG,ICOMM,IERROR)
ELSE
  IF(PRESENT(KERROR)) THEN
    KERROR=1
  ELSE
    CALL MPL_MESSAGE(KERROR,'MPL_SEND',' INVALID METHOD',LDABORT=LLABORT)
  ENDIF
ENDIF
IF(MPL_OUTPUT > 1 )THEN
  WRITE(MPL_UNIT,'(A,5I8)') ' MPL_SEND ',ICOUNT,IMP_TYPE,KDEST,KTAG,ICOMM
ENDIF
IF(PRESENT(KERROR)) THEN
  KERROR=IERROR
ELSE
  IF(IERROR /= 0 ) CALL MPL_MESSAGE(IERROR,'MPL_SEND',CDSTRING,LDABORT=LLABORT)
ENDIF

END SUBROUTINE MPL_SEND_INT_SCALAR

SUBROUTINE MPL_SEND_REAL42(PBUF,KDEST,KTAG,KCOMM,KMP_TYPE,KERROR,KREQUEST,CDSTRING)

#ifdef USE_8_BYTE_WORDS
  USE MPI4TO8, ONLY : &
    MPI_SEND => MPI_SEND8, MPI_BSEND => MPI_BSEND8, MPI_ISEND => MPI_ISEND8
#endif

! real_m,intent(in) :: PBUF(:,:)
REAL(KIND=JPRM)            :: PBUF(:,:)
INTEGER(KIND=JPIM),INTENT(IN) :: KDEST,KTAG
INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL :: KCOMM,KMP_TYPE
INTEGER(KIND=JPIM),INTENT(OUT),OPTIONAL :: KREQUEST,KERROR
CHARACTER(LEN=*),INTENT(IN),OPTIONAL :: CDSTRING

INTEGER(KIND=JPIM) :: ICOUNT,IMP_TYPE,ICOMM,IERROR
LOGICAL :: LLABORT=.TRUE.
INTEGER(KIND=JPIM) :: ITID
REAL(KIND=JPRM)    :: ZDUM(1:0)
ITID = OML_MY_THREAD()

IF(MPL_NUMPROC < 1) CALL MPL_MESSAGE( &
  & CDMESSAGE='MPL_SEND: MPL NOT INITIALISED ',LDABORT=LLABORT) 

IF(PRESENT(KMP_TYPE)) THEN
  IMP_TYPE=KMP_TYPE
ELSE
  IMP_TYPE=MPL_METHOD
ENDIF
IF(PRESENT(KCOMM)) THEN
  ICOMM=KCOMM
ELSE
  ICOMM=MPL_COMM_OML(ITID)
ENDIF
IF((KDEST < 1 .OR. KDEST >MPL_NPROC(ICOMM)) .AND. (.NOT. PRESENT (KCOMM))) THEN
  WRITE(MPL_ERRUNIT,*)'MPL_SEND: ERROR KDEST=',KDEST
  CALL MPL_MESSAGE(CDMESSAGE='MPL_SEND:ILLEGAL KDEST ',LDABORT=LLABORT)
ENDIF

ICOUNT = SIZE(PBUF)
#ifndef NAG
IF (ICOUNT > 0) THEN
  IF( (LOC(PBUF(UBOUND(PBUF,1),UBOUND(PBUF,2))) - &
     & LOC(PBUF(LBOUND(PBUF,1),LBOUND(PBUF,2)))) /= 4_JPIB*(ICOUNT - 1) ) THEN
    CALL MPL_MESSAGE(CDMESSAGE='MPL_SEND: BUFFER NOT CONTIGUOUS ',LDABORT=LLABORT)
  ENDIF
ENDIF
#endif

IF(LMPLSTATS) THEN
  CALL MPL_SENDSTATS(ICOUNT,INT(MPI_REAL4))
ENDIF

IF (ICOUNT == 0) THEN
  IF(IMP_TYPE == JP_BLOCKING_STANDARD) THEN
    CALL MPI_SEND(ZDUM,ICOUNT,INT(MPI_REAL4),KDEST-1,KTAG,ICOMM,IERROR)
  ELSE IF(IMP_TYPE == JP_BLOCKING_BUFFERED) THEN
    CALL MPI_BSEND(ZDUM,ICOUNT,INT(MPI_REAL4),KDEST-1,KTAG,ICOMM,IERROR)
  ELSE IF(IMP_TYPE == JP_NON_BLOCKING_STANDARD) THEN
    CALL MPI_ISEND(ZDUM,ICOUNT,INT(MPI_REAL4),KDEST-1,KTAG,ICOMM, &
      & KREQUEST,IERROR)
  ELSE IF(IMP_TYPE == JP_NON_BLOCKING_BUFFERED) THEN
    CALL MPI_IBSEND(ZDUM,ICOUNT,INT(MPI_REAL4),KDEST-1,KTAG,ICOMM, &
      & KREQUEST,IERROR)
  ELSE IF(IMP_TYPE == JP_BLOCKING_SYNCHRONOUS) THEN
    CALL MPI_SSEND(ZDUM,ICOUNT,INT(MPI_REAL4),KDEST-1,KTAG,ICOMM,IERROR)
  ELSE
    IF(PRESENT(KERROR)) THEN
      KERROR=1
    ELSE
      CALL MPL_MESSAGE(KERROR,'MPL_SEND',' INVALID METHOD',LDABORT=LLABORT)
    ENDIF
  ENDIF
ELSE
  IF(IMP_TYPE == JP_BLOCKING_STANDARD) THEN
    CALL MPI_SEND(PBUF(1,1),ICOUNT,INT(MPI_REAL4),KDEST-1,KTAG,ICOMM,IERROR)
  ELSE IF(IMP_TYPE == JP_BLOCKING_BUFFERED) THEN
    CALL MPI_BSEND(PBUF(1,1),ICOUNT,INT(MPI_REAL4),KDEST-1,KTAG,ICOMM,IERROR)
  ELSE IF(IMP_TYPE == JP_NON_BLOCKING_STANDARD) THEN
    CALL MPI_ISEND(PBUF(1,1),ICOUNT,INT(MPI_REAL4),KDEST-1,KTAG,ICOMM, &
      & KREQUEST,IERROR)
  ELSE IF(IMP_TYPE == JP_NON_BLOCKING_BUFFERED) THEN
    CALL MPI_IBSEND(PBUF(1,1),ICOUNT,INT(MPI_REAL4),KDEST-1,KTAG,ICOMM, &
      & KREQUEST,IERROR)
  ELSE IF(IMP_TYPE == JP_BLOCKING_SYNCHRONOUS) THEN
    CALL MPI_SSEND(PBUF(1,1),ICOUNT,INT(MPI_REAL4),KDEST-1,KTAG,ICOMM,IERROR)
  ELSE
    IF(PRESENT(KERROR)) THEN
      KERROR=1
    ELSE
      CALL MPL_MESSAGE(KERROR,'MPL_SEND',' INVALID METHOD',LDABORT=LLABORT)
    ENDIF
  ENDIF
ENDIF
IF(MPL_OUTPUT > 1 )THEN
  WRITE(MPL_UNIT,'(A,5I8)') ' MPL_SEND ',ICOUNT,IMP_TYPE,KDEST,KTAG,ICOMM
ENDIF
IF(PRESENT(KERROR)) THEN
  KERROR=IERROR
ELSE
  IF(IERROR /= 0 ) CALL MPL_MESSAGE(IERROR,'MPL_SEND',CDSTRING,LDABORT=LLABORT)
ENDIF

END SUBROUTINE MPL_SEND_REAL42  

SUBROUTINE MPL_SEND_REAL43(PBUF,KDEST,KTAG,KCOMM,KMP_TYPE,KERROR,KREQUEST,CDSTRING)

#ifdef USE_8_BYTE_WORDS
  USE MPI4TO8, ONLY : &
    MPI_SEND => MPI_SEND8, MPI_BSEND => MPI_BSEND8, MPI_ISEND => MPI_ISEND8
#endif

! real_b,intent(in) :: PBUF(:,:,:)
REAL(KIND=JPRM)            :: PBUF(:,:,:)
INTEGER(KIND=JPIM),INTENT(IN) :: KDEST,KTAG
INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL :: KCOMM,KMP_TYPE
INTEGER(KIND=JPIM),INTENT(OUT),OPTIONAL :: KREQUEST,KERROR
CHARACTER(LEN=*),INTENT(IN),OPTIONAL :: CDSTRING

INTEGER(KIND=JPIM) :: ICOUNT,IMP_TYPE,ICOMM,IERROR
LOGICAL :: LLABORT=.TRUE.
INTEGER(KIND=JPIM) :: ITID
ITID = OML_MY_THREAD()

IF(MPL_NUMPROC < 1) CALL MPL_MESSAGE( &
  & CDMESSAGE='MPL_SEND: MPL NOT INITIALISED ',LDABORT=LLABORT) 

IF(PRESENT(KMP_TYPE)) THEN
  IMP_TYPE=KMP_TYPE
ELSE
  IMP_TYPE=MPL_METHOD
ENDIF
IF(PRESENT(KCOMM)) THEN
  ICOMM=KCOMM
ELSE
  ICOMM=MPL_COMM_OML(ITID)
ENDIF
IF(KDEST < 1 .OR. KDEST >MPL_NPROC(ICOMM).AND. (.NOT. PRESENT (KCOMM))) THEN
  WRITE(MPL_ERRUNIT,*)'MPL_SEND: ERROR KDEST=',KDEST
  CALL MPL_MESSAGE(CDMESSAGE='MPL_SEND:ILLEGAL KDEST ',LDABORT=LLABORT)
ENDIF

ICOUNT = SIZE(PBUF)

IF(LMPLSTATS) THEN
  CALL MPL_SENDSTATS(ICOUNT,INT(MPI_REAL4))
ENDIF

#ifndef NAG
IF (ICOUNT > 0) THEN
  IF( (LOC(PBUF(UBOUND(PBUF,1),UBOUND(PBUF,2),UBOUND(PBUF,3))) - &
     & LOC(PBUF(LBOUND(PBUF,1),LBOUND(PBUF,2),LBOUND(PBUF,3)))) /= 4_JPIB*(ICOUNT - 1) ) THEN
    CALL MPL_MESSAGE(CDMESSAGE='MPL_SEND: BUFFER NOT CONTIGUOUS ',LDABORT=LLABORT)
  ENDIF
ENDIF
#endif

IF(IMP_TYPE == JP_BLOCKING_STANDARD) THEN
  CALL MPI_SEND(PBUF,ICOUNT,INT(MPI_REAL4),KDEST-1,KTAG,ICOMM,IERROR)
ELSE IF(IMP_TYPE == JP_BLOCKING_BUFFERED) THEN
  CALL MPI_BSEND(PBUF,ICOUNT,INT(MPI_REAL4),KDEST-1,KTAG,ICOMM,IERROR)
ELSE IF(IMP_TYPE == JP_NON_BLOCKING_STANDARD) THEN
  CALL MPI_ISEND(PBUF,ICOUNT,INT(MPI_REAL4),KDEST-1,KTAG,ICOMM, &
    & KREQUEST,IERROR)
ELSE IF(IMP_TYPE == JP_NON_BLOCKING_BUFFERED) THEN
  CALL MPI_IBSEND(PBUF,ICOUNT,INT(MPI_REAL4),KDEST-1,KTAG,ICOMM, &
    & KREQUEST,IERROR)
ELSE IF(IMP_TYPE == JP_BLOCKING_SYNCHRONOUS) THEN
  CALL MPI_SSEND(PBUF,ICOUNT,INT(MPI_REAL4),KDEST-1,KTAG,ICOMM,IERROR)
ELSE
  IF(PRESENT(KERROR)) THEN
    KERROR=1
  ELSE
    CALL MPL_MESSAGE(KERROR,'MPL_SEND',' INVALID METHOD',LDABORT=LLABORT)
  ENDIF
ENDIF
IF(MPL_OUTPUT > 1 )THEN
  WRITE(MPL_UNIT,'(A,5I8)') ' MPL_SEND ',ICOUNT,IMP_TYPE,KDEST,KTAG,ICOMM
ENDIF
IF(PRESENT(KERROR)) THEN
  KERROR=IERROR
ELSE
  IF(IERROR /= 0 ) CALL MPL_MESSAGE(IERROR,'MPL_SEND',CDSTRING,LDABORT=LLABORT)
ENDIF

END SUBROUTINE MPL_SEND_REAL43



SUBROUTINE MPL_SEND_REAL82(PBUF,KDEST,KTAG,KCOMM,KMP_TYPE,KERROR,KREQUEST,CDSTRING)

#ifdef USE_8_BYTE_WORDS
  USE MPI4TO8, ONLY : &
    MPI_SEND => MPI_SEND8, MPI_BSEND => MPI_BSEND8, MPI_ISEND => MPI_ISEND8
#endif

! real_b,intent(in) :: PBUF(:,:)
REAL(KIND=JPRD)            :: PBUF(:,:)
INTEGER(KIND=JPIM),INTENT(IN) :: KDEST,KTAG
INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL :: KCOMM,KMP_TYPE
INTEGER(KIND=JPIM),INTENT(OUT),OPTIONAL :: KREQUEST,KERROR
CHARACTER(LEN=*),INTENT(IN),OPTIONAL :: CDSTRING

INTEGER(KIND=JPIM) :: ICOUNT,IMP_TYPE,ICOMM,IERROR
LOGICAL :: LLABORT=.TRUE.
INTEGER(KIND=JPIM) :: ITID
REAL(KIND=JPRD)    :: ZDUM(1:0)
ITID = OML_MY_THREAD()

IF(MPL_NUMPROC < 1) CALL MPL_MESSAGE( &
  & CDMESSAGE='MPL_SEND: MPL NOT INITIALISED ',LDABORT=LLABORT) 

IF(PRESENT(KMP_TYPE)) THEN
  IMP_TYPE=KMP_TYPE
ELSE
  IMP_TYPE=MPL_METHOD
ENDIF
IF(PRESENT(KCOMM)) THEN
  ICOMM=KCOMM
ELSE
  ICOMM=MPL_COMM_OML(ITID)
ENDIF
IF((KDEST < 1 .OR. KDEST >MPL_NPROC(ICOMM)) .AND. (.NOT. PRESENT (KCOMM))) THEN
  WRITE(MPL_ERRUNIT,*)'MPL_SEND: ERROR KDEST=',KDEST
  CALL MPL_MESSAGE(CDMESSAGE='MPL_SEND:ILLEGAL KDEST ',LDABORT=LLABORT)
ENDIF

ICOUNT = SIZE(PBUF)

IF(LMPLSTATS) THEN
  CALL MPL_SENDSTATS(ICOUNT,INT(MPI_REAL8))
ENDIF

#ifndef NAG
IF (ICOUNT > 0) THEN
  IF( (LOC(PBUF(UBOUND(PBUF,1),UBOUND(PBUF,2))) - &
     & LOC(PBUF(LBOUND(PBUF,1),LBOUND(PBUF,2)))) /= 8_JPIB*(ICOUNT - 1) ) THEN
    CALL MPL_MESSAGE(CDMESSAGE='MPL_SEND: BUFFER NOT CONTIGUOUS ',LDABORT=LLABORT)
  ENDIF
ENDIF
#endif

IF (ICOUNT == 0) THEN
  IF(IMP_TYPE == JP_BLOCKING_STANDARD) THEN
    CALL MPI_SEND(ZDUM,ICOUNT,INT(MPI_REAL8),KDEST-1,KTAG,ICOMM,IERROR)
  ELSE IF(IMP_TYPE == JP_BLOCKING_BUFFERED) THEN
    CALL MPI_BSEND(ZDUM,ICOUNT,INT(MPI_REAL8),KDEST-1,KTAG,ICOMM,IERROR)
  ELSE IF(IMP_TYPE == JP_NON_BLOCKING_STANDARD) THEN
    CALL MPI_ISEND(ZDUM,ICOUNT,INT(MPI_REAL8),KDEST-1,KTAG,ICOMM, &
      & KREQUEST,IERROR)
  ELSE IF(IMP_TYPE == JP_NON_BLOCKING_BUFFERED) THEN
    CALL MPI_IBSEND(ZDUM,ICOUNT,INT(MPI_REAL8),KDEST-1,KTAG,ICOMM, &
      & KREQUEST,IERROR)
  ELSE IF(IMP_TYPE == JP_BLOCKING_SYNCHRONOUS) THEN
    CALL MPI_SSEND(ZDUM,ICOUNT,INT(MPI_REAL8),KDEST-1,KTAG,ICOMM,IERROR)
  ELSE
    IF(PRESENT(KERROR)) THEN
      KERROR=1
    ELSE
      CALL MPL_MESSAGE(KERROR,'MPL_SEND',' INVALID METHOD',LDABORT=LLABORT)
    ENDIF
  ENDIF
ELSE
  IF(IMP_TYPE == JP_BLOCKING_STANDARD) THEN
    CALL MPI_SEND(PBUF(1,1),ICOUNT,INT(MPI_REAL8),KDEST-1,KTAG,ICOMM,IERROR)
  ELSE IF(IMP_TYPE == JP_BLOCKING_BUFFERED) THEN
    CALL MPI_BSEND(PBUF(1,1),ICOUNT,INT(MPI_REAL8),KDEST-1,KTAG,ICOMM,IERROR)
  ELSE IF(IMP_TYPE == JP_NON_BLOCKING_STANDARD) THEN
    CALL MPI_ISEND(PBUF(1,1),ICOUNT,INT(MPI_REAL8),KDEST-1,KTAG,ICOMM, &
      & KREQUEST,IERROR)
  ELSE IF(IMP_TYPE == JP_NON_BLOCKING_BUFFERED) THEN
    CALL MPI_IBSEND(PBUF(1,1),ICOUNT,INT(MPI_REAL8),KDEST-1,KTAG,ICOMM, &
      & KREQUEST,IERROR)
  ELSE IF(IMP_TYPE == JP_BLOCKING_SYNCHRONOUS) THEN
    CALL MPI_SSEND(PBUF(1,1),ICOUNT,INT(MPI_REAL8),KDEST-1,KTAG,ICOMM,IERROR)
  ELSE
    IF(PRESENT(KERROR)) THEN
      KERROR=1
    ELSE
      CALL MPL_MESSAGE(KERROR,'MPL_SEND',' INVALID METHOD',LDABORT=LLABORT)
    ENDIF
  ENDIF
ENDIF
IF(MPL_OUTPUT > 1 )THEN
  WRITE(MPL_UNIT,'(A,5I8)') ' MPL_SEND ',ICOUNT,IMP_TYPE,KDEST,KTAG,ICOMM
ENDIF
IF(PRESENT(KERROR)) THEN
  KERROR=IERROR
ELSE
  IF(IERROR /= 0 ) CALL MPL_MESSAGE(IERROR,'MPL_SEND',CDSTRING,LDABORT=LLABORT)
ENDIF

END SUBROUTINE MPL_SEND_REAL82


SUBROUTINE MPL_SEND_CHAR_SCALAR(CDCHAR,KDEST,KTAG,KCOMM,KMP_TYPE,KERROR,KREQUEST,CDSTRING)

#ifdef USE_8_BYTE_WORDS
  USE MPI4TO8, ONLY : &
    MPI_SEND => MPI_SEND8, MPI_BSEND => MPI_BSEND8, MPI_ISEND => MPI_ISEND8
#endif

CHARACTER(LEN=*) :: CDCHAR
INTEGER(KIND=JPIM),INTENT(IN) :: KDEST,KTAG
INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL :: KCOMM,KMP_TYPE
INTEGER(KIND=JPIM),INTENT(OUT),OPTIONAL :: KREQUEST,KERROR
CHARACTER(LEN=*),INTENT(IN),OPTIONAL :: CDSTRING

INTEGER(KIND=JPIM) :: ICOUNT,IMP_TYPE,ICOMM,IERROR
LOGICAL :: LLABORT=.TRUE.
INTEGER(KIND=JPIM) :: ITID
ITID = OML_MY_THREAD()

IF(MPL_NUMPROC < 1) CALL MPL_MESSAGE( &
  & CDMESSAGE='MPL_SEND: MPL NOT INITIALISED ',LDABORT=LLABORT) 

IF(PRESENT(KMP_TYPE)) THEN
  IMP_TYPE=KMP_TYPE
ELSE
  IMP_TYPE=MPL_METHOD
ENDIF
IF(PRESENT(KCOMM)) THEN
  ICOMM=KCOMM
ELSE
  ICOMM=MPL_COMM_OML(ITID)
ENDIF
IF((KDEST < 1 .OR. KDEST >MPL_NPROC(ICOMM)) .AND. (.NOT. PRESENT (KCOMM))) THEN
  WRITE(MPL_ERRUNIT,*)'MPL_SEND: ERROR KDEST=',KDEST
  CALL MPL_MESSAGE(CDMESSAGE='MPL_SEND:ILLEGAL KDEST ',LDABORT=LLABORT)
ENDIF

ICOUNT = LEN(CDCHAR)

IF(LMPLSTATS) THEN
  CALL MPL_SENDSTATS(ICOUNT,INT(MPI_BYTE))
ENDIF

IF(IMP_TYPE == JP_BLOCKING_STANDARD) THEN
  CALL MPI_SEND(CDCHAR,ICOUNT,INT(MPI_BYTE),KDEST-1,KTAG,ICOMM,IERROR)
ELSE IF(IMP_TYPE == JP_BLOCKING_BUFFERED) THEN
  CALL MPI_BSEND(CDCHAR,ICOUNT,INT(MPI_BYTE),KDEST-1,KTAG,ICOMM,IERROR)
ELSE IF(IMP_TYPE == JP_NON_BLOCKING_STANDARD) THEN
  CALL MPI_ISEND(CDCHAR,ICOUNT,INT(MPI_BYTE),KDEST-1,KTAG,ICOMM, &
    & KREQUEST,IERROR)
ELSE IF(IMP_TYPE == JP_NON_BLOCKING_BUFFERED) THEN
  CALL MPI_IBSEND(CDCHAR,ICOUNT,INT(MPI_BYTE),KDEST-1,KTAG,ICOMM, &
    & KREQUEST,IERROR)
ELSE IF(IMP_TYPE == JP_BLOCKING_SYNCHRONOUS) THEN
  CALL MPI_SSEND(CDCHAR,ICOUNT,INT(MPI_BYTE),KDEST-1,KTAG,ICOMM,IERROR)
ELSE
  IF(PRESENT(KERROR)) THEN
    KERROR=1
  ELSE
    CALL MPL_MESSAGE(KERROR,'MPL_SEND',' INVALID METHOD',LDABORT=LLABORT)
  ENDIF
ENDIF
IF(MPL_OUTPUT > 1 )THEN
  WRITE(MPL_UNIT,'(A,5I8)') ' MPL_SEND ',ICOUNT,IMP_TYPE,KDEST,KTAG,ICOMM
ENDIF
IF(PRESENT(KERROR)) THEN
  KERROR=IERROR
ELSE
  IF(IERROR /= 0 ) CALL MPL_MESSAGE(IERROR,'MPL_SEND',CDSTRING,LDABORT=LLABORT)
ENDIF

END SUBROUTINE MPL_SEND_CHAR_SCALAR

SUBROUTINE MPL_SEND_CHAR(CDCHAR,KDEST,KTAG,KCOMM,KMP_TYPE,KERROR,KREQUEST,CDSTRING)

#ifdef USE_8_BYTE_WORDS
  USE MPI4TO8, ONLY : &
    MPI_SEND => MPI_SEND8, MPI_BSEND => MPI_BSEND8, MPI_ISEND => MPI_ISEND8
#endif

CHARACTER(LEN=*) :: CDCHAR(:)
INTEGER(KIND=JPIM),INTENT(IN) :: KDEST,KTAG
INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL :: KCOMM,KMP_TYPE
INTEGER(KIND=JPIM),INTENT(OUT),OPTIONAL :: KREQUEST,KERROR
CHARACTER(LEN=*),INTENT(IN),OPTIONAL :: CDSTRING

INTEGER(KIND=JPIM) :: ICOUNT,IMP_TYPE,ICOMM,IERROR
LOGICAL :: LLABORT=.TRUE.
INTEGER(KIND=JPIM) :: ITID
ITID = OML_MY_THREAD()

IF(MPL_NUMPROC < 1) CALL MPL_MESSAGE( &
  & CDMESSAGE='MPL_SEND: MPL NOT INITIALISED ',LDABORT=LLABORT) 

IF(PRESENT(KMP_TYPE)) THEN
  IMP_TYPE=KMP_TYPE
ELSE
  IMP_TYPE=MPL_METHOD
ENDIF
IF(PRESENT(KCOMM)) THEN
  ICOMM=KCOMM
ELSE
  ICOMM=MPL_COMM_OML(ITID)
ENDIF
IF((KDEST < 1 .OR. KDEST >MPL_NPROC(ICOMM)) .AND. (.NOT. PRESENT (KCOMM))) THEN
  WRITE(MPL_ERRUNIT,*)'MPL_SEND: ERROR KDEST=',KDEST
  CALL MPL_MESSAGE(CDMESSAGE='MPL_SEND:ILLEGAL KDEST ',LDABORT=LLABORT)
ENDIF

ICOUNT = LEN(CDCHAR) * SIZE(CDCHAR)

IF(LMPLSTATS) THEN
  CALL MPL_SENDSTATS(ICOUNT,INT(MPI_BYTE))
ENDIF

IF(IMP_TYPE == JP_BLOCKING_STANDARD) THEN
  CALL MPI_SEND(CDCHAR,ICOUNT,INT(MPI_BYTE),KDEST-1,KTAG,ICOMM,IERROR)
ELSE IF(IMP_TYPE == JP_BLOCKING_BUFFERED) THEN
  CALL MPI_BSEND(CDCHAR,ICOUNT,INT(MPI_BYTE),KDEST-1,KTAG,ICOMM,IERROR)
ELSE IF(IMP_TYPE == JP_NON_BLOCKING_STANDARD) THEN
  CALL MPI_ISEND(CDCHAR,ICOUNT,INT(MPI_BYTE),KDEST-1,KTAG,ICOMM, &
    & KREQUEST,IERROR)
ELSE IF(IMP_TYPE == JP_NON_BLOCKING_BUFFERED) THEN
  CALL MPI_IBSEND(CDCHAR,ICOUNT,INT(MPI_BYTE),KDEST-1,KTAG,ICOMM, &
    & KREQUEST,IERROR)
ELSE IF(IMP_TYPE == JP_BLOCKING_SYNCHRONOUS) THEN
  CALL MPI_SSEND(CDCHAR,ICOUNT,INT(MPI_BYTE),KDEST-1,KTAG,ICOMM,IERROR)
ELSE
  IF(PRESENT(KERROR)) THEN
    KERROR=1
  ELSE
    CALL MPL_MESSAGE(KERROR,'MPL_SEND',' INVALID METHOD',LDABORT=LLABORT)
  ENDIF
ENDIF
IF(MPL_OUTPUT > 1 )THEN
  WRITE(MPL_UNIT,'(A,5I8)') ' MPL_SEND ',ICOUNT,IMP_TYPE,KDEST,KTAG,ICOMM
ENDIF
IF(PRESENT(KERROR)) THEN
  KERROR=IERROR
ELSE
  IF(IERROR /= 0 ) CALL MPL_MESSAGE(IERROR,'MPL_SEND',CDSTRING,LDABORT=LLABORT)
ENDIF

END SUBROUTINE MPL_SEND_CHAR

SUBROUTINE MPL_SEND_REAL4_SCALAR(PBUF,KDEST,KTAG,KCOMM,KMP_TYPE,KERROR,KREQUEST,CDSTRING)

#ifdef USE_8_BYTE_WORDS
  USE MPI4TO8, ONLY : &
    MPI_SEND => MPI_SEND8, MPI_BSEND => MPI_BSEND8, MPI_ISEND => MPI_ISEND8
#endif

REAL(KIND=JPRM)              :: PBUF
INTEGER(KIND=JPIM),INTENT(IN) :: KDEST,KTAG
INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL :: KCOMM,KMP_TYPE
INTEGER(KIND=JPIM),INTENT(OUT),OPTIONAL :: KREQUEST,KERROR
CHARACTER(LEN=*),INTENT(IN),OPTIONAL :: CDSTRING

INTEGER(KIND=JPIM) :: ICOUNT,IMP_TYPE,ICOMM,IERROR
LOGICAL :: LLABORT=.TRUE.
INTEGER(KIND=JPIM) :: ITID
ITID = OML_MY_THREAD()

IF(MPL_NUMPROC < 1) CALL MPL_MESSAGE( &
  & CDMESSAGE='MPL_SEND: MPL NOT INITIALISED ',LDABORT=LLABORT) 

IF(PRESENT(KMP_TYPE)) THEN
  IMP_TYPE=KMP_TYPE
ELSE
  IMP_TYPE=MPL_METHOD
ENDIF
IF(PRESENT(KCOMM)) THEN
  ICOMM=KCOMM
ELSE
  ICOMM=MPL_COMM_OML(ITID)
ENDIF
IF((KDEST < 1 .OR. KDEST >MPL_NPROC(ICOMM)) .AND. (.NOT. PRESENT (KCOMM))) THEN
  WRITE(MPL_ERRUNIT,*)'MPL_SEND: ERROR KDEST=',KDEST
  CALL MPL_MESSAGE(CDMESSAGE='MPL_SEND:ILLEGAL KDEST ',LDABORT=LLABORT)
ENDIF

ICOUNT = 1

IF(LMPLSTATS) THEN
  CALL MPL_SENDSTATS(ICOUNT,INT(MPI_REAL4))
ENDIF

IF(IMP_TYPE == JP_BLOCKING_STANDARD) THEN
  CALL MPI_SEND(PBUF,ICOUNT,INT(MPI_REAL4),KDEST-1,KTAG,ICOMM,IERROR)
ELSE IF(IMP_TYPE == JP_BLOCKING_BUFFERED) THEN
  CALL MPI_BSEND(PBUF,ICOUNT,INT(MPI_REAL4),KDEST-1,KTAG,ICOMM,IERROR)
ELSE IF(IMP_TYPE == JP_NON_BLOCKING_STANDARD) THEN
  CALL MPI_ISEND(PBUF,ICOUNT,INT(MPI_REAL4),KDEST-1,KTAG,ICOMM, &
    & KREQUEST,IERROR)
ELSE IF(IMP_TYPE == JP_NON_BLOCKING_BUFFERED) THEN
  CALL MPI_IBSEND(PBUF,ICOUNT,INT(MPI_REAL4),KDEST-1,KTAG,ICOMM, &
    & KREQUEST,IERROR)
ELSE IF(IMP_TYPE == JP_BLOCKING_SYNCHRONOUS) THEN
  CALL MPI_SSEND(PBUF,ICOUNT,INT(MPI_REAL4),KDEST-1,KTAG,ICOMM,IERROR)
ELSE
  IF(PRESENT(KERROR)) THEN
    KERROR=1
  ELSE
    CALL MPL_MESSAGE(KERROR,'MPL_SEND',' INVALID METHOD',LDABORT=LLABORT)
  ENDIF
ENDIF
IF(MPL_OUTPUT > 1 )THEN
  WRITE(MPL_UNIT,'(A,5I8)') ' MPL_SEND ',ICOUNT,IMP_TYPE,KDEST,KTAG,ICOMM
ENDIF
IF(PRESENT(KERROR)) THEN
  KERROR=IERROR
ELSE
  IF(IERROR /= 0 ) CALL MPL_MESSAGE(IERROR,'MPL_SEND',CDSTRING,LDABORT=LLABORT)
ENDIF

END SUBROUTINE MPL_SEND_REAL4_SCALAR

SUBROUTINE MPL_SEND_REAL8_SCALAR(PBUF,KDEST,KTAG,KCOMM,KMP_TYPE,KERROR,KREQUEST,CDSTRING)

#ifdef USE_8_BYTE_WORDS
  USE MPI4TO8, ONLY : &
    MPI_SEND => MPI_SEND8, MPI_BSEND => MPI_BSEND8, MPI_ISEND => MPI_ISEND8
#endif

REAL(KIND=JPRD)              :: PBUF
INTEGER(KIND=JPIM),INTENT(IN) :: KDEST,KTAG
INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL :: KCOMM,KMP_TYPE
INTEGER(KIND=JPIM),INTENT(OUT),OPTIONAL :: KREQUEST,KERROR
CHARACTER(LEN=*),INTENT(IN),OPTIONAL :: CDSTRING

INTEGER(KIND=JPIM) :: ICOUNT,IMP_TYPE,ICOMM,IERROR
LOGICAL :: LLABORT=.TRUE.
INTEGER(KIND=JPIM) :: ITID
ITID = OML_MY_THREAD()

IF(MPL_NUMPROC < 1) CALL MPL_MESSAGE( &
  & CDMESSAGE='MPL_SEND: MPL NOT INITIALISED ',LDABORT=LLABORT) 

IF(PRESENT(KMP_TYPE)) THEN
  IMP_TYPE=KMP_TYPE
ELSE
  IMP_TYPE=MPL_METHOD
ENDIF
IF(PRESENT(KCOMM)) THEN
  ICOMM=KCOMM
ELSE
  ICOMM=MPL_COMM_OML(ITID)
ENDIF
IF((KDEST < 1 .OR. KDEST >MPL_NPROC(ICOMM)) .AND. (.NOT. PRESENT (KCOMM))) THEN
  WRITE(MPL_ERRUNIT,*)'MPL_SEND: ERROR KDEST=',KDEST
  CALL MPL_MESSAGE(CDMESSAGE='MPL_SEND:ILLEGAL KDEST ',LDABORT=LLABORT)
ENDIF

ICOUNT = 1

IF(LMPLSTATS) THEN
  CALL MPL_SENDSTATS(ICOUNT,INT(MPI_REAL8))
ENDIF

IF(IMP_TYPE == JP_BLOCKING_STANDARD) THEN
  CALL MPI_SEND(PBUF,ICOUNT,INT(MPI_REAL8),KDEST-1,KTAG,ICOMM,IERROR)
ELSE IF(IMP_TYPE == JP_BLOCKING_BUFFERED) THEN
  CALL MPI_BSEND(PBUF,ICOUNT,INT(MPI_REAL8),KDEST-1,KTAG,ICOMM,IERROR)
ELSE IF(IMP_TYPE == JP_NON_BLOCKING_STANDARD) THEN
  CALL MPI_ISEND(PBUF,ICOUNT,INT(MPI_REAL8),KDEST-1,KTAG,ICOMM, &
    & KREQUEST,IERROR)
ELSE IF(IMP_TYPE == JP_NON_BLOCKING_BUFFERED) THEN
  CALL MPI_IBSEND(PBUF,ICOUNT,INT(MPI_REAL8),KDEST-1,KTAG,ICOMM, &
    & KREQUEST,IERROR)
ELSE IF(IMP_TYPE == JP_BLOCKING_SYNCHRONOUS) THEN
  CALL MPI_SSEND(PBUF,ICOUNT,INT(MPI_REAL8),KDEST-1,KTAG,ICOMM,IERROR)
ELSE
  IF(PRESENT(KERROR)) THEN
    KERROR=1
  ELSE
    CALL MPL_MESSAGE(KERROR,'MPL_SEND',' INVALID METHOD',LDABORT=LLABORT)
  ENDIF
ENDIF
IF(MPL_OUTPUT > 1 )THEN
  WRITE(MPL_UNIT,'(A,5I8)') ' MPL_SEND ',ICOUNT,IMP_TYPE,KDEST,KTAG,ICOMM
ENDIF
IF(PRESENT(KERROR)) THEN
  KERROR=IERROR
ELSE
  IF(IERROR /= 0 ) CALL MPL_MESSAGE(IERROR,'MPL_SEND',CDSTRING,LDABORT=LLABORT)
ENDIF

END SUBROUTINE MPL_SEND_REAL8_SCALAR

SUBROUTINE MPL_SEND_REAL83(PBUF,KDEST,KTAG,KCOMM,KMP_TYPE,KERROR,KREQUEST,CDSTRING)

#ifdef USE_8_BYTE_WORDS
  USE MPI4TO8, ONLY : &
    MPI_SEND => MPI_SEND8, MPI_BSEND => MPI_BSEND8, MPI_ISEND => MPI_ISEND8
#endif

! real_b,intent(in) :: PBUF(:,:,:)
REAL(KIND=JPRD)            :: PBUF(:,:,:)
INTEGER(KIND=JPIM),INTENT(IN) :: KDEST,KTAG
INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL :: KCOMM,KMP_TYPE
INTEGER(KIND=JPIM),INTENT(OUT),OPTIONAL :: KREQUEST,KERROR
CHARACTER(LEN=*),INTENT(IN),OPTIONAL :: CDSTRING

INTEGER(KIND=JPIM) :: ICOUNT,IMP_TYPE,ICOMM,IERROR
LOGICAL :: LLABORT=.TRUE.
INTEGER(KIND=JPIM) :: ITID
ITID = OML_MY_THREAD()

IF(MPL_NUMPROC < 1) CALL MPL_MESSAGE( &
  & CDMESSAGE='MPL_SEND: MPL NOT INITIALISED ',LDABORT=LLABORT) 

IF(PRESENT(KMP_TYPE)) THEN
  IMP_TYPE=KMP_TYPE
ELSE
  IMP_TYPE=MPL_METHOD
ENDIF
IF(PRESENT(KCOMM)) THEN
  ICOMM=KCOMM
ELSE
  ICOMM=MPL_COMM_OML(ITID)
ENDIF
IF(KDEST < 1 .OR. KDEST >MPL_NPROC(ICOMM).AND. (.NOT. PRESENT (KCOMM))) THEN
  WRITE(MPL_ERRUNIT,*)'MPL_SEND: ERROR KDEST=',KDEST
  CALL MPL_MESSAGE(CDMESSAGE='MPL_SEND:ILLEGAL KDEST ',LDABORT=LLABORT)
ENDIF

ICOUNT = SIZE(PBUF)

IF(LMPLSTATS) THEN
  CALL MPL_SENDSTATS(ICOUNT,INT(MPI_REAL8))
ENDIF

#ifndef NAG
IF (ICOUNT > 0) THEN
  IF( (LOC(PBUF(UBOUND(PBUF,1),UBOUND(PBUF,2),UBOUND(PBUF,3))) - &
     & LOC(PBUF(LBOUND(PBUF,1),LBOUND(PBUF,2),LBOUND(PBUF,3)))) /= 8_JPIB*(ICOUNT - 1) ) THEN
    CALL MPL_MESSAGE(CDMESSAGE='MPL_SEND: BUFFER NOT CONTIGUOUS ',LDABORT=LLABORT)
  ENDIF
ENDIF
#endif

IF(IMP_TYPE == JP_BLOCKING_STANDARD) THEN
  CALL MPI_SEND(PBUF,ICOUNT,INT(MPI_REAL8),KDEST-1,KTAG,ICOMM,IERROR)
ELSE IF(IMP_TYPE == JP_BLOCKING_BUFFERED) THEN
  CALL MPI_BSEND(PBUF,ICOUNT,INT(MPI_REAL8),KDEST-1,KTAG,ICOMM,IERROR)
ELSE IF(IMP_TYPE == JP_NON_BLOCKING_STANDARD) THEN
  CALL MPI_ISEND(PBUF,ICOUNT,INT(MPI_REAL8),KDEST-1,KTAG,ICOMM, &
    & KREQUEST,IERROR)
ELSE IF(IMP_TYPE == JP_NON_BLOCKING_BUFFERED) THEN
  CALL MPI_IBSEND(PBUF,ICOUNT,INT(MPI_REAL8),KDEST-1,KTAG,ICOMM, &
    & KREQUEST,IERROR)
ELSE IF(IMP_TYPE == JP_BLOCKING_SYNCHRONOUS) THEN
  CALL MPI_SSEND(PBUF,ICOUNT,INT(MPI_REAL8),KDEST-1,KTAG,ICOMM,IERROR)
ELSE
  IF(PRESENT(KERROR)) THEN
    KERROR=1
  ELSE
    CALL MPL_MESSAGE(KERROR,'MPL_SEND',' INVALID METHOD',LDABORT=LLABORT)
  ENDIF
ENDIF
IF(MPL_OUTPUT > 1 )THEN
  WRITE(MPL_UNIT,'(A,5I8)') ' MPL_SEND ',ICOUNT,IMP_TYPE,KDEST,KTAG,ICOMM
ENDIF
IF(PRESENT(KERROR)) THEN
  KERROR=IERROR
ELSE
  IF(IERROR /= 0 ) CALL MPL_MESSAGE(IERROR,'MPL_SEND',CDSTRING,LDABORT=LLABORT)
ENDIF

END SUBROUTINE MPL_SEND_REAL83

END MODULE MPL_SEND_MOD

! (C) Copyright 2005- ECMWF.
! (C) Copyright 2013- Meteo-France.
! 
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!

#define DR_HOOK_ASSERT_MPI_INITITALIZED 1
  !! TEMPORARY !!
  !! DR_HOOK will abort when MPI is not initialized.
  !! DR_HOOK used to initialize MPI via MPL_INIT, but no longer.

SUBROUTINE DR_HOOK_INIT()
  !! Initialises DR_HOOK
  !! Also calls
  !! - OML_INIT to e.g. save the OMP_NUM_THREADS environment variable
  !! - EC_ARGS to save command-line arguments in case the main program is Fortran
  !! Environment variable "DR_HOOK=1" will enable DR_HOOK
  USE, INTRINSIC :: ISO_C_BINDING, ONLY : C_INT
  USE OML_MOD       ,ONLY : OML_MAX_THREADS, OML_INIT
  USE EC_ARGS_MOD   ,ONLY : EC_ARGS
  USE YOMHOOK       ,ONLY : LHOOK ! True by default
  IMPLICIT NONE
  LOGICAL,SAVE :: LL_FIRST_TIME = .TRUE.
  CHARACTER(LEN=512) :: CLENV
  INTEGER(KIND=C_INT) :: IMAX_THREADS

  IF (LL_FIRST_TIME) THEN
    LL_FIRST_TIME = .FALSE.

    CALL GET_ENVIRONMENT_VARIABLE('DR_HOOK',CLENV)
    IF ( CLENV == ' ' .OR. CLENV == '0'  .OR. &
       & CLENV == 'false' .OR. CLENV == 'FALSE' .OR. &
       & CLENV == 'off'   .OR. CLENV == 'OFF' .OR. &
       & CLENV == 'no'    .OR. CLENV == 'NO' ) THEN
       LHOOK = .FALSE.
    ENDIF
    CALL OML_INIT()

#if DR_HOOK_ASSERT_MPI_INITITALIZED
    CALL DR_HOOK_ASSERT_MPI_INITIALIZED_()
#endif

    CALL EC_ARGS()

    IF (.NOT. LHOOK) RETURN
    
    IMAX_THREADS = OML_MAX_THREADS()
    CALL C_DRHOOK_INIT('',IMAX_THREADS)
      !! First argument (progname) is empty ==> c_drhook_init will retrieve progname via ec_args itself
  ENDIF

CONTAINS

#if DR_HOOK_ASSERT_MPI_INITITALIZED
SUBROUTINE DR_HOOK_ASSERT_MPI_INITIALIZED_()
  LOGICAL :: LMPI_REQUIRED
  INTEGER :: ILEN
  INTEGER(KIND=C_INT) :: IERR
  LOGICAL :: LMPI_INITIALIZED
  INTEGER, PARAMETER :: NVARS = 4
  CHARACTER(LEN=32), DIMENSION(NVARS) :: CMPIRUN_DETECT
  CHARACTER(LEN=4) :: CLENV_DR_HOOK_ASSERT_MPI_INITIALIZED
  INTEGER :: IVAR

#include "mpif.h"
#include "abor1.intfb.h"

  ! Environment variables that are set when mpirun, srun, aprun, ... are used (see eckit/mpi/Comm.cc)
  CMPIRUN_DETECT(1) = 'OMPI_COMM_WORLD_SIZE'  ! OpenMPI
  CMPIRUN_DETECT(2) = 'ALPS_APP_PE'           ! Cray PE
  CMPIRUN_DETECT(3) = 'PMI_SIZE'              ! Intel
  CMPIRUN_DETECT(4) = 'SLURM_STEP_NUM_TASKS'  ! Slurm
  ! When adding here, change NVARS parameter above

  LMPI_REQUIRED = .FALSE.
  DO IVAR=1,NVARS
    CALL GET_ENVIRONMENT_VARIABLE(NAME=TRIM(CMPIRUN_DETECT(IVAR)),LENGTH=ILEN)
    IF (ILEN > 0) THEN
      LMPI_REQUIRED = .TRUE.
      EXIT ! break
    ENDIF
  ENDDO

  IF (LMPI_REQUIRED) THEN
    CALL GET_ENVIRONMENT_VARIABLE(NAME="DR_HOOK_ASSERT_MPI_INITIALIZED", VALUE=CLENV)
    IF ( CLENV == '0'  .OR. &
       & CLENV == 'false' .OR. CLENV == 'FALSE' .OR. &
       & CLENV == 'off'   .OR. CLENV == 'OFF' .OR. &
       & CLENV == 'no'    .OR. CLENV == 'NO' ) THEN
      LMPI_REQUIRED = .FALSE.
    ENDIF
  ENDIF
  IF (LMPI_REQUIRED) THEN
    CALL MPI_INITIALIZED(LMPI_INITIALIZED,IERR)
    IF( IERR /= 0 ) THEN
      CALL ABOR1FL( "dr_hook_init.F90", __LINE__, &
        & "DR_HOOK: MPI_INITIALIZED failed" )
    ENDIF
    IF( .NOT.LMPI_INITIALIZED ) THEN
      CALL ABOR1FL( "dr_hook_init.F90", __LINE__, &
        & "DR_HOOK no longer calls MPL_INIT. Please initialize MPI (or MPL) before first DR_HOOK call."//NEW_LINE('A')//&
        & "This assertion can be disabled with environment: DR_HOOK_ASSERT_MPI_INITIALIZED=0" )
    ENDIF
  ENDIF
END SUBROUTINE
#endif
END SUBROUTINE

! (C) Copyright 2005- ECMWF.
! (C) Copyright 2013- Meteo-France.
! 
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!

MODULE PARKIND1
!
!     *** Define usual kinds for strong typing ***
!
IMPLICIT NONE
SAVE
!
!     Integer Kinds
!     -------------
!
INTEGER, PARAMETER :: JPIT = SELECTED_INT_KIND(2)
INTEGER, PARAMETER :: JPIS = SELECTED_INT_KIND(4)
INTEGER, PARAMETER :: JPIM = SELECTED_INT_KIND(9)
INTEGER, PARAMETER :: JPIB = SELECTED_INT_KIND(12)

!Special integer type to be used for sensative adress calculations
!should be *8 for a machine with 8byte adressing for optimum performance
#ifdef ADDRESS64
INTEGER, PARAMETER :: JPIA = JPIB
#else
INTEGER, PARAMETER :: JPIA = JPIM
#endif

!
!     Real Kinds
!     ----------
!
INTEGER, PARAMETER :: JPRT = SELECTED_REAL_KIND(2,1)
INTEGER, PARAMETER :: JPRS = SELECTED_REAL_KIND(4,2)
INTEGER, PARAMETER :: JPRM = SELECTED_REAL_KIND(6,37)
#ifdef PARKIND1_SINGLE
INTEGER, PARAMETER :: JPRB = SELECTED_REAL_KIND(6,37)
#else
INTEGER, PARAMETER :: JPRB = SELECTED_REAL_KIND(13,300)
#endif

! Double real for C code and special places requiring 
!    higher precision. 
INTEGER, PARAMETER :: JPRD = SELECTED_REAL_KIND(13,300)


! Logical Kinds for RTTOV....

INTEGER, PARAMETER :: JPLM = JPIM   !Standard logical type

END MODULE PARKIND1

! (C) Copyright 2005- ECMWF.
! (C) Copyright 2013- Meteo-France.
! 
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!

MODULE MPL_ABORT_MOD

USE MPL_DATA_MODULE
USE MPL_MPIF
USE OML_MOD
USE EC_PARKIND  ,ONLY : JPIM
USE YOMHOOK  , ONLY : LHOOK

PRIVATE
PUBLIC MPL_ABORT

INTEGER(KIND=JPIM), SAVE :: MAB_CNT = 0 ! Must be used with OMP FLUSH inside the OMP CRITICAL regions

CONTAINS 

SUBROUTINE MPL_ABORT(CDMESSAGE)

IMPLICIT NONE

CHARACTER(LEN=*),INTENT(IN),OPTIONAL :: CDMESSAGE
INTEGER(KIND=JPIM) :: IRETURN_CODE,IERROR,ITID,INUMTH,IPROC,INUM_PROC
LOGICAL :: LMPI_INITIALIZED

IPROC=1
INUM_PROC=1
CALL MPI_INITIALIZED(LMPI_INITIALIZED,IERROR)
IF( LMPI_INITIALIZED ) THEN
  CALL MPI_COMM_RANK(MPI_COMM_WORLD,IPROC,IERROR)
  IPROC = IPROC+1 ! 1-based in IFS context
  CALL MPI_COMM_SIZE(MPI_COMM_WORLD,INUM_PROC,IERROR)
ENDIF
ITID=OML_MY_THREAD()
INUMTH=OML_MAX_THREADS()

CALL EC_FLUSH(MPL_UNIT)
!------Traceback from only one thread
!$OMP CRITICAL (CRIT_MPL_ABORT)
!$OMP FLUSH(MAB_CNT)
IF (MAB_CNT == 0) THEN
  IF(PRESENT(CDMESSAGE)) THEN
    WRITE(MPL_ERRUNIT,'(A,I0,A,I0,A,A)') 'MPL_ABORT [PROC=',IPROC,',THRD=',ITID, '] : ', CDMESSAGE
  ELSE
    WRITE(MPL_ERRUNIT,'(A,I0,A,I0,A)') 'MPL_ABORT [PROC=',IPROC,',THRD=',ITID, ']'
  ENDIF
  CALL EC_FLUSH(MPL_ERRUNIT)
  MAB_CNT=1
!$OMP FLUSH(MAB_CNT)
  CALL TABORT() ! tabort.c : does not hang -- never returns
ENDIF
!$OMP END CRITICAL (CRIT_MPL_ABORT)

END SUBROUTINE MPL_ABORT

END MODULE MPL_ABORT_MOD

! (C) Copyright 2005- ECMWF.
! 
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!

SUBROUTINE EC_KHZ(KOREID,KHZ)
USE EC_PARKIND, ONLY : JPIM
IMPLICIT NONE
INTEGER(KIND=JPIM),INTENT(IN)  :: KOREID
INTEGER(KIND=JPIM),INTENT(OUT) :: KHZ
INTEGER(KIND=JPIM) :: ITHISCORE, ISTAT
INTEGER, external :: EC_COREID ! from ec_env.c
!  /sys/devices/system/cpu/cpu0/cpufreq/scaling_cur_freq
CHARACTER(LEN=80) :: CLSYS
IF (KOREID >= 0) THEN
   ITHISCORE = KOREID
ELSE
   ITHISCORE = EC_COREID()
ENDIF
WRITE(CLSYS,'(A,I0,A)') '/sys/devices/system/cpu/cpu',ITHISCORE,'/cpufreq/scaling_cur_freq'
OPEN(505,FILE=trim(CLSYS),IOSTAT=ISTAT,STATUS='old',ACTION='read')
IF (ISTAT == 0) THEN
   READ(505,*,IOSTAT=ISTAT) KHZ
   CLOSE(505)
ENDIF
IF (ISTAT /= 0) KHZ = 0
END SUBROUTINE EC_KHZ

! (C) Copyright 2005- ECMWF.
! (C) Copyright 2013- Meteo-France.
! 
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!

MODULE YOMMPLSTATS

USE EC_PARKIND  ,ONLY : JPRD, JPIM

IMPLICIT NONE

SAVE

PRIVATE :: JPRD, JPIM
PUBLIC

!     ------------------------------------------------------------------
! Module for communications statistics.
! Module is internal to the MPLSTATS package -
! routines MPL_SENDSTATS, MPL_RECVSTATS

! LMPLSTATS - TRUE for gathering communications statistics


LOGICAL :: LMPLSTATS = .FALSE.
REAL(KIND=JPRD), ALLOCATABLE    :: MPLSENDBYTES(:), MPLRECVBYTES(:)
INTEGER(KIND=JPIM), ALLOCATABLE :: MPLSENDNUM(:), MPLRECVNUM(:)

END MODULE YOMMPLSTATS

! (C) Copyright 2005- ECMWF.
! (C) Copyright 2013- Meteo-France.
! 
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!

SUBROUTINE GSTATS_BARRIER(KNUM)

USE EC_PARKIND  ,ONLY : JPIM

USE YOMGSTATS, ONLY : LBARRIER_STATS
USE MPL_MODULE  , ONLY : MPL_BARRIER

IMPLICIT NONE

INTEGER(KIND=JPIM) :: KNUM

IF(LBARRIER_STATS)THEN
  CALL GSTATS(KNUM,0)
  CALL MPL_BARRIER()
  CALL GSTATS(KNUM,1)
ENDIF

END SUBROUTINE GSTATS_BARRIER

! (C) Copyright 2005- ECMWF.
! (C) Copyright 2013- Meteo-France.
! 
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!

SUBROUTINE GSTATS_BARRIER(KNUM)

USE EC_PARKIND, ONLY: JPIM
USE YOMGSTATS, ONLY: LBARRIER_STATS
USE MPL_MODULE, ONLY: MPL_BARRIER

IMPLICIT NONE

INTEGER(KIND=JPIM) :: KNUM

IF (LBARRIER_STATS) THEN
  CALL GSTATS(KNUM, 0)
  CALL MPL_BARRIER()
  CALL GSTATS(KNUM, 1)
ENDIF

END SUBROUTINE GSTATS_BARRIER

! (C) Copyright 2005- ECMWF.
! (C) Copyright 2013- Meteo-France.
! 
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!

MODULE MPL_WAIT_MOD

!**** MPL_WAIT Waits for completion

!     Purpose.
!     --------
!     Returns control when the operation(s) identified by the request
!     is completed.
!     Normally used in conjunction with non-blocking buffering type

!**   Interface.
!     ----------
!        CALL MPL_WAIT

!        Input required arguments :
!        -------------------------
!           KREQUEST -  array or scalar containing
!                       Communication request(s)
!                       as provided by MPL_RECV or MPL_SEND

!        Input optional arguments :
!        -------------------------
!           CDSTRING -  Character string for ABORT messages
!                       used when KERROR is not provided

!        Output required arguments :
!        -------------------------
!           none

!        Output optional arguments :
!        -------------------------
!           KOUNT    -  must be the same size and shape as KREQUEST
!                       contains number of items sent/received
!           KBYTES   -  number of bytes in a single element in all KOUNTs
!                       *must* be supplied with KOUNT
!                       KBYTES normally determited robustly by MPL_BYTES
!           KERROR   -  return error code.     If not supplied, 
!                       MPL_WAIT aborts when an error is detected.
!     Author.
!     -------
!        D.Dent, M.Hamrud     ECMWF

!     Modifications.
!     --------------
!        Original: 2000-09-01
!        J. Hague: 2005-04-25  WAITALL replaced by WAIT loop
!      F. Vana  05-Mar-2015  Support for single precision
!  S. Saarinen  17-Feb-2017  Removed PBUF argument (not realy needed)
!                            KREQUEST must be INOUT (as per MPI_Wait)
!                            MPL_WAITS calls MPI_Waitall unless MPI1
!  S. Saarinen  01-Mar-2017  Added KBYTES

!     ------------------------------------------------------------------

USE EC_PARKIND  ,ONLY : JPRD, JPIM, JPRM, JPIB

USE MPL_MPIF
USE MPL_DATA_MODULE
USE MPL_MESSAGE_MOD

IMPLICIT NONE

PRIVATE

INTERFACE MPL_WAIT
MODULE PROCEDURE MPL_WAITS, MPL_WAIT1
END INTERFACE

PUBLIC MPL_WAIT

CONTAINS 


SUBROUTINE MPL_WAITS(KREQUEST,KOUNT,KBYTES,KERROR,CDSTRING)

#ifdef USE_8_BYTE_WORDS
  USE MPI4TO8, ONLY : &
    MPI_WAITALL => MPI_WAITALL8, MPI_GET_COUNT => MPI_GET_COUNT8, &
    MPI_WAIT => MPI_WAIT8
#endif

INTEGER(KIND=JPIM),INTENT(INOUT)  :: KREQUEST(:)
CHARACTER(LEN=*),INTENT(IN),OPTIONAL :: CDSTRING
INTEGER(KIND=JPIM),INTENT(OUT),OPTIONAL :: KOUNT(SIZE(KREQUEST))
INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL :: KBYTES
INTEGER(KIND=JPIM),INTENT(OUT),OPTIONAL :: KERROR
INTEGER(KIND=JPIM) :: IWAITERR,ICOUNTERR,JL,IREQLEN,ICOUNT,IW
INTEGER(KIND=JPIM) :: IWAIT_STATUS(MPI_STATUS_SIZE,SIZE(KREQUEST))
LOGICAL :: LLABORT
LLABORT=.TRUE.
IWAITERR=0
ICOUNTERR=0

IF(MPL_NUMPROC < 1) CALL MPL_MESSAGE( &
  & CDMESSAGE='MPL_WAITS: MPL NOT INITIALISED ',LDABORT=LLABORT) 

IREQLEN=SIZE(KREQUEST)
#ifndef MPI1
CALL MPI_WAITALL(IREQLEN,KREQUEST,IWAIT_STATUS,IWAITERR)
#else
DO JL=1,IREQLEN
  CALL MPI_WAIT(KREQUEST(JL),IWAIT_STATUS(1,JL),IW)
  IWAITERR=MAX(IWAITERR,IW)
ENDDO
#endif

IF(PRESENT(KOUNT))THEN
  IF (.not.PRESENT(KBYTES)) THEN
    CALL MPL_MESSAGE( &
    & CDMESSAGE='MPL_WAIT: KBYTES MUST BE PRESENT WITH KOUNT ', &
    & CDSTRING=CDSTRING,LDABORT=LLABORT)
  ENDIF
  IF(SIZE(KOUNT) /= IREQLEN) THEN
    CALL MPL_MESSAGE( &
    & CDMESSAGE='MPL_WAIT: KOUNT AND KREQUEST INCONSISTENT ', &
    & CDSTRING=CDSTRING,LDABORT=LLABORT)
  ENDIF
  DO JL=1,IREQLEN
    CALL MPI_GET_COUNT(IWAIT_STATUS(1,JL),INT(MPI_BYTE),KOUNT(JL),ICOUNTERR)
    KOUNT(JL) = KOUNT(JL) / KBYTES
  ENDDO
ENDIF

IF(PRESENT(KERROR))THEN
  KERROR=IWAITERR+ICOUNTERR
ELSE IF(IWAITERR /= 0) THEN
  CALL MPL_MESSAGE(IWAITERR,'MPL_WAITS_WAITING',CDSTRING,LDABORT=LLABORT)
ELSE IF(ICOUNTERR /= 0) THEN
  CALL MPL_MESSAGE(ICOUNTERR,'MPL_WAITS_COUNT',CDSTRING,LDABORT=LLABORT)
ENDIF

RETURN
END SUBROUTINE MPL_WAITS


SUBROUTINE MPL_WAIT1(KREQUEST,KOUNT,KBYTES,KERROR,CDSTRING)

#ifdef USE_8_BYTE_WORDS
  USE MPI4TO8, ONLY : &
    MPI_WAITALL => MPI_WAITALL8, MPI_GET_COUNT => MPI_GET_COUNT8
#endif

INTEGER(KIND=JPIM),INTENT(INOUT)  :: KREQUEST
CHARACTER(LEN=*),INTENT(IN),OPTIONAL :: CDSTRING
INTEGER(KIND=JPIM),INTENT(OUT),OPTIONAL :: KOUNT
INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL :: KBYTES
INTEGER(KIND=JPIM),INTENT(OUT),OPTIONAL :: KERROR
INTEGER(KIND=JPIM) :: IWAITERR,ICOUNTERR,JL,IREQLEN,ICOUNT
INTEGER(KIND=JPIM) :: IWAIT_STATUS(MPI_STATUS_SIZE)
LOGICAL :: LLABORT
LLABORT=.TRUE.
IWAITERR=0
ICOUNTERR=0

IF(MPL_NUMPROC < 1) CALL MPL_MESSAGE( &
  & CDMESSAGE='MPL_WAIT: MPL NOT INITIALISED ',LDABORT=LLABORT) 

CALL MPI_WAIT(KREQUEST,IWAIT_STATUS,IWAITERR)

IF(PRESENT(KOUNT))THEN
  IF (.not.PRESENT(KBYTES)) THEN
    CALL MPL_MESSAGE( &
    & CDMESSAGE='MPL_WAIT: KBYTES MUST BE PRESENT WITH KOUNT ', &
    & CDSTRING=CDSTRING,LDABORT=LLABORT)
  ENDIF
  CALL MPI_GET_COUNT(IWAIT_STATUS(1),INT(MPI_BYTE),KOUNT,ICOUNTERR)
  KOUNT = KOUNT / KBYTES
ENDIF

IF(PRESENT(KERROR))THEN
  KERROR=IWAITERR+ICOUNTERR
ELSE IF(IWAITERR /= 0) THEN
  CALL MPL_MESSAGE(IWAITERR,'MPL_WAIT_WAITING',CDSTRING,LDABORT=LLABORT)
ELSE IF(ICOUNTERR /= 0) THEN
  CALL MPL_MESSAGE(ICOUNTERR,'MPL_WAIT_COUNT',CDSTRING,LDABORT=LLABORT)
ENDIF

RETURN
END SUBROUTINE MPL_WAIT1

END MODULE MPL_WAIT_MOD

! (C) Copyright 2005- ECMWF.
! (C) Copyright 2013- Meteo-France.
! 
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!

SUBROUTINE DR_HOOK_PROCINFO(KMYPROC, KNPROC)
USE EC_PARKIND  ,ONLY : JPIM
USE MPL_MPIF
IMPLICIT NONE
INTEGER(KIND=JPIM),INTENT(OUT) :: KMYPROC, KNPROC
LOGICAL :: LMPI_INITIALIZED
INTEGER(KIND=JPIM) :: IERROR

KMYPROC=-1
KNPROC=0
CALL MPI_INITIALIZED(LMPI_INITIALIZED,IERROR)
IF( LMPI_INITIALIZED ) THEN
  CALL MPI_COMM_SIZE(MPI_COMM_WORLD,KNPROC,IERROR)
  CALL MPI_COMM_RANK(MPI_COMM_WORLD,KMYPROC,IERROR)
  KMYPROC = KMYPROC+1 ! 1-based in IFS context
ENDIF
END SUBROUTINE DR_HOOK_PROCINFO

! (C) Copyright 2005- ECMWF.
! (C) Copyright 2013- Meteo-France.
! 
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!

MODULE ECSORT_MIX
USE EC_PARKIND   , ONLY : JPIM     ,JPIB,    JPRM    ,JPRD
USE YOMHOOK    , ONLY : LHOOK, DR_HOOK, JPHOOK
USE OML_MOD     , ONLY : OML_MAX_THREADS, OML_MY_THREAD, OML_IN_PARALLEL
USE STRHANDLER_MOD, ONLY : TOUPPER
USE MPL_MODULE , ONLY : MPL_MYRANK, MPL_NPROC

!$
!..   Author: Sami Saarinen, ECMWF, 10/02/98
!     Fixes : Sami Saarinen, ECMWF, 08/11/99 : Sub-arrays go now correctly (look for addrdiff)
!                                              Genuine real(4) sort "re-habilitated"
!                                              sizeof_int, _real4 & _real8 HARDCODED !
!             Sami Saarinen, ECMWF, 11/10/00 : REAL*4 version included (REAL_M)
!             Sami Saarinen, ECMWF, 28/11/03 : Calls to DR_HOOK added manually (on top of CY28)
!             Sami Saarinen, ECMWF, 18/02/05 : 64-bit integer sorting introduced (for CY30)
!             Sami Saarinen, ECMWF, 22/02/05 : Using genuine 64-bit rsort64() => one-pass through data
!             Sami Saarinen, ECMWF, 06/07/05 : "current_method" made OpenMP-thread aware (for max. # of threads = NTHRDS)
!             Sami Saarinen, ECMWF, 07/07/05 : Quick-sort method finally arrived (and applicable to multikeys, too)
!                                              Quick-sort the default for scalar machines ("non-VPP"), VPPs is radix-sort
!             Sami Saarinen, ECMWF, 03/07/07 : Quick-sort method uses stable approach (was not guaranteed so before)
!             Sami Saarinen, ECMWF, 15/10/07 : Subroutines put into a common file ../include/ecsort_shared.h and
!                                              preprocessed from there
!             Sami Saarinen, ECMWF, 15/10/07 : NTHRDS increased from 32 to 64
!             Sami Saarinen, ECMWF, 16/10/07 : The default sorting method can be overriden via export EC_SORTING_METHOD=[<number>|<string>]
!             Sami Saarinen, ECMWF, 30/10/07 : Support for CountingSort added as part of QuickSort speedup
!             Sami Saarinen, ECMWF, 31/10/07 : CALL SORTING_METHOD() now prints the prevailing method from EC_SORTING_METHOD
!             Sami Saarinen, ECMWF, 01/11/07 : CountingSort implemented as independent method
!             Sami Saarinen, ECMWF, 06/11/07 : index_adj added as an optional argument to init_index ; new routine adjust_index()
!             Sami Saarinen, ECMWF, 07/11/07 : threshold length "nomp" (see below). Override with EC_SORTING_NOMP.
!             Sami Saarinen, ECMWF, 12/11/07 : Gnome-sort -- the easiest sort on Earth (and very slow for large arrays)
!             Sami Saarinen, ECMWF, 15/11/07 : OpenMP-sorting still under development. Do NOT override the EC_SORTING_NOMP yet.
!             Sami Saarinen, ECMWF, 05/12/07 : When export EC_SORTING_INFO=0, then no info messages are printed from CALL sorting_method()
!             Sami Saarinen, ECMWF, 20/12/07 : export EC_SORTING_INFO=0, rather than =1 is now the default --> less hassling output


IMPLICIT NONE
SAVE
PRIVATE

INTEGER(KIND=JPIM), PARAMETER :: NTHRDS = 64 ! ***Note: A hardcoded max number of threads !!!

INTEGER(KIND=JPIM), PARAMETER :: SIZEOF_INT4  = 4
INTEGER(KIND=JPIM), PARAMETER :: SIZEOF_INT8  = 8
INTEGER(KIND=JPIM), PARAMETER :: SIZEOF_REAL4 = 4
INTEGER(KIND=JPIM), PARAMETER :: SIZEOF_REAL8 = 8

INTEGER(KIND=JPIM), PARAMETER :: MIN_METHOD = 1
INTEGER(KIND=JPIM), PARAMETER :: MAX_METHOD = 5

INTEGER(KIND=JPIM), PARAMETER :: RADIXSORT_METHOD = 1
INTEGER(KIND=JPIM), PARAMETER :: HEAPSORT_METHOD  = 2
INTEGER(KIND=JPIM), PARAMETER :: QUICKSORT_METHOD = 3
INTEGER(KIND=JPIM), PARAMETER :: COUNTINGSORT_METHOD = 4
INTEGER(KIND=JPIM), PARAMETER :: GNOMESORT_METHOD = 5

CHARACTER(LEN=12), PARAMETER :: METHOD_NAME(MIN_METHOD:MAX_METHOD) = &
     & (/&
     &   'RADIXSORT   ' &
     &  ,'HEAPSORT    ' &
     &  ,'QUICKSORT   ' &
     &  ,'COUNTINGSORT' &
     &  ,'GNOMESORT   ' &
     &  /)

!-- Select such method for default_method, which also works for multikey sorts
!   Vector machines should choose radixsort_method, others quicksort_method (oh, sorry, countingsort_method!)
!
!   Note: Occasionally radixsort_method may be faster on non-vector machines, too
INTEGER(KIND=JPIM) :: DEFAULT_METHOD = COUNTINGSORT_METHOD
INTEGER(KIND=JPIM) :: CURRENT_METHOD(NTHRDS) = COUNTINGSORT_METHOD

!-- A threshold length after which OpenMP in sorting, merging, copying may kick in.
!   Override with EC_SORTING_NOMP. Detected while initializing/calling SORTING_METHOD
!   Non-positive values (<= 0) indicate that OpenMP will NOT be attempted at all
INTEGER(KIND=JPIM) :: NOMP = -1

!-- EC_SORTING_INFO = MPL-proc id [1..$NPES] to print the info message when CALL sorting_method()
!                   : 0 (no print; the default)
!                   : 1 (print on MPL-task one)
!                   : > 1 and <= $NPES (some other MPL-task than 1 prints)
INTEGER(KIND=JPIM) :: NSINFO = 0

INTERFACE KEYSORT
MODULE PROCEDURE &
     &INT4_KEYSORT_1D, INT4_KEYSORT_2D, &
     &INT8_KEYSORT_1D, INT8_KEYSORT_2D, &
     &REAL8_KEYSORT_1D, REAL8_KEYSORT_2D, &
     &REAL4_KEYSORT_1D, REAL4_KEYSORT_2D
END INTERFACE

INTERFACE SORTING_METHOD
MODULE PROCEDURE INT_SORTING_METHOD, STR_SORTING_METHOD
END INTERFACE

PUBLIC :: KEYSORT
PUBLIC :: INIT_INDEX, GET_RANK, ADJUST_INDEX
PUBLIC :: SORTING_METHOD
PUBLIC :: RADIXSORT_METHOD, HEAPSORT_METHOD, QUICKSORT_METHOD
PUBLIC :: COUNTINGSORT_METHOD, GNOMESORT_METHOD

CONTAINS

!----------------------------
!--   Public subroutines   --
!----------------------------

SUBROUTINE INT_SORTING_METHOD(INEW, IOLD)
INTEGER(KIND=JPIM), OPTIONAL, INTENT(IN)  :: INEW
INTEGER(KIND=JPIM), OPTIONAL, INTENT(OUT) :: IOLD
INTEGER(KIND=JPIM) :: ITMP, IMYPROC, INPES
INTEGER(KIND=JPIM) :: ITID
CHARACTER(LEN=20) CLENV
LOGICAL, SAVE :: LLFIRST = .TRUE.
LOGICAL LLOMP, LLHOOK_OK
REAL(KIND=JPHOOK) :: ZHOOK_HANDLE
!-- This maybe called from the very first call of DR_HOOK_UTIL ...
LLHOOK_OK = LHOOK .AND. (PRESENT(INEW) .OR. PRESENT(IOLD))
IF (LLHOOK_OK) CALL DR_HOOK('ECSORT_MIX:INT_SORTING_METHOD',0,ZHOOK_HANDLE)
ITID = OML_MY_THREAD()
LLOMP = OML_IN_PARALLEL()
IF (PRESENT(IOLD)) IOLD = CURRENT_METHOD(ITID)
ITMP = -1
IF (PRESENT(INEW)) THEN
  ITMP = INEW
ELSE IF (.NOT.LLOMP) THEN ! Override the default method (only if outside the OpenMP)
  ITMP = -1 ! no change
  IF (LLFIRST) THEN ! Do once per execution only
    INPES = MPL_NPROC()
    CALL GET_ENVIRONMENT_VARIABLE('EC_SORTING_INFO',CLENV) ! ../support/env.c
    IF (CLENV /= ' ') THEN
      ITMP = NSINFO
      READ(CLENV,'(i20)',END=89,ERR=89) ITMP
      GOTO 88
89    CONTINUE
      ITMP = NSINFO ! no change
88    CONTINUE
      IF (ITMP <= 0) THEN
        NSINFO = 0
      ELSE IF (ITMP >= 1 .AND. ITMP <= INPES) THEN
        NSINFO = ITMP
      ENDIF
    ENDIF
    IMYPROC = MPL_MYRANK()
    CALL GET_ENVIRONMENT_VARIABLE('EC_SORTING_METHOD',CLENV) ! ../support/env.c
    IF (CLENV /= ' ') THEN
       IF (IMYPROC == NSINFO) WRITE(0,'(a)')'<EC_SORTING_METHOD='//TRIM(CLENV)
       CALL TOUPPER(CLENV)
       SELECT CASE (CLENV)
       CASE ('RADIX', 'RADIXSORT')
          ITMP = RADIXSORT_METHOD
       CASE ('HEAP', 'HEAPSORT')
          ITMP = HEAPSORT_METHOD
       CASE ('QUICK', 'QUICKSORT', 'QSORT')
          ITMP = QUICKSORT_METHOD
       CASE ('COUNT', 'COUNTINGSORT', 'COUNTSORT')
          ITMP = COUNTINGSORT_METHOD
       CASE ('GNOME', 'GNOMESORT')
          ITMP = GNOMESORT_METHOD
       CASE ('DEFAULT', 'DEF')
          ITMP = -1 ! no change
       CASE DEFAULT
          READ(CLENV,'(i20)',END=99,ERR=99) ITMP
          GOTO 98
99        CONTINUE
          ITMP = -1 ! no change
98        CONTINUE
       END SELECT
    ENDIF

    IF (ITMP < MIN_METHOD .OR. ITMP > MAX_METHOD) ITMP = DEFAULT_METHOD
    DEFAULT_METHOD = ITMP
    CURRENT_METHOD(:) = ITMP
    IF (IMYPROC == NSINFO) &
         & WRITE(0,'(a,i1,a)')'>EC_SORTING_METHOD=',DEFAULT_METHOD,&
         & ' # '//METHOD_NAME(DEFAULT_METHOD)

    CALL GET_ENVIRONMENT_VARIABLE('EC_SORTING_NOMP',CLENV)
    IF (CLENV /= ' ') THEN
       IF (IMYPROC == NSINFO) WRITE(0,'(a)')'<EC_SORTING_NOMP='//TRIM(CLENV)
       READ(CLENV,'(i20)',END=199,ERR=199) ITMP
       GOTO 198
199    CONTINUE
       ITMP = NOMP ! no change
198    CONTINUE
       NOMP = ITMP
    ENDIF

    IF (IMYPROC == NSINFO) THEN
      WRITE(CLENV,'(i20)') NOMP
      WRITE(0,'(a)')'>EC_SORTING_NOMP='//TRIM(ADJUSTL(CLENV))
    ENDIF

    ITMP = DEFAULT_METHOD
    LLFIRST = .FALSE.
  ENDIF
ENDIF

IF (ITMP < MIN_METHOD .OR. ITMP > MAX_METHOD) ITMP = DEFAULT_METHOD
IF (LLOMP) THEN ! Only this thread sees the change
  CURRENT_METHOD(ITID) = ITMP
ELSE ! All threads see the change
  CURRENT_METHOD(:) = ITMP
ENDIF
IF (LLHOOK_OK) CALL DR_HOOK('ECSORT_MIX:INT_SORTING_METHOD',1,ZHOOK_HANDLE)
END SUBROUTINE INT_SORTING_METHOD


SUBROUTINE STR_SORTING_METHOD(CDNEW, IOLD)
CHARACTER(LEN=*), INTENT(IN) :: CDNEW
INTEGER(KIND=JPIM), OPTIONAL, INTENT(OUT) :: IOLD
CHARACTER(LEN=LEN(CDNEW)) CLNEW
REAL(KIND=JPHOOK) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('ECSORT_MIX:STR_SORTING_METHOD',0,ZHOOK_HANDLE)
CLNEW = CDNEW
CALL TOUPPER(CLNEW)
SELECT CASE (CLNEW)
CASE ('RADIX', 'RADIXSORT')
  CALL SORTING_METHOD(RADIXSORT_METHOD, IOLD)
CASE ('HEAP', 'HEAPSORT')
  CALL SORTING_METHOD(HEAPSORT_METHOD, IOLD)
CASE ('QUICK', 'QUICKSORT', 'QSORT')
  CALL SORTING_METHOD(QUICKSORT_METHOD, IOLD)
CASE ('COUNT', 'COUNTINGSORT', 'COUNTSORT')
  CALL SORTING_METHOD(COUNTINGSORT_METHOD, IOLD)
CASE ('GNOME', 'GNOMESORT')
  CALL SORTING_METHOD(GNOMESORT_METHOD, IOLD)
CASE ('DEFAULT', 'DEF')
  CALL SORTING_METHOD(DEFAULT_METHOD, IOLD)
CASE DEFAULT
  CALL SORTING_METHOD(DEFAULT_METHOD, IOLD)
END SELECT
IF (LHOOK) CALL DR_HOOK('ECSORT_MIX:STR_SORTING_METHOD',1,ZHOOK_HANDLE)
END SUBROUTINE STR_SORTING_METHOD


SUBROUTINE INIT_INDEX(INDEX, INDEX_ADJ)
INTEGER(KIND=JPIM), INTENT(OUT):: INDEX(:)
INTEGER(KIND=JPIM), INTENT(IN), OPTIONAL :: INDEX_ADJ
INTEGER(KIND=JPIM) :: I, N
REAL(KIND=JPHOOK) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('ECSORT_MIX:INIT_INDEX',0,ZHOOK_HANDLE)
N = SIZE(INDEX)
IF (PRESENT(INDEX_ADJ)) THEN
  DO I=1,N
    INDEX(I) = I + INDEX_ADJ
  ENDDO
ELSE
  DO I=1,N
    INDEX(I) = I
  ENDDO
ENDIF
IF (LHOOK) CALL DR_HOOK('ECSORT_MIX:INIT_INDEX',1,ZHOOK_HANDLE)
END SUBROUTINE INIT_INDEX


SUBROUTINE ADJUST_INDEX(INDEX, INDEX_ADJ)
INTEGER(KIND=JPIM), INTENT(INOUT):: INDEX(:)
INTEGER(KIND=JPIM), INTENT(IN) :: INDEX_ADJ
INTEGER(KIND=JPIM) :: I, N
REAL(KIND=JPHOOK) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('ECSORT_MIX:ADJUST_INDEX',0,ZHOOK_HANDLE)
IF (INDEX_ADJ /= 0) THEN
  N = SIZE(INDEX)
  DO I=1,N
    INDEX(I) = INDEX(I) + INDEX_ADJ
  ENDDO
ENDIF
IF (LHOOK) CALL DR_HOOK('ECSORT_MIX:ADJUST_INDEX',1,ZHOOK_HANDLE)
END SUBROUTINE ADJUST_INDEX


SUBROUTINE GET_RANK(INDEX, RANK, INDEX_ADJ)
INTEGER(KIND=JPIM), INTENT(IN) :: INDEX(:)
INTEGER(KIND=JPIM), INTENT(OUT):: RANK(:)
INTEGER(KIND=JPIM), INTENT(IN), OPTIONAL :: INDEX_ADJ
INTEGER(KIND=JPIM) :: I, N
REAL(KIND=JPHOOK) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('ECSORT_MIX:GET_RANK',0,ZHOOK_HANDLE)
N = MIN(SIZE(INDEX),SIZE(RANK))
IF (PRESENT(INDEX_ADJ)) THEN
  DO I=1,N
    RANK(INDEX(I)+INDEX_ADJ) = I
  ENDDO
ELSE
  DO I=1,N
    RANK(INDEX(I)) = I
  ENDDO
ENDIF
IF (LHOOK) CALL DR_HOOK('ECSORT_MIX:GET_RANK',1,ZHOOK_HANDLE)
END SUBROUTINE GET_RANK


#undef INT_VERSION
#undef REAL_VERSION

!-- Create version for INTEGER(KIND=JPIM)
#define INT_VERSION   4
#define REAL_VERSION  0
#include "ecsort_shared.h"
#undef INT_VERSION
#undef REAL_VERSION

!-- Create version for INTEGER(KIND=JPIB)
#define INT_VERSION   8
#define REAL_VERSION  0
#include "ecsort_shared.h"
#undef INT_VERSION
#undef REAL_VERSION

!-- Create version for REAL(KIND=JPRM)
#define INT_VERSION   0
#define REAL_VERSION  4
#include "ecsort_shared.h"
#undef INT_VERSION
#undef REAL_VERSION

!-- Create version for REAL(KIND=JPRD)
#define INT_VERSION   0
#define REAL_VERSION  8
#include "ecsort_shared.h"
#undef INT_VERSION
#undef REAL_VERSION

END MODULE ECSORT_MIX

! (C) Copyright 2005- ECMWF.
!
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!

!
! Simple Test program
!
subroutine fail_impl(msg,line)
use mpl_module, only : mpl_abort
character(*) :: msg
integer :: line

write(0,'(A,I0,A)') "TEST FAILED in alltoallv @ line ",line," :"
write(0,*) msg

call mpl_abort()

end subroutine

#define FAIL(msg) call fail_impl(msg,__LINE__)
subroutine work1(r)
implicit none
integer, intent(out) :: r

real a(100000)
call  random_number(a)
if (any(a < 0.0) ) then
  r =1
else
  r =0
endif
end subroutine work1


program test_mpl_alltoallv
use ec_parkind, only : jpim, jprm, jprd
use mpl_module, only: mpl_init, mpl_end, mpl_rank, linitmpi_via_mpl, mpl_alltoallv, JP_NON_BLOCKING_STANDARD, mpl_wait

implicit none

integer(jpim) :: nprocs
logical :: verbose = .false.
integer(jpim), allocatable :: sbuf(:), rbuf(:), scounts(:), rcounts(:)
real(jprm), allocatable :: sbufr(:), rbufr(:)
real(jprd), allocatable :: sbufd(:), rbufd(:)
integer i,j,k
character(len=256) msg

call mpl_init(KPROCS=nprocs,ldinfo=verbose,ldenv=.true.)

if( nprocs <= 1 ) FAIL("nprocs must be > 1")
if( mpl_rank < 1 .or. mpl_rank > nprocs  ) FAIL("mpl_rank must be >= 1 and <= nprocs")
if( .not. linitmpi_via_mpl ) FAIL("linitmpi_via_mpl must be True")

allocate(sbuf((nprocs*(nprocs+1))/2),rbuf(nprocs*mpl_rank),&
  sbufr((nprocs*(nprocs+1))/2),rbufr(nprocs*mpl_rank), &
  sbufd((nprocs*(nprocs+1))/2),rbufd(nprocs*mpl_rank),&
  scounts(nprocs),rcounts(nprocs))

k=1
do i=1,nprocs
  do j=1,i
    sbuf (k) = mpl_rank
    sbufr(k) = mpl_rank
    sbufd(k) = mpl_rank
    k=k+1
  enddo
  scounts(i)=i
enddo
rcounts(:)=mpl_rank

call do_alltoallv_blocking()
call do_alltoallv_nonblocking()

call mpl_end(ldmeminfo=verbose)
! Note that with mpi_serial meminfo will not be printed regardless of ldmeminfo

contains

subroutine do_alltoallv_blocking
implicit none

character(len=256) :: msg

integer request_i, request_r, request_d, i, j, k, res
integer sdispl(nprocs), rdispl(nprocs), rqarray(3)

if (mpl_rank == 1) write(0,*) "test nonblocking"

call mpl_alltoallv(sbuf,scounts,rbuf,rcounts)
call mpl_alltoallv(sbufr,scounts,rbufr,rcounts)
call mpl_alltoallv(sbufd,scounts,rbufd,rcounts)

k=1
do i=1,size(rbuf),mpl_rank
  if ( any(rbuf(i:i+mpl_rank-1) /= k) ) then
    write(msg,*) "blocking int alltoall test test failed on mpl_rank", mpl_rank, rbuf
    FAIL(msg)
  endif
  if ( any(nint(rbufr(i:i+mpl_rank-1)) /= k) ) then
    write(msg,*) "blocking real alltoall test test failed on mpl_rank", mpl_rank, rbufr
    FAIL(msg)
  endif
  if ( any(nint(rbufd(i:i+mpl_rank-1)) /= k) ) then
    write(msg,*) "blocking double alltoall test test failed on mpl_rank", mpl_rank, rbufd
    FAIL(msg)
  endif
  k=k+1
enddo

end subroutine do_alltoallv_blocking

subroutine do_alltoallv_nonblocking()
implicit none

character(len=256) :: msg

integer request_i, request_r, request_d, i, j, k, res
integer sdispl(nprocs), rdispl(nprocs), rqarray(3)

if (mpl_rank == 1) write(0,*) "test nonblocking"

! trying to get a random failure
do j=1,1
  call mpl_alltoallv(sbuf,scounts,rbuf,rcounts, KMP_TYPE = JP_NON_BLOCKING_STANDARD, KREQUEST=request_i)
  call mpl_alltoallv(sbufr,scounts,rbufr,rcounts, KMP_TYPE = JP_NON_BLOCKING_STANDARD, KREQUEST=request_r)
  call mpl_alltoallv(sbufd,scounts,rbufd,rcounts, KMP_TYPE = JP_NON_BLOCKING_STANDARD, KREQUEST=request_d)
  call work1(res)
  if ( res > 0 ) write(0,*) "error in  work1 non-blocking alltoallv" ! this should not happen ever !!!
  !call mpl_wait(request_r)
  call mpl_wait(request_d)
  !call mpl_wait(request_i)
  rqarray = [request_i, request_r, request_d]
  call mpl_wait(rqarray(1:2))
enddo
k = 1
do i=1,size(rbuf),mpl_rank
  if ( any(rbuf(i:i+mpl_rank-1) /= k) ) then
    write(msg,*) "nonblocking int alltoall test failed on mpl_rank", mpl_rank, rbuf
    FAIL(msg)
  endif
  if ( any(nint(rbufr(i:i+mpl_rank-1)) /= k) ) then
    write(msg,*) "nonblocking real alltoall test failed on mpl_rank", mpl_rank, rbuf
    FAIL(msg)
  endif
  if ( any(nint(rbufd(i:i+mpl_rank-1)) /= k) ) then
    write(msg,*) "nonblocking double alltoall test failed on mpl_rank", mpl_rank, rbuf
    FAIL(msg)
  endif
  k = k+1
enddo

! test with displacement arguments
sdispl(1)=0
rdispl(1)=0
do i=2,nprocs
  sdispl(i)=sdispl(i-1)+scounts(i-1)
  rdispl(i)=rdispl(i-1)+rcounts(i-1)
enddo

call mpl_alltoallv(sbuf, scounts, rbuf, rcounts, sdispl, rdispl, KMP_TYPE = JP_NON_BLOCKING_STANDARD, KREQUEST=request_i)
call work1(res)
if ( res > 0 ) write(0,*) "error in  work1 non-blocking alltoallv" ! this should not happen ever !!!
call mpl_wait(request_i)

k=1
do i=1,nprocs,mpl_rank
  if ( any(rbuf(i:i+mpl_rank-1) /= k) ) then
    write(msg,*) "nonblocking int alltoall test with displ args failed on mpl_rank", mpl_rank, rbuf
    FAIL(msg)
  endif
  k=k+1
enddo
end subroutine do_alltoallv_nonblocking

end program test_mpl_alltoallv

! (C) Copyright 2005- ECMWF.
! (C) Copyright 2013- Meteo-France.
! 
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!

SUBROUTINE ABOR1FL(CDFILE, KLINENUM, CDTEXT)
  !! Abort that prints file, line, and message
  !! Tracebacks will be printed if possible
  !! All processes will be terminated in parallel MPI context

USE EC_PARKIND  ,ONLY : JPIM
USE EC_LUN   ,ONLY : NULOUT, NULERR
USE MPL_MODULE    ,ONLY : MPL_ABORT
USE OML_MOD       ,ONLY : OML_MY_THREAD
IMPLICIT NONE

CHARACTER(LEN=*),   INTENT(IN) :: CDFILE
INTEGER(KIND=JPIM), INTENT(IN) :: KLINENUM
CHARACTER(LEN=*),   INTENT(IN) :: CDTEXT

IF (LEN(CDFILE) > 0 .AND. KLINENUM > 0) THEN
  IF (NULOUT >= 0 .AND. NULOUT /= 6 .AND. NULOUT /= NULERR) THEN
    WRITE(NULOUT,'(A,I0,A,I0,A,A,A,I0,A,A)') 'ABOR1     [PROC=',MYPROC(),',THRD=',OML_MY_THREAD(),'] from [',CDFILE,' +',KLINENUM,'] : ', CDTEXT
  ENDIF
  IF (NULERR >= 0) THEN
    WRITE(NULERR,'(A,I0,A,I0,A,A,A,I0,A,A)') 'ABOR1     [PROC=',MYPROC(),',THRD=',OML_MY_THREAD(),'] from [',CDFILE,' +',KLINENUM,'] : ', CDTEXT
  ENDIF
ELSE
  IF (NULOUT >= 0 .AND. NULOUT /= 6 .AND. NULOUT /= NULERR) THEN
    WRITE(NULOUT,'(A,I0,A,I0,A,A)') 'ABOR1     [PROC=',MYPROC(),',THRD=',OML_MY_THREAD(),'] : ', CDTEXT
  ENDIF
  IF (NULERR >= 0 ) THEN
    WRITE(NULERR,'(A,I0,A,I0,A,A)') 'ABOR1     [PROC=',MYPROC(),',THRD=',OML_MY_THREAD(),'] : ', CDTEXT
  ENDIF
ENDIF

IF (NULOUT >= 0) THEN
  CALL EC_FLUSH(NULOUT)
  IF (NULOUT /= 0 .AND. NULOUT /= 6) CLOSE(NULOUT)
ENDIF
CALL EC_FLUSH(NULERR)

IF(LEN(CDTEXT) <= 512) THEN
  CALL MPL_ABORT(CDTEXT)
ELSE
  CALL MPL_ABORT
ENDIF

CONTAINS

FUNCTION MYPROC() RESULT(IPROC)
  USE MPL_MPIF
  IMPLICIT NONE
  INTEGER(KIND=JPIM) :: IERROR,IPROC
  LOGICAL :: LMPI_INITIALIZED
  IPROC = 1
  CALL MPI_INITIALIZED(LMPI_INITIALIZED,IERROR) ! always thread safe, see standard !
  IF( LMPI_INITIALIZED ) THEN
    CALL MPI_COMM_RANK(MPI_COMM_WORLD,IPROC,IERROR) ! always thread safe, see standard !
    IPROC = IPROC+1 ! 1-based in IFS context
  ENDIF
END FUNCTION

END SUBROUTINE ABOR1FL


SUBROUTINE ABOR1(CDTEXT)
  !! Abort that prints message without file and line number
  !! Delegates to ABOR1FL
  !! Tracebacks will be printed if possible
  !! All processes will be terminated in parallel MPI context

IMPLICIT NONE
CHARACTER(LEN=*), INTENT(IN) :: CDTEXT
CALL ABOR1FL("",0,CDTEXT)
END SUBROUTINE ABOR1


SUBROUTINE ABOR1_EXCEPTION_HANDLER()
  !! This routine, when registered as the fckit exception handler, will be called
  !! whenever any C++ exception is thrown. The exception is intercepted and can
  !! be inquired through the variable FCKIT_EXCEPTION.
  !! An exception can also be thrown within Fortran:
  !!    CALL FCKIT_EXCEPTION%ABORT("I have my reasons")

#ifdef WITH_FCKIT
USE FCKIT_MODULE, ONLY : FCKIT_EXCEPTION
IF( FCKIT_EXCEPTION%LOCATION%IS_SET() ) then 
  CALL ABOR1FL( FCKIT_EXCEPTION%LOCATION%FILE(), FCKIT_EXCEPTION%LOCATION%LINE(), FCKIT_EXCEPTION%WHAT() )
ELSE
  CALL ABOR1( FCKIT_EXCEPTION%WHAT() )
ENDIF
#else
CALL ABOR1( "An unknown exception is handled via ABOR1_EXCEPTION_HANDLER. Compile fiat with fckit to get a better error message" )
#endif
END SUBROUTINE

SUBROUTINE SET_ABOR1_EXCEPTION_HANDLER() BIND(C,NAME="set_abor1_exception_handler")
  !! This routine registers ABOR1 as the C++ exception handler, will be called
  !! whenever any C++ exception is thrown and not caught.
  !! The exception is intercepted and can be inquired through
  !! the variable FCKIT_EXCEPTION.
  !! An exception can also be thrown within Fortran:
  !!    CALL FCKIT_EXCEPTION%ABORT("I have my reasons")

#ifdef WITH_FCKIT
USE FCKIT_MODULE, ONLY : FCKIT_EXCEPTION, FCKIT_EXCEPTION_HANDLER
EXTERNAL :: ABOR1_EXCEPTION_HANDLER
PROCEDURE(FCKIT_EXCEPTION_HANDLER), POINTER :: FUNPTR
FUNPTR => ABOR1_EXCEPTION_HANDLER
CALL FCKIT_EXCEPTION%SET_HANDLER( FUNPTR )
#endif
END SUBROUTINE

! (C) Copyright 2005- ECMWF.
! (C) Copyright 2013- Meteo-France.
! 
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!

SUBROUTINE GSTATS_LABEL(KNUM, CTYPE, CDESC)

USE EC_PARKIND, ONLY: JPIM
USE YOMGSTATS, ONLY: JPMAXSTAT, CCDESC, CCTYPE, JPERR

IMPLICIT NONE

INTEGER(KIND=JPIM) :: KNUM
CHARACTER(*) :: CDESC
CHARACTER(*) :: CTYPE
INTEGER(KIND=JPIM) :: ILEN, ITLEN

IF (KNUM < 0 .OR. KNUM > JPMAXSTAT) CALL ABOR1('GSTATS_LABEL:ILLEGAL KNUM')
ILEN = LEN(CDESC)
ILEN = MIN(ILEN,50)
ITLEN = LEN(CTYPE)
ITLEN = MIN(ILEN,3)
IF (CCDESC(KNUM) == '') THEN
  CCDESC(KNUM) = CDESC(1:ILEN)
  CCTYPE(KNUM) = CTYPE(1:ITLEN)
ELSEIF (CCDESC(KNUM)(1:ILEN) /= CDESC(1:ILEN)) THEN
  WRITE(JPERR,*) 'LABEL', KNUM, ' USED ', CCDESC(KNUM)
  CALL ABOR1('GSTATS_LABEL:OVERWRITE OF USED LABEL')
ENDIF

END SUBROUTINE GSTATS_LABEL

! (C) Copyright 2005- ECMWF.
! (C) Copyright 2013- Meteo-France.
! 
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!

MODULE MPL_ALLGATHER_MOD

!**** MPL_ALLGATHER Send data to all processes

!     Purpose.
!     --------
!     Send a message to all processes from a buffer.
!     The data may be REAL*4, REAL*8,or INTEGER, one dimensional array
!                     REAL*4,or REAL*8, two dimensional array
!                  or INTEGER scalar

!**   Interface.
!     ----------
!        CALL MPL_ALLGATHER

!        Input required arguments :
!        -------------------------
!           PSENDBUF -  buffer containing message
!                       (can be type REAL*4, REAL*8 or INTEGER)
!           PRECVBUF -  buffer containing message
!                       (can be type REAL*4, REAL*8 or INTEGER)
!           KRECVCOUNTS-number of elements received from each process

!        Input optional arguments :
!        -------------------------
!           KCOMM    -  Communicator number if different from MPI_COMM_WORLD 
!                       or from that established as the default 
!                       by an MPL communicator routine
!           KMP_TYPE -  buffering type (see MPL_BUFFER_METHOD)
!                       overrides value provided to MPL_BUFFER_METHOD
!           KRECVDISPL -displacements in PRECVBUF at which to place 
!                       the incoming data
!           CDSTRING -  Character string for ABORT messages
!                       used when KERROR is not provided

!        Output required arguments :
!        -------------------------
!           none

!        Output optional arguments :
!        -------------------------
!           KREQUEST -  Communication request
!                       required when buffering type is non-blocking
!           KERROR   -  return error code.     If not supplied, 
!                       MPL_ALLGATHER aborts when an error is detected.
!     Author.
!     -------
!        D.Dent, M.Hamrud     ECMWF

!     Modifications.
!     --------------
!        Original: 2000-11-23
!        M.Hamrud     : 2014-10-22 : Add nonblocking option
!      F. Vana  05-Mar-2015  Support for single precision

!     ------------------------------------------------------------------

USE EC_PARKIND  ,ONLY : JPIM

USE MPL_MPIF
USE MPL_DATA_MODULE
USE MPL_MESSAGE_MOD
USE MPL_SEND_MOD
USE MPL_RECV_MOD
USE MPL_BARRIER_MOD

IMPLICIT NONE

PRIVATE

INTEGER(KIND=JPIM) :: IR,ISENDCOUNT,IRECVCOUNT,ICOMM,IERROR
LOGICAL :: LLABORT=.TRUE.
INTEGER(KIND=JPIM) :: ITAG
LOGICAL :: LLBARRIER
INTEGER(KIND=JPIM) :: IMAXMSG,JK,IMYPAIR,ICHUNKS,ISTS,ISTR,JMESS,ILENS,IENS,IOUNT,IMP_TYPE
INTEGER(KIND=JPIM) :: ILIMIT,IBARRFREQ,IDUM

PUBLIC MPL_ALLGATHER

CONTAINS

SUBROUTINE MPL_ALLGATHER()
RETURN
END SUBROUTINE MPL_ALLGATHER
END MODULE MPL_ALLGATHER_MOD

! (C) Copyright 2005- ECMWF.
! 
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!

program test_drhook
use yomhook
use oml_mod
use mpl_module
#ifdef WITH_FCKIT
use fckit_module
#endif
implicit none
real(jphook) :: zhook_handle
integer :: nproc, myproc

call test_init()

if (lhook) call dr_hook('test_drhook',0,zhook_handle)
call function_1()
if (lhook) call dr_hook('test_drhook',1,zhook_handle)

call test_end()

contains

subroutine function_3
implicit none
#include "abor1.intfb.h"
real(jphook) :: zhook_handle
real(jphook) :: automatic_array(10,10)
if (lhook) call dr_hook('function_3',0,zhook_handle)
automatic_array = 2
if( do_abort() .and. oml_my_thread() == oml_max_threads() .and. ( myproc == nproc ) ) then
    call abor1fl("test_drhook_fortran.F90",__LINE__,"problem in function_3")
endif
if (lhook) call dr_hook('function_3',1,zhook_handle)    
end subroutine

subroutine function_2
implicit none
real(jphook) :: zhook_handle
real(jphook) :: automatic_array(10,10)
if (lhook) call dr_hook('function_2',0,zhook_handle)
automatic_array = 1
!$OMP PARALLEL
call function_3()
!$OMP END PARALLEL
call barrier()
if (lhook) call dr_hook('function_2',1,zhook_handle)    
end subroutine

subroutine function_1
implicit none
real(jphook) :: zhook_handle
real(jphook) :: automatic_array(10,10)
automatic_array = 3
if (lhook) call dr_hook('function_1',0,zhook_handle)
call function_2()
if (lhook) call dr_hook('function_1',1,zhook_handle)
end subroutine

! -----------------------------------------------------------------------------------------
! Initialization and Finalization
! -----------------------------------------------------------------------------------------

subroutine test_init
use ec_env_mod, only : ec_setenv

if( mpl() ) then
    call mpl_init(ldinfo=.true.)
    nproc = mpl_numproc
    myproc = mpl_rank
#ifdef WITH_FCKIT
elseif( fckit() ) then
    call fckit_main%init()
    nproc = fckit_mpi%size()
    myproc = fckit_mpi%rank() + 1
#else
else
    nproc = 1
    myproc = 1
#endif
endif

call ec_setenv("DR_HOOK",        "1",   overwrite=.true.)
call ec_setenv("DR_HOOK_OPT",    "PROF",overwrite=.false.)
call ec_setenv("DR_HOOK_SILENT", "1",   overwrite=.false.)

end subroutine

subroutine test_end
call dr_hook_end()
if( mpl() ) then
  call mpl_end(ldmeminfo=.false.)
endif
end subroutine

! -----------------------------------------------------------------------------------------
! Utility functions, checking environment variables etc
! -----------------------------------------------------------------------------------------

function do_abort() result(labort)
    logical :: labort
    character(len=512) :: env
    call get_environment_variable("ABORT",env)
    if( env == '0' ) then
        labort = .false.
    else
        labort = .true.
    endif
end function

function mpl() result(lmpl)
    logical :: lmpl
    character(len=512) :: env
    call get_environment_variable("MPL",env)
    if( env == '0' ) then
        lmpl = .false.
    else
        lmpl = .true.
    endif
end function

function fckit() result(lfckit)
    logical :: lfckit
    character(len=512) :: env
    call get_environment_variable("FCKIT",env)
    if( env == '0' ) then
        lfckit = .false.
    else
        lfckit = .true.
    endif
end function

subroutine barrier()
    if( mpl() ) then
        call mpl_barrier()
#ifdef WITH_FCKIT
    elseif( fckit() ) then
        call fckit_mpi%barrier()
#endif
    endif
end subroutine

! -----------------------------------------------------------------------------------------

end program

! (C) Copyright 2005- ECMWF.
! (C) Copyright 2013- Meteo-France.
! 
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!

MODULE MPL_CLOSE_MOD
!
!     Purpose.  close an MPIIO file 
!     --------
!
!
!     Interface.
!     ----------
!        call mpl_close(...)
!
!        Explicit arguments :
!        --------------------
!
!        input arguments:
!        kfptr   - handle for file pointer
!        output arguments:
!        kerror  - error code
!
!        Implicit arguments :
!        --------------------
!
!     Method.
!     -------
!     MPL supports 4 styles of MPIIO
!
!     kop = 1    -  Blocking, non collective, shared file pointer
!                   using MPI_FILE_WRITE_SHARED,
!                         MPI_FILE_READ_SHARED
!     kop = 2    -  Blocking, collective, ordered, shared file pointer
!                   using MPI_FILE_WRITE_ORDERED,
!                         MPI_FILE_READ_ORDERED
!     kop = 3    -  Non Blocking, non collective, shared file pointer
!                   using MPI_FILE_IWRITE_SHARED,
!                         MPI_FILE_IREAD_SHARED
!                   and MPI_WAIT
!     kop = 4    -  Non Blocking, collective, ordered, shared file pointer
!                   using MPI_FILE_WRITE_ORDERED_BEGIN/END,
!                         MPI_FILE_READ_ORDERED_BEGIN/END
!
!     Externals.
!     ----------
!
!     Reference.
!     ----------
!        none yet
!
!     Author.
!     -------
!        G.Mozdzynski
!
!     Modifications.
!     --------------
!        Original : 2000-12-08 (Based on MPE_CLOSE)
!        R. EL Khatib 24-May-2011 Change ifdef MPI2 into ifndef MPI1
!     -----------------------------------------------------------------
!
USE EC_PARKIND  ,ONLY : JPIM

USE MPL_DATA_MODULE
USE MPL_MESSAGE_MOD
USE MPL_IOINIT_MOD

IMPLICIT NONE

PRIVATE
PUBLIC MPL_CLOSE

CONTAINS

SUBROUTINE MPL_CLOSE(KFPTR,KERROR)


#ifdef USE_8_BYTE_WORDS
  USE MPI4TO8, ONLY : &
    MPI_FILE_CLOSE => MPI_FILE_CLOSE8
#endif

INTEGER(KIND=JPIM),INTENT(IN) :: KFPTR
INTEGER(KIND=JPIM),INTENT(OUT) :: KERROR
!
#ifndef MPI1

!     -----------------------------------------------------------------
!
!     1.    Preamble
!           --------
IF( MPL_RANK > MPL_NUMIO ) THEN
  KERROR = -1
  RETURN
ENDIF
!
!     -----------------------------------------------------------------
!
!     1.    Close the File
!           --------------
CALL MPI_FILE_CLOSE(KFPTR,KERROR)
!
!     -----------------------------------------------------------------
#else

CALL ABOR1('MPI_CLOSE not built with MPI2')

#endif
!
RETURN
END SUBROUTINE MPL_CLOSE

END MODULE MPL_CLOSE_MOD

! (C) Copyright 2005- ECMWF.
! (C) Copyright 2013- Meteo-France.
! 
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!

SUBROUTINE EC_MEMINFO(KU,CDSTRING,KCOMM,KBARR,KIOTASK,KCALL)

USE EC_PARKIND, ONLY : JPIM, JPIB, JPRD
USE MPL_MPIF
USE EC_ARGS_MOD, ONLY : EC_ARGV

IMPLICIT NONE

!-- EC_MEMINFO:
!   Author   : Peter Towers (ECMWF)  : 2015-2016
!   Modified : Sami Saarinen (ECMWF) : 21-SEP-2016 : Added getenv EC_MEMINFO -- export EC_MEMINFO=0 disables any EC_MEMINFO output
!              Sami Saarinen (ECMWF) : 02-MAR-2017 : Enabled flexible number of sockets & lots of tidying
!              Sami Saarinen (ECMWF) : 09-MAR-2017 : Power monitoring added (via EC_PMON) -- works at least on Cray systems
!              Sami Saarinen (ECMWF) : 12-MAR-2017 : Gather core affinities via call to ec_coreid()
!              Sami Saarinen (ECMWF) : 12-DEC-2017 : Obtain MPI & OpenMP version information
!              Sami Saarinen (HPCK)  : 21-FEB-2022 : Cleaned up for FIAT (the Fortran IFS and Arpege Toolkit)

#include "ec_pmon.intfb.h"

INTEGER(KIND=JPIM), INTENT(IN) :: KU,KCOMM,KBARR,KIOTASK,KCALL
CHARACTER(LEN=*), INTENT(IN) :: CDSTRING
INTEGER(KIND=JPIM), PARAMETER :: ITAG = 32099 ! A prime number below 2^15 = 32768
INTEGER(KIND=JPIM) :: ID,KULOUT
INTEGER(KIND=JPIM) :: II,JJ,I,J,K,MYPROC,NPROC,LEN,ERROR,NODENUM,JID
INTEGER(KIND=JPIB) :: TASKSMALL,NODEHUGE,MEMFREE,CACHED,NFREE
INTEGER(KIND=JPIB),SAVE :: NODEHUGE_CACHED
INTEGER(KIND=JPIB),SAVE :: NODEHUGE_PAGE_COUNT = 0
INTEGER(KIND=JPIM), PARAMETER :: MAXNUMA_DEF = 8 ! Max number of "sockets" supported by default
INTEGER(KIND=JPIM), SAVE :: MAXNUMA = 0 ! Max number of "sockets" supported -- initialized to zero to enforce updated value (env EC_MAXNUMA)
INTEGER(KIND=JPIM) :: NNUMA ! Actual number of "sockets" (can be 0 on systems that do not have /proc/buddyinfo, e.g. WSL)
!INTEGER(KIND=JPIB),DIMENSION(0:MAXNUMA-1) :: SMALLPAGE,HUGEPAGE
INTEGER(KIND=JPIB),DIMENSION(:),ALLOCATABLE,SAVE :: SMALLPAGE,HUGEPAGE
INTEGER(KIND=JPIB) :: GETMAXRSS,GETMAXHWM
INTEGER(KIND=JPIB) :: HEAP_SIZE
INTEGER(KIND=JPIB), PARAMETER :: ONEMEGA = 1024_JPIB * 1024_JPIB
INTEGER(KIND=JPIB) :: ENERGY, POWER
INTEGER(KIND=JPIB) :: TOT_ENERGY, MAXPOWER, AVGPOWER
INTEGER(KIND=JPIB) :: RUNNING, LOADAVG ! /proc/loadavg: running processes (parse 4th column thisvalue/totprocesses) and last 1 minute load (x 100)
INTEGER(KIND=JPIB),SAVE :: PAGESIZE = 0
INTEGER(KIND=JPIM),SAVE :: MAXTH = 0
INTEGER(KIND=JPIM),SAVE :: MAXTH_COMP = 0
INTEGER(KIND=JPIM),SAVE :: MAXTH_IO = 0
INTEGER(KIND=JPIM),PARAMETER :: MAXCOLS = 18 ! Max numerical columns in /proc/buddyinfo (often just 11, but Cray has 18 entries)
INTEGER(KIND=JPIM) :: N18
!INTEGER(KIND=JPIB),DIMENSION(0:MAXCOLS-1,0:MAXNUMA-1) :: NODE, BUCKET
!INTEGER(KIND=JPIB),DIMENSION(7+2*MAXNUMA) :: SENDBUF,RECVBUF
INTEGER(KIND=JPIB),DIMENSION(:,:),ALLOCATABLE,SAVE :: NODE, BUCKET
INTEGER(KIND=JPIB),DIMENSION(:),ALLOCATABLE,SAVE :: SENDBUF,RECVBUF
REAL(KIND=JPRD) :: PERCENT_USED(2)
CHARACTER(LEN=256) :: CLSTR
CHARACTER(LEN=512) :: TMPDIR
CHARACTER(LEN=512), SAVE :: PROGRAM = ' '
CHARACTER(LEN=20)  :: NODENAME,LASTNODE,CLMAXNODE
CHARACTER(LEN=12)  :: VAL
CHARACTER(LEN=1)   :: M
CHARACTER(LEN=160) ::LINE
CHARACTER(LEN=56) :: FILENAME
CHARACTER(LEN=1), save :: CLEC_MEMINFO = '1'
CHARACTER(LEN=5) :: CSTAR
#ifdef __PGI
CHARACTER(LEN=64) :: ID_STRING
#else
CHARACTER(LEN=LEN(CSTAR)+1+LEN(CDSTRING)) :: ID_STRING
#endif
CHARACTER(LEN=10) ::  CLDATEOD,CLTIMEOD,CLZONEOD
CHARACTER(LEN=3), PARAMETER :: CLMON(1:12) = (/ &
     'Jan','Feb','Mar','Apr','May','Jun', &
     'Jul','Aug','Sep','Oct','Nov','Dec' /)
INTEGER(KIND=JPIM) :: IVALUES(8), IMON
INTEGER(KIND=JPIM) :: IRECV_STATUS(MPI_STATUS_SIZE)
LOGICAL :: LLNOCOMM, LLNOHDR
INTEGER(KIND=JPIM), SAVE :: IAM_NODEMASTER = 0
LOGICAL, SAVE :: LLFIRST_TIME = .TRUE.
TYPE RANKNODE_T
   INTEGER(KIND=JPIM) :: NODENUM
   INTEGER(KIND=JPIM) :: PID
   INTEGER(KIND=JPIM) :: RANK_WORLD
   INTEGER(KIND=JPIM) :: RANK
   INTEGER(KIND=JPIM) :: IORANK
   INTEGER(KIND=JPIM) :: NODEMASTER
   INTEGER(KIND=JPIM) :: NUMTH
   INTEGER(KIND=JPIM), ALLOCATABLE :: COREIDS(:)
   CHARACTER(LEN=LEN(NODENAME)) :: NODE
   CHARACTER(LEN=LEN(CLSTR)) :: STR
END TYPE
TYPE (RANKNODE_T), ALLOCATABLE, SAVE :: RN(:)
INTEGER(KIND=JPIM), ALLOCATABLE :: COREIDS(:)
LOGICAL, ALLOCATABLE :: DONE(:)
INTEGER(KIND=JPIM), SAVE :: NUMNODES = 0
INTEGER(KIND=JPIM) :: NN
INTEGER(KIND=JPIM), SAVE :: IOTASKS = 0
INTEGER(KIND=JPIM) :: IORANK, NSEND, NRECV
LOGICAL :: FILE_EXISTS
REAL(KIND=JPRD), EXTERNAL :: UTIL_WALLTIME
REAL(KIND=JPRD), SAVE :: WT0
REAL(KIND=JPRD) :: WT
CHARACTER(LEN=64) :: CLPFX
CHARACTER(LEN=3) :: ZUM
INTEGER(KIND=JPIM) :: IPFXLEN, NUMTH, MYTH, IPID, ICOREID
INTEGER(KIND=JPIM) :: KHZ
INTEGER, external :: EC_GETPID, EC_COREID ! from ec_env.c
INTEGER(KIND=JPIM) :: NCOMM_MEMINFO = 0
COMMON /cmn_meminfo/ NCOMM_MEMINFO
!-- In case this file was compiled w/o OpenMP :
INTEGER :: OMP_GET_MAX_THREADS, OMP_GET_THREAD_NUM
#ifdef _OPENMP
EXTERNAL OMP_GET_MAX_THREADS, OMP_GET_THREAD_NUM
#else
OMP_GET_MAX_THREADS() = 1
OMP_GET_THREAD_NUM() = 0
#endif

IF (LLFIRST_TIME) THEN
   WT0 = UTIL_WALLTIME()
   CALL GET_ENVIRONMENT_VARIABLE('EC_MEMINFO',CLEC_MEMINFO)
   IF (CLEC_MEMINFO == '0') LLFIRST_TIME = .FALSE.
ENDIF
IF (CLEC_MEMINFO == '0') RETURN

IF (MAXTH == 0) MAXTH = OMP_GET_MAX_THREADS()

LLNOCOMM = (KCOMM == -1 .or. KCOMM == -2)
LLNOHDR = (KCOMM == -2)

IF (LLNOCOMM) THEN
   ! Direct call to obtain EC_meminfo -output
   ERROR = 0
   MYPROC = 0
   NPROC = 1
   CLPFX = CDSTRING
   IPFXLEN = LEN_TRIM(CLPFX)
   ZUM = 'tsk'
ELSE
   CLPFX = ' '
   IPFXLEN = 0
   ZUM = 'sum'
   CALL MPI_COMM_RANK(KCOMM,MYPROC,ERROR)
   CALL CHECK_ERROR("from MPI_COMM_RANK",__FILE__,__LINE__)

   CALL MPI_COMM_SIZE(KCOMM,NPROC,ERROR)
   CALL CHECK_ERROR("from MPI_COMM_SIZE",__FILE__,__LINE__)

   IF (KCALL == 0) THEN
      CALL CONDBARR()
      CALL CHECK_ERROR("from MPI_BARRIER(at start)",__FILE__,__LINE__)
   ENDIF
ENDIF

IF (LLFIRST_TIME) THEN ! The *very* first time
   CALL EC_PMON(ENERGY,POWER)

   !-- Neither of these two may stop working when linking with C++ (like in OOPS) ...
   ! CALL GETARG(0,PROGRAM)
   ! CALL GET_COMMAND_ARGUMENT(0,PROGRAM)
   !... so using ec_args_mod:
   PROGRAM = EC_ARGV(0)

   PAGESIZE = 0
   NODEHUGE_PAGE_COUNT = 0
   
!!234567890!234567890!234
!HugePages_Total:   24000
!Hugepagesize:       2048 kB

   OPEN(FILE="/proc/meminfo",UNIT=502,STATUS="old",ACTION="read",ERR=1977)
   DO WHILE (PAGESIZE == 0 .or. NODEHUGE_PAGE_COUNT == 0)
      READ(502,'(a)',ERR=1988,END=1988) LINE
      IF(LINE(1:15) == "HugePages_Total") THEN
         READ(LINE(17:25),*) NODEHUGE_PAGE_COUNT
      ELSEIF(LINE(1:12) == "Hugepagesize") THEN
         READ(LINE(14:25),*) PAGESIZE ! directly in kB
      ENDIF
   ENDDO
1988 continue
   CLOSE(502)
1977 continue

   NODEHUGE=NODEHUGE_PAGE_COUNT*PAGESIZE
   NODEHUGE=NODEHUGE/1024
   NODEHUGE_CACHED = NODEHUGE
ENDIF

NODEHUGE=NODEHUGE_CACHED ! in MB

CALL EC_GETHOSTNAME(NODENAME) ! from support/env.c

IF (MAXNUMA == 0) THEN
   CALL GET_ENVIRONMENT_VARIABLE("EC_MAXNUMA",VAL) ! Note: *not* export EC_MEMINFO_MAXNUMA=<value>, but EC_MAXNUMA=<value>
   IF (VAL /= "") READ(VAL,*) MAXNUMA
   IF (MAXNUMA < 1) MAXNUMA = MAXNUMA_DEF
   ALLOCATE(SMALLPAGE(0:MAXNUMA-1))
   ALLOCATE(HUGEPAGE(0:MAXNUMA-1))
   ALLOCATE(NODE(0:MAXCOLS-1,0:MAXNUMA-1))
   ALLOCATE(BUCKET(0:MAXCOLS-1,0:MAXNUMA-1))
   ALLOCATE(SENDBUF(-1:7+2*MAXNUMA))
   ALLOCATE(RECVBUF(-1:7+2*MAXNUMA))
ENDIF

IF (MYPROC == 0) THEN 
!
! Use already open file for output or $EC_MEMINFO_TMPDIR/meminfo
! We do not use $TMPDIR as it may have been inherited from mother superiour (MOMS) node
!
   IF(KU == -1) THEN
      CALL GET_ENVIRONMENT_VARIABLE('EC_MEMINFO_TMPDIR',TMPDIR)
      IF (TMPDIR == ' ') TMPDIR = '.'
      !    write(0,*) '## EC_MEMINFO: KCOMM=',KCOMM
      !    CALL LINUX_TRBK()
      KULOUT=501
      OPEN(UNIT=KULOUT,FILE=TRIM(TMPDIR)//"/"//"meminfo.txt",STATUS='unknown', &
         & ACTION='write',POSITION='append')
   ELSE
      KULOUT=KU
   ENDIF
ENDIF

IF (LLFIRST_TIME .and. .not. LLNOCOMM) THEN
! Fetch affinities (over OpenMP threads)
! Note: I/O-tasks may now have different number of threads than on computational tasks
   ALLOCATE(COREIDS(0:MAXTH-1))
   COREIDS(:) = -1
#ifdef _OPENMP
!$OMP PARALLEL NUM_THREADS(MAXTH) SHARED(COREIDS) PRIVATE(I,MYTH,ICOREID)
!$OMP DO SCHEDULE(STATIC,1)
#endif
   DO I=1,MAXTH
      ICOREID = EC_COREID()
      MYTH = OMP_GET_THREAD_NUM()
      COREIDS(MYTH) = ICOREID ! False sharing here
   ENDDO
#ifdef _OPENMP
!$OMP END DO
!$OMP END PARALLEL
#endif

! Store the communicator we are in upon entering EC_MEMINFO for the first time -- to be used in the EC_MPI_FINALIZE
   NCOMM_MEMINFO = KCOMM
! Fetch node names & numbers per task
   IORANK = 0
   IF (KIOTASK > 0) IORANK = 1
   IF (MYPROC == 0) THEN
      CALL SLASH_PROC
      ALLOCATE(RN(0:NPROC-1))
      DO I=0,NPROC-1
         RN(I)%NODENUM = -1
         IF (I > 0) THEN ! Receive in the MPI-rank order of KCOMM (i.e. may not be the same as MPI_COMM_WORLD -order)
            CALL MPI_RECV(LASTNODE,LEN(LASTNODE),MPI_BYTE,I,ITAG,KCOMM,IRECV_STATUS,ERROR)
            CALL CHECK_ERROR("from MPI_RECV(LASTNODE)",__FILE__,__LINE__)
            CALL MPI_RECV(IORANK,1,MPI_INTEGER4,I,ITAG+1,KCOMM,IRECV_STATUS,ERROR)
            CALL CHECK_ERROR("from MPI_RECV(IORANK)",__FILE__,__LINE__)
            CALL MPI_RECV(K,1,MPI_INTEGER4,I,ITAG+2,KCOMM,IRECV_STATUS,ERROR)
            CALL CHECK_ERROR("from MPI_RECV(RANK_WORLD)",__FILE__,__LINE__)
            CALL MPI_RECV(IPID,1,MPI_INTEGER4,I,ITAG+3,KCOMM,IRECV_STATUS,ERROR)
            CALL CHECK_ERROR("from MPI_RECV(GETPID)",__FILE__,__LINE__)
            CALL MPI_RECV(NUMTH,1,MPI_INTEGER4,I,ITAG+4,KCOMM,IRECV_STATUS,ERROR)
            CALL CHECK_ERROR("from MPI_RECV(NUMTH)",__FILE__,__LINE__)
            CALL MPI_RECV(CLSTR,LEN(CLSTR),MPI_BYTE,I,ITAG+5,KCOMM,IRECV_STATUS,ERROR)
            CALL CHECK_ERROR("from MPI_RECV(CLSTR)",__FILE__,__LINE__)
            RN(I)%RANK = I
            RN(I)%STR = CLSTR
            RN(I)%PID = IPID
         ELSE
            LASTNODE=NODENAME
            NUMTH = MAXTH
            CALL MPI_COMM_RANK(MPI_COMM_WORLD,K,ERROR)
            RN(I)%RANK = 0 ! Itself
            RN(I)%STR = CDSTRING
            RN(I)%PID = EC_GETPID()
         ENDIF
         RN(I)%RANK_WORLD = K
         RN(I)%IORANK = IORANK
         RN(I)%NODEMASTER = 0
         RN(I)%NODE = LASTNODE
         ! Affinities
         RN(I)%NUMTH = NUMTH
         ALLOCATE(RN(I)%COREIDS(0:NUMTH-1))
         IF (I > 0) THEN ! Receive in MPI-rank order
            CALL MPI_RECV(RN(I)%COREIDS,NUMTH,MPI_INTEGER4,I,ITAG+6,KCOMM,IRECV_STATUS,ERROR)
            CALL CHECK_ERROR("from MPI_RECV(COREIDS)",__FILE__,__LINE__)
         ELSE
            RN(I)%COREIDS = COREIDS
         ENDIF
         IF (IORANK == 0) THEN
            MAXTH_COMP = MAX(MAXTH_COMP,NUMTH)
         ELSE
            MAXTH_IO = MAX(MAXTH_IO,NUMTH)
         ENDIF
      ENDDO
      
      CALL RNSORT(KULOUT) ! Output now goes to "meminfo.txt"

      IAM_NODEMASTER = RN(0)%NODEMASTER ! Itself
      DO I=1,NPROC-1
         CALL MPI_SEND(RN(I)%NODEMASTER,1,MPI_INTEGER4,I,ITAG+7,KCOMM,ERROR)
         CALL CHECK_ERROR("from MPI_SEND(IAM_NODEMASTER)",__FILE__,__LINE__)
      ENDDO
   ELSE
      CALL MPI_SEND(NODENAME,LEN(NODENAME),MPI_BYTE,0,ITAG,KCOMM,ERROR)
      CALL CHECK_ERROR("from MPI_SEND(NODENAME)",__FILE__,__LINE__)
      CALL MPI_SEND(IORANK,1,MPI_INTEGER4,0,ITAG+1,KCOMM,ERROR)
      CALL CHECK_ERROR("from MPI_SEND(IORANK)",__FILE__,__LINE__)
      CALL MPI_COMM_RANK(MPI_COMM_WORLD,K,ERROR)
      CALL MPI_SEND(K,1,MPI_INTEGER4,0,ITAG+2,KCOMM,ERROR)
      CALL CHECK_ERROR("from MPI_SEND(RANK_WORLD)",__FILE__,__LINE__)
      IPID = EC_GETPID()
      CALL MPI_SEND(IPID,1,MPI_INTEGER4,0,ITAG+3,KCOMM,ERROR)
      CALL CHECK_ERROR("from MPI_SEND(GETPID)",__FILE__,__LINE__)
      CALL MPI_SEND(MAXTH,1,MPI_INTEGER4,0,ITAG+4,KCOMM,ERROR)
      CALL CHECK_ERROR("from MPI_SEND(MAXTH)",__FILE__,__LINE__)
      CLSTR = CDSTRING
      CALL MPI_SEND(CLSTR,LEN(CLSTR),MPI_BYTE,0,ITAG+5,KCOMM,ERROR)
      CALL CHECK_ERROR("from MPI_SEND(CLSTR)",__FILE__,__LINE__)
      CALL MPI_SEND(COREIDS,MAXTH,MPI_INTEGER4,0,ITAG+6,KCOMM,ERROR)
      CALL CHECK_ERROR("from MPI_SEND(COREIDS)",__FILE__,__LINE__)
      CALL MPI_RECV(IAM_NODEMASTER,1,MPI_INTEGER4,0,ITAG+7,KCOMM,IRECV_STATUS,ERROR)
      CALL CHECK_ERROR("from MPI_RECV(IAM_NODEMASTER)",__FILE__,__LINE__)
   ENDIF
   DEALLOCATE(COREIDS)
   LLFIRST_TIME = .FALSE.
   CALL CONDBARR()
   CALL CHECK_ERROR("from MPI_BARRIER near LLFIRST_TIME=.FALSE.",__FILE__,__LINE__)
ENDIF

IF (MYPROC == 0 .or. IAM_NODEMASTER == 1) CALL SLASH_PROC

HEAP_SIZE=GETMAXHWM()/ONEMEGA
TASKSMALL=GETMAXRSS()/ONEMEGA

CALL PROC_LOADAVG ! Tracks potential run-away processes/threads from e.g. previous jobs

IF (MYPROC == 0) THEN
   CALL DATE_AND_TIME(CLDATEOD,CLTIMEOD,CLZONEOD,IVALUES)
   READ(CLDATEOD(5:6),'(I2)') IMON
   IF (.not.LLNOCOMM .AND. KCALL /= 1) CALL PRT_DETAIL(KULOUT)
   IF (.not.LLNOHDR)  CALL PRT_HDR(KULOUT,KCALL)
   IF(KU == -1) THEN
      IF (KCALL /= 1) CALL PRT_DETAIL(0)
      CALL PRT_HDR(0,KCALL)
   ENDIF

   ! Note: MYPROC == 0 is always at the RN(0) i.e. at the first NODENUM
   TOT_ENERGY = ENERGY
   MAXPOWER = POWER
   AVGPOWER = POWER
   CLMAXNODE = NODENAME
   LASTNODE = NODENAME

   NN = NUMNODES
   IF (LLNOCOMM) NN=1

   IF (NPROC > 1) THEN
      ALLOCATE(DONE(1:NPROC-1))
      DONE(:) = .FALSE.
   ENDIF

   DO NODENUM=1,NN
      JID = 0
      DO II=1,NPROC-1
         IF (.NOT.DONE(II)) THEN
            J = II ! Used to be REF(II) -- don't know why ?!
            IF (RN(J)%NODENUM == NODENUM) THEN
               I = RN(J)%RANK
               IF (RN(J)%NODEMASTER == 1) THEN ! Always the first task on a particular NODENUM
                  LASTNODE = RN(J)%NODE
                  NRECV = SIZE(RECVBUF)
                  JID = J ! Always >= 1
               ELSE
                  NRECV = 4
               ENDIF
               CALL MPI_RECV(RECVBUF,NRECV,MPI_INTEGER8,I,ITAG+8,KCOMM,IRECV_STATUS,ERROR)
               CALL CHECK_ERROR("from MPI_RECV(RECVBUF)",__FILE__,__LINE__)
               IF (NRECV > 4) THEN
                  LOADAVG=RECVBUF(-1)
                  RUNNING=RECVBUF(0)
                  HEAP_SIZE=RECVBUF(1)
                  TASKSMALL=RECVBUF(2)
                  ENERGY=RECVBUF(3)
                  POWER=RECVBUF(4)
                  NODEHUGE=RECVBUF(5)
                  MEMFREE=RECVBUF(6)
                  CACHED=RECVBUF(7)
                  DO K=0,MAXNUMA-1
                     SMALLPAGE(K) = RECVBUF(7+2*K+1)
                     HUGEPAGE(K) = RECVBUF(7+2*K+2)
                  ENDDO
                  TOT_ENERGY = TOT_ENERGY + ENERGY
                  IF (POWER > MAXPOWER) THEN
                     MAXPOWER = POWER
                     CLMAXNODE = LASTNODE
                  ENDIF
                  AVGPOWER = AVGPOWER + POWER
               ELSE
                  IF (LOADAVG < RECVBUF(-1)) LOADAVG = RECVBUF(-1)
                  IF (RUNNING < RECVBUF(0)) RUNNING = RECVBUF(0)
                  HEAP_SIZE=HEAP_SIZE+RECVBUF(1)
                  TASKSMALL=TASKSMALL+RECVBUF(2)
               ENDIF
               DONE(II) = .TRUE.
            ENDIF
         ENDIF
      ENDDO
      
      PERCENT_USED(2) = 0
      IF (NODEHUGE == 0 .or. HEAP_SIZE >= NODEHUGE) THEN
         ! running with small pages
         IF (TASKSMALL+NODEHUGE+MEMFREE+CACHED > 0) THEN
            PERCENT_USED(1) = 100.0*(TASKSMALL+NODEHUGE)/(TASKSMALL+NODEHUGE+MEMFREE+CACHED)
         ELSE
            PERCENT_USED(1) = 0
         ENDIF
         CSTAR = " Sm/p"
      ELSE
         ! running with huge pages
         PERCENT_USED(1) = 100.0*(HEAP_SIZE+TASKSMALL)/(TASKSMALL+NODEHUGE+MEMFREE+CACHED)
         NFREE = 0
         IF (NNUMA > 0) NFREE = SUM(HUGEPAGE(0:NNUMA-1))
         PERCENT_USED(2) = (100.0*(NODEHUGE - NFREE))/NODEHUGE
         IF (PERCENT_USED(2) < 0) PERCENT_USED(2) = 0
         IF (PERCENT_USED(2) > 100) PERCENT_USED(2) = 100
         CSTAR = " Hg/p"
      ENDIF
   
      IF (LLNOCOMM) THEN
         ID_STRING = CSTAR
      ELSE IF (KCALL == 0 .AND. JID > 0) THEN
         ! This should signify the compute & I/O nodes (if they are separate)
         CLSTR = RN(JID)%STR
         ID_STRING = CSTAR//":"//TRIM(CLSTR)
      ELSE
         ID_STRING = CSTAR//":"//CDSTRING
      ENDIF

      CALL PRT_DATA(KULOUT,NODENUM,LASTNODE,KCALL)
      IF (KU == -1) THEN
         CALL PRT_DATA(0,NODENUM,LASTNODE,KCALL)
         IF (NODENUM == NN) THEN
            AVGPOWER = NINT(REAL(AVGPOWER)/REAL(NN))
            CALL PRT_TOTAL_ENERGIES(0)
            CALL PRT_TOTAL_ENERGIES(KULOUT)
            IF (KCALL == 1) THEN
               CALL DATE_AND_TIME(CLDATEOD,CLTIMEOD,CLZONEOD,IVALUES)
               READ(CLDATEOD(5:6),'(I2)') IMON
               CALL PRT_DETAIL(0)
               CALL PRT_DETAIL(KULOUT)
            ENDIF
            CALL PRT_EMPTY(KULOUT,1)
            CLOSE(KULOUT)
         ENDIF
      ENDIF
   ENDDO ! DO NODENUM=1,NN
   IF (ALLOCATED(DONE)) DEALLOCATE(DONE)
ELSE
    SENDBUF(-1)=LOADAVG
    SENDBUF(0)=RUNNING
    SENDBUF(1)=HEAP_SIZE
    SENDBUF(2)=TASKSMALL
    IF (IAM_NODEMASTER == 1) THEN
       SENDBUF(3)=ENERGY
       SENDBUF(4)=POWER
       SENDBUF(5)=NODEHUGE
       SENDBUF(6)=MEMFREE
       SENDBUF(7)=CACHED
       DO K=0,MAXNUMA-1
          SENDBUF(7+2*K+1)=SMALLPAGE(K)
          SENDBUF(7+2*K+2)=HUGEPAGE(K)
       ENDDO
       NSEND = SIZE(SENDBUF)
    ELSE
       NSEND = 4
    ENDIF
    CALL MPI_SEND(SENDBUF,NSEND,MPI_INTEGER8,0,ITAG+8,KCOMM,ERROR)
    CALL CHECK_ERROR("from MPI_SEND(SENDBUF)",__FILE__,__LINE__)
ENDIF

IF (.not.LLNOCOMM) THEN
   CALL CONDBARR()
   CALL CHECK_ERROR("from MPI_BARRIER(at end)",__FILE__,__LINE__)
ENDIF

CONTAINS

SUBROUTINE SLASH_PROC
  IMPLICIT NONE
  INTEGER(KIND=JPIM) :: IDX, ICLKEYLEN
#if defined(__powerpc64__)
  CHARACTER(LEN=*), PARAMETER :: CLKEY = " DMA "
#else
  CHARACTER(LEN=*), PARAMETER :: CLKEY = " Normal "
#endif
  ICLKEYLEN = LEN(CLKEY)

  CALL EC_PMON(ENERGY,POWER)
  
  N18 = 0 ! number of buddy columns (up to MAXCOLS)
  NNUMA = 0 ! number of NUMA-nodes (up to MAXNUMA)

  OPEN(FILE="/proc/buddyinfo",UNIT=502,STATUS="old",ACTION="read",ERR=97)
  
#if defined(__powerpc64__)
  READ(502,'(a)',END=99) LINE
#else
  READ(502,'(a)',END=99) LINE
  READ(502,'(a)',END=99) LINE
  READ(502,'(a)',END=99) LINE
#endif
  IDX = INDEX(LINE,CLKEY)
  IF (IDX <= 0) GOTO 99
  NODE(:,0)=-1
  READ(LINE(IDX+ICLKEYLEN-1:),*,ERR=99,END=98) NODE(:,0)
98 CONTINUE
  N18 = COUNT(NODE(:,0) >= 0)
  NNUMA = 1
  DO K=1,MAXNUMA-1
     NODE(:,K)=0
     READ(502,'(a)',END=99) LINE
     IDX = INDEX(LINE,CLKEY)
     IF (IDX <= 0) GOTO 99
     READ(LINE(IDX+ICLKEYLEN-1:),*,ERR=99) NODE(0:N18-1,K)
     NNUMA = NNUMA + 1
  ENDDO
  
99 CONTINUE
  CLOSE(502)
97 CONTINUE
  
  SMALLPAGE(:) = 0
  HUGEPAGE(:) = 0
  DO K=0,NNUMA-1
     BUCKET(:,K) = 0
     DO J=0,N18-1
        BUCKET(J,K) = 4096_JPIB * NODE(J,K) * (2_JPIB ** J)
     ENDDO
     SMALLPAGE(K) = SUM(BUCKET(0:8,K))/ONEMEGA
     HUGEPAGE(K) = SUM(BUCKET(9:N18-1,K))/ONEMEGA
  ENDDO
  
  MEMFREE = 0
  CACHED = 0
  
  OPEN(FILE="/proc/meminfo",UNIT=502,STATUS="old",ACTION="read",ERR=977)
  DO I=1,10
     READ(502,'(a)',ERR=988,END=988) LINE
     IF(LINE(1:7) == "MemFree") THEN
        READ(LINE(9:80),*) MEMFREE 
     ELSEIF(LINE(1:6) == "Cached") THEN
        READ(LINE(8:80),*) CACHED
     ENDIF
  ENDDO
988 continue
  CLOSE(502)
977 continue
  
  MEMFREE=MEMFREE/1024
  CACHED=CACHED/1024
END SUBROUTINE SLASH_PROC

SUBROUTINE PRT_EMPTY(KUN,KOUNT)
IMPLICIT NONE
INTEGER(KIND=JPIM), INTENT(IN) :: KUN,KOUNT
INTEGER(KIND=JPIM) :: JJ
DO JJ=1,KOUNT
   WRITE(KUN,'(a)')  CLPFX(1:IPFXLEN)//"## EC_MEMINFO "
ENDDO
END SUBROUTINE PRT_EMPTY

FUNCTION KWH(JOULES)
IMPLICIT NONE
INTEGER(KIND=JPIB), INTENT(IN) :: JOULES
REAL(KIND=JPRD) KWH
KWH = REAL(JOULES,JPRD) / 3600000.0_JPRD
END FUNCTION KWH

SUBROUTINE PRT_TOTAL_ENERGIES(KUN)
IMPLICIT NONE
INTEGER(KIND=JPIM), INTENT(IN) :: KUN
IF (KCALL == 1) THEN ! last call
   WT = UTIL_WALLTIME() - WT0
   CALL PRT_EMPTY(KUN,2)
   WRITE(KUN,'(a,a,f12.3,a,i0,a)')  CLPFX(1:IPFXLEN)//"## EC_MEMINFO ",&
        & " Total energy consumed : ",KWH(TOT_ENERGY), " kWh (",TOT_ENERGY," J)"
!-- Peak power below is misleading since based on values at sample points
!   WRITE(KUN,'(a,a,i0,a)')  CLPFX(1:IPFXLEN)//"## EC_MEMINFO ",&
!        & " Peak power            : ",MAXPOWER," W (node "//trim(CLMAXNODE)//")"
!-- Avg power must be calculated based on total Joules divided by wall time and num nodes
   AVGPOWER = TOT_ENERGY / WT / NUMNODES
   WRITE(KUN,'(a,a,i0,a,i0,a)')  CLPFX(1:IPFXLEN)//"## EC_MEMINFO ",&
        & " Avg. power / node     : ",AVGPOWER," W across ",NUMNODES," nodes"
   CALL PRT_EMPTY(KUN,1)
ENDIF
END SUBROUTINE PRT_TOTAL_ENERGIES

SUBROUTINE PRT_DETAIL(KUN)
IMPLICIT NONE
INTEGER(KIND=JPIM), INTENT(IN) :: KUN
CHARACTER(LEN=128) :: JOBNAME
CHARACTER(LEN=128) :: JOBID
CALL GET_ENVIRONMENT_VARIABLE('EC_JOB_NAME',JOBNAME)
IF (JOBNAME == '') CALL GET_ENVIRONMENT_VARIABLE('PBS_JOBNAME',JOBNAME)
IF (JOBNAME == '') CALL GET_ENVIRONMENT_VARIABLE('SLURM_JOB_NAME',JOBNAME)
IF (JOBNAME == '') CALL GET_ENVIRONMENT_VARIABLE('EC_MEMINFO_JOBNAME',JOBNAME)
CALL GET_ENVIRONMENT_VARIABLE('PBS_JOBID',JOBID)
IF (JOBID == '') CALL GET_ENVIRONMENT_VARIABLE('SLURM_JOB_ID',JOBID)
IF (JOBID == '') CALL GET_ENVIRONMENT_VARIABLE('EC_MEMINFO_JOBID',JOBID)
CALL PRT_EMPTY(KUN,1)
WT = UTIL_WALLTIME() - WT0
WRITE(KUN,'(4a,f10.3,a)') CLPFX(1:IPFXLEN)//"## EC_MEMINFO Detailed memory information ", &
     "for program ",TRIM(PROGRAM)," -- wall-time : ",WT,"s"
WRITE(KUN,'(a,i0,a,i0,a,i0,a,i0,a,i0,a,i0,a,a,":",a,":",a,a,a,"-",a,"-",a)') &
     CLPFX(1:IPFXLEN)//"## EC_MEMINFO Running on ",NUMNODES," nodes (",NNUMA,&
     "-numa) with ",NPROC-IOTASKS, &
     " compute + ",IOTASKS," I/O-tasks and ", MAXTH_COMP, "+", MAXTH_IO, " threads at ", &
     CLTIMEOD(1:2),CLTIMEOD(3:4),CLTIMEOD(5:10), &
     " on ",CLDATEOD(7:8),CLMON(IMON),CLDATEOD(1:4)
WRITE(KUN,'(4a)') CLPFX(1:IPFXLEN)//"## EC_MEMINFO The Job Name is ",TRIM(JOBNAME), &
     " and the Job ID is ",TRIM(JOBID)
CALL PRT_EMPTY(KUN,1)
END SUBROUTINE PRT_DETAIL

SUBROUTINE PRT_HDR(KUN,KCALL)
IMPLICIT NONE
INTEGER(KIND=JPIM), INTENT(IN) :: KUN,KCALL
INTEGER(KIND=JPIM) :: INUMA, ILEN
CHARACTER(LEN=4096) :: CLBUF
CHARACTER(LEN=7) :: CLTMP
INUMA = NNUMA

ILEN = 0
WRITE(CLBUF(ILEN+1:),'(A)') &
     CLPFX(1:IPFXLEN)//"## EC_MEMINFO                           | TC    | MEMORY USED(MB) "
ILEN = LEN_TRIM(CLBUF)
DO K=0,INUMA-1
   IF (K == 0) THEN
      WRITE(CLBUF(ILEN+1:),'(A)') " | MEMORY FREE(MB)"
      ILEN = LEN_TRIM(CLBUF)
   ELSE
      WRITE(CLBUF(ILEN+1:),'(A)') "  -------------  "
      ILEN = LEN_TRIM(CLBUF) + 2
   ENDIF
ENDDO
IF (KCALL == 0) THEN
   CLTMP = 'Running'
ELSE
   CLTMP = 'LoadAvg'
ENDIF
IF (NNUMA > 0) THEN
   WRITE(CLBUF(ILEN+1:),'(A)') " INCLUDING CACHED|  %USED %HUGE  | Energy  Power "//CLTMP
ELSE
   WRITE(CLBUF(ILEN+1:),'(A)') "  MEMORY FREE(MB) |  %USED %HUGE  | Energy  Power "//CLTMP
ENDIF
WRITE(KUN,'(A)') TRIM(CLBUF)

ILEN=0
WRITE(CLBUF(ILEN+1:),'(A)') &
     CLPFX(1:IPFXLEN)//"## EC_MEMINFO                           | Malloc| Inc Heap        |"
ILEN = LEN_TRIM(CLBUF)
DO K=0,INUMA-1
   WRITE(CLBUF(ILEN+1:),'(A,I2,A)') " Numa region ",K," |"
   ILEN = LEN_TRIM(CLBUF)
ENDDO
WRITE(CLBUF(ILEN+1:),'(A)') "                |               |    (J)    (W)"
WRITE(KUN,'(A)') TRIM(CLBUF)

ILEN=0
WRITE(CLBUF(ILEN+1:),'(A)') &
     CLPFX(1:IPFXLEN)//"## EC_MEMINFO Node Name                 | Heap  | RSS("//zum//")        |"
ILEN = LEN_TRIM(CLBUF)
DO K=0,INUMA-1
   WRITE(CLBUF(ILEN+1:),'(A)') " Small  Huge or |"
   ILEN = LEN_TRIM(CLBUF)
ENDDO
WRITE(CLBUF(ILEN+1:),'(A)') " Total          |"
WRITE(KUN,'(A)') TRIM(CLBUF)

ILEN=0
WRITE(CLBUF(ILEN+1:),'(A)') &
     CLPFX(1:IPFXLEN)//"## EC_MEMINFO                           | (sum) | Small    Huge   |"
ILEN = LEN_TRIM(CLBUF)
DO K=0,INUMA-1
   WRITE(CLBUF(ILEN+1:),'(A)') "  Only   Small  |"
   ILEN = LEN_TRIM(CLBUF)
ENDDO
WRITE(CLBUF(ILEN+1:),'(A)') " Memfree+Cached |"
WRITE(KUN,'(A)') TRIM(CLBUF)
END SUBROUTINE PRT_HDR

SUBROUTINE PRT_DATA(KUN,KNODENUM,CDLASTNODE,KCALL)
IMPLICIT NONE
INTEGER(KIND=JPIM), INTENT(IN) :: KUN, KNODENUM, KCALL
CHARACTER(LEN=*)  , INTENT(IN) :: CDLASTNODE
INTEGER(KIND=JPIM) :: INUMA,ILEN
CHARACTER(LEN=4096) :: CLBUF
CHARACTER(LEN=7) :: CLTMP
REAL(KIND=JPRD) :: TMP
INUMA = NNUMA

ILEN=0
WRITE(CLBUF(ILEN+1:),'(a,i4,1x,a,3i8,1x)') &
     CLPFX(1:IPFXLEN)//"## EC_MEMINFO ", &
     KNODENUM-1,CDLASTNODE,HEAP_SIZE,TASKSMALL,NODEHUGE
ILEN = LEN_TRIM(CLBUF) + 1
DO K=0,INUMA-1
   WRITE(CLBUF(ILEN+1:),'(1x,2i8)') SMALLPAGE(K),HUGEPAGE(K)
   ILEN = LEN_TRIM(CLBUF)
ENDDO
IF (KCALL == 0) THEN
   WRITE(CLTMP,'(i7)') RUNNING
ELSE
   TMP = REAL(LOADAVG,JPRD) * 0.01_JPRD
   WRITE(CLTMP,'(f7.2)') TMP
ENDIF
WRITE(CLBUF(ILEN+1:),'(2x,2i8,3x,2f6.1,1x,i9,1x,i6,1x,a7,1x,a)') &
     MEMFREE,CACHED, &
     PERCENT_USED,&
     ENERGY,POWER,&
     CLTMP,&
     trim(ID_STRING)
WRITE(KUN,'(A)') TRIM(CLBUF)
END SUBROUTINE PRT_DATA

SUBROUTINE CONDBARR()
IF (NPROC > 1 .and. KBARR /= 0) THEN
   CALL MPI_BARRIER(KCOMM,ERROR)
ELSE
   ERROR = 0
ENDIF
END SUBROUTINE CONDBARR

SUBROUTINE CHECK_ERROR(CLWHAT,SRCFILE,SRCLINE)
IMPLICIT NONE
CHARACTER(LEN=*), INTENT(IN) :: CLWHAT, SRCFILE
INTEGER(KIND=JPIM), INTENT(IN) :: SRCLINE
IF (ERROR /= 0) THEN
   WRITE(0,'(A,I0,1X,A,1X,"(",A,":",I0,")")') &
        & CLPFX(1:IPFXLEN)//"## EC_MEMINFO error code =",ERROR,CLWHAT,SRCFILE,SRCLINE
   CALL MPI_ABORT(KCOMM,-1,ERROR)
ENDIF
ERROR = 0
END SUBROUTINE CHECK_ERROR

SUBROUTINE RNSORT(KUN)
IMPLICIT NONE
INTEGER(KIND=JPIM), INTENT(IN) :: KUN
INTEGER(KIND=JPIM) :: ILEN
INTEGER(KIND=JPIB) :: IHUGE
CHARACTER(LEN=1) :: CLAST
CHARACTER(LEN=4) :: CLMASTER
CHARACTER(LEN=8192) :: CLBUF
INTEGER(KIND=JPIM) :: impi_vers, impi_subvers, ilibrary_version_len
INTEGER(KIND=JPIM) :: iomp_vers, iomp_subvers, iopenmp
INTEGER(KIND=JPIM) :: JCOUNT, MINCID, MAXCID ! "CID" = core id
INTEGER(KIND=JPIM), ALLOCATABLE :: NODE_CIDS(:,:) ! (MINCID:MAXCID) x NUMNODES
CHARACTER(LEN=8192) :: clibrary_version
CHARACTER(LEN=80) :: CL_CPUMODEL
LOGICAL :: LLDONE(0:NPROC-1)
INTEGER(KIND=JPIM) :: REF(0:NPROC-1) ! Keep list of the order tasks been added
INTEGER(KIND=JPIM) :: IORANKS(0:NPROC-1) ! =0 compute rank, =1 I/O-ranks
INTEGER(KIND=JPIM) :: IWORLD_RANK ! Index to IORANKS
LLDONE(:) = .FALSE.
IOTASKS = 0
K = 0
NODENUM = 0
MINCID = 9999999
MAXCID = 0
DO I=0,NPROC-1
   IF (RN(I)%NODENUM == -1) THEN
      IF (RN(I)%IORANK == 1) THEN
         IOTASKS = IOTASKS + 1
         RN(I)%IORANK = IOTASKS
      ELSE
         RN(I)%IORANK = 0
      ENDIF
      NODENUM = NODENUM + 1
      MINCID = MIN(MINCID,MINVAL(RN(I)%COREIDS(:)))
      MAXCID = MAX(MAXCID,MAXVAL(RN(I)%COREIDS(:)))
      RN(I)%NODENUM = NODENUM
      RN(I)%NODEMASTER = 1
      LLDONE(I) = .TRUE.
      ! NB: Adjacent REF-elements allow us to operate with particular node's tasks that follow their the node-master
      REF(K) = I
      K = K + 1
      LASTNODE = RN(I)%NODE
!      DO J=I+1,NPROC-1 ! not valid anymore since ranks might have been reordered -- need to run through the whole list -- LLNODE speeds up
      DO J=0,NPROC-1
         IF (.NOT.LLDONE(J)) THEN
            IF (RN(J)%NODENUM == -1) THEN
               IF (RN(J)%NODE == LASTNODE) THEN
                  MINCID = MIN(MINCID,MINVAL(RN(J)%COREIDS(:)))
                  MAXCID = MAX(MAXCID,MAXVAL(RN(J)%COREIDS(:)))
                  RN(J)%NODENUM = NODENUM
                  IF (RN(J)%IORANK == 1) THEN
                     IOTASKS = IOTASKS + 1
                     RN(J)%IORANK = IOTASKS
                  ELSE
                     RN(J)%IORANK = 0
                  ENDIF
                  RN(J)%NODEMASTER = 0
                  LLDONE(J) = .TRUE.
                  REF(K) = J
                  K = K + 1
               ENDIF
            ENDIF
         ENDIF
      ENDDO
   ENDIF
ENDDO
NUMNODES = NODENUM

write(0,'(1X,A,3(1X,I0))') 'EC_MEMINFO@RNSORT: MINCID, MAXCID, NUMNODES = ',MINCID, MAXCID, NUMNODES ! debug -- to be removed ?

ALLOCATE(NODE_CIDS(MINCID:MAXCID,NUMNODES))
NODE_CIDS(:,:) = 0
DO J=0,NPROC-1
   NODENUM = RN(J)%NODENUM
   NODE_CIDS(RN(J)%COREIDS(:),NODENUM) = NODE_CIDS(RN(J)%COREIDS(:),NODENUM) + 1
ENDDO

CALL ecmpi_version(impi_vers, impi_subvers, clibrary_version, ilibrary_version_len)
call ecomp_version(iomp_vers, iomp_subvers, iopenmp)
CALL EC_CPUMODEL(CL_CPUMODEL) ! ec_cpumodel from ../support/env.c
CALL PRT_EMPTY(KUN,1)
WRITE(KUN,'(a,i0,".",i0)') &
     & CLPFX(1:IPFXLEN)//&
     & "## EC_MEMINFO : MPI-version ",impi_vers, impi_subvers
WRITE(KUN,'(a)')  &
     & CLPFX(1:IPFXLEN)//&
     & "## EC_MEMINFO : Start of MPI-library version"
WRITE(KUN,'(a)') trim(clibrary_version) ! This is could be multiline, a very long string
WRITE(KUN,'(a)')  &
     & CLPFX(1:IPFXLEN)//&
     & "## EC_MEMINFO : End of MPI-library version"
WRITE(KUN,'(a,i0,".",i0,".",i6.6)') &
     & CLPFX(1:IPFXLEN)//&
     & "## EC_MEMINFO : OpenMP-version ",iomp_vers, iomp_subvers, iopenmp
WRITE(KUN,'(a,a)') &
     & CLPFX(1:IPFXLEN)//&
     & "## EC_MEMINFO : CPU-model : ",trim(CL_CPUMODEL)
IF (PAGESIZE > 0) THEN 
   IHUGE = INT(NODEHUGE_PAGE_COUNT,JPIB) * INT(PAGESIZE*1024,JPIB)
   WRITE(KUN,'(a,I0," bytes/page x ",I0," pages = ",I0," bytes")') &
        & CLPFX(1:IPFXLEN)//&
        & "## EC_MEMINFO : Hugepages : ",PAGESIZE*1024,NODEHUGE_PAGE_COUNT,IHUGE
ELSE
   WRITE(KUN,'(a)') &
        & CLPFX(1:IPFXLEN)//&
        & "## EC_MEMINFO : Hugepages : Not detected"
ENDIF
CALL PRT_EMPTY(KUN,2)
WRITE(KUN,1003) &
     & CLPFX(1:IPFXLEN)//&
     &"## EC_MEMINFO ********************************************************************************",&
     & CLPFX(1:IPFXLEN)//&
     &"## EC_MEMINFO *** Mapping of MPI & I/O-tasks to nodes and tasks' thread-to-core affinities ***", &
     & CLPFX(1:IPFXLEN)//&
     &"## EC_MEMINFO ********************************************************************************"
1003 FORMAT((A))
CALL PRT_EMPTY(KUN,1)
WRITE(KUN,'(a,i0,a,i0,a,i0,a,i0,a,i0,a,i0,a)') &
     & CLPFX(1:IPFXLEN)//"## EC_MEMINFO Running on ",NUMNODES," nodes (",NNUMA,&
     & "-numa) with ",NPROC-IOTASKS, &
     & " compute + ",IOTASKS," I/O-tasks and ", MAXTH_COMP, "+", MAXTH_IO, " threads"
CALL PRT_EMPTY(KUN,1)
WRITE(KUN,1000) CLPFX(1:IPFXLEN)//"## EC_MEMINFO ",&
     & "#","NODE#","NODENAME","MPI#","WORLD#","GETPID","I/O#","MASTER","REF#","OMP#","Core affinities"
WRITE(KUN,1000) CLPFX(1:IPFXLEN)//"## EC_MEMINFO ",&
     & "=","=====","========","====","======","======","====","======","====","====","==============="
1000 FORMAT(A,2(1X,A5),1X,A20,7(1X,A7),2X,A)
CALL PRT_EMPTY(KUN,1)
IORANKS(:) = 0 ! No I/O-ranks by default
DO K=0,NPROC-1 ! Loop over the task as they have been added (see few lines earlier how REF(K) has been getting its values I or J)
   ILEN = 0
   ! A formidable trick ? No need for a nested loop over 0:NPROC-1 to keep tasks within the same node together in the output
   I = REF(K)
   IWORLD_RANK = RN(I)%RANK_WORLD
   NUMTH = RN(I)%NUMTH
   CLMASTER = '[No]'
   IF (RN(I)%NODEMASTER == 1) CLMASTER = ' Yes'
   IF (RN(I)%IORANK > 0) THEN
      IORANKS(IWORLD_RANK) = 1
      WRITE(CLBUF(ILEN+1:),1001) &
           & CLPFX(1:IPFXLEN)//"## EC_MEMINFO ",&
           & K,RN(I)%NODENUM-1,TRIM(ADJUSTL(RN(I)%NODE)),RN(I)%RANK,IWORLD_RANK,RN(I)%PID,&
           & RN(I)%IORANK-1,CLMASTER,I,NUMTH,"{"
1001  FORMAT(A,2(1X,I5),1X,A20,4(1X,I7),1X,A7,2(1X,I7),2X,A)
   ELSE
      WRITE(CLBUF(ILEN+1:),1002) &
           & CLPFX(1:IPFXLEN)//"## EC_MEMINFO ",&
           & K,RN(I)%NODENUM-1,TRIM(ADJUSTL(RN(I)%NODE)),RN(I)%RANK,IWORLD_RANK,RN(I)%PID,&
           & "[No]",CLMASTER,I,NUMTH,"{"
1002  FORMAT(A,2(1X,I5),1X,A20,3(1X,I7),2(1X,A7),2(1X,I7),2X,A)
   ENDIF
   ILEN = LEN_TRIM(CLBUF)
   CLAST = ','
   NODENUM = RN(I)%NODENUM
   DO J=0,NUMTH-1
      IF (J == NUMTH-1) CLAST = '}'
      ! Are there multiple coreids the same ?
      ICOREID = RN(I)%COREIDS(J)
      !JCOUNT = COUNT(RN(I)%COREIDS(:) == ICOREID) ! should be == 1 or thread binding has gone wrong
      JCOUNT = NODE_CIDS(ICOREID,NODENUM) ! # of ICOREID's referenced on this node (over all tasks) -- should be exactly one (1)
      IF (JCOUNT == 1) THEN
         WRITE(CLBUF(ILEN+1:),'(I0,A1)') ICOREID,CLAST
      ELSE ! mark with asterisk failed bindings
         WRITE(CLBUF(ILEN+1:),'(I0,A2)') ICOREID,'*'//CLAST
      ENDIF
      ILEN = LEN_TRIM(CLBUF)
   ENDDO
   WRITE(KUN,'(A,1X)') TRIM(CLBUF)
ENDDO
DEALLOCATE(NODE_CIDS)
CALL PRT_EMPTY(KUN,1)
CALL EC_FLUSH(KUN)
END SUBROUTINE RNSORT

SUBROUTINE PROC_LOADAVG
IMPLICIT NONE
INTEGER(KIND=JPIM) :: ISTAT, ISP1, ISP3, ISLASH
REAL(KIND=JPRD) :: TMP
CHARACTER(LEN=32) :: CLINE
RUNNING = 0
LOADAVG = 0
! 0.00 0.02 0.08 1/2562 77533
OPEN(506,FILE='/proc/loadavg',IOSTAT=ISTAT,STATUS='old',ACTION='read')
IF (ISTAT == 0) THEN
   READ(506,'(A)',IOSTAT=ISTAT) CLINE
   CLOSE(506)
ENDIF
IF (ISTAT == 0) THEN
   ISLASH = SCAN(CLINE,'/')
   IF (ISLASH > 0) THEN
      ISP3 = SCAN(CLINE(:ISLASH-1),' ',BACK=.TRUE.)
      IF (ISP3 > 0) THEN
         READ(CLINE(ISP3+1:ISLASH-1),*,IOSTAT=ISTAT) RUNNING
         ISP1 = SCAN(CLINE(:ISP3-1),' ')
         IF (ISP1 > 0) THEN
            READ(CLINE(:ISP1-1),*,IOSTAT=ISTAT) TMP
            IF (ISTAT == 0) LOADAVG = INT(TMP * 100.0_JPRD)
         ENDIF
      ENDIF
   ENDIF
ENDIF
END SUBROUTINE PROC_LOADAVG

END SUBROUTINE EC_MEMINFO

! (C) Copyright 2023- ECMWF.
! 
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!

MODULE MPL_COMM_COMPARE_MOD

!**** *MPL_COMM_COMPARE_MOD*  - Compare two communicators

!     Author.
!     -------
!      Willem Deconinck *ECMWF*
!      Original : 31-08-2023

USE EC_PARKIND, ONLY : JPIM

IMPLICIT NONE

PRIVATE
PUBLIC :: MPL_COMM_COMPARE

CONTAINS

SUBROUTINE MPL_COMM_COMPARE (KCOMM1, KCOMM2, KRES, KERR, CDSTRING)
USE MPL_MPIF

INTEGER (KIND=JPIM), INTENT (IN)  :: KCOMM1
INTEGER (KIND=JPIM), INTENT (IN)  :: KCOMM2
INTEGER (KIND=JPIM), INTENT (OUT) :: KRES
INTEGER (KIND=JPIM), INTENT (OUT) :: KERR
CHARACTER (LEN=*),   INTENT (IN), OPTIONAL :: CDSTRING

CALL MPI_COMM_COMPARE (KCOMM1, KCOMM2, KRES, KERR)
if( KRES == MPI_IDENT ) THEN
    KRES = 0 ! contexts and groups are the same
ELSEIF (KRES == MPI_CONGRUENT) THEN
    KRES = 1 ! different contexts but identical groups
ELSEIF (KRES == MPI_SIMILAR) THEN
    KRES = 2 ! different contexts but similar groups
ELSE ! (KRES == MPI_UNEQUAL) THEN
    KRES = 3 ! otherwise
ENDIF

END SUBROUTINE MPL_COMM_COMPARE

END MODULE MPL_COMM_COMPARE_MOD

! (C) Copyright 2005- ECMWF.
! 
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!

MODULE EC_DATETIME_MOD

!**** Interface to eclib's date-time routines

!     Purpose.
!     --------
!     Fortran 90 Interface to calling eclib date-time routines

!     Author.
!     -------
!        W.Deconinck     ECMWF

!     Modifications.
!     --------------
!        Original: 2021-05-10

!     ------------------------------------------------------------------

IMPLICIT NONE
PRIVATE

PUBLIC :: cd2date, yd2date, idate2cd, idate2yd, icd2ymd, iymd2cd
PUBLIC :: daydiff, hourdiff, mindiff, secdiff
PUBLIC :: hourincr, minincr, secincr

! ISO-C-BINDING C-interfaces
INTERFACE

    ! void cd2date(const int32_t *const icd, int32_t *const iy, int32_t *const im, int32_t *const id, int32_t *const iret);
    subroutine cd2date( &
      & cd, &
      & year, month, day, &
      & iret) &
      & bind(c, name="cd2date")
      use, intrinsic :: iso_c_binding
      integer(c_int32_t), intent(in)  :: cd
      integer(c_int32_t), intent(out) :: year, month, day
      integer(c_int32_t), intent(out) :: iret
    end subroutine

    ! void yd2date(const int32_t *const iyd, const int32_t *const iy, int32_t *const im, int32_t *const id, int32_t *const iret);
    subroutine yd2date( &
      & yearday, year, &
      & month, day, &
      & iret) &
      & bind(c, name="yd2date")
      use, intrinsic :: iso_c_binding
      integer(c_int32_t), intent(in)  :: yearday, year
      integer(c_int32_t), intent(out) :: month, day
      integer(c_int32_t), intent(out) :: iret
    end subroutine

    ! int32_t idate2cd(const int32_t *const iy, const int32_t *const im, const int32_t *const id, int32_t *const iret);
    function idate2cd( &
      & year, month, day, &
      & iret) &
      & bind(c, name="idate2cd")
      use, intrinsic :: iso_c_binding
      integer(c_int32_t) :: idate2cd
      integer(c_int32_t), intent(in)  :: year, month, day
      integer(c_int32_t), intent(out) :: iret
    end function

    ! int32_t idate2yd(const int32_t *const iy, const int32_t *const im, const int32_t *const id, int32_t *const iret);
    function idate2yd( &
      & year, month, day, &
      & iret) &
      & bind(c, name="idate2yd")
      use, intrinsic :: iso_c_binding
      integer(c_int32_t) :: idate2yd
      integer(c_int32_t), intent(in)  :: year, month, day
      integer(c_int32_t), intent(out) :: iret
    end function

    ! int32_t icd2ymd(const int32_t *const icd, int32_t *const iret);
    function icd2ymd( &
      & cd, &
      & iret) &
      & bind(c, name="icd2ymd")
      use, intrinsic :: iso_c_binding
      integer(c_int32_t) :: icd2ymd
      integer(c_int32_t), intent(in)  :: cd
      integer(c_int32_t), intent(out) :: iret
    end function

    ! int32_t  iymd2cd(const int32_t *const iymd, int32_t *const iret);
    function iymd2cd( &
      & ymd, &
      & iret) &
      & bind(c, name="iymd2cd")
      use, intrinsic :: iso_c_binding
      integer(c_int32_t) :: iymd2cd
      integer(c_int32_t), intent(in)  :: ymd
      integer(c_int32_t), intent(out) :: iret
    end function

    ! void daydiff(const int32_t *const year1, const int32_t *const month1, const int32_t *const day1,
    !              const int32_t *const year2, const int32_t *const month2, const int32_t *const day2,
    !              int32_t *const days, int32_t *const iret);
    subroutine daydiff( &
      & year1, month1, day1, &
      & year2, month2, day2, &
      & days, &
      & iret) &
      & bind(c, name="daydiff")
      use, intrinsic :: iso_c_binding
      integer(c_int32_t), intent(in)  :: year1, month1, day1
      integer(c_int32_t), intent(in)  :: year2, month2, day2
      integer(c_int32_t), intent(out) :: days, iret
    end subroutine

    ! void hourdiff(const int32_t *const year1, const int32_t *const month1, const int32_t *const day1, const int32_t *const hour1,
    !               const int32_t *const year2, const int32_t *const month2, const int32_t *const day2, const int32_t *const hour2,
    !               int32_t *const hours, int32_t *const iret);
    subroutine hourdiff( &
      & year1, month1, day1, hour1, &
      & year2, month2, day2, hour2, &
      & hours, &
      & iret) &
      & bind(c, name="hourdiff")
      use, intrinsic :: iso_c_binding
      integer(c_int32_t), intent(in)  :: year1, month1, day1, hour1
      integer(c_int32_t), intent(in)  :: year2, month2, day2, hour2
      integer(c_int32_t), intent(out) :: hours, iret
    end subroutine

    ! void mindiff(const int32_t *const year1, const int32_t *const month1, const int32_t *const day1,
    !              const int32_t *const hour1, const int32_t *const min1,
    !              const int32_t *const year2, const int32_t *const month2, const int32_t *const day2,
    !              const int32_t *const hour2, const int32_t *const min2,
    !              int32_t *const minutes, int32_t *const iret);
    subroutine mindiff( &
        & year1, month1, day1, hour1, min1, &
        & year2, month2, day2, hour2, min2, &
        & minutes, &
        & iret) &
        & bind(c, name="mindiff")
        use, intrinsic :: iso_c_binding
        integer(c_int32_t), intent(in)  :: year1, month1, day1, hour1, min1
        integer(c_int32_t), intent(in)  :: year2, month2, day2, hour2, min2
        integer(c_int32_t), intent(out) :: minutes, iret
    end subroutine

    ! void secdiff(const int32_t *const year1, const int32_t *const month1, const int32_t *const day1, const int32_t *const hour1,
    !              const int32_t *const min1, const int32_t *const sec1,
    !              const int32_t *const year2, const int32_t *const month2, const int32_t *const day2, const int32_t *const hour2,
    !              const int32_t *const min2, const int32_t *const sec2,
    !              int32_t *const seconds, int32_t *const iret);
    subroutine secdiff( &
        & year1, month1, day1, hour1, min1, sec1, &
        & year2, month2, day2, hour2, min2, sec2, &
        & seconds, &
        & iret) &
        & bind(c, name="secdiff")
        use, intrinsic :: iso_c_binding
        integer(c_int32_t), intent(in)  :: year1, month1, day1, hour1, min1, sec1
        integer(c_int32_t), intent(in)  :: year2, month2, day2, hour2, min2, sec2
        integer(c_int32_t), intent(out) :: seconds, iret
    end subroutine

    ! void hourincr(const int32_t *const year, const int32_t *const month, const int32_t *const day, const int32_t *const hour,
    !               const int32_t *const hours,
    !               int32_t *const new_year, int32_t *const new_month, int32_t *const new_day, int32_t *const new_hour,
    !               int32_t *const iret);
    subroutine hourincr( &
      & year, month, day, hour, &
      & hours, &
      & new_year, new_month, new_day, new_hour, &
      & iret) &
      & bind(c, name="hourincr")
      use, intrinsic :: iso_c_binding
      integer(c_int32_t), intent(in)  :: year, month, day, hour, hours
      integer(c_int32_t), intent(out) :: new_year, new_month, new_day, new_hour, iret
    end subroutine

    ! void minincr(const int32_t *const year, const int32_t *const month, const int32_t *const day, const int32_t *const hour,
    !              const int32_t *const min,
    !              const int32_t *const minutes,int32_t *const new_year, int32_t *const new_month, int32_t *const new_day,
    !              int32_t *const new_hour, int32_t *const new_min,  int32_t *const iret);
    subroutine minincr( &
      & year, month, day, hour, min, &
      & minutes, &
      & new_year, new_month, new_day, new_hour, new_min, &
      & iret) &
      & bind(c, name="minincr")
      use, intrinsic :: iso_c_binding
      integer(c_int32_t), intent(in)  :: year, month, day, hour, min, minutes
      integer(c_int32_t), intent(out) :: new_year, new_month, new_day, new_hour, new_min, iret
    end subroutine

    ! void secincr(const int32_t *const year, const int32_t *const month, const int32_t *const day, const int32_t *const hour,
    !              const int32_t *const min, const int32_t *const sec, const int32_t *const seconds,
    !              int32_t *const new_year, int32_t *const new_month, int32_t *const new_day, int32_t *const new_hour,
    !              int32_t *const new_min, int32_t *const new_sec,  int32_t *const iret);
    subroutine secincr( &
        & year, month, day, hour, min, sec, &
        & seconds, &
        & new_year, new_month, new_day, new_hour, new_min, new_sec, &
        & iret) &
        & bind(c, name="secincr")
        use, intrinsic :: iso_c_binding
        integer(c_int32_t), intent(in)  :: year, month, day, hour, min, sec, seconds
        integer(c_int32_t), intent(out) :: new_year, new_month, new_day, new_hour, new_min, new_sec, iret
    end subroutine

END INTERFACE

CONTAINS

END MODULE

! (C) Copyright 2005- ECMWF.
! (C) Copyright 2013- Meteo-France.
! 
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!

MODULE MPL_MESSAGE_MOD

!**** MPL_MESSAGE - Prints message

!     Purpose.
!     --------
!     Creates an ASCII message for printing and optionally aborts

!**   Interface.
!     ----------
!        CALL MPL_MESSAGE

!        Input required arguments :
!        -------------------------
!           CDMESSAGE-  character string for message

!        Input optional arguments :
!        -------------------------
!           KERROR   -  Error number
!           CDSTRING -  Optional additional message 
!                       prepended to CDMESSAGE
!           LDABORT  -  forces ABORT if true

!        Output required arguments :
!        -------------------------
!           none

!        Output optional arguments :
!        -------------------------
!           none
!     Author.
!     -------
!        D.Dent, M.Hamrud     ECMWF

!     Modifications.
!     --------------
!        Original: 2000-09-01

!     ------------------------------------------------------------------

USE MPL_MPIF
USE MPL_DATA_MODULE
USE MPL_ABORT_MOD

USE EC_PARKIND  ,ONLY : JPIM

PRIVATE

PUBLIC MPL_MESSAGE

CONTAINS 

SUBROUTINE MPL_MESSAGE(KERROR,CDMESSAGE,CDSTRING,LDABORT)


#ifdef USE_8_BYTE_WORDS
  USE MPI4TO8, ONLY : &
    MPI_ERROR_STRING => MPI_ERROR_STRING8
#endif


IMPLICIT NONE

INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL     :: KERROR
CHARACTER(LEN=*),INTENT(IN)          :: CDMESSAGE
CHARACTER(LEN=*),INTENT(IN),OPTIONAL :: CDSTRING
LOGICAL      ,INTENT(IN),OPTIONAL :: LDABORT

CHARACTER*(MPI_MAX_ERROR_STRING)  :: CLMPI_ERROR
CHARACTER*12                      :: CLERROR
INTEGER(KIND=JPIM)                :: IRESULTLEN,IERROR

IF(PRESENT(KERROR)) THEN
  WRITE(CLERROR,'(I0)') KERROR
ELSE
  CLERROR=' '
ENDIF
IF(PRESENT(CDSTRING)) THEN
  WRITE(MPL_UNIT,'(4(1X,A),I0)') CDSTRING,CDMESSAGE,CLERROR, &
                               & ' FROM PROCESSOR ',MPL_RANK
ELSE
  WRITE(MPL_UNIT,'(3(1X,A),I0)') CDMESSAGE,CLERROR, &
                               & ' FROM PROCESSOR ',MPL_RANK
ENDIF

IF(PRESENT(KERROR)) THEN
  CALL MPI_ERROR_STRING(KERROR,CLMPI_ERROR,IRESULTLEN,IERROR)
  WRITE(MPL_UNIT,'(1X,2A,I0)') CLMPI_ERROR(1:IRESULTLEN),' in processor ',MPL_RANK
ELSE
  CLMPI_ERROR=' '
  IRESULTLEN=1
ENDIF

IF(PRESENT(LDABORT)) THEN
  IF(LDABORT) THEN
    WRITE(0,'(1X,2A,I0)') CLMPI_ERROR(1:IRESULTLEN),' in processor ',MPL_RANK
    CALL MPL_ABORT('ABORT')
  ENDIF
ENDIF
RETURN
END SUBROUTINE MPL_MESSAGE

END MODULE MPL_MESSAGE_MOD

! (C) Copyright 2005- ECMWF.
! (C) Copyright 2013- Meteo-France.
! 
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!

MODULE MPL_ALLREDUCE_MOD

!**** MPL_ALLREDUCE Perform collective communication

!     Purpose.
!     --------
!     To calculate global MIN,MAX,SUM or IEOR and return result to all processes.
!     The data may be REAL*4, REAL*8,or INTEGER, one dimensional array or scalar

!**   Interface.
!     ----------
!        CALL MPL_ALLREDUCE

!        Input required arguments :
!        -------------------------
!           PSENDBUF -  buffer containing message to be collectively communicated
!                       (can be type REAL*4, REAL*8 or INTEGER) (also output)
!           CDOPER   -  Global operation to be performed : 'MAX', 'MIN', 'SUM' or 'IEOR'

!        Input optional arguments :
!        -------------------------
!           LDREPROD -  Reproducibility flag for SUMmation-operator.
!                       Meaningful only for REAL-numbers.
!                       Three modes (applicable for REAL-number only):
!                       1) Not provided at all (the default) ==> MPL_ABORT
!                       2) Provided and .TRUE. ==> Use home-written binary tree
!                          No MPI_ALLREDUCE used.
!                       3) Provided, but .FALSE. ==> let MPI_ALLREDUCE do the summation.
!           KCOMM    -  Communicator number if different from MPI_COMM_WORLD 
!                       or from that established as the default 
!                       by an MPL communicator routine
!                       the incoming data
!           CDSTRING -  Character string for ABORT messages
!                       used when KERROR is not provided

!        Output required arguments :
!        -------------------------
!           none

!        Output optional arguments :
!        -------------------------
!           KERROR   -  return error code.     If not supplied, 
!                       MPL_ALLREDUCE aborts when an error is detected.
!     Author.
!     -------
!        D.Dent, M.Hamrud, S.Saarinen     ECMWF

!     Modifications.
!     --------------
!        Original: 2001-02-02
!      F. Vana  05-Mar-2015  Support for single precision

!     ------------------------------------------------------------------

USE EC_PARKIND , ONLY : JPRD, JPIM, JPRM, JPIB
USE OML_MOD   ,ONLY : OML_MY_THREAD

USE MPL_MPIF
USE MPL_DATA_MODULE
USE MPL_STATS_MOD
USE YOMMPLSTATS
USE MPL_MESSAGE_MOD
USE MPL_SEND_MOD
USE MPL_RECV_MOD
USE MPL_WAIT_MOD
USE MPL_BROADCAST_MOD

IMPLICIT NONE

PRIVATE

LOGICAL :: LLABORT=.TRUE.

INTERFACE MPL_ALLREDUCE
MODULE PROCEDURE MPL_ALLREDUCE_REAL8, MPL_ALLREDUCE_REAL4, MPL_ALLREDUCE_INT, &
  MPL_ALLREDUCE_INT8, &
  MPL_ALLREDUCE_REAL8_SCALAR, MPL_ALLREDUCE_REAL4_SCALAR, &
  MPL_ALLREDUCE_INT_SCALAR, MPL_ALLREDUCE_INT8_SCALAR, &
  MPL_ALLREDUCE_REAL4_2D, MPL_ALLREDUCE_REAL8_2D
END INTERFACE

PUBLIC MPL_ALLREDUCE

CONTAINS

SUBROUTINE MPL_ALLREDUCE_INT_SCALAR(KSENDBUF,CDOPER,LDREPROD, &
                            & KCOMM,KERROR,CDSTRING)

INTEGER(KIND=JPIM),INTENT(INOUT)     :: KSENDBUF
CHARACTER(LEN=*),INTENT(IN)    :: CDOPER
LOGICAL,INTENT(IN),OPTIONAL :: LDREPROD
INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL :: KCOMM
INTEGER(KIND=JPIM),INTENT(OUT),OPTIONAL :: KERROR
CHARACTER(LEN=*),INTENT(IN),OPTIONAL :: CDSTRING
INTEGER(KIND=JPIM) ISENDBUF(1)

ISENDBUF(1) = KSENDBUF
CALL MPL_ALLREDUCE(ISENDBUF,CDOPER,LDREPROD,KCOMM,KERROR,CDSTRING)
KSENDBUF = ISENDBUF(1)

END SUBROUTINE MPL_ALLREDUCE_INT_SCALAR

SUBROUTINE MPL_ALLREDUCE_INT8_SCALAR(KSENDBUF,CDOPER,LDREPROD, &
                            & KCOMM,KERROR,CDSTRING)
INTEGER(KIND=JPIB),INTENT(INOUT)     :: KSENDBUF
CHARACTER(LEN=*),INTENT(IN)    :: CDOPER
LOGICAL,INTENT(IN),OPTIONAL :: LDREPROD
INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL :: KCOMM
INTEGER(KIND=JPIM),INTENT(OUT),OPTIONAL :: KERROR
CHARACTER(LEN=*),INTENT(IN),OPTIONAL :: CDSTRING
INTEGER(KIND=JPIB) ISENDBUF(1)

ISENDBUF(1) = KSENDBUF
CALL MPL_ALLREDUCE(ISENDBUF,CDOPER,LDREPROD,KCOMM,KERROR,CDSTRING)
KSENDBUF = ISENDBUF(1)

END SUBROUTINE MPL_ALLREDUCE_INT8_SCALAR



SUBROUTINE MPL_ALLREDUCE_REAL8_SCALAR(PSENDBUF,CDOPER,LDREPROD, &
                            & KCOMM,KERROR,CDSTRING)
REAL(KIND=JPRD),INTENT(INOUT)     :: PSENDBUF
CHARACTER(LEN=*),INTENT(IN)    :: CDOPER
LOGICAL,INTENT(IN),OPTIONAL :: LDREPROD
INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL :: KCOMM
INTEGER(KIND=JPIM),INTENT(OUT),OPTIONAL :: KERROR
CHARACTER(LEN=*),INTENT(IN),OPTIONAL :: CDSTRING
REAL(KIND=JPRD) ZSENDBUF(1)

ZSENDBUF(1) = PSENDBUF
CALL MPL_ALLREDUCE(ZSENDBUF,CDOPER,LDREPROD,KCOMM,KERROR,CDSTRING)
PSENDBUF = ZSENDBUF(1)

END SUBROUTINE MPL_ALLREDUCE_REAL8_SCALAR


SUBROUTINE MPL_ALLREDUCE_REAL4_SCALAR(PSENDBUF,CDOPER,LDREPROD, &
                            & KCOMM,KERROR,CDSTRING)
REAL(KIND=JPRM),INTENT(INOUT)     :: PSENDBUF
CHARACTER(LEN=*),INTENT(IN)    :: CDOPER
LOGICAL,INTENT(IN),OPTIONAL :: LDREPROD
INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL :: KCOMM
INTEGER(KIND=JPIM),INTENT(OUT),OPTIONAL :: KERROR
CHARACTER(LEN=*),INTENT(IN),OPTIONAL :: CDSTRING
REAL(KIND=JPRM) ZSENDBUF(1)

ZSENDBUF(1) = PSENDBUF
CALL MPL_ALLREDUCE(ZSENDBUF,CDOPER,LDREPROD,KCOMM,KERROR,CDSTRING)
PSENDBUF = ZSENDBUF(1)

END SUBROUTINE MPL_ALLREDUCE_REAL4_SCALAR


SUBROUTINE MPL_ALLREDUCE_INT(KSENDBUF,CDOPER,LDREPROD, &
                            & KCOMM,KERROR,CDSTRING)

#ifdef USE_8_BYTE_WORDS
  USE MPI4TO8, ONLY : &
    MPI_ALLREDUCE => MPI_ALLREDUCE8
#endif

INTEGER(KIND=JPIM),INTENT(INOUT)     :: KSENDBUF(:)
CHARACTER(LEN=*),INTENT(IN)    :: CDOPER
LOGICAL,INTENT(IN),OPTIONAL :: LDREPROD
INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL :: KCOMM
INTEGER(KIND=JPIM),INTENT(OUT),OPTIONAL :: KERROR
CHARACTER(LEN=*),INTENT(IN),OPTIONAL :: CDSTRING
INTEGER(KIND=JPIM) :: IRECVBUF(SIZE(KSENDBUF))
INTEGER(KIND=JPIM) :: ISENDCOUNT,ICOMM,IERROR,IOPER
INTEGER(KIND=JPIM) :: ITID
ITID = OML_MY_THREAD()
IERROR = 0
IF(MPL_NUMPROC < 1) CALL MPL_MESSAGE( &
  & CDMESSAGE='MPL_ALLREDUCE: MPL NOT INITIALISED ',LDABORT=LLABORT) 

IF(CDOPER(1:3) == 'MAX' .OR. CDOPER(1:3) == 'max' ) THEN
  IOPER = MPI_MAX
ELSEIF(CDOPER(1:3) == 'MIN' .OR. CDOPER(1:3) == 'min' ) THEN
  IOPER = MPI_MIN
ELSEIF(CDOPER(1:3) == 'SUM' .OR. CDOPER(1:3) == 'sum' ) THEN
  IOPER = MPI_SUM
ELSEIF(CDOPER(1:4) == 'IEOR' .OR. CDOPER(1:4) == 'ieor' ) THEN
  IOPER = MPI_BXOR
ELSEIF(CDOPER(1:4) == 'XOR' .OR. CDOPER(1:4) == 'xor' ) THEN
  IOPER = MPI_BXOR
ELSE
  CALL MPL_MESSAGE(IERROR,'MPL_ALLREDUCE: ERROR UNKNOWN OPERATOR',&
   & CDSTRING,LDABORT=LLABORT)
ENDIF

IF(PRESENT(KCOMM)) THEN
  ICOMM=KCOMM
ELSE
  ICOMM=MPL_COMM_OML(ITID)
ENDIF

ISENDCOUNT = SIZE(KSENDBUF)

#ifndef NAG
IF (ISENDCOUNT > 0) THEN
  IF( (LOC(KSENDBUF(UBOUND(KSENDBUF,1)))-LOC(KSENDBUF(LBOUND(KSENDBUF,1)))) /= 4_JPIB*(ISENDCOUNT - 1) ) THEN
    CALL MPL_MESSAGE(CDMESSAGE='MPL_ALLREDUCE: BUFFER NOT CONTIGUOUS ',LDABORT=LLABORT)
  ENDIF
ENDIF
#endif

IF ( MPL_NUMPROC > 1 ) &
CALL MPI_ALLREDUCE(KSENDBUF,IRECVBUF,ISENDCOUNT,INT(MPI_INTEGER), &
                &  IOPER,ICOMM,IERROR)

IF(LMPLSTATS) THEN
  CALL MPL_SENDSTATS(ISENDCOUNT,INT(MPI_INTEGER))
  CALL MPL_RECVSTATS(ISENDCOUNT,INT(MPI_INTEGER))
ENDIF

IF(MPL_OUTPUT > 1 )THEN
  WRITE(MPL_UNIT,'(A,5I8)') ' MPL_ALLREDUCE ',ISENDCOUNT,ICOMM,IOPER
ENDIF
IF(PRESENT(KERROR)) THEN
  KERROR=IERROR
ELSE
  IF(IERROR /= 0 ) CALL MPL_MESSAGE(IERROR,'MPL_ALLREDUCE',CDSTRING,LDABORT=LLABORT)
ENDIF

IF ( MPL_NUMPROC > 1 ) &
KSENDBUF(:) = IRECVBUF(:)

END SUBROUTINE MPL_ALLREDUCE_INT

SUBROUTINE MPL_ALLREDUCE_INT8(KSENDBUF,CDOPER,LDREPROD, &
                            & KCOMM,KERROR,CDSTRING)
INTEGER(KIND=JPIB),INTENT(INOUT)     :: KSENDBUF(:)
CHARACTER(LEN=*),INTENT(IN)    :: CDOPER
LOGICAL,INTENT(IN),OPTIONAL :: LDREPROD
INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL :: KCOMM
INTEGER(KIND=JPIM),INTENT(OUT),OPTIONAL :: KERROR
CHARACTER(LEN=*),INTENT(IN),OPTIONAL :: CDSTRING
INTEGER(KIND=JPIB) :: IRECVBUF(SIZE(KSENDBUF))
INTEGER(KIND=JPIM) :: ISENDCOUNT,ICOMM,IERROR,IOPER
INTEGER(KIND=JPIM) :: ITID
IERROR = 0
ITID = OML_MY_THREAD()
IF(MPL_NUMPROC < 1) CALL MPL_MESSAGE( &
  & CDMESSAGE='MPL_ALLREDUCE: MPL NOT INITIALISED ',LDABORT=LLABORT) 

IF(CDOPER(1:3) == 'MAX' .OR. CDOPER(1:3) == 'max' ) THEN
  IOPER = MPI_MAX
ELSEIF(CDOPER(1:3) == 'MIN' .OR. CDOPER(1:3) == 'min' ) THEN
  IOPER = MPI_MIN
ELSEIF(CDOPER(1:3) == 'SUM' .OR. CDOPER(1:3) == 'sum' ) THEN
  IOPER = MPI_SUM
ELSEIF(CDOPER(1:4) == 'IEOR' .OR. CDOPER(1:4) == 'ieor' ) THEN
  IOPER = MPI_BXOR
ELSEIF(CDOPER(1:4) == 'XOR' .OR. CDOPER(1:4) == 'xor' ) THEN
  IOPER = MPI_BXOR
ELSE
  CALL MPL_MESSAGE(IERROR,'MPL_ALLREDUCE: ERROR UNKNOWN OPERATOR',&
   & CDSTRING,LDABORT=LLABORT)
ENDIF

IF(PRESENT(KCOMM)) THEN
  ICOMM=KCOMM
ELSE
  ICOMM=MPL_COMM_OML(ITID)
ENDIF

ISENDCOUNT = SIZE(KSENDBUF)
#ifndef NAG
IF (ISENDCOUNT > 0) THEN
  IF( (LOC(KSENDBUF(UBOUND(KSENDBUF,1)))-LOC(KSENDBUF(LBOUND(KSENDBUF,1)))) /= 8_JPIB*(ISENDCOUNT - 1) ) THEN
    CALL MPL_MESSAGE(CDMESSAGE='MPL_ALLREDUCE: BUFFER NOT CONTIGUOUS ',LDABORT=LLABORT)
  ENDIF
ENDIF
#endif

IF ( MPL_NUMPROC > 1 ) &
CALL MPI_ALLREDUCE(KSENDBUF,IRECVBUF,ISENDCOUNT,MPI_INTEGER8, &
                &  IOPER,ICOMM,IERROR)

IF(LMPLSTATS) THEN
  CALL MPL_SENDSTATS(ISENDCOUNT,INT(MPI_INTEGER8))
  CALL MPL_RECVSTATS(ISENDCOUNT,INT(MPI_INTEGER8))
ENDIF

IF(MPL_OUTPUT > 1 )THEN
  WRITE(MPL_UNIT,'(A,5I8)') ' MPL_ALLREDUCE ',ISENDCOUNT,ICOMM,IOPER
ENDIF
IF(PRESENT(KERROR)) THEN
  KERROR=IERROR
ELSE
  IF(IERROR /= 0 ) CALL MPL_MESSAGE(IERROR,'MPL_ALLREDUCE',CDSTRING,LDABORT=LLABORT)
ENDIF

IF ( MPL_NUMPROC > 1 ) &
KSENDBUF(:) = IRECVBUF(:)

END SUBROUTINE MPL_ALLREDUCE_INT8


SUBROUTINE MPL_ALLREDUCE_REAL8(PSENDBUF,CDOPER,LDREPROD, &
                            & KCOMM,KERROR,CDSTRING)


#ifdef USE_8_BYTE_WORDS
  USE MPI4TO8, ONLY : &
    MPI_ALLREDUCE => MPI_ALLREDUCE8
#endif

REAL(KIND=JPRD),INTENT(INOUT)        :: PSENDBUF(:)
CHARACTER(LEN=*),INTENT(IN)    :: CDOPER
LOGICAL,INTENT(IN),OPTIONAL :: LDREPROD
INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL :: KCOMM
INTEGER(KIND=JPIM),INTENT(OUT),OPTIONAL :: KERROR
CHARACTER(LEN=*),INTENT(IN),OPTIONAL :: CDSTRING
REAL(KIND=JPRD)            :: ZRECVBUF(SIZE(PSENDBUF))
INTEGER(KIND=JPIM) ITAG, ICOUNT
LOGICAL LLREPRODSUM
INTEGER(KIND=JPIM) :: ISENDCOUNT,ICOMM,IERROR,IOPER
INTEGER(KIND=JPIM) :: IP2,II,IHALF,JSTAGE,ISEND,IRECV,IMSENT
INTEGER(KIND=JPIM) :: ISREQ(MPL_NUMPROC)
INTEGER(KIND=JPIM) :: ITID
IERROR = 0
ITID = OML_MY_THREAD()
LLREPRODSUM = .FALSE.

IF(MPL_NUMPROC < 1) CALL MPL_MESSAGE( &
  & CDMESSAGE='MPL_ALLREDUCE: MPL NOT INITIALISED ',LDABORT=LLABORT) 

IF(CDOPER(1:3) == 'MAX' .OR. CDOPER(1:3) == 'max' ) THEN
  IOPER = MPI_MAX
ELSEIF(CDOPER(1:3) == 'MIN' .OR. CDOPER(1:3) == 'min' ) THEN
  IOPER = MPI_MIN
ELSEIF(CDOPER(1:3) == 'SUM' .OR. CDOPER(1:3) == 'sum' ) THEN
  IOPER = MPI_SUM
  IF (PRESENT(LDREPROD)) THEN
    LLREPRODSUM = LDREPROD
  ELSE
    CALL MPL_MESSAGE(IERROR,&
     & 'MPL_ALLREDUCE: SUMMATION OPERATOR NOT REPRODUCIBLE IN REAL MODE',&
     & CDSTRING,LDABORT=LLABORT)
  ENDIF
ELSE
  CALL MPL_MESSAGE(IERROR,'MPL_ALLREDUCE: ERROR UNKNOWN OPERATOR',&
   & CDSTRING,LDABORT=LLABORT)
ENDIF

IF(PRESENT(KCOMM)) THEN
  ICOMM=KCOMM
ELSE
  ICOMM=MPL_COMM_OML(ITID)
ENDIF

ISENDCOUNT = SIZE(PSENDBUF)
#ifndef NAG
IF (ISENDCOUNT > 0) THEN
  IF( (LOC(PSENDBUF(UBOUND(PSENDBUF,1)))-LOC(PSENDBUF(LBOUND(PSENDBUF,1)))) /= 8_JPIB*(ISENDCOUNT - 1) ) THEN
    CALL MPL_MESSAGE(CDMESSAGE='MPL_ALLREDUCE: BUFFER NOT CONTIGUOUS ',LDABORT=LLABORT)
  ENDIF
ENDIF
#endif

IF (LLREPRODSUM) THEN
!-- Near reproducible summation (independent of number of threads)

  IP2=0
  DO
    IP2=IP2+1
    IF(2**IP2 >= MPL_NUMPROC) EXIT
  ENDDO

  IMSENT=0
  DO JSTAGE=IP2,1,-1
!    WRITE(0,*) 'STAGE ',JSTAGE
    ITAG  = 2001+JSTAGE
    II    = 2**JSTAGE
    IHALF = II/2
    ISEND = MPL_RANK - IHALF
    IF(ISEND > 0 .AND. MPL_RANK <= II) THEN
      IMSENT=IMSENT+1
      CALL MPL_SEND(PSENDBUF,KDEST=ISEND,KCOMM=ICOMM,KTAG=ITAG,KERROR=IERROR,&
       &KMP_TYPE=JP_NON_BLOCKING_STANDARD,KREQUEST=ISREQ(IMSENT),CDSTRING='MPLS_SEND')
!      write(0,*) 'I SEND TO ',MPL_RANK,ISEND
    ENDIF
    IRECV=MPL_RANK + IHALF
    IF(IRECV <=MPL_NUMPROC .AND. MPL_RANK <= IHALF) THEN
      CALL MPL_RECV(ZRECVBUF,KSOURCE=IRECV,KCOMM=ICOMM,KTAG=ITAG,&
       &KERROR=IERROR,KOUNT=ICOUNT)
!      write(0,*) 'I RECV FROM ',MPL_RANK,IRECV
      PSENDBUF(:) = PSENDBUF(:) + ZRECVBUF(:)
    ENDIF
  ENDDO
  IF(IMSENT > 0) THEN
    CALL MPL_WAIT(KREQUEST=ISREQ(1:IMSENT),CDSTRING='MPLS_SEND')
  ENDIF
  IF (MPL_RANK == 1) THEN
    ZRECVBUF(:) = PSENDBUF(:)
  ENDIF
!  write(0,*) 'enter broadcast '
  CALL MPL_BROADCAST(ZRECVBUF,KTAG=ITAG,KCOMM=ICOMM,KROOT=1,KERROR=IERROR)
!  write(0,*) 'exit broadcast '

!!$  IMSENT=0
!!$  DO JSTAGE=1,IP2
!!$    ITAG = 2001+JSTAGE
!!$    WRITE(0,*) 'STAGE BACK  ',JSTAGE
!!$    II = 2**JSTAGE
!!$    IHALF = II/2
!!$    ISEND=MPL_RANK + IHALF
!!$    IF(ISEND <=MPL_NUMPROC .AND. MPL_RANK <= IHALF) THEN
!!$      IMSENT=IMSENT+1
!!$      CALL MPL_SEND(PSENDBUF,KDEST=ISEND,KCOMM=ICOMM,KTAG=ITAG,KERROR=IERROR,&
!!$       &KMP_TYPE=JP_NON_BLOCKING_STANDARD,KREQUEST=ISREQ(IMSENT),CDSTRING='MPLS_SEND')
!!$      WRITE(0,*) 'I SEND BACK TO ',MPL_RANK,ISEND
!!$    ENDIF
!!$    IRECV=MPL_RANK - IHALF
!!$    IF(IRECV > 0 .AND. MPL_RANK <= II) THEN
!!$      WRITE(0,*) 'I RECV BACK FROM ',MPL_RANK,IRECV
!!$      CALL MPL_RECV(ZRECVBUF,KSOURCE=IRECV,KCOMM=ICOMM,KTAG=ITAG,&
!!$       &KERROR=IERROR,KOUNT=ICOUNT)
!!$    ENDIF
!!$  ENDDO
!!$  IF(IMSENT > 0) THEN
!!$    CALL MPL_WAIT(KREQUEST=ISREQ(1:IMSENT),CDSTRING='MPLS_SEND')
!!$  ENDIF
  
ELSE  
  IF ( MPL_NUMPROC > 1 ) &
  CALL MPI_ALLREDUCE(PSENDBUF,ZRECVBUF,ISENDCOUNT,INT(MPI_REAL8), &
                  &  IOPER,ICOMM,IERROR)

  IF(LMPLSTATS) THEN
    CALL MPL_SENDSTATS(ISENDCOUNT,INT(MPI_REAL8))
    CALL MPL_RECVSTATS(ISENDCOUNT,INT(MPI_REAL8))
  ENDIF

ENDIF

IF(MPL_OUTPUT > 1 )THEN
  WRITE(MPL_UNIT,'(A,5I8)') ' MPL_ALLREDUCE ',ISENDCOUNT,ICOMM,IOPER
ENDIF
IF(PRESENT(KERROR)) THEN
  KERROR=IERROR
ELSE
  IF(IERROR /= 0 ) CALL MPL_MESSAGE(IERROR,'MPL_ALLREDUCE',CDSTRING,LDABORT=LLABORT)
ENDIF

IF ( MPL_NUMPROC > 1 ) &
PSENDBUF(:) = ZRECVBUF(:)

END SUBROUTINE MPL_ALLREDUCE_REAL8

SUBROUTINE MPL_ALLREDUCE_REAL8_2D(PSENDBUF,CDOPER,LDREPROD, &
                            & KCOMM,KERROR,CDSTRING)


#ifdef USE_8_BYTE_WORDS
  USE MPI4TO8, ONLY : &
    MPI_ALLREDUCE => MPI_ALLREDUCE8
#endif

REAL(KIND=JPRD),INTENT(INOUT)        :: PSENDBUF(:,:)
CHARACTER(LEN=*),INTENT(IN)    :: CDOPER
LOGICAL,INTENT(IN),OPTIONAL :: LDREPROD
INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL :: KCOMM
INTEGER(KIND=JPIM),INTENT(OUT),OPTIONAL :: KERROR
CHARACTER(LEN=*),INTENT(IN),OPTIONAL :: CDSTRING
REAL(KIND=JPRD)            :: ZRECVBUF(SIZE(PSENDBUF(:,1)),SIZE(PSENDBUF(1,:)))
INTEGER(KIND=JPIM) ITAG, ICOUNT
LOGICAL LLREPRODSUM
INTEGER(KIND=JPIM) :: ISENDCOUNT,ICOMM,IERROR,IOPER
INTEGER(KIND=JPIM) :: IP2,II,IHALF,JSTAGE,ISEND,IRECV,IMSENT
INTEGER(KIND=JPIM) :: ISREQ(MPL_NUMPROC)
INTEGER(KIND=JPIM) :: ITID
IERROR = 0
ITID = OML_MY_THREAD()
LLREPRODSUM = .FALSE.

IF(MPL_NUMPROC < 1) CALL MPL_MESSAGE( &
  & CDMESSAGE='MPL_ALLREDUCE: MPL NOT INITIALISED ',LDABORT=LLABORT)

IF(CDOPER(1:3) == 'MAX' .OR. CDOPER(1:3) == 'max' ) THEN
  IOPER = MPI_MAX
ELSEIF(CDOPER(1:3) == 'MIN' .OR. CDOPER(1:3) == 'min' ) THEN
  IOPER = MPI_MIN
ELSEIF(CDOPER(1:3) == 'SUM' .OR. CDOPER(1:3) == 'sum' ) THEN
  IOPER = MPI_SUM
  IF (PRESENT(LDREPROD)) THEN
    LLREPRODSUM = LDREPROD
  ELSE
    CALL MPL_MESSAGE(IERROR,&
     & 'MPL_ALLREDUCE: SUMMATION OPERATOR NOT REPRODUCIBLE IN REAL MODE',&
     & CDSTRING,LDABORT=LLABORT)
  ENDIF
ELSE
  CALL MPL_MESSAGE(IERROR,'MPL_ALLREDUCE: ERROR UNKNOWN OPERATOR',&
   & CDSTRING,LDABORT=LLABORT)
ENDIF

IF(PRESENT(KCOMM)) THEN
  ICOMM=KCOMM
ELSE
  ICOMM=MPL_COMM_OML(ITID)
ENDIF

ISENDCOUNT = SIZE(PSENDBUF)
!#ifndef NAG
!IF (ISENDCOUNT > 0) THEN
!  IF( (LOC(PSENDBUF(UBOUND(PSENDBUF,1)))-LOC(PSENDBUF(LBOUND(PSENDBUF,1)))) /= 8_JPIB*(ISENDCOUNT - 1) ) THEN
!    CALL MPL_MESSAGE(CDMESSAGE='MPL_ALLREDUCE: BUFFER NOT CONTIGUOUS ',LDABORT=LLABORT)
!  ENDIF
!ENDIF
!#endif

!IF (LLREPRODSUM) THEN
!-- Near reproducible summation (independent of number of threads)

!  IP2=0
!  DO
!    IP2=IP2+1
!    IF(2**IP2 >= MPL_NUMPROC) EXIT
!  ENDDO

!  IMSENT=0
!  DO JSTAGE=IP2,1,-1
!    WRITE(0,*) 'STAGE ',JSTAGE
!    ITAG  = 2001+JSTAGE
!    II    = 2**JSTAGE
!    IHALF = II/2
!    ISEND = MPL_RANK - IHALF
!    IF(ISEND > 0 .AND. MPL_RANK <= II) THEN
!      IMSENT=IMSENT+1
!      CALL MPL_SEND(PSENDBUF,KDEST=ISEND,KCOMM=ICOMM,KTAG=ITAG,KERROR=IERROR,&
!       &KMP_TYPE=JP_NON_BLOCKING_STANDARD,KREQUEST=ISREQ(IMSENT),CDSTRING='MPLS_SEND')
!      write(0,*) 'I SEND TO ',MPL_RANK,ISEND
!    ENDIF
!    IRECV=MPL_RANK + IHALF
!    IF(IRECV <=MPL_NUMPROC .AND. MPL_RANK <= IHALF) THEN
!      CALL MPL_RECV(ZRECVBUF,KSOURCE=IRECV,KCOMM=ICOMM,KTAG=ITAG,&
!       &KERROR=IERROR,KOUNT=ICOUNT)
!      write(0,*) 'I RECV FROM ',MPL_RANK,IRECV
!      PSENDBUF(:) = PSENDBUF(:) + ZRECVBUF(:)
!    ENDIF
!  ENDDO
!  IF(IMSENT > 0) THEN
!    CALL MPL_WAIT(KREQUEST=ISREQ(1:IMSENT),CDSTRING='MPLS_SEND')
!  ENDIF
!  IF (MPL_RANK == 1) THEN
!    ZRECVBUF(:) = PSENDBUF(:)
!  ENDIF
!  write(0,*) 'enter broadcast '
!  CALL MPL_BROADCAST(ZRECVBUF,KTAG=ITAG,KCOMM=ICOMM,KROOT=1,KERROR=IERROR)
!  write(0,*) 'exit broadcast '

!ELSE
  IF ( MPL_NUMPROC > 1 ) &
  CALL MPI_ALLREDUCE(PSENDBUF,ZRECVBUF,ISENDCOUNT,INT(MPI_REAL8), &
                  &  IOPER,ICOMM,IERROR)

  IF(LMPLSTATS) THEN
    CALL MPL_SENDSTATS(ISENDCOUNT,INT(MPI_REAL8))
    CALL MPL_RECVSTATS(ISENDCOUNT,INT(MPI_REAL8))
  ENDIF

!ENDIF

IF(MPL_OUTPUT > 1 )THEN
  WRITE(MPL_UNIT,'(A,5I8)') ' MPL_ALLREDUCE ',ISENDCOUNT,ICOMM,IOPER
ENDIF
IF(PRESENT(KERROR)) THEN
  KERROR=IERROR
ELSE
  IF(IERROR /= 0 ) CALL MPL_MESSAGE(IERROR,'MPL_ALLREDUCE',CDSTRING,LDABORT=LLABORT)
ENDIF

IF ( MPL_NUMPROC > 1 ) &
PSENDBUF(:,:) = ZRECVBUF(:,:)

END SUBROUTINE MPL_ALLREDUCE_REAL8_2D



SUBROUTINE MPL_ALLREDUCE_REAL4(PSENDBUF,CDOPER,LDREPROD, &
                            & KCOMM,KERROR,CDSTRING)


#ifdef USE_8_BYTE_WORDS
  USE MPI4TO8, ONLY : &
    MPI_ALLREDUCE => MPI_ALLREDUCE8
#endif

REAL(KIND=JPRM),INTENT(INOUT)        :: PSENDBUF(:)
CHARACTER(LEN=*),INTENT(IN)    :: CDOPER
LOGICAL,INTENT(IN),OPTIONAL :: LDREPROD
INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL :: KCOMM
INTEGER(KIND=JPIM),INTENT(OUT),OPTIONAL :: KERROR
CHARACTER(LEN=*),INTENT(IN),OPTIONAL :: CDSTRING
REAL(KIND=JPRM)            :: ZRECVBUF(SIZE(PSENDBUF))
INTEGER(KIND=JPIM) IPROC, ITAG, ICOUNT
LOGICAL LLREPRODSUM
INTEGER(KIND=JPIM) :: ISENDCOUNT,ICOMM,IERROR,IOPER
INTEGER(KIND=JPIM) :: ITID
IERROR = 0
ITID = OML_MY_THREAD()
LLREPRODSUM = .FALSE.

IF(MPL_NUMPROC < 1) CALL MPL_MESSAGE( &
  & CDMESSAGE='MPL_ALLREDUCE: MPL NOT INITIALISED ',LDABORT=LLABORT) 

IF(CDOPER(1:3) == 'MAX' .OR. CDOPER(1:3) == 'max' ) THEN
  IOPER = MPI_MAX
ELSEIF(CDOPER(1:3) == 'MIN' .OR. CDOPER(1:3) == 'min' ) THEN
  IOPER = MPI_MIN
ELSEIF(CDOPER(1:3) == 'SUM' .OR. CDOPER(1:3) == 'sum' ) THEN
  IOPER = MPI_SUM
  IF (PRESENT(LDREPROD)) THEN
    LLREPRODSUM = LDREPROD
  ELSE
    CALL MPL_MESSAGE(IERROR,&
     & 'MPL_ALLREDUCE: SUMMATION OPERATOR NOT REPRODUCIBLE IN REAL MODE',&
     & CDSTRING,LDABORT=LLABORT)
  ENDIF
ELSE
  CALL MPL_MESSAGE(IERROR,'MPL_ALLREDUCE: ERROR UNKNOWN OPERATOR',&
   & CDSTRING,LDABORT=LLABORT)
ENDIF

IF(PRESENT(KCOMM)) THEN
  ICOMM=KCOMM
ELSE
  ICOMM=MPL_COMM_OML(ITID)
ENDIF

ISENDCOUNT = SIZE(PSENDBUF)
#ifndef NAG
IF (ISENDCOUNT > 0) THEN
  IF( (LOC(PSENDBUF(UBOUND(PSENDBUF,1)))-LOC(PSENDBUF(LBOUND(PSENDBUF,1)))) /= 4_JPIB*(ISENDCOUNT - 1) ) THEN
    CALL MPL_MESSAGE(CDMESSAGE='MPL_ALLREDUCE: BUFFER NOT CONTIGUOUS ',LDABORT=LLABORT)
  ENDIF
ENDIF
#endif

IF (LLREPRODSUM) THEN
!-- Near reproducible summation
  ITAG = 2001
  IF (MPL_RANK == 1) THEN
    DO IPROC=2,MPL_NUMPROC
      CALL MPL_RECV(ZRECVBUF,KSOURCE=IPROC,KCOMM=ICOMM,KTAG=ITAG,&
        &KERROR=IERROR,KOUNT=ICOUNT)
      IF (ICOUNT /= ISENDCOUNT) THEN
        WRITE(MPL_ERRUNIT,'(A,I10,A,I6,A,I10)')&
        & 'MPL_ALLREDUCE: RECEIVED UNEXPECTED NUMBER OF ELEMENTS ', &
        & ICOUNT,' FROM PROC ',IPROC,'. EXPECTED=',ISENDCOUNT
        CALL MPL_MESSAGE(IERROR,'MPL_ALLREDUCE',CDSTRING,LDABORT=LLABORT)
      ENDIF
      PSENDBUF(:) = PSENDBUF(:) + ZRECVBUF(:)
    ENDDO
    ZRECVBUF(:) = PSENDBUF(:)
  ELSE
    CALL MPL_SEND(PSENDBUF,KDEST=1,KCOMM=ICOMM,KTAG=ITAG,KERROR=IERROR,&
      &KMP_TYPE=JP_BLOCKING_STANDARD,CDSTRING='MPLS_SEND')
  ENDIF
  ITAG = ITAG + 1
  CALL MPL_BROADCAST(ZRECVBUF,KTAG=ITAG,KCOMM=ICOMM,KROOT=1,KERROR=IERROR)
ELSE  
  IF ( MPL_NUMPROC > 1 ) &
  CALL MPI_ALLREDUCE(PSENDBUF,ZRECVBUF,ISENDCOUNT,INT(MPI_REAL4), &
                  &  IOPER,ICOMM,IERROR)

  IF(LMPLSTATS) THEN
    CALL MPL_SENDSTATS(ISENDCOUNT,INT(MPI_REAL4))
    CALL MPL_RECVSTATS(ISENDCOUNT,INT(MPI_REAL4))
  ENDIF

ENDIF

IF(MPL_OUTPUT > 1 )THEN
  WRITE(MPL_UNIT,'(A,5I8)') ' MPL_ALLREDUCE ',ISENDCOUNT,ICOMM,IOPER
ENDIF
IF(PRESENT(KERROR)) THEN
  KERROR=IERROR
ELSE
  IF(IERROR /= 0 ) CALL MPL_MESSAGE(IERROR,'MPL_ALLREDUCE',CDSTRING,LDABORT=LLABORT)
ENDIF

IF ( MPL_NUMPROC > 1 ) &
PSENDBUF(:) = ZRECVBUF(:)

END SUBROUTINE MPL_ALLREDUCE_REAL4

SUBROUTINE MPL_ALLREDUCE_REAL4_2D(PSENDBUF,CDOPER,LDREPROD, &
                            & KCOMM,KERROR,CDSTRING)


#ifdef USE_8_BYTE_WORDS
  USE MPI4TO8, ONLY : &
    MPI_ALLREDUCE => MPI_ALLREDUCE8
#endif

REAL(KIND=JPRM),INTENT(INOUT)        :: PSENDBUF(:,:)
CHARACTER(LEN=*),INTENT(IN)    :: CDOPER
LOGICAL,INTENT(IN),OPTIONAL :: LDREPROD
INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL :: KCOMM
INTEGER(KIND=JPIM),INTENT(OUT),OPTIONAL :: KERROR
CHARACTER(LEN=*),INTENT(IN),OPTIONAL :: CDSTRING
REAL(KIND=JPRM)            :: ZRECVBUF(SIZE(PSENDBUF(:,1)),SIZE(PSENDBUF(1,:)))
INTEGER(KIND=JPIM) IPROC, ITAG, ICOUNT
LOGICAL LLREPRODSUM
INTEGER(KIND=JPIM) :: ISENDCOUNT,ICOMM,IERROR,IOPER
INTEGER(KIND=JPIM) :: ITID
IERROR = 0
ITID = OML_MY_THREAD()
LLREPRODSUM = .FALSE.

IF(MPL_NUMPROC < 1) CALL MPL_MESSAGE( &
  & CDMESSAGE='MPL_ALLREDUCE: MPL NOT INITIALISED ',LDABORT=LLABORT)

IF(CDOPER(1:3) == 'MAX' .OR. CDOPER(1:3) == 'max' ) THEN
  IOPER = MPI_MAX
ELSEIF(CDOPER(1:3) == 'MIN' .OR. CDOPER(1:3) == 'min' ) THEN
  IOPER = MPI_MIN
ELSEIF(CDOPER(1:3) == 'SUM' .OR. CDOPER(1:3) == 'sum' ) THEN
  IOPER = MPI_SUM
  IF (PRESENT(LDREPROD)) THEN
    LLREPRODSUM = LDREPROD
  ELSE
    CALL MPL_MESSAGE(IERROR,&
     & 'MPL_ALLREDUCE: SUMMATION OPERATOR NOT REPRODUCIBLE IN REAL MODE',&
     & CDSTRING,LDABORT=LLABORT)
  ENDIF
ELSE
  CALL MPL_MESSAGE(IERROR,'MPL_ALLREDUCE: ERROR UNKNOWN OPERATOR',&
   & CDSTRING,LDABORT=LLABORT)
ENDIF

IF(PRESENT(KCOMM)) THEN
  ICOMM=KCOMM
ELSE
  ICOMM=MPL_COMM_OML(ITID)
ENDIF

ISENDCOUNT = SIZE(PSENDBUF)
!#ifndef NAG
!IF (ISENDCOUNT > 0) THEN
!  IF( (LOC(PSENDBUF(UBOUND(PSENDBUF,1)))-LOC(PSENDBUF(LBOUND(PSENDBUF,1)))) /= 4_JPIB*(ISENDCOUNT - 1) ) THEN
!    CALL MPL_MESSAGE(CDMESSAGE='MPL_ALLREDUCE: BUFFER NOT CONTIGUOUS ',LDABORT=LLABORT)
!  ENDIF
!ENDIF
!#endif

!IF (LLREPRODSUM) THEN
!-- Near reproducible summation
!  ITAG = 2001
!  IF (MPL_RANK == 1) THEN
!    DO IPROC=2,MPL_NUMPROC
!      CALL MPL_RECV(ZRECVBUF,KSOURCE=IPROC,KCOMM=ICOMM,KTAG=ITAG,&
!        &KERROR=IERROR,KOUNT=ICOUNT)
!      IF (ICOUNT /= ISENDCOUNT) THEN
!        WRITE(MPL_ERRUNIT,'(A,I10,A,I6,A,I10)')&
!        & 'MPL_ALLREDUCE: RECEIVED UNEXPECTED NUMBER OF ELEMENTS ', &
!        & ICOUNT,' FROM PROC ',IPROC,'. EXPECTED=',ISENDCOUNT
!        CALL MPL_MESSAGE(IERROR,'MPL_ALLREDUCE',CDSTRING,LDABORT=LLABORT)
!      ENDIF
!      PSENDBUF(:) = PSENDBUF(:) + ZRECVBUF(:)
!    ENDDO
!    ZRECVBUF(:) = PSENDBUF(:)
!  ELSE
!    CALL MPL_SEND(PSENDBUF,KDEST=1,KCOMM=ICOMM,KTAG=ITAG,KERROR=IERROR,&
!      &KMP_TYPE=JP_BLOCKING_STANDARD,CDSTRING='MPLS_SEND')
!  ENDIF
!  ITAG = ITAG + 1
!  CALL MPL_BROADCAST(ZRECVBUF,KTAG=ITAG,KCOMM=ICOMM,KROOT=1,KERROR=IERROR)
!ELSE
IF ( MPL_NUMPROC > 1 ) &
CALL MPI_ALLREDUCE(PSENDBUF,ZRECVBUF,ISENDCOUNT,INT(MPI_REAL4), &
                  &  IOPER,ICOMM,IERROR)

IF(LMPLSTATS) THEN
  CALL MPL_SENDSTATS(ISENDCOUNT,INT(MPI_REAL4))
  CALL MPL_RECVSTATS(ISENDCOUNT,INT(MPI_REAL4))
ENDIF

!ENDIF

IF(MPL_OUTPUT > 1 )THEN
  WRITE(MPL_UNIT,'(A,5I8)') ' MPL_ALLREDUCE ',ISENDCOUNT,ICOMM,IOPER
ENDIF
IF(PRESENT(KERROR)) THEN
  KERROR=IERROR
ELSE
  IF(IERROR /= 0 ) CALL MPL_MESSAGE(IERROR,'MPL_ALLREDUCE',CDSTRING,LDABORT=LLABORT)
ENDIF

IF ( MPL_NUMPROC > 1 ) &
PSENDBUF(:,:) = ZRECVBUF(:,:)

END SUBROUTINE MPL_ALLREDUCE_REAL4_2D


END MODULE MPL_ALLREDUCE_MOD

! (C) Copyright 2005- ECMWF.
! (C) Copyright 2013- Meteo-France.
! 
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!

SUBROUTINE DR_HOOK_PROCINFO(KMYPROC, KNPROC, LMPI_INITIALIZED)
USE EC_PARKIND  ,ONLY : JPIM
USE MPL_MPI
IMPLICIT NONE
INTEGER(KIND=JPIM), INTENT(OUT) :: KMYPROC, KNPROC
LOGICAL, INTENT(OUT) :: LMPI_INITIALIZED
INTEGER(KIND=JPIM) :: IERROR

KMYPROC=1
KNPROC=1
CALL MPI_INITIALIZED(LMPI_INITIALIZED,IERROR)
IF( LMPI_INITIALIZED ) THEN
  CALL MPI_COMM_SIZE(MPI_COMM_WORLD,KNPROC,IERROR)
  CALL MPI_COMM_RANK(MPI_COMM_WORLD,KMYPROC,IERROR)
  KMYPROC = KMYPROC+1 ! 1-based in IFS context
ENDIF
END SUBROUTINE DR_HOOK_PROCINFO

SUBROUTINE C_DR_HOOK_PROCINFO(KMYPROC, KNPROC, KMPI_INITIALIZED) BIND(C, name="c_dr_hook_procinfo")
  USE, INTRINSIC :: ISO_C_BINDING, ONLY : C_INT
  IMPLICIT NONE
  INTEGER(KIND=C_INT), INTENT(OUT) :: KMYPROC, KNPROC, KMPI_INITIALIZED
  LOGICAL :: LLMPI_INITIALIZED

  CALL DR_HOOK_PROCINFO(KMYPROC, KNPROC, LLMPI_INITIALIZED)

  KMPI_INITIALIZED = MERGE(1, 0, LLMPI_INITIALIZED)
END SUBROUTINE C_DR_HOOK_PROCINFO

! (C) Copyright 2005- ECMWF.
! (C) Copyright 2013- Meteo-France.
! 
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!

MODULE MPL_BUFFER_METHOD_MOD

!**** MPL_BUFFER_METHOD Establish message passing default method

!     Purpose.
!     --------
!     Setup the message passing buffering 
!     by allocating an attached buffer if required.

!**   Interface.
!     ----------
!        CALL MPL_BUFFER_METHOD

!        Input required arguments :
!        -------------------------
!           KMP_TYPE -  buffering type
!                       possible values are :
!                       JP_BLOCKING_STANDARD, JP_BLOCKING_BUFFERED
!                       defined as parameters in MPL_DATA_MODULE

!        Input optional arguments :
!        -------------------------
!           KMBX_SIZE - Size (in bytes) of attached buffer 
!                       if KMP_TYPE=JP_BLOCKING_BUFFERED
!           KPROCIDS  - array of processor ids
!           LDINFO   -  = .TRUE.  : Print informative msgs from MPL_INIT (default) 
!                       = .FALSE. : Do not print

!        Output required arguments :
!        -------------------------
!           none

!        Output optional arguments :
!        -------------------------
!           KERROR   -  return error code.     If not supplied, 
!                       MPL_BUFFER_METHOD aborts when an error is detected.
!     Author.
!     -------
!        D.Dent, M.Hamrud     ECMWF

!     Modifications.
!     --------------
!        Original: 2000-09-01

!     ------------------------------------------------------------------

USE MPL_DATA_MODULE
USE MPL_MESSAGE_MOD

IMPLICIT NONE

PRIVATE
PUBLIC MPL_BUFFER_METHOD

CONTAINS 

SUBROUTINE MPL_BUFFER_METHOD(KMP_TYPE,KMBX_SIZE,KERROR,KPROCIDS,LDINFO)


#ifdef USE_8_BYTE_WORDS
  USE MPI4TO8, ONLY : &
    MPI_BUFFER_DETACH => MPI_BUFFER_DETACH8, MPI_BUFFER_ATTACH => MPI_BUFFER_ATTACH8
#endif


USE EC_PARKIND  ,ONLY : JPIM

INTEGER(KIND=JPIM),INTENT(IN) ::  KMP_TYPE
INTEGER(KIND=JPIM),OPTIONAL,INTENT(IN)  :: KMBX_SIZE
INTEGER(KIND=JPIM),OPTIONAL,INTENT(IN)  :: KPROCIDS(:)
INTEGER(KIND=JPIM),OPTIONAL,INTENT(OUT) :: KERROR
LOGICAL,INTENT(IN),OPTIONAL :: LDINFO
INTEGER(KIND=JPIM) :: IMBX_DEFAULT_SIZE = 1000000
INTEGER(KIND=JPIM) :: IBUFFMPI,IERROR,ILEN
LOGICAL :: LLABORT=.TRUE., LLINFO

IF(MPL_NUMPROC < 1) CALL MPL_MESSAGE( &
  & CDMESSAGE='MPL_BUFFER_METHOD: MPL NOT INITIALISED ',LDABORT=LLABORT) 

IF (ALLOCATED(MPL_ATTACHED_BUFFER)) THEN
  CALL MPI_BUFFER_DETACH(MPL_ATTACHED_BUFFER,MPL_MBX_SIZE,IERROR)
  DEALLOCATE(MPL_ATTACHED_BUFFER)
ENDIF

IF(PRESENT(LDINFO)) THEN
  LLINFO = LDINFO
ELSE
  LLINFO = .TRUE.
ENDIF

IF(KMP_TYPE == JP_BLOCKING_STANDARD) THEN
  IBUFFMPI=MPL_MBX_SIZE
ELSE IF(KMP_TYPE == JP_BLOCKING_BUFFERED) THEN
  IBUFFMPI=KMBX_SIZE
  IF(IBUFFMPI == 0) IBUFFMPI=IMBX_DEFAULT_SIZE
!    convert to bytes
  ILEN = (IBUFFMPI-1)/JP_ATTACHED_BUFFER_BYTES+1
  ALLOCATE(MPL_ATTACHED_BUFFER(ILEN))
#ifdef OPS_COMPILE
  IERROR = 0
#else
  CALL MPI_BUFFER_ATTACH(MPL_ATTACHED_BUFFER,IBUFFMPI,IERROR)
#endif
  IF(PRESENT(KERROR)) THEN
    KERROR=IERROR
  ELSE
    IF( IERROR /= 0 )THEN
      CALL MPL_MESSAGE(IERROR,'MPL_BUFFER_METHOD ','MPI_BUFFER_ATTACH ERROR',LDABORT=LLABORT)
    ENDIF
  ENDIF
ELSE
!    invalid type
  IF(PRESENT(KERROR)) THEN
    KERROR=1
  ELSE
    CALL MPL_MESSAGE(KMP_TYPE,'MPL_BUFFER_METHOD','INVALID KMP_TYPE=',LDABORT=LLABORT)
  ENDIF
ENDIF

MPL_MBX_SIZE=IBUFFMPI
MPL_METHOD=KMP_TYPE

IF (MPL_RANK == 1) THEN
  IF (LLINFO) WRITE(MPL_UNIT,'(A,I2,I12)') 'MPL_BUFFER_METHOD: ',MPL_METHOD,MPL_MBX_SIZE
ENDIF

IF(PRESENT(KPROCIDS)) THEN
  IF(SIZE(KPROCIDS) < MPL_NUMPROC) THEN
    CALL MPL_MESSAGE(CDMESSAGE='MPL_BUFFER_METHOD: KPROCIDS NOT CORRECT',LDABORT=LLABORT)
  ELSE
    MPL_IDS=KPROCIDS
  ENDIF
ENDIF

RETURN
END SUBROUTINE MPL_BUFFER_METHOD

END MODULE MPL_BUFFER_METHOD_MOD

! (C) Copyright 2021- ECMWF.
! 
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!

!
! Testing of ec_args; expected to be launched with 3 arguments:
!    <program> arg1 arg2 arg3
!

#define FAIL(msg) call fail_impl(msg,__LINE__)

program test_ec_args
use iso_c_binding
use ec_args_mod
implicit none
integer(c_int) :: argc, iarg

argc = ec_argc()
if( argc /= 0 ) FAIL("argc should be zero before initialisation")

! Setup ec_args --> computes command line arguments in Fortran and stores in C for C to use as well
call ec_args()

argc = ec_argc()
if( argc == 0 ) FAIL("argc should be non-zero after initialisation")

write(0,*) "program name = ", ec_argv(0)

if( argc /= 4 ) FAIL("4 arguments expected")
if( ec_argv(1) /= "arg1" ) FAIL("unexpected value 'arg1'")
if( ec_argv(2) /= "arg2" ) FAIL("unexpected value 'arg2'")
if( ec_argv(3) /= "arg3" ) FAIL("unexpected value 'arg3'")

contains
subroutine fail_impl(msg,line)
    character(*) :: msg
    integer :: line
    write(0,'(A,I0,A)') "TEST FAILED in test_ec_args.F90 @ line ",line," :"
    write(0,*) msg
    stop 1
end subroutine
end program

! (C) Copyright 2005- ECMWF.
! (C) Copyright 2013- Meteo-France.
! 
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!

SUBROUTINE DR_HOOK_PRT(KUNIT, CDSTR)
USE EC_PARKIND  ,ONLY : JPIM
IMPLICIT NONE
INTEGER(KIND=JPIM), INTENT(IN) :: KUNIT
CHARACTER(LEN=*), INTENT(IN) :: CDSTR
IF (KUNIT < 0) THEN
  WRITE(*,'(A)') CDSTR
ELSE
  WRITE(KUNIT,'(A)') CDSTR
  CALL EC_FLUSH(KUNIT)
ENDIF
END SUBROUTINE DR_HOOK_PRT

SUBROUTINE DR_HOOK_PRT_CHAR(KUNIT, CD, KLD)
USE EC_PARKIND  ,ONLY : JPIM
IMPLICIT NONE
INTEGER(KIND=JPIM), INTENT(IN) :: KUNIT
INTEGER(KIND=JPIM), INTENT(IN) :: KLD
CHARACTER(LEN=1), INTENT(IN) :: CD(KLD)
IF (KUNIT < 0) THEN
  WRITE(*,'(40A1)') CD
ELSE
  WRITE(*,'(40A1)') CD
  CALL EC_FLUSH(KUNIT)
ENDIF
END SUBROUTINE DR_HOOK_PRT_CHAR

SUBROUTINE DR_HOOK_PRT_LOGICAL(KUNIT, LD, KLD)
USE EC_PARKIND  ,ONLY : JPIM
IMPLICIT NONE
INTEGER(KIND=JPIM), INTENT(IN) :: KUNIT
INTEGER(KIND=JPIM), INTENT(IN) :: KLD
LOGICAL, INTENT(IN) :: LD(KLD)
IF (KUNIT < 0) THEN
  WRITE(*,'(40L2)') LD
ELSE
  WRITE(KUNIT,'(40L2)') LD
  CALL EC_FLUSH(KUNIT)
ENDIF
END SUBROUTINE DR_HOOK_PRT_LOGICAL

SUBROUTINE DR_HOOK_PRT_I4(KUNIT, KD, KLD)
USE EC_PARKIND  ,ONLY : JPIM
IMPLICIT NONE
INTEGER(KIND=JPIM), INTENT(IN) :: KUNIT
INTEGER(KIND=JPIM), INTENT(IN) :: KLD
INTEGER(KIND=JPIM), INTENT(IN) :: KD(KLD)
IF (KUNIT < 0) THEN
  WRITE(*,'(5I12)') KD
ELSE
  WRITE(KUNIT,'(5I12)') KD
  CALL EC_FLUSH(KUNIT)
ENDIF
END SUBROUTINE DR_HOOK_PRT_I4

SUBROUTINE DR_HOOK_PRT_I8(KUNIT, KD, KLD)
USE EC_PARKIND  ,ONLY : JPIM, JPIB
IMPLICIT NONE
INTEGER(KIND=JPIM), INTENT(IN) :: KUNIT
INTEGER(KIND=JPIM), INTENT(IN) :: KLD
INTEGER(KIND=JPIB), INTENT(IN) :: KD(KLD)
IF (KUNIT < 0) THEN
  WRITE(*,'(5I20)') KD
ELSE
  WRITE(KUNIT,'(5I20)') KD
  CALL EC_FLUSH(KUNIT)
ENDIF
END SUBROUTINE DR_HOOK_PRT_I8

SUBROUTINE DR_HOOK_PRT_R4(KUNIT, PD, KLD)
USE EC_PARKIND  ,ONLY : JPIM, JPIB, JPRM
IMPLICIT NONE
INTEGER(KIND=JPIM), INTENT(IN) :: KUNIT
INTEGER(KIND=JPIM), INTENT(IN) :: KLD
REAL(KIND=JPRM), INTENT(IN) :: PD(KLD)
IF (KUNIT < 0) THEN
  WRITE(*,*) PD
ELSE
  WRITE(KUNIT,*) PD
  CALL EC_FLUSH(KUNIT)
ENDIF
END SUBROUTINE DR_HOOK_PRT_R4

SUBROUTINE DR_HOOK_PRT_R8(KUNIT, PD, KLD)
USE EC_PARKIND  ,ONLY : JPIM, JPIB, JPRD
IMPLICIT NONE
INTEGER(KIND=JPIM), INTENT(IN) :: KUNIT
INTEGER(KIND=JPIM), INTENT(IN) :: KLD
REAL(KIND=JPRD), INTENT(IN) :: PD(KLD)
IF (KUNIT < 0) THEN
  WRITE(*,*) PD
ELSE
  WRITE(KUNIT,*) PD
  CALL EC_FLUSH(KUNIT)
ENDIF
END SUBROUTINE DR_HOOK_PRT_R8

! (C) Copyright 2005- ECMWF.
! (C) Copyright 2013- Meteo-France.
! 
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!

MODULE MPL_TOUR_TABLE_MOD

USE EC_PARKIND  ,ONLY : JPIM

USE MPL_DATA_MODULE, ONLY : MPL_NUMPROC, MPL_RANK, MPL_ERRUNIT
USE MPL_MESSAGE_MOD

IMPLICIT NONE

PRIVATE
PUBLIC MPL_TOUR_TABLE

CONTAINS
SUBROUTINE MPL_TOUR_TABLE(KOPPONENT, KEVEN)
INTEGER(KIND=JPIM),INTENT(OUT)::KOPPONENT(:)
INTEGER(KIND=JPIM),INTENT(OUT),OPTIONAL::KEVEN

INTEGER(KIND=JPIM) :: ICIRCULAR(MPL_NUMPROC+1)
INTEGER(KIND=JPIM) :: IEVEN,IMYPOS,ITMP,JK,JI
LOGICAL :: LLABORT=.TRUE.

IEVEN = ((MPL_NUMPROC+1)/2)*2
IF(SIZE(KOPPONENT)  < IEVEN) THEN
  WRITE(MPL_ERRUNIT,*)'MPL_TOUR_TABLE: ERROR KOPPONENT dimension=',&
   & SIZE(KOPPONENT),'. MUST BE AT LEAST=',IEVEN
  CALL MPL_MESSAGE(CDMESSAGE='MPL_TOUR_TABLE: ERROR KOPPONENT dimension wrong',&
   & LDABORT=LLABORT)
ENDIF

DO JK = 1,IEVEN
  ICIRCULAR(JK) = JK
ENDDO
KOPPONENT(:) = -1
IMYPOS = MPL_RANK
DO JK=1,IEVEN-1
  KOPPONENT(JK) = ICIRCULAR(IEVEN-IMYPOS+1)
  ITMP = ICIRCULAR(IEVEN-1)
  DO JI=IEVEN-2,1,-1
    ICIRCULAR(JI+1) = ICIRCULAR(JI)
  ENDDO
  ICIRCULAR(1) = ITMP
  IF(MPL_RANK < IEVEN) IMYPOS = MOD(IMYPOS,IEVEN-1)+1
ENDDO

KOPPONENT(IEVEN) = MPL_RANK

IF (PRESENT(KEVEN)) KEVEN = IEVEN

END SUBROUTINE MPL_TOUR_TABLE
END MODULE MPL_TOUR_TABLE_MOD

! (C) Copyright 2026- ECMWF.
!
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!

PROGRAM TEST_GSTATS
    USE YOMGSTATS, ONLY : JPMAXSTAT
    USE EC_PARKIND, ONLY : JPRD
    USE EC_LUN, ONLY : NULOUT
    IMPLICIT NONE
    REAL(JPRD) :: AVEARRAY(0:JPMAXSTAT)

    CALL TEST_INIT()
    CALL GSTATS(0,0)
    CALL GSTATS(1,0)
    CALL WORK_SECTION_1()
    CALL GSTATS(1,1)
    CALL GSTATS(2,0)
    CALL WORK_SECTION_2()
    CALL GSTATS(2,1)
    CALL GSTATS(0,1)
    CALL GSTATS_PRINT(NULOUT,AVEARRAY, JPMAXSTAT)

    ! CHECK THAT THE CSV FILE EXISTS
    CALL CHECK_OUTPUT()
    CALL TEST_END()

CONTAINS
    
    ! ---------------------------------------------------------------------
    SUBROUTINE WORK_SECTION_1
      IMPLICIT NONE
      REAL(JPRD) :: X
      INTEGER :: I
      X = 0.0_JPRD
      DO I = 1, 5000000
         X = X + SIN(REAL(I, JPRD))
      END DO
    END SUBROUTINE WORK_SECTION_1
    ! ---------------------------------------------------------------------
    
    SUBROUTINE WORK_SECTION_2
      IMPLICIT NONE
      REAL(JPRD) :: X
      INTEGER :: I
      X = 1.0_JPRD
      DO I = 1, 4000000
         X = X * 1.0000001_JPRD
      END DO
    END SUBROUTINE WORK_SECTION_2
    ! ---------------------------------------------------------------------
    
    SUBROUTINE TEST_INIT
      USE MPL_MODULE, ONLY : MPL_RANK, MPL_NUMPROC, MPL_INIT
      USE EC_LUN, ONLY : NULOUT

      INTEGER :: KPROC, KMYPROC, JPROC
      INTEGER, ALLOCATABLE :: KPRCIDS(:)
      LOGICAL :: LDSTATS, LDSTATSCPU, LDSYNCSTATS
      LOGICAL :: LDDETAILED_STATS, LDBARRIER_STATS, LDBARRIER_STATS2
      LOGICAL :: LDSTATS_OMP, LDSTATS_COMMS, LDSTATS_MEM
      LOGICAL :: LDSTATS_ALLOC, LDTRACE_STATS, LDXML_STATS, LDCSV_STATS
      INTEGER :: KSTATS_MEM, KTRACE_STATS, KPRNT_STATS
      LOGICAL :: LUSE_MPI

#include "gstats_setup.intfb.h"

      ! INITIALIZE ENVIRONMENT
      LUSE_MPI = DETECT_MPIRUN()
      KPROC   = 1
      KMYPROC = 1
      IF (LUSE_MPI) THEN
        CALL MPL_INIT(LDINFO=.TRUE.)
        KMYPROC = MPL_RANK
        KPROC   = MPL_NUMPROC
      ENDIF
      IF (KMYPROC == 1) THEN
        WRITE(0,*) "LUSE_MPI: ", LUSE_MPI
        WRITE(0,*) "NPROC:    ", KPROC
      ELSE
        ! All other ranks set EC_LUN's NULOUT to /dev/null
        OPEN(UNIT=NULOUT, FILE='/dev/null')
      ENDIF
      ALLOCATE(KPRCIDS(KPROC))

      LDSTATS          = .TRUE.
      LDSTATSCPU       = .FALSE.
      LDSYNCSTATS      = .FALSE.
      LDDETAILED_STATS = .TRUE.
      LDBARRIER_STATS  = .FALSE.
      LDBARRIER_STATS2 = .FALSE.
      LDSTATS_OMP      = .FALSE.
      LDSTATS_COMMS    = .FALSE.
      LDSTATS_MEM      = .FALSE.
      KSTATS_MEM       = 0
      LDSTATS_ALLOC    = .FALSE.
      LDTRACE_STATS    = .FALSE.
      KTRACE_STATS     = 0
      KPRNT_STATS      = KPROC
      LDXML_STATS      = .FALSE.
      LDCSV_STATS      = .TRUE.
      DO JPROC = 1, KPROC
        KPRCIDS(JPROC) = JPROC
      ENDDO

      CALL GSTATS_SETUP( KPROC, KMYPROC, KPRCIDS, &
           LDSTATS, LDSTATSCPU, LDSYNCSTATS, LDDETAILED_STATS, &
           LDBARRIER_STATS, LDBARRIER_STATS2, &
           LDSTATS_OMP, LDSTATS_COMMS, LDSTATS_MEM, KSTATS_MEM, LDSTATS_ALLOC, &
           LDTRACE_STATS, KTRACE_STATS, KPRNT_STATS, LDXML_STATS, LDCSV_STATS )
      CALL GSTATS_LABEL(0, "   ", "TOTAL EXECUTION")
      CALL GSTATS_LABEL(1, "CAT 1", "WORK 1") ! Note that second argument will be truncated to 3 chars
      CALL GSTATS_LABEL(2, "CAT 1", "WORK 2") ! Note that second argument will be truncated to 3 chars
      CALL GSTATS_PSUT

    END SUBROUTINE TEST_INIT
    ! ---------------------------------------------------------------------
    
    SUBROUTINE TEST_END
      USE MPL_MODULE, ONLY : MPL_END, MPL_NUMPROC
      IF (MPL_NUMPROC > 0) THEN
        CALL MPL_END(LDMEMINFO=.FALSE.)
      ENDIF
    END SUBROUTINE TEST_END
    ! ---------------------------------------------------------------------
    
    SUBROUTINE CHECK_OUTPUT
      USE MPL_MODULE, ONLY : MPL_RANK, MPL_NUMPROC
      IMPLICIT NONE
      LOGICAL :: EXISTS
      CHARACTER(LEN=32) :: FNAME
      INTEGER :: U
      INTEGER :: MYPROC

      MYPROC = 1
      IF (MPL_NUMPROC > 0) THEN
        MYPROC = MPL_RANK
      ENDIF
      WRITE(FNAME, '(A,I0,A)') 'gstats.', MYPROC, '.csv'

      INQUIRE(FILE=FNAME, EXIST=EXISTS)
    
      IF (.NOT. EXISTS) THEN
        PRINT *, "ERROR: GSTATS DID NOT CREATE FILE: ", TRIM(FNAME)
        STOP 1
      ELSE
        OPEN(NEWUNIT=U, FILE=FNAME, STATUS='OLD')
        CLOSE(U, STATUS='DELETE')
        PRINT *, "OK: FILE GENERATED: ", TRIM(FNAME)
      END IF
    END SUBROUTINE CHECK_OUTPUT
    ! ---------------------------------------------------------------------
    
    function detect_mpirun() result(lmpi_required)
      logical :: lmpi_required
      integer :: ilen
      integer, parameter :: nvars = 4
      character(len=32), dimension(nvars) :: cmpirun_detect
      character(len=4) :: clenv_value
      integer :: ivar
      lmpi_required = .false.

      call get_environment_variable(name='FIAT_USE_MPI', value=clenv_value, length=ilen)
      write(0,*) "FIAT_USE_MPI: ", clenv_value
      if (ilen > 0) then
        if (clenv_value == '1' .or. clenv_value == 'TRUE' .or. clenv_value == 'ON') then
          write(0,*) "FIAT_USE_MPI environment variable set to a true value, MPI will be used"
          lmpi_required = .true.
        else
          write(0,*) "FIAT_USE_MPI environment variable set to a false value, MPI will NOT be used"
          lmpi_required = .false.
        endif
        return
      endif

      ! Environment variables that are set when mpirun, srun, aprun, ... are used
      cmpirun_detect(1) = 'OMPI_COMM_WORLD_SIZE'  ! openmpi
      cmpirun_detect(2) = 'ALPS_APP_PE'           ! cray pe
      cmpirun_detect(3) = 'PMI_SIZE'              ! intel
      cmpirun_detect(4) = 'SLURM_NTASKS'          ! slurm

      do ivar = 1, nvars
        call get_environment_variable(name=trim(cmpirun_detect(ivar)), length=ilen)
        if (ilen > 0) then
          lmpi_required = .true.
          exit ! break
        endif
      enddo
    end function

    END PROGRAM TEST_GSTATS
    

! (C) Copyright 2005- ECMWF.
! 
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!

program main

! From library fiat
  use yomhook      ! assert found
  use mpl_module   ! assert found
! From library parkind_(dp|sp)
  use parkind1, only: JPRB ! assert found

implicit none

write(0,*) "JPRB =",JPRB ! depending on link with parkind_sp or parkind_dp this will print 4 or 8

end program

! (C) Copyright 2005- ECMWF.
! (C) Copyright 2013- Meteo-France.
! 
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!

MODULE MPL_PROBE_MOD

!**** MPL_PROBE - Check for incoming message

!     Purpose.
!     --------
!     Look for existence of an incoming message.

!**   Interface.
!     ----------
!        CALL MPL_PROBE

!        Input required arguments :
!        -------------------------
!           none

!        Input optional arguments :
!        -------------------------
!           KSOURCE  -  rank of process sending the message
!                       default is MPI_ANY_SOURCE
!           KTAG     -  tag of incoming message
!                       default is MPI_ANY_TAG
!           KCOMM    -  Communicator number if different from MPI_COMM_WORLD 
!           LDWAIT   -  = TRUE : waits for a message to be available
!                       = FALSE: return immediately and set
!                                LDFLAG to indicate if a message exists
!           CDSTRING -  Character string for ABORT messages
!                       used when KERROR is not provided

!        Output required arguments :
!        -------------------------
!           none

!        Output optional arguments :
!        -------------------------
!           KERROR   -  return error code.     If not supplied, 
!                       MPL_PROBE aborts when an error is detected.
!           LDFLAG   -  must be supplied if LDWAIT=false
!                       = TRUE if a message exists
!     Author.
!     -------
!        D.Dent, M.Hamrud     ECMWF

!     Modifications.
!     --------------
!        Original: 2000-09-01
!        P. Marguinaud : 01-Jan-2011 : Extends original interface with 
!                                      KCOUNT,KRECVTAG,KFROM (same meaning as
!                                      in all MPL_* routines)

!     ------------------------------------------------------------------

USE EC_PARKIND  ,ONLY : JPIM
USE OML_MOD   ,ONLY : OML_MY_THREAD

USE MPL_MPIF
USE MPL_DATA_MODULE
USE MPL_MESSAGE_MOD

IMPLICIT NONE

PUBLIC MPL_PROBE

PRIVATE

!--- Moved into subroutine to make thrreadsafe----
! INTEGER(KIND=JPIM) :: IRECV_STATUS(MPI_STATUS_SIZE)
! INTEGER(KIND=JPIM) :: ICOMM,ITAG,ISOURCE,IERROR
! LOGICAL :: LLWAIT,LLABORT=.TRUE.

CONTAINS

SUBROUTINE MPL_PROBE(KSOURCE,KTAG,KCOMM,LDWAIT,LDFLAG,CDSTRING,KERROR,KCOUNT,KRECVTAG,KFROM)


#ifdef USE_8_BYTE_WORDS
  USE MPI4TO8, ONLY : &
    MPI_PROBE => MPI_PROBE8, MPI_IPROBE => MPI_IPROBE8
#endif


INTEGER(KIND=JPIM),INTENT(IN), OPTIONAL  :: KSOURCE,KTAG,KCOMM
INTEGER(KIND=JPIM),INTENT(OUT),OPTIONAL  :: KERROR
LOGICAL,INTENT(IN), OPTIONAL  :: LDWAIT
LOGICAL,INTENT(OUT),OPTIONAL  :: LDFLAG
CHARACTER(LEN=*),INTENT(IN),OPTIONAL :: CDSTRING
INTEGER(KIND=JPIM),INTENT(OUT),OPTIONAL  :: KCOUNT, KRECVTAG, KFROM

INTEGER(KIND=JPIM) :: IRECV_STATUS(MPI_STATUS_SIZE)
INTEGER(KIND=JPIM) :: ICOMM,ITAG,ISOURCE,IERROR
LOGICAL :: LLWAIT,LLABORT=.TRUE.
INTEGER(KIND=JPIM) :: ITID
ITID = OML_MY_THREAD()
IF(MPL_NUMPROC < 1) CALL MPL_MESSAGE( &
  & CDMESSAGE='MPL_PROBE: MPL NOT INITIALISED ',LDABORT=LLABORT) 

IF(PRESENT(KCOMM)) THEN
  ICOMM=KCOMM
ELSE
  ICOMM=MPL_COMM_OML(ITID)
ENDIF
IF(PRESENT(KSOURCE)) THEN
  ISOURCE=KSOURCE-1
ELSE
  ISOURCE=MPI_ANY_SOURCE
ENDIF
IF(PRESENT(KTAG)) THEN
  ITAG=KTAG
ELSE
  ITAG=MPI_ANY_TAG
ENDIF

IF(PRESENT(LDWAIT)) THEN
  LLWAIT=LDWAIT
ELSE
  LLWAIT=.TRUE.
ENDIF

IF(LLWAIT) THEN
  CALL MPI_PROBE(ISOURCE,ITAG,ICOMM,IRECV_STATUS,IERROR)
  IF (IERROR == 0) THEN
    IF (PRESENT (KCOUNT))   CALL MPI_GET_COUNT (IRECV_STATUS, MPI_CHARACTER, KCOUNT, IERROR) 
    IF (PRESENT (KRECVTAG)) KRECVTAG = IRECV_STATUS(MPI_TAG)
    IF (PRESENT (KFROM))    KFROM    = IRECV_STATUS(MPI_SOURCE)+1
  ENDIF
ELSE
  IF(PRESENT(LDFLAG)) THEN
    CALL MPI_IPROBE(ISOURCE,ITAG,ICOMM,LDFLAG,IRECV_STATUS,IERROR)
    IF (IERROR == 0 .AND. LDFLAG) THEN
      IF (PRESENT (KCOUNT))   CALL MPI_GET_COUNT (IRECV_STATUS, MPI_CHARACTER, KCOUNT, IERROR)
      IF (PRESENT (KRECVTAG)) KRECVTAG = IRECV_STATUS(MPI_TAG)
      IF (PRESENT (KFROM))    KFROM    = IRECV_STATUS(MPI_SOURCE)+1
    ENDIF
  ELSE
    CALL MPL_MESSAGE(IERROR,'MPL_PROBE: MUST PROVIDE LDFLAG ',CDSTRING, &
                    & LDABORT=LLABORT)
  ENDIF
ENDIF
IF(PRESENT(KERROR)) THEN
  KERROR=IERROR
ELSE
  IF(IERROR /= 0 ) CALL MPL_MESSAGE(IERROR,'MPL_PROBE',CDSTRING,LDABORT=LLABORT)
ENDIF
  
RETURN
END SUBROUTINE MPL_PROBE

END MODULE MPL_PROBE_MOD

MODULE XRD_GETOPTIONS

!**** *XRD_GETOPTIONS*  - Parse command lines options in long form

!     Author. 
!     ------- 
!      Philippe Marguinaud *METEO FRANCE*
!      Original : 11-09-2012

USE EC_PARKIND, ONLY: JPIM, JPRD, JPRM

USE XRD_UNIX_ENV, ONLY: XRD_IARGC, XRD_GETARG, &
  XRD_BASENAME, XRD_COUNTWORDS, XRD_GETENV,    &
  XRD_ISALPHA, XRD_ISDIGIT, XRD_EXIT

IMPLICIT NONE

INTERFACE GETOPTION
  MODULE PROCEDURE GETOPTIONS, GETOPTIONSL, &
                   GETOPTIONI, GETOPTIONIL, &
                   GETOPTIONR4, GETOPTIONR4L, &
                   GETOPTIONR8, GETOPTIONR8L, &
                   GETOPTIONB
                   
END INTERFACE

!! @TODO : LIST WITH FIXED SIZE

PUBLIC :: GETOPTION, INITOPTIONS, CHECKOPTIONS, ADDGROUP

INTEGER, PARAMETER :: ARGSIZEMAX = 256

CHARACTER(LEN=ARGSIZEMAX), POINTER :: MYARGS(:) => NULL()
LOGICAL(KIND=JPIM), POINTER :: CHECK_ARGS(:) => NULL()
LOGICAL(KIND=JPIM) :: LHELP  = .FALSE., LSHELL = .FALSE.

CHARACTER(LEN=1056) :: MESSAGE_OPT = ""


TYPE XRD_OPT
  CHARACTER(LEN=32) :: KEY, TYPE
  CHARACTER(LEN=1024) :: USE
  LOGICAL(KIND=JPIM) :: GROUP = .FALSE.
END TYPE

INTEGER(KIND=JPIM) :: NOPT_SEEN
TYPE(XRD_OPT), POINTER :: OPT_SEEN(:) => NULL()

PRIVATE

CONTAINS

SUBROUTINE ADDGROUP( USE )
CHARACTER(LEN=*), INTENT(IN) :: USE

CALL INIT_OPT_SEEN()
NOPT_SEEN = NOPT_SEEN + 1
CALL GROW_OPT_SEEN()

OPT_SEEN(NOPT_SEEN)%GROUP = .TRUE.
OPT_SEEN(NOPT_SEEN)%USE = USE


END SUBROUTINE ADDGROUP

CHARACTER(LEN=ARGSIZEMAX) FUNCTION GET_ENV_OPT( KEY )
CHARACTER(LEN=*), INTENT(IN) :: KEY
CHARACTER(LEN=ARGSIZEMAX) :: KEY_ENV, VAL_ENV
INTEGER(KIND=JPIM) :: I, N
CHARACTER :: C

KEY_ENV = KEY(3:)

N = LEN(TRIM(KEY_ENV))
DO I = 1, N
  C = KEY_ENV(I:I)
  IF((.NOT.XRD_ISALPHA(C)) .AND. &
     (.NOT.XRD_ISDIGIT(C)) .AND. &
     (C .NE. '_' )) THEN
    KEY_ENV(I:I) = '_'
  ENDIF
ENDDO

VAL_ENV = ""
CALL XRD_GETENV( 'XRD_OPT_'//TRIM(KEY_ENV), VAL_ENV )

!PRINT *, " KEY = ", TRIM(KEY_ENV), " VAL = ", TRIM(VAL_ENV)

GET_ENV_OPT = VAL_ENV

END FUNCTION GET_ENV_OPT

SUBROUTINE MYGETARG( I, S )
  INTEGER(KIND=JPIM), INTENT(IN)  :: I
  CHARACTER(LEN=*),      INTENT(OUT) :: S
!
  IF( I .LE. UBOUND( MYARGS, 1 ) ) THEN
    S = MYARGS(I)
  ELSE
    S = ""
   ENDIF
END SUBROUTINE MYGETARG

INTEGER FUNCTION MYIARGC()
  INTEGER :: N
  N = UBOUND( MYARGS, 1 )
  MYIARGC = N
END FUNCTION MYIARGC

SUBROUTINE ADDOPT_SHELL( KEY, TYPE, MND, USE )
  CHARACTER*(*), INTENT(IN) :: KEY, TYPE, USE
  LOGICAL(KIND=JPIM), INTENT(IN) :: MND
  OPTIONAL :: USE, MND
!
  CHARACTER(LEN=ARGSIZEMAX) :: STR
  INTEGER :: NN, N, N1, I1, I2, K
  CHARACTER(LEN=ARGSIZEMAX), POINTER :: MYARGS1(:)

  MYARGS1 => NULL()

  IF( PRESENT( USE ) ) WRITE( *, '("> ",A)' ) TRIM(USE)
  IF( PRESENT( MND ) ) THEN
    IF( MND ) WRITE( *, * ) "[MANDATORY]"
  ENDIF 
  WRITE( *, * ) "* OPTION: [", TYPE, "]", " ", TRIM(KEY)
  READ( *, '(A)' ) STR

! PRINT *, "STR = ",TRIM(STR)
  IF( TRIM(STR) .NE. "" )  THEN
    IF( TYPE .EQ. 'FLAG' ) THEN
      NN = 0
    ELSE
      NN = XRD_COUNTWORDS( STR )
    ENDIF
    N  = UBOUND( MYARGS, 1 )
    N1 = N + NN + 1

!
! REALLOC MYARGS
!
    ALLOCATE( MYARGS1(0:N1) )
    MYARGS1(0:N) = MYARGS(0:N)
    DEALLOCATE( MYARGS )
    MYARGS => MYARGS1
    MYARGS(N+1) = KEY

!
! PARSE ARGUMENT LIST
!
    IF( TYPE .NE. 'FLAG' ) THEN
      K = 1
      I1 = 1
      LOOP_I1 : DO 
        DO
          IF( I1 .GT. LEN(STR)) EXIT LOOP_I1
          IF( STR(I1:I1) .NE. ' ' ) EXIT
          I1 = I1+1
        ENDDO
        I2 = I1+1
        DO
          IF( I2 .GT. LEN(STR)) EXIT
          IF( STR(I2:I2) .EQ. ' ' ) EXIT
          I2 = I2+1
        ENDDO
!PRINT *, I1, I2
        MYARGS(N+1+K) = STR(I1:I2-1)
!PRINT *, K, TRIM(MYARGS(N+1+K))
        K = K+1
        I1 = I2+1
      ENDDO LOOP_I1
    ENDIF
  ENDIF

END SUBROUTINE ADDOPT_SHELL

SUBROUTINE INIT_OPT_SEEN()

  IF( .NOT. ASSOCIATED( OPT_SEEN ) ) THEN
    NOPT_SEEN = 0
    ALLOCATE( OPT_SEEN( 32 ) )
  ENDIF

END SUBROUTINE INIT_OPT_SEEN

SUBROUTINE GROW_OPT_SEEN()
  INTEGER(KIND=JPIM) :: N
  TYPE(XRD_OPT), POINTER :: OPT_SEEN1(:)

  N = SIZE( OPT_SEEN )
  IF( NOPT_SEEN .GE. N ) THEN ! REALLOC DATA
    OPT_SEEN1 => OPT_SEEN
    ALLOCATE( OPT_SEEN( 2 * N ) )
    OPT_SEEN(1:NOPT_SEEN) = OPT_SEEN1(1:NOPT_SEEN)
    DEALLOCATE( OPT_SEEN1 )
  ENDIF

END SUBROUTINE GROW_OPT_SEEN

SUBROUTINE ADDOPT( KEY, TYPE, USE )
  CHARACTER*(*), INTENT(IN) :: KEY, TYPE, USE
  OPTIONAL :: USE

  CALL INIT_OPT_SEEN()

  NOPT_SEEN = NOPT_SEEN + 1

  CALL GROW_OPT_SEEN()

  OPT_SEEN(NOPT_SEEN)%KEY  = KEY
  OPT_SEEN(NOPT_SEEN)%TYPE = TYPE

  IF( PRESENT( USE ) ) THEN
    OPT_SEEN(NOPT_SEEN)%USE  = USE
  ELSE
    OPT_SEEN(NOPT_SEEN)%USE  = ''
  ENDIF

END SUBROUTINE ADDOPT

SUBROUTINE INITOPTIONS( CDMESSAGE, KOPTMIN, KOPTMAX, CDARGS )
 CHARACTER(LEN=*),    OPTIONAL, INTENT (IN) :: CDMESSAGE
 INTEGER (KIND=JPIM), OPTIONAL, INTENT (IN) :: KOPTMIN, KOPTMAX
 CHARACTER (LEN=*),   OPTIONAL, INTENT (IN) :: CDARGS (0:)
 INTEGER(KIND=JPIM) :: N, I
 INTEGER(KIND=JPIM) :: IOPTMIN, IOPTMAX
 CHARACTER*32 :: STR

 IF (PRESENT (CDARGS)) THEN
   N = UBOUND (CDARGS, 1)
 ELSE
   N = XRD_IARGC()
 ENDIF

 IOPTMIN = 0
 IOPTMAX = N
 IF (PRESENT (KOPTMIN)) IOPTMIN = KOPTMIN
 IF (PRESENT (KOPTMAX)) IOPTMAX = KOPTMAX

 N = IOPTMAX-IOPTMIN

 ALLOCATE( MYARGS(0:N) )
 DO I = 0, N
   IF (PRESENT (CDARGS)) THEN
     MYARGS(I) = CDARGS (IOPTMIN+I)
   ELSE
     CALL XRD_GETARG( IOPTMIN+I, MYARGS(I) )
   ENDIF
 ENDDO

 IF( PRESENT( CDMESSAGE ) ) THEN
  MESSAGE_OPT = CDMESSAGE
 ELSE
  MESSAGE_OPT = ""
 ENDIF

 IF( N .EQ. 1 ) THEN
   CALL MYGETARG( 1_JPIM, STR )
   IF( TRIM( STR ) .EQ. '--help' ) THEN
     LHELP = .TRUE.
     RETURN
   ELSE IF( TRIM( STR ) .EQ. '--shell' ) THEN
     LSHELL = .TRUE.
     RETURN
   ENDIF
 ENDIF

 LHELP = .FALSE.
 ALLOCATE( CHECK_ARGS( N ) )
 CHECK_ARGS = .FALSE.

END SUBROUTINE INITOPTIONS



SUBROUTINE CHECKOPTIONS()
 INTEGER(KIND=JPIM) :: I, N, IS, NS, KS
 CHARACTER(LEN=ARGSIZEMAX) :: OPT, PROG
 LOGICAL(KIND=JPIM) :: PB
 CHARACTER(LEN=10) :: FMT
 CHARACTER(LEN=110) :: BUF

 CALL MYGETARG( 0_JPIM, PROG )

 IF( LHELP ) THEN
   PRINT *, "PROGRAM: ", TRIM(XRD_BASENAME( PROG ))
   IF( TRIM(MESSAGE_OPT) .NE. "" ) THEN
     NS = LEN(MESSAGE_OPT)
     DO IS = 1, NS / 96
       KS = LEN( TRIM(MESSAGE_OPT(1+(IS-1)*96:IS*96)) )
       IF( KS .GT. 0 ) THEN
         IF( IS .EQ. 1 ) THEN
           WRITE( *, '("    ")', ADVANCE = 'NO' )
         ELSE
           WRITE( *, '("  > ")', ADVANCE = 'NO' )
         ENDIF
         WRITE( FMT, '("(A",I2,")")' ) KS
         WRITE( *, FMT ) TRIM(MESSAGE_OPT(1+(IS-1)*96:IS*96))
       ENDIF
     ENDDO
   ENDIF
   DO I = 1, NOPT_SEEN

     IF(OPT_SEEN(I)%GROUP) THEN
       WRITE( *, * ) 
       IF( TRIM(OPT_SEEN(I)%USE) .NE. "" ) &
         WRITE( *, * ) '* '//TRIM(OPT_SEEN(I)%USE)
       CYCLE
     ENDIF

     BUF = ""

     WRITE( BUF, '(A32," = ",A15)' ) &
         TRIM(OPT_SEEN(I)%KEY), &
         TRIM(OPT_SEEN(I)%TYPE)

     IF( TRIM(OPT_SEEN(I)%USE) .NE. '' ) THEN
       NS = LEN( OPT_SEEN(I)%USE) 
       DO IS = 1, NS / 48
         KS = LEN(TRIM(OPT_SEEN(I)%USE(1+(IS-1)*48:IS*48)))
         IF( KS .GT. 0 ) THEN
           IF( IS .EQ. 1 ) THEN
             BUF = TRIM(BUF)//" :   "//TRIM(OPT_SEEN(I)%USE(1+(IS-1)*48:IS*48))
           ELSE
!                   000000000011111111112222222222333333333344444444445555555555
!                   012345678901234567890123456789012345678901234567890123456789
             BUF = "                                                     > "&
                   //TRIM(OPT_SEEN(I)%USE(1+(IS-1)*48:IS*48))
           ENDIF
           WRITE( *, '(A120)' ) BUF
         ENDIF
       ENDDO
     ELSE
       WRITE( *, '(A120)' ) BUF
       WRITE( *, * )
     ENDIF

   ENDDO
   STOP
 ELSE IF( ASSOCIATED( CHECK_ARGS ) ) THEN
   N = SIZE( CHECK_ARGS )
   PB = .FALSE.
   DO I = 1, N
     IF( .NOT. CHECK_ARGS(I) ) THEN
       CALL MYGETARG( I, OPT )
       IF( OPT(1:2) .EQ. '--' ) THEN
         PRINT *, 'INVALID OPTION: ', TRIM(OPT)
         PB = .TRUE.
         CHECK_ARGS(I) = .TRUE.
       ENDIF
     ENDIF
   ENDDO

   DO I = 1, N
     IF( .NOT. CHECK_ARGS(I) ) THEN
       CALL MYGETARG( I, OPT )
       PRINT *, 'GARBAGE IN OPTIONS:`', TRIM(OPT), "'"
       PB = .TRUE.
       EXIT
     ENDIF
   ENDDO

   IF( PB ) CALL XRD_EXIT(1_JPIM)

   DEALLOCATE( CHECK_ARGS )
 ELSE IF( LSHELL ) THEN
   OPEN( 77, FILE = TRIM(PROG)//'.sh', FORM = 'FORMATTED' )
   WRITE( 77, '("#!/bin/sh")' )
   WRITE( 77, * )
   WRITE( 77, '(A)', ADVANCE = 'NO' ) TRIM(PROG)
   N = UBOUND( MYARGS, 1 )
   DO I = 1, N
     IF( MYARGS(I) .EQ. '--shell' ) CYCLE
     IF( MYARGS(I)(1:2) .EQ. '--' ) THEN
       WRITE( 77, '(" \")' )
       WRITE( 77, '("    ")', ADVANCE = 'NO' )
     ENDIF
     WRITE( 77, '(" ",A)', ADVANCE = 'NO' ) TRIM(MYARGS(I))
   ENDDO
   WRITE( 77, * )
   CLOSE(77)
 ENDIF



 IF( ASSOCIATED( OPT_SEEN ) ) DEALLOCATE( OPT_SEEN )
 IF( ASSOCIATED( MYARGS ) ) DEALLOCATE( MYARGS )
END SUBROUTINE CHECKOPTIONS


SUBROUTINE CHECK_MND( KEY, MND, USE )
 CHARACTER(LEN=*),           INTENT(IN) :: KEY
 CHARACTER(LEN=*), OPTIONAL, INTENT(IN) :: USE
 LOGICAL(KIND=JPIM), OPTIONAL, INTENT(IN) :: MND
!
 CHARACTER(LEN=ARGSIZEMAX) :: PROG

 IF( PRESENT( MND ) ) THEN
   IF( MND ) THEN
     CALL MYGETARG( 0_JPIM, PROG )
     WRITE( *, '("PROGRAM: ",(A))' ) TRIM( PROG )
     WRITE( *, '("ERROR:   OPTION `",(A),"'' IS MANDATORY")' ) TRIM( KEY )
     IF( PRESENT( USE ) ) WRITE( *, '("         ",(A)," : ",(A))' ) TRIM( KEY ), TRIM( USE )
     CALL XRD_EXIT(1_JPIM)
   ENDIF
 ENDIF

END SUBROUTINE CHECK_MND

SUBROUTINE FINDARGINDEX( KEY, I, N )
 CHARACTER(LEN=*),      INTENT(IN)  :: KEY
 INTEGER(KIND=JPIM), INTENT(OUT) :: I, N
 CHARACTER(LEN=ARGSIZEMAX) :: ARG

 N = MYIARGC()
 DO I = 1, N
   CALL MYGETARG( I, ARG )
   IF( TRIM( ARG ) .EQ. TRIM( KEY ) ) RETURN
 ENDDO
 I = -1_JPIM
END SUBROUTINE FINDARGINDEX

SUBROUTINE FINDNEXTARGINDEX( I, J )
 INTEGER(KIND=JPIM), INTENT(IN)  :: I
 INTEGER(KIND=JPIM), INTENT(OUT) :: J
!
 CHARACTER(LEN=ARGSIZEMAX) :: ARG
 INTEGER(KIND=JPIM) :: N

 N = MYIARGC()
 DO J = I+1, N
  CALL MYGETARG( J, ARG )
  IF( ARG(1:2) .EQ. '--' ) EXIT
 ENDDO

END SUBROUTINE FINDNEXTARGINDEX

SUBROUTINE GETOPTIONS( KEY, VAL, MND, USE )
!
 CHARACTER(LEN=*), INTENT(IN)  :: KEY
 CHARACTER(LEN=*), INTENT(INOUT) :: VAL
 LOGICAL(KIND=JPIM), INTENT(IN), OPTIONAL :: MND
 CHARACTER(LEN=*), INTENT(IN), OPTIONAL :: USE
!
 INTEGER(KIND=JPIM) :: I, N
 CHARACTER(LEN=ARGSIZEMAX) :: ARG
 LOGICAL(KIND=JPIM) :: LSHELL1
 LOGICAL(KIND=JPIM) :: FOUND

 LSHELL1 = LSHELL

 IF( LHELP ) THEN
   CALL ADDOPT( KEY, 'STRING', USE )
   RETURN
 ELSE IF( LSHELL ) THEN
   LSHELL = .FALSE.
   CALL ADDOPT_SHELL( KEY, 'STRING', MND, USE )
 ENDIF

 CALL FINDARGINDEX( KEY, I, N )

 FOUND = ( 0 .LT. I ) .AND. ( I .LT. N )

 IF( FOUND ) THEN
   IF( ASSOCIATED( CHECK_ARGS ) ) THEN
     CHECK_ARGS(I)   = .TRUE.
     CHECK_ARGS(I+1) = .TRUE.
   ENDIF
   CALL MYGETARG( I+1_JPIM, VAL )
 ELSE
   ARG = GET_ENV_OPT( KEY )
   FOUND = ARG .NE. ""
   IF( FOUND ) VAL = ARG
 ENDIF

 IF( .NOT. FOUND ) &
   CALL CHECK_MND( KEY, MND, USE )

 LSHELL = LSHELL1

END SUBROUTINE GETOPTIONS

SUBROUTINE GETOPTIONI( KEY, VAL, MND, USE )
!
 CHARACTER(LEN=*),      INTENT(IN)  :: KEY
 INTEGER(KIND=JPIM), INTENT(INOUT) :: VAL
 LOGICAL(KIND=JPIM), OPTIONAL, INTENT(IN) :: MND
 CHARACTER(LEN=*), OPTIONAL, INTENT(IN) :: USE
!
 CHARACTER(LEN=ARGSIZEMAX) :: SVAL
 INTEGER :: ERR
 LOGICAL(KIND=JPIM) :: LSHELL1

 LSHELL1 = LSHELL
 
 IF( LHELP ) THEN
   CALL ADDOPT( KEY, 'INTEGER', USE )
   RETURN
 ELSE IF( LSHELL ) THEN
   LSHELL = .FALSE.
   CALL ADDOPT_SHELL( KEY, 'INTEGER', MND, USE )
 ENDIF
 
 SVAL = ""
 CALL GETOPTIONS( KEY, SVAL, MND, USE )
 IF( TRIM( SVAL ) .NE. "" ) THEN
   READ( SVAL, *, IOSTAT = ERR ) VAL
   IF( ERR .NE. 0 ) THEN
     PRINT *, "ERROR WHILE PARSING OPTION "//TRIM(KEY)
     CALL XRD_EXIT(1_JPIM)
   ENDIF
 ENDIF

 LSHELL = LSHELL1

END SUBROUTINE GETOPTIONI

SUBROUTINE GETOPTIONR4( KEY, VAL, MND, USE )
!
 CHARACTER(LEN=*),   INTENT(IN)  :: KEY
 REAL(KIND=JPRM), INTENT(INOUT) :: VAL
 LOGICAL(KIND=JPIM), OPTIONAL, INTENT(IN) :: MND
 CHARACTER(LEN=*), OPTIONAL, INTENT(IN) :: USE
!
 CHARACTER(LEN=ARGSIZEMAX) :: SVAL
 INTEGER :: ERR
 LOGICAL(KIND=JPIM) :: LSHELL1

 LSHELL1 = LSHELL
 
 IF( LHELP ) THEN
   CALL ADDOPT( KEY, 'REAL', USE )
   RETURN
 ELSE IF( LSHELL ) THEN
   LSHELL = .FALSE.
   CALL ADDOPT_SHELL( KEY, 'REAL', MND, USE )
 ENDIF
 
 SVAL = ""
 CALL GETOPTIONS( KEY, SVAL, MND, USE )
 IF( TRIM( SVAL ) .NE. "" ) THEN
   READ( SVAL, *, IOSTAT = ERR ) VAL
   IF( ERR .NE. 0 ) THEN
     PRINT *, "ERROR WHILE PARSING OPTION "//TRIM(KEY)
     CALL XRD_EXIT(1_JPIM)
   ENDIF
 ENDIF

 LSHELL = LSHELL1

END SUBROUTINE GETOPTIONR4

SUBROUTINE GETOPTIONR8( KEY, VAL, MND, USE )
!
 CHARACTER(LEN=*),   INTENT(IN)  :: KEY
 REAL(KIND=JPRD), INTENT(INOUT) :: VAL
 LOGICAL(KIND=JPIM), OPTIONAL, INTENT(IN) :: MND
 CHARACTER(LEN=*), OPTIONAL, INTENT(IN) :: USE
!
 CHARACTER(LEN=ARGSIZEMAX) :: SVAL
 INTEGER :: ERR
 LOGICAL(KIND=JPIM) :: LSHELL1

 LSHELL1 = LSHELL
 
 IF( LHELP ) THEN
   CALL ADDOPT( KEY, 'REAL', USE )
   RETURN
 ELSE IF( LSHELL ) THEN
   LSHELL = .FALSE.
   CALL ADDOPT_SHELL( KEY, 'REAL', MND, USE )
 ENDIF
 
 SVAL = ""
 CALL GETOPTIONS( KEY, SVAL, MND, USE )
 IF( TRIM( SVAL ) .NE. "" ) THEN
   READ( SVAL, *, IOSTAT = ERR ) VAL
   IF( ERR .NE. 0 ) THEN
     PRINT *, "ERROR WHILE PARSING OPTION "//TRIM(KEY)
     CALL XRD_EXIT(1_JPIM)
   ENDIF
 ENDIF

 LSHELL = LSHELL1

END SUBROUTINE GETOPTIONR8

SUBROUTINE READASLFROMSTRING( VAL, SVAL )
 CHARACTER(LEN=*), INTENT(OUT) :: VAL(:)
 CHARACTER(LEN=*), INTENT(IN) :: SVAL
!
 INTEGER(KIND=JPIM) :: I, J, K, N

 N = LEN( SVAL )

 I = 1
 K = 1
 DO1 : DO 
   DO
     IF( I .GT. N ) EXIT DO1
     IF( SVAL(I:I) .NE. ' ' ) EXIT
     I = I + 1
   ENDDO
   J = I
   DO
     IF( J .GT. N ) EXIT 
     IF( SVAL(J:J) .EQ. ' ' ) EXIT
     J = J + 1
   ENDDO

   VAL(K) = SVAL(I:J-1)
   I = J
   K = K + 1
 ENDDO DO1


END SUBROUTINE READASLFROMSTRING

SUBROUTINE READSLFROMSTRING( VAL, SVAL )
 CHARACTER(LEN=*), POINTER :: VAL(:)
 CHARACTER(LEN=*), INTENT(IN) :: SVAL
!
 INTEGER(KIND=JPIM) :: N

 N = XRD_COUNTWORDS( SVAL )
 ALLOCATE( VAL( N ) )

 CALL READASLFROMSTRING( VAL, SVAL )

END SUBROUTINE READSLFROMSTRING

SUBROUTINE READSLFROMFILE( VAL, SVAL )
 CHARACTER(LEN=*), POINTER :: VAL(:)
 CHARACTER(LEN=*), INTENT(IN) :: SVAL
!
 INTEGER(KIND=JPIM) :: K, N
 INTEGER(KIND=JPIM) :: IOERR
 CHARACTER(LEN=4096) :: BUFFER

 OPEN( 77, FILE = TRIM(SVAL), FORM = 'FORMATTED', STATUS = 'OLD', IOSTAT = IOERR )
 IF( IOERR .NE. 0 ) THEN
   PRINT '( "COULD NOT OPEN ",A, " FOR READING")', TRIM(SVAL)
   CALL XRD_EXIT(1_JPIM)
 ENDIF
 N = 0_JPIM
 DO 
   READ( 77, '(A)', END = 500 ) BUFFER
   N = N + XRD_COUNTWORDS( BUFFER )
 ENDDO

 500 CONTINUE

 REWIND( 77 )

 ALLOCATE( VAL( N ) )
 
 K = 1
 DO 
   READ( 77, '(A)', END = 600 ) BUFFER
   N = XRD_COUNTWORDS( BUFFER )
   CALL READASLFROMSTRING( VAL(K:K+N-1), BUFFER )
   K = K + N
 ENDDO

 600 CONTINUE


 CLOSE( 77 )
 
END SUBROUTINE READSLFROMFILE

SUBROUTINE GETOPTIONSL( KEY, VAL, MND, USE )
!
 CHARACTER(LEN=*), INTENT(IN) :: KEY
 CHARACTER(LEN=*), POINTER :: VAL(:)
 LOGICAL(KIND=JPIM), OPTIONAL, INTENT(IN) :: MND
 CHARACTER(LEN=*), OPTIONAL, INTENT(IN) :: USE
!
 INTEGER(KIND=JPIM) :: I, J, K, N
 CHARACTER(LEN=ARGSIZEMAX) :: ARG
 CHARACTER(LEN=ARGSIZEMAX) :: SVAL
 LOGICAL(KIND=JPIM) :: LSHELL1
 LOGICAL(KIND=JPIM) :: FOUND

 LSHELL1 = LSHELL
 
 IF( LHELP ) THEN
   CALL ADDOPT( KEY, 'STRING-LIST', USE )
   RETURN
 ELSE IF( LSHELL ) THEN
   LSHELL = .FALSE.
   CALL ADDOPT_SHELL( KEY, 'STRING-LIST', MND, USE )
 ENDIF
 
 CALL FINDARGINDEX( KEY, I, N )

 FOUND = I >= 0

 IF( FOUND ) THEN

   CALL FINDNEXTARGINDEX( I, J )

   ALLOCATE( VAL( J - I - 1 ) )
   
   IF( ASSOCIATED( CHECK_ARGS ) ) &
     CHECK_ARGS(I) = .TRUE.
   
   DO K = I+1, J-1
     IF( ASSOCIATED( CHECK_ARGS ) ) &
       CHECK_ARGS(K)   = .TRUE.
     CALL MYGETARG( K, ARG )
     IF ((I+1.EQ.J-1) .AND. (ARG(1:7).EQ.'file://')) THEN
       DEALLOCATE (VAL)
       ARG = ARG(8:)
       CALL READSLFROMFILE( VAL, ARG )
     ELSE
       VAL(K-I) = ARG
     ENDIF
   ENDDO

 ENDIF
 
 IF(.NOT. FOUND) THEN
   SVAL = GET_ENV_OPT( KEY )
   FOUND = SVAL .NE. ""
   IF( FOUND ) &
     CALL READSLFROMSTRING( VAL, SVAL )
 ENDIF

 IF( .NOT. FOUND ) &
   CALL CHECK_MND( KEY, MND, USE )

 LSHELL = LSHELL1

END SUBROUTINE GETOPTIONSL

SUBROUTINE GETOPTIONIL( KEY, VAL, MND, USE )
!
 CHARACTER(LEN=*),      INTENT(IN) :: KEY
 INTEGER(KIND=JPIM), POINTER    :: VAL(:)
 LOGICAL(KIND=JPIM), OPTIONAL, INTENT(IN) :: MND
 CHARACTER(LEN=*), OPTIONAL, INTENT(IN) :: USE
!
 CHARACTER(LEN=ARGSIZEMAX), POINTER :: SVAL(:)
 INTEGER(KIND=JPIM) :: I, N
 INTEGER :: ERR
 LOGICAL(KIND=JPIM) :: LSHELL1

 NULLIFY (SVAL)

 LSHELL1 = LSHELL

 IF( LHELP ) THEN
   CALL ADDOPT( KEY, 'INTEGER-LIST', USE )
   RETURN
 ELSE IF( LSHELL ) THEN
   LSHELL = .FALSE.
   CALL ADDOPT_SHELL( KEY, 'INTEGER-LIST', MND, USE )
 ENDIF
 
 CALL GETOPTIONSL( KEY, SVAL, MND, USE )

 IF( .NOT. ASSOCIATED( SVAL ) ) GOTO 999

 N = SIZE( SVAL )
 ALLOCATE( VAL( N ) )
 DO I = 1, N
   READ( SVAL( I ), *, IOSTAT = ERR ) VAL( I )
   IF( ERR .NE. 0 ) THEN
     PRINT *, "ERROR WHILE PARSING OPTION "//TRIM(KEY)
     CALL XRD_EXIT(1_JPIM)
   ENDIF
 ENDDO

 DEALLOCATE( SVAL )

999 CONTINUE
 LSHELL = LSHELL1

END SUBROUTINE GETOPTIONIL

SUBROUTINE GETOPTIONR4L( KEY, VAL, MND, USE )
!
 CHARACTER(LEN=*),   INTENT(IN) :: KEY
 REAL(KIND=JPRM), POINTER    :: VAL(:)
 LOGICAL(KIND=JPIM), OPTIONAL, INTENT(IN) :: MND
 CHARACTER(LEN=*), OPTIONAL, INTENT(IN) :: USE
!
 CHARACTER(LEN=ARGSIZEMAX), POINTER :: SVAL(:)
 INTEGER(KIND=JPIM) :: I, N
 INTEGER :: ERR
 LOGICAL(KIND=JPIM) :: LSHELL1

 NULLIFY (SVAL)

 LSHELL1 = LSHELL

 IF( LHELP ) THEN
   CALL ADDOPT( KEY, 'REAL-LIST', USE )
   RETURN
 ELSE IF( LSHELL ) THEN
   LSHELL = .FALSE.
   CALL ADDOPT_SHELL( KEY, 'REAL-LIST', MND, USE )
 ENDIF
 
 CALL GETOPTIONSL( KEY, SVAL, MND, USE )

 IF( .NOT. ASSOCIATED( SVAL ) ) GOTO 999

 N = SIZE( SVAL )
 ALLOCATE( VAL( N ) )
 DO I = 1, N
   READ( SVAL( I ), *, IOSTAT = ERR ) VAL( I )
   IF( ERR .NE. 0 ) THEN
     PRINT *, "ERROR WHILE PARSING OPTION "//TRIM(KEY)
     CALL XRD_EXIT(1_JPIM)
   ENDIF
 ENDDO

 DEALLOCATE( SVAL )

999 CONTINUE
 LSHELL = LSHELL1

END SUBROUTINE GETOPTIONR4L

SUBROUTINE GETOPTIONR8L( KEY, VAL, MND, USE )
!
 CHARACTER(LEN=*),   INTENT(IN) :: KEY
 REAL(KIND=JPRD), POINTER    :: VAL(:)
 LOGICAL(KIND=JPIM), OPTIONAL, INTENT(IN) :: MND
 CHARACTER(LEN=*), OPTIONAL, INTENT(IN) :: USE
!
 CHARACTER(LEN=ARGSIZEMAX), POINTER :: SVAL(:)
 INTEGER(KIND=JPIM) :: I, N
 INTEGER :: ERR
 LOGICAL(KIND=JPIM) :: LSHELL1

 NULLIFY (SVAL)

 LSHELL1 = LSHELL

 IF( LHELP ) THEN
   CALL ADDOPT( KEY, 'REAL-LIST', USE )
   RETURN
 ELSE IF( LSHELL ) THEN
   LSHELL = .FALSE.
   CALL ADDOPT_SHELL( KEY, 'REAL-LIST', MND, USE )
 ENDIF
 
 CALL GETOPTIONSL( KEY, SVAL, MND, USE )

 IF( .NOT. ASSOCIATED( SVAL ) ) GOTO 999

 N = SIZE( SVAL )
 ALLOCATE( VAL( N ) )
 DO I = 1, N
   READ( SVAL( I ), *, IOSTAT = ERR ) VAL( I )
   IF( ERR .NE. 0 ) THEN
     PRINT *, "ERROR WHILE PARSING OPTION "//TRIM(KEY)
     CALL XRD_EXIT(1_JPIM)
   ENDIF
 ENDDO

 DEALLOCATE( SVAL )

999 CONTINUE
 LSHELL = LSHELL1

END SUBROUTINE GETOPTIONR8L

SUBROUTINE GETOPTIONB( KEY, VAL, USE )
!
 CHARACTER(LEN=*), INTENT(IN)  :: KEY
 LOGICAL(KIND=JPIM), INTENT(INOUT) :: VAL
 CHARACTER(LEN=*), OPTIONAL, INTENT(IN) :: USE
!
 LOGICAL(KIND=JPIM) :: LSHELL1
 LOGICAL(KIND=JPIM) :: FOUND
 CHARACTER(LEN=ARGSIZEMAX) :: SVAL
 INTEGER(KIND=JPIM) :: I, N
 
 LSHELL1 = LSHELL

 VAL = .FALSE.

 IF( LHELP ) THEN
   CALL ADDOPT( KEY, 'FLAG', USE )
   RETURN
 ELSE IF( LSHELL ) THEN
   LSHELL = .FALSE.
   CALL ADDOPT_SHELL( KEY, 'FLAG', .FALSE._JPIM, USE )
 ENDIF
 
 CALL FINDARGINDEX( KEY, I, N )
 FOUND = I > 0
 IF( FOUND .AND. ASSOCIATED( CHECK_ARGS ) ) THEN
   CHECK_ARGS(I)   = .TRUE.
   VAL = .TRUE.
 ELSE
   SVAL = GET_ENV_OPT( KEY )
   IF( SVAL .NE. "" ) &
     READ( SVAL, * ) VAL
 ENDIF

 LSHELL = LSHELL1

END SUBROUTINE GETOPTIONB

END MODULE XRD_GETOPTIONS

! (C) Copyright 2005- ECMWF.
! (C) Copyright 2013- Meteo-France.
! 
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!

MODULE MPL_WAITANY_MOD

!**** MPL_WAITANY Waits for completion of any request

!     Purpose.
!     --------
!     Returns control when any operation identified by the request
!     is completed.
!     Normally used in conjunction with non-blocking buffering type

!**   Interface.
!     ----------
!        CALL MPL_WAITANY

!        Input required arguments :
!        -------------------------
!           KREQUEST -  array or scalar containing
!                       Communication request(s)
!                       as provided by MPL_RECV or MPL_SEND

!        Input optional arguments :
!        -------------------------
!           CDSTRING -  Character string for ABORT messages
!                       used when KERROR is not provided

!        Output required arguments :
!        -------------------------
!           KINDEX - index of received request

!        Output optional arguments :
!        -------------------------
!           KERROR   -  return error code.     If not supplied, 
!                       MPL_WAITANY aborts when an error is detected.
!     Author.
!     -------
!        R. El Khatib *Meteo-France*

!     Modifications.
!     --------------
!        Original: 02-Sep-2014

!     ------------------------------------------------------------------

USE EC_PARKIND  ,ONLY : JPIM ,JPRM, JPIB

USE MPL_MPIF
USE MPL_DATA_MODULE
USE MPL_MESSAGE_MOD

IMPLICIT NONE

PRIVATE
PUBLIC MPL_WAITANY

CONTAINS 

SUBROUTINE MPL_WAITANY(KREQUEST,KINDEX,CDSTRING,KERROR)


#ifdef USE_8_BYTE_WORDS
  USE MPI4TO8, ONLY : &
    MPI_WAITANY => MPI_WAITANY8
#endif

INTEGER(KIND=JPIM),INTENT(INOUT)        :: KREQUEST(:)
INTEGER(KIND=JPIM),INTENT(OUT)          :: KINDEX
CHARACTER(LEN=*)  ,INTENT(IN), OPTIONAL :: CDSTRING
INTEGER(KIND=JPIM),INTENT(OUT),OPTIONAL :: KERROR

INTEGER(KIND=JPIM) :: IWAITERR,IREQLEN,J
INTEGER(KIND=JPIM) :: IWAIT_STATUS(MPI_STATUS_SIZE)
LOGICAL :: LLABORT
LLABORT=.TRUE.
IWAITERR=0

IF(MPL_NUMPROC < 1) CALL MPL_MESSAGE( &
  & CDMESSAGE='MPL_WAITANY: MPL NOT INITIALISED ',LDABORT=LLABORT) 

KINDEX = MPI_UNDEFINED
IREQLEN=SIZE(KREQUEST)

#ifndef MPI1
CALL MPI_WAITANY(IREQLEN,KREQUEST,KINDEX,IWAIT_STATUS,IWAITERR)
#else
!CALL ABOR1('MPI_WAITANY not built with MPI2')
IWAITERR = MPI_ERR_UNKNOWN ! Initialized in case all requests already NULL (= logic err in code)
DO J=1,IREQLEN
   IF (KREQUEST(J) /= MPI_REQUEST_NULL) THEN
      CALL MPI_WAIT(KREQUEST(J),IWAIT_STATUS,IWAITERR)
      KINDEX = J
      EXIT
   ENDIF
ENDDO
#endif

IF(PRESENT(KERROR))THEN
  KERROR=IWAITERR
ELSE IF(IWAITERR /= 0) THEN
  CALL MPL_MESSAGE(IWAITERR,'MPL_WAITANY_WAITING',CDSTRING,LDABORT=LLABORT)
ENDIF

RETURN
END SUBROUTINE MPL_WAITANY


END MODULE MPL_WAITANY_MOD

! (C) Copyright 2005- ECMWF.
! 
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!

!-- Generic traceback calls here

SUBROUTINE GENTRBK_DUMMY
END SUBROUTINE GENTRBK_DUMMY

SUBROUTINE INTEL_TRBK()
#ifdef __INTEL_COMPILER
USE IFCORE
#endif
USE MPL_DATA_MODULE, ONLY : MPL_RANK
LOGICAL :: DONE_TRACEBACK = .FALSE.
INTEGER :: MYPROC,MYTHREAD
CHARACTER(LEN=512) :: CLTRBK
CHARACTER(LEN=512) :: MESSAGE
#ifdef _OPENMP
INTEGER,EXTERNAL :: OMP_GET_THREAD_NUM
#endif

IF(DONE_TRACEBACK) THEN
  WRITE(0,*) "INTEL_TRBK already called"
  RETURN
ENDIF

MYPROC=MPL_RANK
#ifdef _OPENMP
MYTHREAD=OMP_GET_THREAD_NUM() + 1
#else
MYTHREAD=1
#endif

#ifdef __INTEL_COMPILER
WRITE(MESSAGE,'(A,I4,A,I2,A)') &
  &           "Process ",MYPROC," thread ",MYTHREAD, &
  &           " calling tracebackqq from intel_trbk()"
CALL TRACEBACKQQ(TRIM(MESSAGE), USER_EXIT_CODE=-1)
CALL GET_ENVIRONMENT_VARIABLE("EC_LINUX_TRBK",CLTRBK)
#else
  CLTRBK = '1'
#endif
IF( CLTRBK == '1' ) THEN
  WRITE(0,*) "Process ",MYPROC," thread ",MYTHREAD, &
    &        " calling linux_trbk from intel_trbk()"
  CALL LINUX_TRBK() ! See linuxtrbk.c
ENDIF
DONE_TRACEBACK=.TRUE.
END SUBROUTINE INTEL_TRBK

! (C) Copyright 2005- ECMWF.
! (C) Copyright 2013- Meteo-France.
! 
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!

MODULE MPL_BROADCAST_MOD

!**** MPL_BROADCAST Message broadcast

!     Purpose.
!     --------
!     Broadcasts a message from the process with rank root
!     to all processes in the group.

!**   Interface.
!     ----------
!        CALL MPL_BROADCAST

!        Input required arguments :
!        -------------------------
!           PBUF     -  buffer containing message
!                       (can be type REAL*4, REAL*8 or INTEGER)
!           KTAG     -  message tag

!        Input optional arguments :
!        -------------------------
!           KROOT    -  number of root process (default=1)
!           KCOMM    -  Communicator number if different from MPI_COMM_WORLD 
!                       or from that established as the default 
!                       by an MPL communicator routine
!           KMP_TYPE -  buffering type (see MPL_BUFFER_METHOD)
!                       overrides value provided to MPL_BUFFER_METHOD
!           CDSTRING -  Character string for ABORT messages
!                       used when KERROR is not provided
!                   

!        Output required arguments :
!        -------------------------
!           none

!        Output optional arguments :
!        -------------------------
!           KREQUEST -  Communication request
!                       required when buffering type is non-blocking
!           KERROR   -  return error code.     If not supplied, 
!                       MPL_BROADCAST aborts when an error is detected.
!     Author.
!     -------
!        D.Dent, M.Hamrud, S.Saarinen    ECMWF

!     Modifications.
!     --------------
!        Original: 2000-09-01
!        P.Marguinaud : 2012-04-13 : Cleaning & refactor PREAMB1
!        P.Marguinaud : 2012-09-11 : Add MPL_BROADCAST_LOGICAL1
!        M.Hamrud     : 2014-10-22 : Add nonblocking option
!      F. Vana  05-Mar-2015  Support for single precision

!     ------------------------------------------------------------------

USE EC_PARKIND , ONLY : JPRD, JPIM, JPIB, JPRM
USE OML_MOD   ,ONLY : OML_MY_THREAD

USE MPL_MPIF
USE MPL_DATA_MODULE
USE MPL_STATS_MOD
USE YOMMPLSTATS
USE MPL_MESSAGE_MOD
USE MPL_SEND_MOD
USE MPL_RECV_MOD
USE MPL_BARRIER_MOD
USE MPL_MYRANK_MOD

IMPLICIT NONE
PRIVATE

LOGICAL :: LLABORT=.TRUE.

INTERFACE MPL_BROADCAST
MODULE PROCEDURE MPL_BROADCAST_REAL4,MPL_BROADCAST_REAL8, &
     & MPL_BROADCAST_REAL42,MPL_BROADCAST_REAL43,MPL_BROADCAST_REAL44,&
     & MPL_BROADCAST_REAL82,MPL_BROADCAST_REAL83,MPL_BROADCAST_REAL84,&
     & MPL_BROADCAST_REAL4_SCALAR,MPL_BROADCAST_REAL8_SCALAR, &
     & MPL_BROADCAST_INT,MPL_BROADCAST_INT2,MPL_BROADCAST_INT3,MPL_BROADCAST_INT_SCALAR, &
     & MPL_BROADCAST_CHAR_SCALAR, MPL_BROADCAST_CHAR1, &
     & MPL_BROADCAST_LOGICAL_SCALAR, MPL_BROADCAST_LOGICAL1
END INTERFACE

PUBLIC MPL_BROADCAST

CONTAINS

SUBROUTINE MPL_BROADCAST_PREAMB1(KROOTR,KCOMMR,KPL_NUMPROC,KPL_MYRANK,KMP_TYPER,LDRETURN,KERROR,KCOMM,KROOT,KMP_TYPE)


#ifdef USE_8_BYTE_WORDS
  USE MPI4TO8, ONLY : &
    MPI_COMM_SIZE => MPI_COMM_SIZE8
#endif


INTEGER(KIND=JPIM),INTENT(OUT)          :: KROOTR
INTEGER(KIND=JPIM),INTENT(OUT)          :: KCOMMR
INTEGER(KIND=JPIM),INTENT(OUT)          :: KPL_NUMPROC
INTEGER(KIND=JPIM),INTENT(OUT)          :: KPL_MYRANK
INTEGER(KIND=JPIM),INTENT(OUT)          :: KMP_TYPER
LOGICAL,           INTENT(OUT)          :: LDRETURN
INTEGER(KIND=JPIM),INTENT(OUT),OPTIONAL :: KERROR
INTEGER(KIND=JPIM),INTENT(IN), OPTIONAL :: KROOT
INTEGER(KIND=JPIM),INTENT(IN), OPTIONAL :: KCOMM
INTEGER(KIND=JPIM),INTENT(IN), OPTIONAL :: KMP_TYPE

INTEGER(KIND=JPIM) :: IERROR
INTEGER(KIND=JPIM) :: ITID

ITID = OML_MY_THREAD()
IERROR = 0

IF(MPL_NUMPROC < 1) CALL MPL_MESSAGE( &
  & CDMESSAGE='MPL_BROADCAST: MPL NOT INITIALISED ',LDABORT=LLABORT) 

IF(PRESENT(KCOMM)) THEN
  KCOMMR=KCOMM
ELSE
  KCOMMR=MPL_COMM_OML(ITID)
ENDIF

IF(KCOMMR == MPL_COMM_OML(ITID)) THEN
  KPL_NUMPROC = MPL_NUMPROC
  KPL_MYRANK  = MPL_RANK
ELSE
  CALL MPI_COMM_SIZE(KCOMMR,KPL_NUMPROC,IERROR)
  KPL_MYRANK  = MPL_MYRANK(KCOMMR)
ENDIF

IF(PRESENT(KROOT)) THEN
  KROOTR=KROOT
ELSE
  KROOTR=1
ENDIF

IF(PRESENT(KMP_TYPE)) THEN
  KMP_TYPER=KMP_TYPE
ELSE
  KMP_TYPER=MPL_METHOD
ENDIF

IF (PRESENT (KERROR)) KERROR = IERROR

IF (KPL_NUMPROC == 1) THEN
  IF(PRESENT(KERROR)) THEN
    KERROR=0
  ENDIF
  LDRETURN=.TRUE.
ELSE
  LDRETURN=.FALSE.
ENDIF

END SUBROUTINE MPL_BROADCAST_PREAMB1

SUBROUTINE MPL_BROADCAST_REAL4(PBUF,KTAG,KROOT,KMP_TYPE,&
                               KCOMM,KERROR,KREQUEST,CDSTRING)


#ifdef USE_8_BYTE_WORDS
  USE MPI4TO8, ONLY : &
    MPI_COMM_SIZE => MPI_COMM_SIZE8, MPI_BCAST => MPI_BCAST8
#endif


REAL(KIND=JPRM)            :: PBUF(:)
INTEGER(KIND=JPIM),INTENT(IN)          :: KTAG
INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL :: KROOT,KCOMM,KMP_TYPE
INTEGER(KIND=JPIM),INTENT(OUT),OPTIONAL :: KERROR,KREQUEST
CHARACTER(LEN=*),INTENT(IN),OPTIONAL :: CDSTRING

INTEGER(KIND=JPIM) :: ICOUNT,ICOMM,IERROR,IROOT,IPL_NUMPROC,IPL_MYRANK,IMP_TYPE
LOGICAL :: LLRETURN

CALL MPL_BROADCAST_PREAMB1(IROOT,ICOMM,IPL_NUMPROC,IPL_MYRANK,IMP_TYPE,LLRETURN,KERROR,KCOMM,KROOT,KMP_TYPE)
IF (LLRETURN) RETURN

IERROR = 0

ICOUNT = SIZE(PBUF)

IF(IMP_TYPE == JP_BLOCKING_STANDARD .OR. IMP_TYPE == JP_BLOCKING_BUFFERED) THEN
  CALL MPI_BCAST(PBUF,ICOUNT,INT(MPI_REAL4),IROOT-1,ICOMM,IERROR)
ELSEIF(IMP_TYPE == JP_NON_BLOCKING_STANDARD .OR. IMP_TYPE == JP_NON_BLOCKING_BUFFERED) THEN
  IF(.NOT.PRESENT(KREQUEST)) CALL MPL_MESSAGE(KERROR,'MPL_SEND',' KREQUEST MISSING',LDABORT=LLABORT)
  CALL MPI_IBCAST(PBUF,ICOUNT,INT(MPI_REAL4),IROOT-1,ICOMM,KREQUEST,IERROR)
ELSE
  IF(PRESENT(KERROR)) THEN
    IERROR=1
  ELSE
    CALL MPL_MESSAGE(KERROR,'MPL_BROADCAST',' INVALID METHOD',LDABORT=LLABORT)
  ENDIF
ENDIF

IF(LMPLSTATS) THEN
  IF(IROOT == IPL_MYRANK) THEN
    CALL MPL_SENDSTATS(ICOUNT,INT(MPI_REAL4))
  ENDIF
  CALL MPL_RECVSTATS(ICOUNT,INT(MPI_REAL4))
ENDIF

IF(PRESENT(KERROR)) THEN
  KERROR=IERROR
ELSE
  IF(IERROR /= 0 ) CALL MPL_MESSAGE(IERROR,'MPL_BROADCAST',CDSTRING,LDABORT=LLABORT)
ENDIF


END SUBROUTINE MPL_BROADCAST_REAL4

SUBROUTINE MPL_BROADCAST_REAL8(PBUF,KTAG,KROOT,KMP_TYPE,&
                               KCOMM,KERROR,KREQUEST,CDSTRING)


#ifdef USE_8_BYTE_WORDS
  USE MPI4TO8, ONLY : &
    MPI_COMM_SIZE => MPI_COMM_SIZE8, MPI_BCAST => MPI_BCAST8
#endif


REAL(KIND=JPRD)            :: PBUF(:)
INTEGER(KIND=JPIM),INTENT(IN)          :: KTAG
INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL :: KROOT,KCOMM,KMP_TYPE
INTEGER(KIND=JPIM),INTENT(OUT),OPTIONAL :: KERROR,KREQUEST
CHARACTER(LEN=*),INTENT(IN),OPTIONAL :: CDSTRING

INTEGER(KIND=JPIM) :: ICOUNT,ICOMM,IERROR,IROOT,IPL_NUMPROC,IPL_MYRANK,IMP_TYPE
LOGICAL :: LLRETURN

CALL MPL_BROADCAST_PREAMB1(IROOT,ICOMM,IPL_NUMPROC,IPL_MYRANK,IMP_TYPE,LLRETURN,KERROR,KCOMM,KROOT,KMP_TYPE)
IF (LLRETURN) RETURN

IERROR = 0

ICOUNT = SIZE(PBUF)

! Passing PBUF(1) here causes incorrect results on IBM
IF(IMP_TYPE == JP_BLOCKING_STANDARD .OR. IMP_TYPE == JP_BLOCKING_BUFFERED) THEN
  CALL MPI_BCAST(PBUF,ICOUNT,INT(MPI_REAL8),IROOT-1,ICOMM,IERROR)
ELSEIF(IMP_TYPE == JP_NON_BLOCKING_STANDARD .OR. IMP_TYPE == JP_NON_BLOCKING_BUFFERED) THEN
  IF(.NOT.PRESENT(KREQUEST)) CALL MPL_MESSAGE(KERROR,'MPL_SEND',' KREQUEST MISSING',LDABORT=LLABORT)
  CALL MPI_IBCAST(PBUF,ICOUNT,INT(MPI_REAL8),IROOT-1,ICOMM,KREQUEST,IERROR)
ELSE
  IF(PRESENT(KERROR)) THEN
    IERROR=1
  ELSE
    CALL MPL_MESSAGE(KERROR,'MPL_BROADCAST',' INVALID METHOD',LDABORT=LLABORT)
  ENDIF
ENDIF
IF(LMPLSTATS) THEN
  IF(IROOT == IPL_MYRANK) THEN
    CALL MPL_SENDSTATS(ICOUNT,INT(MPI_REAL8))
  ENDIF
  CALL MPL_RECVSTATS(ICOUNT,INT(MPI_REAL8))
ENDIF

IF(PRESENT(KERROR)) THEN
  KERROR=IERROR
ELSE
  IF(IERROR /= 0 ) CALL MPL_MESSAGE(IERROR,'MPL_BROADCAST',CDSTRING,LDABORT=LLABORT)
ENDIF


END SUBROUTINE MPL_BROADCAST_REAL8


SUBROUTINE MPL_BROADCAST_REAL42(PBUF,KTAG,KROOT,KMP_TYPE,KCOMM,KERROR,KREQUEST,CDSTRING)

REAL(KIND=JPRM)            :: PBUF(:,:)
INTEGER(KIND=JPIM),INTENT(IN)          :: KTAG
INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL :: KROOT,KCOMM,KMP_TYPE
INTEGER(KIND=JPIM),INTENT(OUT),OPTIONAL :: KERROR,KREQUEST
CHARACTER(LEN=*),INTENT(IN),OPTIONAL :: CDSTRING

INTEGER(KIND=JPIM) :: ICOUNT,ICOMM,IERROR,IROOT,IPL_NUMPROC,IPL_MYRANK,IMP_TYPE
LOGICAL :: LLRETURN

CALL MPL_BROADCAST_PREAMB1(IROOT,ICOMM,IPL_NUMPROC,IPL_MYRANK,IMP_TYPE,LLRETURN,KERROR,KCOMM,KROOT,KMP_TYPE)
IF (LLRETURN) RETURN

IERROR = 0

ICOUNT = SIZE(PBUF)
#ifndef NAG
IF (ICOUNT > 0) THEN
  IF( (LOC(PBUF(UBOUND(PBUF,1),UBOUND(PBUF,2))) - &
     & LOC(PBUF(LBOUND(PBUF,1),LBOUND(PBUF,2)))) /= 4_JPIB*(ICOUNT - 1) ) THEN
    CALL MPL_MESSAGE(CDMESSAGE='MPL_BROADCAST: BUFFER NOT CONTIGUOUS ',LDABORT=LLABORT)
  ENDIF
ENDIF
#endif

IF(IMP_TYPE == JP_BLOCKING_STANDARD .OR. IMP_TYPE == JP_BLOCKING_BUFFERED) THEN
  CALL MPI_BCAST(PBUF(1,1),ICOUNT,INT(MPI_REAL4),IROOT-1,ICOMM,IERROR)
ELSEIF(IMP_TYPE == JP_NON_BLOCKING_STANDARD .OR. IMP_TYPE == JP_NON_BLOCKING_BUFFERED) THEN
  IF(.NOT.PRESENT(KREQUEST)) CALL MPL_MESSAGE(KERROR,'MPL_SEND',' KREQUEST MISSING',LDABORT=LLABORT)
  CALL MPI_IBCAST(PBUF(1,1),ICOUNT,INT(MPI_REAL4),IROOT-1,ICOMM,KREQUEST,IERROR)
ELSE
  IF(PRESENT(KERROR)) THEN
    IERROR=1
  ELSE
    CALL MPL_MESSAGE(KERROR,'MPL_BROADCAST',' INVALID METHOD',LDABORT=LLABORT)
  ENDIF
ENDIF

IF(LMPLSTATS) THEN
  IF(IROOT == IPL_MYRANK) THEN
    CALL MPL_SENDSTATS(ICOUNT,INT(MPI_REAL4))
  ENDIF
  CALL MPL_RECVSTATS(ICOUNT,INT(MPI_REAL4))
ENDIF

IF(PRESENT(KERROR)) THEN
  KERROR=IERROR
ELSE
  IF(IERROR /= 0 ) CALL MPL_MESSAGE(IERROR,'MPL_BROADCAST',CDSTRING,LDABORT=LLABORT)
ENDIF

END SUBROUTINE MPL_BROADCAST_REAL42


SUBROUTINE MPL_BROADCAST_REAL43(PBUF,KTAG,KROOT,KMP_TYPE,KCOMM,KERROR,KREQUEST,CDSTRING)

REAL(KIND=JPRM)            :: PBUF(:,:,:)
INTEGER(KIND=JPIM),INTENT(IN)          :: KTAG
INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL :: KROOT,KCOMM,KMP_TYPE
INTEGER(KIND=JPIM),INTENT(OUT),OPTIONAL :: KERROR,KREQUEST
CHARACTER(LEN=*),INTENT(IN),OPTIONAL :: CDSTRING

INTEGER(KIND=JPIM) :: ICOUNT,ICOMM,IERROR,IROOT,IPL_NUMPROC,IPL_MYRANK,IMP_TYPE
LOGICAL :: LLRETURN

CALL MPL_BROADCAST_PREAMB1(IROOT,ICOMM,IPL_NUMPROC,IPL_MYRANK,IMP_TYPE,LLRETURN,KERROR,KCOMM,KROOT,KMP_TYPE)
IF (LLRETURN) RETURN

IERROR = 0

ICOUNT = SIZE(PBUF)
#ifndef NAG
IF (ICOUNT > 0) THEN
  IF( (LOC(PBUF(UBOUND(PBUF,1),UBOUND(PBUF,2),UBOUND(PBUF,3))) - &
     & LOC(PBUF(LBOUND(PBUF,1),LBOUND(PBUF,2),LBOUND(PBUF,3)))) /= 4_JPIB*(ICOUNT - 1) ) THEN
    CALL MPL_MESSAGE(CDMESSAGE='MPL_BROADCAST: BUFFER NOT CONTIGUOUS ',LDABORT=LLABORT)
  ENDIF
ENDIF
#endif

IF(IMP_TYPE == JP_BLOCKING_STANDARD .OR. IMP_TYPE == JP_BLOCKING_BUFFERED) THEN
  CALL MPI_BCAST(PBUF(1,1,1),ICOUNT,INT(MPI_REAL4),IROOT-1,ICOMM,IERROR)
ELSEIF(IMP_TYPE == JP_NON_BLOCKING_STANDARD .OR. IMP_TYPE == JP_NON_BLOCKING_BUFFERED) THEN
  IF(.NOT.PRESENT(KREQUEST)) CALL MPL_MESSAGE(KERROR,'MPL_SEND',' KREQUEST MISSING',LDABORT=LLABORT)
  CALL MPI_IBCAST(PBUF(1,1,1),ICOUNT,INT(MPI_REAL4),IROOT-1,ICOMM,KREQUEST,IERROR)
ELSE
  IF(PRESENT(KERROR)) THEN
    IERROR=1
  ELSE
    CALL MPL_MESSAGE(KERROR,'MPL_BROADCAST',' INVALID METHOD',LDABORT=LLABORT)
  ENDIF
ENDIF

IF(LMPLSTATS) THEN
  IF(IROOT == IPL_MYRANK) THEN
    CALL MPL_SENDSTATS(ICOUNT,INT(MPI_REAL4))
  ENDIF
  CALL MPL_RECVSTATS(ICOUNT,INT(MPI_REAL4))
ENDIF

IF(PRESENT(KERROR)) THEN
  KERROR=IERROR
ELSE
  IF(IERROR /= 0 ) CALL MPL_MESSAGE(IERROR,'MPL_BROADCAST',CDSTRING,LDABORT=LLABORT)
ENDIF

END SUBROUTINE MPL_BROADCAST_REAL43


SUBROUTINE MPL_BROADCAST_REAL44(PBUF,KTAG,KROOT,KMP_TYPE,KCOMM,KERROR,KREQUEST,CDSTRING)

REAL(KIND=JPRM)            :: PBUF(:,:,:,:)
INTEGER(KIND=JPIM),INTENT(IN)          :: KTAG
INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL :: KROOT,KCOMM,KMP_TYPE
INTEGER(KIND=JPIM),INTENT(OUT),OPTIONAL :: KERROR,KREQUEST
CHARACTER(LEN=*),INTENT(IN),OPTIONAL :: CDSTRING

INTEGER(KIND=JPIM) :: ICOUNT,ICOMM,IERROR,IROOT,IPL_NUMPROC,IPL_MYRANK,IMP_TYPE
LOGICAL :: LLRETURN

CALL MPL_BROADCAST_PREAMB1(IROOT,ICOMM,IPL_NUMPROC,IPL_MYRANK,IMP_TYPE,LLRETURN,KERROR,KCOMM,KROOT,KMP_TYPE)
IF (LLRETURN) RETURN

IERROR = 0

ICOUNT = SIZE(PBUF)
#ifndef NAG
IF (ICOUNT > 0) THEN
  IF( (LOC(PBUF(UBOUND(PBUF,1),UBOUND(PBUF,2),UBOUND(PBUF,3),UBOUND(PBUF,4))) - &
     & LOC(PBUF(LBOUND(PBUF,1),LBOUND(PBUF,2),LBOUND(PBUF,3),LBOUND(PBUF,4))))  &
     &  /= 4_JPIB*(ICOUNT - 1) ) THEN
    CALL MPL_MESSAGE(CDMESSAGE='MPL_BROADCAST: BUFFER NOT CONTIGUOUS ',LDABORT=LLABORT)
  ENDIF
ENDIF
#endif

IF(IMP_TYPE == JP_BLOCKING_STANDARD .OR. IMP_TYPE == JP_BLOCKING_BUFFERED) THEN
  CALL MPI_BCAST(PBUF(1,1,1,1),ICOUNT,INT(MPI_REAL4),IROOT-1,ICOMM,IERROR)
ELSEIF(IMP_TYPE == JP_NON_BLOCKING_STANDARD .OR. IMP_TYPE == JP_NON_BLOCKING_BUFFERED) THEN
  IF(.NOT.PRESENT(KREQUEST)) CALL MPL_MESSAGE(KERROR,'MPL_SEND',' KREQUEST MISSING',LDABORT=LLABORT)
  CALL MPI_IBCAST(PBUF(1,1,1,1),ICOUNT,INT(MPI_REAL4),IROOT-1,ICOMM,KREQUEST,IERROR)
ELSE
  IF(PRESENT(KERROR)) THEN
    IERROR=1
  ELSE
    CALL MPL_MESSAGE(KERROR,'MPL_BROADCAST',' INVALID METHOD',LDABORT=LLABORT)
  ENDIF
ENDIF

IF(LMPLSTATS) THEN
  IF(IROOT == IPL_MYRANK) THEN
    CALL MPL_SENDSTATS(ICOUNT,INT(MPI_REAL4))
  ENDIF
  CALL MPL_RECVSTATS(ICOUNT,INT(MPI_REAL4))
ENDIF

IF(PRESENT(KERROR)) THEN
  KERROR=IERROR
ELSE
  IF(IERROR /= 0 ) CALL MPL_MESSAGE(IERROR,'MPL_BROADCAST',CDSTRING,LDABORT=LLABORT)
ENDIF

END SUBROUTINE MPL_BROADCAST_REAL44


SUBROUTINE MPL_BROADCAST_REAL82(PBUF,KTAG,KROOT,KMP_TYPE,&
                                KCOMM,KERROR,KREQUEST,CDSTRING)

#ifdef USE_8_BYTE_WORDS
  USE MPI4TO8, ONLY : &
    MPI_COMM_SIZE => MPI_COMM_SIZE8, MPI_BCAST => MPI_BCAST8
#endif

REAL(KIND=JPRD)            :: PBUF(:,:)
INTEGER(KIND=JPIM),INTENT(IN)          :: KTAG
INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL :: KROOT,KCOMM,KMP_TYPE
INTEGER(KIND=JPIM),INTENT(OUT),OPTIONAL :: KERROR,KREQUEST
CHARACTER(LEN=*),INTENT(IN),OPTIONAL :: CDSTRING

INTEGER(KIND=JPIM) :: ICOUNT,ICOMM,IERROR,IROOT,IPL_NUMPROC,IPL_MYRANK,IMP_TYPE
LOGICAL :: LLRETURN

CALL MPL_BROADCAST_PREAMB1(IROOT,ICOMM,IPL_NUMPROC,IPL_MYRANK,IMP_TYPE,LLRETURN,KERROR,KCOMM,KROOT,KMP_TYPE)
IF (LLRETURN) RETURN

IERROR = 0

ICOUNT = SIZE(PBUF)
#ifndef NAG
IF (ICOUNT > 0) THEN
  IF( (LOC(PBUF(UBOUND(PBUF,1),UBOUND(PBUF,2))) - &
     & LOC(PBUF(LBOUND(PBUF,1),LBOUND(PBUF,2)))) /= 8_JPIB*(ICOUNT - 1) ) THEN
    CALL MPL_MESSAGE(CDMESSAGE='MPL_BROADCAST: BUFFER NOT CONTIGUOUS ',LDABORT=LLABORT)
  ENDIF
ENDIF
#endif

IF(IMP_TYPE == JP_BLOCKING_STANDARD .OR. IMP_TYPE == JP_BLOCKING_BUFFERED) THEN
  CALL MPI_BCAST(PBUF(1,1),ICOUNT,INT(MPI_REAL8),IROOT-1,ICOMM,IERROR)
ELSEIF(IMP_TYPE == JP_NON_BLOCKING_STANDARD .OR. IMP_TYPE == JP_NON_BLOCKING_BUFFERED) THEN
  IF(.NOT.PRESENT(KREQUEST)) CALL MPL_MESSAGE(KERROR,'MPL_SEND',' KREQUEST MISSING',LDABORT=LLABORT)
  CALL MPI_IBCAST(PBUF(1,1),ICOUNT,INT(MPI_REAL8),IROOT-1,ICOMM,KREQUEST,IERROR)
ELSE
  IF(PRESENT(KERROR)) THEN
    IERROR=1
  ELSE
    CALL MPL_MESSAGE(KERROR,'MPL_BROADCAST',' INVALID METHOD',LDABORT=LLABORT)
  ENDIF
ENDIF

IF(LMPLSTATS) THEN
  IF(IROOT == IPL_MYRANK) THEN
    CALL MPL_SENDSTATS(ICOUNT,INT(MPI_REAL8))
  ENDIF
  CALL MPL_RECVSTATS(ICOUNT,INT(MPI_REAL8))
ENDIF

IF(PRESENT(KERROR)) THEN
  KERROR=IERROR
ELSE
  IF(IERROR /= 0 ) CALL MPL_MESSAGE(IERROR,'MPL_BROADCAST',CDSTRING,LDABORT=LLABORT)
ENDIF


END SUBROUTINE MPL_BROADCAST_REAL82

SUBROUTINE MPL_BROADCAST_REAL83(PBUF,KTAG,KROOT,KMP_TYPE,&
                                KCOMM,KERROR,KREQUEST,CDSTRING)

#ifdef USE_8_BYTE_WORDS
  USE MPI4TO8, ONLY : &
    MPI_COMM_SIZE => MPI_COMM_SIZE8, MPI_BCAST => MPI_BCAST8
#endif


REAL(KIND=JPRD)            :: PBUF(:,:,:)
INTEGER(KIND=JPIM),INTENT(IN)          :: KTAG
INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL :: KROOT,KCOMM,KMP_TYPE
INTEGER(KIND=JPIM),INTENT(OUT),OPTIONAL :: KERROR,KREQUEST
CHARACTER(LEN=*),INTENT(IN),OPTIONAL :: CDSTRING

INTEGER(KIND=JPIM) :: ICOUNT,ICOMM,IERROR,IROOT,IPL_NUMPROC,IPL_MYRANK,IMP_TYPE
LOGICAL :: LLRETURN

CALL MPL_BROADCAST_PREAMB1(IROOT,ICOMM,IPL_NUMPROC,IPL_MYRANK,IMP_TYPE,LLRETURN,KERROR,KCOMM,KROOT,KMP_TYPE)
IF (LLRETURN) RETURN

IERROR = 0

ICOUNT = SIZE(PBUF)
#ifndef NAG
IF (ICOUNT > 0) THEN
  IF( (LOC(PBUF(UBOUND(PBUF,1),UBOUND(PBUF,2),UBOUND(PBUF,3))) - &
    &  LOC(PBUF(LBOUND(PBUF,1),LBOUND(PBUF,2),LBOUND(PBUF,3)))) /= 8_JPIB*(ICOUNT - 1) ) THEN
    CALL MPL_MESSAGE(CDMESSAGE='MPL_BROADCAST: BUFFER NOT CONTIGUOUS ',LDABORT=LLABORT)
  ENDIF
ENDIF
#endif

IF(IMP_TYPE == JP_BLOCKING_STANDARD .OR. IMP_TYPE == JP_BLOCKING_BUFFERED) THEN
  CALL MPI_BCAST(PBUF(1,1,1),ICOUNT,INT(MPI_REAL8),IROOT-1,ICOMM,IERROR)
ELSEIF(IMP_TYPE == JP_NON_BLOCKING_STANDARD .OR. IMP_TYPE == JP_NON_BLOCKING_BUFFERED) THEN
  IF(.NOT.PRESENT(KREQUEST)) CALL MPL_MESSAGE(KERROR,'MPL_SEND',' KREQUEST MISSING',LDABORT=LLABORT)
  CALL MPI_IBCAST(PBUF(1,1,1),ICOUNT,INT(MPI_REAL8),IROOT-1,ICOMM,KREQUEST,IERROR)
ELSE
  IF(PRESENT(KERROR)) THEN
    IERROR=1
  ELSE
    CALL MPL_MESSAGE(KERROR,'MPL_BROADCAST',' INVALID METHOD',LDABORT=LLABORT)
  ENDIF
ENDIF
IF(LMPLSTATS) THEN
  IF(IROOT == IPL_MYRANK) THEN
    CALL MPL_SENDSTATS(ICOUNT,INT(MPI_REAL8))
  ENDIF
  CALL MPL_RECVSTATS(ICOUNT,INT(MPI_REAL8))
ENDIF

IF(PRESENT(KERROR)) THEN
  KERROR=IERROR
ELSE
  IF(IERROR /= 0 ) CALL MPL_MESSAGE(IERROR,'MPL_BROADCAST',CDSTRING,LDABORT=LLABORT)
ENDIF


END SUBROUTINE MPL_BROADCAST_REAL83

SUBROUTINE MPL_BROADCAST_REAL84(PBUF,KTAG,KROOT,KMP_TYPE,&
                                KCOMM,KERROR,KREQUEST,CDSTRING)

#ifdef USE_8_BYTE_WORDS
  USE MPI4TO8, ONLY : &
    MPI_COMM_SIZE => MPI_COMM_SIZE8, MPI_BCAST => MPI_BCAST8
#endif


REAL(KIND=JPRD)            :: PBUF(:,:,:,:)
INTEGER(KIND=JPIM),INTENT(IN)          :: KTAG
INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL :: KROOT,KCOMM,KMP_TYPE
INTEGER(KIND=JPIM),INTENT(OUT),OPTIONAL :: KERROR,KREQUEST
CHARACTER(LEN=*),INTENT(IN),OPTIONAL :: CDSTRING

INTEGER(KIND=JPIM) :: ICOUNT,ICOMM,IERROR,IROOT,IPL_NUMPROC,IPL_MYRANK,IMP_TYPE
LOGICAL :: LLRETURN

CALL MPL_BROADCAST_PREAMB1(IROOT,ICOMM,IPL_NUMPROC,IPL_MYRANK,IMP_TYPE,LLRETURN,KERROR,KCOMM,KROOT,KMP_TYPE)
IF (LLRETURN) RETURN

IERROR = 0

ICOUNT = SIZE(PBUF)
#ifndef NAG
IF (ICOUNT > 0) THEN
  IF( (LOC(PBUF(UBOUND(PBUF,1),UBOUND(PBUF,2),UBOUND(PBUF,3),UBOUND(PBUF,4))) - &
    &  LOC(PBUF(LBOUND(PBUF,1),LBOUND(PBUF,2),LBOUND(PBUF,3),LBOUND(PBUF,4)))) /= 8_JPIB*(ICOUNT - 1) ) THEN
    CALL MPL_MESSAGE(CDMESSAGE='MPL_BROADCAST: BUFFER NOT CONTIGUOUS ',LDABORT=LLABORT)
  ENDIF
ENDIF
#endif

IF(IMP_TYPE == JP_BLOCKING_STANDARD .OR. IMP_TYPE == JP_BLOCKING_BUFFERED) THEN
  CALL MPI_BCAST(PBUF(1,1,1,1),ICOUNT,INT(MPI_REAL8),IROOT-1,ICOMM,IERROR)
ELSEIF(IMP_TYPE == JP_NON_BLOCKING_STANDARD .OR. IMP_TYPE == JP_NON_BLOCKING_BUFFERED) THEN
  IF(.NOT.PRESENT(KREQUEST)) CALL MPL_MESSAGE(KERROR,'MPL_SEND',' KREQUEST MISSING',LDABORT=LLABORT)
  CALL MPI_IBCAST(PBUF(1,1,1,1),ICOUNT,INT(MPI_REAL8),IROOT-1,ICOMM,KREQUEST,IERROR)
ELSE
  IF(PRESENT(KERROR)) THEN
    IERROR=1
  ELSE
    CALL MPL_MESSAGE(KERROR,'MPL_BROADCAST',' INVALID METHOD',LDABORT=LLABORT)
  ENDIF
ENDIF

IF(LMPLSTATS) THEN
  IF(IROOT == IPL_MYRANK) THEN
    CALL MPL_SENDSTATS(ICOUNT,INT(MPI_REAL8))
  ENDIF
  CALL MPL_RECVSTATS(ICOUNT,INT(MPI_REAL8))
ENDIF

IF(PRESENT(KERROR)) THEN
  KERROR=IERROR
ELSE
  IF(IERROR /= 0 ) CALL MPL_MESSAGE(IERROR,'MPL_BROADCAST',CDSTRING,LDABORT=LLABORT)
ENDIF


END SUBROUTINE MPL_BROADCAST_REAL84


SUBROUTINE MPL_BROADCAST_REAL4_SCALAR(PBUF,KTAG,KROOT,KMP_TYPE,&
                                      KCOMM,KERROR,KREQUEST,CDSTRING)


#ifdef USE_8_BYTE_WORDS
  USE MPI4TO8, ONLY : &
    MPI_COMM_SIZE => MPI_COMM_SIZE8, MPI_BCAST => MPI_BCAST8
#endif


REAL(KIND=JPRM)            :: PBUF
INTEGER(KIND=JPIM),INTENT(IN)          :: KTAG
INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL :: KROOT,KCOMM,KMP_TYPE
INTEGER(KIND=JPIM),INTENT(OUT),OPTIONAL :: KERROR,KREQUEST
CHARACTER(LEN=*),INTENT(IN),OPTIONAL :: CDSTRING

INTEGER(KIND=JPIM) :: ICOUNT,ICOMM,IERROR,IROOT,IPL_NUMPROC,IPL_MYRANK,IMP_TYPE
LOGICAL :: LLRETURN

CALL MPL_BROADCAST_PREAMB1(IROOT,ICOMM,IPL_NUMPROC,IPL_MYRANK,IMP_TYPE,LLRETURN,KERROR,KCOMM,KROOT,KMP_TYPE)
IF (LLRETURN) RETURN

IERROR = 0

ICOUNT = 1

IF(IMP_TYPE == JP_BLOCKING_STANDARD .OR. IMP_TYPE == JP_BLOCKING_BUFFERED) THEN
  CALL MPI_BCAST(PBUF,ICOUNT,INT(MPI_REAL4),IROOT-1,ICOMM,IERROR)
ELSEIF(IMP_TYPE == JP_NON_BLOCKING_STANDARD .OR. IMP_TYPE == JP_NON_BLOCKING_BUFFERED) THEN
  IF(.NOT.PRESENT(KREQUEST)) CALL MPL_MESSAGE(KERROR,'MPL_SEND',' KREQUEST MISSING',LDABORT=LLABORT)
  CALL MPI_IBCAST(PBUF,ICOUNT,INT(MPI_REAL4),IROOT-1,ICOMM,KREQUEST,IERROR)
ELSE
  IF(PRESENT(KERROR)) THEN
    IERROR=1
  ELSE
    CALL MPL_MESSAGE(KERROR,'MPL_BROADCAST',' INVALID METHOD',LDABORT=LLABORT)
  ENDIF
ENDIF

IF(PRESENT(KERROR)) THEN
  KERROR=IERROR
ELSE
  IF(IERROR /= 0 ) CALL MPL_MESSAGE(IERROR,'MPL_BROADCAST',CDSTRING,LDABORT=LLABORT)
ENDIF

END SUBROUTINE MPL_BROADCAST_REAL4_SCALAR


SUBROUTINE MPL_BROADCAST_REAL8_SCALAR(PBUF,KTAG,KROOT,KMP_TYPE,&
                                      KCOMM,KERROR,KREQUEST,CDSTRING)


#ifdef USE_8_BYTE_WORDS
  USE MPI4TO8, ONLY : &
    MPI_COMM_SIZE => MPI_COMM_SIZE8, MPI_BCAST => MPI_BCAST8
#endif


REAL(KIND=JPRD)            :: PBUF
INTEGER(KIND=JPIM),INTENT(IN)          :: KTAG
INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL :: KROOT,KCOMM,KMP_TYPE
INTEGER(KIND=JPIM),INTENT(OUT),OPTIONAL :: KERROR,KREQUEST
CHARACTER(LEN=*),INTENT(IN),OPTIONAL :: CDSTRING

INTEGER(KIND=JPIM) :: ICOUNT,ICOMM,IERROR,IROOT,IPL_NUMPROC,IPL_MYRANK,IMP_TYPE
LOGICAL :: LLRETURN

CALL MPL_BROADCAST_PREAMB1(IROOT,ICOMM,IPL_NUMPROC,IPL_MYRANK,IMP_TYPE,LLRETURN,KERROR,KCOMM,KROOT,KMP_TYPE)
IF (LLRETURN) RETURN

IERROR = 0

ICOUNT = 1

IF(IMP_TYPE == JP_BLOCKING_STANDARD .OR. IMP_TYPE == JP_BLOCKING_BUFFERED) THEN
  CALL MPI_BCAST(PBUF,ICOUNT,INT(MPI_REAL8),IROOT-1,ICOMM,IERROR)
ELSEIF(IMP_TYPE == JP_NON_BLOCKING_STANDARD .OR. IMP_TYPE == JP_NON_BLOCKING_BUFFERED) THEN
  IF(.NOT.PRESENT(KREQUEST)) CALL MPL_MESSAGE(KERROR,'MPL_SEND',' KREQUEST MISSING',LDABORT=LLABORT)
  CALL MPI_IBCAST(PBUF,ICOUNT,INT(MPI_REAL8),IROOT-1,ICOMM,KREQUEST,IERROR)
ELSE
  IF(PRESENT(KERROR)) THEN
    IERROR=1
  ELSE
    CALL MPL_MESSAGE(KERROR,'MPL_BROADCAST',' INVALID METHOD',LDABORT=LLABORT)
  ENDIF
ENDIF

IF(PRESENT(KERROR)) THEN
  KERROR=IERROR
ELSE
  IF(IERROR /= 0 ) CALL MPL_MESSAGE(IERROR,'MPL_BROADCAST',CDSTRING,LDABORT=LLABORT)
ENDIF


END SUBROUTINE MPL_BROADCAST_REAL8_SCALAR


SUBROUTINE MPL_BROADCAST_INT(KBUF,KTAG,KROOT,KMP_TYPE,&
                             KCOMM,KERROR,KREQUEST,CDSTRING)


#ifdef USE_8_BYTE_WORDS
  USE MPI4TO8, ONLY : &
    MPI_COMM_SIZE => MPI_COMM_SIZE8, MPI_BCAST => MPI_BCAST8
#endif


INTEGER(KIND=JPIM)           :: KBUF(:)
INTEGER(KIND=JPIM),INTENT(IN)          :: KTAG
INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL :: KROOT,KCOMM,KMP_TYPE
INTEGER(KIND=JPIM),INTENT(OUT),OPTIONAL :: KERROR,KREQUEST
CHARACTER(LEN=*),INTENT(IN),OPTIONAL :: CDSTRING

INTEGER(KIND=JPIM) :: ICOUNT,ICOMM,IERROR,IROOT,IPL_NUMPROC,IPL_MYRANK,IMP_TYPE
LOGICAL :: LLRETURN

CALL MPL_BROADCAST_PREAMB1(IROOT,ICOMM,IPL_NUMPROC,IPL_MYRANK,IMP_TYPE,LLRETURN,KERROR,KCOMM,KROOT,KMP_TYPE)
IF (LLRETURN) RETURN

IERROR = 0

ICOUNT = SIZE(KBUF)

IF(IMP_TYPE == JP_BLOCKING_STANDARD .OR. IMP_TYPE == JP_BLOCKING_BUFFERED) THEN
  CALL MPI_BCAST(KBUF,ICOUNT,INT(MPI_INTEGER),IROOT-1,ICOMM,IERROR)
ELSEIF(IMP_TYPE == JP_NON_BLOCKING_STANDARD .OR. IMP_TYPE == JP_NON_BLOCKING_BUFFERED) THEN
  IF(.NOT.PRESENT(KREQUEST)) CALL MPL_MESSAGE(KERROR,'MPL_SEND',' KREQUEST MISSING',LDABORT=LLABORT)
  CALL MPI_IBCAST(KBUF,ICOUNT,INT(MPI_INTEGER),IROOT-1,ICOMM,KREQUEST,IERROR)
ELSE
  IF(PRESENT(KERROR)) THEN
    IERROR=1
  ELSE
    CALL MPL_MESSAGE(KERROR,'MPL_BROADCAST',' INVALID METHOD',LDABORT=LLABORT)
  ENDIF
ENDIF

IF(LMPLSTATS) THEN
  IF(IROOT == IPL_MYRANK) THEN
    CALL MPL_SENDSTATS(ICOUNT,INT(MPI_INTEGER))
  ENDIF
  CALL MPL_RECVSTATS(ICOUNT,INT(MPI_INTEGER))
ENDIF

IF(PRESENT(KERROR)) THEN
  KERROR=IERROR
ELSE
  IF(IERROR /= 0 ) CALL MPL_MESSAGE(IERROR,'MPL_BROADCAST',CDSTRING,LDABORT=LLABORT)
ENDIF


END SUBROUTINE MPL_BROADCAST_INT


SUBROUTINE MPL_BROADCAST_INT2(KBUF,KTAG,KROOT,KMP_TYPE,&
                              KCOMM,KERROR,KREQUEST,CDSTRING)

INTEGER(KIND=JPIM)           :: KBUF(:,:)
INTEGER(KIND=JPIM),INTENT(IN)          :: KTAG
INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL :: KROOT,KCOMM,KMP_TYPE
INTEGER(KIND=JPIM),INTENT(OUT),OPTIONAL :: KERROR,KREQUEST
CHARACTER(LEN=*),INTENT(IN),OPTIONAL :: CDSTRING

INTEGER(KIND=JPIM) :: ICOUNT,ICOMM,IERROR,IROOT,IPL_NUMPROC,IPL_MYRANK,IMP_TYPE
LOGICAL :: LLRETURN


CALL MPL_BROADCAST_PREAMB1(IROOT,ICOMM,IPL_NUMPROC,IPL_MYRANK,IMP_TYPE,LLRETURN,KERROR,KCOMM,KROOT,KMP_TYPE)
IF (LLRETURN) RETURN

IERROR = 0
ICOUNT = SIZE(KBUF)

#ifndef NAG
IF (ICOUNT > 0) THEN
  IF( (LOC(KBUF(UBOUND(KBUF,1),UBOUND(KBUF,2))) - &
     & LOC(KBUF(LBOUND(KBUF,1),LBOUND(KBUF,2)))) /= 4_JPIB*(ICOUNT - 1) ) THEN
    CALL MPL_MESSAGE(CDMESSAGE='MPL_BROADCAST: BUFFER NOT CONTIGUOUS ',LDABORT=LLABORT)
  ENDIF
ENDIF
#endif

IF(IMP_TYPE == JP_BLOCKING_STANDARD .OR. IMP_TYPE == JP_BLOCKING_BUFFERED) THEN
  CALL MPI_BCAST(KBUF(1,1),ICOUNT,INT(MPI_INTEGER),IROOT-1,ICOMM,IERROR)
ELSEIF(IMP_TYPE == JP_NON_BLOCKING_STANDARD .OR. IMP_TYPE == JP_NON_BLOCKING_BUFFERED) THEN
  IF(.NOT.PRESENT(KREQUEST)) CALL MPL_MESSAGE(KERROR,'MPL_SEND',' KREQUEST MISSING',LDABORT=LLABORT)
  CALL MPI_IBCAST(KBUF(1,1),ICOUNT,INT(MPI_INTEGER),IROOT-1,ICOMM,KREQUEST,IERROR)
ELSE
  IF(PRESENT(KERROR)) THEN
    IERROR=1
  ELSE
    CALL MPL_MESSAGE(KERROR,'MPL_BROADCAST',' INVALID METHOD',LDABORT=LLABORT)
  ENDIF
ENDIF

IF(LMPLSTATS) THEN
  IF(IROOT == IPL_MYRANK) THEN
    CALL MPL_SENDSTATS(ICOUNT,INT(MPI_INTEGER))
  ENDIF
  CALL MPL_RECVSTATS(ICOUNT,INT(MPI_INTEGER))
ENDIF

IF(PRESENT(KERROR)) THEN
  KERROR=IERROR
ELSE
  IF(IERROR /= 0 ) CALL MPL_MESSAGE(IERROR,'MPL_BROADCAST',CDSTRING,LDABORT=LLABORT)
ENDIF

END SUBROUTINE MPL_BROADCAST_INT2


SUBROUTINE MPL_BROADCAST_INT3(KBUF,KTAG,KROOT,KMP_TYPE,&
                              KCOMM,KERROR,KREQUEST,CDSTRING)

INTEGER(KIND=JPIM)           :: KBUF(:,:,:)
INTEGER(KIND=JPIM),INTENT(IN)          :: KTAG
INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL :: KROOT,KCOMM,KMP_TYPE
INTEGER(KIND=JPIM),INTENT(OUT),OPTIONAL :: KERROR,KREQUEST
CHARACTER(LEN=*),INTENT(IN),OPTIONAL :: CDSTRING

INTEGER(KIND=JPIM) :: ICOUNT,ICOMM,IERROR,IROOT,IPL_NUMPROC,IPL_MYRANK,IMP_TYPE
LOGICAL :: LLRETURN


CALL MPL_BROADCAST_PREAMB1(IROOT,ICOMM,IPL_NUMPROC,IPL_MYRANK,IMP_TYPE,LLRETURN,KERROR,KCOMM,KROOT,KMP_TYPE)
IF (LLRETURN) RETURN

IERROR = 0
ICOUNT = SIZE(KBUF)

#ifndef NAG
IF (ICOUNT > 0) THEN
  IF( (LOC(KBUF(UBOUND(KBUF,1),UBOUND(KBUF,2),UBOUND(KBUF,3))) - &
     & LOC(KBUF(LBOUND(KBUF,1),LBOUND(KBUF,2),LBOUND(KBUF,3)))) /= 4_JPIB*(ICOUNT - 1) ) THEN
    CALL MPL_MESSAGE(CDMESSAGE='MPL_BROADCAST: BUFFER NOT CONTIGUOUS ',LDABORT=LLABORT)
  ENDIF
ENDIF
#endif

IF(IMP_TYPE == JP_BLOCKING_STANDARD .OR. IMP_TYPE == JP_BLOCKING_BUFFERED) THEN
  CALL MPI_BCAST(KBUF(1,1,1),ICOUNT,INT(MPI_INTEGER),IROOT-1,ICOMM,IERROR)
ELSEIF(IMP_TYPE == JP_NON_BLOCKING_STANDARD .OR. IMP_TYPE == JP_NON_BLOCKING_BUFFERED) THEN
  IF(.NOT.PRESENT(KREQUEST)) CALL MPL_MESSAGE(KERROR,'MPL_SEND',' KREQUEST MISSING',LDABORT=LLABORT)
  CALL MPI_IBCAST(KBUF(1,1,1),ICOUNT,INT(MPI_INTEGER),IROOT-1,ICOMM,KREQUEST,IERROR)
ELSE
  IF(PRESENT(KERROR)) THEN
    IERROR=1
  ELSE
    CALL MPL_MESSAGE(KERROR,'MPL_BROADCAST',' INVALID METHOD',LDABORT=LLABORT)
  ENDIF
ENDIF

IF(LMPLSTATS) THEN
  IF(IROOT == IPL_MYRANK) THEN
    CALL MPL_SENDSTATS(ICOUNT,INT(MPI_INTEGER))
  ENDIF
  CALL MPL_RECVSTATS(ICOUNT,INT(MPI_INTEGER))
ENDIF

IF(PRESENT(KERROR)) THEN
  KERROR=IERROR
ELSE
  IF(IERROR /= 0 ) CALL MPL_MESSAGE(IERROR,'MPL_BROADCAST',CDSTRING,LDABORT=LLABORT)
ENDIF

END SUBROUTINE MPL_BROADCAST_INT3


SUBROUTINE MPL_BROADCAST_INT_SCALAR(KBUF,KTAG,KROOT,KMP_TYPE,&
                                    KCOMM,KERROR,KREQUEST,CDSTRING)


#ifdef USE_8_BYTE_WORDS
  USE MPI4TO8, ONLY : &
    MPI_COMM_SIZE => MPI_COMM_SIZE8, MPI_BCAST => MPI_BCAST8
#endif


INTEGER(KIND=JPIM)           :: KBUF
INTEGER(KIND=JPIM),INTENT(IN)          :: KTAG
INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL :: KROOT,KCOMM,KMP_TYPE
INTEGER(KIND=JPIM),INTENT(OUT),OPTIONAL :: KERROR,KREQUEST
CHARACTER(LEN=*),INTENT(IN),OPTIONAL :: CDSTRING

INTEGER(KIND=JPIM) :: ICOUNT,ICOMM,IERROR,IROOT,IPL_NUMPROC,IPL_MYRANK,IMP_TYPE
LOGICAL :: LLRETURN

CALL MPL_BROADCAST_PREAMB1(IROOT,ICOMM,IPL_NUMPROC,IPL_MYRANK,IMP_TYPE,LLRETURN,KERROR,KCOMM,KROOT,KMP_TYPE)
IF (LLRETURN) RETURN

IERROR = 0

ICOUNT = 1

IF(IMP_TYPE == JP_BLOCKING_STANDARD .OR. IMP_TYPE == JP_BLOCKING_BUFFERED) THEN
  CALL MPI_BCAST(KBUF,ICOUNT,INT(MPI_INTEGER),IROOT-1,ICOMM,IERROR)
ELSEIF(IMP_TYPE == JP_NON_BLOCKING_STANDARD .OR. IMP_TYPE == JP_NON_BLOCKING_BUFFERED) THEN
  IF(.NOT.PRESENT(KREQUEST)) CALL MPL_MESSAGE(KERROR,'MPL_SEND',' KREQUEST MISSING',LDABORT=LLABORT)
  CALL MPI_IBCAST(KBUF,ICOUNT,INT(MPI_INTEGER),IROOT-1,ICOMM,KREQUEST,IERROR)
ELSE
  IF(PRESENT(KERROR)) THEN
    IERROR=1
  ELSE
    CALL MPL_MESSAGE(KERROR,'MPL_BROADCAST',' INVALID METHOD',LDABORT=LLABORT)
  ENDIF
ENDIF

IF(LMPLSTATS) THEN
  IF(IROOT == IPL_MYRANK) THEN
    CALL MPL_SENDSTATS(ICOUNT,INT(MPI_INTEGER))
  ENDIF
  CALL MPL_RECVSTATS(ICOUNT,INT(MPI_INTEGER))
ENDIF

IF(PRESENT(KERROR)) THEN
  KERROR=IERROR
ELSE
  IF(IERROR /= 0 ) CALL MPL_MESSAGE(IERROR,'MPL_BROADCAST',CDSTRING,LDABORT=LLABORT)
ENDIF


END SUBROUTINE MPL_BROADCAST_INT_SCALAR


SUBROUTINE MPL_BROADCAST_CHAR_SCALAR(CDBUF,KTAG,KROOT,KMP_TYPE,&
                                    KCOMM,KERROR,KREQUEST,CDSTRING)


#ifdef USE_8_BYTE_WORDS
  USE MPI4TO8, ONLY : &
    MPI_COMM_SIZE => MPI_COMM_SIZE8, MPI_BCAST => MPI_BCAST8
#endif


CHARACTER(LEN=*)                       :: CDBUF
INTEGER(KIND=JPIM),INTENT(IN)          :: KTAG
INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL :: KROOT,KCOMM,KMP_TYPE
INTEGER(KIND=JPIM),INTENT(OUT),OPTIONAL :: KERROR,KREQUEST
CHARACTER(LEN=*),INTENT(IN),OPTIONAL :: CDSTRING

INTEGER(KIND=JPIM) :: ICOUNT,ICOMM,IERROR,IROOT,IPL_NUMPROC,IPL_MYRANK,IMP_TYPE
LOGICAL :: LLRETURN

CALL MPL_BROADCAST_PREAMB1(IROOT,ICOMM,IPL_NUMPROC,IPL_MYRANK,IMP_TYPE,LLRETURN,KERROR,KCOMM,KROOT,KMP_TYPE)
IF (LLRETURN) RETURN

IERROR = 0

ICOUNT = LEN(CDBUF)

IF(IMP_TYPE == JP_BLOCKING_STANDARD .OR. IMP_TYPE == JP_BLOCKING_BUFFERED) THEN
  CALL MPI_BCAST(CDBUF,ICOUNT,INT(MPI_BYTE),IROOT-1,ICOMM,IERROR)
ELSEIF(IMP_TYPE == JP_NON_BLOCKING_STANDARD .OR. IMP_TYPE == JP_NON_BLOCKING_BUFFERED) THEN
  IF(.NOT.PRESENT(KREQUEST)) CALL MPL_MESSAGE(KERROR,'MPL_SEND',' KREQUEST MISSING',LDABORT=LLABORT)
  CALL MPI_IBCAST(CDBUF,ICOUNT,INT(MPI_BYTE),IROOT-1,ICOMM,KREQUEST,IERROR)
ELSE
  IF(PRESENT(KERROR)) THEN
    IERROR=1
  ELSE
    CALL MPL_MESSAGE(KERROR,'MPL_BROADCAST',' INVALID METHOD',LDABORT=LLABORT)
  ENDIF
ENDIF

IF(LMPLSTATS) THEN
  IF(IROOT == IPL_MYRANK) THEN
    CALL MPL_SENDSTATS(ICOUNT,INT(MPI_BYTE))
  ENDIF
  CALL MPL_RECVSTATS(ICOUNT,INT(MPI_BYTE))
ENDIF

IF(PRESENT(KERROR)) THEN
  KERROR=IERROR
ELSE
  IF(IERROR /= 0 ) CALL MPL_MESSAGE(IERROR,'MPL_BROADCAST',CDSTRING,LDABORT=LLABORT)
ENDIF


END SUBROUTINE MPL_BROADCAST_CHAR_SCALAR

SUBROUTINE MPL_BROADCAST_CHAR1(CDBUF,KTAG,KROOT,KMP_TYPE,&
                               KCOMM,KERROR,KREQUEST,CDSTRING)


#ifdef USE_8_BYTE_WORDS
  USE MPI4TO8, ONLY : &
    MPI_COMM_SIZE => MPI_COMM_SIZE8, MPI_BCAST => MPI_BCAST8
#endif


CHARACTER(LEN=*)                       :: CDBUF (:)
INTEGER(KIND=JPIM),INTENT(IN)          :: KTAG
INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL :: KROOT,KCOMM,KMP_TYPE
INTEGER(KIND=JPIM),INTENT(OUT),OPTIONAL :: KERROR,KREQUEST
CHARACTER(LEN=*),INTENT(IN),OPTIONAL :: CDSTRING

INTEGER(KIND=JPIM) :: ICOUNT,ICOMM,IERROR,IROOT,IPL_NUMPROC,IPL_MYRANK,IMP_TYPE
LOGICAL :: LLRETURN

CALL MPL_BROADCAST_PREAMB1(IROOT,ICOMM,IPL_NUMPROC,IPL_MYRANK,IMP_TYPE,LLRETURN,KERROR,KCOMM,KROOT,KMP_TYPE)
IF (LLRETURN) RETURN

IERROR = 0

ICOUNT = LEN(CDBUF)*SIZE(CDBUF)

IF(IMP_TYPE == JP_BLOCKING_STANDARD .OR. IMP_TYPE == JP_BLOCKING_BUFFERED) THEN
  CALL MPI_BCAST(CDBUF,ICOUNT,INT(MPI_BYTE),IROOT-1,ICOMM,IERROR)
ELSEIF(IMP_TYPE == JP_NON_BLOCKING_STANDARD .OR. IMP_TYPE == JP_NON_BLOCKING_BUFFERED) THEN
  IF(.NOT.PRESENT(KREQUEST)) CALL MPL_MESSAGE(KERROR,'MPL_SEND',' KREQUEST MISSING',LDABORT=LLABORT)
  CALL MPI_IBCAST(CDBUF,ICOUNT,INT(MPI_BYTE),IROOT-1,ICOMM,KREQUEST,IERROR)
ELSE
  IF(PRESENT(KERROR)) THEN
    IERROR=1
  ELSE
    CALL MPL_MESSAGE(KERROR,'MPL_BROADCAST',' INVALID METHOD',LDABORT=LLABORT)
  ENDIF
ENDIF

IF(LMPLSTATS) THEN
  IF(IROOT == IPL_MYRANK) THEN
    CALL MPL_SENDSTATS(ICOUNT,INT(MPI_BYTE))
  ENDIF
  CALL MPL_RECVSTATS(ICOUNT,INT(MPI_BYTE))
ENDIF

IF(PRESENT(KERROR)) THEN
  KERROR=IERROR
ELSE
  IF(IERROR /= 0 ) CALL MPL_MESSAGE(IERROR,'MPL_BROADCAST',CDSTRING,LDABORT=LLABORT)
ENDIF


END SUBROUTINE MPL_BROADCAST_CHAR1

SUBROUTINE MPL_BROADCAST_LOGICAL_SCALAR(LDBUF,KTAG,KROOT,KMP_TYPE,&
                                    KCOMM,KERROR,KREQUEST,CDSTRING)


#ifdef USE_8_BYTE_WORDS
  USE MPI4TO8, ONLY : &
    MPI_COMM_SIZE => MPI_COMM_SIZE8, MPI_BCAST => MPI_BCAST8
#endif


LOGICAL                                :: LDBUF
INTEGER(KIND=JPIM),INTENT(IN)          :: KTAG
INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL :: KROOT,KCOMM,KMP_TYPE
INTEGER(KIND=JPIM),INTENT(OUT),OPTIONAL :: KERROR,KREQUEST
CHARACTER(LEN=*),INTENT(IN),OPTIONAL :: CDSTRING

INTEGER(KIND=JPIM) :: ICOUNT,ICOMM,IERROR,IROOT,IPL_NUMPROC,IPL_MYRANK,IMP_TYPE
LOGICAL :: LLRETURN

CALL MPL_BROADCAST_PREAMB1(IROOT,ICOMM,IPL_NUMPROC,IPL_MYRANK,IMP_TYPE,LLRETURN,KERROR,KCOMM,KROOT,KMP_TYPE)
IF (LLRETURN) RETURN

IERROR = 0

ICOUNT = 1

IF(IMP_TYPE == JP_BLOCKING_STANDARD .OR. IMP_TYPE == JP_BLOCKING_BUFFERED) THEN
  CALL MPI_BCAST(LDBUF,ICOUNT,INT(MPI_LOGICAL),IROOT-1,ICOMM,IERROR)
ELSEIF(IMP_TYPE == JP_NON_BLOCKING_STANDARD .OR. IMP_TYPE == JP_NON_BLOCKING_BUFFERED) THEN
  IF(.NOT.PRESENT(KREQUEST)) CALL MPL_MESSAGE(KERROR,'MPL_SEND',' KREQUEST MISSING',LDABORT=LLABORT)
  CALL MPI_IBCAST(LDBUF,ICOUNT,INT(MPI_LOGICAL),IROOT-1,ICOMM,KREQUEST,IERROR)
ELSE
  IF(PRESENT(KERROR)) THEN
    IERROR=1
  ELSE
    CALL MPL_MESSAGE(KERROR,'MPL_BROADCAST',' INVALID METHOD',LDABORT=LLABORT)
  ENDIF
ENDIF

IF(LMPLSTATS) THEN
  IF(IROOT == IPL_MYRANK) THEN
    CALL MPL_SENDSTATS(ICOUNT,INT(MPI_BYTE))
  ENDIF
  CALL MPL_RECVSTATS(ICOUNT,INT(MPI_BYTE))
ENDIF

IF(PRESENT(KERROR)) THEN
  KERROR=IERROR
ELSE
  IF(IERROR /= 0 ) CALL MPL_MESSAGE(IERROR,'MPL_BROADCAST',CDSTRING,LDABORT=LLABORT)
ENDIF


END SUBROUTINE MPL_BROADCAST_LOGICAL_SCALAR

SUBROUTINE MPL_BROADCAST_LOGICAL1(LDBUF,KTAG,KROOT,KMP_TYPE,&
                                  KCOMM,KERROR,KREQUEST,CDSTRING)


#ifdef USE_8_BYTE_WORDS
  USE MPI4TO8, ONLY : &
    MPI_COMM_SIZE => MPI_COMM_SIZE8, MPI_BCAST => MPI_BCAST8
#endif


LOGICAL                                :: LDBUF (:)
INTEGER(KIND=JPIM),INTENT(IN)          :: KTAG
INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL :: KROOT,KCOMM,KMP_TYPE
INTEGER(KIND=JPIM),INTENT(OUT),OPTIONAL :: KERROR,KREQUEST
CHARACTER(LEN=*),INTENT(IN),OPTIONAL :: CDSTRING

INTEGER(KIND=JPIM) :: ICOUNT,ICOMM,IERROR,IROOT,IPL_NUMPROC,IPL_MYRANK,IMP_TYPE
LOGICAL :: LLRETURN

CALL MPL_BROADCAST_PREAMB1(IROOT,ICOMM,IPL_NUMPROC,IPL_MYRANK,IMP_TYPE,LLRETURN,KERROR,KCOMM,KROOT,KMP_TYPE)
IF (LLRETURN) RETURN

IERROR = 0

ICOUNT = SIZE (LDBUF)

IF(IMP_TYPE == JP_BLOCKING_STANDARD .OR. IMP_TYPE == JP_BLOCKING_BUFFERED) THEN
  CALL MPI_BCAST (LDBUF,ICOUNT,INT(MPI_LOGICAL),IROOT-1,ICOMM,IERROR)
ELSEIF(IMP_TYPE == JP_NON_BLOCKING_STANDARD .OR. IMP_TYPE == JP_NON_BLOCKING_BUFFERED) THEN
  IF(.NOT.PRESENT(KREQUEST)) CALL MPL_MESSAGE(KERROR,'MPL_SEND',' KREQUEST MISSING',LDABORT=LLABORT)
  CALL MPI_IBCAST (LDBUF,ICOUNT,INT(MPI_LOGICAL),IROOT-1,ICOMM,KREQUEST,IERROR)
ELSE
  IF(PRESENT(KERROR)) THEN
    IERROR=1
  ELSE
    CALL MPL_MESSAGE(KERROR,'MPL_BROADCAST',' INVALID METHOD',LDABORT=LLABORT)
  ENDIF
ENDIF


IF(LMPLSTATS) THEN
  IF(IROOT == IPL_MYRANK) THEN
    CALL MPL_SENDSTATS(ICOUNT,INT(MPI_BYTE))
  ENDIF
  CALL MPL_RECVSTATS(ICOUNT,INT(MPI_BYTE))
ENDIF

IF(PRESENT(KERROR)) THEN
  KERROR=IERROR
ELSE
  IF(IERROR /= 0 ) CALL MPL_MESSAGE(IERROR,'MPL_BROADCAST',CDSTRING,LDABORT=LLABORT)
ENDIF


END SUBROUTINE MPL_BROADCAST_LOGICAL1

END MODULE MPL_BROADCAST_MOD

! (C) Copyright 2005- ECMWF.
! (C) Copyright 2013- Meteo-France.
! 
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!

MODULE DR_HACK_MOD

USE EC_PARKIND  ,ONLY : JPIM

IMPLICIT NONE

PRIVATE

LOGICAL, SAVE,      PUBLIC :: LL_DRHACK = .FALSE. ! Will be set to .TRUE. if envvar DR_HACK=1
INTEGER(KIND=JPIM), PUBLIC :: NULDRHACK = 999 ! Output unit for drHack pseudo xml file 

PUBLIC :: DR_HACK_INIT
PUBLIC :: DR_HACK
PUBLIC :: DR_HACK_END

CONTAINS

SUBROUTINE DR_HACK_INIT()
  IMPLICIT NONE
  CHARACTER(LEN=512) :: CLENV
  CALL GET_ENVIRONMENT_VARIABLE('DR_HACK',CLENV)
  IF( CLENV == 'yes'  .OR. CLENV == 'YES'  .OR. &
    & CLENV == 'true' .OR. CLENV == 'TRUE' .OR. &
    & CLENV == 'on'   .OR. CLENV == 'ON'   .OR. &
    & CLENV == '1' ) THEN
    LL_DRHACK=.TRUE.
    IF( MYPROC() == 1 ) THEN
      OPEN (UNIT = NULDRHACK, file = "drhack.txt",position="append",action="write")
    ENDIF
  ENDIF
CONTAINS
  FUNCTION MYPROC()
    USE MPL_DATA_MODULE ,ONLY : MPL_NUMPROC
    USE MPL_MYRANK_MOD  ,ONLY : MPL_MYRANK
    INTEGER(KIND=JPIM) :: MYPROC
    IF( MPL_NUMPROC > 0 ) THEN
      MYPROC = MPL_MYRANK()
    ELSE
      MYPROC = 1
    ENDIF
  END FUNCTION MYPROC
END SUBROUTINE DR_HACK_INIT

SUBROUTINE DR_HACK_END()
  IMPLICIT NONE
  LOGICAL LOPENED 
  INQUIRE(UNIT=NULDRHACK, OPENED=LOPENED) 
  IF( LOPENED ) THEN
    CLOSE (NULDRHACK)
  ENDIF
END SUBROUTINE DR_HACK_END

SUBROUTINE DR_HACK(ROUTINE,START)
!
! Florian Suzat (METEO-FRANCE) Sept 2017 : add drHack functionality
!
! drHack documentation:
! ----------------------------------
! ARPIFS has become a huge and complicated program. Debugging it can be very
! painful especially for newbies. Documenting it is also is a huge and tedious
! job.
! The idea behind “drHack” is basically to hack drHook: using the calls 
! "IF (LHOOK) CALL DR_HOOK('XXX',I,ZHOOK_HANDLE)" 
! (where XXX is the name of a routine, and I is 0 at the beginning of the
! routine and 1 at
! the end) in order to build a big XML file describing the ARPIFS calling tree.
! At initialization, if both environmental variables DR_HOOK and DR_HACK are set
! equal to 1, 
! then the hack is activated, otherwise everything works as usual.

! IMPORTANT: for the moment, it does not work with openmp
! (need to run with openmp=1) 

! When active, we first open a file drhack.txt.
! Every time the program enters a routine, we append <ROUTINE_NAME> to the
! file, and every time the routine is left, we append </ROUTINE_NAME> (mind the
! “/” extra character).
! Then, at the end of the run, the (big!) file drhack.txt contains the calling
! tree of the MPI processor number 0 as an XML file:
! <MASTER>
! <STACK_MIX_INIT_STACK>
! <STACK_MIX_GETSTACKUSAGEX>
! </STACK_MIX_GETSTACKUSAGEX>
! </STACK_MIX_INIT_STACK>
! <CNT0>
! <GEOMETRY_MOD_GEOMETRY_SET>
! </GEOMETRY_MOD_GEOMETRY_SET>
! ....
! 
! The resulting files are not usable as is (because they are too big). But with
! a few
! lines of python, it is easy to produce a condensed version of the drhack.txt
! file
! (if you want an example script, you may ask florian.suzat@meteo.fr).
! Then, with html and javascript, these condensed files are read and a
! dynamic collapsible search tree is built.
! Illustrations of such pages can be seen at http://intra.cnrm.meteo.fr/drhack/ 
! (only from the MeteoFrance network... If you want an export, mail
! florian.suzat@meteo.fr)

! Hope this help...

! -----------------------------------------------------------------
! Different implementation of this have been tested, but this one, even if it is
! not elegant at all, is almost fast.... 

IMPLICIT NONE
CHARACTER(LEN=*),INTENT(IN) :: ROUTINE
INTEGER(KIND=JPIM),INTENT(IN) :: START
INTEGER(KIND=JPIM) :: i
CHARACTER(LEN(ROUTINE)) :: ROUTINE_CLEAN

! replace some special character
DO i = 1,LEN(ROUTINE)
  SELECT CASE (ROUTINE(i:i))
  CASE ("<")
    ROUTINE_CLEAN (i:i)="_"
  CASE (">")
    ROUTINE_CLEAN (i:i)="_"
  CASE (":")
    ROUTINE_CLEAN (i:i)="_"
  CASE (" ")
    ROUTINE_CLEAN (i:i)="_"
  CASE DEFAULT
    ROUTINE_CLEAN (i:i)=ROUTINE(i:i)
  END SELECT
END DO

IF (START==0) THEN
  WRITE(NULDRHACK,*) '<',ROUTINE_CLEAN,'>'
ELSE
  WRITE(NULDRHACK,*) '</',ROUTINE_CLEAN,'>'
  !CLOSE FILE IF LAST ROUTINE
  IF (ROUTINE_CLEAN .eq. 'MODEL_MOD_MODEL_DELETE') THEN
    CLOSE(NULDRHACK)
  ENDIF
ENDIF
END SUBROUTINE DR_HACK

END MODULE

! (C) Copyright 2005- ECMWF.
! (C) Copyright 2013- Meteo-France.
! 
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!

MODULE MPI4TO8_S
#ifdef USE_8_BYTE_WORDS

USE EC_PARKIND, ONLY : JPIM
USE MPL_MPIF

IMPLICIT NONE

PRIVATE :: STATUS8
  INTEGER(KIND=8), DIMENSION(MPI_STATUS_SIZE) :: STATUS8

INTERFACE MPI_GET_COUNT8
  MODULE PROCEDURE MPI_GET_COUNT8_I4, MPI_GET_COUNT8_I4_1
END INTERFACE MPI_GET_COUNT8

INTERFACE MPI_WAITALL8
  MODULE PROCEDURE MPI_WAITALL8_I4, MPI_WAITALL8_I4_1
END INTERFACE MPI_WAITALL8

INTERFACE MPI_WAIT8
  MODULE PROCEDURE MPI_WAIT8_I4, MPI_WAIT8_I4_1
END INTERFACE MPI_WAIT8

PUBLIC

CONTAINS

! ---------------------------------------------------------
SUBROUTINE MPI_ABORT8(COMM, ERRORCODE, IERROR)

  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COMM, ERRORCODE
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    IERROR

  INTEGER(KIND=8) :: &
    COMM8, ERRORCODE8, IERROR8

  COMM8 = COMM
  ERRORCODE8 = ERRORCODE

  CALL MPI_ABORT(COMM8, ERRORCODE8, IERROR8)

  IERROR = IERROR8

END SUBROUTINE MPI_ABORT8

! ---------------------------------------------------------
SUBROUTINE MPI_BARRIER8(COMM, IERROR)

  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COMM
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    IERROR

  INTEGER(KIND=8) :: &
    COMM8, IERROR8

  COMM8 = COMM

  CALL MPI_BARRIER(COMM8, IERROR8)

  IERROR = IERROR8

END SUBROUTINE MPI_BARRIER8

! ---------------------------------------------------------
SUBROUTINE MPI_BUFFER_DETACH8(BUFFER_ADDR, SZ, IERROR)

  INTEGER(KIND=JPIM), DIMENSION(:), INTENT(OUT) :: &
    BUFFER_ADDR
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    SZ, IERROR

  INTEGER(KIND=8), DIMENSION(:), ALLOCATABLE :: &
    BUFFER_ADDR8
  INTEGER(KIND=8) :: &
    SZ8, IERROR8

  ALLOCATE(BUFFER_ADDR8(SIZE(BUFFER_ADDR)))

  CALL MPI_BUFFER_DETACH(BUFFER_ADDR8, SZ8, IERROR8)

  BUFFER_ADDR = BUFFER_ADDR8
  SZ = SZ8
  IERROR = IERROR8

  DEALLOCATE(BUFFER_ADDR8)

END SUBROUTINE MPI_BUFFER_DETACH8

! ---------------------------------------------------------
SUBROUTINE MPI_BUFFER_ATTACH8(BUFFER_ADDR, SZ, IERROR)

  INTEGER(KIND=JPIM), DIMENSION(:), INTENT(IN) :: &
    BUFFER_ADDR
  INTEGER(KIND=JPIM), INTENT(IN) :: &
    SZ
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    IERROR

  INTEGER(KIND=8), DIMENSION(:), ALLOCATABLE :: &
    BUFFER_ADDR8
  INTEGER(KIND=8) :: &
    SZ8, IERROR8

  ALLOCATE(BUFFER_ADDR8(SIZE(BUFFER_ADDR)))

  BUFFER_ADDR8 = BUFFER_ADDR
  SZ8 = SZ

  CALL MPI_BUFFER_ATTACH(BUFFER_ADDR8, SZ8, IERROR8)

  IERROR = IERROR8

  DEALLOCATE(BUFFER_ADDR8)

END SUBROUTINE MPI_BUFFER_ATTACH8

! ---------------------------------------------------------
SUBROUTINE MPI_CART_COORDS8(COMM, RANK, MAXDIMS, COORDS, IERROR)

  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COMM, RANK, MAXDIMS
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    IERROR
  INTEGER(KIND=JPIM), DIMENSION(:), INTENT(OUT) :: COORDS

  INTEGER(KIND=8), DIMENSION(:), ALLOCATABLE :: COORDS8
  INTEGER(KIND=8) :: &
    COMM8, RANK8, MAXDIMS8, IERROR8

  ALLOCATE(COORDS8(SIZE(COORDS)))

  COMM8 = COMM
  RANK8 = RANK
  MAXDIMS8 = MAXDIMS

  CALL MPI_CART_COORDS(COMM8, RANK8, MAXDIMS8, COORDS8, IERROR8)

  COORDS = COORDS8
  IERROR = IERROR8

  DEALLOCATE(COORDS8)

END SUBROUTINE MPI_CART_COORDS8

! ---------------------------------------------------------
SUBROUTINE MPI_CART_CREATE8(COMM_OLD, NDIMS, DIMS, PERIODS, REORDER, COMM_CART, IERROR)

  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COMM_OLD, NDIMS, DIMS(:)
  LOGICAL(KIND=JPIM), INTENT(IN) :: &
    PERIODS(:), REORDER
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    COMM_CART, IERROR

  INTEGER(KIND=8), DIMENSION(:), ALLOCATABLE :: &
    DIMS8
  INTEGER(KIND=8) :: &
    COMM_OLD8, NDIMS8, COMM_CART8, IERROR8
  LOGICAL(KIND=8), DIMENSION(:), ALLOCATABLE :: &
    PERIODS8
  LOGICAL(KIND=8) :: &
    REORDER8

  ALLOCATE(DIMS8(SIZE(DIMS)))
  ALLOCATE(PERIODS8(SIZE(PERIODS)))

  COMM_OLD8 = COMM_OLD
  NDIMS8 = NDIMS
  DIMS8 = DIMS
  PERIODS8 = PERIODS
  REORDER8 = REORDER

  CALL MPI_CART_CREATE(COMM_OLD8, NDIMS8, DIMS8, PERIODS8, REORDER8, COMM_CART8, IERROR8)

  COMM_CART =  COMM_CART8
  IERROR  = IERROR8

  DEALLOCATE(DIMS8)
  DEALLOCATE(PERIODS8)

END SUBROUTINE MPI_CART_CREATE8

! ---------------------------------------------------------
SUBROUTINE MPI_CART_RANK8(COMM, COORDS, RANK, IERROR)

  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COMM
  INTEGER(KIND=JPIM), INTENT(IN), DIMENSION(:) :: COORDS
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    RANK, IERROR

  INTEGER(KIND=8), DIMENSION(:), ALLOCATABLE :: COORDS8
  INTEGER(KIND=8) :: &
    COMM8, RANK8, IERROR8

  ALLOCATE(COORDS8(SIZE(COORDS)))

  COMM8 = COMM
  COORDS8 = COORDS

  CALL MPI_CART_RANK(COMM8, COORDS8, RANK8, IERROR8)

  RANK = RANK8
  IERROR = IERROR8

  DEALLOCATE(COORDS8)

END SUBROUTINE MPI_CART_RANK8

! ---------------------------------------------------------
SUBROUTINE MPI_CART_SUB8(COMM, REMAIN_DIMS, NEWCOMM, IERROR)

  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COMM
  LOGICAL(KIND=JPIM), INTENT(IN), DIMENSION(:) :: &
    REMAIN_DIMS
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    NEWCOMM, IERROR

  INTEGER(KIND=8) :: &
    COMM8, NEWCOMM8, IERROR8
  LOGICAL(KIND=8), DIMENSION(:), ALLOCATABLE :: &
    REMAIN_DIMS8

  ALLOCATE(REMAIN_DIMS8(SIZE(REMAIN_DIMS)))

  COMM8 = COMM
  REMAIN_DIMS8 = REMAIN_DIMS

  CALL MPI_CART_SUB(COMM8, REMAIN_DIMS8, NEWCOMM8, IERROR8)

  NEWCOMM = NEWCOMM8
  IERROR = IERROR8

  DEALLOCATE(REMAIN_DIMS8)

END SUBROUTINE MPI_CART_SUB8

! ---------------------------------------------------------
SUBROUTINE MPI_COMM_CREATE8(COMM, GROUP, NEWCOMM, IERROR)

  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COMM, GROUP
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    NEWCOMM, IERROR

  INTEGER(KIND=8) :: &
    COMM8, GROUP8, NEWCOMM8, IERROR8

  COMM8 = COMM
  GROUP8 = GROUP

  CALL MPI_COMM_CREATE(COMM8, GROUP8, NEWCOMM8, IERROR8)

  NEWCOMM = NEWCOMM8
  IERROR = IERROR8

END SUBROUTINE MPI_COMM_CREATE8

! ---------------------------------------------------------
SUBROUTINE MPI_COMM_GROUP8(COMM, GROUP, IERROR)

  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COMM
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    GROUP, IERROR

  INTEGER(KIND=8) :: &
    COMM8, GROUP8, IERROR8

  COMM8 = COMM

  CALL MPI_COMM_GROUP(COMM8, GROUP8, IERROR8)

  GROUP = GROUP8
  IERROR = IERROR8

END SUBROUTINE MPI_COMM_GROUP8

! ---------------------------------------------------------
SUBROUTINE MPI_COMM_RANK8(COMM, RANK, IERROR)

  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COMM
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    RANK, IERROR

  INTEGER(KIND=8) :: &
    COMM8, RANK8, IERROR8

  COMM8 = COMM

  CALL MPI_COMM_RANK(COMM8, RANK8, IERROR8)

  RANK = RANK8
  IERROR = IERROR8

END SUBROUTINE MPI_COMM_RANK8

! ---------------------------------------------------------
SUBROUTINE MPI_COMM_SIZE8(COMM, SIZE, IERROR)

  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COMM
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    SIZE, IERROR

  INTEGER(KIND=8) :: &
    COMM8, SIZE8, IERROR8

  COMM8 = COMM

  CALL MPI_COMM_SIZE(COMM8, SIZE8, IERROR8)

  SIZE = SIZE8
  IERROR = IERROR8

END SUBROUTINE MPI_COMM_SIZE8

! ---------------------------------------------------------
SUBROUTINE MPI_COMM_SPLIT8(COMM, COLOR, KEY, NEWCOMM, IERROR)

  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COMM, COLOR, KEY
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    NEWCOMM, IERROR

  INTEGER(KIND=8) :: &
    COMM8, COLOR8, KEY8, NEWCOMM8, IERROR8

  COMM8 = COMM
  COLOR8 = COLOR
  KEY8 = KEY

  CALL MPI_COMM_SPLIT(COMM8, COLOR8, KEY8, NEWCOMM8, IERROR8)

  NEWCOMM = NEWCOMM8
  IERROR = IERROR8

END SUBROUTINE MPI_COMM_SPLIT8

! ---------------------------------------------------------
SUBROUTINE MPI_ERROR_STRING8(ERRORCODE, STRING, RESULTLEN, IERROR)

  INTEGER(KIND=JPIM), INTENT(IN) :: &
    ERRORCODE
  CHARACTER(LEN=*), INTENT(OUT) :: &
    STRING
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    RESULTLEN, IERROR

  INTEGER(KIND=8) :: &
    ERRORCODE8, RESULTLEN8, IERROR8

  ERRORCODE8 = ERRORCODE

  CALL MPI_ERROR_STRING(ERRORCODE8, STRING, RESULTLEN8, IERROR8)

  RESULTLEN = RESULTLEN8
  IERROR = IERROR8

END SUBROUTINE MPI_ERROR_STRING8

! ---------------------------------------------------------
SUBROUTINE MPI_FILE_CLOSE8(FH, IERROR)

  INTEGER(KIND=JPIM), INTENT(IN) :: &
    FH
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    IERROR

  INTEGER(KIND=8) :: &
    FH8, IERROR8

  FH8 = FH

  CALL MPI_FILE_CLOSE(FH8, IERROR8)

  IERROR = IERROR8

END SUBROUTINE MPI_FILE_CLOSE8

! ---------------------------------------------------------
SUBROUTINE MPI_FILE_OPEN8(COMM, FILENAME, AMODE, INFO, FH, IERROR)

  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COMM, AMODE, INFO
  CHARACTER(LEN=*), INTENT(IN) :: &
    FILENAME
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    FH, IERROR

  INTEGER(KIND=8) :: &
    COMM8, AMODE8, INFO8, FH8, IERROR8

  COMM8 = COMM
  AMODE8 = AMODE
  INFO8 = INFO

  CALL MPI_FILE_OPEN(COMM8, FILENAME, AMODE8, INFO8, FH8, IERROR8)

  FH = FH8
  IERROR = IERROR8

END SUBROUTINE MPI_FILE_OPEN8

! ---------------------------------------------------------
SUBROUTINE MPI_FINALIZE8(IERROR)

  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    IERROR

  INTEGER(KIND=8) :: &
    IERROR8

  CALL MPI_FINALIZE(IERROR8)

  IERROR = IERROR8

END SUBROUTINE MPI_FINALIZE8

! ---------------------------------------------------------
SUBROUTINE MPI_GET_COUNT8_I4(STATUS, DATATYPE, COUNT, IERROR)

  INTEGER(KIND=JPIM), INTENT(IN) :: &
    STATUS(:), DATATYPE
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    COUNT, IERROR

  INTEGER(KIND=8) :: &
    DATATYPE8, COUNT8, IERROR8

  STATUS8 = STATUS
  DATATYPE8 = DATATYPE

  CALL MPI_GET_COUNT(STATUS8, DATATYPE8, COUNT8, IERROR8)

  COUNT = COUNT8
  IERROR = IERROR8

END SUBROUTINE MPI_GET_COUNT8_I4

! ---------------------------------------------------------
SUBROUTINE MPI_GET_COUNT8_I4_1(STATUS, DATATYPE, COUNT, IERROR)

  INTEGER(KIND=JPIM), INTENT(IN) :: &
    STATUS, DATATYPE
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    COUNT, IERROR

  INTEGER(KIND=8) :: &
    DATATYPE8, COUNT8, IERROR8, STATUS8

  STATUS8 = STATUS
  DATATYPE8 = DATATYPE

  CALL MPI_GET_COUNT(STATUS8, DATATYPE8, COUNT8, IERROR8)

  COUNT = COUNT8
  IERROR = IERROR8

END SUBROUTINE MPI_GET_COUNT8_I4_1

! ---------------------------------------------------------
SUBROUTINE MPI_GROUP_INCL8(GROUP1, N, RANKS, NEWGROUP, IERROR)

  INTEGER(KIND=JPIM), INTENT(IN) :: &
    GROUP1, N, RANKS(:)
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    NEWGROUP, IERROR

  INTEGER(KIND=8), DIMENSION(:), ALLOCATABLE :: &
    RANKS8
  INTEGER(KIND=8) :: &
    GROUP18, N8, NEWGROUP8, IERROR8

  ALLOCATE(RANKS8(SIZE(RANKS)))

  GROUP18 = GROUP1
  N8 = N
  RANKS8 = RANKS

  CALL MPI_GROUP_INCL(GROUP18, N8, RANKS8, NEWGROUP8, IERROR8)

  NEWGROUP = NEWGROUP8
  IERROR = IERROR8

  DEALLOCATE(RANKS8)

END SUBROUTINE MPI_GROUP_INCL8

! ---------------------------------------------------------
SUBROUTINE MPI_INIT8(IERROR)

  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    IERROR

  INTEGER(KIND=8) :: &
    IERROR8

  CALL MPI_INIT(IERROR8)

  IERROR = IERROR8

END SUBROUTINE MPI_INIT8

! ---------------------------------------------------------
SUBROUTINE MPI_INITIALIZED8(FLAG, IERROR)

  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    FLAG
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    IERROR

  INTEGER(KIND=8) :: &
    FLAG8
  INTEGER(KIND=8) :: &
    IERROR8


  CALL MPI_INITIALIZED(FLAG8, IERROR8)

  FLAG = FLAG8
  IERROR = IERROR8

END SUBROUTINE MPI_INITIALIZED8

! ---------------------------------------------------------
SUBROUTINE MPI_IPROBE8(SOURCE, TAG, COMM, FLAG, STATUS, IERROR)

  INTEGER(KIND=JPIM), INTENT(IN) :: &
    SOURCE, TAG, COMM
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    FLAG
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    STATUS(:), IERROR

  INTEGER(KIND=8) :: &
    SOURCE8, TAG8, COMM8, IERROR8
  INTEGER(KIND=8) :: &
    FLAG8

  SOURCE8 = SOURCE
  TAG8 = TAG
  COMM8 = COMM

  CALL MPI_IPROBE(SOURCE8, TAG8, COMM8, FLAG8, STATUS8, IERROR8)

  FLAG = FLAG8
  STATUS = STATUS8
  IERROR = IERROR8

END SUBROUTINE MPI_IPROBE8

! ---------------------------------------------------------
SUBROUTINE MPI_PROBE8(SOURCE, TAG, COMM, STATUS, IERROR)

  INTEGER(KIND=JPIM), INTENT(IN) :: &
    SOURCE, TAG, COMM
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    STATUS(:), IERROR

  INTEGER(KIND=8) :: &
    SOURCE8, TAG8, COMM8, IERROR8

  SOURCE8 = SOURCE
  TAG8 = TAG
  COMM8 = COMM

  CALL MPI_PROBE(SOURCE8, TAG8, COMM8, STATUS8, IERROR8)

  STATUS = STATUS8
  IERROR = IERROR8

END SUBROUTINE MPI_PROBE8

! ---------------------------------------------------------
SUBROUTINE MPI_WAIT8_I4(REQUEST, STATUS, IERROR)

  INTEGER(KIND=JPIM), INTENT(INOUT) :: &
    REQUEST
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    STATUS(:), IERROR

  INTEGER(KIND=8) :: &
    REQUEST8, IERROR8
  INTEGER(KIND=8), DIMENSION(:), ALLOCATABLE :: STATUS8

  ALLOCATE(STATUS8(SIZE(STATUS)))

  REQUEST8 = REQUEST

  CALL MPI_WAIT(REQUEST8, STATUS8, IERROR8)

  REQUEST = REQUEST8
  STATUS = STATUS8
  IERROR = IERROR8

  DEALLOCATE(STATUS8)

END SUBROUTINE MPI_WAIT8_I4

! ---------------------------------------------------------
SUBROUTINE MPI_WAIT8_I4_1(REQUEST, STATUS, IERROR)

  INTEGER(KIND=JPIM) :: &
    REQUEST
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    STATUS, IERROR

  INTEGER(KIND=8) :: &
    REQUEST8, IERROR8, STATUS8

  REQUEST8 = REQUEST

  CALL MPI_WAIT(REQUEST8, STATUS8, IERROR8)

  REQUEST = REQUEST8
  STATUS = STATUS8
  IERROR = IERROR8

END SUBROUTINE MPI_WAIT8_I4_1

! ---------------------------------------------------------
SUBROUTINE MPI_WAITALL8_I4(COUNT, ARRAY_OF_REQUESTS, ARRAY_OF_STATUSES, IERROR)

  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COUNT
  INTEGER(KIND=JPIM), DIMENSION(:), INTENT(INOUT) :: &
    ARRAY_OF_REQUESTS
  INTEGER(KIND=JPIM), DIMENSION(:,:), INTENT(OUT) :: &
    ARRAY_OF_STATUSES
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    IERROR

  INTEGER(KIND=8), DIMENSION(:), ALLOCATABLE :: &
    ARRAY_OF_REQUESTS8
  INTEGER(KIND=8), DIMENSION(:,:), ALLOCATABLE :: &
    ARRAY_OF_STATUSES8
  INTEGER(KIND=8) :: &
    COUNT8, IERROR8

  INTEGER :: N

  COUNT8 = COUNT

  ALLOCATE(ARRAY_OF_REQUESTS8(SIZE(ARRAY_OF_REQUESTS)))
  N = SIZE(ARRAY_OF_STATUSES) / MPI_STATUS_SIZE
  ALLOCATE(ARRAY_OF_STATUSES8(MPI_STATUS_SIZE,N))

  ARRAY_OF_REQUESTS8 = ARRAY_OF_REQUESTS

  CALL MPI_WAITALL(COUNT8, ARRAY_OF_REQUESTS8, ARRAY_OF_STATUSES8, IERROR8)

  ARRAY_OF_REQUESTS = ARRAY_OF_REQUESTS8
  ARRAY_OF_STATUSES = ARRAY_OF_STATUSES8

  DEALLOCATE(ARRAY_OF_REQUESTS8)
  DEALLOCATE(ARRAY_OF_STATUSES8)

  IERROR = IERROR8

END SUBROUTINE MPI_WAITALL8_I4

! ---------------------------------------------------------
SUBROUTINE MPI_WAITALL8_I4_1(COUNT, ARRAY_OF_REQUESTS, ARRAY_OF_STATUSES, IERROR)

  INTEGER(KIND=JPIM), INTENT(IN) :: &
    COUNT
  INTEGER(KIND=JPIM) :: &
    ARRAY_OF_REQUESTS
  INTEGER(KIND=JPIM), DIMENSION(:,:), INTENT(OUT) :: &
    ARRAY_OF_STATUSES
  INTEGER(KIND=JPIM), INTENT(OUT) :: &
    IERROR

  INTEGER(KIND=8) :: &
    ARRAY_OF_REQUESTS8
  INTEGER(KIND=8), DIMENSION(:,:), ALLOCATABLE :: &
    ARRAY_OF_STATUSES8
  INTEGER(KIND=8) :: &
    COUNT8, IERROR8

  INTEGER :: N

  COUNT8 = COUNT

  N = SIZE(ARRAY_OF_STATUSES) / MPI_STATUS_SIZE
  ALLOCATE(ARRAY_OF_STATUSES8(MPI_STATUS_SIZE,N))

  ARRAY_OF_REQUESTS8 = ARRAY_OF_REQUESTS

  CALL MPI_WAITALL(COUNT8, ARRAY_OF_REQUESTS8, ARRAY_OF_STATUSES8, IERROR8)

  ARRAY_OF_REQUESTS = ARRAY_OF_REQUESTS8
  ARRAY_OF_STATUSES = ARRAY_OF_STATUSES8

  DEALLOCATE(ARRAY_OF_STATUSES8)

  IERROR = IERROR8

END SUBROUTINE MPI_WAITALL8_I4_1

#endif
END MODULE MPI4TO8_S

SUBROUTINE GSTATS_QUERY(KNUM,PTIME)

!**** *GSTATS_QUERY*  - Get current value of gstats timer

!     PURPOSE.
!     --------
!       To query values of gstats timer for use in live output 


!**   INTERFACE.
!     ----------
!       *CALL* *GSTATS(KNUM,PTIME)

!        EXPLICIT ARGUMENTS
!        --------------------
!        KNUM - timing event number (for list of already defined events
!               see routine STATS_OUTPUT)
!        PTIME    - Output current value of timer

!        IMPLICIT ARGUMENTS
!        --------------------
!        Module YOMGSTATS

!     METHOD.
!     -------

!     REFERENCE.
!     ----------
!        ECMWF Research Department documentation of the IFS

!     AUTHOR.
!     -------
!        P. Gillies ECMWF

!     MODIFICATIONS.
!     --------------
!        ORIGINAL : 2021-03-03 

!     ------------------------------------------------------------------

USE EC_PARKIND  ,ONLY : JPRD, JPIM
USE YOMHOOK   ,ONLY : LHOOK, DR_HOOK, JPHOOK

USE YOMGSTATS  
USE OML_MOD

IMPLICIT NONE

INTEGER(KIND=JPIM),INTENT(IN) :: KNUM
REAL(KIND=JPRD),INTENT(OUT) :: PTIME
REAL(KIND=JPHOOK) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('GSTATS_QUERY',0,ZHOOK_HANDLE)

IF(LSTATS) THEN

! only process gstats calls for master thread

  IF(OML_MY_THREAD() <= 1) THEN

    ! Return current total value of specified timer
    IF(NCALLS(KNUM)>1) THEN
      PTIME=TIMESUM(KNUM)
    ELSE
      PTIME=0.0_JPRD
    ENDIF

  ENDIF

ELSE
  PTIME=0.0_JPRD
ENDIF

IF (LHOOK) CALL DR_HOOK('GSTATS_QUERY',1,ZHOOK_HANDLE)

END SUBROUTINE GSTATS_QUERY

C (C) Copyright 2005- ECMWF.
C (C) Copyright 2013- Meteo-France.
C 
C This software is licensed under the terms of the Apache Licence Version 2.0
C which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      subroutine mpi_group_incl(MPI_GROUP_WORLD,N,IRANK,IGROUP,IERR)
      ierr=0
!     call abor1('mpi_group_incl should never be called')
      return
      end

! (C) Copyright 2005- ECMWF.
! (C) Copyright 2013- Meteo-France.
! 
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!

SUBROUTINE GSTATS_BARRIER2(KNUM)

USE EC_PARKIND, ONLY: JPIM
USE YOMGSTATS, ONLY: LBARRIER_STATS2, NBAR_PTR, NBAR2
USE MPL_MODULE, ONLY: MPL_BARRIER

IMPLICIT NONE

INTEGER(KIND=JPIM) :: KNUM
INTEGER(KIND=JPIM) :: INUM

IF (LBARRIER_STATS2) THEN
  IF (NBAR_PTR(KNUM) == 0) THEN
    INUM = NBAR2
    NBAR2 = NBAR2 + 1
    NBAR_PTR(KNUM) = INUM
  ENDIF
  INUM = NBAR_PTR(KNUM)
  CALL GSTATS(INUM, 0)
  CALL MPL_BARRIER()
  CALL GSTATS(INUM, 1)
ENDIF

END SUBROUTINE GSTATS_BARRIER2

subroutine fail_impl(msg,line)
character(*) :: msg
integer :: line
write(0,'(A,I0,A)') "TEST FAILED in test_mpl.F90 @ line ",line," :"
write(0,*) msg
stop 1
end subroutine

#define FAIL(msg) call fail_impl(msg,__LINE__)

program main
use mpl_displs_container_mod
implicit none

integer, pointer :: send_pt(:), recv_pt(:)
integer, allocatable :: send(:), recv(:)
integer i, req, r1, r2, nproc
integer,allocatable :: aux(:)
logical copy

type(list_manager), pointer :: list => null()

list => yddispls_list

 ! keep it simple
nproc = 1
allocate(send(nproc),recv(nproc))

req   = 1
call list%append(req,nproc,send_pt,recv_pt)
 !write(0,*) associated(send_pt), associated(recv_pt),list%head%get_nproc(),list%head%get_req()
send_pt = 1
recv_pt = 1

req = 2
call list%append(req, nproc,send_pt, recv_pt)
send_pt = 2
recv_pt = 2

send = list%head%get_send()
recv = list%head%get_recv()

if ( list%list_size /= 2 .or. list%head%req /= 2 &
  .or. send(1) /= 2 .or. recv(1) /= 2) FAIL("append 2 nodes failed")
 !call list%print_list()
 !write(*,*) '+++++++++++++++++++++++++++++++'

call list%remove_first()
send = list%head%get_send()
recv = list%head%get_recv()
if ( list%list_size /= 1 .or. list%head%req /= 1 &
  .or. send(1) /=1 .or. recv(1) /=1) FAIL("head remove failed")


req = 4
call list%append(req)
call list%remove_req(2)
if ( list%list_size /= 2 .or. list%head%get_req() /= 4 ) FAIL("try to remove non-existent request failed")

call list%remove_req(1)
if ( list%list_size /= 1 .or. list%head%get_req() /= 4 ) FAIL("try to remove inner node failed")

req = 5
call list%append(knproc=nproc,ksend_pt=send_pt)
call list%append(krecv_pt=recv_pt,no_new_node=.true.)
call list%append(kreq=req,no_new_node=.true.)
if ( list%list_size /= 2 .or. list%head%get_req() /=5) FAIL("try one update in two steps failed")

call list%clear_list()
if ( associated(list%head) .or. list%list_size /=0 ) FAIL("clear list failed")

 ! remove two consecutive nodes
do i=1,10
  call list%append(i)
enddo
r1=7
r2=8
call list%remove_req(r2)
call list%remove_req(r1)
if (list%list_size /= 8) FAIL("remove two consecutive nodes failed 1")
allocate(aux(10))

do i = 10,1,-1
  if(i == r1 .or. i == r2) cycle
  aux(i) = list%head%get_req()
  call list%remove_first()
enddo
if (associated(list%head)) FAIL("remove two consecutive nodes failed 2")
do i=1,10
  if (i == r1 .or. i == r2) cycle
  if (aux(i) /= i) FAIL("remove two consecutive nodes failed 3")
enddo

end program main

! (C) Copyright 2005- ECMWF.
! 
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!

!
! Simple Test program
!
subroutine fail_impl(msg,line)
  use mpl_module, only : mpl_abort
  character(*) :: msg
  integer :: line
  
  write(0,'(A,I0,A)') "TEST FAILED in gatherv.F90 @ line ",line," :"
  write(0,*) msg

  call mpl_abort()
  
end subroutine

#define FAIL(msg) call fail_impl(msg,__LINE__)

subroutine work1(r)
  implicit none
  integer, intent(out) :: r

  real a(100000)
  call  random_number(a)
  if (any(a < 0.0) ) then
    r =1
  else
    r =0
  endif
end subroutine work1


program test_mpl_gatherv
use ec_parkind, only : jpim, jprm, jprd
use mpl_module, only: mpl_init, mpl_end, mpl_rank, linitmpi_via_mpl, mpl_gatherv, JP_NON_BLOCKING_STANDARD, mpl_wait

implicit none

integer(jpim) :: nprocs
logical :: verbose = .false.
integer(jpim), allocatable :: sbuf(:), rbuf(:), rcounts(:)
integer(jpim) :: scounts
real(jprm), allocatable :: sbufr(:), rbufr(:)
real(jprd), allocatable :: sbufd(:), rbufd(:)
character(len=6) :: sbufc
character(len=6), allocatable ::  rbufc(:)
integer i,j,k, kroot
character(len=256) msg

call mpl_init(KPROCS=nprocs,ldinfo=verbose,ldenv=.true.)

if( nprocs <= 1 ) FAIL("nprocs must be > 1")
if( mpl_rank < 1 .or. mpl_rank > nprocs  ) FAIL("mpl_rank must be >= 1 and <= nprocs")
if( .not. linitmpi_via_mpl ) FAIL("linitmpi_via_mpl must be True")

allocate(sbuf(mpl_rank),rbuf((nprocs*(nprocs+1))/2+nprocs),&
    sbufr(mpl_rank),rbufr((nprocs*(nprocs+1))/2+nprocs), &
    sbufd(mpl_rank),rbufd((nprocs*(nprocs+1))/2+nprocs),&
    rcounts(nprocs))
!allocate(character(len=mpl_rank) :: sbufc)
allocate(rbufc(nprocs))

sbuf  = mpl_rank
sbufr = mpl_rank
sbufd = mpl_rank
do i=1,len(sbufc)
  sbufc(i:i) = char(ichar('a')+mod(mpl_rank-1,26))
  !print*,sbufc(i:i), mpl_rank
enddo
scounts=mpl_rank
do i=1,nprocs
  rcounts(i)=i
enddo

kroot=2

call do_gatherv("blocking")

call do_gatherv("nonblocking")

call mpl_end(ldmeminfo=verbose)
! Note that with mpi_serial meminfo will not be printed regardless of ldmeminfo

contains

  subroutine do_gatherv(mode)
    implicit none
    character(len=*), intent(in) :: mode

    character(len=128) :: msg
    
    integer request_i, request_r, request_d, request_c, i, j, k, res
    integer rdispl(nprocs), rcounts_c(nprocs)

    select case(mode)
    case("blocking")
      call mpl_gatherv(sbuf,kroot,rbuf,rcounts)
      call mpl_gatherv(sbufr,kroot,rbufr,rcounts)
      rcounts_c=6
      call mpl_gatherv(sbufc,kroot,rbufc,rcounts_c)
      if (mpl_rank == kroot) then
        call mpl_gatherv(sbufd,kroot,rbufd,rcounts)
      else
        call mpl_gatherv(sbufd,kroot)
      endif    
    case("nonblocking")
      ! trying to get a random failure
      do j=1,1
        if (mpl_rank == kroot ) then
          call mpl_gatherv(sbuf,kroot,rbuf,rcounts, KMP_TYPE = JP_NON_BLOCKING_STANDARD, KREQUEST=request_i)
          call mpl_gatherv(sbufr,kroot,rbufr,rcounts, KMP_TYPE = JP_NON_BLOCKING_STANDARD, KREQUEST=request_r)
          call mpl_gatherv(sbufd,kroot,rbufd,rcounts, KMP_TYPE = JP_NON_BLOCKING_STANDARD, KREQUEST=request_d)
          rcounts_c=6 ! 
          call mpl_gatherv(sbufc,kroot,rbufc,rcounts_c, KMP_TYPE = JP_NON_BLOCKING_STANDARD,KREQUEST=request_c)
        else
          call mpl_gatherv(sbuf,kroot, KMP_TYPE = JP_NON_BLOCKING_STANDARD, KREQUEST=request_i)
          call mpl_gatherv(sbufr,kroot, KMP_TYPE = JP_NON_BLOCKING_STANDARD, KREQUEST=request_r)
          call mpl_gatherv(sbufd,kroot, KMP_TYPE = JP_NON_BLOCKING_STANDARD, KREQUEST=request_d)
          call mpl_gatherv(sbufc,kroot, KMP_TYPE = JP_NON_BLOCKING_STANDARD, KREQUEST=request_c)
        endif
          call work1(res)
        if ( res > 0 ) write(0,*) "error in work1 non-blocking alltoallv" ! this should not happen ever !!!
        call mpl_wait(request_r)
        call mpl_wait(request_d)
        call mpl_wait(request_i)
        call mpl_wait(request_c)
      enddo
    end select
    ! test values
    if (mpl_rank == kroot) then
      k=1
      do i=1,nprocs
        if ( any(rbuf(k:k+i-1) /= i) ) then
          !write(0,*) 'send ', mpl_rank, scounts, sbuf
          !write(0,*) 'recv ', mpl_rank, rcounts, rdispl
          write(msg,*) trim(mode)//" int alltoall test test failed on mpl_rank", mpl_rank, rbuf
          FAIL(msg)
        endif
        if ( any(nint(rbufr(k:k+i-1)) /= i) ) then
          write(msg,*) trim(mode)//" real alltoall test test failed on mpl_rank", mpl_rank, rbufr
          FAIL(msg)
        endif
        if ( any(nint(rbufd(k:k+i-1)) /= i) ) then
          write(msg,*) trim(mode)//" double alltoall test test failed on mpl_rank", mpl_rank, rbufd
          FAIL(msg)
        endif
        if ( rbufc(i)(1:1) /= char(ichar('a')+mod(i-1,26)) ) then
              write(msg,*) trim(mode)//" char alltoall test test failed on mpl_rank", mpl_rank, rbufc(i)
            FAIL(msg)
        endif
        k=k+i
      enddo
    endif

      ! test with displacement arguments
      ! leaving a space of 1 between each block
      select case(mode)
      case("nonblocking")
        rdispl(1)=0
        rdispl(1)=1
        do i=2,nprocs
          rdispl(i)=rdispl(i-1)+(i-1)+1
        enddo
        rbuf = 0
        call mpl_gatherv(sbuf, kroot, rbuf, rcounts, krecvdispl=rdispl, KMP_TYPE = JP_NON_BLOCKING_STANDARD, KREQUEST=request_i)
        call work1(res)
        if ( res > 0 ) write(0,*) "error in  work1 non-blocking alltoallv" ! this should not happen ever !!!
        call mpl_wait(request_i)
        
        if (mpl_rank == kroot) then
          !write(*,*) "rbuf", rbuf
          k=1
          do i=1,nprocs     
        if ( any(rbuf(k+1:k+1+i-1) /= i) .or. rbuf(k) /= 0 ) then
          write(msg,*) trim(mode)//" int alltoall test with displ args failed on mpl_rank", mpl_rank, rbuf
          FAIL(msg)
        endif
        k=k+i+1
          enddo
        endif
      end select
      
  end subroutine do_gatherv

end program test_mpl_gatherv

! (C) Copyright 2005- ECMWF.
! (C) Copyright 2013- Meteo-France.
! 
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!

MODULE MPL_STATS_MOD

PRIVATE
PUBLIC :: MPL_STATSINIT, MPL_STATSON, MPL_STATSREAD, MPL_SENDSTATS, MPL_RECVSTATS

CONTAINS

SUBROUTINE MPL_STATSINIT

!**** MPL_STATSINIT - Initialise collection of mpl statistics

!     Purpose.
!     --------
!     Initialises the mpl_stats package 

!**   Interface.
!     ----------
!        CALL MPL_STATSINIT

!        Input required arguments :
!        -------------------------
!           none

!        Input optional arguments :
!        -------------------------
!           none

!        Output required arguments :
!        -------------------------
!           none

!        Output optional arguments :
!        -------------------------
!           none 
 
!     Author.
!     -------
!        P.Towers             ECMWF

!     Modifications.
!     --------------
!        Original: 2011-04-06
!      F. Vana  05-Mar-2015  Support for single precision

!     ------------------------------------------------------------------

USE EC_PARKIND  ,ONLY : JPIM

USE YOMMPLSTATS

IMPLICIT NONE

INTEGER(KIND=JPIM) :: ITHR,OMP_GET_MAX_THREADS

LMPLSTATS=.TRUE.

ITHR = 1
!$ ITHR = OMP_GET_MAX_THREADS()
ITHR = ITHR-1

ALLOCATE(MPLSENDBYTES(0:ITHR))
ALLOCATE(MPLRECVBYTES(0:ITHR))
ALLOCATE(MPLSENDNUM(0:ITHR))
ALLOCATE(MPLRECVNUM(0:ITHR))
  
MPLSENDBYTES(:) = 0
MPLRECVBYTES(:) = 0
MPLSENDNUM(:) = 0
MPLRECVNUM(:) = 0

RETURN
END SUBROUTINE MPL_STATSINIT

SUBROUTINE MPL_STATSON(SENDNUM,SENDBYTES,RECVNUM,RECVBYTES)

!**** MPL_STATSON - Reset mpl statistics counters

!     Purpose.
!     --------
!     Returns the mpl statistics counter values
!     and sets them back to zero
!     non zero returned values correspond to messages that have
!     been sent/received outside of a GSTATS MPL region

!**   Interface.
!     ----------
!        CALL MPL_STATSON(SENDNUM,SENDBYTES,RECVNUM,RECVBYTES)

!        Input required arguments :
!        -------------------------
!           none

!        Input optional arguments :
!        -------------------------
!           none

!        Output required arguments :
!        -------------------------
!           SENDNUM     - number of unknown messages sent
!           SENDBYTES   - number of unknown bytes sent
!           RECVNUM     - number of unknown messages received
!           RECVBYTES   - number of unknown bytes received

!        Output optional arguments :
!        -------------------------
!           none 
 
!     Author.
!     -------
!        P.Towers             ECMWF

!     Modifications.
!     --------------
!        Original: 2011-04-06

!     ------------------------------------------------------------------

USE EC_PARKIND  ,ONLY : JPRD, JPIM

USE YOMMPLSTATS

IMPLICIT NONE

REAL(KIND=JPRD), INTENT(OUT)    :: SENDBYTES,RECVBYTES
INTEGER(KIND=JPIM), INTENT(OUT) :: SENDNUM,RECVNUM


 SENDBYTES = SUM(MPLSENDBYTES(:))
 RECVBYTES = SUM(MPLRECVBYTES(:))
 SENDNUM   = SUM(MPLSENDNUM(:))
 RECVNUM   = SUM(MPLRECVNUM(:))
 
 MPLSENDBYTES(:)=0.0_JPRD
 MPLRECVBYTES(:)=0.0_JPRD
 MPLSENDNUM(:)=0
 MPLRECVNUM(:)=0
 
RETURN
END SUBROUTINE MPL_STATSON

SUBROUTINE MPL_STATSREAD(SENDNUM,SENDBYTES,RECVNUM,RECVBYTES)

!**** MPL_STATSREAD - read mpl statistics counters

!     Purpose.
!     --------
!     returns the mpl statistics counter values
!     before setting them back to zero

!**   Interface.
!     ----------
!        CALL MPL_STATSREAD(SENDNUM,SENDBYTES,RECVNUM,RECVBYTES)

!        Input required arguments :
!        -------------------------
!           none

!        Input optional arguments :
!        -------------------------
!           none

!        Output required arguments :
!        -------------------------
!           SENDNUM     - number of messages sent
!           SENDBYTES   - number of bytes sent
!           RECVNUM     - number of messages received
!           RECVBYTES   - number of bytes received

!        Output optional arguments :
!        -------------------------
!           none 
 
!     Author.
!     -------
!        P.Towers             ECMWF

!     Modifications.
!     --------------
!        Original: 2011-04-06

!     ------------------------------------------------------------------

USE EC_PARKIND  ,ONLY : JPRD, JPIM

USE YOMMPLSTATS

IMPLICIT NONE

REAL(KIND=JPRD), INTENT(OUT)    :: SENDBYTES,RECVBYTES
INTEGER(KIND=JPIM), INTENT(OUT) :: SENDNUM,RECVNUM

  SENDNUM=SUM(MPLSENDNUM(:))
  RECVNUM=SUM(MPLRECVNUM(:))
  SENDBYTES=SUM(MPLSENDBYTES(:))
  RECVBYTES=SUM(MPLRECVBYTES (:))

  MPLSENDNUM(:)=0
  MPLRECVNUM(:)=0
  MPLSENDBYTES(:)=0.0_JPRD
  MPLRECVBYTES(:)=0.0_JPRD

RETURN
END SUBROUTINE MPL_STATSREAD

SUBROUTINE MPL_SENDSTATS(ICOUNT,ITYPE)

!**** MPL_SENDSTATS - collect mpl send statistics

!     Purpose.
!     --------
!     counts the number of messages and volume sent

!**   Interface.
!     ----------
!        CALL MPL_SENDSTATS(ICOUNT,ITYPE)

!        Input required arguments :
!        -------------------------
!           ICOUNT   - The number of elements sent
!           ITYPE    - The type of an element 

!        Input optional arguments :
!        -------------------------
!           none

!        Output required arguments :
!        -------------------------
!           none

!        Output optional arguments :
!        -------------------------
!           none 
 
!     Author.
!     -------
!        P.Towers             ECMWF

!     Modifications.
!     --------------
!        Original: 2011-04-06

!     ------------------------------------------------------------------

USE EC_PARKIND  ,ONLY : JPIM

USE MPL_DATA_MODULE
USE MPL_MESSAGE_MOD
USE YOMMPLSTATS

IMPLICIT NONE

INTEGER(KIND=JPIM),INTENT(IN)            :: ICOUNT
INTEGER(KIND=JPIM),INTENT(IN)            :: ITYPE

INTEGER(KIND=JPIM)  ISIZE,IERR,ITH,OMP_GET_THREAD_NUM

ITH = 0
!$ ITH = OMP_GET_THREAD_NUM()

MPLSENDNUM(ITH) = MPLSENDNUM(ITH) + 1

CALL MPI_TYPE_SIZE(ITYPE,ISIZE,IERR)

MPLSENDBYTES(ITH)=MPLSENDBYTES(ITH) + FLOAT(ISIZE * ICOUNT)

  
RETURN
END SUBROUTINE MPL_SENDSTATS

SUBROUTINE MPL_RECVSTATS(ICOUNT,ITYPE)

!**** MPL_RECVSTATS - collect mpl recv statistics

!     Purpose.
!     --------
!     counts the number of messages and volume received

!**   Interface.
!     ----------
!        CALL MPL_RECVSTATS(ICOUNT,ITYPE)

!        Input required arguments :
!        -------------------------
!           ICOUNT   - The number of elements received
!           ITYPE    - The type of an element 

!        Input optional arguments :
!        -------------------------
!           none

!        Output required arguments :
!        -------------------------
!           none

!        Output optional arguments :
!        -------------------------
!           none 
 
!     Author.
!     -------
!        P.Towers             ECMWF

!     Modifications.
!     --------------
!        Original: 2011-04-06

!     ------------------------------------------------------------------

USE EC_PARKIND  ,ONLY : JPIM

USE MPL_DATA_MODULE
USE MPL_MESSAGE_MOD
USE YOMMPLSTATS

IMPLICIT NONE

INTEGER(KIND=JPIM),INTENT(IN)            :: ICOUNT
INTEGER(KIND=JPIM),INTENT(IN)            :: ITYPE

INTEGER(KIND=JPIM) ISIZE,IERR,ITH,OMP_GET_THREAD_NUM

ITH = 0
!$ ITH = OMP_GET_THREAD_NUM()

MPLRECVNUM(ITH) = MPLRECVNUM(ITH) + 1

CALL MPI_TYPE_SIZE(ITYPE,ISIZE,IERR)

MPLRECVBYTES(ITH)=MPLRECVBYTES(ITH) + FLOAT(ISIZE * ICOUNT)
  
RETURN
END SUBROUTINE MPL_RECVSTATS

END MODULE MPL_STATS_MOD

      MODULE mpi_f08_compile_constants
      INTEGER :: mpi_byte = 0
      INTEGER :: mpi_comm_world = 0
      INTEGER :: mpi_integer = 0
      INTEGER :: mpi_integer4 = 0
      INTEGER :: mpi_integer8 = 0
      END MODULE

! (C) Copyright 2024- ECMWF.
! (C) Copyright 2024- Meteo-France.
! 
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!

MODULE MPI_F08

INTEGER :: MPI_UNDEFINED, MPI_MAX_ERROR_STRING, MPI_ANY_TAG, MPI_ANY_SOURCE, &
 &         MPI_IDENT, MPI_CONGRUENT, MPI_SIMILAR, MPI_THREAD_SINGLE, MPI_THREAD_MULTIPLE, &
 &         MPI_MODE_RDONLY, MPI_MODE_WRONLY, MPI_MODE_CREATE

!! dummy type definitions
!!========================

TYPE MPI_COMM
  INTEGER :: MPI_VAL
END TYPE

TYPE MPI_DATATYPE
  INTEGER :: MPI_VAL
END TYPE

TYPE MPI_STATUS
  INTEGER :: MPI_TAG, MPI_SOURCE
END TYPE

TYPE MPI_REQUEST
  INTEGER :: MPI_VAL
END TYPE

TYPE MPI_FILE
  INTEGER :: MPI_VAL
END TYPE

TYPE MPI_OP
END TYPE

TYPE MPI_GROUP
END TYPE

TYPE MPI_INFO
END TYPE


!! dummy instances
!!=================

TYPE(MPI_DATATYPE) :: MPI_BYTE, MPI_LOGICAL, MPI_CHARACTER, MPI_INTEGER, MPI_INTEGER4, MPI_INTEGER8, MPI_REAL4, MPI_REAL8

TYPE(MPI_OP)       :: MPI_MAX, MPI_MIN, MPI_SUM, MPI_BXOR

TYPE(MPI_REQUEST)  :: MPI_REQUEST_NULL

TYPE(MPI_COMM)     :: MPI_COMM_WORLD, MPI_COMM_NULL

TYPE(MPI_INFO)     :: MPI_INFO_NULL

!! symbols defined in mpi_serial library, and picked up via a 'USE MPL_MPI' important statement
!!==============================================================================================

EXTERNAL :: MPI_COMM_SIZE, MPI_TYPE_SIZE, MPI_ALLREDUCE, MPI_COMM_CREATE, MPI_COMM_GROUP

END MODULE MPI_F08

! (C) Copyright 2005- ECMWF.
! (C) Copyright 2013- Meteo-France.
! 
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!

MODULE MPL_ALLGATHERV_MOD

!**** MPL_ALLGATHERV Send data to all processes

!     Purpose.
!     --------
!     Send a message to all processes from a buffer.
!     The data may be REAL*4, REAL*8,or INTEGER, one dimensional array
!                     REAL*4,or REAL*8, two dimensional array
!                  or INTEGER scalar

!**   Interface.
!     ----------
!        CALL MPL_ALLGATHERV

!        Input required arguments :
!        -------------------------
!           PSENDBUF -  buffer containing message
!                       (can be type REAL*4, REAL*8 or INTEGER)
!           PRECVBUF -  buffer containing message
!                       (can be type REAL*4, REAL*8 or INTEGER)
!           KRECVCOUNTS-number of elements received from each process

!        Input optional arguments :
!        -------------------------
!           KCOMM    -  Communicator number if different from MPI_COMM_WORLD 
!                       or from that established as the default 
!                       by an MPL communicator routine
!           KMP_TYPE -  buffering type (see MPL_BUFFER_METHOD)
!                       overrides value provided to MPL_BUFFER_METHOD
!           KRECVDISPL -displacements in PRECVBUF at which to place 
!                       the incoming data
!           CDSTRING -  Character string for ABORT messages
!                       used when KERROR is not provided

!        Output required arguments :
!        -------------------------
!           none

!        Output optional arguments :
!        -------------------------
!           KREQUEST -  Communication request
!                       required when buffering type is non-blocking
!           KERROR   -  return error code.     If not supplied, 
!                       MPL_ALLGATHERV aborts when an error is detected.
!     Author.
!     -------
!        D.Dent, M.Hamrud     ECMWF

!     Modifications.
!     --------------
!        Original:   2000-11-23
!        J.Hague:    2004-12-15 : Threadsafe
!        M.Hamrud:   2014-10-22 : Add nonblocking option
!        F.Vana:     2015-03-05 : Support for single precision
!        P.Gillies:  2018-05-30 : Add KSENDCOUNT argument, needed for zero length sends

!     ------------------------------------------------------------------

USE EC_PARKIND  ,ONLY : JPRD, JPIM ,JPRM
USE OML_MOD   ,ONLY : OML_MY_THREAD

USE MPL_MPIF
USE MPL_DATA_MODULE
USE MPL_STATS_MOD
USE YOMMPLSTATS
USE MPL_MESSAGE_MOD
USE MPL_SEND_MOD
USE MPL_RECV_MOD
USE MPL_BARRIER_MOD

IMPLICIT NONE

PRIVATE

LOGICAL   :: LLABORT=.TRUE.
LOGICAL   :: LLBARRIER

INTERFACE MPL_ALLGATHERV
MODULE PROCEDURE MPL_ALLGATHERV_REAL8,MPL_ALLGATHERV_REAL4,&
                 MPL_ALLGATHERV_INT,  MPL_ALLGATHERV_INT_SCALAR
END INTERFACE

PUBLIC MPL_ALLGATHERV

CONTAINS


SUBROUTINE MPL_ALLGATHERV_REAL4(PSENDBUF,PRECVBUF,KRECVCOUNTS,KSENDCOUNT,KRECVDISPL, &
                            & KMP_TYPE,KCOMM,KERROR,KREQUEST,CDSTRING)


#ifdef USE_8_BYTE_WORDS
  USE MPI4TO8, ONLY : &
    MPI_COMM_SIZE => MPI_COMM_SIZE8, MPI_ALLGATHERV => MPI_ALLGATHERV8
#endif



REAL(KIND=JPRM)            :: PSENDBUF(:)
REAL(KIND=JPRM)            :: PRECVBUF(:)
INTEGER(KIND=JPIM),INTENT(IN) :: KRECVCOUNTS(:)
INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL :: KSENDCOUNT
INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL :: KRECVDISPL(:),KCOMM,KMP_TYPE
INTEGER(KIND=JPIM),INTENT(OUT),OPTIONAL :: KERROR,KREQUEST
CHARACTER(LEN=*),INTENT(IN),OPTIONAL :: CDSTRING

INTEGER(KIND=JPIM) :: IR,ISENDCOUNT,IRECVCOUNT
INTEGER(KIND=JPIM) :: IMP_TYPE
INTEGER(KIND=JPIM) :: ICOMM,IERROR,IPL_NUMPROC
INTEGER(KIND=JPIM) :: ITID
INTEGER(KIND=JPIM),ALLOCATABLE :: IRECVDISPL(:)

ITID = OML_MY_THREAD()
IF(PRESENT(KSENDCOUNT)) THEN
  ISENDCOUNT = KSENDCOUNT
ELSE
  ISENDCOUNT = SIZE(PSENDBUF)
  ISENDCOUNT = MAX(0,ISENDCOUNT)  ! Bug? on IBM
ENDIF
IRECVCOUNT = SIZE(PRECVBUF)

!--------- Preamble repeated for threadsafe--------------
IF(PRESENT(KCOMM)) THEN
  ICOMM=KCOMM
ELSE
  ICOMM=MPL_COMM_OML(ITID)
ENDIF

IF(ICOMM == MPL_COMM_OML(ITID)) THEN
  IPL_NUMPROC = MPL_NUMPROC
ELSE
  CALL MPI_COMM_SIZE(ICOMM,IPL_NUMPROC,IERROR)
ENDIF

ALLOCATE(IRECVDISPL(IPL_NUMPROC))
IF(PRESENT(KRECVDISPL)) THEN
  IRECVDISPL(:) = KRECVDISPL(:)
ELSE
  IRECVDISPL(:) = 0
  DO IR=2, IPL_NUMPROC
    IRECVDISPL(IR) = IRECVDISPL(IR-1) + KRECVCOUNTS(IR-1)
  ENDDO
ENDIF
IF(PRESENT(KMP_TYPE)) THEN
  IMP_TYPE=KMP_TYPE
ELSE
  IMP_TYPE=MPL_METHOD
ENDIF
IF(IMP_TYPE == JP_NON_BLOCKING_STANDARD .OR. IMP_TYPE == JP_NON_BLOCKING_BUFFERED) THEN
  IF(.NOT.PRESENT(KREQUEST)) CALL MPL_MESSAGE(CDMESSAGE='MPL_ALLGATHERV:  KREQUEST MISSING',LDABORT=LLABORT)
ENDIF
!--------- End of Preamble --------------


IF(IMP_TYPE == JP_BLOCKING_STANDARD .OR. IMP_TYPE == JP_BLOCKING_BUFFERED) THEN
  CALL MPI_ALLGATHERV(PSENDBUF(1),ISENDCOUNT,INT(MPI_REAL4),PRECVBUF(1),&
   & KRECVCOUNTS,IRECVDISPL,INT(MPI_REAL4),ICOMM,IERROR)
ELSEIF(IMP_TYPE == JP_NON_BLOCKING_STANDARD .OR. IMP_TYPE == JP_NON_BLOCKING_BUFFERED) THEN
  CALL MPI_IALLGATHERV(PSENDBUF(1),ISENDCOUNT,INT(MPI_REAL4),PRECVBUF(1),&
   & KRECVCOUNTS,IRECVDISPL,INT(MPI_REAL4),ICOMM,KREQUEST,IERROR)
ENDIF
IF(LMPLSTATS) THEN
  CALL MPL_SENDSTATS(ISENDCOUNT,INT(MPI_REAL4))
  CALL MPL_RECVSTATS(SUM(KRECVCOUNTS),INT(MPI_REAL4))
ENDIF

IF(MPL_OUTPUT > 1 )THEN
  WRITE(MPL_UNIT,'(A,5I8)') ' MPL_ALLGATHERV ',ISENDCOUNT,IRECVCOUNT,ICOMM
ENDIF
IF(PRESENT(KERROR)) THEN
  KERROR=IERROR
ELSE
  IF(IERROR /= 0 ) CALL MPL_MESSAGE(IERROR,'MPL_ALLGATHERV',&
   & CDSTRING,LDABORT=LLABORT)
ENDIF
DEALLOCATE(IRECVDISPL)

END SUBROUTINE MPL_ALLGATHERV_REAL4

SUBROUTINE MPL_ALLGATHERV_REAL8(PSENDBUF,PRECVBUF,KRECVCOUNTS,KSENDCOUNT,KRECVDISPL, &
                            & KMP_TYPE,KCOMM,KERROR,KREQUEST,CDSTRING)


#ifdef USE_8_BYTE_WORDS
  USE MPI4TO8, ONLY : &
    MPI_COMM_SIZE => MPI_COMM_SIZE8, MPI_ALLGATHERV => MPI_ALLGATHERV8
#endif



REAL(KIND=JPRD)            :: PSENDBUF(:)
REAL(KIND=JPRD)            :: PRECVBUF(:)
INTEGER(KIND=JPIM),INTENT(IN) :: KRECVCOUNTS(:)
INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL :: KSENDCOUNT
INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL :: KRECVDISPL(:),KCOMM,KMP_TYPE
INTEGER(KIND=JPIM),INTENT(OUT),OPTIONAL :: KERROR,KREQUEST
CHARACTER(LEN=*),INTENT(IN),OPTIONAL :: CDSTRING

INTEGER(KIND=JPIM) :: IR,ISENDCOUNT,IRECVCOUNT
INTEGER(KIND=JPIM) :: IMP_TYPE
INTEGER(KIND=JPIM) :: ICOMM,IERROR,IPL_NUMPROC
INTEGER(KIND=JPIM) :: ITID,J
INTEGER(KIND=JPIM),ALLOCATABLE :: IRECVDISPL(:)
ITID = OML_MY_THREAD()
IF(PRESENT(KSENDCOUNT)) THEN
  ISENDCOUNT = KSENDCOUNT
ELSE
  ISENDCOUNT = SIZE(PSENDBUF)
  ISENDCOUNT = MAX(0,ISENDCOUNT)  ! Bug? on IBM
ENDIF
IRECVCOUNT = SIZE(PRECVBUF)

!--------- Preamble repeated for threadsafe--------------
IF(PRESENT(KCOMM)) THEN
  ICOMM=KCOMM
ELSE
  ICOMM=MPL_COMM_OML(ITID)
ENDIF

IF(ICOMM == MPL_COMM_OML(ITID)) THEN
  IPL_NUMPROC = MPL_NUMPROC
ELSE
  CALL MPI_COMM_SIZE(ICOMM,IPL_NUMPROC,IERROR)
ENDIF

ALLOCATE(IRECVDISPL(IPL_NUMPROC))
IF(PRESENT(KRECVDISPL)) THEN
  DO J=1,MIN(SIZE(IRECVDISPL),SIZE(KRECVDISPL))
    IRECVDISPL(J) = KRECVDISPL(J)
  ENDDO
ELSE
  IRECVDISPL(:) = 0
  DO IR=2, IPL_NUMPROC
    IRECVDISPL(IR) = IRECVDISPL(IR-1) + KRECVCOUNTS(IR-1)
  ENDDO
ENDIF
IF(PRESENT(KMP_TYPE)) THEN
  IMP_TYPE=KMP_TYPE
ELSE
  IMP_TYPE=MPL_METHOD
ENDIF
IF(IMP_TYPE == JP_NON_BLOCKING_STANDARD .OR. IMP_TYPE == JP_NON_BLOCKING_BUFFERED) THEN
  IF(.NOT.PRESENT(KREQUEST)) CALL MPL_MESSAGE(CDMESSAGE='MPL_ALLGATHERV:  KREQUEST MISSING',LDABORT=LLABORT)
ENDIF
!!--------- End of Preamble --------------

IERROR=0

IF(IMP_TYPE == JP_BLOCKING_STANDARD .OR. IMP_TYPE == JP_BLOCKING_BUFFERED) THEN
  CALL MPI_ALLGATHERV(PSENDBUF(1),ISENDCOUNT,INT(MPI_REAL8),PRECVBUF(1),&
   & KRECVCOUNTS,IRECVDISPL,INT(MPI_REAL8),ICOMM,IERROR)
ELSEIF(IMP_TYPE == JP_NON_BLOCKING_STANDARD .OR. IMP_TYPE == JP_NON_BLOCKING_BUFFERED) THEN
  CALL MPI_IALLGATHERV(PSENDBUF(1),ISENDCOUNT,INT(MPI_REAL8),PRECVBUF(1),&
   & KRECVCOUNTS,IRECVDISPL,INT(MPI_REAL8),ICOMM,KREQUEST,IERROR)
ENDIF

IF(LMPLSTATS) THEN
  CALL MPL_SENDSTATS(ISENDCOUNT,INT(MPI_REAL8))
  CALL MPL_RECVSTATS(SUM(KRECVCOUNTS),INT(MPI_REAL8))
ENDIF

IF(MPL_OUTPUT > 1 )THEN
  WRITE(MPL_UNIT,'(A,5I8)') ' MPL_ALLGATHERV ',ISENDCOUNT,IRECVCOUNT,ICOMM
ENDIF
IF(PRESENT(KERROR)) THEN
  KERROR=IERROR
ELSE
  IF(IERROR /= 0 ) CALL MPL_MESSAGE(IERROR,'MPL_ALLGATHERV',CDSTRING,&
   & LDABORT=LLABORT)
ENDIF
DEALLOCATE(IRECVDISPL)

END SUBROUTINE MPL_ALLGATHERV_REAL8

SUBROUTINE MPL_ALLGATHERV_INT(KSENDBUF,KRECVBUF,KRECVCOUNTS,KSENDCOUNT,KRECVDISPL, &
                            & KMP_TYPE,KCOMM,KERROR,KREQUEST,CDSTRING)


#ifdef USE_8_BYTE_WORDS
  USE MPI4TO8, ONLY : &
    MPI_COMM_SIZE => MPI_COMM_SIZE8, MPI_ALLGATHERV => MPI_ALLGATHERV8
#endif



INTEGER(KIND=JPIM)         :: KSENDBUF(:)
INTEGER(KIND=JPIM)         :: KRECVBUF(:)
INTEGER(KIND=JPIM),INTENT(IN) :: KRECVCOUNTS(:)
INTEGER(KIND=JPIM),INTENT(IN), OPTIONAL :: KSENDCOUNT
INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL :: KRECVDISPL(:),KCOMM,KMP_TYPE
INTEGER(KIND=JPIM),INTENT(OUT),OPTIONAL :: KERROR,KREQUEST
CHARACTER(LEN=*),INTENT(IN),OPTIONAL :: CDSTRING

INTEGER(KIND=JPIM) :: IR,ISENDCOUNT,IRECVCOUNT
INTEGER(KIND=JPIM) :: IMP_TYPE
INTEGER(KIND=JPIM) :: ICOMM,IERROR,IPL_NUMPROC
INTEGER(KIND=JPIM) :: ITID
INTEGER(KIND=JPIM),ALLOCATABLE :: IRECVDISPL(:)
ITID = OML_MY_THREAD()
IF(PRESENT(KSENDCOUNT)) THEN
  ISENDCOUNT = KSENDCOUNT
ELSE
  ISENDCOUNT = SIZE(KSENDBUF)
  ISENDCOUNT = MAX(0,ISENDCOUNT)  ! Bug? on IBM
ENDIF
IRECVCOUNT = SIZE(KRECVBUF)

!--------- Preamble repeated for threadsafe--------------
IF(PRESENT(KCOMM)) THEN
  ICOMM=KCOMM
ELSE
  ICOMM=MPL_COMM_OML(ITID)
ENDIF

IF(ICOMM == MPL_COMM_OML(ITID)) THEN
  IPL_NUMPROC = MPL_NUMPROC
ELSE
  CALL MPI_COMM_SIZE(ICOMM,IPL_NUMPROC,IERROR)
ENDIF

ALLOCATE(IRECVDISPL(IPL_NUMPROC))
IF(PRESENT(KRECVDISPL)) THEN
  IRECVDISPL(:) = KRECVDISPL(:)
ELSE
  IRECVDISPL(:) = 0
  DO IR=2, IPL_NUMPROC
    IRECVDISPL(IR) = IRECVDISPL(IR-1) + KRECVCOUNTS(IR-1)
  ENDDO
ENDIF
IF(PRESENT(KMP_TYPE)) THEN
  IMP_TYPE=KMP_TYPE
ELSE
  IMP_TYPE=MPL_METHOD
ENDIF
IF(IMP_TYPE == JP_NON_BLOCKING_STANDARD .OR. IMP_TYPE == JP_NON_BLOCKING_BUFFERED) THEN
  IF(.NOT.PRESENT(KREQUEST)) CALL MPL_MESSAGE(CDMESSAGE='MPL_ALLGATHERV:  KREQUEST MISSING',LDABORT=LLABORT)
ENDIF
!--------- End of Preamble --------------

IERROR=0
IF(IMP_TYPE == JP_BLOCKING_STANDARD .OR. IMP_TYPE == JP_BLOCKING_BUFFERED) THEN
  CALL MPI_ALLGATHERV(KSENDBUF(1),ISENDCOUNT,INT(MPI_INTEGER),KRECVBUF(1),&
   & KRECVCOUNTS,IRECVDISPL,INT(MPI_INTEGER),ICOMM,IERROR)
ELSEIF(IMP_TYPE == JP_NON_BLOCKING_STANDARD .OR. IMP_TYPE == JP_NON_BLOCKING_BUFFERED) THEN
  CALL MPI_IALLGATHERV(KSENDBUF(1),ISENDCOUNT,INT(MPI_INTEGER),KRECVBUF(1),&
   & KRECVCOUNTS,IRECVDISPL,INT(MPI_INTEGER),ICOMM,KREQUEST,IERROR)
ENDIF

IF(LMPLSTATS) THEN
  CALL MPL_SENDSTATS(ISENDCOUNT,INT(MPI_INTEGER))
  CALL MPL_RECVSTATS(SUM(KRECVCOUNTS),INT(MPI_INTEGER))
ENDIF

IF(MPL_OUTPUT > 1 )THEN
  WRITE(MPL_UNIT,'(A,5I8)') ' MPL_ALLGATHERV ',ISENDCOUNT,IRECVCOUNT,ICOMM
ENDIF
IF(PRESENT(KERROR)) THEN
  KERROR=IERROR
ELSE
  IF(IERROR /= 0 ) CALL MPL_MESSAGE(IERROR,'MPL_ALLGATHERV',CDSTRING,LDABORT=LLABORT)
ENDIF
DEALLOCATE(IRECVDISPL)

END SUBROUTINE MPL_ALLGATHERV_INT

SUBROUTINE MPL_ALLGATHERV_INT_SCALAR(KSENDBUF,KRECVBUF,KRECVCOUNTS,KSENDCOUNT,KRECVDISPL, &
                            & KMP_TYPE,KCOMM,KERROR,KREQUEST,CDSTRING)


#ifdef USE_8_BYTE_WORDS
  USE MPI4TO8, ONLY : &
    MPI_COMM_SIZE => MPI_COMM_SIZE8, MPI_ALLGATHERV => MPI_ALLGATHERV8
#endif



INTEGER(KIND=JPIM)         :: KSENDBUF
INTEGER(KIND=JPIM)         :: KRECVBUF(:)
INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL :: KRECVCOUNTS(:)
INTEGER(KIND=JPIM),INTENT(IN), OPTIONAL :: KSENDCOUNT
INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL :: KRECVDISPL(:),KCOMM,KMP_TYPE
INTEGER(KIND=JPIM),INTENT(OUT),OPTIONAL :: KERROR,KREQUEST
CHARACTER(LEN=*),INTENT(IN),OPTIONAL :: CDSTRING

INTEGER(KIND=JPIM) :: IR,ISENDCOUNT,IRECVCOUNT
INTEGER(KIND=JPIM) :: IMP_TYPE
INTEGER(KIND=JPIM) :: IRECVCOUNTS(MPL_NUMPROC)
INTEGER(KIND=JPIM) :: ICOMM,IERROR,IPL_NUMPROC
INTEGER(KIND=JPIM) :: ITID
INTEGER(KIND=JPIM),ALLOCATABLE :: IRECVDISPL(:)
ITID = OML_MY_THREAD()
IF(PRESENT(KSENDCOUNT)) THEN
  ISENDCOUNT = KSENDCOUNT
ELSE
  ISENDCOUNT = 1
ENDIF
IRECVCOUNT = SIZE(KRECVBUF)
IF(PRESENT(KRECVCOUNTS)) THEN
  IRECVCOUNTS=KRECVCOUNTS
ELSE
  IRECVCOUNTS(:) = 1
ENDIF
!IF(PRESENT(KSENDCOUNT)) WRITE(*,*) 'ALLGATHERV_SCALAR', IRECVCOUNTS
!--------- Preamble repeated for threadsafe--------------
IF(PRESENT(KCOMM)) THEN
  ICOMM=KCOMM
ELSE
  ICOMM=MPL_COMM_OML(ITID)
ENDIF

IF(ICOMM == MPL_COMM_OML(ITID)) THEN
  IPL_NUMPROC = MPL_NUMPROC
ELSE
  CALL MPI_COMM_SIZE(ICOMM,IPL_NUMPROC,IERROR)
ENDIF

ALLOCATE(IRECVDISPL(IPL_NUMPROC))
IF(PRESENT(KRECVDISPL)) THEN
  IRECVDISPL(:) = KRECVDISPL(:)
ELSE
  IRECVDISPL(:) = 0
  DO IR=2, IPL_NUMPROC
    IRECVDISPL(IR) = IRECVDISPL(IR-1) + IRECVCOUNTS(IR-1)
  ENDDO
ENDIF
IF(PRESENT(KMP_TYPE)) THEN
  IMP_TYPE=KMP_TYPE
ELSE
  IMP_TYPE=MPL_METHOD
ENDIF
IF(IMP_TYPE == JP_NON_BLOCKING_STANDARD .OR. IMP_TYPE == JP_NON_BLOCKING_BUFFERED) THEN
  IF(.NOT.PRESENT(KREQUEST)) CALL MPL_MESSAGE(CDMESSAGE='MPL_ALLGATHERV:  KREQUEST MISSING',LDABORT=LLABORT)
ENDIF
!--------- End of Preamble --------------

IF(IMP_TYPE == JP_BLOCKING_STANDARD .OR. IMP_TYPE == JP_BLOCKING_BUFFERED) THEN
  CALL MPI_ALLGATHERV(KSENDBUF,ISENDCOUNT,INT(MPI_INTEGER),KRECVBUF(1),IRECVCOUNTS,&
   &  IRECVDISPL,INT(MPI_INTEGER),ICOMM,IERROR)
ELSEIF(IMP_TYPE == JP_NON_BLOCKING_STANDARD .OR. IMP_TYPE == JP_NON_BLOCKING_BUFFERED) THEN
  CALL MPI_IALLGATHERV(KSENDBUF,ISENDCOUNT,INT(MPI_INTEGER),KRECVBUF(1),IRECVCOUNTS,&
   &  IRECVDISPL,INT(MPI_INTEGER),ICOMM,KREQUEST,IERROR)
ENDIF
IF(LMPLSTATS) THEN
  CALL MPL_SENDSTATS(ISENDCOUNT,INT(MPI_INTEGER))
  CALL MPL_RECVSTATS(SUM(IRECVCOUNTS),INT(MPI_INTEGER))
ENDIF

IF(MPL_OUTPUT > 1 )THEN
  WRITE(MPL_UNIT,'(A,5I8)') ' MPL_ALLGATHERV ',ISENDCOUNT,IRECVCOUNT,ICOMM
ENDIF
IF(PRESENT(KERROR)) THEN
  KERROR=IERROR
ELSE
  IF(IERROR /= 0 ) CALL MPL_MESSAGE(IERROR,'MPL_ALLGATHERV',CDSTRING,LDABORT=LLABORT)
ENDIF
DEALLOCATE(IRECVDISPL)

END SUBROUTINE MPL_ALLGATHERV_INT_SCALAR

END MODULE MPL_ALLGATHERV_MOD

! (C) Copyright 2005- ECMWF.
! (C) Copyright 2013- Meteo-France.
! 
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!

MODULE MPL_IOINIT_MOD

!
!     Purpose.  initialise parallel IO environment
!     --------
!
!
!     Interface.
!     ----------
!        call mpl_ioinit(...)
!
!        Explicit arguments :
!        --------------------
!
!        input arguments:
!        kop     -  Style of parallel IO
!        kstrout - Number of output processors
!        output arguments:
!        kerror  - error code
!
!        Implicit arguments :
!        --------------------
!
!     Method.
!     -------
!     MPL supports 4 styles of MPIIO
!
!     kop = 1    -  Blocking, non collective, shared file pointer
!                   using MPI_FILE_WRITE_SHARED,
!                         MPI_FILE_READ_SHARED
!     kop = 2    -  Blocking, collective, ordered, shared file pointer
!                   using MPI_FILE_WRITE_ORDERED,
!                         MPI_FILE_READ_ORDERED
!     kop = 3    -  Non Blocking, non collective, shared file pointer
!                   using MPI_FILE_IWRITE_SHARED,
!                         MPI_FILE_IREAD_SHARED
!                   and MPI_WAIT
!     kop = 4    -  Non Blocking, collective, ordered, shared file pointer 
!                   using MPI_FILE_WRITE_ORDERED_BEGIN/END,
!                         MPI_FILE_READ_ORDERED_BEGIN/END
!
!     Externals.
!     ----------
!
!     Reference.
!     ----------
!        none yet
!
!     Author.
!     -------
!        G.Mozdzynski
!
!     Modifications.
!     --------------
!        Original : 2000-12-08 (Based on MPE_IOINIT)
!
!     -----------------------------------------------------------------
!

USE EC_PARKIND  ,ONLY : JPIM

USE MPL_MPIF
USE MPL_DATA_MODULE
USE MPL_MESSAGE_MOD

IMPLICIT NONE


INTEGER(KIND=JPIM) :: MPL_NUMIO
INTEGER(KIND=JPIM) :: MPL_IOP
INTEGER(KIND=JPIM) :: MPL_COMM_IO

PRIVATE
PUBLIC :: MPL_IOINIT, MPL_NUMIO, MPL_IOP, MPL_COMM_IO

CONTAINS

SUBROUTINE MPL_IOINIT(KOP,KSTROUT,KERROR)


#ifdef USE_8_BYTE_WORDS
  USE MPI4TO8, ONLY : &
    MPI_COMM_SPLIT => MPI_COMM_SPLIT8
#endif

INTEGER(KIND=JPIM),INTENT(IN) :: KOP,KSTROUT
INTEGER(KIND=JPIM),INTENT(OUT) :: KERROR
INTEGER(KIND=JPIM) :: COLOR,KEY

!
!     -----------------------------------------------------------------
!
!     1.    Preamble
!           --------

IF(KOP < 1 .OR. KOP > 4) THEN

  KERROR = -1
  RETURN

ENDIF

!
!     -----------------------------------------------------------------
!
!     2. Check Style of Operation and take appropriate action
!     -------------------------------------------------------

MPL_NUMIO = KSTROUT

MPL_IOP = KOP

IF(MPL_RANK <= KSTROUT) THEN
  COLOR = 1
ELSE
  COLOR = MPI_UNDEFINED
ENDIF

KEY = 0

CALL MPI_COMM_SPLIT(MPL_COMM,COLOR,KEY,MPL_COMM_IO,KERROR)

!
!
!     -----------------------------------------------------------------
RETURN
END SUBROUTINE MPL_IOINIT

END MODULE MPL_IOINIT_MOD

! (C) Copyright 2005- ECMWF.
! (C) Copyright 2013- Meteo-France.
! 
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!

MODULE MPL_ALLTOALLV_MOD

!**** MPL_ALLTOALLV - Everyone sends different data to everyone

!     Purpose.
!     --------
!     Interface to MPI_ALLTOALLV
 
!     The data may be REAL*8,or INTEGER

!**   Interface.
!     ----------
!        CALL MPL_ALLTOALLV

!        Input required arguments :
!        -------------------------
!           PSENDBUF -  buffer containing message
!                       (can be type  REAL*8 or INTEGER)
!           PRECVBUF -  buffer containing message
!                       (can be type REAL*8 or INTEGER)
!           KRECVCOUNTS-number of elements received from each process
!           KSENDCOUNTS-number of elements to be sent to each process

!        Input optional arguments :
!        -------------------------
!           KCOMM    -  Communicator number if different from MPI_COMM_WORLD 
!                       or from that established as the default 
!                       by an MPL communicator routine
!           KRECVDISPL -displacements in PRECVBUF at which to place 
!                       the incoming data
!           KSENDDISPL -displacements in PSENDBUF from which to send
!                       the data
!           KMP_TYPE -  buffering type (see MPL_BUFFER_METHOD)
!                       overrides value provided to MPL_BUFFER_METHOD
!           CDSTRING -  Character string for ABORT messages
!                       used when KERROR is not provided

!        Output optional arguments :
!        -------------------------
!           KREQUEST -  Communication request
!                       required when buffering type is non-blocking
!           KERROR   -  return error code.     If not supplied, 
!                       MPL_ALLTOALLV aborts when an error is detected.

!     Author.
!     -------
!       Y. Tremolet

!     Modifications.
!     --------------
!       Original: 02-03-21
!       Modified : 25-09-02 M.Hamrud - generalize
!      F. Vana  05-Mar-2015  Support for single precision
! ------------------------------------------------------------------

USE EC_PARKIND  ,ONLY : JPRD, JPIM, JPIB, JPRM
USE OML_MOD   ,ONLY : OML_MY_THREAD

USE MPL_MPIF
USE MPL_DATA_MODULE
USE MPL_MESSAGE_MOD
USE MPL_STATS_MOD
USE YOMMPLSTATS

IMPLICIT NONE
PRIVATE

LOGICAL :: LLABORT=.TRUE.
INTEGER(KIND=JPIM) :: ICOMM,IERROR,IPL_NUMPROC,IRECVCOUNT,ISENDCOUNT,IR,IMP_TYPE
LOGICAL :: LLSCALAR

INTERFACE MPL_ALLTOALLV
MODULE PROCEDURE MPL_ALLTOALLV_REAL8,MPL_ALLTOALLV_INTEGER,MPL_ALLTOALLV_REAL4
END INTERFACE

PUBLIC MPL_ALLTOALLV

CONTAINS
! ------------------------------------------------------------------

SUBROUTINE MPL_ALLTOALLV_PREAMB(KSENDCOUNTS,KISENDDISPL,&
 & KRECVCOUNTS,KIRECVDISPL,KSENDDISPL,KRECVDISPL,KMP_TYPE,KCOMM,CDSTRING)


#ifdef USE_8_BYTE_WORDS
  USE MPI4TO8, ONLY : &
    MPI_COMM_SIZE => MPI_COMM_SIZE8
#endif


INTEGER(KIND=JPIM),INTENT(IN) :: KRECVCOUNTS(:),KSENDCOUNTS(:)
INTEGER(KIND=JPIM),INTENT(OUT) :: KISENDDISPL(:),KIRECVDISPL(:)
INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL :: KSENDDISPL(:),KRECVDISPL(:),KCOMM,KMP_TYPE
CHARACTER(LEN=*),INTENT(IN),OPTIONAL :: CDSTRING
INTEGER(KIND=JPIM) :: ITID,J
ITID = OML_MY_THREAD()
IF(MPL_NUMPROC < 1) CALL MPL_MESSAGE( &
  & CDMESSAGE='MPL_ALLTOALLV: MPL NOT INITIALISED ',LDABORT=LLABORT)
 
IF(PRESENT(KCOMM)) THEN
  ICOMM=KCOMM
ELSE
  ICOMM=MPL_COMM_OML(ITID)
ENDIF

IF(PRESENT(KMP_TYPE)) THEN
  IMP_TYPE=KMP_TYPE
ELSE
  IMP_TYPE=MPL_METHOD
ENDIF

IF(ICOMM == MPL_COMM_OML(ITID)) THEN
  IPL_NUMPROC = MPL_NUMPROC
ELSE
  CALL MPI_COMM_SIZE(ICOMM,IPL_NUMPROC,IERROR)
ENDIF

IF(SIZE(KRECVCOUNTS)  < IPL_NUMPROC) THEN
  WRITE(MPL_ERRUNIT,*)'MPL_ALLTOALLV: ERROR KRECVCOUNTS dimension=',&
   & SIZE(KRECVCOUNTS)
  CALL MPL_MESSAGE(CDMESSAGE=&
   & 'MPL_ALLTOALLV: ERROR KRECVCOUNTS dimension is wrong',LDABORT=LLABORT)
ENDIF

IF(SIZE(KSENDCOUNTS)  < IPL_NUMPROC) THEN
  WRITE(MPL_ERRUNIT,*)'MPL_ALLTOALLV: ERROR KSENDCOUNTS dimension=',&
   & SIZE(KSENDCOUNTS)
  CALL MPL_MESSAGE(CDMESSAGE=&
   & 'MPL_ALLTOALLV: ERROR KSENDCOUNTS dimension is wrong',LDABORT=LLABORT)
ENDIF

IF(PRESENT(KRECVDISPL)) THEN
  DO J=1,MIN(SIZE(KRECVDISPL),SIZE(KIRECVDISPL))
    KIRECVDISPL(J) = KRECVDISPL(J)
  ENDDO
ELSE
  KIRECVDISPL(:) = 0
  IF(LLSCALAR) THEN
    DO IR=2, IPL_NUMPROC
      KIRECVDISPL(IR) = KIRECVDISPL(IR-1) + 1
    ENDDO
  ELSE
    DO IR=2, IPL_NUMPROC
      KIRECVDISPL(IR) = KIRECVDISPL(IR-1) + KRECVCOUNTS(IR-1)
    ENDDO
  ENDIF
ENDIF

DO IR=1, IPL_NUMPROC
  IF(KIRECVDISPL(IR) < 0 .OR. KRECVCOUNTS(IR) < 0) THEN
    WRITE(MPL_ERRUNIT,'(A,4I10)')'MPL_ALLTOALLV: RECV.. < 0 ',&
     & IR,KIRECVDISPL(IR),KRECVCOUNTS(IR)
    CALL MPL_MESSAGE(IERROR,'MPL_ALLTOALLV',CDSTRING,LDABORT=LLABORT)
  ENDIF
  IF(KIRECVDISPL(IR)+KRECVCOUNTS(IR) > IRECVCOUNT) THEN
    WRITE(MPL_ERRUNIT,'(A,4I10)')'MPL_ALLTOALLV:RECV BUFFER TOO SMALL  ', &
     & IR,KIRECVDISPL(IR),KRECVCOUNTS(IR),IRECVCOUNT
    CALL MPL_MESSAGE(IERROR,'MPL_ALLTOALLV',CDSTRING,LDABORT=LLABORT)
  ENDIF
ENDDO

IF(PRESENT(KSENDDISPL)) THEN
  DO J=1,MIN(SIZE(KSENDDISPL),SIZE(KISENDDISPL))
    KISENDDISPL(J) = KSENDDISPL(J)
  ENDDO
ELSE
  KISENDDISPL(:) = 0
  IF(LLSCALAR) THEN
    DO IR=2, IPL_NUMPROC
      KISENDDISPL(IR) = KISENDDISPL(IR-1) + 1
    ENDDO
  ELSE
    DO IR=2, IPL_NUMPROC
      KISENDDISPL(IR) = KISENDDISPL(IR-1) + KSENDCOUNTS(IR-1)
    ENDDO
  ENDIF
ENDIF
DO IR=1, IPL_NUMPROC
  IF(KISENDDISPL(IR) < 0 .OR. KSENDCOUNTS(IR) < 0) THEN
    WRITE(MPL_ERRUNIT,'(A,4I10)')'MPL_ALLTOALLV:SEND.. <0 ',&
     & IR,KISENDDISPL(IR),KSENDCOUNTS(IR)
    CALL MPL_MESSAGE(IERROR,'MPL_ALLTOALLV',CDSTRING,LDABORT=LLABORT)
  ENDIF
  IF(KISENDDISPL(IR)+KSENDCOUNTS(IR) > ISENDCOUNT) THEN
    WRITE(MPL_ERRUNIT,'(A,4I10)')'MPL_ALLTOALLV:SEND BUFFER TOO SMALL  ', &
     & IR,KISENDDISPL(IR),KSENDCOUNTS(IR),ISENDCOUNT
    CALL MPL_MESSAGE(IERROR,'MPL_ALLTOALLV',CDSTRING,LDABORT=LLABORT)
  ENDIF
ENDDO

END SUBROUTINE MPL_ALLTOALLV_PREAMB

SUBROUTINE MPL_ALLTOALLV_REAL8(PSENDBUF,KSENDCOUNTS,PRECVBUF,KRECVCOUNTS,&
 &KSENDDISPL,KRECVDISPL,KMP_TYPE,KCOMM,KERROR,KREQUEST,CDSTRING)


#ifdef USE_8_BYTE_WORDS
  USE MPI4TO8, ONLY : &
    MPI_ALLTOALLV => MPI_ALLTOALLV8
#endif


IMPLICIT NONE
INTEGER(KIND=JPIM), INTENT(IN) :: KSENDCOUNTS(:), KRECVCOUNTS(:)
REAL(KIND=JPRD), INTENT(IN)  :: PSENDBUF(:)
REAL(KIND=JPRD), INTENT(OUT) :: PRECVBUF(:)
INTEGER(KIND=JPIM), INTENT(IN),OPTIONAL :: KSENDDISPL(:), KRECVDISPL(:), KCOMM ,KMP_TYPE
CHARACTER(LEN=*),INTENT(IN),OPTIONAL :: CDSTRING
INTEGER(KIND=JPIM),INTENT(OUT),OPTIONAL :: KREQUEST,KERROR

INTEGER(KIND=JPIM) :: IRECVDISPL(MPL_NUMPROC),ISENDDISPL(MPL_NUMPROC)

ISENDCOUNT=SIZE(PSENDBUF)
IRECVCOUNT=SIZE(PRECVBUF)

#ifndef NAG
IF (ISENDCOUNT > 0) THEN
  IF( (LOC(PSENDBUF(UBOUND(PSENDBUF,1))) - LOC(PSENDBUF(LBOUND(PSENDBUF,1)))) /= 8_JPIB*(ISENDCOUNT - 1) .AND. &
    & ISENDCOUNT > 0 ) THEN
    CALL MPL_MESSAGE(CDMESSAGE='MPL_ALLTOALLV: SENDBUF NOT CONTIGUOUS ',LDABORT=LLABORT)
  ENDIF
ENDIF

IF (IRECVCOUNT > 0) THEN
  IF( (LOC(PRECVBUF(UBOUND(PRECVBUF,1))) - LOC(PRECVBUF(LBOUND(PRECVBUF,1)))) /= 8_JPIB*(IRECVCOUNT - 1) .AND. &
    & IRECVCOUNT > 0 ) THEN
    CALL MPL_MESSAGE(CDMESSAGE='MPL_ALLTOALLV: RECVBUF NOT CONTIGUOUS ',LDABORT=LLABORT)
  ENDIF
ENDIF
#endif

LLSCALAR=.FALSE.

IERROR=0
CALL MPL_ALLTOALLV_PREAMB(KSENDCOUNTS,ISENDDISPL,&
 & KRECVCOUNTS,IRECVDISPL,KSENDDISPL,KRECVDISPL,KMP_TYPE,KCOMM,CDSTRING)
IF(IMP_TYPE == JP_BLOCKING_STANDARD .OR. IMP_TYPE == JP_BLOCKING_BUFFERED) THEN
  CALL MPI_ALLTOALLV(PSENDBUF(:),KSENDCOUNTS,ISENDDISPL,INT(MPI_REAL8), &
   & PRECVBUF(:),KRECVCOUNTS,IRECVDISPL,INT(MPI_REAL8),ICOMM,IERROR)
ELSEIF(IMP_TYPE == JP_NON_BLOCKING_STANDARD .OR. IMP_TYPE == JP_NON_BLOCKING_BUFFERED) THEN
  IF(.NOT.PRESENT(KREQUEST)) CALL MPL_MESSAGE(KERROR,'MPL_ALLTOALLV',' KREQUEST MISSING',LDABORT=LLABORT)
  CALL MPI_IALLTOALLV(PSENDBUF(:),KSENDCOUNTS,ISENDDISPL,INT(MPI_REAL8), &
   & PRECVBUF(:),KRECVCOUNTS,IRECVDISPL,INT(MPI_REAL8),ICOMM,KREQUEST,IERROR)
ELSE
  IF(PRESENT(KERROR)) THEN
    IERROR=1
  ELSE
    CALL MPL_MESSAGE(KERROR,'MPL_ALLTOALLV',' INVALID METHOD',LDABORT=LLABORT)
  ENDIF
ENDIF

IF(PRESENT(KERROR)) THEN
  KERROR=IERROR
ELSE
  IF (IERROR/=0) CALL MPL_MESSAGE(IERROR,'ERROR IN MPL_ALLTOALLV',&
   &LDABORT=LLABORT)
ENDIF

IF(LMPLSTATS) THEN
  CALL MPL_SENDSTATS(SUM(KSENDCOUNTS),INT(MPI_REAL8))
  CALL MPL_RECVSTATS(SUM(KRECVCOUNTS),INT(MPI_REAL8))
ENDIF

END SUBROUTINE MPL_ALLTOALLV_REAL8

SUBROUTINE MPL_ALLTOALLV_REAL4(PSENDBUF,KSENDCOUNTS,PRECVBUF,KRECVCOUNTS,&
 &KSENDDISPL,KRECVDISPL,KMP_TYPE,KCOMM,KERROR,KREQUEST,CDSTRING)


#ifdef USE_8_BYTE_WORDS
  USE MPI4TO8, ONLY : &
    MPI_ALLTOALLV => MPI_ALLTOALLV8
#endif


IMPLICIT NONE
INTEGER(KIND=JPIM), INTENT(IN) :: KSENDCOUNTS(:), KRECVCOUNTS(:)
REAL(KIND=JPRM), INTENT(IN)  :: PSENDBUF(:)
REAL(KIND=JPRM), INTENT(OUT) :: PRECVBUF(:)
INTEGER(KIND=JPIM), INTENT(IN),OPTIONAL :: KSENDDISPL(:), KRECVDISPL(:), KCOMM  ,KMP_TYPE
CHARACTER(LEN=*),INTENT(IN),OPTIONAL :: CDSTRING
INTEGER(KIND=JPIM),INTENT(OUT),OPTIONAL :: KREQUEST,KERROR

INTEGER(KIND=JPIM) :: IRECVDISPL(MPL_NUMPROC),ISENDDISPL(MPL_NUMPROC)

ISENDCOUNT=SIZE(PSENDBUF)
IRECVCOUNT=SIZE(PRECVBUF)

#ifndef NAG
IF (ISENDCOUNT > 0) THEN
  IF( (LOC(PSENDBUF(UBOUND(PSENDBUF,1))) - LOC(PSENDBUF(LBOUND(PSENDBUF,1)))) /= 4_JPIB*(ISENDCOUNT - 1) ) THEN
    CALL MPL_MESSAGE(CDMESSAGE='MPL_ALLTOALLV: SENDBUF NOT CONTIGUOUS ',LDABORT=LLABORT)
  ENDIF
ENDIF

IF (IRECVCOUNT > 0) THEN
  IF( (LOC(PRECVBUF(UBOUND(PRECVBUF,1))) - LOC(PRECVBUF(LBOUND(PRECVBUF,1)))) /= 4_JPIB*(IRECVCOUNT - 1) ) THEN
    CALL MPL_MESSAGE(CDMESSAGE='MPL_ALLTOALLV: RECVBUF NOT CONTIGUOUS ',LDABORT=LLABORT)
  ENDIF
ENDIF
#endif

LLSCALAR=.FALSE.

IERROR=0
CALL MPL_ALLTOALLV_PREAMB(KSENDCOUNTS,ISENDDISPL,&
 & KRECVCOUNTS,IRECVDISPL,KSENDDISPL,KRECVDISPL,KMP_TYPE,KCOMM,CDSTRING)
IF(IMP_TYPE == JP_BLOCKING_STANDARD .OR. IMP_TYPE == JP_BLOCKING_BUFFERED) THEN
  CALL MPI_ALLTOALLV(PSENDBUF(:),KSENDCOUNTS,ISENDDISPL,INT(MPI_REAL4), &
   & PRECVBUF(:),KRECVCOUNTS,IRECVDISPL,INT(MPI_REAL4),ICOMM,IERROR)
ELSEIF(IMP_TYPE == JP_NON_BLOCKING_STANDARD .OR. IMP_TYPE == JP_NON_BLOCKING_BUFFERED) THEN
  CALL MPI_IALLTOALLV(PSENDBUF(:),KSENDCOUNTS,ISENDDISPL,INT(MPI_REAL4), &
   & PRECVBUF(:),KRECVCOUNTS,IRECVDISPL,INT(MPI_REAL4),ICOMM,KREQUEST,IERROR)
ELSE
  IF(PRESENT(KERROR)) THEN
    IERROR=1
  ELSE
    CALL MPL_MESSAGE(KERROR,'MPL_ALLTOALLV',' INVALID METHOD',LDABORT=LLABORT)
  ENDIF
ENDIF

IF(PRESENT(KERROR)) THEN
  KERROR=IERROR
ELSE
  IF (IERROR/=0) CALL MPL_MESSAGE(IERROR,'ERROR IN MPL_ALLTOALLV',&
   &LDABORT=LLABORT)
ENDIF

IF(LMPLSTATS) THEN
  CALL MPL_SENDSTATS(SUM(KSENDCOUNTS),INT(MPI_REAL4))
  CALL MPL_RECVSTATS(SUM(KRECVCOUNTS),INT(MPI_REAL4))
ENDIF

END SUBROUTINE MPL_ALLTOALLV_REAL4


SUBROUTINE MPL_ALLTOALLV_INTEGER(KSENDBUF,KSENDCOUNTS,KRECVBUF,KRECVCOUNTS,&
 &KSENDDISPL,KRECVDISPL,KMP_TYPE,KCOMM,KERROR,KREQUEST,CDSTRING)


#ifdef USE_8_BYTE_WORDS
  USE MPI4TO8, ONLY : &
    MPI_ALLTOALLV => MPI_ALLTOALLV8
#endif


IMPLICIT NONE
INTEGER(KIND=JPIM), INTENT(IN) :: KSENDCOUNTS(:), KRECVCOUNTS(:)
INTEGER(KIND=JPIM), INTENT(IN)  :: KSENDBUF(:)
INTEGER(KIND=JPIM), INTENT(OUT) :: KRECVBUF(:)
INTEGER(KIND=JPIM), INTENT(IN),OPTIONAL :: KSENDDISPL(:), KRECVDISPL(:), KCOMM,KMP_TYPE 
CHARACTER(LEN=*),INTENT(IN),OPTIONAL :: CDSTRING
INTEGER(KIND=JPIM),INTENT(OUT),OPTIONAL :: KREQUEST,KERROR

INTEGER(KIND=JPIM) :: IRECVDISPL(MPL_NUMPROC),ISENDDISPL(MPL_NUMPROC)

ISENDCOUNT=SIZE(KSENDBUF)
IRECVCOUNT=SIZE(KRECVBUF)

#ifndef NAG
IF (ISENDCOUNT > 0) THEN
  IF( (LOC(KSENDBUF(UBOUND(KSENDBUF,1))) - LOC(KSENDBUF(LBOUND(KSENDBUF,1)))) /= 4_JPIB*(ISENDCOUNT - 1) ) THEN
    CALL MPL_MESSAGE(CDMESSAGE='MPL_ALLTOALLV: SENDBUF NOT CONTIGUOUS ',LDABORT=LLABORT)
  ENDIF
ENDIF

IF (IRECVCOUNT > 0) THEN
  IF( (LOC(KRECVBUF(UBOUND(KRECVBUF,1))) - LOC(KRECVBUF(LBOUND(KRECVBUF,1)))) /= 4_JPIB*(IRECVCOUNT - 1) ) THEN
    CALL MPL_MESSAGE(CDMESSAGE='MPL_ALLTOALLV: RECVBUF NOT CONTIGUOUS ',LDABORT=LLABORT)
  ENDIF
ENDIF
#endif

LLSCALAR=.FALSE.

IERROR=0
CALL MPL_ALLTOALLV_PREAMB(KSENDCOUNTS,ISENDDISPL,&
 & KRECVCOUNTS,IRECVDISPL,KSENDDISPL,KRECVDISPL,KMP_TYPE,KCOMM,CDSTRING)
IF(IMP_TYPE == JP_BLOCKING_STANDARD .OR. IMP_TYPE == JP_BLOCKING_BUFFERED) THEN
  CALL MPI_ALLTOALLV(KSENDBUF(1),KSENDCOUNTS,ISENDDISPL,INT(MPI_INTEGER), &
   & KRECVBUF(1),KRECVCOUNTS,IRECVDISPL,INT(MPI_INTEGER),ICOMM,IERROR)
ELSEIF(IMP_TYPE == JP_NON_BLOCKING_STANDARD .OR. IMP_TYPE == JP_NON_BLOCKING_BUFFERED) THEN
  IF(.NOT.PRESENT(KREQUEST)) CALL MPL_MESSAGE(KERROR,'MPL_ALLTOALLV',' KREQUEST MISSING',LDABORT=LLABORT)
  CALL MPI_IALLTOALLV(KSENDBUF(1),KSENDCOUNTS,ISENDDISPL,INT(MPI_INTEGER), &
   & KRECVBUF(1),KRECVCOUNTS,IRECVDISPL,INT(MPI_INTEGER),ICOMM,KREQUEST,IERROR)
ELSE
  IF(PRESENT(KERROR)) THEN
    IERROR=1
  ELSE
    CALL MPL_MESSAGE(KERROR,'MPL_ALLTOALLV',' INVALID METHOD',LDABORT=LLABORT)
  ENDIF
ENDIF

IF(PRESENT(KERROR)) THEN
  KERROR=IERROR
ELSE
  IF (IERROR/=0) CALL MPL_MESSAGE(IERROR,'ERROR IN MPL_ALLTOALLV',&
   &LDABORT=LLABORT)
ENDIF

IF(LMPLSTATS) THEN
  CALL MPL_SENDSTATS(SUM(KSENDCOUNTS),INT(MPI_INTEGER))
  CALL MPL_RECVSTATS(SUM(KRECVCOUNTS),INT(MPI_INTEGER))
ENDIF

END SUBROUTINE MPL_ALLTOALLV_INTEGER

! ------------------------------------------------------------------

END MODULE MPL_ALLTOALLV_MOD

! (C) Copyright 2024- ECMWF.
!
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
!
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.

program drhook_roctx_mismatched_regions

use yomhook, only : jphook, dr_hook

implicit none

real(jphook) :: zhook_handle, zhook_handle_a
integer :: a, b
call dr_hook('drhook_roctx_mismatched_regions', 0, zhook_handle)

! Region A Start
call dr_hook('a', 0, zhook_handle_a)
a = 1

! Region A Stop
call dr_hook('this_is_not_a!', 1, zhook_handle_a)

call dr_hook('drhook_roctx_mismatched_regions', 1, zhook_handle)

end program drhook_roctx_mismatched_regions

program fiat_test_drhook_counters
  use oml_mod    ,only : oml_max_threads
  use mpl_module, only : mpl_init, mpl_end, mpl_nproc, mpl_myrank
  use yomhook,    only : LHOOK,DR_HOOK,JPHOOK,dr_hook_init,dr_hook_end
  use test_drhook_counters_stream_mod, only : stream_combinations
  use test_drhook_counters_gemm_mod,   only : gemm_combinations
  use ec_env_mod, only : ec_setenv

  implicit none
  logical :: luse_mpi = .true.
  logical :: lsmall_problem_size = .false.
  integer :: myproc,nproc
  integer :: verbosity = 0

  REAL(KIND=JPHOOK) :: ZHOOK_HANDLE
  
  luse_mpi = detect_mpirun()
  lsmall_problem_size = detect_FIAT_UNIT_TEST()

  if (luse_mpi) then
     call mpl_init(ldinfo=(verbosity>=1))
     nproc  = mpl_nproc()
     myproc = mpl_myrank()
  else
     nproc  = 1
     myproc = 1
  endif

  if (myproc.eq.1) write(6,*)'Starting Tasks=',nproc,'threads=',oml_max_threads()

  call ec_setenv("DR_HOOK",        "1",        overwrite=.true.)
  call ec_setenv("DR_HOOK_OPT",    "COUNTERS", overwrite=.true.)

  call dr_hook_init()

  IF (LHOOK) CALL DR_HOOK('MAIN',0,ZHOOK_HANDLE)

  if (myproc.eq.1) write(6,*) "================================================= BENCHMARK STREAM START"
  if (lsmall_problem_size) then
    call stream_combinations(int(1024*32,kind=8))
  else
    call stream_combinations()
  endif
  if (myproc.eq.1) write(6,*) "================================================= BENCHMARK STREAM END"

  if (myproc.eq.1) write(6,*) "================================================= BENCHMARK GEMM START"
  if (lsmall_problem_size) then
    call gemm_combinations(int(250,kind=8))
  else
    call gemm_combinations()
  endif
  write(6,*) "================================================= BENCHMARK GEMM END"
  
  IF (LHOOK) CALL DR_HOOK('MAIN',1,ZHOOK_HANDLE)

  call dr_hook_end()

  if (luse_mpi) then
     call mpl_end(ldmeminfo=.false.)
  endif
  if (myproc.eq.1) write(6,*)'Completed'
contains
  function detect_mpirun() result(lmpi_required)
  logical :: lmpi_required
  integer :: ilen
  integer, parameter :: nvars = 5
  character(len=32), dimension(nvars) :: cmpirun_detect
  character(len=4) :: clenv_dr_hook_assert_mpi_initialized
  integer :: ivar
  lmpi_required = .false.
#if defined(NOMPI)
  return
#endif 
  ! Environment variables that are set when mpirun, srun, aprun, ... are used
  cmpirun_detect(1) = 'OMPI_COMM_WORLD_SIZE'  ! openmpi
  cmpirun_detect(2) = 'ALPS_APP_PE'           ! cray pe
  cmpirun_detect(3) = 'PMI_SIZE'              ! intel
  cmpirun_detect(4) = 'SLURM_NTASKS'          ! slurm
  cmpirun_detect(5) = 'FIAT_USE_MPI'          ! forced

  do ivar = 1, nvars
    call get_environment_variable(name=trim(cmpirun_detect(ivar)), length=ilen)
    if (ilen > 0) then
      lmpi_required = .true.
      exit ! break
    endif
  enddo
end function

function detect_FIAT_UNIT_TEST() result(lunit_test)
  logical :: lunit_test
  integer :: ilen
  lunit_test = .false.
  call get_environment_variable(name='FIAT_UNIT_TEST', length=ilen)
  if (ilen > 0) then
    lunit_test = .true.
  endif
end function

end program

! (C) Copyright 2005- ECMWF.
! 
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!

MODULE BYTES_IO_MOD

!**** Interface to BYTES_IO

!     Purpose.
!     --------
!     Fortran 90 Interface to calling byte IO 

!     Author.
!     -------
!        W.Deconinck and M.Hamrud     ECMWF

!     Modifications.
!     --------------
!        Original: 2016-01-28

!     ------------------------------------------------------------------

USE EC_PARKIND , ONLY : JPRD, JPIM, JPIB, JPRM
USE YOMHOOK  , ONLY : LHOOK, DR_HOOK, JPHOOK
USE MPL_MODULE, ONLY : MPL_ABORT

IMPLICIT NONE

PRIVATE :: JPRD, JPIM, JPIB, JPRM
PRIVATE :: LHOOK, DR_HOOK
PRIVATE :: MPL_ABORT

PRIVATE

INTERFACE BYTES_IO_READ
MODULE PROCEDURE BYTES_IO_READ_JPIM_INT
MODULE PROCEDURE BYTES_IO_READ_JPIM_INT_ARRAY
MODULE PROCEDURE BYTES_IO_READ_JPIM_REAL4
MODULE PROCEDURE BYTES_IO_READ_JPIM_REAL4_ARRAY
MODULE PROCEDURE BYTES_IO_READ_JPIM_REAL4_ARRAY2
MODULE PROCEDURE BYTES_IO_READ_JPIM_REAL8
MODULE PROCEDURE BYTES_IO_READ_JPIM_REAL8_ARRAY
MODULE PROCEDURE BYTES_IO_READ_JPIM_REAL8_ARRAY2
MODULE PROCEDURE BYTES_IO_READ_JPIM_CHAR_ARRAY

MODULE PROCEDURE BYTES_IO_READ_JPIB_INT
MODULE PROCEDURE BYTES_IO_READ_JPIB_INT_ARRAY
MODULE PROCEDURE BYTES_IO_READ_JPIB_REAL4
MODULE PROCEDURE BYTES_IO_READ_JPIB_REAL4_ARRAY
MODULE PROCEDURE BYTES_IO_READ_JPIB_REAL4_ARRAY2
MODULE PROCEDURE BYTES_IO_READ_JPIB_REAL8
MODULE PROCEDURE BYTES_IO_READ_JPIB_REAL8_ARRAY
MODULE PROCEDURE BYTES_IO_READ_JPIB_REAL8_ARRAY2
MODULE PROCEDURE BYTES_IO_READ_JPIB_CHAR_ARRAY
END INTERFACE

INTERFACE BYTES_IO_WRITE
MODULE PROCEDURE BYTES_IO_WRITE_JPIM_INT
MODULE PROCEDURE BYTES_IO_WRITE_JPIM_INT_ARRAY
MODULE PROCEDURE BYTES_IO_WRITE_JPIM_REAL4
MODULE PROCEDURE BYTES_IO_WRITE_JPIM_REAL4_ARRAY
MODULE PROCEDURE BYTES_IO_WRITE_JPIM_REAL4_ARRAY2
MODULE PROCEDURE BYTES_IO_WRITE_JPIM_REAL8
MODULE PROCEDURE BYTES_IO_WRITE_JPIM_REAL8_ARRAY
MODULE PROCEDURE BYTES_IO_WRITE_JPIM_REAL8_ARRAY2
MODULE PROCEDURE BYTES_IO_WRITE_JPIM_CHAR_ARRAY

MODULE PROCEDURE BYTES_IO_WRITE_JPIB_INT
MODULE PROCEDURE BYTES_IO_WRITE_JPIB_INT_ARRAY
MODULE PROCEDURE BYTES_IO_WRITE_JPIB_REAL4
MODULE PROCEDURE BYTES_IO_WRITE_JPIB_REAL4_ARRAY
MODULE PROCEDURE BYTES_IO_WRITE_JPIB_REAL4_ARRAY2
MODULE PROCEDURE BYTES_IO_WRITE_JPIB_REAL8
MODULE PROCEDURE BYTES_IO_WRITE_JPIB_REAL8_ARRAY
MODULE PROCEDURE BYTES_IO_WRITE_JPIB_REAL8_ARRAY2
MODULE PROCEDURE BYTES_IO_WRITE_JPIB_CHAR_ARRAY
END INTERFACE

PUBLIC :: BYTES_IO_OPEN
PUBLIC :: BYTES_IO_CLOSE
PUBLIC :: BYTES_IO_WRITE
PUBLIC :: BYTES_IO_READ
PUBLIC :: BYTES_IO_SEEK
PUBLIC :: BYTES_IO_TELL
PUBLIC :: BYTES_IO_FLUSH

INTEGER, PARAMETER, PUBLIC :: JPBYTES_IO_SUCCESS=0
INTEGER, PARAMETER :: JPBYTES_IO_COULD_NOT_OPEN_FILE=-1
INTEGER, PARAMETER :: JPBYTES_IO_COULD_NOT_CLOSE_FILE=-1
INTEGER, PARAMETER :: JPBYTES_IO_INVALID_FILE_NAME=-2
INTEGER, PARAMETER :: JPBYTES_IO_INVALID_OPEN_MODE=-3
INTEGER, PARAMETER :: JPBYTES_IO_END_OF_FILE=-1
INTEGER, PARAMETER :: JPBYTES_IO_SEEK_ERROR=-2
INTEGER, PARAMETER :: JPBYTES_IO_READ_JPIM_ERROR=-2
INTEGER, PARAMETER :: JPBYTES_IO_WRITE_JPIM_ERROR=-1

CONTAINS


SUBROUTINE BYTES_IO_OPEN(KFILE,CDPATH,CDMODE,KRET)
INTEGER(KIND=JPIM),INTENT(OUT)  :: KFILE
CHARACTER(LEN=*)  ,INTENT(IN)   :: CDPATH
CHARACTER(LEN=1)  ,INTENT(IN)   :: CDMODE
INTEGER(KIND=JPIM),OPTIONAL,INTENT(OUT) :: KRET
INTEGER(KIND=JPIM) :: IRET
REAL(KIND=JPHOOK) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('BYTES_IO:BYTES_IO_OPEN',0,ZHOOK_HANDLE)
CALL C_BYTES_IO_OPEN(KFILE,CDPATH,CDMODE,IRET)
IF(PRESENT(KRET)) THEN
  KRET = IRET
ELSEIF (IRET < JPBYTES_IO_SUCCESS) THEN
  WRITE(0,*) 'BYTES_IO ',TRIM(CDPATH),' FAILED',IRET
  CALL MPL_ABORT('BYTES_IO_OPEN FAILED')
ENDIF
IF (LHOOK) CALL DR_HOOK('BYTES_IO:BYTES_IO_OPEN',1,ZHOOK_HANDLE)
END SUBROUTINE BYTES_IO_OPEN

SUBROUTINE BYTES_IO_CLOSE(KFILE,KRET)
INTEGER(KIND=JPIM),INTENT(IN)  :: KFILE
INTEGER(KIND=JPIM),OPTIONAL,INTENT(OUT) :: KRET
INTEGER(KIND=JPIM) :: IRET
REAL(KIND=JPHOOK) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('BYTES_IO:BYTES_IO_CLOSE',0,ZHOOK_HANDLE)
CALL C_BYTES_IO_CLOSE(KFILE,IRET)
IF(PRESENT(KRET)) THEN
  KRET = IRET
ELSEIF (IRET < JPBYTES_IO_SUCCESS) THEN
  WRITE(0,*) 'BYTES_IO_CLOSE ',KFILE,' FAILED',IRET
  CALL MPL_ABORT('BYTES_IO_CLOSE FAILED')
ENDIF
IF (LHOOK) CALL DR_HOOK('BYTES_IO:BYTES_IO_CLOSE',1,ZHOOK_HANDLE)
END SUBROUTINE BYTES_IO_CLOSE

SUBROUTINE BYTES_IO_FLUSH(KFILE)
  INTEGER(KIND=JPIM),INTENT(IN)  :: KFILE
  REAL(KIND=JPHOOK) :: ZHOOK_HANDLE
  IF (LHOOK) CALL DR_HOOK('BYTES_IO:BYTES_IO_FLUSH',0,ZHOOK_HANDLE)
  CALL C_BYTES_IO_FLUSH(KFILE)
  IF (LHOOK) CALL DR_HOOK('BYTES_IO:BYTES_IO_FLUSH',1,ZHOOK_HANDLE)
END SUBROUTINE BYTES_IO_FLUSH

SUBROUTINE BYTES_IO_SEEK(KFILE,KOFFSET,KWHENCE,KRET)
INTEGER(KIND=JPIM),INTENT(IN) :: KFILE
INTEGER(KIND=JPIM),INTENT(IN) :: KOFFSET 
INTEGER(KIND=JPIM),INTENT(IN) :: KWHENCE
INTEGER(KIND=JPIM),INTENT(OUT), OPTIONAL :: KRET
INTEGER(KIND=JPIM) :: IRET
REAL(KIND=JPHOOK) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('BYTES_IO:BYTES_IO_SEEK',0,ZHOOK_HANDLE)
CALL C_BYTES_IO_SEEK(KFILE,KOFFSET,KWHENCE,IRET)
IF(PRESENT(KRET)) THEN
  KRET=IRET
ELSEIF(IRET < JPBYTES_IO_SUCCESS) THEN
  WRITE(0,*) 'BYTES_IO_SEEK ',KFILE,' FAILED',IRET
  CALL MPL_ABORT('BYTES_IO_SEEK FAILED')
ENDIF
IF (LHOOK) CALL DR_HOOK('BYTES_IO:BYTES_IO_SEEK',1,ZHOOK_HANDLE)
END SUBROUTINE BYTES_IO_SEEK


SUBROUTINE BYTES_IO_TELL(KFILE,KRET)
INTEGER(KIND=JPIM),INTENT(IN) :: KFILE
INTEGER(KIND=JPIM),INTENT(OUT), OPTIONAL :: KRET
INTEGER(KIND=JPIM) :: IRET
REAL(KIND=JPHOOK) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('BYTES_IO:BYTES_IO_SEEK',0,ZHOOK_HANDLE)
CALL C_BYTES_IO_TELL(KFILE,IRET)
IF(PRESENT(KRET)) THEN
  KRET=IRET
ELSEIF(IRET < JPBYTES_IO_SUCCESS) THEN
  WRITE(0,*) 'BYTES_IO_TELL ',KFILE,' FAILED',IRET
  CALL MPL_ABORT('BYTES_IO_TELL FAILED')
ENDIF
IF (LHOOK) CALL DR_HOOK('BYTES_IO:BYTES_IO_TELL',1,ZHOOK_HANDLE)
END SUBROUTINE BYTES_IO_TELL

! ============================================
! BYTES_IO_READ_JPIM

SUBROUTINE BYTES_IO_READ_JPIM_INT(KFILE,KBUF,KBYTES,KRET)
INTEGER(KIND=JPIM),INTENT(IN)    :: KFILE
INTEGER(KIND=JPIM),INTENT(OUT)   :: KBUF
INTEGER(KIND=JPIM),INTENT(IN)    :: KBYTES
INTEGER(KIND=JPIM),INTENT(OUT), OPTIONAL   :: KRET
INTEGER(KIND=JPIM) :: IRET,ILEN
REAL(KIND=JPHOOK) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('BYTES_IO:BYTES_IO_READ_JPIM_INT',0,ZHOOK_HANDLE)
CALL C_BYTES_IO_READ(KFILE,KBUF,KBYTES,IRET)
IF(PRESENT(KRET)) THEN
  KRET=IRET
ELSEIF(IRET < JPBYTES_IO_SUCCESS .AND. IRET < JPBYTES_IO_END_OF_FILE ) THEN
  WRITE(0,*) 'BYTES_IO_READ_JPIM_INT ',KFILE,' ',KBYTES,' FAILED',IRET
  CALL MPL_ABORT('BYTES_IO_READ_JPIM_INT FAILED')
ENDIF
IF (LHOOK) CALL DR_HOOK('BYTES_IO:BYTES_IO_READ_JPIM_INT',1,ZHOOK_HANDLE)
END SUBROUTINE BYTES_IO_READ_JPIM_INT

SUBROUTINE BYTES_IO_READ_JPIM_INT_ARRAY(KFILE,KBUF,KBYTES,KRET)
INTEGER(KIND=JPIM),INTENT(IN)    :: KFILE
INTEGER(KIND=JPIM),INTENT(OUT)   :: KBUF(:)
INTEGER(KIND=JPIM),INTENT(IN)    :: KBYTES
INTEGER(KIND=JPIM),INTENT(OUT), OPTIONAL   :: KRET
INTEGER(KIND=JPIM) :: IRET,ILEN
REAL(KIND=JPHOOK) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('BYTES_IO:BYTES_IO_READ_JPIM_INT_ARRAY',0,ZHOOK_HANDLE)
CALL C_BYTES_IO_READ(KFILE,KBUF,KBYTES,IRET)
IF(PRESENT(KRET)) THEN
  KRET=IRET
ELSEIF(IRET < JPBYTES_IO_SUCCESS .AND. IRET < JPBYTES_IO_END_OF_FILE ) THEN
  WRITE(0,*) 'BYTES_IO_READ_JPIM_INT_ARRAY ',KFILE,' ',KBYTES,' FAILED',IRET
  CALL MPL_ABORT('BYTES_IO_READ_JPIM_INT_ARRAY FAILED')
ENDIF
IF (LHOOK) CALL DR_HOOK('BYTES_IO:BYTES_IO_READ_JPIM_INT_ARRAY',1,ZHOOK_HANDLE)
END SUBROUTINE BYTES_IO_READ_JPIM_INT_ARRAY

SUBROUTINE BYTES_IO_READ_JPIM_REAL4(KFILE,PBUF,KBYTES,KRET)
INTEGER(KIND=JPIM),INTENT(IN)    :: KFILE
REAL(KIND=JPRM),INTENT(OUT)      :: PBUF
INTEGER(KIND=JPIM),INTENT(IN)    :: KBYTES
INTEGER(KIND=JPIM),INTENT(OUT), OPTIONAL   :: KRET
INTEGER(KIND=JPIM) :: IRET,ILEN
REAL(KIND=JPHOOK) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('BYTES_IO:BYTES_IO_READ_JPIM_REAL4',0,ZHOOK_HANDLE)
CALL C_BYTES_IO_READ(KFILE,PBUF,KBYTES,IRET)
IF(PRESENT(KRET)) THEN
  KRET=IRET
ELSEIF(IRET < JPBYTES_IO_SUCCESS .AND. IRET < JPBYTES_IO_END_OF_FILE ) THEN
  WRITE(0,*) 'BYTES_IO_READ_JPIM_REAL4 ',KFILE,' ',KBYTES,' FAILED',IRET
  CALL MPL_ABORT('BYTES_IO_READ_JPIM_REAL4 FAILED')
ENDIF
IF (LHOOK) CALL DR_HOOK('BYTES_IO:BYTES_IO_READ_JPIM_REAL4',1,ZHOOK_HANDLE)
END SUBROUTINE BYTES_IO_READ_JPIM_REAL4

SUBROUTINE BYTES_IO_READ_JPIM_REAL4_ARRAY(KFILE,PBUF,KBYTES,KRET)
INTEGER(KIND=JPIM),INTENT(IN)    :: KFILE
REAL(KIND=JPRM),INTENT(OUT)      :: PBUF(:)
INTEGER(KIND=JPIM),INTENT(IN)    :: KBYTES
INTEGER(KIND=JPIM),INTENT(OUT), OPTIONAL   :: KRET
INTEGER(KIND=JPIM) :: IRET,ILEN
REAL(KIND=JPHOOK) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('BYTES_IO:BYTES_IO_READ_JPIM_REAL4_ARRAY',0,ZHOOK_HANDLE)
CALL C_BYTES_IO_READ(KFILE,PBUF,KBYTES,IRET)
IF(PRESENT(KRET)) THEN
  KRET=IRET
ELSEIF(IRET < JPBYTES_IO_SUCCESS .AND. IRET < JPBYTES_IO_END_OF_FILE ) THEN
  WRITE(0,*) 'BYTES_IO_READ_JPIM_REAL4_ARRAY ',KFILE,' ',KBYTES,' FAILED',IRET
  CALL MPL_ABORT('BYTES_IO_READ_JPIM_REAL4_ARRAY FAILED')
ENDIF
IF (LHOOK) CALL DR_HOOK('BYTES_IO:BYTES_IO_READ_JPIM_REAL4_ARRAY',1,ZHOOK_HANDLE)
END SUBROUTINE BYTES_IO_READ_JPIM_REAL4_ARRAY

SUBROUTINE BYTES_IO_READ_JPIM_REAL4_ARRAY2(KFILE,PBUF,KBYTES,KRET)
  INTEGER(KIND=JPIM),INTENT(IN)    :: KFILE
  REAL(KIND=JPRM),INTENT(OUT)      :: PBUF(:,:)
  INTEGER(KIND=JPIM),INTENT(IN)    :: KBYTES
  INTEGER(KIND=JPIM),INTENT(OUT), OPTIONAL   :: KRET
  INTEGER(KIND=JPIM) :: IRET,ILEN
  REAL(KIND=JPHOOK) :: ZHOOK_HANDLE
  IF (LHOOK) CALL DR_HOOK('BYTES_IO:BYTES_IO_READ_JPIM_REAL4_ARRAY2',0,ZHOOK_HANDLE)
  CALL C_BYTES_IO_READ(KFILE,PBUF,KBYTES,IRET)
  IF(PRESENT(KRET)) THEN
    KRET=IRET
  ELSEIF(IRET < JPBYTES_IO_SUCCESS .AND. IRET < JPBYTES_IO_END_OF_FILE ) THEN
    WRITE(0,*) 'BYTES_IO_READ_JPIM_REAL4_ARRAY2 ',KFILE,' ',KBYTES,' FAILED',IRET
    CALL MPL_ABORT('BYTES_IO_READ_JPIM_REAL4_ARRAY2 FAILED')
  ENDIF
  IF (LHOOK) CALL DR_HOOK('BYTES_IO:BYTES_IO_READ_JPIM_REAL4_ARRAY2',1,ZHOOK_HANDLE)
END SUBROUTINE BYTES_IO_READ_JPIM_REAL4_ARRAY2

SUBROUTINE BYTES_IO_READ_JPIM_REAL8(KFILE,PBUF,KBYTES,KRET)
INTEGER(KIND=JPIM),INTENT(IN)    :: KFILE
REAL(KIND=JPRD),INTENT(OUT)      :: PBUF
INTEGER(KIND=JPIM),INTENT(IN)    :: KBYTES
INTEGER(KIND=JPIM),INTENT(OUT), OPTIONAL   :: KRET
INTEGER(KIND=JPIM) :: IRET,ILEN
REAL(KIND=JPHOOK) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('BYTES_IO:BYTES_IO_READ_JPIM_REAL8',0,ZHOOK_HANDLE)
CALL C_BYTES_IO_READ(KFILE,PBUF,KBYTES,IRET)
IF(PRESENT(KRET)) THEN
  KRET=IRET
ELSEIF(IRET < JPBYTES_IO_SUCCESS .AND. IRET < JPBYTES_IO_END_OF_FILE ) THEN
  WRITE(0,*) 'BYTES_IO_READ_JPIM_REAL8 ',KFILE,' ',KBYTES,' FAILED',IRET
  CALL MPL_ABORT('BYTES_IO_READ_JPIM_REAL8 FAILED')
ENDIF
IF (LHOOK) CALL DR_HOOK('BYTES_IO:BYTES_IO_READ_JPIM_REAL8',1,ZHOOK_HANDLE)
END SUBROUTINE BYTES_IO_READ_JPIM_REAL8

SUBROUTINE BYTES_IO_READ_JPIM_REAL8_ARRAY(KFILE,PBUF,KBYTES,KRET)
INTEGER(KIND=JPIM),INTENT(IN)    :: KFILE
REAL(KIND=JPRD),INTENT(OUT)      :: PBUF(:)
INTEGER(KIND=JPIM),INTENT(IN)    :: KBYTES
INTEGER(KIND=JPIM),INTENT(OUT), OPTIONAL   :: KRET
INTEGER(KIND=JPIM) :: IRET,ILEN
REAL(KIND=JPHOOK) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('BYTES_IO:BYTES_IO_READ_JPIM_REAL8_ARRAY',0,ZHOOK_HANDLE)
CALL C_BYTES_IO_READ(KFILE,PBUF,KBYTES,IRET)
IF(PRESENT(KRET)) THEN
  KRET=IRET
ELSEIF(IRET < JPBYTES_IO_SUCCESS .AND. IRET < JPBYTES_IO_END_OF_FILE ) THEN
  WRITE(0,*) 'BYTES_IO_READ_JPIM_REAL8_ARRAY ',KFILE,' ',KBYTES,' FAILED',IRET
  CALL MPL_ABORT('BYTES_IO_READ_JPIM_REAL8_ARRAY FAILED')
ENDIF
IF (LHOOK) CALL DR_HOOK('BYTES_IO:BYTES_IO_READ_JPIM_REAL8_ARRAY',1,ZHOOK_HANDLE)
END SUBROUTINE BYTES_IO_READ_JPIM_REAL8_ARRAY

SUBROUTINE BYTES_IO_READ_JPIM_REAL8_ARRAY2(KFILE,PBUF,KBYTES,KRET)
  INTEGER(KIND=JPIM),INTENT(IN)    :: KFILE
  REAL(KIND=JPRD),INTENT(OUT)      :: PBUF(:,:)
  INTEGER(KIND=JPIM),INTENT(IN)    :: KBYTES
  INTEGER(KIND=JPIM),INTENT(OUT), OPTIONAL   :: KRET
  INTEGER(KIND=JPIM) :: IRET,ILEN
  REAL(KIND=JPHOOK) :: ZHOOK_HANDLE
  IF (LHOOK) CALL DR_HOOK('BYTES_IO:BYTES_IO_READ_JPIM_REAL8_ARRAY2',0,ZHOOK_HANDLE)
  CALL C_BYTES_IO_READ(KFILE,PBUF,KBYTES,IRET)
  IF(PRESENT(KRET)) THEN
    KRET=IRET
  ELSEIF(IRET < JPBYTES_IO_SUCCESS .AND. IRET < JPBYTES_IO_END_OF_FILE ) THEN
    WRITE(0,*) 'BYTES_IO_READ_JPIM_REAL8_ARRAY2 ',KFILE,' ',KBYTES,' FAILED',IRET
    CALL MPL_ABORT('BYTES_IO_READ_JPIM_REAL8_ARRAY2 FAILED')
  ENDIF
  IF (LHOOK) CALL DR_HOOK('BYTES_IO:BYTES_IO_READ_JPIM_REAL8_ARRAY2',1,ZHOOK_HANDLE)
END SUBROUTINE BYTES_IO_READ_JPIM_REAL8_ARRAY2

SUBROUTINE BYTES_IO_READ_JPIM_CHAR_ARRAY(KFILE,CDBUF,KBYTES,KRET)
INTEGER(KIND=JPIM),INTENT(IN)    :: KFILE
CHARACTER(LEN=1)  ,INTENT(OUT)   :: CDBUF(:)
INTEGER(KIND=JPIM),INTENT(INOUT) :: KBYTES
INTEGER(KIND=JPIM),INTENT(OUT), OPTIONAL   :: KRET
INTEGER(KIND=JPIM) :: IRET,ILEN
REAL(KIND=JPHOOK) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('BYTES_IO:BYTES_IO_READ_JPIM_CHAR_ARRAY',0,ZHOOK_HANDLE)
CALL C_BYTES_IO_READ(KFILE,CDBUF,KBYTES,IRET)
IF(PRESENT(KRET)) THEN
  KRET=IRET
ELSEIF(IRET < JPBYTES_IO_SUCCESS .AND. IRET < JPBYTES_IO_END_OF_FILE ) THEN
  WRITE(0,*) 'BYTES_IO_READ_JPIM_CHAR_ARRAY ',KFILE,' FAILED',IRET
  CALL MPL_ABORT('BYTES_IO_READ_JPIM_CHAR_ARRAY FAILED')
ENDIF
IF (LHOOK) CALL DR_HOOK('BYTES_IO:BYTES_IO_READ_JPIM_CHAR_ARRAY',1,ZHOOK_HANDLE)
END SUBROUTINE BYTES_IO_READ_JPIM_CHAR_ARRAY


! ============================================
! BYTES_IO_WRITE_JPIM

SUBROUTINE BYTES_IO_WRITE_JPIM_INT(KFILE,PBUF,KBYTES,KRET)
INTEGER(KIND=JPIM),INTENT(IN)    :: KFILE
INTEGER(KIND=JPIM),INTENT(IN)    :: PBUF
INTEGER(KIND=JPIM),INTENT(IN)    :: KBYTES
INTEGER(KIND=JPIM),OPTIONAL,INTENT(OUT) :: KRET
INTEGER(KIND=JPIM) :: IRET
INTEGER(KIND=JPIM) :: ILEN
REAL(KIND=JPHOOK) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('BYTES_IO:BYTES_IO_WRITE_JPIM_INT',0,ZHOOK_HANDLE)

CALL C_BYTES_IO_WRITE(KFILE,PBUF,KBYTES,IRET)
IF(PRESENT(KRET)) THEN
  KRET=IRET
ENDIF
IF(IRET < JPBYTES_IO_SUCCESS ) THEN
  WRITE(0,*) 'BYTES_IO_WRITE_JPIM_INT ',KFILE,' ',KBYTES,' FAILED',IRET
  CALL MPL_ABORT('BYTES_IO_WRITE_JPIM_INT FAILED')
ENDIF
IF (LHOOK) CALL DR_HOOK('BYTES_IO:BYTES_IO_WRITE_JPIM_INT',1,ZHOOK_HANDLE)
END SUBROUTINE BYTES_IO_WRITE_JPIM_INT

SUBROUTINE BYTES_IO_WRITE_JPIM_INT_ARRAY(KFILE,PBUF,KBYTES,KRET)
INTEGER(KIND=JPIM),INTENT(IN)    :: KFILE
INTEGER(KIND=JPIM),INTENT(IN)    :: PBUF(:)
INTEGER(KIND=JPIM),INTENT(IN)    :: KBYTES
INTEGER(KIND=JPIM),OPTIONAL,INTENT(OUT) :: KRET
INTEGER(KIND=JPIM) :: IRET
INTEGER(KIND=JPIM) :: ILEN
REAL(KIND=JPHOOK) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('BYTES_IO:BYTES_IO_WRITE_JPIM_INT',0,ZHOOK_HANDLE)

CALL C_BYTES_IO_WRITE(KFILE,PBUF,KBYTES,IRET)
IF(PRESENT(KRET)) THEN
  KRET=IRET
ENDIF
IF(IRET < JPBYTES_IO_SUCCESS ) THEN
  WRITE(0,*) 'BYTES_IO_WRITE_JPIM_INT ',KFILE,' ',KBYTES,' FAILED',IRET
  CALL MPL_ABORT('BYTES_IO_WRITE_JPIM_INT FAILED')
ENDIF
IF (LHOOK) CALL DR_HOOK('BYTES_IO:BYTES_IO_WRITE_JPIM_INT',1,ZHOOK_HANDLE)
END SUBROUTINE BYTES_IO_WRITE_JPIM_INT_ARRAY

SUBROUTINE BYTES_IO_WRITE_JPIM_REAL4(KFILE,PBUF,KBYTES,KRET)
INTEGER(KIND=JPIM),INTENT(IN)    :: KFILE
REAL(KIND=JPRM),INTENT(IN)    :: PBUF
INTEGER(KIND=JPIM),INTENT(IN)    :: KBYTES
INTEGER(KIND=JPIM),OPTIONAL,INTENT(OUT) :: KRET
INTEGER(KIND=JPIM) :: IRET
INTEGER(KIND=JPIM) :: ILEN
REAL(KIND=JPHOOK) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('BYTES_IO:BYTES_IO_WRITE_JPIM_REAL4',0,ZHOOK_HANDLE)

CALL C_BYTES_IO_WRITE(KFILE,PBUF,KBYTES,IRET)
IF(PRESENT(KRET)) THEN
  KRET=IRET
ENDIF
IF(IRET < JPBYTES_IO_SUCCESS ) THEN
  WRITE(0,*) 'BYTES_IO_WRITE_JPIM_REAL4 ',KFILE,' ',KBYTES,' FAILED',IRET
  CALL MPL_ABORT('BYTES_IO_WRITE_JPIM_REAL4 FAILED')
ENDIF
IF (LHOOK) CALL DR_HOOK('BYTES_IO:BYTES_IO_WRITE_JPIM_REAL4',1,ZHOOK_HANDLE)
END SUBROUTINE BYTES_IO_WRITE_JPIM_REAL4

SUBROUTINE BYTES_IO_WRITE_JPIM_REAL4_ARRAY(KFILE,PBUF,KBYTES,KRET)
INTEGER(KIND=JPIM),INTENT(IN)    :: KFILE
REAL(KIND=JPRM),INTENT(IN)       :: PBUF(:)
INTEGER(KIND=JPIM),INTENT(IN)    :: KBYTES
INTEGER(KIND=JPIM),OPTIONAL,INTENT(OUT) :: KRET
INTEGER(KIND=JPIM) :: IRET
INTEGER(KIND=JPIM) :: ILEN
REAL(KIND=JPHOOK) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('BYTES_IO:BYTES_IO_WRITE_JPIM_REAL4_ARRAY',0,ZHOOK_HANDLE)
CALL C_BYTES_IO_WRITE(KFILE,PBUF,KBYTES,IRET)
IF(PRESENT(KRET)) THEN
  KRET=IRET
ENDIF
IF(IRET < JPBYTES_IO_SUCCESS ) THEN
  WRITE(0,*) 'BYTES_IO_WRITE_JPIM_REAL4_ARRAY ',KFILE,' ',KBYTES,' FAILED',IRET
  CALL MPL_ABORT('BYTES_IO_WRITE_JPIM_REAL4_ARRAY FAILED')
ENDIF
IF (LHOOK) CALL DR_HOOK('BYTES_IO:BYTES_IO_WRITE_JPIM_REAL4_ARRAY',1,ZHOOK_HANDLE)
END SUBROUTINE BYTES_IO_WRITE_JPIM_REAL4_ARRAY

SUBROUTINE BYTES_IO_WRITE_JPIM_REAL4_ARRAY2(KFILE,PBUF,KBYTES,KRET)
  INTEGER(KIND=JPIM),INTENT(IN)    :: KFILE
  REAL(KIND=JPRM),INTENT(IN)       :: PBUF(:,:)
  INTEGER(KIND=JPIM),INTENT(IN)    :: KBYTES
  INTEGER(KIND=JPIM),OPTIONAL,INTENT(OUT) :: KRET
  INTEGER(KIND=JPIM) :: IRET
  INTEGER(KIND=JPIM) :: ILEN
  REAL(KIND=JPHOOK) :: ZHOOK_HANDLE
  IF (LHOOK) CALL DR_HOOK('BYTES_IO:BYTES_IO_WRITE_JPIM_REAL4_ARRAY2',0,ZHOOK_HANDLE)
  CALL C_BYTES_IO_WRITE(KFILE,PBUF,KBYTES,IRET)
  IF(PRESENT(KRET)) THEN
    KRET=IRET
  ENDIF
  IF(IRET < JPBYTES_IO_SUCCESS ) THEN
    WRITE(0,*) 'BYTES_IO_WRITE_JPIM_REAL4_ARRAY2 ',KFILE,' ',KBYTES,' FAILED',IRET
    CALL MPL_ABORT('BYTES_IO_WRITE_JPIM_REAL4_ARRAY2 FAILED')
  ENDIF
  IF (LHOOK) CALL DR_HOOK('BYTES_IO:BYTES_IO_WRITE_JPIM_REAL4_ARRAY2',1,ZHOOK_HANDLE)
END SUBROUTINE BYTES_IO_WRITE_JPIM_REAL4_ARRAY2

SUBROUTINE BYTES_IO_WRITE_JPIM_REAL8(KFILE,PBUF,KBYTES,KRET)
INTEGER(KIND=JPIM),INTENT(IN)    :: KFILE
REAL(KIND=JPRD),INTENT(IN)    :: PBUF
INTEGER(KIND=JPIM),INTENT(IN)    :: KBYTES
INTEGER(KIND=JPIM),OPTIONAL,INTENT(OUT) :: KRET
INTEGER(KIND=JPIM) :: IRET
INTEGER(KIND=JPIM) :: ILEN
REAL(KIND=JPHOOK) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('BYTES_IO:BYTES_IO_WRITE_JPIM_REAL8',0,ZHOOK_HANDLE)
CALL C_BYTES_IO_WRITE(KFILE,PBUF,KBYTES,IRET)
IF(PRESENT(KRET)) THEN
  KRET=IRET
ENDIF
IF(IRET < JPBYTES_IO_SUCCESS ) THEN
  WRITE(0,*) 'BYTES_IO_WRITE_JPIM_REAL8 ',KFILE,' ',KBYTES,' FAILED',IRET
  CALL MPL_ABORT('BYTES_IO_WRITE_JPIM_REAL8 FAILED')
ENDIF
IF (LHOOK) CALL DR_HOOK('BYTES_IO:BYTES_IO_WRITE_JPIM_REAL8',1,ZHOOK_HANDLE)
END SUBROUTINE BYTES_IO_WRITE_JPIM_REAL8

SUBROUTINE BYTES_IO_WRITE_JPIM_REAL8_ARRAY(KFILE,PBUF,KBYTES,KRET)
INTEGER(KIND=JPIM),INTENT(IN)    :: KFILE
REAL(KIND=JPRD),INTENT(IN)       :: PBUF(:)
INTEGER(KIND=JPIM),INTENT(IN)    :: KBYTES
INTEGER(KIND=JPIM),OPTIONAL,INTENT(OUT) :: KRET
INTEGER(KIND=JPIM) :: IRET
INTEGER(KIND=JPIM) :: ILEN
REAL(KIND=JPHOOK) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('BYTES_IO:BYTES_IO_WRITE_JPIM_REAL8_ARRAY',0,ZHOOK_HANDLE)
CALL C_BYTES_IO_WRITE(KFILE,PBUF,KBYTES,IRET)
IF(PRESENT(KRET)) THEN
  KRET=IRET
ENDIF
IF(IRET < JPBYTES_IO_SUCCESS ) THEN
  WRITE(0,*) 'BYTES_IO_WRITE_JPIM_REAL8_ARRAY ',KFILE,' ',KBYTES,' FAILED',IRET
  CALL MPL_ABORT('BYTES_IO_WRITE_JPIM_REAL8_ARRAY FAILED')
ENDIF
IF (LHOOK) CALL DR_HOOK('BYTES_IO:BYTES_IO_WRITE_JPIM_REAL8_ARRAY',1,ZHOOK_HANDLE)
END SUBROUTINE BYTES_IO_WRITE_JPIM_REAL8_ARRAY

SUBROUTINE BYTES_IO_WRITE_JPIM_REAL8_ARRAY2(KFILE,PBUF,KBYTES,KRET)
  INTEGER(KIND=JPIM),INTENT(IN)    :: KFILE
  REAL(KIND=JPRD),INTENT(IN)       :: PBUF(:,:)
  INTEGER(KIND=JPIM),INTENT(IN)    :: KBYTES
  INTEGER(KIND=JPIM),OPTIONAL,INTENT(OUT) :: KRET
  INTEGER(KIND=JPIM) :: IRET
  INTEGER(KIND=JPIM) :: ILEN
  REAL(KIND=JPHOOK) :: ZHOOK_HANDLE
  IF (LHOOK) CALL DR_HOOK('BYTES_IO:BYTES_IO_WRITE_JPIM_REAL8_ARRAY2',0,ZHOOK_HANDLE)
  CALL C_BYTES_IO_WRITE(KFILE,PBUF,KBYTES,IRET)
  IF(PRESENT(KRET)) THEN
    KRET=IRET
  ENDIF
  IF(IRET < JPBYTES_IO_SUCCESS ) THEN
    WRITE(0,*) 'BYTES_IO_WRITE_JPIM_REAL8_ARRAY2 ',KFILE,' ',KBYTES,' FAILED',IRET
    CALL MPL_ABORT('BYTES_IO_WRITE_JPIM_REAL8_ARRAY2 FAILED')
  ENDIF
  IF (LHOOK) CALL DR_HOOK('BYTES_IO:BYTES_IO_WRITE_JPIM_REAL8_ARRAY2',1,ZHOOK_HANDLE)
END SUBROUTINE BYTES_IO_WRITE_JPIM_REAL8_ARRAY2

SUBROUTINE BYTES_IO_WRITE_JPIM_CHAR_ARRAY(KFILE,CDBUF,KBYTES,KRET)
INTEGER(KIND=JPIM),INTENT(IN)    :: KFILE
CHARACTER(LEN=1)  ,INTENT(IN)    :: CDBUF(:)
INTEGER(KIND=JPIM),INTENT(INOUT) :: KBYTES
INTEGER(KIND=JPIM),INTENT(OUT), OPTIONAL :: KRET
INTEGER(KIND=JPIM) :: IRET
REAL(KIND=JPHOOK) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('BYTES_IO:BYTES_IO_WRITE_JPIM_CHAR_ARRAY',0,ZHOOK_HANDLE)
CALL C_BYTES_IO_WRITE(KFILE,CDBUF,KBYTES,IRET)
IF(PRESENT(KRET)) THEN
  KRET=IRET
ELSEIF(IRET < JPBYTES_IO_SUCCESS) THEN
  WRITE(0,*) 'BYTES_IO_WRITE_JPIM_CHAR_ARRAY ',KFILE,' FAILED',IRET
  CALL MPL_ABORT('BYTES_IO_WRITE_JPIM_CHAR_ARRAY FAILED')
ENDIF
IF (LHOOK) CALL DR_HOOK('BYTES_IO:BYTES_IO_WRITE_JPIM_CHAR_ARRAY',1,ZHOOK_HANDLE)
END SUBROUTINE BYTES_IO_WRITE_JPIM_CHAR_ARRAY

! ============================================
! BYTES_IO_READ_JPIB

SUBROUTINE BYTES_IO_READ_JPIB_INT(KFILE,KBUF,KBYTES,KRET)
INTEGER(KIND=JPIM),INTENT(IN)    :: KFILE
INTEGER(KIND=JPIM),INTENT(OUT)   :: KBUF
INTEGER(KIND=JPIB),INTENT(IN)    :: KBYTES
INTEGER(KIND=JPIM),INTENT(OUT), OPTIONAL   :: KRET
INTEGER(KIND=JPIM) :: IRET,ILEN
REAL(KIND=JPHOOK) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('BYTES_IO:BYTES_IO_READ_JPIB_INT',0,ZHOOK_HANDLE)
CALL C_BYTES_IO_READ(KFILE,KBUF,INT(KBYTES,JPIM),IRET)
IF(PRESENT(KRET)) THEN
  KRET=IRET
ELSEIF(IRET < JPBYTES_IO_SUCCESS .AND. IRET < JPBYTES_IO_END_OF_FILE ) THEN
  WRITE(0,*) 'BYTES_IO_READ_JPIB_INT ',KFILE,' ',KBYTES,' FAILED',IRET
  CALL MPL_ABORT('BYTES_IO_READ_JPIB_INT FAILED')
ENDIF
IF (LHOOK) CALL DR_HOOK('BYTES_IO:BYTES_IO_READ_JPIB_INT',1,ZHOOK_HANDLE)
END SUBROUTINE BYTES_IO_READ_JPIB_INT

SUBROUTINE BYTES_IO_READ_JPIB_INT_ARRAY(KFILE,KBUF,KBYTES,KRET)
INTEGER(KIND=JPIM),INTENT(IN)    :: KFILE
INTEGER(KIND=JPIM),INTENT(OUT)   :: KBUF(:)
INTEGER(KIND=JPIB),INTENT(IN)    :: KBYTES
INTEGER(KIND=JPIM),INTENT(OUT), OPTIONAL   :: KRET
INTEGER(KIND=JPIM) :: IRET,ILEN
REAL(KIND=JPHOOK) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('BYTES_IO:BYTES_IO_READ_JPIB_INT_ARRAY',0,ZHOOK_HANDLE)
CALL C_BYTES_IO_READ(KFILE,KBUF,INT(KBYTES,JPIM),IRET)
IF(PRESENT(KRET)) THEN
  KRET=IRET
ELSEIF(IRET < JPBYTES_IO_SUCCESS .AND. IRET < JPBYTES_IO_END_OF_FILE ) THEN
  WRITE(0,*) 'BYTES_IO_READ_JPIB_INT_ARRAY ',KFILE,' ',KBYTES,' FAILED',IRET
  CALL MPL_ABORT('BYTES_IO_READ_JPIB_INT_ARRAY FAILED')
ENDIF
IF (LHOOK) CALL DR_HOOK('BYTES_IO:BYTES_IO_READ_JPIB_INT_ARRAY',1,ZHOOK_HANDLE)
END SUBROUTINE BYTES_IO_READ_JPIB_INT_ARRAY

SUBROUTINE BYTES_IO_READ_JPIB_REAL4(KFILE,PBUF,KBYTES,KRET)
INTEGER(KIND=JPIM),INTENT(IN)    :: KFILE
REAL(KIND=JPRM),INTENT(OUT)      :: PBUF
INTEGER(KIND=JPIB),INTENT(IN)    :: KBYTES
INTEGER(KIND=JPIM),INTENT(OUT), OPTIONAL   :: KRET
INTEGER(KIND=JPIM) :: IRET,ILEN
REAL(KIND=JPHOOK) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('BYTES_IO:BYTES_IO_READ_JPIB_REAL4',0,ZHOOK_HANDLE)
CALL C_BYTES_IO_READ(KFILE,PBUF,INT(KBYTES,JPIM),IRET)
IF(PRESENT(KRET)) THEN
  KRET=IRET
ELSEIF(IRET < JPBYTES_IO_SUCCESS .AND. IRET < JPBYTES_IO_END_OF_FILE ) THEN
  WRITE(0,*) 'BYTES_IO_READ_JPIB_REAL4 ',KFILE,' ',KBYTES,' FAILED',IRET
  CALL MPL_ABORT('BYTES_IO_READ_JPIB_REAL4 FAILED')
ENDIF
IF (LHOOK) CALL DR_HOOK('BYTES_IO:BYTES_IO_READ_JPIB_REAL4',1,ZHOOK_HANDLE)
END SUBROUTINE BYTES_IO_READ_JPIB_REAL4

SUBROUTINE BYTES_IO_READ_JPIB_REAL4_ARRAY(KFILE,PBUF,KBYTES,KRET)
INTEGER(KIND=JPIM),INTENT(IN)    :: KFILE
REAL(KIND=JPRM),INTENT(OUT)      :: PBUF(:)
INTEGER(KIND=JPIB),INTENT(IN)    :: KBYTES
INTEGER(KIND=JPIM),INTENT(OUT), OPTIONAL   :: KRET
INTEGER(KIND=JPIM) :: IRET,ILEN
REAL(KIND=JPHOOK) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('BYTES_IO:BYTES_IO_READ_JPIB_REAL4_ARRAY',0,ZHOOK_HANDLE)
CALL C_BYTES_IO_READ(KFILE,PBUF,INT(KBYTES,JPIM),IRET)
IF(PRESENT(KRET)) THEN
  KRET=IRET
ELSEIF(IRET < JPBYTES_IO_SUCCESS .AND. IRET < JPBYTES_IO_END_OF_FILE ) THEN
  WRITE(0,*) 'BYTES_IO_READ_JPIB_REAL4_ARRAY ',KFILE,' ',KBYTES,' FAILED',IRET
  CALL MPL_ABORT('BYTES_IO_READ_JPIB_REAL4_ARRAY FAILED')
ENDIF
IF (LHOOK) CALL DR_HOOK('BYTES_IO:BYTES_IO_READ_JPIB_REAL4_ARRAY',1,ZHOOK_HANDLE)
END SUBROUTINE BYTES_IO_READ_JPIB_REAL4_ARRAY

SUBROUTINE BYTES_IO_READ_JPIB_REAL4_ARRAY2(KFILE,PBUF,KBYTES,KRET)
  INTEGER(KIND=JPIM),INTENT(IN)    :: KFILE
  REAL(KIND=JPRM),INTENT(OUT)      :: PBUF(:,:)
  INTEGER(KIND=JPIB),INTENT(IN)    :: KBYTES
  INTEGER(KIND=JPIM),INTENT(OUT), OPTIONAL   :: KRET
  INTEGER(KIND=JPIM) :: IRET,ILEN
  REAL(KIND=JPHOOK) :: ZHOOK_HANDLE
  IF (LHOOK) CALL DR_HOOK('BYTES_IO:BYTES_IO_READ_JPIB_REAL4_ARRAY2',0,ZHOOK_HANDLE)
  CALL C_BYTES_IO_READ(KFILE,PBUF,INT(KBYTES,JPIM),IRET)
  IF(PRESENT(KRET)) THEN
    KRET=IRET
  ELSEIF(IRET < JPBYTES_IO_SUCCESS .AND. IRET < JPBYTES_IO_END_OF_FILE ) THEN
    WRITE(0,*) 'BYTES_IO_READ_JPIB_REAL4_ARRAY2 ',KFILE,' ',KBYTES,' FAILED',IRET
    CALL MPL_ABORT('BYTES_IO_READ_JPIB_REAL4_ARRAY2 FAILED')
  ENDIF
  IF (LHOOK) CALL DR_HOOK('BYTES_IO:BYTES_IO_READ_JPIB_REAL4_ARRAY2',1,ZHOOK_HANDLE)
END SUBROUTINE BYTES_IO_READ_JPIB_REAL4_ARRAY2

SUBROUTINE BYTES_IO_READ_JPIB_REAL8(KFILE,PBUF,KBYTES,KRET)
INTEGER(KIND=JPIM),INTENT(IN)    :: KFILE
REAL(KIND=JPRD),INTENT(OUT)      :: PBUF
INTEGER(KIND=JPIB),INTENT(IN)    :: KBYTES
INTEGER(KIND=JPIM),INTENT(OUT), OPTIONAL   :: KRET
INTEGER(KIND=JPIM) :: IRET,ILEN
REAL(KIND=JPHOOK) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('BYTES_IO:BYTES_IO_READ_JPIB_REAL8',0,ZHOOK_HANDLE)
CALL C_BYTES_IO_READ(KFILE,PBUF,INT(KBYTES,JPIM),IRET)
IF(PRESENT(KRET)) THEN
  KRET=IRET
ELSEIF(IRET < JPBYTES_IO_SUCCESS .AND. IRET < JPBYTES_IO_END_OF_FILE ) THEN
  WRITE(0,*) 'BYTES_IO_READ_JPIB_REAL8 ',KFILE,' ',KBYTES,' FAILED',IRET
  CALL MPL_ABORT('BYTES_IO_READ_JPIB_REAL8 FAILED')
ENDIF
IF (LHOOK) CALL DR_HOOK('BYTES_IO:BYTES_IO_READ_JPIB_REAL8',1,ZHOOK_HANDLE)
END SUBROUTINE BYTES_IO_READ_JPIB_REAL8

SUBROUTINE BYTES_IO_READ_JPIB_REAL8_ARRAY(KFILE,PBUF,KBYTES,KRET)
INTEGER(KIND=JPIM),INTENT(IN)    :: KFILE
REAL(KIND=JPRD),INTENT(OUT)      :: PBUF(:)
INTEGER(KIND=JPIB),INTENT(IN)    :: KBYTES
INTEGER(KIND=JPIM),INTENT(OUT), OPTIONAL   :: KRET
INTEGER(KIND=JPIM) :: IRET,ILEN
REAL(KIND=JPHOOK) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('BYTES_IO:BYTES_IO_READ_JPIB_REAL8_ARRAY',0,ZHOOK_HANDLE)
CALL C_BYTES_IO_READ(KFILE,PBUF,INT(KBYTES,JPIM),IRET)
IF(PRESENT(KRET)) THEN
  KRET=IRET
ELSEIF(IRET < JPBYTES_IO_SUCCESS .AND. IRET < JPBYTES_IO_END_OF_FILE ) THEN
  WRITE(0,*) 'BYTES_IO_READ_JPIB_REAL8_ARRAY ',KFILE,' ',KBYTES,' FAILED',IRET
  CALL MPL_ABORT('BYTES_IO_READ_JPIB_REAL8_ARRAY FAILED')
ENDIF
IF (LHOOK) CALL DR_HOOK('BYTES_IO:BYTES_IO_READ_JPIB_REAL8_ARRAY',1,ZHOOK_HANDLE)
END SUBROUTINE BYTES_IO_READ_JPIB_REAL8_ARRAY

SUBROUTINE BYTES_IO_READ_JPIB_REAL8_ARRAY2(KFILE,PBUF,KBYTES,KRET)
  INTEGER(KIND=JPIM),INTENT(IN)    :: KFILE
  REAL(KIND=JPRD),INTENT(OUT)      :: PBUF(:,:)
  INTEGER(KIND=JPIB),INTENT(IN)    :: KBYTES
  INTEGER(KIND=JPIM),INTENT(OUT), OPTIONAL   :: KRET
  INTEGER(KIND=JPIM) :: IRET,ILEN
  REAL(KIND=JPHOOK) :: ZHOOK_HANDLE
  IF (LHOOK) CALL DR_HOOK('BYTES_IO:BYTES_IO_READ_JPIB_REAL8_ARRAY2',0,ZHOOK_HANDLE)
  CALL C_BYTES_IO_READ(KFILE,PBUF,INT(KBYTES,JPIM),IRET)
  IF(PRESENT(KRET)) THEN
    KRET=IRET
  ELSEIF(IRET < JPBYTES_IO_SUCCESS .AND. IRET < JPBYTES_IO_END_OF_FILE ) THEN
    WRITE(0,*) 'BYTES_IO_READ_JPIB_REAL8_ARRAY2 ',KFILE,' ',KBYTES,' FAILED',IRET
    CALL MPL_ABORT('BYTES_IO_READ_JPIB_REAL8_ARRAY2 FAILED')
  ENDIF
  IF (LHOOK) CALL DR_HOOK('BYTES_IO:BYTES_IO_READ_JPIB_REAL8_ARRAY2',1,ZHOOK_HANDLE)
END SUBROUTINE BYTES_IO_READ_JPIB_REAL8_ARRAY2

SUBROUTINE BYTES_IO_READ_JPIB_CHAR_ARRAY(KFILE,CDBUF,KBYTES,KRET)
INTEGER(KIND=JPIM),INTENT(IN)    :: KFILE
CHARACTER(LEN=1)  ,INTENT(OUT)   :: CDBUF(:)
INTEGER(KIND=JPIB),INTENT(IN) :: KBYTES
INTEGER(KIND=JPIM),INTENT(OUT), OPTIONAL   :: KRET
INTEGER(KIND=JPIM) :: IRET,ILEN
REAL(KIND=JPHOOK) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('BYTES_IO:BYTES_IO_READ_JPIB_CHAR_ARRAY',0,ZHOOK_HANDLE)
CALL C_BYTES_IO_READ(KFILE,CDBUF,INT(KBYTES,JPIM),IRET)
IF(PRESENT(KRET)) THEN
  KRET=IRET
ELSEIF(IRET < JPBYTES_IO_SUCCESS .AND. IRET < JPBYTES_IO_END_OF_FILE ) THEN
  WRITE(0,*) 'BYTES_IO_READ_JPIB_CHAR_ARRAY ',KFILE,' FAILED',IRET
  CALL MPL_ABORT('BYTES_IO_READ_JPIB_CHAR_ARRAY FAILED')
ENDIF
IF (LHOOK) CALL DR_HOOK('BYTES_IO:BYTES_IO_READ_JPIB_CHAR_ARRAY',1,ZHOOK_HANDLE)
END SUBROUTINE BYTES_IO_READ_JPIB_CHAR_ARRAY


! ============================================
! BYTES_IO_WRITE_JPIB

SUBROUTINE BYTES_IO_WRITE_JPIB_INT(KFILE,PBUF,KBYTES,KRET)
INTEGER(KIND=JPIM),INTENT(IN)    :: KFILE
INTEGER(KIND=JPIM),INTENT(IN)    :: PBUF
INTEGER(KIND=JPIB),INTENT(IN)    :: KBYTES
INTEGER(KIND=JPIM),OPTIONAL,INTENT(OUT) :: KRET
INTEGER(KIND=JPIM) :: IRET
INTEGER(KIND=JPIM) :: ILEN
REAL(KIND=JPHOOK) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('BYTES_IO:BYTES_IO_WRITE_JPIB_INT',0,ZHOOK_HANDLE)

CALL C_BYTES_IO_WRITE(KFILE,PBUF,INT(KBYTES,JPIM),IRET)
IF(PRESENT(KRET)) THEN
  KRET=IRET
ENDIF
IF(IRET < JPBYTES_IO_SUCCESS ) THEN
  WRITE(0,*) 'BYTES_IO_WRITE_JPIB_INT ',KFILE,' ',KBYTES,' FAILED',IRET
  CALL MPL_ABORT('BYTES_IO_WRITE_JPIB_INT FAILED')
ENDIF
IF (LHOOK) CALL DR_HOOK('BYTES_IO:BYTES_IO_WRITE_JPIB_INT',1,ZHOOK_HANDLE)
END SUBROUTINE BYTES_IO_WRITE_JPIB_INT

SUBROUTINE BYTES_IO_WRITE_JPIB_INT_ARRAY(KFILE,PBUF,KBYTES,KRET)
INTEGER(KIND=JPIM),INTENT(IN)    :: KFILE
INTEGER(KIND=JPIM),INTENT(IN)    :: PBUF(:)
INTEGER(KIND=JPIB),INTENT(IN)    :: KBYTES
INTEGER(KIND=JPIM),OPTIONAL,INTENT(OUT) :: KRET
INTEGER(KIND=JPIM) :: IRET
INTEGER(KIND=JPIM) :: ILEN
REAL(KIND=JPHOOK) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('BYTES_IO:BYTES_IO_WRITE_JPIB_INT',0,ZHOOK_HANDLE)

CALL C_BYTES_IO_WRITE(KFILE,PBUF,INT(KBYTES,JPIM),IRET)
IF(PRESENT(KRET)) THEN
  KRET=IRET
ENDIF
IF(IRET < JPBYTES_IO_SUCCESS ) THEN
  WRITE(0,*) 'BYTES_IO_WRITE_JPIB_INT ',KFILE,' ',KBYTES,' FAILED',IRET
  CALL MPL_ABORT('BYTES_IO_WRITE_JPIB_INT FAILED')
ENDIF
IF (LHOOK) CALL DR_HOOK('BYTES_IO:BYTES_IO_WRITE_JPIB_INT',1,ZHOOK_HANDLE)
END SUBROUTINE BYTES_IO_WRITE_JPIB_INT_ARRAY

SUBROUTINE BYTES_IO_WRITE_JPIB_REAL4(KFILE,PBUF,KBYTES,KRET)
INTEGER(KIND=JPIM),INTENT(IN)    :: KFILE
REAL(KIND=JPRM),INTENT(IN)    :: PBUF
INTEGER(KIND=JPIB),INTENT(IN)    :: KBYTES
INTEGER(KIND=JPIM),OPTIONAL,INTENT(OUT) :: KRET
INTEGER(KIND=JPIM) :: IRET
INTEGER(KIND=JPIM) :: ILEN
REAL(KIND=JPHOOK) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('BYTES_IO:BYTES_IO_WRITE_JPIB_REAL4',0,ZHOOK_HANDLE)

CALL C_BYTES_IO_WRITE(KFILE,PBUF,INT(KBYTES,JPIM),IRET)
IF(PRESENT(KRET)) THEN
  KRET=IRET
ENDIF
IF(IRET < JPBYTES_IO_SUCCESS ) THEN
  WRITE(0,*) 'BYTES_IO_WRITE_JPIB_REAL4 ',KFILE,' ',KBYTES,' FAILED',IRET
  CALL MPL_ABORT('BYTES_IO_WRITE_JPIB_REAL4 FAILED')
ENDIF
IF (LHOOK) CALL DR_HOOK('BYTES_IO:BYTES_IO_WRITE_JPIB_REAL4',1,ZHOOK_HANDLE)
END SUBROUTINE BYTES_IO_WRITE_JPIB_REAL4

SUBROUTINE BYTES_IO_WRITE_JPIB_REAL4_ARRAY(KFILE,PBUF,KBYTES,KRET)
INTEGER(KIND=JPIM),INTENT(IN)    :: KFILE
REAL(KIND=JPRM),INTENT(IN)       :: PBUF(:)
INTEGER(KIND=JPIB),INTENT(IN)    :: KBYTES
INTEGER(KIND=JPIM),OPTIONAL,INTENT(OUT) :: KRET
INTEGER(KIND=JPIM) :: IRET
INTEGER(KIND=JPIM) :: ILEN
REAL(KIND=JPHOOK) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('BYTES_IO:BYTES_IO_WRITE_JPIB_REAL4_ARRAY',0,ZHOOK_HANDLE)
CALL C_BYTES_IO_WRITE(KFILE,PBUF,INT(KBYTES,JPIM),IRET)
IF(PRESENT(KRET)) THEN
  KRET=IRET
ENDIF
IF(IRET < JPBYTES_IO_SUCCESS ) THEN
  WRITE(0,*) 'BYTES_IO_WRITE_JPIB_REAL4_ARRAY ',KFILE,' ',KBYTES,' FAILED',IRET
  CALL MPL_ABORT('BYTES_IO_WRITE_JPIB_REAL4_ARRAY FAILED')
ENDIF
IF (LHOOK) CALL DR_HOOK('BYTES_IO:BYTES_IO_WRITE_JPIB_REAL4_ARRAY',1,ZHOOK_HANDLE)
END SUBROUTINE BYTES_IO_WRITE_JPIB_REAL4_ARRAY

SUBROUTINE BYTES_IO_WRITE_JPIB_REAL4_ARRAY2(KFILE,PBUF,KBYTES,KRET)
  INTEGER(KIND=JPIM),INTENT(IN)    :: KFILE
  REAL(KIND=JPRM),INTENT(IN)       :: PBUF(:,:)
  INTEGER(KIND=JPIB),INTENT(IN)    :: KBYTES
  INTEGER(KIND=JPIM),OPTIONAL,INTENT(OUT) :: KRET
  INTEGER(KIND=JPIM) :: IRET
  INTEGER(KIND=JPIM) :: ILEN
  REAL(KIND=JPHOOK) :: ZHOOK_HANDLE
  IF (LHOOK) CALL DR_HOOK('BYTES_IO:BYTES_IO_WRITE_JPIB_REAL4_ARRAY2',0,ZHOOK_HANDLE)
  CALL C_BYTES_IO_WRITE(KFILE,PBUF,INT(KBYTES,JPIM),IRET)
  IF(PRESENT(KRET)) THEN
    KRET=IRET
  ENDIF
  IF(IRET < JPBYTES_IO_SUCCESS ) THEN
    WRITE(0,*) 'BYTES_IO_WRITE_JPIB_REAL4_ARRAY2 ',KFILE,' ',KBYTES,' FAILED',IRET
    CALL MPL_ABORT('BYTES_IO_WRITE_JPIB_REAL4_ARRAY2 FAILED')
  ENDIF
  IF (LHOOK) CALL DR_HOOK('BYTES_IO:BYTES_IO_WRITE_JPIB_REAL4_ARRAY2',1,ZHOOK_HANDLE)
END SUBROUTINE BYTES_IO_WRITE_JPIB_REAL4_ARRAY2

SUBROUTINE BYTES_IO_WRITE_JPIB_REAL8(KFILE,PBUF,KBYTES,KRET)
INTEGER(KIND=JPIM),INTENT(IN)    :: KFILE
REAL(KIND=JPRD),INTENT(IN)    :: PBUF
INTEGER(KIND=JPIB),INTENT(IN)    :: KBYTES
INTEGER(KIND=JPIM),OPTIONAL,INTENT(OUT) :: KRET
INTEGER(KIND=JPIM) :: IRET
INTEGER(KIND=JPIM) :: ILEN
REAL(KIND=JPHOOK) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('BYTES_IO:BYTES_IO_WRITE_JPIB_REAL8',0,ZHOOK_HANDLE)
CALL C_BYTES_IO_WRITE(KFILE,PBUF,INT(KBYTES,JPIM),IRET)
IF(PRESENT(KRET)) THEN
  KRET=IRET
ENDIF
IF(IRET < JPBYTES_IO_SUCCESS ) THEN
  WRITE(0,*) 'BYTES_IO_WRITE_JPIB_REAL8 ',KFILE,' ',KBYTES,' FAILED',IRET
  CALL MPL_ABORT('BYTES_IO_WRITE_JPIB_REAL8 FAILED')
ENDIF
IF (LHOOK) CALL DR_HOOK('BYTES_IO:BYTES_IO_WRITE_JPIB_REAL8',1,ZHOOK_HANDLE)
END SUBROUTINE BYTES_IO_WRITE_JPIB_REAL8

SUBROUTINE BYTES_IO_WRITE_JPIB_REAL8_ARRAY(KFILE,PBUF,KBYTES,KRET)
INTEGER(KIND=JPIM),INTENT(IN)    :: KFILE
REAL(KIND=JPRD),INTENT(IN)       :: PBUF(:)
INTEGER(KIND=JPIB),INTENT(IN)    :: KBYTES
INTEGER(KIND=JPIM),OPTIONAL,INTENT(OUT) :: KRET
INTEGER(KIND=JPIM) :: IRET
INTEGER(KIND=JPIM) :: ILEN
REAL(KIND=JPHOOK) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('BYTES_IO:BYTES_IO_WRITE_JPIB_REAL8_ARRAY',0,ZHOOK_HANDLE)
CALL C_BYTES_IO_WRITE(KFILE,PBUF,INT(KBYTES,JPIM),IRET)
IF(PRESENT(KRET)) THEN
  KRET=IRET
ENDIF
IF(IRET < JPBYTES_IO_SUCCESS ) THEN
  WRITE(0,*) 'BYTES_IO_WRITE_JPIB_REAL8_ARRAY ',KFILE,' ',KBYTES,' FAILED',IRET
  CALL MPL_ABORT('BYTES_IO_WRITE_JPIB_REAL8_ARRAY FAILED')
ENDIF
IF (LHOOK) CALL DR_HOOK('BYTES_IO:BYTES_IO_WRITE_JPIB_REAL8_ARRAY',1,ZHOOK_HANDLE)
END SUBROUTINE BYTES_IO_WRITE_JPIB_REAL8_ARRAY

SUBROUTINE BYTES_IO_WRITE_JPIB_REAL8_ARRAY2(KFILE,PBUF,KBYTES,KRET)
  INTEGER(KIND=JPIM),INTENT(IN)    :: KFILE
  REAL(KIND=JPRD),INTENT(IN)       :: PBUF(:,:)
  INTEGER(KIND=JPIB),INTENT(IN)    :: KBYTES
  INTEGER(KIND=JPIM),OPTIONAL,INTENT(OUT) :: KRET
  INTEGER(KIND=JPIM) :: IRET
  INTEGER(KIND=JPIM) :: ILEN
  REAL(KIND=JPHOOK) :: ZHOOK_HANDLE
  IF (LHOOK) CALL DR_HOOK('BYTES_IO:BYTES_IO_WRITE_JPIB_REAL8_ARRAY2',0,ZHOOK_HANDLE)
  CALL C_BYTES_IO_WRITE(KFILE,PBUF,INT(KBYTES,JPIM),IRET)
  IF(PRESENT(KRET)) THEN
    KRET=IRET
  ENDIF
  IF(IRET < JPBYTES_IO_SUCCESS ) THEN
    WRITE(0,*) 'BYTES_IO_WRITE_JPIB_REAL8_ARRAY2 ',KFILE,' ',KBYTES,' FAILED',IRET
    CALL MPL_ABORT('BYTES_IO_WRITE_JPIB_REAL8_ARRAY2 FAILED')
  ENDIF
  IF (LHOOK) CALL DR_HOOK('BYTES_IO:BYTES_IO_WRITE_JPIB_REAL8_ARRAY2',1,ZHOOK_HANDLE)
END SUBROUTINE BYTES_IO_WRITE_JPIB_REAL8_ARRAY2

SUBROUTINE BYTES_IO_WRITE_JPIB_CHAR_ARRAY(KFILE,CDBUF,KBYTES,KRET)
INTEGER(KIND=JPIM),INTENT(IN)    :: KFILE
CHARACTER(LEN=1)  ,INTENT(IN)    :: CDBUF(:)
INTEGER(KIND=JPIB),INTENT(IN) :: KBYTES
INTEGER(KIND=JPIM),INTENT(OUT), OPTIONAL :: KRET
INTEGER(KIND=JPIM) :: IRET
REAL(KIND=JPHOOK) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('BYTES_IO:BYTES_IO_WRITE_JPIB_CHAR_ARRAY',0,ZHOOK_HANDLE)
CALL C_BYTES_IO_WRITE(KFILE,CDBUF,INT(KBYTES,JPIM),IRET)
IF(PRESENT(KRET)) THEN
  KRET=IRET
ELSEIF(IRET < JPBYTES_IO_SUCCESS) THEN
  WRITE(0,*) 'BYTES_IO_WRITE_JPIB_CHAR_ARRAY ',KFILE,' FAILED',IRET
  CALL MPL_ABORT('BYTES_IO_WRITE_JPIB_CHAR_ARRAY FAILED')
ENDIF
IF (LHOOK) CALL DR_HOOK('BYTES_IO:BYTES_IO_WRITE_JPIB_CHAR_ARRAY',1,ZHOOK_HANDLE)
END SUBROUTINE BYTES_IO_WRITE_JPIB_CHAR_ARRAY

END MODULE BYTES_IO_MOD

! (C) Copyright 2005- ECMWF.
! (C) Copyright 2013- Meteo-France.
! 
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!

MODULE MPL_MYGATHERV_MOD

USE EC_PARKIND  ,ONLY : JPRD, JPIM

USE MPL_MPIF
USE MPL_DATA_MODULE
USE MPL_MESSAGE_MOD

IMPLICIT NONE
PRIVATE
PUBLIC MPL_MYGATHERV

LOGICAL :: LLABORT=.TRUE.

CONTAINS

! ------------------------------------------------------------------
SUBROUTINE MPL_MYGATHERV(PSEND,KSEND,PRECV,KRECV,KDISPL,KROOT,KCOMM)


#ifdef USE_8_BYTE_WORDS
  USE MPI4TO8, ONLY : &
    MPI_GATHERV => MPI_GATHERV8
#endif


REAL(KIND=JPRD), INTENT(IN)  :: PSEND(:)
REAL(KIND=JPRD), INTENT(OUT) :: PRECV(:)
INTEGER(KIND=JPIM), INTENT(IN) :: KSEND, KRECV(:), KDISPL(:)
INTEGER(KIND=JPIM), INTENT(IN) :: KROOT, KCOMM
INTEGER(KIND=JPIM) :: IERR

CALL MPI_GATHERV(PSEND,KSEND,INT(MPI_REAL8), &
               & PRECV,KRECV,KDISPL,INT(MPI_REAL8),KROOT-1,KCOMM,IERR)

IF (IERR/=0) CALL MPL_MESSAGE(IERR,'MPL_MYGATHERV',LDABORT=LLABORT)

END SUBROUTINE MPL_MYGATHERV
! ------------------------------------------------------------------

END MODULE MPL_MYGATHERV_MOD

!(C) Copyright 2005- ECMWF.
! 
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!

!
! Simple Test program
!
subroutine fail_impl(msg,line)
  use mpl_module, only : mpl_abort
  character(*) :: msg
  integer :: line
  
  write(0,'(A,I0,A)') "TEST FAILED in scatterv.F90 @ line ",line," :"
  write(0,*) msg

  call mpl_abort()
  
end subroutine

#define FAIL(msg) call fail_impl(msg,__LINE__)

subroutine work1(r)
  implicit none
  integer, intent(out) :: r

  real a(100000)
  call  random_number(a)
  if (any(a < 0.0) ) then
    r =1
  else
    r =0
  endif
end subroutine work1


program test_mpl_scatterv
use ec_parkind, only : jpim, jprm, jprd
use mpl_module, only: mpl_init, mpl_end, mpl_rank, linitmpi_via_mpl, mpl_scatterv, JP_NON_BLOCKING_STANDARD, mpl_wait

implicit none

integer(jpim) :: nprocs


call mpl_init(KPROCS=nprocs,ldinfo=.false.,ldenv=.true.)

if( nprocs <= 1 ) FAIL("nprocs must be > 1")
if( mpl_rank < 1 .or. mpl_rank > nprocs  ) FAIL("mpl_rank must be >= 1 and <= nprocs")
if( .not. linitmpi_via_mpl ) FAIL("linitmpi_via_mpl must be True")

call do_scatterv("blocking")

call do_scatterv("nonblocking")

call mpl_end(ldmeminfo=.false.)
! Note that with mpi_serial meminfo will not be printed regardless of ldmeminfo

contains

  subroutine do_scatterv(mode)
    implicit none
    character(len=*), intent(in) :: mode

    character(len=128) :: msg
    integer request_i, request_r, request_d, request_c, i, j, k, res
    integer sdispl(nprocs), rcounts_c(nprocs)
    integer(jpim), allocatable :: sbuf(:), rbuf(:), scounts(:)
    integer(jpim) :: rcounts
    real(jprm), allocatable :: sbufr(:), rbufr(:)
    real(jprd), allocatable :: sbufd(:), rbufd(:)
    integer kroot

    allocate(rbuf(mpl_rank),sbuf((nprocs*(nprocs+1))/2+nprocs),&
        rbufr(mpl_rank),sbufr((nprocs*(nprocs+1))/2+nprocs), &
        rbufd(mpl_rank),sbufd((nprocs*(nprocs+1))/2+nprocs),&
        scounts(nprocs))
    k=1
    do i=1,nprocs
        do j=0,i-1
            sbuf(k+j)=i
            sbufr(k+j)=real(i)
            sbufd(k+j)=real(i,kind=jprd)
        enddo
        k=k+i
    enddo

    rcounts=mpl_rank
    do i=1,nprocs
      scounts(i)=i
    enddo

    kroot=2

    select case(mode)
    case("blocking")
      call mpl_scatterv(rbuf,kroot,sbuf,scounts)
      call mpl_scatterv(rbufr,kroot,sbufr,scounts)
      if (mpl_rank == kroot) then
        call mpl_scatterv(rbufd,kroot,sbufd,scounts)
      else
        call mpl_scatterv(rbufd,kroot)
      endif    
    case("nonblocking")
      ! trying to get a random failure
      do j=1,1
        if (mpl_rank == kroot ) then
          call mpl_scatterv(rbuf,kroot,sbuf,scounts, KMP_TYPE = JP_NON_BLOCKING_STANDARD, KREQUEST=request_i)
          call mpl_scatterv(rbufr,kroot,sbufr,scounts, KMP_TYPE = JP_NON_BLOCKING_STANDARD, KREQUEST=request_r)
          call mpl_scatterv(rbufd,kroot,sbufd,scounts, KMP_TYPE = JP_NON_BLOCKING_STANDARD, KREQUEST=request_d)
        else
          call mpl_scatterv(rbuf,kroot, KMP_TYPE = JP_NON_BLOCKING_STANDARD, KREQUEST=request_i)
          call mpl_scatterv(rbufr,kroot, KMP_TYPE = JP_NON_BLOCKING_STANDARD, KREQUEST=request_r)
          call mpl_scatterv(rbufd,kroot, KMP_TYPE = JP_NON_BLOCKING_STANDARD, KREQUEST=request_d)
        endif
          call work1(res)
        if ( res > 0 ) write(0,*) "error in work1 non-blocking alltoallv" ! this should not happen ever !!!
        call mpl_wait(request_r)
        call mpl_wait(request_d)
        call mpl_wait(request_i)
      enddo
    end select
    ! test values
    if ( any(rbuf /= mpl_rank) ) then
      !write(0,*) 'send ', mpl_rank, scounts, sbuf
      !write(0,*) 'recv ', mpl_rank, rcounts, rdispl
      write(msg,*) trim(mode)//" int scatterv test failed on mpl_rank", mpl_rank, rbuf
          FAIL(msg)
    endif
    if ( any(nint(rbufr) /= mpl_rank) ) then
      write(msg,*) trim(mode)//" real scatterv test failed on mpl_rank", mpl_rank, rbufr
      FAIL(msg)
    endif
    if ( any(nint(rbufd) /= mpl_rank) ) then
      write(msg,*) trim(mode)//" double scatterv test failed on mpl_rank", mpl_rank, rbufd
      FAIL(msg)
    endif

    ! test with displacement arguments
    k=1
    do i=1,nprocs
      sbuf(k)=-1
      sbufr(k)=-1.0
      sbufd(k)=-1.0
      do j=1,i
          sbuf(k+j)=i
          sbufr(k+j)=real(i)
          sbufd(k+j)=real(i,kind=jprd)
      enddo
      k=k+i+1
    enddo

  rcounts=mpl_rank
  do i=1,nprocs
    scounts(i)=i
    sdispl(i)=sum(scounts(1:i-1)) + i
  enddo

  kroot=1

  select case(mode)
  case("blocking")
    call mpl_scatterv(rbuf,kroot,sbuf,scounts,sdispl)
    call mpl_scatterv(rbufr,kroot,sbufr,scounts,sdispl)
    if (mpl_rank == kroot) then
      call mpl_scatterv(rbufd,kroot,sbufd,scounts,sdispl)
    else
      call mpl_scatterv(rbufd,kroot)
    endif    
  case("nonblocking")
    ! trying to get a random failure
    do j=1,1
      if (mpl_rank == kroot ) then
        call mpl_scatterv(rbuf,kroot,sbuf,scounts, sdispl, KMP_TYPE = JP_NON_BLOCKING_STANDARD, KREQUEST=request_i)
        call mpl_scatterv(rbufr,kroot,sbufr,scounts, sdispl, KMP_TYPE = JP_NON_BLOCKING_STANDARD, KREQUEST=request_r)
        call mpl_scatterv(rbufd,kroot,sbufd,scounts, sdispl, KMP_TYPE = JP_NON_BLOCKING_STANDARD, KREQUEST=request_d)
      else
        call mpl_scatterv(rbuf,kroot, KMP_TYPE = JP_NON_BLOCKING_STANDARD, KREQUEST=request_i)
        call mpl_scatterv(rbufr,kroot, KMP_TYPE = JP_NON_BLOCKING_STANDARD, KREQUEST=request_r)
        call mpl_scatterv(rbufd,kroot, KMP_TYPE = JP_NON_BLOCKING_STANDARD, KREQUEST=request_d)
      endif
        call work1(res)
      if ( res > 0 ) write(0,*) "error in work1 non-blocking alltoallv" ! this should not happen ever !!!
      call mpl_wait(request_r)
      call mpl_wait(request_d)
      call mpl_wait(request_i)
    enddo
  end select
  ! test values
  if ( any(rbuf /= mpl_rank) ) then
    !write(0,*) 'send ', mpl_rank, scounts, sbuf
    !write(0,*) 'recv ', mpl_rank, rcounts, rdispl
    write(msg,*) trim(mode)//" int scatterv with displ test failed on mpl_rank", mpl_rank, rbuf
        FAIL(msg)
  endif
  if ( any(nint(rbufr) /= mpl_rank) ) then
    write(msg,*) trim(mode)//" real scatterv with displ test failed on mpl_rank", mpl_rank, rbufr
    FAIL(msg)
  endif
  if ( any(nint(rbufd) /= mpl_rank) ) then
    write(msg,*) trim(mode)//" double scatterv with displ test failed on mpl_rank", mpl_rank, rbufd
    FAIL(msg)
  endif

      
  end subroutine do_scatterv

end program test_mpl_scatterv

! (C) Copyright 2005- ECMWF.
! (C) Copyright 2013- Meteo-France.
! 
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!

MODULE MPL_DATA_MODULE

!     Author.
!     -------
!        D.Dent, M.Hamrud     ECMWF

!     Modifications.
!     --------------
!        Original: 2000-09-01

!     ------------------------------------------------------------------

!      variables controlling the execution of MPL

!  MPL_METHOD   : buffering type
!  MPL_MBX_SIZE : size of application mailbox, (bytes)
!                 used when MPL_METHOD=JP_BLOCKING_BUFFERED
!  MPL_COMM     : default communicator in use
!  MPL_COMM_OML : communicators for messages between corresponding OML-threads
!  MPL_UNIT     : Fortran I/O unit for messages (default=6)
!  MPL_ERRUNIT  : Fortran I/O unit for error messages (default=0)
!  MPL_OUTPUT   : controls contents of Output (see mpl_init_mod.F90 for values/default)
!  MPL_RANK     : rank of the process within MPL_COMM_OML(1)
!  MPL_NUMPROC  : number of processes in MPL_COMM_OML(1)
!  MPL_IDS      : array of processor numbers
!  LUSEHLMPI    : always use high level MPI calls (collective comm.)
!  LINITMPI_VIA_MPL : true if MPI has been initialized from within MPL_INIT()
!  LTHSAFEMPI   : Thread safe MPI, if .TRUE. (default)

USE MPL_MPIF , ONLY : MPI_COMM_WORLD
USE EC_PARKIND  ,ONLY : JPIM

IMPLICIT NONE

PRIVATE :: JPIM

SAVE

PUBLIC 

INTEGER(KIND=JPIM) :: MPL_METHOD, MPL_MBX_SIZE, MPL_UNIT=6, MPL_OUTPUT=1
INTEGER(KIND=JPIM) :: MPL_RANK=0,MPL_NUMPROC = -1,MPL_ERRUNIT=0
INTEGER(KIND=JPIM),ALLOCATABLE :: MPL_IDS(:)
INTEGER(KIND=JPIM) :: MPL_COMM
INTEGER(KIND=JPIM),ALLOCATABLE :: MPL_COMM_OML(:)
INTEGER(KIND=JPIM),ALLOCATABLE :: MPL_OPPONENT(:)
INTEGER(KIND=JPIM) :: MPL_NCPU_PER_NODE=1
INTEGER(KIND=JPIM) :: MPL_MAX_TASK_PER_NODE
INTEGER(KIND=JPIM),ALLOCATABLE :: MPL_TASK_PER_NODE(:)
INTEGER(KIND=JPIM) :: MPL_NNODES
LOGICAL :: LFULLNODES
INTEGER(KIND=JPIM) :: MPL_MYNODE=0
INTEGER(KIND=JPIM),ALLOCATABLE :: MPL_NODE(:)
INTEGER(KIND=JPIM),ALLOCATABLE :: MPL_NODE_TASKS(:,:)
!INTEGER_M,ALLOCATABLE :: MPL_ATTACHED_BUFFER(:)
!   needs to ge a TARGET for coexistence with MPE
INTEGER(KIND=JPIM),ALLOCATABLE,TARGET :: MPL_ATTACHED_BUFFER(:)
LOGICAL :: LUSEHLMPI
LOGICAL :: LINITMPI_VIA_MPL = .FALSE.
LOGICAL :: LTHSAFEMPI = .TRUE.
INTEGER(KIND=JPIM),PARAMETER :: JP_ATTACHED_BUFFER_BYTES    = JPIM
INTEGER(KIND=JPIM),PARAMETER :: JP_BLOCKING_STANDARD        = 1
INTEGER(KIND=JPIM),PARAMETER :: JP_BLOCKING_BUFFERED        = 2
INTEGER(KIND=JPIM),PARAMETER :: JP_BLOCKING_SYNCHRONOUS     = 3
INTEGER(KIND=JPIM),PARAMETER :: JP_BLOCKING_READY           = 4
INTEGER(KIND=JPIM),PARAMETER :: JP_NON_BLOCKING_STANDARD    = 5
INTEGER(KIND=JPIM),PARAMETER :: JP_NON_BLOCKING_BUFFERED    = 6
INTEGER(KIND=JPIM),PARAMETER :: JP_NON_BLOCKING_SYNCHRONOUS = 7
INTEGER(KIND=JPIM),PARAMETER :: JP_NON_BLOCKING_READY       = 8
LOGICAL :: LMPLUSERCOMM = .FALSE.
INTEGER(KIND=JPIM) :: MPLUSERCOMM = -1
INTEGER(KIND=JPIM) :: MPL_SEND_COUNT, MPL_SEND_BYTES
INTEGER(KIND=JPIM) :: MPL_RECV_COUNT, MPL_RECV_BYTES
INTEGER(KIND=JPIM) :: MPL_WORLD_RANK = -1
INTEGER(KIND=JPIM) :: MPL_WORLD_SIZE =  0

END MODULE MPL_DATA_MODULE

! (C) Copyright 2024- ECMWF.
! (C) Copyright 2024- Meteo-France.
!
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
!
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.

program fiat_test_drhook_nvtx_basic

use yomhook, only : jphook, dr_hook

implicit none

real(jphook) :: zhook_handle

call dr_hook('fiat_test_drhook_nvtx_basic',0,zhook_handle)

call sub (0)

call dr_hook('fiat_test_drhook_nvtx_basic',1,zhook_handle)

contains 

recursive subroutine sub (depth)

integer :: depth

character(len=128) :: clname
real(jphook) :: zhook_handle

integer :: i

if (depth > irand (2, 4)) return

do i = 1, len (clname)
  clname (i:i) = ' '
enddo

do i = 1, 16
  clname (i:i) = char (irand (ichar ('A'), ichar ('Z')))
enddo

do i = 1, depth
  write (*, '("  ")', advance='no') 
enddo

write (*, '(" - ",A)') clname (1:16)

call dr_hook(clname,0,zhook_handle)

call sleep (real (irand (10, 200)))


do i = 1, irand (1, 4)
  call sub (depth+1)
  call sleep (real (irand (10, 200)))
enddo

call dr_hook(clname,1,zhook_handle)

end subroutine

subroutine sleep (dt)

implicit none

real, intent (in) :: dt                

integer, dimension (8) :: t 
integer :: s1,s2,ms1,ms2  

call date_and_time(values=t)
ms1=(t(5)*3600+t(6)*60+t(7))*1000+t(8)

do 
  call date_and_time(values=t)
  ms2=(t(5)*3600+t(6)*60+t(7))*1000+t(8)
  if(ms2-ms1>=dt)exit
enddo

end subroutine sleep

integer function irand (k1, k2) 

integer :: k1, k2

integer*8, save :: x = 2713

x = modulo (16807_8 * x, 2147483647_8)

irand = k1 + modulo (x, int (k2-k1+1, 8)) 

end function

end program fiat_test_drhook_nvtx_basic

! (C) Copyright 2005- ECMWF.
! 
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!

! This program aborts from an OpenMP parallel region
! It can be called within a MPI-parallel context when "MPL=1" is set in the environment
! To enable DR_HOOK, set "DR_HOOK=1" in environment
program test_abor1
use oml_mod
use mpl_module
use yomhook
implicit none

#include "abor1.intfb.h"

call test_init()

if( MPL_RANK <= 1 ) write(0,'(A,I0)') "OML_MAX_THREADS = ", OML_MAX_THREADS()

!$OMP PARALLEL
if( OML_MY_THREAD() == OML_GET_NUM_THREADS() .AND. (MPL_RANK == MPL_NUMPROC .OR. MPL_NUMPROC < 0)) then
    if( do_abort() ) call abor1fl("test_abort.F90",__LINE__,"aborting from OpenMP parallel region")
endif
!$OMP END PARALLEL

call test_end()

contains

    subroutine test_init()
        use ec_env_mod, only : ec_setenv
        implicit none

        ! Only enables MPL when environment MPL=1
        if( mpl() ) then
            call mpl_init(LDINFO=.FALSE.)
        endif

        ! Only enables DR_HOOK when environment DR_HOOK=1
        call ec_setenv("DR_HOOK_SILENT","1",overwrite=.false.)
        call dr_hook_init() 
    end subroutine

    subroutine test_end()
        ! Should not reach here unless "ABORT=0" in environment
        if( mpl() ) then
            call mpl_barrier()
            call mpl_end(LDMEMINFO=.FALSE.)    
        endif
    end subroutine

    function do_abort() result(labort)
        logical :: labort
        character(len=512) :: env
        call get_environment_variable("ABORT",env)
        if( env == '0' ) then
            labort = .false.
        else
            labort = .true.
        endif
    end function

    function mpl() result(lmpl)
        logical :: lmpl
        character(len=512) :: env
        call get_environment_variable("MPL",env)
        if( env == '1' ) then
            lmpl = .true.
        else
            lmpl = .false.
        endif
    end function


end program

! (C) Copyright 2005- ECMWF.
! (C) Copyright 2013- Meteo-France.
! 
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!

MODULE MPL_TESTSOME_MOD

USE MPL_MPIF
USE EC_PARKIND, ONLY : JPIM
USE MPL_MESSAGE_MOD
IMPLICIT NONE

! P. Marguinaud : 01-Jan-2011 

! KARRAY_OF_REQUESTS  (see MPI_TESTSOME)
! KARRAY_OF_INDICES   (see MPI_TESTSOME)
! KARRAY_OF_INDICES1  pending requests
! KOUTCOUNT1          number of pending requests

PRIVATE
PUBLIC :: MPL_TESTSOME

CONTAINS

SUBROUTINE MPL_TESTSOME (KARRAY_OF_REQUESTS, KARRAY_OF_INDICES,      &
                       & KARRAY_OF_INDICES1, KOUTCOUNT, KOUTCOUNT1,  &
                       & KERROR, CDSTRING, LDWAIT)
INTEGER(KIND=JPIM), INTENT (IN)  :: KARRAY_OF_REQUESTS (:)
INTEGER(KIND=JPIM), INTENT (OUT) :: KARRAY_OF_INDICES (:)
INTEGER(KIND=JPIM), INTENT (OUT), OPTIONAL :: KARRAY_OF_INDICES1 (:)
INTEGER(KIND=JPIM), INTENT (OUT), OPTIONAL :: KOUTCOUNT
INTEGER(KIND=JPIM), INTENT (OUT), OPTIONAL :: KOUTCOUNT1
INTEGER(KIND=JPIM), INTENT (OUT), OPTIONAL :: KERROR
CHARACTER(LEN=*),   INTENT(IN),   OPTIONAL :: CDSTRING
LOGICAL,            INTENT(IN),   OPTIONAL :: LDWAIT

INTEGER(KIND=JPIM) :: IERROR
INTEGER(KIND=JPIM) :: IINCOUNT
INTEGER(KIND=JPIM) :: IOUTCOUNT
INTEGER(KIND=JPIM) :: IARRAY_OF_STATUSES (MPI_STATUS_SIZE, SIZE (KARRAY_OF_REQUESTS))
INTEGER(KIND=JPIM) :: II, IJ, IK
LOGICAL :: LLWAIT
LOGICAL :: LLABORT=.TRUE.



IINCOUNT = SIZE (KARRAY_OF_REQUESTS)
KARRAY_OF_INDICES = -1

LLWAIT = .FALSE.
IF (PRESENT (LDWAIT)) LLWAIT = LDWAIT

IF (LLWAIT) THEN
  CALL MPI_WAITSOME(IINCOUNT, KARRAY_OF_REQUESTS, IOUTCOUNT, &
                    KARRAY_OF_INDICES, IARRAY_OF_STATUSES, IERROR)
ELSE
  CALL MPI_TESTSOME(IINCOUNT, KARRAY_OF_REQUESTS, IOUTCOUNT, &
                    KARRAY_OF_INDICES, IARRAY_OF_STATUSES, IERROR)
ENDIF

IF (PRESENT (KOUTCOUNT)) THEN
  KOUTCOUNT = IOUTCOUNT
ENDIF

IF (PRESENT (KOUTCOUNT1)) THEN
  KOUTCOUNT1 = IINCOUNT - IOUTCOUNT
ENDIF

IF (PRESENT (KARRAY_OF_INDICES1)) THEN
  KARRAY_OF_INDICES1 = -1
  IJ = 1
  IK = 1
  DO II = 1, IINCOUNT
    IF (II .EQ. KARRAY_OF_INDICES (IJ)) THEN
      IJ = IJ + 1
    ELSE
      KARRAY_OF_INDICES1 (IK) = II
      IK = IK + 1
    ENDIF
  ENDDO
ENDIF

IF (PRESENT (KERROR)) THEN
  KERROR = IERROR
ELSE
  IF(IERROR /= 0) CALL MPL_MESSAGE(IERROR,'MPL_TESTSOME',CDSTRING,LDABORT=LLABORT)
ENDIF

END SUBROUTINE MPL_TESTSOME

END MODULE MPL_TESTSOME_MOD

C (C) Copyright 2005- ECMWF.
C (C) Copyright 2013- Meteo-France.
C 
C This software is licensed under the terms of the Apache Licence Version 2.0
C which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
C In applying this licence, ECMWF does not waive the privileges and immunities
C granted to it by virtue of its status as an intergovernmental organisation
C nor does it submit to any jurisdiction.
C

      subroutine mpi_ibsend
      call abort()
      return
      end

! (C) Copyright 2005- ECMWF.
! (C) Copyright 2013- Meteo-France.
! 
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!

MODULE MPL_LOCOMM_CREATE_MOD

!**** MPL_LOCOMM_CREATE Create a new communicator

!     Purpose.
!     --------
!     Create a new communicator from lowest N tasks in MPI_COMM_WORLD 
!     and set as default
                                                                                
!**   Interface.
!     ----------
!        CALL MPL_LOCOMM_CREATE

!        Input required arguments :
!        -------------------------
!           N     -  Number of tasks in New Communicator

!        Input optional arguments :
!        -------------------------

!        Output required arguments :
!        -------------------------
!           KCOMM -  New Communicator

!        Output optional arguments :
!        -------------------------
!           MPL_LOCOMM_CREATE aborts when an error is detected.
 
!     Author.
!     -------
!        J.Hague        

!     Modifications.
!     --------------
!        Original: 21/07/2003

!     ------------------------------------------------------------------

USE EC_PARKIND  ,ONLY : JPIM

USE MPL_MPIF
USE MPL_DATA_MODULE
USE MPL_MESSAGE_MOD

IMPLICIT NONE

PRIVATE
PUBLIC MPL_LOCOMM_CREATE

CONTAINS 


SUBROUTINE MPL_LOCOMM_CREATE(N,KCOMM)


#ifdef USE_8_BYTE_WORDS
  USE MPI4TO8, ONLY : &
    MPI_COMM_GROUP => MPI_COMM_GROUP8, MPI_GROUP_INCL => MPI_GROUP_INCL8, MPI_COMM_CREATE => MPI_COMM_CREATE8
#endif


INTEGER(KIND=JPIM),INTENT(OUT) :: KCOMM
INTEGER(KIND=JPIM),INTENT(IN)  :: N

INTEGER(KIND=JPIM) :: IRANK(N)
INTEGER(KIND=JPIM) :: J, IER, IGROUP, MPI_GROUP_WORLD
LOGICAL   :: LLABORT=.TRUE.

DO J=1,N
  IRANK(J)=J-1
ENDDO

CALL MPI_COMM_GROUP(MPL_COMM,MPI_GROUP_WORLD,IER)
IF (IER/=0) CALL MPL_MESSAGE(IER,'MPL_LOCOMM_CREATE: MPI_COMM_GROUP',LDABORT=LLABORT)

CALL MPI_GROUP_INCL(MPI_GROUP_WORLD,N,IRANK,IGROUP,IER)
IF (IER/=0) CALL MPL_MESSAGE(IER,'MPL_LOCOMM_CREATE: MPI_GROUP_INCL',LDABORT=LLABORT)

CALL MPI_COMM_CREATE(MPL_COMM,IGROUP,KCOMM,IER)
IF (IER/=0) CALL MPL_MESSAGE(IER,'MPL_LOCOMM_CREATE: MPI_COMM_CREATE',LDABORT=LLABORT)

RETURN

END SUBROUTINE MPL_LOCOMM_CREATE

END MODULE MPL_LOCOMM_CREATE_MOD

! (C) Copyright 2005- ECMWF.
! (C) Copyright 2013- Meteo-France.
! 
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!

SUBROUTINE CDRHOOKINIT(KRET)
!-- Makes sure Dr.Hook gets properly initialized from C-main program, too
USE EC_PARKIND  ,ONLY  : JPIM, JPRD
USE YOMHOOK   ,ONLY  : LHOOK, DR_HOOK_INIT
IMPLICIT NONE
INTEGER(KIND=JPIM), INTENT(OUT) :: KRET
CALL DR_HOOK_INIT()
IF (LHOOK) THEN
  KRET = 1 ! Dr.Hook is ON
ELSE
  KRET = 0 ! Dr.Hook is OFF
ENDIF
END SUBROUTINE CDRHOOKINIT

! (C) Copyright 2005- ECMWF.
! (C) Copyright 2013- Meteo-France.
! 
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!

SUBROUTINE DR_HOOK_UTIL_MULTI(LDHOOK,CDNAME,KCASE,PKEY,KPKEY,CDFILENAME,KSIZEINFO)
USE EC_PARKIND  ,ONLY : JPIM     ,JPRD
USE OML_MOD,ONLY : OML_GET_MAX_THREADS,OML_MY_THREAD
IMPLICIT NONE
LOGICAL,INTENT(INOUT)       :: LDHOOK
CHARACTER(LEN=*),INTENT(IN) :: CDNAME,CDFILENAME
INTEGER(KIND=JPIM),INTENT(IN) :: KPKEY, KCASE,KSIZEINFO
REAL(KIND=JPRD),INTENT(INOUT) :: PKEY(KPKEY)

LOGICAL,SAVE :: LL_FIRST_TIME = .TRUE.
REAL(KIND=JPRD) :: ZDUMMY
INTEGER(KIND=JPIM) :: IMYTID, ISILENT, IMAXTH

#include "dr_hook_util.h"

! -----------------------------------------------------------------

IF (.NOT.LDHOOK) RETURN
IF (LL_FIRST_TIME) THEN
  LL_FIRST_TIME = .FALSE.
  CALL DR_HOOK_UTIL(LDHOOK,'',-1,ZDUMMY,'',-1_JPIM)

  ! Approximately the very first OpenMP-loop
  IMAXTH = OML_GET_MAX_THREADS()
  ! trapfpe setting also for slave threads -- was missing
  !$OMP PARALLEL DO SCHEDULE(STATIC,1) PRIVATE(IMYTID,ISILENT) IF (IMAXTH > 1)
  DO IMYTID=1,IMAXTH
     ISILENT = 1 ! no verbosity
     IF (IMYTID == IMAXTH) ISILENT = 0 ! be verbose with the last thread
     CALL TRAPFPE_SLAVE_THREADS(ISILENT) ! see drhook.c; does not do anything on master thread
  ENDDO ! IMYTID=1,IMAXTH
  !$OMP END PARALLEL DO
ENDIF

!$OMP PARALLEL DO SCHEDULE(STATIC,1) PRIVATE(IMYTID)
DO IMYTID=1,KPKEY
  IF (KCASE == 0) THEN
    CALL C_DRHOOK_START(CDNAME, IMYTID, PKEY(IMYTID), CDFILENAME, KSIZEINFO)
  ELSE IF (KCASE == 1) THEN
    CALL C_DRHOOK_END  (CDNAME, IMYTID, PKEY(IMYTID), CDFILENAME, KSIZEINFO)
  ENDIF
ENDDO ! IMYTID=1,KPKEY
!$OMP END PARALLEL DO

END SUBROUTINE DR_HOOK_UTIL_MULTI

! (C) Copyright 2005- ECMWF.
! (C) Copyright 2013- Meteo-France.
! 
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!

MODULE MPL_INIT_MOD

!**** MPL_INIT - Initialises the Message passing environment

!     Purpose.
!     --------
!     Must be called before any other MPL routine.

!**   Interface.
!     ----------
!        CALL MPL_INIT

!        Input required arguments :
!        -------------------------
!           none

!        Input optional arguments :
!        -------------------------
!           KOUTPUT  -  Level of printing for MPL routines
!                       =0: none
!                       =1: intermediate (default)
!                       =2: full trace
!           KUNIT    -  Fortran Unit to receive printed trace
!           LDINFO   -  = .TRUE.  : Print informative msgs from MPL_INIT (default) 
!                       = .FALSE. : Do not print
!           LDENV    -  = .TRUE.  : Propagate environment variables across participating tasks (default)
!                       = .FALSE. : Do not propagate
!

!        Output required arguments :
!        -------------------------
!           none

!        Output optional arguments :
!        -------------------------
!           KERROR   -  return error code.     If not supplied, 
!                       MPL_INIT aborts when an error is detected.
!           KPROCS   -  Number of processes which have been initialised
!                       in the MPI_COMM_WORLD communicator
!
!     Author.
!     -------
!        D.Dent, M.Hamrud     ECMWF

!     Modifications.
!     --------------
!        Original: 2000-09-01
!        R. El Khatib  14-May-2007 Do not propagate environment if NECSX
!        S. Saarinen 04-Oct-2009 Reduced output & redefined MPL_COMM_OML(1)
!        P. Marguinaud 01-Jan-2011 Add LDENV argument
!        R. El Khatib  24-May-2011 Make MPI2 the default expectation.
!        P. Towers     3-Jul-2014 Add call to ec_cray_meminfo
!     ------------------------------------------------------------------

USE EC_PARKIND  ,ONLY : JPIM
USE OML_MOD, ONLY : OML_INIT, OML_GET_MAX_THREADS
USE MPL_MPIF
USE MPL_DATA_MODULE
USE MPL_MESSAGE_MOD
USE MPL_BUFFER_METHOD_MOD
USE MPL_TOUR_TABLE_MOD
USE MPL_LOCOMM_CREATE_MOD
USE MPL_ARG_MOD
USE EC_ENV_MOD, ONLY : EC_PUTENV, EC_NUMENV, EC_ENVIRON

IMPLICIT NONE

PUBLIC MPL_INIT

PRIVATE

CONTAINS 

SUBROUTINE MPL_INIT(KOUTPUT,KUNIT,KERROR,KPROCS,LDINFO,LDENV)

#ifdef USE_8_BYTE_WORDS
  USE MPI4TO8, ONLY : &
    MPI_INITIALIZED => MPI_INITIALIZED8, MPI_INIT => MPI_INIT8, &
    MPI_COMM_SIZE => MPI_COMM_SIZE8,     MPI_COMM_RANK => MPI_COMM_RANK8, &
    MPI_BCAST => MPI_BCAST8
#endif



INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL :: KOUTPUT,KUNIT
INTEGER(KIND=JPIM),INTENT(OUT),OPTIONAL :: KERROR,KPROCS
LOGICAL,INTENT(IN),OPTIONAL :: LDINFO,LDENV
INTEGER(KIND=JPIM) :: IERROR,IP,ICOMM,IRANK,JNODE,JROC,ISTA
INTEGER(KIND=JPIM) :: IMAX_THREADS, IRET, IROOT, INUM(2), ICOUNT
INTEGER(KIND=JPIM) :: IREQUIRED,IPROVIDED
INTEGER(KIND=JPIM) :: IWORLD_RANK, IWORLD_SIZE
INTEGER(KIND=JPIM) :: IME
LOGICAL            :: LLABORT=.TRUE., LLINFO
LOGICAL            :: LLINIT
LOGICAL            :: LLENV
CHARACTER(LEN=12)  :: CL_MBX_SIZE
CHARACTER(LEN=12)  :: CL_ARCH
CHARACTER(LEN=12)  :: CL_TASKSPERNODE
CHARACTER(LEN=1024):: CLENV
CHARACTER(LEN=20)  :: CL_METHOD,CL_HOST
CHARACTER(LEN=1)   :: CL_SET

IF(PRESENT(KOUTPUT)) THEN
  MPL_OUTPUT=MAX(0,KOUTPUT)
ELSE
  MPL_OUTPUT=1
ENDIF

IF(PRESENT(KUNIT)) THEN
  MPL_UNIT=MAX(0,KUNIT)
ELSE
  MPL_UNIT=6
ENDIF

IF(PRESENT(LDINFO)) THEN
  LLINFO = LDINFO
ELSE
  LLINFO = .TRUE.
ENDIF

IF(PRESENT(LDENV)) THEN
  LLENV = LDENV
ELSE
  LLENV = .TRUE.
ENDIF

IF(MPL_NUMPROC /= -1) THEN
!!  We do not want this extra message
!!  CALL MPL_MESSAGE(CDMESSAGE=' MPL_INIT CALLED MULTIPLE TIMES ')
  IF(PRESENT(KERROR)) THEN
    KERROR=0
  ENDIF
  IF(PRESENT(KPROCS)) THEN
    KPROCS=MPL_NUMPROC
  ENDIF
  RETURN
ENDIF

CALL MPI_INITIALIZED(LLINIT, IRET)

IF (.NOT.LLINIT) THEN

  CALL GET_ENVIRONMENT_VARIABLE('ARCH',CL_ARCH)


#ifndef MPI1
  IREQUIRED = MPI_THREAD_MULTIPLE
  IPROVIDED = MPI_THREAD_SINGLE
  CALL MPI_INIT_THREAD(IREQUIRED,IPROVIDED,IERROR)
  IF (IERROR /= 0) CALL ABOR1 ('MPL_INIT: MPI_INIT_THREAD FAILED')
  LTHSAFEMPI = (IPROVIDED >= IREQUIRED)
#else
  CALL MPI_INIT(IERROR)
  IF (IERROR /= 0) CALL ABOR1 ('MPL_INIT: MPI_INIT FAILED')
  LTHSAFEMPI = .FALSE.
#endif

CALL MPI_Comm_rank(MPI_COMM_WORLD, IME, IERROR)

! Print out thread safety etc. messages -- must use MPI_Comm_rank since MPL not initialized just yet
IF (IME == 0 .AND. LLINFO ) THEN
   WRITE(MPL_UNIT,'(4(A,I0),1(A,L1))') &
        & 'MPL_INIT : MPI_THREAD_MULTIPLE=',MPI_THREAD_MULTIPLE,' , MPI_THREAD_SINGLE=',MPI_THREAD_SINGLE,&
        &         ' , IREQUIRED=',IREQUIRED,' , IPROVIDED=',IPROVIDED,' , LTHSAFEMPI=',LTHSAFEMPI
ENDIF

  LINITMPI_VIA_MPL = .TRUE.
!  CALL ec_mpi_atexit() ! ifsaux/support/endian.c: to make sure MPI_FINALIZE gets called

ELSE
  IERROR = 0
ENDIF

IF(PRESENT(KERROR)) THEN
  KERROR=IERROR
ELSE
  IF(IERROR /= 0) THEN
    CALL MPL_MESSAGE(IERROR,CDMESSAGE=' MPL_INIT ERROR ',LDABORT=LLABORT)
  ENDIF
ENDIF

! If LMPLUSERCOMM is not set use MPI_COMM_WORLD
!mps: Sami Saarinen, 29-Nov-2016
! Must be set *AFTER* MPI_INIT*() has ben called (or LLINIT is true)
! Otherwise MPI_COMM_WORLD not defined (at least not in OpenMPI)
IF(LMPLUSERCOMM) THEN
   MPL_COMM = MPLUSERCOMM
ELSE
   MPL_COMM = MPI_COMM_WORLD
ENDIF

CALL MPI_COMM_SIZE(MPL_COMM,MPL_NUMPROC,IERROR)

IF(PRESENT(KPROCS)) THEN
  KPROCS=MPL_NUMPROC
ENDIF

ALLOCATE (MPL_IDS(MPL_NUMPROC))
DO IP=1,MPL_NUMPROC
  MPL_IDS(IP)=IP
ENDDO

CALL MPI_COMM_RANK(MPL_COMM, IRANK, IERROR)
MPL_RANK=IRANK+1

IF (MPL_RANK == 1) THEN
  ! Clean up possible lockfile which gets created within MPL_ABORT
  CALL TABORT_DELETE_LOCKFILE()
ENDIF

LLINFO = LLINFO .AND. (MPL_RANK <= 1)

IF (LLINFO) THEN
   IF(LMPLUSERCOMM) THEN
      WRITE(MPL_UNIT,'(2(A,I0))')'MPL_INIT : MPL_COMM=',MPL_COMM, ' (non-default) , MPL_NUMPROC=',MPL_NUMPROC
   ELSE
      WRITE(MPL_UNIT,'(2(A,I0))')'MPL_INIT : MPL_COMM=',MPL_COMM, ' (default) , MPL_NUMPROC=',MPL_NUMPROC
   ENDIF
ENDIF

!-- Propagate environment variables & argument lists
!   Here we have to be careful and use MPI_BCAST directly (not MPL_BROADCAST) since
!   1) MPL_BUFFER_METHOD has not been called
!   2) MPL_COMM_OML has not been initialized since it is possible that only the 
!      master proc knows the # of threads (i.e. OMP_NUM_THREADS may be set only for master)

! Do not propagate on nec machine because the environment variables could be mpi-task-specific.

IF (MPL_NUMPROC > 1 .AND. LLENV) THEN
  IROOT = 0
  !-- Progate environment variables
  INUM(1) = 0 ! The number of environment variables
  INUM(2) = 0 ! Do not (=0) or do (=1) overwrite if particular environment variable already exists (0 = default)
  IF (MPL_RANK == 1) THEN ! Master proc inquires
    INUM(1) = EC_NUMENV()
    CALL GET_ENVIRONMENT_VARIABLE("EC_OVERWRITE_ENV",CLENV)
    IF( CLENV == '1' ) INUM(2) = 1
  ENDIF
  ! The following broadcast does not use "mailbox" nor attached buffer, both potentially yet to be allocated
  CALL MPI_BCAST(INUM(1),2,INT(MPI_INTEGER),IROOT,MPL_COMM,IERROR)
  ICOUNT = LEN(CLENV)
  DO IP=1,INUM(1)
    IF (MPL_RANK == 1) CALL EC_ENVIRON(IP,CLENV)
    ! The following broadcast does not use "mailbox" nor attached buffer, both potentially yet to be allocated
    CALL MPI_BCAST(CLENV,ICOUNT,INT(MPI_BYTE),IROOT,MPL_COMM,IERROR)
    IF (MPL_RANK > 1) THEN
      IF (INUM(2) == 1) THEN
        CALL EC_PUTENV(CLENV,OVERWRITE=.TRUE.) ! ../support/env.c ; Unconditionally overwrite, even if already exists
      ELSE
        CALL EC_PUTENV(CLENV,OVERWRITE=.FALSE.) ! ../support/env.c ; Do not overwrite, if exists
      ENDIF
    ENDIF
  ENDDO
  !-- Propagate argument list (all under the bonnet using MPL_ARG_MOD-module)
  INUM = MPL_IARGC()
ENDIF

CALL OML_INIT()
IMAX_THREADS = OML_GET_MAX_THREADS()
ALLOCATE(MPL_COMM_OML(IMAX_THREADS))

IF (LMPLUSERCOMM) THEN
   MPL_COMM_OML(1) = MPLUSERCOMM
   ISTA = 2
ELSE
   ISTA = 1
ENDIF

DO IP=ISTA,IMAX_THREADS
  CALL MPL_LOCOMM_CREATE(MPL_NUMPROC,MPL_COMM_OML(IP))
ENDDO
MPL_COMM = MPL_COMM_OML(1) ! i.e. not necessary MPI_COMM_WORLD anymore

CL_METHOD=' '
CALL GET_ENVIRONMENT_VARIABLE('MPL_METHOD',CL_METHOD)
IF (CL_METHOD == 'JP_BLOCKING_STANDARD' ) THEN
  MPL_METHOD=JP_BLOCKING_STANDARD
ELSE
  MPL_METHOD=JP_BLOCKING_BUFFERED
ENDIF
MPL_MBX_SIZE=1000000
CL_MBX_SIZE=' '
CALL GET_ENVIRONMENT_VARIABLE('MPL_MBX_SIZE',CL_MBX_SIZE)
IF (CL_MBX_SIZE /= ' ') THEN
  READ(CL_MBX_SIZE,*) MPL_MBX_SIZE
ENDIF
IF (CL_METHOD == 'JP_BLOCKING_STANDARD' ) THEN
  IF (LLINFO) WRITE(MPL_UNIT,'(A,I0)')'MPL_INIT : MPL_METHOD=JP_BLOCKING_STANDARD , MPL_MBX_SIZE=',MPL_MBX_SIZE
ELSE
  IF (LLINFO) WRITE(MPL_UNIT,'(A,I0)')'MPL_INIT : MPL_METHOD=JP_BLOCKING_BUFFERED , MPL_MBX_SIZE=',MPL_MBX_SIZE
ENDIF

CALL MPL_BUFFER_METHOD(KMP_TYPE=MPL_METHOD,KMBX_SIZE=MPL_MBX_SIZE,LDINFO=.FALSE.)
LUSEHLMPI = .TRUE.

CALL MPI_COMM_RANK (MPI_COMM_WORLD, IWORLD_RANK, IERROR)
CALL MPI_COMM_SIZE (MPI_COMM_WORLD, IWORLD_SIZE, IERROR)

#ifdef LINUX
CALL LINUX_BIND (IWORLD_RANK, IWORLD_SIZE)
#endif

!-- World-wide tasks
MPL_WORLD_RANK = IWORLD_RANK
MPL_WORLD_SIZE = IWORLD_SIZE

!!!! If you are not at ECMWF this may need changing!!!!
CALL GET_ENVIRONMENT_VARIABLE('EC_TASKS_PER_NODE',CL_TASKSPERNODE)
IF (CL_TASKSPERNODE(1:1) == ' ' ) THEN
   CALL GET_ENVIRONMENT_VARIABLE('HOST',CL_HOST)
   IF(CL_HOST(1:3) == 'cck') THEN ! KNL
      MPL_NCPU_PER_NODE=64
   ELSEIF(CL_HOST(1:3) == 'cct') THEN ! Test-cluster
      MPL_NCPU_PER_NODE=24
   ELSEIF(CL_HOST(1:2) == 'cc') THEN ! cca/ccb
      MPL_NCPU_PER_NODE=36
   ELSEIF(CL_HOST(1:3) == 'lxg') THEN ! GPU-cluster
      MPL_NCPU_PER_NODE=24
   ELSEIF (CL_HOST(1:2) == 'c1') THEN
      MPL_NCPU_PER_NODE=64
   ELSEIF(CL_HOST(1:3) == 'hpc') THEN
      MPL_NCPU_PER_NODE=32
   ELSE
      MPL_NCPU_PER_NODE=1
      !IF(LLINFO) WRITE(MPL_UNIT,'(A)')'MPL_INIT : MPL_NCPU_PER_NODE = 1 (CAUTION: could not be inferred from hostname!)'
   ENDIF
ELSE
   READ(CL_TASKSPERNODE,*) MPL_NCPU_PER_NODE  
ENDIF
MPL_MAX_TASK_PER_NODE=MAX(1, MPL_NCPU_PER_NODE/IMAX_THREADS)
LFULLNODES=MOD(MPL_NUMPROC,MPL_MAX_TASK_PER_NODE) == 0
MPL_NNODES=(MPL_NUMPROC-1)/MPL_MAX_TASK_PER_NODE+1

ALLOCATE(MPL_TASK_PER_NODE(MPL_NNODES))
ALLOCATE(MPL_NODE(MPL_NUMPROC))
ALLOCATE(MPL_NODE_TASKS(MPL_NNODES,MPL_MAX_TASK_PER_NODE))
MPL_NODE_TASKS(:,:)=-99
ICOUNT=0
DO JNODE=1,MPL_NNODES
  DO JROC=1,MPL_MAX_TASK_PER_NODE
    ICOUNT=ICOUNT+1
    IF (ICOUNT<=MPL_NUMPROC) THEN
       MPL_NODE(ICOUNT)=JNODE
       MPL_TASK_PER_NODE(JNODE) = JROC
       MPL_NODE_TASKS(JNODE,JROC) = ICOUNT
    ENDIF
  ENDDO
ENDDO
MPL_MYNODE=(MPL_RANK-1)/MPL_MAX_TASK_PER_NODE+1
!WRITE(MPL_UNIT,*) 'MPL_INIT : NCPU_PER_NODE,MPL_MAX_TASK_PER_NODE,MPL_NNODES,MPL_MYNODE ',&
! & MPL_NCPU_PER_NODE,MPL_MAX_TASK_PER_NODE,MPL_NNODES,MPL_MYNODE
!WRITE(MPL_UNIT,*) 'MPL_INIT : MPL_NODE_TASKS(MPL_MYNODE,1:MPL_TASK_PER_NODE(MPL_MYNODE)) ', &
! & MPL_NODE_TASKS(MPL_MYNODE,1:MPL_TASK_PER_NODE(MPL_MYNODE))

ALLOCATE(MPL_OPPONENT(MPL_NUMPROC+1))
CALL MPL_TOUR_TABLE(MPL_OPPONENT)

RETURN
END SUBROUTINE MPL_INIT

END MODULE MPL_INIT_MOD

! (C) Copyright 2005- ECMWF.
! (C) Copyright 2013- Meteo-France.
!
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!

MODULE MPL_ALLGATHERV_MOD

!**** MPL_ALLGATHERV Send data to all processes

!     Purpose.
!     --------
!     Send a message to all processes from a buffer.
!     The data may be REAL*4, REAL*8,or INTEGER, one dimensional array
!                     REAL*4,or REAL*8, two dimensional array
!                  or INTEGER scalar

!**   Interface.
!     ----------
!        CALL MPL_ALLGATHERV

!        Input required arguments :
!        -------------------------
!           PSENDBUF -  buffer containing message
!                       (can be type REAL*4, REAL*8 or INTEGER)
!           PRECVBUF -  buffer containing message
!                       (can be type REAL*4, REAL*8 or INTEGER)
!           KRECVCOUNTS-number of elements received from each process

!        Input optional arguments :
!        -------------------------
!           KCOMM    -  Communicator number if different from MPI_COMM_WORLD
!                       or from that established as the default
!                       by an MPL communicator routine
!           KMP_TYPE -  buffering type (see MPL_BUFFER_METHOD)
!                       overrides value provided to MPL_BUFFER_METHOD
!           KRECVDISPL -displacements in PRECVBUF at which to place
!                       the incoming data
!           CDSTRING -  Character string for ABORT messages
!                       used when KERROR is not provided

!        Output required arguments :
!        -------------------------
!           none

!        Output optional arguments :
!        -------------------------
!           KREQUEST -  Communication request
!                       required when buffering type is non-blocking
!           KERROR   -  return error code.     If not supplied,
!                       MPL_ALLGATHERV aborts when an error is detected.
!     Author.
!     -------
!        D.Dent, M.Hamrud     ECMWF

!     Modifications.
!     --------------
!        Original:   2000-11-23
!        J.Hague:    2004-12-15 : Threadsafe
!        M.Hamrud:   2014-10-22 : Add nonblocking option
!        F.Vana:     2015-03-05 : Support for single precision
!        P.Gillies:  2018-05-30 : Add KSENDCOUNT argument, needed for zero length sends

!     ------------------------------------------------------------------

USE EC_PARKIND, ONLY : JPRD, JPIM ,JPRM
USE OML_MOD,    ONLY : OML_MY_THREAD

USE MPL_MPI,                  ONLY : MPI_REQUEST, MPI_COMM, MPI_REAL4, MPI_REAL8, MPI_INTEGER
USE MPL_DATA_MODULE,          ONLY : MPL_NUMPROC, MPL_COMM_OML, MPL_METHOD, MPL_UNIT, MPL_OUTPUT, &
 &                                   JP_BLOCKING_STANDARD, JP_BLOCKING_BUFFERED, &
 &                                   JP_NON_BLOCKING_STANDARD, JP_NON_BLOCKING_BUFFERED
USE MPL_STATS_MOD,            ONLY : MPL_RECVSTATS, MPL_SENDSTATS
USE YOMMPLSTATS,              ONLY : LMPLSTATS
USE MPL_MESSAGE_MOD,          ONLY : MPL_MESSAGE
USE MPL_DISPLS_CONTAINER_MOD, ONLY : YDDISPLS_LIST

IMPLICIT NONE

PRIVATE

LOGICAL   :: LLABORT=.TRUE.
LOGICAL   :: LLBARRIER

INTERFACE MPL_ALLGATHERV
   MODULE PROCEDURE MPL_ALLGATHERV_REAL8,MPL_ALLGATHERV_REAL4,&
      MPL_ALLGATHERV_INT,  MPL_ALLGATHERV_INT_SCALAR
END INTERFACE

PUBLIC MPL_ALLGATHERV

CONTAINS


SUBROUTINE MPL_ALLGATHERV_REAL4(PSENDBUF,PRECVBUF,KRECVCOUNTS,KSENDCOUNT,KRECVDISPL, &
& KMP_TYPE,KCOMM,KERROR,KREQUEST,CDSTRING)

#ifdef USE_8_BYTE_WORDS
USE MPI4TO8, ONLY : &
   MPI_COMM_SIZE => MPI_COMM_SIZE8, MPI_ALLGATHERV => MPI_ALLGATHERV8
#endif

IMPLICIT NONE
REAL(KIND=JPRM)            :: PSENDBUF(:)
REAL(KIND=JPRM)            :: PRECVBUF(:)
INTEGER(KIND=JPIM),INTENT(IN) :: KRECVCOUNTS(:)
INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL :: KSENDCOUNT
INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL :: KRECVDISPL(:),KCOMM,KMP_TYPE
INTEGER(KIND=JPIM),INTENT(OUT),OPTIONAL :: KERROR,KREQUEST
CHARACTER(LEN=*),INTENT(IN),OPTIONAL :: CDSTRING
TARGET :: KRECVDISPL

TYPE(MPI_REQUEST)  :: IREQUEST_LOCAL
INTEGER(KIND=JPIM) :: IR,ISENDCOUNT,IRECVCOUNT
INTEGER(KIND=JPIM) :: IMP_TYPE
INTEGER(KIND=JPIM) :: IERROR,IPL_NUMPROC
TYPE(MPI_COMM)     :: ICOMM
INTEGER(KIND=JPIM) :: ITID
INTEGER(KIND=JPIM), TARGET, ALLOCATABLE :: IRECVDISPL(:)
INTEGER(KIND=JPIM), POINTER :: IRECVDISPL_PT(:)
LOGICAL :: LKRECVCOUNTS = .TRUE. ! .TRUE. if KRECVCOUNTS is present (used in _int_scalar version)
INTEGER(KIND=JPIM) :: IRECVCOUNTS(1) ! needed for _int_scalar version preamble

ITID = OML_MY_THREAD()
IF(PRESENT(KSENDCOUNT)) THEN
   ISENDCOUNT = KSENDCOUNT
ELSE
   ISENDCOUNT = SIZE(PSENDBUF)
   ISENDCOUNT = MAX(0,ISENDCOUNT)  ! Bug? on IBM
ENDIF
IRECVCOUNT = SIZE(PRECVBUF)

!--------- Preamble repeated for threadsafe--------------
#include "mpl_allgatherv_preamble.i90"
!--------- End of Preamble --------------


IF(IMP_TYPE == JP_BLOCKING_STANDARD .OR. IMP_TYPE == JP_BLOCKING_BUFFERED) THEN
 CALL MPI_ALLGATHERV(PSENDBUF,ISENDCOUNT,MPI_REAL4,PRECVBUF,&
   & KRECVCOUNTS,IRECVDISPL_PT,MPI_REAL4,ICOMM,IERROR)
ELSEIF(IMP_TYPE == JP_NON_BLOCKING_STANDARD .OR. IMP_TYPE == JP_NON_BLOCKING_BUFFERED) THEN
 CALL MPI_IALLGATHERV(PSENDBUF,ISENDCOUNT,MPI_REAL4,PRECVBUF,&
   & KRECVCOUNTS,IRECVDISPL_PT,MPI_REAL4,ICOMM,IREQUEST_LOCAL,IERROR)
 KREQUEST=IREQUEST_LOCAL%MPI_VAL
 IF(.NOT. PRESENT(KRECVDISPL)) THEN
    CALL YDDISPLS_LIST%APPEND(KREQ=KREQUEST,NO_NEW_NODE=.TRUE.)
 ENDIF
ENDIF
IF(LMPLSTATS) THEN
  CALL MPL_SENDSTATS(ISENDCOUNT,MPI_REAL4%MPI_VAL)
  CALL MPL_RECVSTATS(SUM(KRECVCOUNTS),MPI_REAL4%MPI_VAL)
ENDIF

IF(MPL_OUTPUT > 1 )THEN
   WRITE(MPL_UNIT,'(A,5I8)') ' MPL_ALLGATHERV ',ISENDCOUNT,IRECVCOUNT,ICOMM
ENDIF
IF(PRESENT(KERROR)) THEN
   KERROR=IERROR
ELSE
  IF(IERROR /= 0 ) CALL MPL_MESSAGE(CDMESSAGE='MPL_ALLGATHERV',&
   & CDSTRING=CDSTRING,KERROR=IERROR,LDABORT=LLABORT)
ENDIF

END SUBROUTINE MPL_ALLGATHERV_REAL4

SUBROUTINE MPL_ALLGATHERV_REAL8(PSENDBUF,PRECVBUF,KRECVCOUNTS,KSENDCOUNT,KRECVDISPL, &
& KMP_TYPE,KCOMM,KERROR,KREQUEST,CDSTRING)

#ifdef USE_8_BYTE_WORDS
USE MPI4TO8, ONLY : &
   MPI_COMM_SIZE => MPI_COMM_SIZE8, MPI_ALLGATHERV => MPI_ALLGATHERV8
#endif

IMPLICIT NONE
REAL(KIND=JPRD)            :: PSENDBUF(:)
REAL(KIND=JPRD)            :: PRECVBUF(:)
INTEGER(KIND=JPIM),INTENT(IN) :: KRECVCOUNTS(:)
INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL :: KSENDCOUNT
INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL :: KRECVDISPL(:),KCOMM,KMP_TYPE
INTEGER(KIND=JPIM),INTENT(OUT),OPTIONAL :: KERROR,KREQUEST
CHARACTER(LEN=*),INTENT(IN),OPTIONAL :: CDSTRING
TARGET :: KRECVDISPL

TYPE(MPI_REQUEST)  :: IREQUEST_LOCAL
INTEGER(KIND=JPIM) :: IR,ISENDCOUNT,IRECVCOUNT
INTEGER(KIND=JPIM) :: IMP_TYPE
INTEGER(KIND=JPIM) :: IERROR,IPL_NUMPROC
TYPE(MPI_COMM)     :: ICOMM
INTEGER(KIND=JPIM) :: ITID,J
INTEGER(KIND=JPIM),ALLOCATABLE,TARGET :: IRECVDISPL(:)
INTEGER(KIND=JPIM), POINTER :: IRECVDISPL_PT(:)
LOGICAL :: LKRECVCOUNTS = .TRUE. ! .TRUE. if KRECVCOUNTS is present (used in _int_scalar version)
INTEGER(KIND=JPIM) :: IRECVCOUNTS(1) ! needed for _int_scalar version preamble

ITID = OML_MY_THREAD()
IF(PRESENT(KSENDCOUNT)) THEN
   ISENDCOUNT = KSENDCOUNT
ELSE
   ISENDCOUNT = SIZE(PSENDBUF)
   ISENDCOUNT = MAX(0,ISENDCOUNT)  ! Bug? on IBM
ENDIF
IRECVCOUNT = SIZE(PRECVBUF)

!--------- Preamble repeated for threadsafe--------------
#include "mpl_allgatherv_preamble.i90"
!!--------- End of Preamble --------------

IERROR=0

IF(IMP_TYPE == JP_BLOCKING_STANDARD .OR. IMP_TYPE == JP_BLOCKING_BUFFERED) THEN
  CALL MPI_ALLGATHERV(PSENDBUF,ISENDCOUNT,MPI_REAL8,PRECVBUF,&
   & KRECVCOUNTS,IRECVDISPL_PT,MPI_REAL8,ICOMM,IERROR)
ELSEIF(IMP_TYPE == JP_NON_BLOCKING_STANDARD .OR. IMP_TYPE == JP_NON_BLOCKING_BUFFERED) THEN
  CALL MPI_IALLGATHERV(PSENDBUF,ISENDCOUNT,MPI_REAL8,PRECVBUF,&
   & KRECVCOUNTS,IRECVDISPL_PT,MPI_REAL8,ICOMM,IREQUEST_LOCAL,IERROR)
  KREQUEST=IREQUEST_LOCAL%MPI_VAL
  IF(.NOT. PRESENT(KRECVDISPL)) THEN
    CALL YDDISPLS_LIST%APPEND(KREQ=KREQUEST,NO_NEW_NODE=.TRUE.)
  ENDIF
ENDIF

IF(LMPLSTATS) THEN
  CALL MPL_SENDSTATS(ISENDCOUNT,MPI_REAL8%MPI_VAL)
  CALL MPL_RECVSTATS(SUM(KRECVCOUNTS),MPI_REAL8%MPI_VAL)
ENDIF

IF(MPL_OUTPUT > 1 )THEN
   WRITE(MPL_UNIT,'(A,5I8)') ' MPL_ALLGATHERV ',ISENDCOUNT,IRECVCOUNT,ICOMM
ENDIF
IF(PRESENT(KERROR)) THEN
   KERROR=IERROR
ELSE
  IF(IERROR /= 0 ) CALL MPL_MESSAGE(CDMESSAGE='MPL_ALLGATHERV',CDSTRING=CDSTRING,KERROR=IERROR,&
   & LDABORT=LLABORT)
ENDIF

END SUBROUTINE MPL_ALLGATHERV_REAL8

SUBROUTINE MPL_ALLGATHERV_INT(KSENDBUF,KRECVBUF,KRECVCOUNTS,KSENDCOUNT,KRECVDISPL, &
& KMP_TYPE,KCOMM,KERROR,KREQUEST,CDSTRING)

#ifdef USE_8_BYTE_WORDS
USE MPI4TO8, ONLY : &
   MPI_COMM_SIZE => MPI_COMM_SIZE8, MPI_ALLGATHERV => MPI_ALLGATHERV8
#endif

IMPLICIT NONE
INTEGER(KIND=JPIM)         :: KSENDBUF(:)
INTEGER(KIND=JPIM)         :: KRECVBUF(:)
INTEGER(KIND=JPIM),INTENT(IN) :: KRECVCOUNTS(:)
INTEGER(KIND=JPIM),INTENT(IN), OPTIONAL :: KSENDCOUNT
INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL :: KRECVDISPL(:),KCOMM,KMP_TYPE
INTEGER(KIND=JPIM),INTENT(OUT),OPTIONAL :: KERROR,KREQUEST
CHARACTER(LEN=*),INTENT(IN),OPTIONAL :: CDSTRING
TARGET :: KRECVDISPL

TYPE(MPI_REQUEST)  :: IREQUEST_LOCAL
INTEGER(KIND=JPIM) :: IR,ISENDCOUNT,IRECVCOUNT
INTEGER(KIND=JPIM) :: IMP_TYPE
INTEGER(KIND=JPIM) :: IERROR,IPL_NUMPROC
TYPE(MPI_COMM)     :: ICOMM
INTEGER(KIND=JPIM) :: ITID
INTEGER(KIND=JPIM),ALLOCATABLE,TARGET :: IRECVDISPL(:)
INTEGER(KIND=JPIM), POINTER :: IRECVDISPL_PT(:)
LOGICAL :: LKRECVCOUNTS = .TRUE. ! .TRUE. if KRECVCOUNTS is present (used in _int_scalar version)
INTEGER(KIND=JPIM) :: IRECVCOUNTS(1) ! needed for _int_scalar version preamble

ITID = OML_MY_THREAD()
IF(PRESENT(KSENDCOUNT)) THEN
   ISENDCOUNT = KSENDCOUNT
ELSE
   ISENDCOUNT = SIZE(KSENDBUF)
   ISENDCOUNT = MAX(0,ISENDCOUNT)  ! Bug? on IBM
ENDIF
IRECVCOUNT = SIZE(KRECVBUF)

!--------- Preamble repeated for threadsafe--------------
#include "mpl_allgatherv_preamble.i90"
!--------- End of Preamble --------------

IERROR=0
IF(IMP_TYPE == JP_BLOCKING_STANDARD .OR. IMP_TYPE == JP_BLOCKING_BUFFERED) THEN
  CALL MPI_ALLGATHERV(KSENDBUF,ISENDCOUNT,MPI_INTEGER,KRECVBUF,&
   & KRECVCOUNTS,IRECVDISPL_PT,MPI_INTEGER,ICOMM,IERROR)
ELSEIF(IMP_TYPE == JP_NON_BLOCKING_STANDARD .OR. IMP_TYPE == JP_NON_BLOCKING_BUFFERED) THEN
   CALL MPI_IALLGATHERV(KSENDBUF,ISENDCOUNT,MPI_INTEGER,KRECVBUF,&
   & KRECVCOUNTS,IRECVDISPL_PT,MPI_INTEGER,ICOMM,IREQUEST_LOCAL,IERROR)
  KREQUEST=IREQUEST_LOCAL%MPI_VAL
  IF(.NOT. PRESENT(KRECVDISPL)) THEN
    CALL YDDISPLS_LIST%APPEND(KREQ=KREQUEST,NO_NEW_NODE=.TRUE.)
  ENDIF
ENDIF

IF(LMPLSTATS) THEN
  CALL MPL_SENDSTATS(ISENDCOUNT,MPI_INTEGER%MPI_VAL)
  CALL MPL_RECVSTATS(SUM(KRECVCOUNTS),MPI_INTEGER%MPI_VAL)
ENDIF

IF(MPL_OUTPUT > 1 )THEN
   WRITE(MPL_UNIT,'(A,5I8)') ' MPL_ALLGATHERV ',ISENDCOUNT,IRECVCOUNT,ICOMM
ENDIF
IF(PRESENT(KERROR)) THEN
   KERROR=IERROR
ELSE
  IF(IERROR /= 0 ) CALL MPL_MESSAGE(CDMESSAGE='MPL_ALLGATHERV',CDSTRING=CDSTRING,KERROR=IERROR,LDABORT=LLABORT)
ENDIF

END SUBROUTINE MPL_ALLGATHERV_INT

SUBROUTINE MPL_ALLGATHERV_INT_SCALAR(KSENDBUF,KRECVBUF,KRECVCOUNTS,KSENDCOUNT,KRECVDISPL, &
& KMP_TYPE,KCOMM,KERROR,KREQUEST,CDSTRING)

#ifdef USE_8_BYTE_WORDS
USE MPI4TO8, ONLY : &
   MPI_COMM_SIZE => MPI_COMM_SIZE8, MPI_ALLGATHERV => MPI_ALLGATHERV8
#endif

IMPLICIT NONE
INTEGER(KIND=JPIM)         :: KSENDBUF
INTEGER(KIND=JPIM)         :: KRECVBUF(:)
INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL :: KRECVCOUNTS(:)
INTEGER(KIND=JPIM),INTENT(IN), OPTIONAL :: KSENDCOUNT
INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL :: KRECVDISPL(:),KCOMM,KMP_TYPE
INTEGER(KIND=JPIM),INTENT(OUT),OPTIONAL :: KERROR,KREQUEST
CHARACTER(LEN=*),INTENT(IN),OPTIONAL :: CDSTRING
TARGET :: KRECVDISPL

TYPE(MPI_REQUEST)  :: IREQUEST_LOCAL
INTEGER(KIND=JPIM) :: IR,ISENDCOUNT,IRECVCOUNT
INTEGER(KIND=JPIM) :: IMP_TYPE
INTEGER(KIND=JPIM) :: IRECVCOUNTS(MPL_NUMPROC)
INTEGER(KIND=JPIM) :: IERROR,IPL_NUMPROC
TYPE(MPI_COMM)     :: ICOMM
INTEGER(KIND=JPIM) :: ITID
INTEGER(KIND=JPIM),ALLOCATABLE,TARGET :: IRECVDISPL(:)
INTEGER(KIND=JPIM), POINTER :: IRECVDISPL_PT(:)
LOGICAL :: LKRECVCOUNTS ! .TRUE. if KRECVCOUNTS is present

ITID = OML_MY_THREAD()
IF(PRESENT(KSENDCOUNT)) THEN
   ISENDCOUNT = KSENDCOUNT
ELSE
   ISENDCOUNT = 1
ENDIF
IRECVCOUNT = SIZE(KRECVBUF)
IF(PRESENT(KRECVCOUNTS)) THEN
   IF(ANY(KRECVCOUNTS < 0) .OR. ANY(KRECVCOUNTS > 1)) THEN
      CALL MPL_MESSAGE(CDMESSAGE='MPL_ALLGATHERV_INT_SCALAR: KRECVCOUNTS contains <0 or >1 counts',LDABORT=LLABORT)
   ENDIF
   IRECVCOUNTS=KRECVCOUNTS
   LKRECVCOUNTS = .TRUE.
ELSE
   IRECVCOUNTS(:) = 1
   LKRECVCOUNTS = .FALSE.
ENDIF
!--------- Preamble repeated for threadsafe--------------
#include "mpl_allgatherv_preamble.i90"
!--------- End of Preamble --------------

IF(IMP_TYPE == JP_BLOCKING_STANDARD .OR. IMP_TYPE == JP_BLOCKING_BUFFERED) THEN
  CALL MPI_ALLGATHERV(KSENDBUF,ISENDCOUNT,MPI_INTEGER,KRECVBUF,IRECVCOUNTS,&
   &  IRECVDISPL_PT,MPI_INTEGER,ICOMM,IERROR)
ELSEIF(IMP_TYPE == JP_NON_BLOCKING_STANDARD .OR. IMP_TYPE == JP_NON_BLOCKING_BUFFERED) THEN
   CALL MPI_IALLGATHERV(KSENDBUF,ISENDCOUNT,MPI_INTEGER,KRECVBUF,IRECVCOUNTS,&
   &  IRECVDISPL_PT,MPI_INTEGER,ICOMM,IREQUEST_LOCAL,IERROR)
  KREQUEST=IREQUEST_LOCAL%MPI_VAL
  IF(.NOT. PRESENT(KRECVDISPL)) THEN
    CALL YDDISPLS_LIST%APPEND(KREQ=KREQUEST,NO_NEW_NODE=.TRUE.)
  ENDIF
ENDIF
IF(LMPLSTATS) THEN
  CALL MPL_SENDSTATS(ISENDCOUNT,MPI_INTEGER%MPI_VAL)
  CALL MPL_RECVSTATS(SUM(IRECVCOUNTS),MPI_INTEGER%MPI_VAL)
ENDIF

IF(MPL_OUTPUT > 1 )THEN
   WRITE(MPL_UNIT,'(A,5I8)') ' MPL_ALLGATHERV ',ISENDCOUNT,IRECVCOUNT,ICOMM
ENDIF
IF(PRESENT(KERROR)) THEN
   KERROR=IERROR
ELSE
  IF(IERROR /= 0 ) CALL MPL_MESSAGE(CDMESSAGE='MPL_ALLGATHERV',CDSTRING=CDSTRING,KERROR=IERROR,LDABORT=LLABORT)
ENDIF

END SUBROUTINE MPL_ALLGATHERV_INT_SCALAR

END MODULE MPL_ALLGATHERV_MOD

! (C) Copyright 2025- ECMWF.
!
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!

!
! Test program to test ec_checksum_mod

module fiat_test_fletcher16_type_mod
! A helper module to initialise arrays used in the tests
interface create_array
module procedure :: create_array_real32_r1
module procedure :: create_array_real32_r2
module procedure :: create_array_real32_r3
module procedure :: create_array_real32_r4
module procedure :: create_array_real64_r1
module procedure :: create_array_real64_r2
module procedure :: create_array_real64_r3
module procedure :: create_array_real64_r4
module procedure :: create_array_int32_r1
module procedure :: create_array_int32_r2
module procedure :: create_array_int32_r3
module procedure :: create_array_int32_r4
module procedure :: create_array_int64_r1
module procedure :: create_array_int64_r2
module procedure :: create_array_int64_r3
module procedure :: create_array_int64_r4
end interface

interface create_split_arrays
module procedure :: create_split_arrays_real32_r1
module procedure :: create_split_arrays_real64_r1
end interface

contains

subroutine create_array_real32_r1(array)
  use, intrinsic :: iso_c_binding
  real(c_float), allocatable :: array(:)
  integer :: i
  integer, parameter :: N = 100000
  allocate(array(N))
  do i=1,N
    array(i) = i
  enddo
end subroutine

subroutine create_array_real32_r2(array)
  use, intrinsic :: iso_c_binding
  real(c_float), allocatable :: array(:,:)
  integer :: i, j
  integer, parameter :: N = 100000
  integer, parameter :: Ni = N/200
  integer, parameter :: Nj = N/Ni 
  allocate(array(Ni,Nj))
  do j=1,Nj
    do i=1,Ni
      array(i,j) = i + (j-1) * Ni
    enddo
  enddo
end subroutine

subroutine create_array_real32_r3(array)
  use, intrinsic :: iso_c_binding
  real(c_float), allocatable :: array(:,:,:)
  integer :: i, j, k
  integer, parameter :: Ni = 25
  integer, parameter :: Nj = 8
  integer, parameter :: Nk = 500
  allocate(array(Ni,Nj,Nk))
  do k=1,Nk
    do j=1,Nj
      do i=1,Ni
        array(i,j,k) = i + (j-1) * Ni + (k-1) * (Ni * Nj)
      enddo
    enddo
  enddo
end subroutine

subroutine create_array_real32_r4(array)
  use, intrinsic :: iso_c_binding
  real(c_float), allocatable :: array(:,:,:,:)
  integer :: i, j, k, l
  integer, parameter :: Ni = 25
  integer, parameter :: Nj = 8
  integer, parameter :: Nk = 10
  integer, parameter :: Nl = 50
  allocate(array(Ni,Nj,Nk,Nl))
  do l=1,Nl
    do k=1,Nk
      do j=1,Nj
        do i=1,Ni
          array(i,j,k,l) = i + (j-1) * Ni + (k-1) * (Ni * Nj) + (l-1) * (Ni * Nj * Nk)
        enddo
      enddo
    enddo
  enddo
end subroutine

subroutine create_array_real64_r1(array)
  use, intrinsic :: iso_c_binding
  real(c_double), allocatable :: array(:)
  integer :: i
  integer, parameter :: N = 100000
  allocate(array(N))
  do i=1,N
    array(i) = i
  enddo
end subroutine

subroutine create_array_real64_r2(array)
  use, intrinsic :: iso_c_binding
  real(c_double), allocatable :: array(:,:)
  integer :: i, j
  integer, parameter :: N = 100000
  integer, parameter :: Ni = N/200
  integer, parameter :: Nj = N/Ni 
  allocate(array(Ni,Nj))
  do j=1,Nj
    do i=1,Ni
      array(i,j) = i + (j-1) * Ni
    enddo
  enddo
end subroutine

subroutine create_array_real64_r3(array)
  use, intrinsic :: iso_c_binding
  real(c_double), allocatable :: array(:,:,:)
  integer :: i, j, k
  integer, parameter :: Ni = 25
  integer, parameter :: Nj = 8
  integer, parameter :: Nk = 500
  allocate(array(Ni,Nj,Nk))
  do k=1,Nk
    do j=1,Nj
      do i=1,Ni
        array(i,j,k) = i + (j-1) * Ni + (k-1) * (Ni * Nj)
      enddo
    enddo
  enddo
end subroutine

subroutine create_array_real64_r4(array)
  use, intrinsic :: iso_c_binding
  real(c_double), allocatable :: array(:,:,:,:)
  integer :: i, j, k, l
  integer, parameter :: Ni = 25
  integer, parameter :: Nj = 8
  integer, parameter :: Nk = 10
  integer, parameter :: Nl = 50
  allocate(array(Ni,Nj,Nk,Nl))
  do l=1,Nl
    do k=1,Nk
      do j=1,Nj
        do i=1,Ni
          array(i,j,k,l) = i + (j-1) * Ni + (k-1) * (Ni * Nj) + (l-1) * (Ni * Nj * Nk)
        enddo
      enddo
    enddo
  enddo
end subroutine

subroutine create_array_int32_r1(array)
  use, intrinsic :: iso_c_binding
  integer(c_int32_t), allocatable :: array(:)
  integer :: i
  integer, parameter :: N = 100000
  allocate(array(N))
  do i=1,N
    array(i) = i
  enddo
end subroutine

subroutine create_array_int32_r2(array)
  use, intrinsic :: iso_c_binding
  integer(c_int32_t), allocatable :: array(:,:)
  integer :: i, j
  integer, parameter :: N = 100000
  integer, parameter :: Ni = N/200
  integer, parameter :: Nj = N/Ni 
  allocate(array(Ni,Nj))
  do j=1,Nj
    do i=1,Ni
      array(i,j) = i + (j-1) * Ni
    enddo
  enddo
end subroutine

subroutine create_array_int32_r3(array)
  use, intrinsic :: iso_c_binding
  integer(c_int32_t), allocatable :: array(:,:,:)
  integer :: i, j, k
  integer, parameter :: Ni = 25
  integer, parameter :: Nj = 8
  integer, parameter :: Nk = 500
  allocate(array(Ni,Nj,Nk))
  do k=1,Nk
    do j=1,Nj
      do i=1,Ni
        array(i,j,k) = i + (j-1) * Ni + (k-1) * (Ni * Nj)
      enddo
    enddo
  enddo
end subroutine

subroutine create_array_int32_r4(array)
  use, intrinsic :: iso_c_binding
  integer(c_int32_t), allocatable :: array(:,:,:,:)
  integer :: i, j, k, l
  integer, parameter :: Ni = 25
  integer, parameter :: Nj = 8
  integer, parameter :: Nk = 10
  integer, parameter :: Nl = 50
  allocate(array(Ni,Nj,Nk,Nl))
  do l=1,Nl
    do k=1,Nk
      do j=1,Nj
        do i=1,Ni
          array(i,j,k,l) = i + (j-1) * Ni + (k-1) * (Ni * Nj) + (l-1) * (Ni * Nj * Nk)
        enddo
      enddo
    enddo
  enddo
end subroutine

subroutine create_array_int64_r1(array)
  use, intrinsic :: iso_c_binding
  integer(c_int64_t), allocatable :: array(:)
  integer :: i
  integer, parameter :: N = 100000
  allocate(array(N))
  do i=1,N
    array(i) = i
  enddo
end subroutine

subroutine create_array_int64_r2(array)
  use, intrinsic :: iso_c_binding
  integer(c_int64_t), allocatable :: array(:,:)
  integer :: i, j
  integer, parameter :: N = 100000
  integer, parameter :: Ni = N/200
  integer, parameter :: Nj = N/Ni 
  allocate(array(Ni,Nj))
  do j=1,Nj
    do i=1,Ni
      array(i,j) = i + (j-1) * Ni
    enddo
  enddo
end subroutine

subroutine create_array_int64_r3(array)
  use, intrinsic :: iso_c_binding
  integer(c_int64_t), allocatable :: array(:,:,:)
  integer :: i, j, k
  integer, parameter :: Ni = 25
  integer, parameter :: Nj = 8
  integer, parameter :: Nk = 500
  allocate(array(Ni,Nj,Nk))
  do k=1,Nk
    do j=1,Nj
      do i=1,Ni
        array(i,j,k) = i + (j-1) * Ni + (k-1) * (Ni * Nj)
      enddo
    enddo
  enddo
end subroutine

subroutine create_array_int64_r4(array)
  use, intrinsic :: iso_c_binding
  integer(c_int64_t), allocatable :: array(:,:,:,:)
  integer :: i, j, k, l
  integer, parameter :: Ni = 25
  integer, parameter :: Nj = 8
  integer, parameter :: Nk = 10
  integer, parameter :: Nl = 50
  allocate(array(Ni,Nj,Nk,Nl))
  do l=1,Nl
    do k=1,Nk
      do j=1,Nj
        do i=1,Ni
          array(i,j,k,l) = i + (j-1) * Ni + (k-1) * (Ni * Nj) + (l-1) * (Ni * Nj * Nk)
        enddo
      enddo
    enddo
  enddo
end subroutine

subroutine create_split_arrays_real32_r1(array1, array2)
  use, intrinsic :: iso_c_binding
  real(c_float), allocatable :: array1(:), array2(:)
  integer :: i
  integer, parameter :: N = 100000
  integer :: N1, N2
  N1 = N / 3
  N2 = N - N1
  allocate(array1(N1))
  allocate(array2(N2))
  do i=1,N1
    array1(i) = i
  enddo
  do i=1,N2
    array2(i) = N1 + i
  enddo
end subroutine

subroutine create_split_arrays_real64_r1(array1, array2)
  use, intrinsic :: iso_c_binding
  real(c_double), allocatable :: array1(:), array2(:)
  integer :: i
  integer, parameter :: N = 100000
  integer :: N1, N2
  N1 = N / 3
  N2 = N - N1
  allocate(array1(N1))
  allocate(array2(N2))
  do i=1,N1
    array1(i) = i
  enddo
  do i=1,N2
    array2(i) = N1 + i
  enddo
end subroutine

end module fiat_test_fletcher16_type_mod

subroutine fail_impl(msg,line)
  character(*) :: msg
  integer :: line
  write(0,'(A,I0,A)') "TEST FAILED in test_byteswap.F90 @ line ",line," :"
  write(0,*) msg
  stop 1
end subroutine
#define FAIL(msg) call fail_impl(msg,__LINE__)

program test_checksum
use ec_checksum_mod
use fiat_test_fletcher16_type_mod
use, intrinsic :: iso_c_binding
implicit none

call test_fletcher16_type_real32_r1()
call test_fletcher16_type_real32_r2()
call test_fletcher16_type_real32_r3()
call test_fletcher16_type_real32_r4()
call test_fletcher16_type_real64_r1()
call test_fletcher16_type_real64_r2()
call test_fletcher16_type_real64_r3()
call test_fletcher16_type_real64_r4()
call test_fletcher16_type_int32_r1()
call test_fletcher16_type_int32_r2()
call test_fletcher16_type_int32_r3()
call test_fletcher16_type_int32_r4()
call test_fletcher16_type_int64_r1()
call test_fletcher16_type_int64_r2()
call test_fletcher16_type_int64_r3()
call test_fletcher16_type_int64_r4()
call test_fletcher16_type_split_real32_r1()
call test_fletcher16_type_split_real64_r1()
call test_fletcher16_real32_r1()
call test_fletcher16_real32_r2()
call test_fletcher16_real32_r3()
call test_fletcher16_real32_r4()
call test_fletcher16_real64_r1()
call test_fletcher16_real64_r2()
call test_fletcher16_real64_r3()
call test_fletcher16_real64_r4()
call test_fletcher16_int32_r1()
call test_fletcher16_int32_r2()
call test_fletcher16_int32_r3()
call test_fletcher16_int32_r4()
call test_fletcher16_int64_r1()
call test_fletcher16_int64_r2()
call test_fletcher16_int64_r3()
call test_fletcher16_int64_r4()

write(0,'(A)') "SUCCESS"

CONTAINS

  subroutine test_fletcher16_type_real32_r1()
    real(c_float), allocatable :: array(:)
    type(fletcher16_type) :: checksum
    character(len=4) :: expected = '44c2'
    write(0,'(A)') "test_fletcher16_type_real32_r1"
    call create_array(array)
    call checksum%update(array)
    if (checksum%digest_hex() /= expected) then
      FAIL('checksum failed. Expected: '//expected//' , Computed: '//checksum%digest_hex())
    endif
  end subroutine

  subroutine test_fletcher16_type_real32_r2()
    real(c_float), allocatable :: array(:,:)
    type(fletcher16_type) :: checksum
    character(len=4) :: expected = '44c2'
    write(0,'(A)') "test_fletcher16_type_real32_r2"
    call create_array(array)
    call checksum%update(array)
    if (checksum%digest_hex() /= expected) then
      FAIL('checksum failed. Expected: '//expected//' , Computed: '//checksum%digest_hex())
    endif
  end subroutine

  subroutine test_fletcher16_type_real32_r3()
    real(c_float), allocatable :: array(:,:,:)
    type(fletcher16_type) :: checksum
    character(len=4) :: expected = '44c2'
    write(0,'(A)') "test_fletcher16_type_real32_r3"
    call create_array(array)
    call checksum%update(array)
    if (checksum%digest_hex() /= expected) then
      FAIL('checksum failed. Expected: '//expected//' , Computed: '//checksum%digest_hex())
    endif
  end subroutine

  subroutine test_fletcher16_type_real32_r4()
    real(c_float), allocatable :: array(:,:,:,:)
    type(fletcher16_type) :: checksum
    character(len=4) :: expected = '44c2'
    write(0,'(A)') "test_fletcher16_type_real32_r4"
    call create_array(array)
    call checksum%update(array)
    if (checksum%digest_hex() /= expected) then
      FAIL('checksum failed. Expected: '//expected//' , Computed: '//checksum%digest_hex())
    endif
  end subroutine

  subroutine test_fletcher16_type_real64_r1()
    real(c_double), allocatable :: array(:)
    type(fletcher16_type) :: checksum
    character(len=4) :: expected = 'ca21'
    write(0,'(A)') "test_fletcher16_type_real64_r1"
    call create_array(array)
    call checksum%update(array)
    if (checksum%digest_hex() /= expected) then
      FAIL('checksum failed. Expected: '//expected//' , Computed: '//checksum%digest_hex())
    endif
  end subroutine

  subroutine test_fletcher16_type_real64_r2()
    real(c_double), allocatable :: array(:,:)
    type(fletcher16_type) :: checksum
    character(len=4) :: expected = 'ca21'
    write(0,'(A)') "test_fletcher16_type_real64_r2"
    call create_array(array)
    call checksum%update(array)
    if (checksum%digest_hex() /= expected) then
      FAIL('checksum failed. Expected: '//expected//' , Computed: '//checksum%digest_hex())
    endif
  end subroutine

  subroutine test_fletcher16_type_real64_r3()
    real(c_double), allocatable :: array(:,:,:)
    type(fletcher16_type) :: checksum
    character(len=4) :: expected = 'ca21'
    write(0,'(A)') "test_fletcher16_type_real64_r2"
    call create_array(array)
    call checksum%update(array)
    if (checksum%digest_hex() /= expected) then
      FAIL('checksum failed. Expected: '//expected//' , Computed: '//checksum%digest_hex())
    endif
  end subroutine

  subroutine test_fletcher16_type_real64_r4()
    real(c_double), allocatable :: array(:,:,:,:)
    type(fletcher16_type) :: checksum
    character(len=4) :: expected = 'ca21'
    write(0,'(A)') "test_fletcher16_type_real64_r4"
    call create_array(array)
    call checksum%update(array)
    if (checksum%digest_hex() /= expected) then
      FAIL('checksum failed. Expected: '//expected//' , Computed: '//checksum%digest_hex())
    endif
  end subroutine

  subroutine test_fletcher16_type_int32_r1()
    integer(c_int32_t), allocatable :: array(:)
    type(fletcher16_type) :: checksum
    character(len=4) :: expected = 'e137'
    write(0,'(A)') "test_fletcher16_type_int32_r1"
    call create_array(array)
    call checksum%update(array)
    if (checksum%digest_hex() /= expected) then
      FAIL('checksum failed. Expected: '//expected//' , Computed: '//checksum%digest_hex())
    endif
  end subroutine

  subroutine test_fletcher16_type_int32_r2()
    integer(c_int32_t), allocatable :: array(:,:)
    type(fletcher16_type) :: checksum
    character(len=4) :: expected = 'e137'
    write(0,'(A)') "test_fletcher16_type_int32_r2"
    call create_array(array)
    call checksum%update(array)
    if (checksum%digest_hex() /= expected) then
      FAIL('checksum failed. Expected: '//expected//' , Computed: '//checksum%digest_hex())
    endif
  end subroutine

  subroutine test_fletcher16_type_int32_r3()
    integer(c_int32_t), allocatable :: array(:,:,:)
    type(fletcher16_type) :: checksum
    character(len=4) :: expected = 'e137'
    write(0,'(A)') "test_fletcher16_type_int32_r3"
    call create_array(array)
    call checksum%update(array)
    if (checksum%digest_hex() /= expected) then
      FAIL('checksum failed. Expected: '//expected//' , Computed: '//checksum%digest_hex())
    endif
  end subroutine

  subroutine test_fletcher16_type_int32_r4()
    integer(c_int32_t), allocatable :: array(:,:,:,:)
    type(fletcher16_type) :: checksum
    character(len=4) :: expected = 'e137'
    write(0,'(A)') "test_fletcher16_type_int32_r4"
    call create_array(array)
    call checksum%update(array)
    if (checksum%digest_hex() /= expected) then
      FAIL('checksum failed. Expected: '//expected//' , Computed: '//checksum%digest_hex())
    endif
  end subroutine

  subroutine test_fletcher16_type_int64_r1()
    integer(c_int64_t), allocatable :: array(:)
    type(fletcher16_type) :: checksum
    character(len=4) :: expected = 'a037'
    write(0,'(A)') "test_fletcher16_type_int64_r1"
    call create_array(array)
    call checksum%update(array)
    if (checksum%digest_hex() /= expected) then
      FAIL('checksum failed. Expected: '//expected//' , Computed: '//checksum%digest_hex())
    endif
  end subroutine

  subroutine test_fletcher16_type_int64_r2()
    integer(c_int64_t), allocatable :: array(:,:)
    type(fletcher16_type) :: checksum
    character(len=4) :: expected = 'a037'
    write(0,'(A)') "test_fletcher16_type_int64_r2"
    call create_array(array)
    call checksum%update(array)
    if (checksum%digest_hex() /= expected) then
      FAIL('checksum failed. Expected: '//expected//' , Computed: '//checksum%digest_hex())
    endif
  end subroutine

  subroutine test_fletcher16_type_int64_r3()
    integer(c_int64_t), allocatable :: array(:,:,:)
    type(fletcher16_type) :: checksum
    character(len=4) :: expected = 'a037'
    write(0,'(A)') "test_fletcher16_type_int64_r2"
    call create_array(array)
    call checksum%update(array)
    if (checksum%digest_hex() /= expected) then
      FAIL('checksum failed. Expected: '//expected//' , Computed: '//checksum%digest_hex())
    endif
  end subroutine

  subroutine test_fletcher16_type_int64_r4()
    integer(c_int64_t), allocatable :: array(:,:,:,:)
    type(fletcher16_type) :: checksum
    character(len=4) :: expected = 'a037'
    write(0,'(A)') "test_fletcher16_type_int64_r4"
    call create_array(array)
    call checksum%update(array)
    if (checksum%digest_hex() /= expected) then
      FAIL('checksum failed. Expected: '//expected//' , Computed: '//checksum%digest_hex())
    endif
  end subroutine

  subroutine test_fletcher16_type_split_real32_r1()
    real(c_float), allocatable :: array1(:), array2(:)
    type(fletcher16_type) :: checksum
    character(len=4) :: expected = '44c2'
    write(0,'(A)') "test_fletcher16_type_split_real32_r1"
    call create_split_arrays(array1, array2)
    call checksum%update(array1)
    call checksum%update(array2)
    if (checksum%digest_hex() /= expected) then
      FAIL('checksum failed. Expected: '//expected//' , Computed: '//checksum%digest_hex())
    endif
  end subroutine

  subroutine test_fletcher16_type_split_real64_r1()
    real(c_double), allocatable :: array1(:), array2(:)
    type(fletcher16_type) :: checksum
    character(len=4) :: expected = 'ca21'
    write(0,'(A)') "test_fletcher16_type_split_real64_r1"
    call create_split_arrays(array1, array2)
    call checksum%update(array1)
    call checksum%update(array2)
    if (checksum%digest_hex() /= expected) then
      FAIL('checksum failed. Expected: '//expected//' , Computed: '//checksum%digest_hex())
    endif
  end subroutine

  subroutine test_fletcher16_real32_r1()
    real(c_float), allocatable :: array(:)
    character(len=4) :: expected = '44c2'
    write(0,'(A)') "test_fletcher16_real32_r1"
    call create_array(array)
    if (fletcher16_hex(array) /= expected) then
      FAIL('checksum failed. Expected: '//expected//' , Computed: '//fletcher16_hex(array))
    endif
  end subroutine

  subroutine test_fletcher16_real32_r2()
    real(c_float), allocatable :: array(:,:)
    character(len=4) :: expected = '44c2'
    write(0,'(A)') "test_fletcher16_real32_r2"
    call create_array(array)
    if (fletcher16_hex(array) /= expected) then
      FAIL('checksum failed. Expected: '//expected//' , Computed: '//fletcher16_hex(array))
    endif
  end subroutine

  subroutine test_fletcher16_real32_r3()
    real(c_float), allocatable :: array(:,:,:)
    character(len=4) :: expected = '44c2'
    write(0,'(A)') "test_fletcher16_real32_r3"
    call create_array(array)
    if (fletcher16_hex(array) /= expected) then
      FAIL('checksum failed. Expected: '//expected//' , Computed: '//fletcher16_hex(array))
    endif
  end subroutine

  subroutine test_fletcher16_real32_r4()
    real(c_float), allocatable :: array(:,:,:,:)
    character(len=4) :: expected = '44c2'
    write(0,'(A)') "test_fletcher16_real32_r4"
    call create_array(array)
    if (fletcher16_hex(array) /= expected) then
      FAIL('checksum failed. Expected: '//expected//' , Computed: '//fletcher16_hex(array))
    endif
  end subroutine

  subroutine test_fletcher16_real64_r1()
    real(c_double), allocatable :: array(:)
    character(len=4) :: expected = 'ca21'
    write(0,'(A)') "test_fletcher16_real64_r1"
    call create_array(array)
    if (fletcher16_hex(array) /= expected) then
      FAIL('checksum failed. Expected: '//expected//' , Computed: '//fletcher16_hex(array))
    endif
  end subroutine

  subroutine test_fletcher16_real64_r2()
    real(c_double), allocatable :: array(:,:)
    character(len=4) :: expected = 'ca21'
    write(0,'(A)') "test_fletcher16_real64_r2"
    call create_array(array)
    if (fletcher16_hex(array) /= expected) then
      FAIL('checksum failed. Expected: '//expected//' , Computed: '//fletcher16_hex(array))
    endif
  end subroutine

  subroutine test_fletcher16_real64_r3()
    real(c_double), allocatable :: array(:,:,:)
    character(len=4) :: expected = 'ca21'
    write(0,'(A)') "test_fletcher16_real64_r3"
    call create_array(array)
    if (fletcher16_hex(array) /= expected) then
      FAIL('checksum failed. Expected: '//expected//' , Computed: '//fletcher16_hex(array))
    endif
  end subroutine

  subroutine test_fletcher16_real64_r4()
    real(c_double), allocatable :: array(:,:,:,:)
    character(len=4) :: expected = 'ca21'
    write(0,'(A)') "test_fletcher16_real64_r4"
    call create_array(array)
    if (fletcher16_hex(array) /= expected) then
      FAIL('checksum failed. Expected: '//expected//' , Computed: '//fletcher16_hex(array))
    endif
  end subroutine

  subroutine test_fletcher16_int32_r1()
    integer(c_int32_t), allocatable :: array(:)
    character(len=4) :: expected = 'e137'
    write(0,'(A)') "test_fletcher16_int32_r1"
    call create_array(array)
    if (fletcher16_hex(array) /= expected) then
      FAIL('checksum failed. Expected: '//expected//' , Computed: '//fletcher16_hex(array))
    endif
  end subroutine

  subroutine test_fletcher16_int32_r2()
    integer(c_int32_t), allocatable :: array(:,:)
    character(len=4) :: expected = 'e137'
    write(0,'(A)') "test_fletcher16_int32_r2"
    call create_array(array)
    if (fletcher16_hex(array) /= expected) then
      FAIL('checksum failed. Expected: '//expected//' , Computed: '//fletcher16_hex(array))
    endif
  end subroutine

  subroutine test_fletcher16_int32_r3()
    integer(c_int32_t), allocatable :: array(:,:,:)
    character(len=4) :: expected = 'e137'
    write(0,'(A)') "test_fletcher16_int32_r3"
    call create_array(array)
    if (fletcher16_hex(array) /= expected) then
      FAIL('checksum failed. Expected: '//expected//' , Computed: '//fletcher16_hex(array))
    endif
  end subroutine

  subroutine test_fletcher16_int32_r4()
    integer(c_int32_t), allocatable :: array(:,:,:,:)
    character(len=4) :: expected = 'e137'
    write(0,'(A)') "test_fletcher16_int32_r4"
    call create_array(array)
    if (fletcher16_hex(array) /= expected) then
      FAIL('checksum failed. Expected: '//expected//' , Computed: '//fletcher16_hex(array))
    endif
  end subroutine

  subroutine test_fletcher16_int64_r1()
    integer(c_int64_t), allocatable :: array(:)
    character(len=4) :: expected = 'a037'
    write(0,'(A)') "test_fletcher16_int64_r1"
    call create_array(array)
    if (fletcher16_hex(array) /= expected) then
      FAIL('checksum failed. Expected: '//expected//' , Computed: '//fletcher16_hex(array))
    endif
  end subroutine

  subroutine test_fletcher16_int64_r2()
    integer(c_int64_t), allocatable :: array(:,:)
    character(len=4) :: expected = 'a037'
    write(0,'(A)') "test_fletcher16_int64_r2"
    call create_array(array)
    if (fletcher16_hex(array) /= expected) then
      FAIL('checksum failed. Expected: '//expected//' , Computed: '//fletcher16_hex(array))
    endif
  end subroutine

  subroutine test_fletcher16_int64_r3()
    integer(c_int64_t), allocatable :: array(:,:,:)
    character(len=4) :: expected = 'a037'
    write(0,'(A)') "test_fletcher16_int64_r3"
    call create_array(array)
    if (fletcher16_hex(array) /= expected) then
      FAIL('checksum failed. Expected: '//expected//' , Computed: '//fletcher16_hex(array))
    endif
  end subroutine

  subroutine test_fletcher16_int64_r4()
    integer(c_int64_t), allocatable :: array(:,:,:,:)
    character(len=4) :: expected = 'a037'
    write(0,'(A)') "test_fletcher16_int64_r4"
    call create_array(array)
    if (fletcher16_hex(array) /= expected) then
      FAIL('checksum failed. Expected: '//expected//' , Computed: '//fletcher16_hex(array))
    endif
  end subroutine

end program

! (C) Copyright 2005- ECMWF.
! (C) Copyright 2013- Meteo-France.
! 
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!

SUBROUTINE USER_CLOCK(PELAPSED_TIME,PELAPSED_TIME_SINCE,PVECTOR_CP,PTOTAL_CP)

!**** *USER_CLOCK* - interface to system dependent timer routines

!     Purpose.
!     --------
!        Returns elapsed and CP from the start of execution.
!        Elapsed time is made relative to the first call to USER_CLOCK.

!**   Interface.
!     ----------
!        ZTIME=USER_CLOCK(PELAPSED_TIME,PELAPSED_TIME_SINCE,
!                         PVECTOR_CP,PTOTAL_CP)

!        Explicit arguments: (All are optional arguments)
!                           PELAPSED_TIME=wall clock time (seconds)
!                           PELAPSED_TIME_SINCE=wall clock time (seconds)
!                             change from input value of this parameter
!                           PVECTOR_CP=CP vector time  (seconds)
!                           PTOTAL_CP=total CP time   (seconds)

!     Author.
!     -------
!        D.Dent      *ECMWF*

!     External References:
!     -------------------

!        TIMEF,CPTIME

!     Modifications.
!     --------------
!        Original  : 97-09-25
!      F. Vana  05-Mar-2015  Support for single precision
!     ----------------------------------------------------------


USE EC_PARKIND  ,ONLY : JPRD, JPIM

IMPLICIT NONE

REAL(KIND=JPRD),INTENT(OUT) :: PELAPSED_TIME,PVECTOR_CP,PTOTAL_CP
REAL(KIND=JPRD),INTENT(INOUT) :: PELAPSED_TIME_SINCE
OPTIONAL            PELAPSED_TIME,PELAPSED_TIME_SINCE
OPTIONAL            PVECTOR_CP,PTOTAL_CP
REAL(KIND=JPRD)      :: ZVECTOR_CP,ZTOTAL_CP,ZWALL
REAL(KIND=JPRD),EXTERNAL :: TIMEF


! === END OF INTERFACE BLOCK ===
IF(PRESENT(PELAPSED_TIME).OR. PRESENT(PELAPSED_TIME_SINCE)) THEN

  ZWALL=TIMEF()
!             TIMEF returns milliseconds since first call to TIMEF
  IF(PRESENT(PELAPSED_TIME)) THEN
    PELAPSED_TIME=ZWALL*1.0E-3_JPRD
  ENDIF
  IF(PRESENT(PELAPSED_TIME_SINCE)) THEN
    PELAPSED_TIME_SINCE=ZWALL*1.0E-3_JPRD - PELAPSED_TIME_SINCE
  ENDIF
ENDIF

IF( PRESENT(PVECTOR_CP) .OR. PRESENT(PTOTAL_CP) ) THEN
  CALL CPTIME(ZVECTOR_CP,ZTOTAL_CP)
ENDIF
IF( PRESENT(PVECTOR_CP) ) THEN
  PVECTOR_CP=ZVECTOR_CP
ENDIF
IF( PRESENT(PTOTAL_CP) ) THEN
  PTOTAL_CP=ZTOTAL_CP
ENDIF

RETURN
END SUBROUTINE USER_CLOCK

! (C) Copyright 2005- ECMWF.
! (C) Copyright 2013- Meteo-France.
! 
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!

MODULE MPL_SCATTERV_MOD

!**** MPL_SCATTERV Scatter data from specific processor

!     Purpose.
!     --------
!     Scatter data from specific processor
!     The data may be REAL*8,or INTEGER, one dimensional array
!
!**   Interface.
!     ----------
!        CALL MPL_SCATTERV

!        Input required arguments :
!        -------------------------
!           PRECVBUF -  buffer containing message
!                       (can be type REAL*4, REAL*8 or INTEGER)
!           PSENDBUF -  buffer containing message 
!                       (required from kroot)
!                       (can be type REAL*4, REAL*8 or INTEGER)
!           KSENDCOUNTS-number of elements to be sent to each process
!                       (required from kroot processor)

!        Input optional arguments :
!        -------------------------
!           KROOT    -  rank of sending processor (default 1) 
!           KCOMM    -  Communicator number if different from MPI_COMM_WORLD 
!                       or from that established as the default 
!                       by an MPL communicator routine
!           KMP_TYPE -  buffering type (see MPL_BUFFER_METHOD)
!                       overrides value provided to MPL_BUFFER_METHOD
!           KSENDDISPL -displacements in PRECVBUF at which to place 
!                       the incoming data
!           CDSTRING -  Character string for ABORT messages
!                       used when KERROR is not provided

!        Output required arguments :
!        -------------------------
!           none

!        Output optional arguments :
!        -------------------------
!           KREQUEST -  Communication request
!                       required when buffering type is non-blocking
!           KERROR   -  return error code.     If not supplied, 
!                       MPL_SCATTERV aborts when an error is detected.
!     Author.
!     -------
!        Y. Tremolet, M.Hamrud     ECMWF

!     Modifications.
!     --------------
!        Original: 02-03-13
!        M.Hamrud     : 2014-10-22 : Add nonblocking option
!      F. Vana  05-Mar-2015  Support for single precision

! --- *NOT* THREAD SAFE YET ---

!     ----------------------------------------------------------------
USE EC_PARKIND  ,ONLY : JPRD, JPIM, JPRM
USE OML_MOD   ,ONLY : OML_MY_THREAD

USE MPL_MPIF
USE MPL_DATA_MODULE
USE MPL_STATS_MOD
USE YOMMPLSTATS
USE MPL_MESSAGE_MOD
USE MPL_MYRANK_MOD

IMPLICIT NONE
PRIVATE
PUBLIC MPL_SCATTERV

INTEGER(KIND=JPIM) :: ICOMM,IROOT,IPL_NUMPROC,IRECVCOUNT,ISENDBUFSIZE,IR,IPL_MYRANK,IMP_TYPE
LOGICAL            :: LLABORT=.TRUE.
INTEGER(KIND=JPIM) :: IERROR,IDUM
REAL(KIND=JPRD)    :: ZDUM
REAL(KIND=JPRM)    :: ZDUM_4
INTEGER(KIND=JPIM)    :: ZDUM_INT

INTERFACE MPL_SCATTERV
MODULE PROCEDURE MPL_SCATTERV_REAL8,MPL_SCATTERV_REAL4,MPL_SCATTERV_INTEGER
END INTERFACE

CONTAINS

SUBROUTINE MPL_SCATTERV_PREAMB1(KCOMM,KROOT,KMP_TYPE,KREQUEST)


#ifdef USE_8_BYTE_WORDS
  USE MPI4TO8, ONLY : &
    MPI_SCATTERV => MPI_SCATTERV8, MPI_COMM_SIZE => MPI_COMM_SIZE8
#endif



INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL :: KCOMM
INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL :: KROOT
INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL :: KMP_TYPE
INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL :: KREQUEST
INTEGER(KIND=JPIM) :: ITID
ITID = OML_MY_THREAD()

IERROR = 0

IF(MPL_NUMPROC < 1) CALL MPL_MESSAGE( &
  & CDMESSAGE='MPL_SCATTERV: MPL NOT INITIALISED ',LDABORT=LLABORT) 

IF(PRESENT(KCOMM)) THEN
  ICOMM=KCOMM
ELSE
  ICOMM=MPL_COMM_OML(ITID)
ENDIF

IF(PRESENT(KMP_TYPE)) THEN
  IMP_TYPE=KMP_TYPE
ELSE
  IMP_TYPE=MPL_METHOD
ENDIF
IF(IMP_TYPE == JP_NON_BLOCKING_STANDARD .OR. IMP_TYPE == JP_NON_BLOCKING_BUFFERED) THEN
  IF(.NOT.PRESENT(KREQUEST)) CALL MPL_MESSAGE(CDMESSAGE='MPL_SCATTERV:  KREQUEST MISSING',LDABORT=LLABORT)
ENDIF

IF(ICOMM == MPL_COMM_OML(ITID)) THEN
  IPL_NUMPROC = MPL_NUMPROC
  IPL_MYRANK  = MPL_RANK
ELSE
  CALL MPI_COMM_SIZE(ICOMM,IPL_NUMPROC,IERROR)
  IPL_MYRANK  = MPL_MYRANK(ICOMM)
ENDIF

IF(PRESENT(KROOT)) THEN
  IROOT=KROOT
ELSE
  IROOT=1
ENDIF

END SUBROUTINE MPL_SCATTERV_PREAMB1

SUBROUTINE MPL_SCATTERV_PREAMB2(KSENDCOUNTS,KISENDDISPL,KSENDDISPL,CDSTRING)

INTEGER(KIND=JPIM),INTENT(IN) :: KSENDCOUNTS(:)
INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL :: KSENDDISPL(:)
INTEGER(KIND=JPIM),INTENT(OUT) :: KISENDDISPL(:) 
CHARACTER(LEN=*),INTENT(IN),OPTIONAL :: CDSTRING


IF(SIZE(KSENDCOUNTS)  < IPL_NUMPROC) THEN
  WRITE(MPL_ERRUNIT,*)'MPL_SCATTERV: ERROR KSENDCOUNTS DIMENSION=',&
   & SIZE(KSENDCOUNTS)
  CALL MPL_MESSAGE(CDMESSAGE=&
   & 'MPL_SCATTERV: ERROR KSENDCOUNTS DIMENSION IS WRONG',LDABORT=LLABORT)
ENDIF
IF(IRECVCOUNT /= KSENDCOUNTS(IPL_MYRANK)) THEN
  WRITE(MPL_ERRUNIT,*)'MPL_SCATTERV: ERROR KSENDCOUNTS INCONSISTENCY ',&
   & IRECVCOUNT,KSENDCOUNTS(IPL_MYRANK)
  CALL MPL_MESSAGE(CDMESSAGE=&
   & 'MPL_SCATTERV: ERROR IRECVCOUNT /= KSENDCOUNTS(MPL_RANK) ',LDABORT=LLABORT)
ENDIF

IF(PRESENT(KSENDDISPL)) THEN
  KISENDDISPL(:) = KSENDDISPL(:)
ELSE
  KISENDDISPL(:) = 0
  DO IR=2, IPL_NUMPROC
    KISENDDISPL(IR) = KISENDDISPL(IR-1) + KSENDCOUNTS(IR-1)
  ENDDO
ENDIF
DO IR=1, IPL_NUMPROC
  IF(KISENDDISPL(IR)+KSENDCOUNTS(IR) > ISENDBUFSIZE) THEN
    WRITE(MPL_ERRUNIT,'(A,4I10)')'MPL_SCATTERV:SEND BUFFER TOO SMALL  ', &
     & IR,KISENDDISPL(IR),KSENDCOUNTS(IR),ISENDBUFSIZE
    CALL MPL_MESSAGE(CDMESSAGE='MPL_SCATTERV',CDSTRING=CDSTRING,LDABORT=LLABORT)
  ENDIF
ENDDO

END SUBROUTINE MPL_SCATTERV_PREAMB2
! ------------------------------------------------------------------
SUBROUTINE MPL_SCATTERV_REAL8(PRECVBUF,KROOT,PSENDBUF,KSENDCOUNTS,KSENDDISPL,&
 & KMP_TYPE,KCOMM,KERROR,KREQUEST,CDSTRING)


#ifdef USE_8_BYTE_WORDS
  USE MPI4TO8, ONLY : &
    MPI_SCATTERV => MPI_SCATTERV8
#endif


REAL(KIND=JPRD), INTENT(OUT) :: PRECVBUF(:)
INTEGER(KIND=JPIM), INTENT(IN) :: KROOT
REAL(KIND=JPRD), INTENT(IN),OPTIONAL  :: PSENDBUF(:)
INTEGER(KIND=JPIM), INTENT(IN),OPTIONAL :: KSENDCOUNTS(:), KSENDDISPL(:)
INTEGER(KIND=JPIM), INTENT(IN),OPTIONAL :: KCOMM,KMP_TYPE
INTEGER(KIND=JPIM),INTENT(OUT),OPTIONAL :: KERROR,KREQUEST
CHARACTER(LEN=*),INTENT(IN),OPTIONAL :: CDSTRING

INTEGER(KIND=JPIM) :: ISENDDISPL(MPL_NUMPROC)

CALL MPL_SCATTERV_PREAMB1(KCOMM,KROOT,KMP_TYPE,KREQUEST)
IRECVCOUNT=SIZE(PRECVBUF)

IF(IPL_MYRANK == IROOT) THEN
  IF( .NOT. PRESENT(PSENDBUF)) CALL MPL_MESSAGE(&
   & CDMESSAGE='MPL_SCATTERV:SENDBUF MISSING',CDSTRING=CDSTRING,&
   & LDABORT=LLABORT)
  ISENDBUFSIZE=SIZE(PSENDBUF)
  CALL MPL_SCATTERV_PREAMB2(KSENDCOUNTS,ISENDDISPL,KSENDDISPL,CDSTRING)
  IF(IMP_TYPE == JP_BLOCKING_STANDARD .OR. IMP_TYPE == JP_BLOCKING_BUFFERED) THEN
    CALL MPI_SCATTERV(PSENDBUF,KSENDCOUNTS,ISENDDISPL,INT(MPI_REAL8), &
     & PRECVBUF,IRECVCOUNT,INT(MPI_REAL8),IROOT-1,ICOMM,IERROR)
  ELSEIF(IMP_TYPE == JP_NON_BLOCKING_STANDARD .OR. IMP_TYPE == JP_NON_BLOCKING_BUFFERED) THEN
    CALL MPI_ISCATTERV(PSENDBUF,KSENDCOUNTS,ISENDDISPL,INT(MPI_REAL8), &
     & PRECVBUF,IRECVCOUNT,INT(MPI_REAL8),IROOT-1,ICOMM,KREQUEST,IERROR)
  ENDIF
  IF(LMPLSTATS) THEN
    CALL MPL_SENDSTATS(SUM(KSENDCOUNTS),INT(MPI_REAL8))
    CALL MPL_RECVSTATS(IRECVCOUNT,INT(MPI_REAL8))
  ENDIF
ELSE
  IF(IMP_TYPE == JP_BLOCKING_STANDARD .OR. IMP_TYPE == JP_BLOCKING_BUFFERED) THEN
    CALL MPI_SCATTERV(ZDUM,1,1,INT(MPI_REAL8), &
     & PRECVBUF,IRECVCOUNT,INT(MPI_REAL8),IROOT-1,ICOMM,IERROR)
  ELSEIF(IMP_TYPE == JP_NON_BLOCKING_STANDARD .OR. IMP_TYPE == JP_NON_BLOCKING_BUFFERED) THEN
    CALL MPI_ISCATTERV(ZDUM,1,1,INT(MPI_REAL8), &
     & PRECVBUF,IRECVCOUNT,INT(MPI_REAL8),IROOT-1,ICOMM,KREQUEST,IERROR)
  ENDIF
  IF(LMPLSTATS) THEN
    CALL MPL_RECVSTATS(IRECVCOUNT,INT(MPI_REAL8))
  ENDIF
ENDIF  

IF(PRESENT(KERROR)) THEN
  KERROR=IERROR
ELSE
  IF (IERROR/=0) CALL MPL_MESSAGE(IERROR,'MPL_SCATTERV',&
   & CDSTRING,LDABORT=LLABORT)
ENDIF

END SUBROUTINE MPL_SCATTERV_REAL8
! ------------------------------------------------------------------
SUBROUTINE MPL_SCATTERV_REAL4(PRECVBUF,KROOT,PSENDBUF,KSENDCOUNTS,KSENDDISPL,&
 &  KMP_TYPE,KCOMM,KERROR,KREQUEST,CDSTRING)


#ifdef USE_8_BYTE_WORDS
  USE MPI4TO8, ONLY : &
    MPI_SCATTERV => MPI_SCATTERV8
#endif


REAL(KIND=JPRM), INTENT(OUT) :: PRECVBUF(:)
INTEGER(KIND=JPIM), INTENT(IN) :: KROOT
REAL(KIND=JPRM), INTENT(IN),OPTIONAL  :: PSENDBUF(:)
INTEGER(KIND=JPIM), INTENT(IN),OPTIONAL :: KSENDCOUNTS(:), KSENDDISPL(:)
INTEGER(KIND=JPIM), INTENT(IN),OPTIONAL :: KCOMM,KMP_TYPE
INTEGER(KIND=JPIM),INTENT(OUT),OPTIONAL :: KERROR,KREQUEST
CHARACTER(LEN=*),INTENT(IN),OPTIONAL :: CDSTRING

INTEGER(KIND=JPIM) :: ISENDDISPL(MPL_NUMPROC)

CALL MPL_SCATTERV_PREAMB1(KCOMM,KROOT,KMP_TYPE,KREQUEST)
IRECVCOUNT=SIZE(PRECVBUF)

IF(IPL_MYRANK == IROOT) THEN
  IF( .NOT. PRESENT(PSENDBUF)) CALL MPL_MESSAGE(&
   & CDMESSAGE='MPL_SCATTERV:SENDBUF MISSING',CDSTRING=CDSTRING,&
   & LDABORT=LLABORT)
  ISENDBUFSIZE=SIZE(PSENDBUF)
  CALL MPL_SCATTERV_PREAMB2(KSENDCOUNTS,ISENDDISPL,KSENDDISPL,CDSTRING)
  IF(IMP_TYPE == JP_BLOCKING_STANDARD .OR. IMP_TYPE == JP_BLOCKING_BUFFERED) THEN
    CALL MPI_SCATTERV(PSENDBUF,KSENDCOUNTS,ISENDDISPL,INT(MPI_REAL4), &
     & PRECVBUF,IRECVCOUNT,INT(MPI_REAL4),IROOT-1,ICOMM,IERROR)
  ELSEIF(IMP_TYPE == JP_NON_BLOCKING_STANDARD .OR. IMP_TYPE == JP_NON_BLOCKING_BUFFERED) THEN
    CALL MPI_ISCATTERV(PSENDBUF,KSENDCOUNTS,ISENDDISPL,INT(MPI_REAL4), &
     & PRECVBUF,IRECVCOUNT,INT(MPI_REAL4),IROOT-1,ICOMM,KREQUEST,IERROR)
  ENDIF
  IF(LMPLSTATS) THEN
    CALL MPL_SENDSTATS(SUM(KSENDCOUNTS),INT(MPI_REAL4))
    CALL MPL_RECVSTATS(IRECVCOUNT,INT(MPI_REAL4))
  ENDIF
ELSE
  IF(IMP_TYPE == JP_BLOCKING_STANDARD .OR. IMP_TYPE == JP_BLOCKING_BUFFERED) THEN
    CALL MPI_SCATTERV(ZDUM_4,1,1,INT(MPI_REAL4), &
     & PRECVBUF,IRECVCOUNT,INT(MPI_REAL4),IROOT-1,ICOMM,IERROR)
  ELSEIF(IMP_TYPE == JP_NON_BLOCKING_STANDARD .OR. IMP_TYPE == JP_NON_BLOCKING_BUFFERED) THEN
    CALL MPI_ISCATTERV(ZDUM_4,1,1,INT(MPI_REAL4), &
     & PRECVBUF,IRECVCOUNT,INT(MPI_REAL4),IROOT-1,ICOMM,KREQUEST,IERROR)
  ENDIF
  IF(LMPLSTATS) THEN
    CALL MPL_RECVSTATS(IRECVCOUNT,INT(MPI_REAL4))
  ENDIF
ENDIF  

IF(PRESENT(KERROR)) THEN
  KERROR=IERROR
ELSE
  IF (IERROR/=0) CALL MPL_MESSAGE(IERROR,'MPL_SCATTERV',&
   & CDSTRING,LDABORT=LLABORT)
ENDIF

END SUBROUTINE MPL_SCATTERV_REAL4


SUBROUTINE MPL_SCATTERV_INTEGER(KRECVBUF,KROOT,KSENDBUF,KSENDCOUNTS,&
 & KSENDDISPL,KMP_TYPE,KCOMM,KERROR,KREQUEST,CDSTRING)


#ifdef USE_8_BYTE_WORDS
  USE MPI4TO8, ONLY : &
    MPI_SCATTERV => MPI_SCATTERV8
#endif


INTEGER(KIND=JPIM), INTENT(OUT) :: KRECVBUF(:)
INTEGER(KIND=JPIM), INTENT(IN) :: KROOT
INTEGER(KIND=JPIM), INTENT(IN),OPTIONAL :: KSENDBUF(:)
INTEGER(KIND=JPIM), INTENT(IN),OPTIONAL :: KSENDCOUNTS(:), KSENDDISPL(:)
INTEGER(KIND=JPIM), INTENT(IN),OPTIONAL :: KCOMM,KMP_TYPE
INTEGER(KIND=JPIM),INTENT(OUT),OPTIONAL :: KERROR,KREQUEST
CHARACTER(LEN=*),INTENT(IN),OPTIONAL :: CDSTRING

INTEGER(KIND=JPIM) :: ISENDDISPL(MPL_NUMPROC)

CALL MPL_SCATTERV_PREAMB1(KCOMM,KROOT,KMP_TYPE,KREQUEST)
IRECVCOUNT=SIZE(KRECVBUF)

IF(IPL_MYRANK == IROOT) THEN
  IF( .NOT. PRESENT(KSENDBUF)) CALL MPL_MESSAGE(&
   & CDMESSAGE='MPL_SCATTERV:SENDBUF MISSING',CDSTRING=CDSTRING,&
   & LDABORT=LLABORT)
  ISENDBUFSIZE=SIZE(KSENDBUF)
  CALL MPL_SCATTERV_PREAMB2(KSENDCOUNTS,ISENDDISPL,KSENDDISPL,&
   & CDSTRING)
  IF(IMP_TYPE == JP_BLOCKING_STANDARD .OR. IMP_TYPE == JP_BLOCKING_BUFFERED) THEN
    CALL MPI_SCATTERV(KSENDBUF,KSENDCOUNTS,ISENDDISPL,INT(MPI_INTEGER), &
     & KRECVBUF,IRECVCOUNT,INT(MPI_INTEGER),IROOT-1,ICOMM,IERROR)
  ELSEIF(IMP_TYPE == JP_NON_BLOCKING_STANDARD .OR. IMP_TYPE == JP_NON_BLOCKING_BUFFERED) THEN
    CALL MPI_ISCATTERV(KSENDBUF,KSENDCOUNTS,ISENDDISPL,INT(MPI_INTEGER), &
     & KRECVBUF,IRECVCOUNT,INT(MPI_INTEGER),IROOT-1,ICOMM,KREQUEST,IERROR)
  ENDIF
  IF(LMPLSTATS) THEN
    CALL MPL_SENDSTATS(SUM(KSENDCOUNTS),INT(MPI_INTEGER))
    CALL MPL_RECVSTATS(IRECVCOUNT,INT(MPI_INTEGER))
  ENDIF
ELSE
  IF(IMP_TYPE == JP_BLOCKING_STANDARD .OR. IMP_TYPE == JP_BLOCKING_BUFFERED) THEN
    CALL MPI_SCATTERV(ZDUM_INT,1,1,INT(MPI_INTEGER), &
     & KRECVBUF,IRECVCOUNT,INT(MPI_INTEGER),IROOT-1,ICOMM,IERROR)
  ELSEIF(IMP_TYPE == JP_NON_BLOCKING_STANDARD .OR. IMP_TYPE == JP_NON_BLOCKING_BUFFERED) THEN
    CALL MPI_ISCATTERV(ZDUM_INT,1,1,INT(MPI_INTEGER), &
     & KRECVBUF,IRECVCOUNT,INT(MPI_INTEGER),IROOT-1,ICOMM,KREQUEST,IERROR)
  ENDIF
  IF(LMPLSTATS) THEN
    CALL MPL_RECVSTATS(IRECVCOUNT,INT(MPI_INTEGER))
  ENDIF
ENDIF  

IF(PRESENT(KERROR)) THEN
  KERROR=IERROR
ELSE
  IF (IERROR/=0) CALL MPL_MESSAGE(IERROR,'MPL_SCATTERV',&
   & CDSTRING,LDABORT=LLABORT)
ENDIF

END SUBROUTINE MPL_SCATTERV_INTEGER
! ------------------------------------------------------------------

END MODULE MPL_SCATTERV_MOD

! (C) Copyright 2026- ECMWF.
!
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!


program dummy
  use yomhook, only : jphook, dr_hook
  implicit none
  real(jphook) :: zhook_handle

  call dr_hook('drhook_region',0,zhook_handle)

  call dr_hook('drhook_region',1,zhook_handle)

  stop
end program dummy

! (C) Copyright 2005- ECMWF.
! 
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!

SUBROUTINE EC_FLUSH(UNIT)
  
!USE, INTRINSIC :: iso_fortran_env, ONLY: FLUSH
USE EC_PARKIND, ONLY : JPIM

IMPLICIT NONE

INTEGER(KIND=JPIM),INTENT(IN) :: UNIT

INTEGER(KIND=JPIM) :: IERR

IF (UNIT >= 0) THEN
   FLUSH(UNIT,IOSTAT=IERR,ERR=99) ! F2003 or later
ENDIF

99 CONTINUE

END SUBROUTINE EC_FLUSH

! (C) Copyright 2005- ECMWF.
! (C) Copyright 2013- Meteo-France.
! 
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!

MODULE EC_PARKIND
!
!     *** Define usual kinds for strong typing ***
!
IMPLICIT NONE
SAVE
!
!     Integer Kinds
!     -------------
!
INTEGER, PARAMETER :: JPIM = SELECTED_INT_KIND(9)
INTEGER, PARAMETER :: JPIB = SELECTED_INT_KIND(12)

!
!     Real Kinds
!     ----------
!
INTEGER, PARAMETER :: JPRM = SELECTED_REAL_KIND(6,37)
INTEGER, PARAMETER :: JPRD = SELECTED_REAL_KIND(13,300)


END MODULE EC_PARKIND

! (C) Copyright 2005- ECMWF.
! (C) Copyright 2013- Meteo-France.
! 
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!

MODULE MPL_MODULE
!
!    Message Passing Library (MPL)
!
!    Interface between parallel applications and the
!    Message Passing Interface (MPI standard) provided by the computer vendors
!    This version requires only MPI release 1.
!
!    designed and developed by
!      Mats Hamrud and David Dent,      ECMWF,      September 2000
!
!    all routines which wish to call MPL routines must contain:
!    USE MPL_MODULE

USE MPL_DATA_MODULE
USE MPL_INIT_MOD
USE MPL_BUFFER_METHOD_MOD
USE MPL_SEND_MOD
USE MPL_RECV_MOD
USE MPL_WAIT_MOD
USE MPL_BARRIER_MOD
USE MPL_BROADCAST_MOD
USE MPL_PROBE_MOD
USE MPL_END_MOD
USE MPL_MESSAGE_MOD
USE MPL_ABORT_MOD
USE MPL_COMM_COMPARE_MOD
USE MPL_COMM_CREATE_MOD
USE MPL_COMM_FREE_MOD
USE MPL_COMM_SPLIT_MOD
USE MPL_SETDFLT_COMM_MOD
USE MPL_ALLGATHER_MOD
USE MPL_MYRANK_MOD
USE MPL_NPROC_MOD
USE MPL_IOINIT_MOD
USE MPL_OPEN_MOD
USE MPL_CLOSE_MOD
USE MPL_READ_MOD
USE MPL_WRITE_MOD
USE MPL_ALLREDUCE_MOD
USE MPL_GATHERV_MOD
USE MPL_MYGATHERV_MOD
USE MPL_ALLGATHERV_MOD
USE MPL_ALLTOALLV_MOD
USE MPL_SCATTERV_MOD
USE MPL_GROUPS
USE MPL_ARG_MOD
USE MPL_LOCOMM_CREATE_MOD
USE MPL_TOUR_TABLE_MOD
USE MPL_TESTSOME_MOD
USE MPL_WAITANY_MOD
USE MPL_BYTES_MOD

END MODULE MPL_MODULE

! (C) Copyright 2005- ECMWF.
! (C) Copyright 2013- Meteo-France.
! 
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!

SUBROUTINE GSTATS_PSUT

! MEASURE PARALLELL START UP TIME

USE EC_PARKIND  ,ONLY : JPRD, JPIM

USE YOMGSTATS
USE MPL_MODULE


IMPLICIT NONE

INTEGER(KIND=JPIM) :: ITAG,ILSEND,ILBUF,JROC,IRECV,ISEND
REAL(KIND=JPRD) :: ZTBUF(2),ZCLOCK,ZCLOCKB

#include "user_clock.intfb.h"

IF(NPROC_STATS > 1) THEN
  CALL USER_CLOCK(PELAPSED_TIME=ZCLOCKB)
  CALL MPL_BARRIER
  CALL USER_CLOCK(PELAPSED_TIME=ZCLOCK)
  ITAG = JPTAGSTAT
  IF (MYPROC_STATS == 1 ) THEN
    ALLOCATE(TIME_START(NPROC_STATS))
    TIME_START(1) = ZCLOCKB - TIMELCALL(0)
    ILBUF = 2
  ENDIF
  DO JROC=2,NPROC_STATS
   IF (MYPROC_STATS .eq. jroc ) THEN
    ZTBUF(1) = ZCLOCKB
    ZTBUF(2) = ZCLOCK
    ILSEND = 2
    ISEND = 1
    CALL MPL_SEND(ZTBUF(1:ILSEND),KDEST=NPRCIDS_STATS(ISEND), &
     & KTAG=ITAG,CDSTRING='SUSTATS:')
   ELSEIF (MYPROC_STATS == 1 ) THEN
      IRECV = JROC
      CALL MPL_RECV(ZTBUF(1:ILBUF),KSOURCE=NPRCIDS_STATS(IRECV), &
       & KTAG=ITAG,CDSTRING='SUSTATS:')
      TIME_START(JROC) = ZTBUF(1) - TIMELCALL(0) -(ZTBUF(2)-ZCLOCK)
   ENDIF
   CALL MPL_BARRIER
  ENDDO
ENDIF

END SUBROUTINE GSTATS_PSUT

! (C) Copyright 2005- ECMWF.
! (C) Copyright 2013- Meteo-France.
! 
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!

SUBROUTINE GSTATS_PSUT

! MEASURE PARALLELL START UP TIME

USE EC_PARKIND, ONLY: JPRD, JPIM
USE YOMGSTATS, ONLY: NPROC_STATS, JPTAGSTAT, MYPROC_STATS, TIME_START, TIMELCALL, NPRCIDS_STATS
USE MPL_MODULE, ONLY: MPL_BARRIER, MPL_SEND, MPL_RECV

IMPLICIT NONE

INTEGER(KIND=JPIM) :: ITAG, ILSEND, ILBUF, JROC, IRECV, ISEND
REAL(KIND=JPRD) :: ZTBUF(2), ZCLOCK, ZCLOCKB

#include "user_clock.intfb.h"

IF (NPROC_STATS > 1) THEN
  CALL USER_CLOCK(PELAPSED_TIME=ZCLOCKB)
  CALL MPL_BARRIER
  CALL USER_CLOCK(PELAPSED_TIME=ZCLOCK)
  ITAG = JPTAGSTAT
  IF (MYPROC_STATS == 1 ) THEN
    ALLOCATE(TIME_START(NPROC_STATS))
    TIME_START(1) = ZCLOCKB - TIMELCALL(0)
    ILBUF = 2
  ENDIF
  DO JROC = 2, NPROC_STATS
   IF (MYPROC_STATS .EQ. JROC ) THEN
    ZTBUF(1) = ZCLOCKB
    ZTBUF(2) = ZCLOCK
    ILSEND = 2
    ISEND = 1
    CALL MPL_SEND(ZTBUF(1:ILSEND), KDEST=NPRCIDS_STATS(ISEND), KTAG=ITAG, CDSTRING='SUSTATS:')
   ELSEIF (MYPROC_STATS == 1 ) THEN
      IRECV = JROC
      CALL MPL_RECV(ZTBUF(1:ILBUF), KSOURCE=NPRCIDS_STATS(IRECV), KTAG=ITAG, CDSTRING='SUSTATS:')
      TIME_START(JROC) = ZTBUF(1) - TIMELCALL(0) - (ZTBUF(2) - ZCLOCK)
   ENDIF
   CALL MPL_BARRIER
  ENDDO
ENDIF

END SUBROUTINE GSTATS_PSUT

! (C) Copyright 2005- ECMWF.
! (C) Copyright 2013- Meteo-France.
! 
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!

MODULE OML_MOD

!-- the following system specific omp_lib-module is not always available (e.g. pgf90)
!! use omp_lib

USE EC_PARKIND  ,ONLY : JPIM, JPIB
USE EC_LUN, ONLY : NULERR

!**SS/18-Feb-2005
!--Dr.Hook references removed, because these locks may also be
!  called from within drhook.c itself !! 
!--Also, there could be considerable & unjustified overhead
!  when using Dr.Hook in such a low level

!**SS/15-Dec-2005
!--The size of lock-variables are now OMP_LOCK_KIND as of in OMP_LIB,
!  and OMP_LOCK_KIND is aliased to OML_LOCK_KIND
!  OMP_LOCK_KIND is usually 4 in 32-bit addressing mode
!                           8 in 64-bit addressing mode
!--M_OML_LOCK changed to M_EVENT and kept as 32-bit int
!--OML_FUNCT changed to OML_TEST_EVENT
!--M_LOCK initialized to -1
!--M_EVENT initialized to 0
!--Added intent(s)
!--Support for omp_lib (but not always available)
!--Locks can now also be set/unset OUTSIDE the parallel regions
!--Added routine OML_TEST_LOCK (attempts to set lock, but if *un*successful, does NOT  block)
!--Buffer-zone for M_LOCK; now a vector of 2 elements in case problems/inconsistencies with OMP_LOCK_KIND 4/8

!**SS/22-Feb-2006
!--Locking routines are doing nothing unless OMP_GET_MAX_THREADS() > 1
!  This is to avoid unacceptable deadlocks/timeouts with signal handlers when
!  the only thread receives signal while inside locked region
!--Affected routines: OML_TEST_LOCK()  --> always receives .TRUE.
!                     OML_SET_LOCK()   --> sets nothing
!                     OML_UNSET_LOCK() --> unsets nothing
!                     OML_INIT_LOCK()  --> inits nothing

!**SS/11-Sep-2006
!--Added OML_DEBUG feature

!**REK/18-Jul-2007
!--Protected OML_DESTROY_LOCK

!**REK/07-Sep-2007
!--Add OMP FLUSH feature

!**SS/05-Dec-2007
!--Added routine OML_NUM_THREADS([optional_new_number_of_threads])
! 1) To adjust [reduce] the number of threads working in concert
!    Accepts only # of threads between 1 and the max # of threads (i.e. from export OMP_NUM_THREADS=<value>)
! 2) Returns the previous active number of threads
! 3) Can be called from outside the OpenMP-parallel region only

!**SS/14-Dec-2007
!--The routine OML_NUM_THREADS() now also accepts character string (= environment variable)
!  as the sole argumentoz
!--You could now set effective number of threads (<= $OMP_NUM_THREADS) to the value of
!  particular environment variable; f.ex.:
!  export OML_MSGPASS_OBSDATA_READ=8 and call to OML_NUM_THREADS('OML_MSGPASS_OBSDATA_READ')
!  would set the effective no. of threads to (max) 8 when reading obs. wiz msgpass_obsdata

!**SS/09-May-2008
!-- OML_NUM_THREADS() did not work as expected since I misinterpreted the meaning of 
!   the OpenMP-function OMP_GET_NUM_THREADS()
!-- With two PRIVATE [to this module] variables the bug will get sorted out
!   + a new routine OML_INIT() was added (to be called from MPL_INIT or so)

!**FV/27-May-2009
!-- OML_GET_NUM_THREADS()

!**FV/09-Oct-2018
!-- OML_INCR_COUNTER to increment and check before launching synchronization

!**Willem Deconinck/02-Feb-2022
!-- Deprecate OML_GET_NUM_THREADS() and remove overloads as they were not used
!   Use OML_GET_MAX_THREADS instead.
!-- Initialize OML_ABSMAX_THREADS within OML_INIT and abort if OML_INIT was forgotten
!   before accessing OML_ABSMAX_THREADS

!**Sami Saarinen/19-Feb-2022
!-- Final clean-ups & fixes for this module
!:: Rename (and bring back) OML_NUM_THREADS(<value>) as OML_SET_NUM_THREADS(<value>)
!:: Bring back OML_GET_NUM_THREADS() == the *actual* number of threads WHEN IN a parallel region (otherwise == 1)
!:: The OML_GET_MAX_THREADS() is the *currently* available max threads, which could go up|down
!   if OML|OMP_SET_NUM_THREADS(<value>) was called explicitly (NOT recommended -- messes up thread affinity)
!:: Got rid of the confusing OML_ABSMAX_THREADS() -- instead relying solely on OML_MAX_THREADS()
!   Now N_OML_MAX_THREADS holds the max allowed value (upon OML_INIT())
!   this variable never changes and *should* be the high water mark for number of threads ever per run
!   equivalent to the value of "export OMP_NUM_THREADS=<value>" or the system shell default; e.g. that of "nproc --all"
!   Caveat & warning: User may still increase beyond the N_OML_MAX_THREADS by explicitly calling OMP_SET_NUM_THREADS(<value>) !!!
!:: OML_GET_MAX_THREADS() is now an alias to OML_MAX_THREADS()
!:: OML_INIT()'s initialization of N_OML_MAX_THREADS only done if OUTSIDE the parallel region -- otherwise task aborted

IMPLICIT NONE

SAVE

PRIVATE

LOGICAL :: OML_DEBUG = .FALSE.

INTERFACE OML_SET_NUM_THREADS
   MODULE PROCEDURE &
        & OML_SET_NUM_THREADS_INT, &
        & OML_SET_NUM_THREADS_STR
END INTERFACE OML_SET_NUM_THREADS

INTERFACE OML_GET_MAX_THREADS
   MODULE PROCEDURE &
        & OML_MAX_THREADS
END INTERFACE OML_GET_MAX_THREADS

PUBLIC OML_WAIT_EVENT, OML_SET_EVENT, OML_INCR_EVENT, &
   &   OML_MY_THREAD,  OML_MAX_THREADS , OML_GET_MAX_THREADS, OML_OMP, &
   &   OML_IN_PARALLEL, OML_TEST_EVENT, OML_INCR_COUNTER, &
   &   OML_UNSET_LOCK, OML_INIT_LOCK, OML_SET_LOCK, OML_DESTROY_LOCK, &
   &   OML_LOCK_KIND, OML_TEST_LOCK, OML_DEBUG, OML_SET_NUM_THREADS, &
   &   OML_INIT, OML_GET_NUM_THREADS

!-- The following should normally be 4 in 32-bit addressing mode
!                                    8 in 64-bit addressing mode
! Since system specific omp_lib-module is not always available (e.g. pgf90)
! we hardcode OML_LOCK_KIND to JPIB (usually 8) for now
!!INTEGER(KIND=JPIM), PARAMETER :: OML_LOCK_KIND = OMP_LOCK_KIND
INTEGER(KIND=JPIM), PARAMETER :: OML_LOCK_KIND = JPIB

!-- Note: Still JPIM !!
INTEGER(KIND=JPIM) :: M_EVENT = 0

!-- Note: OML_LOCK_KIND, not JPIM !!
INTEGER(KIND=OML_LOCK_KIND) :: M_LOCK(2) = (/-1, -1/)

!-- The two PRIVATE [to this module] variables
INTEGER(KIND=JPIM) :: N_OML_MAX_THREADS = -1

!-- OMP function declarations (that require knowledge of their type) now in one place:

#include "abor1.intfb.h"

CONTAINS

SUBROUTINE OML_INIT()
CHARACTER(LEN=*), PARAMETER :: CLMSG = 'Fatal coding error : Cannot CALL OML_INIT() INSIDE the OpenMP parallel region'
!$ INTEGER(KIND=JPIM) :: OMP_GET_MAX_THREADS
!$ LOGICAL :: OMP_IN_PARALLEL
IF (N_OML_MAX_THREADS == -1) THEN
   IF (OML_IN_PARALLEL()) THEN
      WRITE(NULERR,'(1X,A)') CLMSG
      CALL ABOR1(CLMSG)
      RETURN
   ENDIF
   N_OML_MAX_THREADS = 1
!$ N_OML_MAX_THREADS = OMP_GET_MAX_THREADS()
ENDIF
END SUBROUTINE OML_INIT

FUNCTION OML_OMP()
LOGICAL :: OML_OMP
   OML_OMP=.FALSE.
!$ OML_OMP=.TRUE.
END FUNCTION OML_OMP

FUNCTION OML_IN_PARALLEL()
LOGICAL :: OML_IN_PARALLEL
!$ INTEGER(KIND=JPIM) :: OMP_GET_NUM_THREADS
!$ LOGICAL :: OMP_IN_PARALLEL
   OML_IN_PARALLEL=.FALSE.
!$ OML_IN_PARALLEL=((OMP_GET_NUM_THREADS() > 1).AND.OMP_IN_PARALLEL())
END FUNCTION OML_IN_PARALLEL

FUNCTION OML_TEST_LOCK(MYLOCK)
LOGICAL :: OML_TEST_LOCK
INTEGER(KIND=OML_LOCK_KIND),INTENT(INOUT),OPTIONAL :: MYLOCK
!$ INTEGER(KIND=JPIM) :: OMP_GET_MAX_THREADS
!$ LOGICAL :: OMP_TEST_LOCK
OML_TEST_LOCK = .TRUE.
!$ IF (OMP_GET_MAX_THREADS() > 1) THEN
!$   IF (PRESENT(MYLOCK)) THEN
!$     OML_TEST_LOCK = OMP_TEST_LOCK(MYLOCK)
!$   ELSE
!$     OML_TEST_LOCK = OMP_TEST_LOCK(M_LOCK(1))
!$   ENDIF
!$ ENDIF
END FUNCTION OML_TEST_LOCK

SUBROUTINE OML_UNSET_LOCK(MYLOCK)
INTEGER(KIND=OML_LOCK_KIND),INTENT(INOUT),OPTIONAL :: MYLOCK
!$ INTEGER(KIND=JPIM) :: OMP_GET_MAX_THREADS
!$ IF (OMP_GET_MAX_THREADS() > 1) THEN
!$   IF (PRESENT(MYLOCK)) THEN
!$     CALL OMP_UNSET_LOCK(MYLOCK)
!$   ELSE
!$     CALL OMP_UNSET_LOCK(M_LOCK(1))
!$   ENDIF
!$ ENDIF
END SUBROUTINE OML_UNSET_LOCK

SUBROUTINE OML_SET_LOCK(MYLOCK)
INTEGER(KIND=OML_LOCK_KIND),INTENT(INOUT),OPTIONAL :: MYLOCK
!$ INTEGER(KIND=JPIM) :: OMP_GET_MAX_THREADS
!$ IF (OMP_GET_MAX_THREADS() > 1) THEN
!$   IF (PRESENT(MYLOCK)) THEN
!$     CALL OMP_SET_LOCK(MYLOCK)
!$   ELSE
!$     CALL OMP_SET_LOCK(M_LOCK(1))
!$   ENDIF
!$ ENDIF
END SUBROUTINE OML_SET_LOCK

SUBROUTINE OML_INIT_LOCK(MYLOCK)
INTEGER(KIND=OML_LOCK_KIND),INTENT(INOUT),OPTIONAL :: MYLOCK
!$ INTEGER(KIND=JPIM) :: OMP_GET_MAX_THREADS
!$ IF (OMP_GET_MAX_THREADS() > 1) THEN
!$   IF (PRESENT(MYLOCK)) THEN
!$     CALL OMP_INIT_LOCK(MYLOCK)
!$   ELSE
!$     CALL OMP_INIT_LOCK(M_LOCK(1))
!$   ENDIF
!$ ENDIF
END SUBROUTINE OML_INIT_LOCK

SUBROUTINE OML_DESTROY_LOCK(MYLOCK)
INTEGER(KIND=OML_LOCK_KIND),INTENT(INOUT),OPTIONAL :: MYLOCK
!$ INTEGER(KIND=JPIM) :: OMP_GET_MAX_THREADS
!$ IF (OMP_GET_MAX_THREADS() > 1) THEN
!$   IF (PRESENT(MYLOCK)) THEN
!$     CALL OMP_DESTROY_LOCK(MYLOCK)
!$   ELSE
!$     CALL OMP_DESTROY_LOCK(M_LOCK(1))
!$   ENDIF
!$ ENDIF
END SUBROUTINE OML_DESTROY_LOCK

FUNCTION OML_TEST_EVENT(K,MYEVENT)
LOGICAL :: OML_TEST_EVENT
INTEGER(KIND=JPIM),INTENT(IN) :: K,MYEVENT
!$OMP FLUSH
IF (K.EQ.MYEVENT) THEN
 OML_TEST_EVENT =.TRUE.
ELSE
 OML_TEST_EVENT=.FALSE.
ENDIF
END FUNCTION OML_TEST_EVENT

SUBROUTINE OML_WAIT_EVENT(K,MYEVENT)
INTEGER(KIND=JPIM),INTENT(IN) :: K
INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL :: MYEVENT
IF (PRESENT(MYEVENT)) THEN
  DO
    IF (OML_TEST_EVENT(K,MYEVENT)) EXIT
  ENDDO
ELSE
  DO
    IF (OML_TEST_EVENT(K,M_EVENT)) EXIT
  ENDDO
ENDIF
END SUBROUTINE OML_WAIT_EVENT

SUBROUTINE OML_SET_EVENT(K,MYEVENT)
INTEGER(KIND=JPIM),INTENT(IN) :: K
INTEGER(KIND=JPIM),INTENT(OUT),OPTIONAL :: MYEVENT
IF (PRESENT(MYEVENT)) THEN
  MYEVENT=K
ELSE
  M_EVENT=K
ENDIF
END SUBROUTINE OML_SET_EVENT

SUBROUTINE OML_INCR_EVENT(K,MYEVENT)
INTEGER(KIND=JPIM) :: K
INTEGER(KIND=JPIM),INTENT(INOUT),OPTIONAL :: MYEVENT
!$OMP FLUSH
IF (PRESENT(MYEVENT)) THEN
!$OMP ATOMIC
  MYEVENT=MYEVENT+K
ELSE
!$OMP ATOMIC
  M_EVENT=M_EVENT+K
ENDIF
!$OMP FLUSH
END SUBROUTINE OML_INCR_EVENT

SUBROUTINE OML_INCR_COUNTER(K,KMAX)
INTEGER(KIND=JPIM),INTENT(INOUT) :: K
INTEGER(KIND=JPIM),INTENT(IN) :: KMAX
! Increment by 1
K=K+1
! Security check
IF (K > KMAX)  THEN
   WRITE(NULERR,'("OML_INCR_COUNTER: ILOCK > SIZE(KLOCK), ILOCK=",I0," SIZE(KLOCK)=",I0)') K,KMAX
   CALL ABOR1('PLEASE INCREASE JP_LOCKS IN CALL_SL_AD')
   RETURN
ENDIF
END SUBROUTINE OML_INCR_COUNTER


FUNCTION OML_MY_THREAD()
INTEGER(KIND=JPIM) :: OML_MY_THREAD
!$ INTEGER(KIND=JPIM) :: OMP_GET_THREAD_NUM
   OML_MY_THREAD = 1
!$ OML_MY_THREAD = OMP_GET_THREAD_NUM() + 1
END FUNCTION OML_MY_THREAD

FUNCTION OML_MAX_THREADS() ! alias OML_GET_MAX_THREADS()
INTEGER(KIND=JPIM) :: OML_MAX_THREADS
!$ INTEGER(KIND=JPIM) :: OMP_GET_MAX_THREADS
IF (N_OML_MAX_THREADS == -1) CALL OML_INIT() ! Harmless as usually called OUTSIDE the parallel region (checked)
   OML_MAX_THREADS = 1
!$ OML_MAX_THREADS = OMP_GET_MAX_THREADS()
END FUNCTION OML_MAX_THREADS

FUNCTION OML_GET_NUM_THREADS()
INTEGER(KIND=JPIM) :: OML_GET_NUM_THREADS
!$ INTEGER(KIND=JPIM) :: OMP_GET_NUM_THREADS
   OML_GET_NUM_THREADS = 1
!$ OML_GET_NUM_THREADS = OMP_GET_NUM_THREADS()
END FUNCTION OML_GET_NUM_THREADS

FUNCTION OML_SET_NUM_THREADS_INT(KOMP_SET_THREADS)
INTEGER(KIND=JPIM) :: OML_SET_NUM_THREADS_INT
INTEGER(KIND=JPIM),INTENT(IN) :: KOMP_SET_THREADS
!$ INTEGER(KIND=JPIM) :: OMP_GET_MAX_THREADS
!$ LOGICAL :: OMP_IN_PARALLEL
IF (N_OML_MAX_THREADS == -1) CALL OML_INIT() ! Harmless as usually called OUTSIDE the parallel region (checked)
   OML_SET_NUM_THREADS_INT = 1
!$ OML_SET_NUM_THREADS_INT = OMP_GET_MAX_THREADS()
!$ IF (KOMP_SET_THREADS /= OML_SET_NUM_THREADS_INT) THEN
!$   IF (KOMP_SET_THREADS >= 1 .AND. KOMP_SET_THREADS <= N_OML_MAX_THREADS) THEN
!- This is the absolute max no. of threads allowed   --> ^^^^^^^^^^^^^^^^^ <--
!$     IF (.NOT.OMP_IN_PARALLEL()) THEN ! Change *only* if called from OUTSIDE the OpenMP-parallel region
!$       CALL OMP_SET_NUM_THREADS(KOMP_SET_THREADS) ! Warning: could mess up your thread affinity !!
!$     ENDIF
!$   ENDIF
!$ ENDIF
END FUNCTION OML_SET_NUM_THREADS_INT

FUNCTION OML_SET_NUM_THREADS_STR(CD_ENV)
INTEGER(KIND=JPIM) :: OML_SET_NUM_THREADS_STR
CHARACTER(LEN=*),INTENT(IN) :: CD_ENV
!$ character(len=20) CLvalue
!$ INTEGER(KIND=JPIM) :: ivalue
!$ INTEGER(KIND=JPIM) :: OMP_GET_MAX_THREADS
   OML_SET_NUM_THREADS_STR = 1
!$ OML_SET_NUM_THREADS_STR = OMP_GET_MAX_THREADS()
!$ IF (LEN(CD_ENV) > 0) THEN
!$   CALL GET_ENVIRONMENT_VARIABLE(CD_ENV,CLvalue)
!$   IF (CLvalue /= ' ') THEN
!$     READ(CLvalue,'(i20)',end=99,err=99) ivalue
!$     OML_SET_NUM_THREADS_STR = OML_SET_NUM_THREADS_INT(ivalue)
!$   ENDIF
!$ 99 continue
!$ ENDIF
END FUNCTION OML_SET_NUM_THREADS_STR

!================================================================================================================================
! C bindings ( Signatures in oml.h must match )
!================================================================================================================================

SUBROUTINE OML_SET_DEBUG_BINDC(KONOFF) BIND(C,name="oml_set_debug")
USE, INTRINSIC :: ISO_C_BINDING, ONLY : C_INT
IMPLICIT NONE
INTEGER(KIND=C_INT), VALUE, INTENT(IN) :: KONOFF
IF (KONOFF == 0) THEN 
      OML_DEBUG = .FALSE.
ELSE
      OML_DEBUG = .TRUE.
ENDIF
END SUBROUTINE

FUNCTION OML_GET_DEBUG_BINDC() BIND(C,name="oml_get_debug") RESULT(KRET)
USE, INTRINSIC :: ISO_C_BINDING, ONLY : C_INT
IMPLICIT NONE
INTEGER(KIND=C_INT) :: KRET
KRET = 0
IF (OML_DEBUG) KRET = 1
END FUNCTION

SUBROUTINE OML_INIT_LOCKID_WITH_NAME_BINDC(KMYLOCK,CDLOCKNAME) BIND(C,NAME="oml_init_lockid_with_name")
USE, INTRINSIC :: ISO_C_BINDING, ONLY : C_INTPTR_T, C_CHAR
IMPLICIT NONE
INTEGER(KIND=OML_LOCK_KIND), INTENT(INOUT) :: KMYLOCK
CHARACTER(KIND=C_CHAR,LEN=1), INTENT(IN)   :: CDLOCKNAME(*)
INTEGER(KIND=C_INTPTR_T), EXTERNAL :: LOC_ADDR
CALL OML_INIT_LOCK(KMYLOCK)
IF (OML_DEBUG) WRITE(0,'(1x,a,2i20)') &
      & 'oml_init_lockid_with_name "'//from_c_str(CDLOCKNAME)//'" :',KMYLOCK,LOC_ADDR(KMYLOCK)

CONTAINS

      function from_c_str(s) result(string)
      use, intrinsic :: iso_c_binding, only : c_char, c_null_char
      character(kind=c_char,len=1), intent(in) :: s(*)
      character(len=:), allocatable :: string
      integer i, nchars
      i = 1
      do
          if (s(i) == c_null_char) exit
          i = i + 1
      enddo
      nchars = i - 1  ! Exclude null character from Fortran string
      allocate( character(len=(nchars)) :: string )
      do i=1,nchars
          string(i:i) = s(i)
      enddo
      end function
END SUBROUTINE

SUBROUTINE OML_INIT_LOCKID_BINDC(KMYLOCK) BIND(C,NAME="oml_init_lockid")
USE, INTRINSIC :: ISO_C_BINDING, ONLY : C_INTPTR_T
IMPLICIT NONE
INTEGER(KIND=OML_LOCK_KIND), INTENT(INOUT) :: KMYLOCK
INTEGER(KIND=C_INTPTR_T), EXTERNAL :: LOC_ADDR
CALL OML_INIT_LOCK(KMYLOCK)
IF (OML_DEBUG) WRITE(0,'(1x,2i20)') &
      & 'oml_init_lockid :',KMYLOCK,LOC_ADDR(KMYLOCK)
END SUBROUTINE

SUBROUTINE OML_INIT_LOCK_BINDC() BIND(C,NAME="oml_init_lock")
IMPLICIT NONE
CALL OML_INIT_LOCK()
END SUBROUTINE

FUNCTION OML_TEST_LOCKID_BINDC(KMYLOCK) BIND(C,NAME="oml_test_lockid") RESULT(KISSET)
USE, INTRINSIC :: ISO_C_BINDING, ONLY : C_INT
IMPLICIT NONE
INTEGER(KIND=C_INT) :: KISSET
INTEGER(KIND=OML_LOCK_KIND), INTENT(INOUT) :: KMYLOCK
KISSET = 1
IF (.NOT.OML_TEST_LOCK(KMYLOCK)) KISSET = 0
END FUNCTION

FUNCTION OML_TEST_LOCK_BINDC() BIND(C,NAME="oml_test_lock") RESULT(KISSET)
USE, INTRINSIC :: ISO_C_BINDING, ONLY : C_INT
IMPLICIT NONE
INTEGER(KIND=C_INT) :: KISSET
KISSET = 1
IF (.NOT.OML_TEST_LOCK()) KISSET = 0
END FUNCTION

SUBROUTINE OML_SET_LOCKID_BINDC(KMYLOCK) BIND(C,NAME="oml_set_lockid")
USE, INTRINSIC :: ISO_C_BINDING, ONLY : C_INTPTR_T
USE EC_PARKIND, ONLY : JPRD
IMPLICIT NONE
INTEGER(KIND=OML_LOCK_KIND), INTENT(INOUT) :: KMYLOCK
INTEGER(KIND=C_INTPTR_T), EXTERNAL :: LOC_ADDR
REAL(KIND=JPRD), EXTERNAL :: UTIL_WALLTIME
IF (OML_DEBUG) WRITE(0,'(1x,f20.6,1x,i3,a,2i20)') &
      & UTIL_WALLTIME(),OML_MY_THREAD(),': oml_set_lockid >>',KMYLOCK,LOC_ADDR(KMYLOCK)
CALL OML_SET_LOCK(KMYLOCK)
IF (OML_DEBUG) WRITE(0,'(1x,f20.6,1x,i3,a,2i20)') &
      & UTIL_WALLTIME(),OML_MY_THREAD(),': oml_set_lockid <<',KMYLOCK,LOC_ADDR(KMYLOCK)
END SUBROUTINE

SUBROUTINE OML_SET_LOCK_BINDC() BIND(C,NAME="oml_set_lock")
IMPLICIT NONE
CALL OML_SET_LOCK()
END SUBROUTINE

SUBROUTINE OML_UNSET_LOCK_BINDC() BIND(C,NAME="oml_unset_lock")
IMPLICIT NONE
CALL OML_UNSET_LOCK()
END SUBROUTINE

SUBROUTINE OML_UNSET_LOCKID_BINDC(KMYLOCK) BIND(C,NAME="oml_unset_lockid")
USE, INTRINSIC :: ISO_C_BINDING, ONLY : C_INTPTR_T
USE EC_PARKIND, ONLY : JPRD
IMPLICIT NONE
INTEGER(KIND=OML_LOCK_KIND), INTENT(INOUT) :: KMYLOCK
INTEGER(KIND=C_INTPTR_T), EXTERNAL :: LOC_ADDR
REAL(KIND=JPRD), EXTERNAL :: UTIL_WALLTIME
IF (OML_DEBUG) WRITE(0,'(1x,f20.6,1x,i3,a,2i20)') &
      & UTIL_WALLTIME(),OML_MY_THREAD(),': oml_unset_lockid >>',KMYLOCK,LOC_ADDR(KMYLOCK)
CALL OML_UNSET_LOCK(KMYLOCK)
IF (OML_DEBUG) WRITE(0,'(1x,f20.6,1x,i3,a,2i20)') &
      & UTIL_WALLTIME(),OML_MY_THREAD(),': oml_unset_lockid <<',KMYLOCK,LOC_ADDR(KMYLOCK)
END SUBROUTINE

FUNCTION OML_IN_PARALLEL_BINDC() BIND(C,NAME="oml_in_parallel") RESULT(KISPAR_REGION)
USE, INTRINSIC :: ISO_C_BINDING, ONLY : C_INT
IMPLICIT NONE
INTEGER(KIND=C_INT) :: KISPAR_REGION
KISPAR_REGION = 0
IF (OML_IN_PARALLEL()) KISPAR_REGION = 1
END FUNCTION

FUNCTION OML_GET_MAX_THREADS_BINDC() BIND(C,NAME="oml_get_max_threads") RESULT(KTIDS)
USE, INTRINSIC :: ISO_C_BINDING, ONLY : C_INT
IMPLICIT NONE
INTEGER(KIND=C_INT) :: KTIDS
KTIDS = OML_GET_MAX_THREADS()
END FUNCTION

FUNCTION OML_GET_NUM_THREADS_BINDC() BIND(C,NAME="oml_get_num_threads") RESULT(KTIDS)
USE, INTRINSIC :: ISO_C_BINDING, ONLY : C_INT
IMPLICIT NONE
INTEGER(KIND=C_INT) :: KTIDS
KTIDS = OML_GET_NUM_THREADS()
END FUNCTION

FUNCTION OML_MY_THREAD_BINDC() BIND(C,NAME="oml_my_thread") RESULT(KMYTID)
USE, INTRINSIC :: ISO_C_BINDING, ONLY : C_INT
IMPLICIT NONE
INTEGER(KIND=C_INT) :: KMYTID
KMYTID = OML_MY_THREAD()
END FUNCTION

END MODULE OML_MOD

! (C) Copyright 2005- ECMWF.
! (C) Copyright 2013- Meteo-France.
! 
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!

MODULE MPL_RECV_MOD

!**** MPL_RECV Receive a message

!     Purpose.
!     --------
!     Receive a message from a named source into a buffer.
!     The data may be REAL*4, REAL*8,or INTEGER, one dimensional array
!                     REAL*4,or REAL*8, two dimensional array
!                  or REAL or INTEGER scalar

!**   Interface.
!     ----------
!        CALL MPL_RECV

!        Input required arguments :
!        -------------------------
!           PBUF     -  buffer to receive the message
!                       (can be type REAL*4, REAL*8 or INTEGER)

!        Input optional arguments :
!        -------------------------
!           KTAG     -  message tag
!           KCOMM    -  Communicator number if different from MPI_COMM_WORLD 
!           KMP_TYPE -  buffering type (see MPL_BUFFER_METHOD)
!                       overrides value provided to MPL_BUFFER_METHOD
!           KSOURCE  -  rank of process sending the message
!                       default is MPI_ANY_SOURCE
!           CDSTRING -  Character string for ABORT messages
!                       used when KERROR is not provided

!        Output required arguments :
!        -------------------------
!           none

!        Output optional arguments :
!        -------------------------
!           KREQUEST -  Communication request
!                       required when buffering type is non-blocking
!           KFROM    -  rank of process sending the message
!           KRECVTAG -  tag of received message
!           KOUNT    -  number of items in received message
!           KERROR   -  return error code.     If not supplied, 
!                       MPL_RECV aborts when an error is detected.
!     Author.
!     -------
!        D.Dent, M.Hamrud     ECMWF

!     Modifications.
!     --------------
!        Original: 2000-09-01
!      F. Vana  05-Mar-2015  Support for single precision

!     ------------------------------------------------------------------

USE EC_PARKIND , ONLY : JPRD, JPIB, JPIM, JPRM
USE OML_MOD   ,ONLY : OML_MY_THREAD

USE MPL_MPIF
USE MPL_DATA_MODULE
USE MPL_STATS_MOD
USE YOMMPLSTATS
USE MPL_MESSAGE_MOD
USE MPL_NPROC_MOD

IMPLICIT NONE

PRIVATE

INTERFACE MPL_RECV
MODULE PROCEDURE MPL_RECV_REAL4,  MPL_RECV_REAL8, &
               & MPL_RECV_INT,    MPL_RECV_REAL42, MPL_RECV_REAL43, &
               & MPL_RECV_REAL82, MPL_RECV_REAL83, MPL_RECV_INT_SCALAR, &
               & MPL_RECV_INT2,   MPL_RECV_REAL4_SCALAR, &
               & MPL_RECV_REAL8_SCALAR, MPL_RECV_CHAR_SCALAR, &
               & MPL_RECV_INT8, MPL_RECV_CHAR
END INTERFACE

PUBLIC MPL_RECV

CONTAINS

!     ------------------------------------------------------------------

SUBROUTINE MPL_RECV_PREAMB(KMP_TYPER,KCOMMR,KSOURCER,KTAGR,KMP_TYPE,KCOMM,KSOURCE,KTAG,KREQUEST)
INTEGER(KIND=JPIM),INTENT(OUT) :: KMP_TYPER,KCOMMR,KSOURCER,KTAGR
INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL :: KMP_TYPE,KCOMM,KSOURCE,KTAG
INTEGER(KIND=JPIM),OPTIONAL :: KREQUEST

LOGICAL :: LLABORT=.TRUE.
INTEGER(KIND=JPIM) :: ITID

ITID = OML_MY_THREAD()

IF(MPL_NUMPROC < 1) CALL MPL_MESSAGE(&
  & CDMESSAGE='MPL_RECV: MPL NOT INITIALISED ',LDABORT=LLABORT) 

IF(PRESENT(KMP_TYPE)) THEN
  KMP_TYPER=KMP_TYPE
ELSE
  KMP_TYPER=MPL_METHOD
ENDIF

IF(KMP_TYPER == JP_NON_BLOCKING_STANDARD) THEN
  IF( .NOT. PRESENT(KREQUEST)) THEN
    CALL MPL_MESSAGE(CDMESSAGE='MPL_RECV:KREQUEST MISSING ',LDABORT=LLABORT)
  ENDIF
ENDIF

IF(PRESENT(KCOMM)) THEN
  KCOMMR=KCOMM
ELSE
  KCOMMR=MPL_COMM_OML(ITID)
ENDIF

IF(PRESENT(KSOURCE)) THEN
  IF(KSOURCE < 1 .OR. KSOURCE >MPL_NPROC(KCOMMR)) THEN
    WRITE(MPL_ERRUNIT,*)'MPL_RECV: ERROR KSOURCE=',KSOURCE
    CALL MPL_MESSAGE(CDMESSAGE='MPL_RECV:ILLEGAL KSOURCE ',LDABORT=LLABORT)
  ENDIF
  KSOURCER=KSOURCE-1
ELSE
  KSOURCER=MPI_ANY_SOURCE
ENDIF

IF(PRESENT(KTAG)) THEN
  KTAGR=KTAG
ELSE
  KTAGR=MPI_ANY_TAG
ENDIF

END SUBROUTINE MPL_RECV_PREAMB

!     ------------------------------------------------------------------

SUBROUTINE MPL_RECV_TAIL(KRECV_STATUS,KTYPE,KFROM,KOUNT,KRECVTAG,KERROR,CDSTRING)


#ifdef USE_8_BYTE_WORDS
  USE MPI4TO8, ONLY : &
    MPI_RECV => MPI_RECV8, MPI_GET_COUNT => MPI_GET_COUNT8
#endif

INTEGER(KIND=JPIM),INTENT(IN) :: KRECV_STATUS(MPI_STATUS_SIZE)
INTEGER(KIND=JPIM),INTENT(IN) :: KTYPE
INTEGER(KIND=JPIM),INTENT(OUT),OPTIONAL :: KERROR,KFROM,KRECVTAG,KOUNT
CHARACTER(LEN=*),INTENT(IN),OPTIONAL :: CDSTRING

INTEGER(KIND=JPIM) :: IMP_TYPE,ICOMM,IERROR 
INTEGER(KIND=JPIM) :: IFROM,IRECVTAG,IRECVCOUNT
LOGICAL :: LLABORT=.TRUE.

IFROM=KRECV_STATUS(MPI_SOURCE)+1
IF(PRESENT(KFROM)) THEN
  KFROM=IFROM
ENDIF
CALL MPI_GET_COUNT(KRECV_STATUS,KTYPE,IRECVCOUNT,IERROR)
IF(PRESENT(KOUNT)) THEN
  KOUNT=IRECVCOUNT
ENDIF
IF(LMPLSTATS) CALL MPL_RECVSTATS(IRECVCOUNT,KTYPE)
IRECVTAG=KRECV_STATUS(MPI_TAG)
IF(PRESENT(KRECVTAG)) THEN
  KRECVTAG=IRECVTAG
ENDIF
!IF(MPL_OUTPUT > 1 )THEN
!  WRITE(MPL_UNIT,'(A,5I8)') ' MPL_RECV ',IRECVCOUNT,IMP_TYPE,IFROM,IRECVTAG,ICOMM
!ENDIF
IF(PRESENT(KERROR)) THEN
  KERROR=IERROR
ELSE
  IF(IERROR /= 0 ) CALL MPL_MESSAGE(IERROR,'MPL_RECV',CDSTRING,LDABORT=LLABORT)
ENDIF

END SUBROUTINE MPL_RECV_TAIL

!     ------------------------------------------------------------------

SUBROUTINE MPL_RECV_REAL4(PBUF,KSOURCE,KTAG,KCOMM,KFROM,KRECVTAG,&
 &KOUNT,KMP_TYPE,KERROR,KREQUEST,CDSTRING)


#ifdef USE_8_BYTE_WORDS
  USE MPI4TO8, ONLY : &
    MPI_RECV => MPI_RECV8,  MPI_IRECV => MPI_IRECV8
#endif


REAL(KIND=JPRM)            :: PBUF(:)
INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL :: KTAG,KCOMM,KMP_TYPE,KSOURCE
INTEGER(KIND=JPIM),INTENT(OUT),OPTIONAL :: KREQUEST,KERROR,KFROM,KRECVTAG,KOUNT
CHARACTER(LEN=*),INTENT(IN),OPTIONAL :: CDSTRING

INTEGER(KIND=JPIM) :: IBUFFSIZE,IMP_TYPE,ICOMM,IERROR 
INTEGER(KIND=JPIM) :: ISOURCE,ITAG
INTEGER(KIND=JPIM) :: IRECV_STATUS(MPI_STATUS_SIZE)
LOGICAL :: LLABORT=.TRUE.
INTEGER(KIND=JPIM) :: ITID
REAL(KIND=JPRM)    :: ZDUM(1)
ITID = OML_MY_THREAD()

CALL MPL_RECV_PREAMB(IMP_TYPE,ICOMM,ISOURCE,ITAG,KMP_TYPE,KCOMM,KSOURCE,KTAG,KREQUEST)

IBUFFSIZE = SIZE(PBUF)

#ifndef NAG
IF (IBUFFSIZE > 0) THEN
  IF( (LOC(PBUF(UBOUND(PBUF,1))) - LOC(PBUF(LBOUND(PBUF,1)))) /= 4_JPIB*(IBUFFSIZE - 1) ) THEN
    CALL MPL_MESSAGE(CDMESSAGE='MPL_RECV: BUFFER NOT CONTIGUOUS ',LDABORT=LLABORT)
  ENDIF
ENDIF
#endif

IF(IBUFFSIZE == 0) THEN
  IF(IMP_TYPE == JP_BLOCKING_STANDARD) THEN
    CALL MPI_RECV(ZDUM(1),1,INT(MPI_REAL4),ISOURCE,ITAG,ICOMM,IRECV_STATUS,IERROR)
  ELSEIF(IMP_TYPE == JP_BLOCKING_BUFFERED) THEN
    CALL MPI_RECV(ZDUM(1),1,INT(MPI_REAL4),ISOURCE,ITAG,ICOMM,IRECV_STATUS,IERROR)
  ELSEIF(IMP_TYPE == JP_NON_BLOCKING_STANDARD) THEN
    CALL MPI_IRECV(ZDUM(1),1,INT(MPI_REAL4),ISOURCE,ITAG,ICOMM, &
     & KREQUEST,IERROR)
  ELSE
    CALL MPL_MESSAGE(CDMESSAGE='MPL_RECV:ILLEGAL MP_TYPE ',LDABORT=LLABORT)
  ENDIF
ELSE
  IF(IMP_TYPE == JP_BLOCKING_STANDARD) THEN
    CALL MPI_RECV(PBUF(1),IBUFFSIZE,INT(MPI_REAL4),ISOURCE,ITAG,ICOMM,IRECV_STATUS,IERROR)
  ELSEIF(IMP_TYPE == JP_BLOCKING_BUFFERED) THEN
    CALL MPI_RECV(PBUF(1),IBUFFSIZE,INT(MPI_REAL4),ISOURCE,ITAG,ICOMM,IRECV_STATUS,IERROR)
  ELSEIF(IMP_TYPE == JP_NON_BLOCKING_STANDARD) THEN
    CALL MPI_IRECV(PBUF(1),IBUFFSIZE,INT(MPI_REAL4),ISOURCE,ITAG,ICOMM, &
     & KREQUEST,IERROR)
  ELSE
    CALL MPL_MESSAGE(CDMESSAGE='MPL_RECV:ILLEGAL MP_TYPE ',LDABORT=LLABORT)
  ENDIF
ENDIF

IF(IMP_TYPE /= JP_NON_BLOCKING_STANDARD) THEN
  CALL MPL_RECV_TAIL(IRECV_STATUS,INT(MPI_REAL4),KFROM,KOUNT,KRECVTAG,KERROR,CDSTRING)
ELSE
  IF(LMPLSTATS) CALL MPL_RECVSTATS(IBUFFSIZE,INT(MPI_REAL4))
ENDIF

END SUBROUTINE MPL_RECV_REAL4  

!     ------------------------------------------------------------------

SUBROUTINE MPL_RECV_REAL8(PBUF,KSOURCE,KTAG,KCOMM,KFROM,KRECVTAG,&
 &KOUNT,KMP_TYPE,KERROR,KREQUEST,CDSTRING)

#ifdef USE_8_BYTE_WORDS
  USE MPI4TO8, ONLY : &
    MPI_RECV => MPI_RECV8,  MPI_IRECV => MPI_IRECV8
#endif

! real_b,intent(in) :: PBUF(:)
REAL(KIND=JPRD)            :: PBUF(:)
INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL :: KTAG,KCOMM,KMP_TYPE,KSOURCE
INTEGER(KIND=JPIM),INTENT(OUT),OPTIONAL :: KREQUEST,KERROR,KFROM,KRECVTAG,KOUNT
CHARACTER(LEN=*),INTENT(IN),OPTIONAL :: CDSTRING

INTEGER(KIND=JPIM) :: IBUFFSIZE,IMP_TYPE,ICOMM,IERROR 
INTEGER(KIND=JPIM) :: ISOURCE,ITAG
INTEGER(KIND=JPIM) :: IRECV_STATUS(MPI_STATUS_SIZE)
LOGICAL :: LLABORT=.TRUE.
INTEGER(KIND=JPIM) :: ITID
REAL(KIND=JPRD)    :: ZDUM(1)
ITID = OML_MY_THREAD()

CALL MPL_RECV_PREAMB(IMP_TYPE,ICOMM,ISOURCE,ITAG,KMP_TYPE,KCOMM,KSOURCE,KTAG,KREQUEST)

IBUFFSIZE = SIZE(PBUF)
#ifndef NAG
IF (IBUFFSIZE > 0) THEN
  IF( (LOC(PBUF(UBOUND(PBUF,1))) - LOC(PBUF(LBOUND(PBUF,1)))) /= 8_JPIB*(IBUFFSIZE - 1) ) THEN
    CALL MPL_MESSAGE(CDMESSAGE='MPL_RECV: BUFFER NOT CONTIGUOUS ',LDABORT=LLABORT)
  ENDIF
ENDIF
#endif

IF(IBUFFSIZE == 0) THEN
  IF(IMP_TYPE == JP_BLOCKING_STANDARD) THEN
    CALL MPI_RECV(ZDUM(1),1,INT(MPI_REAL8),ISOURCE,ITAG,ICOMM,IRECV_STATUS,IERROR)
  ELSEIF(IMP_TYPE == JP_BLOCKING_BUFFERED) THEN
    CALL MPI_RECV(ZDUM(1),1,INT(MPI_REAL8),ISOURCE,ITAG,ICOMM,IRECV_STATUS,IERROR)
  ELSEIF(IMP_TYPE == JP_NON_BLOCKING_STANDARD) THEN
    CALL MPI_IRECV(ZDUM(1),1,INT(MPI_REAL8),ISOURCE,ITAG,ICOMM, &
     & KREQUEST,IERROR)
  ELSE
    CALL MPL_MESSAGE(CDMESSAGE='MPL_RECV:ILLEGAL MP_TYPE ',LDABORT=LLABORT)
  ENDIF
ELSE
  IF(IMP_TYPE == JP_BLOCKING_STANDARD) THEN
    CALL MPI_RECV(PBUF(1),IBUFFSIZE,INT(MPI_REAL8),ISOURCE,ITAG,ICOMM,IRECV_STATUS,IERROR)
  ELSEIF(IMP_TYPE == JP_BLOCKING_BUFFERED) THEN
    CALL MPI_RECV(PBUF(1),IBUFFSIZE,INT(MPI_REAL8),ISOURCE,ITAG,ICOMM,IRECV_STATUS,IERROR)
  ELSEIF(IMP_TYPE == JP_NON_BLOCKING_STANDARD) THEN
    CALL MPI_IRECV(PBUF(1),IBUFFSIZE,INT(MPI_REAL8),ISOURCE,ITAG,ICOMM, &
     & KREQUEST,IERROR)
  ELSE
    CALL MPL_MESSAGE(CDMESSAGE='MPL_RECV:ILLEGAL MP_TYPE ',LDABORT=LLABORT)
  ENDIF
ENDIF

IF(IMP_TYPE /= JP_NON_BLOCKING_STANDARD) THEN
  CALL MPL_RECV_TAIL(IRECV_STATUS,INT(MPI_REAL8),KFROM,KOUNT,KRECVTAG,KERROR,CDSTRING)
ELSE
  IF(LMPLSTATS) CALL MPL_RECVSTATS(IBUFFSIZE,INT(MPI_REAL8))
ENDIF

END SUBROUTINE MPL_RECV_REAL8

!     ------------------------------------------------------------------

SUBROUTINE MPL_RECV_INT(KBUF,KSOURCE,KTAG,KCOMM,KFROM,KRECVTAG,KOUNT,&
 &KMP_TYPE,KERROR,KREQUEST,CDSTRING)

#ifdef USE_8_BYTE_WORDS
  USE MPI4TO8, ONLY : &
    MPI_RECV => MPI_RECV8,  MPI_IRECV => MPI_IRECV8
#endif

INTEGER(KIND=JPIM)           :: KBUF(:)
INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL :: KTAG,KCOMM,KMP_TYPE,KSOURCE
INTEGER(KIND=JPIM),INTENT(OUT),OPTIONAL :: KREQUEST,KERROR,KFROM,KRECVTAG,KOUNT
CHARACTER(LEN=*),INTENT(IN),OPTIONAL :: CDSTRING

INTEGER(KIND=JPIM) :: IBUFFSIZE,IMP_TYPE,ICOMM,IERROR 
INTEGER(KIND=JPIM) :: ISOURCE,ITAG
INTEGER(KIND=JPIM) :: IRECV_STATUS(MPI_STATUS_SIZE)
LOGICAL :: LLABORT=.TRUE.
INTEGER(KIND=JPIM) :: ITID,IDUM(1)
ITID = OML_MY_THREAD()

CALL MPL_RECV_PREAMB(IMP_TYPE,ICOMM,ISOURCE,ITAG,KMP_TYPE,KCOMM,KSOURCE,KTAG,KREQUEST)

IBUFFSIZE = SIZE(KBUF)
#ifndef NAG
IF (IBUFFSIZE > 0) THEN
  IF( (LOC(KBUF(UBOUND(KBUF,1)))-LOC(KBUF(LBOUND(KBUF,1)))) /= 4_JPIB*(IBUFFSIZE - 1) ) THEN
    CALL MPL_MESSAGE(CDMESSAGE='MPL_RECV: BUFFER NOT CONTIGUOUS ',LDABORT=LLABORT)
  ENDIF
ENDIF
#endif

IF(IBUFFSIZE == 0) THEN
  IF(IMP_TYPE == JP_BLOCKING_STANDARD) THEN
    CALL MPI_RECV(IDUM(1),1,INT(MPI_INTEGER),ISOURCE,ITAG,ICOMM,IRECV_STATUS,IERROR)
  ELSEIF(IMP_TYPE == JP_BLOCKING_BUFFERED) THEN
    CALL MPI_RECV(IDUM(1),1,INT(MPI_INTEGER),ISOURCE,ITAG,ICOMM,IRECV_STATUS,IERROR)
  ELSEIF(IMP_TYPE == JP_NON_BLOCKING_STANDARD) THEN
    CALL MPI_IRECV(IDUM(1),1,INT(MPI_INTEGER),ISOURCE,ITAG,ICOMM, &
     & KREQUEST,IERROR)
  ELSE
    CALL MPL_MESSAGE(CDMESSAGE='MPL_RECV:ILLEGAL MP_TYPE ',LDABORT=LLABORT)
  ENDIF
ELSE
  IF(IMP_TYPE == JP_BLOCKING_STANDARD) THEN
    CALL MPI_RECV(KBUF(1),IBUFFSIZE,INT(MPI_INTEGER),ISOURCE,ITAG,ICOMM,IRECV_STATUS,IERROR)
  ELSEIF(IMP_TYPE == JP_BLOCKING_BUFFERED) THEN
    CALL MPI_RECV(KBUF(1),IBUFFSIZE,INT(MPI_INTEGER),ISOURCE,ITAG,ICOMM,IRECV_STATUS,IERROR)
  ELSEIF(IMP_TYPE == JP_NON_BLOCKING_STANDARD) THEN
    CALL MPI_IRECV(KBUF(1),IBUFFSIZE,INT(MPI_INTEGER),ISOURCE,ITAG,ICOMM, &
     & KREQUEST,IERROR)
  ELSE
    CALL MPL_MESSAGE(CDMESSAGE='MPL_RECV:ILLEGAL MP_TYPE ',LDABORT=LLABORT)
  ENDIF
ENDIF
IF(IMP_TYPE /= JP_NON_BLOCKING_STANDARD) THEN
  CALL MPL_RECV_TAIL(IRECV_STATUS,INT(MPI_INTEGER),KFROM,KOUNT,KRECVTAG,KERROR,CDSTRING)
ELSE
  IF(LMPLSTATS) CALL MPL_RECVSTATS(IBUFFSIZE,INT(MPI_INTEGER))
ENDIF

END SUBROUTINE MPL_RECV_INT

SUBROUTINE MPL_RECV_INT8(KBUF,KSOURCE,KTAG,KCOMM,KFROM,KRECVTAG,KOUNT,&
 &KMP_TYPE,KERROR,KREQUEST,CDSTRING)

#ifdef USE_8_BYTE_WORDS
  USE MPI4TO8, ONLY : &
    MPI_RECV => MPI_RECV8,  MPI_IRECV => MPI_IRECV8
#endif

INTEGER(KIND=JPIB)           :: KBUF(:)
INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL :: KTAG,KCOMM,KMP_TYPE,KSOURCE
INTEGER(KIND=JPIM),INTENT(OUT),OPTIONAL :: KREQUEST,KERROR,KFROM,KRECVTAG,KOUNT
CHARACTER(LEN=*),INTENT(IN),OPTIONAL :: CDSTRING

INTEGER(KIND=JPIM) :: IBUFFSIZE,IMP_TYPE,ICOMM,IERROR 
INTEGER(KIND=JPIM) :: ISOURCE,ITAG
INTEGER(KIND=JPIM) :: IRECV_STATUS(MPI_STATUS_SIZE)
LOGICAL :: LLABORT=.TRUE.
INTEGER(KIND=JPIM) :: ITID
INTEGER(KIND=JPIB) :: IDUM(1)
ITID = OML_MY_THREAD()

CALL MPL_RECV_PREAMB(IMP_TYPE,ICOMM,ISOURCE,ITAG,KMP_TYPE,KCOMM,KSOURCE,KTAG,KREQUEST)

IBUFFSIZE = SIZE(KBUF)
#ifndef NAG
IF (IBUFFSIZE > 0) THEN
  IF( (LOC(KBUF(UBOUND(KBUF,1)))-LOC(KBUF(LBOUND(KBUF,1)))) /= 8_JPIB*(IBUFFSIZE - 1) ) THEN
    CALL MPL_MESSAGE(CDMESSAGE='MPL_RECV: BUFFER NOT CONTIGUOUS ',LDABORT=LLABORT)
  ENDIF
ENDIF
#endif

IF(IBUFFSIZE == 0 ) THEN
  IF(IMP_TYPE == JP_BLOCKING_STANDARD) THEN
    CALL MPI_RECV(IDUM(1),1,INT(MPI_INTEGER8),ISOURCE,ITAG,ICOMM,IRECV_STATUS,IERROR)
  ELSEIF(IMP_TYPE == JP_BLOCKING_BUFFERED) THEN
    CALL MPI_RECV(IDUM(1),1,INT(MPI_INTEGER8),ISOURCE,ITAG,ICOMM,IRECV_STATUS,IERROR)
  ELSEIF(IMP_TYPE == JP_NON_BLOCKING_STANDARD) THEN
    CALL MPI_IRECV(IDUM(1),1,INT(MPI_INTEGER8),ISOURCE,ITAG,ICOMM, &
     & KREQUEST,IERROR)
  ELSE
    CALL MPL_MESSAGE(CDMESSAGE='MPL_RECV:ILLEGAL MP_TYPE ',LDABORT=LLABORT)
  ENDIF
ELSE
  IF(IMP_TYPE == JP_BLOCKING_STANDARD) THEN
    CALL MPI_RECV(KBUF(1),IBUFFSIZE,INT(MPI_INTEGER8),ISOURCE,ITAG,ICOMM,IRECV_STATUS,IERROR)
  ELSEIF(IMP_TYPE == JP_BLOCKING_BUFFERED) THEN
    CALL MPI_RECV(KBUF(1),IBUFFSIZE,INT(MPI_INTEGER8),ISOURCE,ITAG,ICOMM,IRECV_STATUS,IERROR)
  ELSEIF(IMP_TYPE == JP_NON_BLOCKING_STANDARD) THEN
    CALL MPI_IRECV(KBUF(1),IBUFFSIZE,INT(MPI_INTEGER8),ISOURCE,ITAG,ICOMM, &
     & KREQUEST,IERROR)
  ELSE
    CALL MPL_MESSAGE(CDMESSAGE='MPL_RECV:ILLEGAL MP_TYPE ',LDABORT=LLABORT)
  ENDIF
ENDIF

IF(IMP_TYPE /= JP_NON_BLOCKING_STANDARD) THEN
  CALL MPL_RECV_TAIL(IRECV_STATUS,INT(MPI_INTEGER8),KFROM,KOUNT,KRECVTAG,KERROR,CDSTRING)
ELSE
  IF(LMPLSTATS) CALL MPL_RECVSTATS(IBUFFSIZE,INT(MPI_INTEGER8))
ENDIF

END SUBROUTINE MPL_RECV_INT8

!     ------------------------------------------------------------------

SUBROUTINE MPL_RECV_INT2(KBUF,KSOURCE,KTAG,KCOMM,KFROM,KRECVTAG,&
 &KOUNT,KMP_TYPE,KERROR,KREQUEST,CDSTRING)

#ifdef USE_8_BYTE_WORDS
  USE MPI4TO8, ONLY : &
    MPI_RECV => MPI_RECV8,  MPI_IRECV => MPI_IRECV8
#endif

INTEGER(KIND=JPIM)           :: KBUF(:,:)
INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL :: KTAG,KCOMM,KMP_TYPE,KSOURCE
INTEGER(KIND=JPIM),INTENT(OUT),OPTIONAL :: KREQUEST,KERROR,KFROM,KRECVTAG,KOUNT
CHARACTER(LEN=*),INTENT(IN),OPTIONAL :: CDSTRING

INTEGER(KIND=JPIM) :: IBUFFSIZE,IMP_TYPE,ICOMM,IERROR 
INTEGER(KIND=JPIM) :: ISOURCE,ITAG
INTEGER(KIND=JPIM) :: IRECV_STATUS(MPI_STATUS_SIZE)
LOGICAL :: LLABORT=.TRUE.
INTEGER(KIND=JPIM) :: ITID, IDUM(1)
ITID = OML_MY_THREAD()

CALL MPL_RECV_PREAMB(IMP_TYPE,ICOMM,ISOURCE,ITAG,KMP_TYPE,KCOMM,KSOURCE,KTAG,KREQUEST)

IBUFFSIZE = SIZE(KBUF)
#ifndef NAG
IF (IBUFFSIZE > 0) THEN
  IF( (LOC(KBUF(UBOUND(KBUF,1),UBOUND(KBUF,2))) - &
     & LOC(KBUF(LBOUND(KBUF,1),LBOUND(KBUF,2)))) /= 4_JPIB*(IBUFFSIZE - 1) ) THEN
    CALL MPL_MESSAGE(CDMESSAGE='MPL_RECV: BUFFER NOT CONTIGUOUS ',LDABORT=LLABORT)
  ENDIF
ENDIF
#endif

IF(IBUFFSIZE == 0 ) THEN
  IF(IMP_TYPE == JP_BLOCKING_STANDARD) THEN
    CALL MPI_RECV(IDUM(1),1,INT(MPI_INTEGER),ISOURCE,ITAG,ICOMM,IRECV_STATUS,IERROR)
  ELSEIF(IMP_TYPE == JP_BLOCKING_BUFFERED) THEN
    CALL MPI_RECV(IDUM(1),1,INT(MPI_INTEGER),ISOURCE,ITAG,ICOMM,IRECV_STATUS,IERROR)
  ELSEIF(IMP_TYPE == JP_NON_BLOCKING_STANDARD) THEN
    CALL MPI_IRECV(IDUM(1),1,INT(MPI_INTEGER),ISOURCE,ITAG,ICOMM, &
     & KREQUEST,IERROR)
  ELSE
    CALL MPL_MESSAGE(CDMESSAGE='MPL_RECV:ILLEGAL MP_TYPE ',LDABORT=LLABORT)
  ENDIF
ELSE
  IF(IMP_TYPE == JP_BLOCKING_STANDARD) THEN
    CALL MPI_RECV(KBUF(1,1),IBUFFSIZE,INT(MPI_INTEGER),ISOURCE,ITAG,ICOMM,IRECV_STATUS,IERROR)
  ELSEIF(IMP_TYPE == JP_BLOCKING_BUFFERED) THEN
    CALL MPI_RECV(KBUF(1,1),IBUFFSIZE,INT(MPI_INTEGER),ISOURCE,ITAG,ICOMM,IRECV_STATUS,IERROR)
  ELSEIF(IMP_TYPE == JP_NON_BLOCKING_STANDARD) THEN
    CALL MPI_IRECV(KBUF(1,1),IBUFFSIZE,INT(MPI_INTEGER),ISOURCE,ITAG,ICOMM, &
     & KREQUEST,IERROR)
  ELSE
    CALL MPL_MESSAGE(CDMESSAGE='MPL_RECV:ILLEGAL MP_TYPE ',LDABORT=LLABORT)
  ENDIF
ENDIF

IF(IMP_TYPE /= JP_NON_BLOCKING_STANDARD) THEN
  CALL MPL_RECV_TAIL(IRECV_STATUS,INT(MPI_INTEGER),KFROM,KOUNT,KRECVTAG,KERROR,CDSTRING)
ELSE
  IF(LMPLSTATS) CALL MPL_RECVSTATS(IBUFFSIZE,INT(MPI_INTEGER))
ENDIF

END SUBROUTINE MPL_RECV_INT2

!     ------------------------------------------------------------------

SUBROUTINE MPL_RECV_INT_SCALAR(KINT,KSOURCE,KTAG,KCOMM,KFROM,KRECVTAG,&
 &KOUNT,KMP_TYPE,KERROR,KREQUEST,CDSTRING)

#ifdef USE_8_BYTE_WORDS
  USE MPI4TO8, ONLY : &
    MPI_RECV => MPI_RECV8,  MPI_IRECV => MPI_IRECV8
#endif

INTEGER(KIND=JPIM)           :: KINT
INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL :: KTAG,KCOMM,KMP_TYPE,KSOURCE
INTEGER(KIND=JPIM),INTENT(OUT),OPTIONAL :: KREQUEST,KERROR,KFROM,KRECVTAG,KOUNT
CHARACTER(LEN=*),INTENT(IN),OPTIONAL :: CDSTRING

INTEGER(KIND=JPIM) :: IBUFFSIZE,IMP_TYPE,ICOMM,IERROR 
INTEGER(KIND=JPIM) :: ISOURCE,ITAG
INTEGER(KIND=JPIM) :: IRECV_STATUS(MPI_STATUS_SIZE)
LOGICAL :: LLABORT=.TRUE.
INTEGER(KIND=JPIM) :: ITID
ITID = OML_MY_THREAD()

CALL MPL_RECV_PREAMB(IMP_TYPE,ICOMM,ISOURCE,ITAG,KMP_TYPE,KCOMM,KSOURCE,KTAG,KREQUEST)

IBUFFSIZE = 1

IF(IMP_TYPE == JP_BLOCKING_STANDARD) THEN
  CALL MPI_RECV(KINT,IBUFFSIZE,INT(MPI_INTEGER),ISOURCE,ITAG,ICOMM,IRECV_STATUS,IERROR)
ELSEIF(IMP_TYPE == JP_BLOCKING_BUFFERED) THEN
  CALL MPI_RECV(KINT,IBUFFSIZE,INT(MPI_INTEGER),ISOURCE,ITAG,ICOMM,IRECV_STATUS,IERROR)
ELSEIF(IMP_TYPE == JP_NON_BLOCKING_STANDARD) THEN
  CALL MPI_IRECV(KINT,IBUFFSIZE,INT(MPI_INTEGER),ISOURCE,ITAG,ICOMM, &
    & KREQUEST,IERROR)
ELSE
  CALL MPL_MESSAGE(CDMESSAGE='MPL_RECV:ILLEGAL MP_TYPE ',LDABORT=LLABORT)
ENDIF

IF(IMP_TYPE /= JP_NON_BLOCKING_STANDARD) THEN
  CALL MPL_RECV_TAIL(IRECV_STATUS,INT(MPI_INTEGER),KFROM,KOUNT,KRECVTAG,KERROR,CDSTRING)
ELSE
  IF(LMPLSTATS) CALL MPL_RECVSTATS(IBUFFSIZE,INT(MPI_INTEGER))
ENDIF

END SUBROUTINE MPL_RECV_INT_SCALAR

!     ------------------------------------------------------------------

SUBROUTINE MPL_RECV_REAL4_SCALAR(PREAL4,KSOURCE,KTAG,KCOMM,KFROM,KRECVTAG,&
 &KOUNT,KMP_TYPE,KERROR,KREQUEST,CDSTRING)


#ifdef USE_8_BYTE_WORDS
  USE MPI4TO8, ONLY : &
    MPI_RECV => MPI_RECV8,  MPI_IRECV => MPI_IRECV8
#endif


REAL(KIND=JPRM)           :: PREAL4
INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL :: KTAG,KCOMM,KMP_TYPE,KSOURCE
INTEGER(KIND=JPIM),INTENT(OUT),OPTIONAL :: KREQUEST,KERROR,KFROM,KRECVTAG,KOUNT
CHARACTER(LEN=*),INTENT(IN),OPTIONAL :: CDSTRING

INTEGER(KIND=JPIM) :: IBUFFSIZE,IMP_TYPE,ICOMM,IERROR 
INTEGER(KIND=JPIM) :: ISOURCE,ITAG
INTEGER(KIND=JPIM) :: IRECV_STATUS(MPI_STATUS_SIZE)
LOGICAL :: LLABORT=.TRUE.
INTEGER(KIND=JPIM) :: ITID
ITID = OML_MY_THREAD()

CALL MPL_RECV_PREAMB(IMP_TYPE,ICOMM,ISOURCE,ITAG,KMP_TYPE,KCOMM,KSOURCE,KTAG,KREQUEST)

IBUFFSIZE = 1

IF(IMP_TYPE == JP_BLOCKING_STANDARD) THEN
  CALL MPI_RECV(PREAL4,IBUFFSIZE,INT(MPI_REAL4),ISOURCE,ITAG,ICOMM,IRECV_STATUS,IERROR)
ELSEIF(IMP_TYPE == JP_BLOCKING_BUFFERED) THEN
  CALL MPI_RECV(PREAL4,IBUFFSIZE,INT(MPI_REAL4),ISOURCE,ITAG,ICOMM,IRECV_STATUS,IERROR)
ELSEIF(IMP_TYPE == JP_NON_BLOCKING_STANDARD) THEN
  CALL MPI_IRECV(PREAL4,IBUFFSIZE,INT(MPI_REAL4),ISOURCE,ITAG,ICOMM, &
    & KREQUEST,IERROR)
ELSE
  CALL MPL_MESSAGE(CDMESSAGE='MPL_RECV:ILLEGAL MP_TYPE ',LDABORT=LLABORT)
ENDIF

IF(IMP_TYPE /= JP_NON_BLOCKING_STANDARD) THEN
  CALL MPL_RECV_TAIL(IRECV_STATUS,INT(MPI_REAL4),KFROM,KOUNT,KRECVTAG,KERROR,CDSTRING)
ELSE
  IF(LMPLSTATS) CALL MPL_RECVSTATS(IBUFFSIZE,INT(MPI_REAL4))
ENDIF

END SUBROUTINE MPL_RECV_REAL4_SCALAR

!     ------------------------------------------------------------------

SUBROUTINE MPL_RECV_REAL8_SCALAR(PREAL8,KSOURCE,KTAG,KCOMM,KFROM,KRECVTAG,&
 &KOUNT,KMP_TYPE,KERROR,KREQUEST,CDSTRING)

#ifdef USE_8_BYTE_WORDS
  USE MPI4TO8, ONLY : &
    MPI_RECV => MPI_RECV8,  MPI_IRECV => MPI_IRECV8
#endif

REAL(KIND=JPRD)           :: PREAL8
INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL :: KTAG,KCOMM,KMP_TYPE,KSOURCE
INTEGER(KIND=JPIM),INTENT(OUT),OPTIONAL :: KREQUEST,KERROR,KFROM,KRECVTAG,KOUNT
CHARACTER(LEN=*),INTENT(IN),OPTIONAL :: CDSTRING

INTEGER(KIND=JPIM) :: IBUFFSIZE,IMP_TYPE,ICOMM,IERROR 
INTEGER(KIND=JPIM) :: ISOURCE,ITAG
INTEGER(KIND=JPIM) :: IRECV_STATUS(MPI_STATUS_SIZE)
LOGICAL :: LLABORT=.TRUE.
INTEGER(KIND=JPIM) :: ITID
ITID = OML_MY_THREAD()

CALL MPL_RECV_PREAMB(IMP_TYPE,ICOMM,ISOURCE,ITAG,KMP_TYPE,KCOMM,KSOURCE,KTAG,KREQUEST)

IBUFFSIZE = 1

IF(IMP_TYPE == JP_BLOCKING_STANDARD) THEN
  CALL MPI_RECV(PREAL8,IBUFFSIZE,INT(MPI_REAL8),ISOURCE,ITAG,ICOMM,IRECV_STATUS,IERROR)
ELSEIF(IMP_TYPE == JP_BLOCKING_BUFFERED) THEN
  CALL MPI_RECV(PREAL8,IBUFFSIZE,INT(MPI_REAL8),ISOURCE,ITAG,ICOMM,IRECV_STATUS,IERROR)
ELSEIF(IMP_TYPE == JP_NON_BLOCKING_STANDARD) THEN
  CALL MPI_IRECV(PREAL8,IBUFFSIZE,INT(MPI_REAL8),ISOURCE,ITAG,ICOMM, &
   & KREQUEST,IERROR)
ELSE
  CALL MPL_MESSAGE(CDMESSAGE='MPL_RECV:ILLEGAL MP_TYPE ',LDABORT=LLABORT)
ENDIF

IF(IMP_TYPE /= JP_NON_BLOCKING_STANDARD) THEN
  CALL MPL_RECV_TAIL(IRECV_STATUS,INT(MPI_REAL8),KFROM,KOUNT,KRECVTAG,KERROR,CDSTRING)
ELSE
  IF(LMPLSTATS) CALL MPL_RECVSTATS(IBUFFSIZE,INT(MPI_REAL8))
ENDIF

END SUBROUTINE MPL_RECV_REAL8_SCALAR

!     ------------------------------------------------------------------

SUBROUTINE MPL_RECV_REAL42(PBUF,KSOURCE,KTAG,KCOMM,KFROM,KRECVTAG,&
 &KOUNT,KMP_TYPE,KERROR,KREQUEST,CDSTRING)


#ifdef USE_8_BYTE_WORDS
  USE MPI4TO8, ONLY : &
    MPI_RECV => MPI_RECV8, MPI_IRECV => MPI_IRECV8
#endif


REAL(KIND=JPRM)            :: PBUF(:,:)
INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL :: KTAG,KCOMM,KMP_TYPE,KSOURCE
INTEGER(KIND=JPIM),INTENT(OUT),OPTIONAL :: KREQUEST,KERROR,KFROM,KRECVTAG,KOUNT
CHARACTER(LEN=*),INTENT(IN),OPTIONAL :: CDSTRING

INTEGER(KIND=JPIM) :: IBUFFSIZE,IMP_TYPE,ICOMM,IERROR 
INTEGER(KIND=JPIM) :: ISOURCE,ITAG
INTEGER(KIND=JPIM) :: IRECV_STATUS(MPI_STATUS_SIZE)
LOGICAL :: LLABORT=.TRUE.
INTEGER(KIND=JPIM) :: ITID
REAL(KIND=JPRM)    :: ZDUM(1)
ITID = OML_MY_THREAD()

CALL MPL_RECV_PREAMB(IMP_TYPE,ICOMM,ISOURCE,ITAG,KMP_TYPE,KCOMM,KSOURCE,KTAG,KREQUEST)

IBUFFSIZE = SIZE(PBUF)
#ifndef NAG
IF (IBUFFSIZE > 0) THEN
  IF( (LOC(PBUF(UBOUND(PBUF,1),UBOUND(PBUF,2))) - &
     & LOC(PBUF(LBOUND(PBUF,1),LBOUND(PBUF,2)))) /= 4_JPIB*(IBUFFSIZE - 1) ) THEN
    CALL MPL_MESSAGE(CDMESSAGE='MPL_RECV: BUFFER NOT CONTIGUOUS ',LDABORT=LLABORT)
  ENDIF
ENDIF
#endif

IF(IBUFFSIZE == 0) THEN
  IF(IMP_TYPE == JP_BLOCKING_STANDARD) THEN
    CALL MPI_RECV(ZDUM(1),1,INT(MPI_REAL4),ISOURCE,ITAG,ICOMM,IRECV_STATUS,IERROR)
  ELSEIF(IMP_TYPE == JP_BLOCKING_BUFFERED) THEN
    CALL MPI_RECV(ZDUM(1),1,INT(MPI_REAL4),ISOURCE,ITAG,ICOMM,IRECV_STATUS,IERROR)
  ELSEIF(IMP_TYPE == JP_NON_BLOCKING_STANDARD) THEN
    CALL MPI_IRECV(ZDUM(1),1,INT(MPI_REAL4),ISOURCE,ITAG,ICOMM, &
     & KREQUEST,IERROR)
  ELSE
    CALL MPL_MESSAGE(CDMESSAGE='MPL_RECV:ILLEGAL MP_TYPE ',LDABORT=LLABORT)
  ENDIF
ELSE
  IF(IMP_TYPE == JP_BLOCKING_STANDARD) THEN
    CALL MPI_RECV(PBUF(1,1),IBUFFSIZE,INT(MPI_REAL4),ISOURCE,ITAG,ICOMM,IRECV_STATUS,IERROR)
  ELSEIF(IMP_TYPE == JP_BLOCKING_BUFFERED) THEN
    CALL MPI_RECV(PBUF(1,1),IBUFFSIZE,INT(MPI_REAL4),ISOURCE,ITAG,ICOMM,IRECV_STATUS,IERROR)
  ELSEIF(IMP_TYPE == JP_NON_BLOCKING_STANDARD) THEN
    CALL MPI_IRECV(PBUF(1,1),IBUFFSIZE,INT(MPI_REAL4),ISOURCE,ITAG,ICOMM, &
     & KREQUEST,IERROR)
  ELSE
    CALL MPL_MESSAGE(CDMESSAGE='MPL_RECV:ILLEGAL MP_TYPE ',LDABORT=LLABORT)
  ENDIF
ENDIF

IF(IMP_TYPE /= JP_NON_BLOCKING_STANDARD) THEN
  CALL MPL_RECV_TAIL(IRECV_STATUS,INT(MPI_REAL4),KFROM,KOUNT,KRECVTAG,KERROR,CDSTRING)
ELSE
  IF(LMPLSTATS) CALL MPL_RECVSTATS(IBUFFSIZE,INT(MPI_REAL4))
ENDIF

END SUBROUTINE MPL_RECV_REAL42  

SUBROUTINE MPL_RECV_REAL43(PBUF,KSOURCE,KTAG,KCOMM,KFROM,KRECVTAG,&
 &KOUNT,KMP_TYPE,KERROR,KREQUEST,CDSTRING)

#ifdef USE_8_BYTE_WORDS
  USE MPI4TO8, ONLY : &
    MPI_RECV => MPI_RECV8,  MPI_IRECV => MPI_IRECV8
#endif

REAL(KIND=JPRM)            :: PBUF(:,:,:)
INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL :: KTAG,KCOMM,KMP_TYPE,KSOURCE
INTEGER(KIND=JPIM),INTENT(OUT),OPTIONAL :: KREQUEST,KERROR,KFROM,KRECVTAG,KOUNT
CHARACTER(LEN=*),INTENT(IN),OPTIONAL :: CDSTRING

INTEGER(KIND=JPIM) :: IBUFFSIZE,IMP_TYPE,ICOMM,IERROR 
INTEGER(KIND=JPIM) :: ISOURCE,ITAG
INTEGER(KIND=JPIM) :: IRECV_STATUS(MPI_STATUS_SIZE)
LOGICAL :: LLABORT=.TRUE.
INTEGER(KIND=JPIM) :: ITID
ITID = OML_MY_THREAD()

CALL MPL_RECV_PREAMB(IMP_TYPE,ICOMM,ISOURCE,ITAG,KMP_TYPE,KCOMM,KSOURCE,KTAG,KREQUEST)

IBUFFSIZE = SIZE(PBUF)

#ifndef NAG
IF (IBUFFSIZE > 0) THEN
  IF( (LOC(PBUF(UBOUND(PBUF,1),UBOUND(PBUF,2),UBOUND(PBUF,3))) - &
     & LOC(PBUF(LBOUND(PBUF,1),LBOUND(PBUF,2),LBOUND(PBUF,3)))) /= 4_JPIB*(IBUFFSIZE - 1) ) THEN
    CALL MPL_MESSAGE(CDMESSAGE='MPL_RECV: BUFFER NOT CONTIGUOUS ',LDABORT=LLABORT)
  ENDIF
ENDIF
#endif

IF(IMP_TYPE == JP_BLOCKING_STANDARD) THEN
  CALL MPI_RECV(PBUF,IBUFFSIZE,INT(MPI_REAL4),ISOURCE,ITAG,ICOMM,IRECV_STATUS,IERROR)
ELSEIF(IMP_TYPE == JP_BLOCKING_BUFFERED) THEN
  CALL MPI_RECV(PBUF,IBUFFSIZE,INT(MPI_REAL4),ISOURCE,ITAG,ICOMM,IRECV_STATUS,IERROR)
ELSEIF(IMP_TYPE == JP_NON_BLOCKING_STANDARD) THEN
  CALL MPI_IRECV(PBUF,IBUFFSIZE,INT(MPI_REAL4),ISOURCE,ITAG,ICOMM, &
    & KREQUEST,IERROR)
ELSE
  CALL MPL_MESSAGE(CDMESSAGE='MPL_RECV:ILLEGAL MP_TYPE ',LDABORT=LLABORT)
ENDIF

IF(IMP_TYPE /= JP_NON_BLOCKING_STANDARD) THEN
  CALL MPL_RECV_TAIL(IRECV_STATUS,INT(MPI_REAL4),KFROM,KOUNT,KRECVTAG,KERROR,CDSTRING)
ELSE
  IF(LMPLSTATS) CALL MPL_RECVSTATS(IBUFFSIZE,INT(MPI_REAL4))
ENDIF

END SUBROUTINE MPL_RECV_REAL43


!     ------------------------------------------------------------------

SUBROUTINE MPL_RECV_REAL82(PBUF,KSOURCE,KTAG,KCOMM,KFROM,KRECVTAG,&
 &KOUNT,KMP_TYPE,KERROR,KREQUEST,CDSTRING)

#ifdef USE_8_BYTE_WORDS
  USE MPI4TO8, ONLY : &
    MPI_RECV => MPI_RECV8,  MPI_IRECV => MPI_IRECV8
#endif

REAL(KIND=JPRD)            :: PBUF(:,:)
INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL :: KTAG,KCOMM,KMP_TYPE,KSOURCE
INTEGER(KIND=JPIM),INTENT(OUT),OPTIONAL :: KREQUEST,KERROR,KFROM,KRECVTAG,KOUNT
CHARACTER(LEN=*),INTENT(IN),OPTIONAL :: CDSTRING

INTEGER(KIND=JPIM) :: IBUFFSIZE,IMP_TYPE,ICOMM,IERROR 
INTEGER(KIND=JPIM) :: ISOURCE,ITAG
INTEGER(KIND=JPIM) :: IRECV_STATUS(MPI_STATUS_SIZE)
LOGICAL :: LLABORT=.TRUE.
INTEGER(KIND=JPIM) :: ITID
REAL(KIND=JPRD)    :: ZDUM(1)
ITID = OML_MY_THREAD()

CALL MPL_RECV_PREAMB(IMP_TYPE,ICOMM,ISOURCE,ITAG,KMP_TYPE,KCOMM,KSOURCE,KTAG,KREQUEST)

IBUFFSIZE = SIZE(PBUF)
#ifndef NAG
IF (IBUFFSIZE > 0) THEN
  IF( (LOC(PBUF(UBOUND(PBUF,1),UBOUND(PBUF,2))) - &
     & LOC(PBUF(LBOUND(PBUF,1),LBOUND(PBUF,2)))) /= 8_JPIB*(IBUFFSIZE - 1) ) THEN
    CALL MPL_MESSAGE(CDMESSAGE='MPL_RECV: BUFFER NOT CONTIGUOUS ',LDABORT=LLABORT)
  ENDIF
ENDIF
#endif

IF(IBUFFSIZE == 0) THEN
  IF(IMP_TYPE == JP_BLOCKING_STANDARD) THEN
    CALL MPI_RECV(ZDUM(1),1,INT(MPI_REAL8),ISOURCE,ITAG,ICOMM,IRECV_STATUS,IERROR)
  ELSEIF(IMP_TYPE == JP_BLOCKING_BUFFERED) THEN
    CALL MPI_RECV(ZDUM(1),1,INT(MPI_REAL8),ISOURCE,ITAG,ICOMM,IRECV_STATUS,IERROR)
  ELSEIF(IMP_TYPE == JP_NON_BLOCKING_STANDARD) THEN
    CALL MPI_IRECV(ZDUM(1),1,INT(MPI_REAL8),ISOURCE,ITAG,ICOMM, &
     & KREQUEST,IERROR)
  ELSE
    CALL MPL_MESSAGE(CDMESSAGE='MPL_RECV:ILLEGAL MP_TYPE ',LDABORT=LLABORT)
  ENDIF
ELSE
  IF(IMP_TYPE == JP_BLOCKING_STANDARD) THEN
    CALL MPI_RECV(PBUF(1,1),IBUFFSIZE,INT(MPI_REAL8),ISOURCE,ITAG,ICOMM,IRECV_STATUS,IERROR)
  ELSEIF(IMP_TYPE == JP_BLOCKING_BUFFERED) THEN
    CALL MPI_RECV(PBUF(1,1),IBUFFSIZE,INT(MPI_REAL8),ISOURCE,ITAG,ICOMM,IRECV_STATUS,IERROR)
  ELSEIF(IMP_TYPE == JP_NON_BLOCKING_STANDARD) THEN
    CALL MPI_IRECV(PBUF(1,1),IBUFFSIZE,INT(MPI_REAL8),ISOURCE,ITAG,ICOMM, &
     & KREQUEST,IERROR)
  ELSE
    CALL MPL_MESSAGE(CDMESSAGE='MPL_RECV:ILLEGAL MP_TYPE ',LDABORT=LLABORT)
  ENDIF
ENDIF

IF(IMP_TYPE /= JP_NON_BLOCKING_STANDARD) THEN
  CALL MPL_RECV_TAIL(IRECV_STATUS,INT(MPI_REAL8),KFROM,KOUNT,KRECVTAG,KERROR,CDSTRING)
ELSE
  IF(LMPLSTATS) CALL MPL_RECVSTATS(IBUFFSIZE,INT(MPI_REAL8))
ENDIF

END SUBROUTINE MPL_RECV_REAL82

SUBROUTINE MPL_RECV_REAL83(PBUF,KSOURCE,KTAG,KCOMM,KFROM,KRECVTAG,&
 &KOUNT,KMP_TYPE,KERROR,KREQUEST,CDSTRING)

#ifdef USE_8_BYTE_WORDS
  USE MPI4TO8, ONLY : &
    MPI_RECV => MPI_RECV8,  MPI_IRECV => MPI_IRECV8
#endif

REAL(KIND=JPRD)            :: PBUF(:,:,:)
INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL :: KTAG,KCOMM,KMP_TYPE,KSOURCE
INTEGER(KIND=JPIM),INTENT(OUT),OPTIONAL :: KREQUEST,KERROR,KFROM,KRECVTAG,KOUNT
CHARACTER(LEN=*),INTENT(IN),OPTIONAL :: CDSTRING

INTEGER(KIND=JPIM) :: IBUFFSIZE,IMP_TYPE,ICOMM,IERROR 
INTEGER(KIND=JPIM) :: ISOURCE,ITAG
INTEGER(KIND=JPIM) :: IRECV_STATUS(MPI_STATUS_SIZE)
LOGICAL :: LLABORT=.TRUE.
INTEGER(KIND=JPIM) :: ITID
ITID = OML_MY_THREAD()

CALL MPL_RECV_PREAMB(IMP_TYPE,ICOMM,ISOURCE,ITAG,KMP_TYPE,KCOMM,KSOURCE,KTAG,KREQUEST)

IBUFFSIZE = SIZE(PBUF)

#ifndef NAG
IF (IBUFFSIZE > 0) THEN
  IF( (LOC(PBUF(UBOUND(PBUF,1),UBOUND(PBUF,2),UBOUND(PBUF,3))) - &
     & LOC(PBUF(LBOUND(PBUF,1),LBOUND(PBUF,2),LBOUND(PBUF,3)))) /= 8_JPIB*(IBUFFSIZE - 1) ) THEN
    CALL MPL_MESSAGE(CDMESSAGE='MPL_RECV: BUFFER NOT CONTIGUOUS ',LDABORT=LLABORT)
  ENDIF
ENDIF
#endif

IF(IMP_TYPE == JP_BLOCKING_STANDARD) THEN
  CALL MPI_RECV(PBUF,IBUFFSIZE,INT(MPI_REAL8),ISOURCE,ITAG,ICOMM,IRECV_STATUS,IERROR)
ELSEIF(IMP_TYPE == JP_BLOCKING_BUFFERED) THEN
  CALL MPI_RECV(PBUF,IBUFFSIZE,INT(MPI_REAL8),ISOURCE,ITAG,ICOMM,IRECV_STATUS,IERROR)
ELSEIF(IMP_TYPE == JP_NON_BLOCKING_STANDARD) THEN
  CALL MPI_IRECV(PBUF,IBUFFSIZE,INT(MPI_REAL8),ISOURCE,ITAG,ICOMM, &
    & KREQUEST,IERROR)
ELSE
  CALL MPL_MESSAGE(CDMESSAGE='MPL_RECV:ILLEGAL MP_TYPE ',LDABORT=LLABORT)
ENDIF

IF(IMP_TYPE /= JP_NON_BLOCKING_STANDARD) THEN
  CALL MPL_RECV_TAIL(IRECV_STATUS,INT(MPI_REAL8),KFROM,KOUNT,KRECVTAG,KERROR,CDSTRING)
ELSE
  IF(LMPLSTATS) CALL MPL_RECVSTATS(IBUFFSIZE,INT(MPI_REAL8))
ENDIF

END SUBROUTINE MPL_RECV_REAL83

!     ------------------------------------------------------------------

SUBROUTINE MPL_RECV_CHAR_SCALAR(CDCHAR,KSOURCE,KTAG,KCOMM,KFROM,KRECVTAG,&
 &KOUNT,KMP_TYPE,KERROR,KREQUEST,CDSTRING)

#ifdef USE_8_BYTE_WORDS
  USE MPI4TO8, ONLY : &
    MPI_RECV => MPI_RECV8,  MPI_IRECV => MPI_IRECV8
#endif

CHARACTER(LEN=*) :: CDCHAR
INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL :: KTAG,KCOMM,KMP_TYPE,KSOURCE
INTEGER(KIND=JPIM),INTENT(OUT),OPTIONAL :: KREQUEST,KERROR,KFROM,KRECVTAG,KOUNT
CHARACTER(LEN=*),INTENT(IN),OPTIONAL :: CDSTRING

INTEGER(KIND=JPIM) :: IBUFFSIZE,IMP_TYPE,ICOMM,IERROR 
INTEGER(KIND=JPIM) :: ISOURCE,ITAG
INTEGER(KIND=JPIM) :: IRECV_STATUS(MPI_STATUS_SIZE)
LOGICAL :: LLABORT=.TRUE.
INTEGER(KIND=JPIM) :: ITID
ITID = OML_MY_THREAD()

CALL MPL_RECV_PREAMB(IMP_TYPE,ICOMM,ISOURCE,ITAG,KMP_TYPE,KCOMM,KSOURCE,KTAG,KREQUEST)

IBUFFSIZE = LEN(CDCHAR)

IF(IMP_TYPE == JP_BLOCKING_STANDARD) THEN
  CALL MPI_RECV(CDCHAR,IBUFFSIZE,INT(MPI_BYTE),ISOURCE,ITAG,ICOMM,IRECV_STATUS,IERROR)
ELSEIF(IMP_TYPE == JP_BLOCKING_BUFFERED) THEN
  CALL MPI_RECV(CDCHAR,IBUFFSIZE,INT(MPI_BYTE),ISOURCE,ITAG,ICOMM,IRECV_STATUS,IERROR)
ELSEIF(IMP_TYPE == JP_NON_BLOCKING_STANDARD) THEN
  CALL MPI_IRECV(CDCHAR,IBUFFSIZE,INT(MPI_BYTE),ISOURCE,ITAG,ICOMM, &
    & KREQUEST,IERROR)
ELSE
  CALL MPL_MESSAGE(CDMESSAGE='MPL_RECV:ILLEGAL MP_TYPE ',LDABORT=LLABORT)
ENDIF

IF(IMP_TYPE /= JP_NON_BLOCKING_STANDARD) THEN
  CALL MPL_RECV_TAIL(IRECV_STATUS,INT(MPI_BYTE),KFROM,KOUNT,KRECVTAG,KERROR,CDSTRING)
ELSE
  IF(LMPLSTATS) CALL MPL_RECVSTATS(IBUFFSIZE,INT(MPI_BYTE))
ENDIF

END SUBROUTINE MPL_RECV_CHAR_SCALAR

SUBROUTINE MPL_RECV_CHAR(CDCHAR,KSOURCE,KTAG,KCOMM,KFROM,KRECVTAG,&
 &KOUNT,KMP_TYPE,KERROR,KREQUEST,CDSTRING)

#ifdef USE_8_BYTE_WORDS
  USE MPI4TO8, ONLY : &
    MPI_RECV => MPI_RECV8,  MPI_IRECV => MPI_IRECV8
#endif

CHARACTER(LEN=*) :: CDCHAR(:)
INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL :: KTAG,KCOMM,KMP_TYPE,KSOURCE
INTEGER(KIND=JPIM),INTENT(OUT),OPTIONAL :: KREQUEST,KERROR,KFROM,KRECVTAG,KOUNT
CHARACTER(LEN=*),INTENT(IN),OPTIONAL :: CDSTRING

INTEGER(KIND=JPIM) :: IBUFFSIZE,IMP_TYPE,ICOMM,IERROR 
INTEGER(KIND=JPIM) :: ISOURCE,ITAG
INTEGER(KIND=JPIM) :: IRECV_STATUS(MPI_STATUS_SIZE)
LOGICAL :: LLABORT=.TRUE.
INTEGER(KIND=JPIM) :: ITID
ITID = OML_MY_THREAD()

CALL MPL_RECV_PREAMB(IMP_TYPE,ICOMM,ISOURCE,ITAG,KMP_TYPE,KCOMM,KSOURCE,KTAG,KREQUEST)

IBUFFSIZE = LEN(CDCHAR) * SIZE(CDCHAR)

IF(IMP_TYPE == JP_BLOCKING_STANDARD) THEN
  CALL MPI_RECV(CDCHAR,IBUFFSIZE,INT(MPI_BYTE),ISOURCE,ITAG,ICOMM,IRECV_STATUS,IERROR)
ELSEIF(IMP_TYPE == JP_BLOCKING_BUFFERED) THEN
  CALL MPI_RECV(CDCHAR,IBUFFSIZE,INT(MPI_BYTE),ISOURCE,ITAG,ICOMM,IRECV_STATUS,IERROR)
ELSEIF(IMP_TYPE == JP_NON_BLOCKING_STANDARD) THEN
  CALL MPI_IRECV(CDCHAR,IBUFFSIZE,INT(MPI_BYTE),ISOURCE,ITAG,ICOMM, &
    & KREQUEST,IERROR)
ELSE
  CALL MPL_MESSAGE(CDMESSAGE='MPL_RECV:ILLEGAL MP_TYPE ',LDABORT=LLABORT)
ENDIF

IF(IMP_TYPE /= JP_NON_BLOCKING_STANDARD) THEN
  CALL MPL_RECV_TAIL(IRECV_STATUS,INT(MPI_BYTE),KFROM,KOUNT,KRECVTAG,KERROR,CDSTRING)
ELSE
  IF(LMPLSTATS) CALL MPL_RECVSTATS(IBUFFSIZE,INT(MPI_BYTE))
ENDIF

END SUBROUTINE MPL_RECV_CHAR

!     ------------------------------------------------------------------

END MODULE MPL_RECV_MOD

! (C) Copyright 2005- ECMWF.
! (C) Copyright 2013- Meteo-France.
! 
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!

MODULE YOMHOOK

USE EC_PARKIND  ,ONLY : JPIM, JPRM, JPRD

IMPLICIT NONE

! Used by "hook" function
! LHOOK = true implies "hook" function will be called
! Altough initialized to TRUE it will be reset by first call to 
! DR_HOOK unless we really want to use the hook function

SAVE

PRIVATE :: JPIM, JPRM, JPRD

PUBLIC

INTEGER, PARAMETER :: JPHOOK = SELECTED_REAL_KIND(13,300)
LOGICAL :: LHOOK=.TRUE.

#include "dr_hook_util.h"
#include "dr_hook_util_multi.h"
#include "dr_hook_init.intfb.h"
#include "dr_hook_end.intfb.h"

INTERFACE DR_HOOK  
! We want compile time mapping of DR_HOOK-arguments and not
! to test OPTIONAL-arguments with PRESENT()-function, since
! it costs more.
! However, this "unrolling" approach cannot be streched much more
! than this without making number of member-functions too large
! (i.e. all the possible permutations of these "optional" args;
!  arguments that are not present in the DR_HOOK_DEFAULT -version)

MODULE PROCEDURE &
#ifdef DR_HOOK_MULTI_PRECISION_HANDLES
  DR_HOOK_DEFAULT4, &
#endif
  DR_HOOK_DEFAULT8, &
  DR_HOOK_FILE, &
  DR_HOOK_SIZE, &
  DR_HOOK_FILE_SIZE, &
  DR_HOOK_MULTI_DEFAULT, &
  DR_HOOK_MULTI_FILE, &
  DR_HOOK_MULTI_SIZE, &
  DR_HOOK_MULTI_FILE_SIZE
END INTERFACE

CONTAINS 

SUBROUTINE DR_HOOK_DEFAULT4(CDNAME,KSWITCH,PKEY)
  !! This overload only works when DR_HOOK_MULTI_PRECISION_HANDLES is defined
  !! This also assumes that DR_HOOK_NCALLSTACK > 0  (e.g. DR_HOOK_NCALLSTACK=64)
CHARACTER(LEN=*), INTENT(IN) :: CDNAME
INTEGER(KIND=JPIM),        INTENT(IN) :: KSWITCH
REAL(KIND=JPRM),        INTENT(INOUT) :: PKEY
REAL(KIND=JPRD) :: ZKEY
ZKEY = TRANSFER(PKEY,ZKEY)
CALL DR_HOOK_UTIL(LHOOK,CDNAME,KSWITCH,ZKEY,'',0_JPIM)
PKEY = TRANSFER(ZKEY,PKEY)
END SUBROUTINE DR_HOOK_DEFAULT4

SUBROUTINE DR_HOOK_DEFAULT8(CDNAME,KSWITCH,PKEY)
CHARACTER(LEN=*), INTENT(IN) :: CDNAME
INTEGER(KIND=JPIM),        INTENT(IN) :: KSWITCH
REAL(KIND=JPRD),        INTENT(INOUT) :: PKEY
!REAL(KIND=JPRD) :: ZKEY
!ZKEY = TRANSFER(PKEY,ZKEY)
CALL DR_HOOK_UTIL(LHOOK,CDNAME,KSWITCH,PKEY,'',0_JPIM)
!PKEY = TRANSFER(ZKEY,PKEY)
END SUBROUTINE DR_HOOK_DEFAULT8



SUBROUTINE DR_HOOK_MULTI_DEFAULT(CDNAME,KSWITCH,PKEY)
CHARACTER(LEN=*), INTENT(IN) :: CDNAME
INTEGER(KIND=JPIM),        INTENT(IN) :: KSWITCH
REAL(KIND=JPRD),        INTENT(INOUT) :: PKEY(:)
CALL DR_HOOK_UTIL_MULTI(LHOOK,CDNAME,KSWITCH,PKEY,INT(SIZE(PKEY)),'',0_JPIM)
END SUBROUTINE DR_HOOK_MULTI_DEFAULT



SUBROUTINE DR_HOOK_FILE(CDNAME,KSWITCH,PKEY,CDFILE)
CHARACTER(LEN=*), INTENT(IN) :: CDNAME,CDFILE
INTEGER(KIND=JPIM),        INTENT(IN) :: KSWITCH
REAL(KIND=JPRD),        INTENT(INOUT) :: PKEY
CALL DR_HOOK_UTIL(LHOOK,CDNAME,KSWITCH,PKEY,CDFILE,0_JPIM)
END SUBROUTINE DR_HOOK_FILE

SUBROUTINE DR_HOOK_MULTI_FILE(CDNAME,KSWITCH,PKEY,CDFILE)
CHARACTER(LEN=*), INTENT(IN) :: CDNAME,CDFILE
INTEGER(KIND=JPIM),        INTENT(IN) :: KSWITCH
REAL(KIND=JPRD),        INTENT(INOUT) :: PKEY(:)
CALL DR_HOOK_UTIL_MULTI(LHOOK,CDNAME,KSWITCH,PKEY,INT(SIZE(PKEY)),CDFILE,0_JPIM)
END SUBROUTINE DR_HOOK_MULTI_FILE



SUBROUTINE DR_HOOK_SIZE(CDNAME,KSWITCH,PKEY,KSIZEINFO)
CHARACTER(LEN=*), INTENT(IN) :: CDNAME
INTEGER(KIND=JPIM),        INTENT(IN) :: KSWITCH,KSIZEINFO
REAL(KIND=JPRD),        INTENT(INOUT) :: PKEY
CALL DR_HOOK_UTIL(LHOOK,CDNAME,KSWITCH,PKEY,'',KSIZEINFO)
END SUBROUTINE DR_HOOK_SIZE

SUBROUTINE DR_HOOK_MULTI_SIZE(CDNAME,KSWITCH,PKEY,KSIZEINFO)
CHARACTER(LEN=*), INTENT(IN) :: CDNAME
INTEGER(KIND=JPIM),        INTENT(IN) :: KSWITCH,KSIZEINFO
REAL(KIND=JPRD),        INTENT(INOUT) :: PKEY(:)
CALL DR_HOOK_UTIL_MULTI(LHOOK,CDNAME,KSWITCH,PKEY,INT(SIZE(PKEY)),'',KSIZEINFO)
END SUBROUTINE DR_HOOK_MULTI_SIZE



SUBROUTINE DR_HOOK_FILE_SIZE(CDNAME,KSWITCH,PKEY,CDFILE,KSIZEINFO)
CHARACTER(LEN=*), INTENT(IN) :: CDNAME,CDFILE
INTEGER(KIND=JPIM),        INTENT(IN) :: KSWITCH,KSIZEINFO
REAL(KIND=JPRD),        INTENT(INOUT) :: PKEY
CALL DR_HOOK_UTIL(LHOOK,CDNAME,KSWITCH,PKEY,CDFILE,KSIZEINFO)
END SUBROUTINE DR_HOOK_FILE_SIZE

SUBROUTINE DR_HOOK_MULTI_FILE_SIZE(CDNAME,KSWITCH,PKEY,CDFILE,KSIZEINFO)
CHARACTER(LEN=*), INTENT(IN) :: CDNAME,CDFILE
INTEGER(KIND=JPIM),        INTENT(IN) :: KSWITCH,KSIZEINFO
REAL(KIND=JPRD),        INTENT(INOUT) :: PKEY(:)
CALL DR_HOOK_UTIL_MULTI(LHOOK,CDNAME,KSWITCH,PKEY,INT(SIZE(PKEY)),CDFILE,KSIZEINFO)
END SUBROUTINE DR_HOOK_MULTI_FILE_SIZE

SUBROUTINE DR_HOOK_CALLTREE(KTID)
USE OML_MOD   ,ONLY : OML_MY_THREAD
INTEGER(KIND=JPIM), INTENT(IN), OPTIONAL :: KTID
INTEGER(KIND=JPIM) :: IPRINT_OPTION ! may not be parameter
INTEGER(KIND=JPIM) :: ILEVEL        ! may not be parameter
INTEGER(KIND=JPIM) :: ITID
IF (LHOOK) THEN
  IF (PRESENT(KTID)) THEN
    ITID = KTID
  ELSE
    ITID = OML_MY_THREAD()
  ENDIF  
  IPRINT_OPTION = 2
  ILEVEL = 99
  CALL C_DRHOOK_PRINT(0, ITID, IPRINT_OPTION, ILEVEL) ! from drhook.c
ENDIF
END SUBROUTINE

END MODULE YOMHOOK

! (C) Copyright 2005- ECMWF.
! 
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!

module ec_args_mod

!**** Interface to ec_args command-line handling
!
!     Purpose.
!     --------
!     Fortran 90 Interface to storing and retrieving command line arguments
!     for the C ec_args API.
!  
!     An example C program:
!
!         #include "ec_args.h"  
!         int main( int argc, char* argv[] ) {
!             ec_args(argc,argv);
!             int num_args     = ec_argc();
!             const char* name = ec_argv()[0];
!         }
!
!     An example Fortran program to do the same:
!     
!         program main
!             use ec_args_mod
!             integer :: num_args
!             character(len=:), allocatable :: name
!             call ec_args()
!             num_args = ec_argc()
!             name     = ec_argv(0)
!         end program  
!
!     Author.
!     -------
!        W.Deconinck, ECMWF
!
!     Modifications.
!     --------------
!        Original: 2021-05-18
!
!     ------------------------------------------------------------------
implicit none

private
public :: ec_argc, ec_argv, ec_args

#define MAX_ARG_LEN 1024
#define EC_MAX_ARGS 512
 !! Matches value in ec_args.c

interface
    function ec_argc() bind(C,name="ec_argc") result(argc)
      use, intrinsic :: iso_c_binding, only : c_int
      integer(c_int) :: argc
    end function
    function ec_argv_bindc() bind(C,name="ec_argv") result(argv)
      use, intrinsic :: iso_c_binding, only : c_ptr
      type(c_ptr) :: argv
    end function
    subroutine ec_args_bindc(argc,argv) BIND(C,NAME="ec_args")
      use, intrinsic :: iso_c_binding, only : c_int, c_ptr
      integer(c_int), value :: argc
      type(c_ptr), dimension(*) :: argv
    end subroutine
end interface

contains

function ec_argv(iarg) result(argv)
    use, intrinsic :: iso_c_binding
    implicit none
    character(len=:), allocatable :: argv
    integer(c_int), intent(in) :: iarg
    integer(c_int) :: argc
    type(c_ptr) :: argv_cptr
    type(c_ptr), pointer :: argv_cptrs(:)
    argc = ec_argc()
    argv_cptr = ec_argv_bindc()
    call c_f_pointer ( argv_cptr , argv_cptrs, (/argc/) )
    argv = to_string( argv_cptrs(iarg+1), MAX_ARG_LEN )
end function

subroutine ec_args()
  use, intrinsic :: iso_c_binding
  implicit none
  integer(c_int) :: argc
  type(c_ptr) :: argv(EC_MAX_ARGS)
  if( ec_argc() == 0 ) then
    call read_command_line(argc,argv)
    call ec_args_bindc(argc,argv)
  endif
end subroutine

function to_string(cptr,maxlen) result(string)
  ! Convert string from C (char*) to Fortran
  ! (copied from fckit)
  use, intrinsic :: iso_c_binding
  implicit none
  character(len=:), allocatable :: string
  type(c_ptr) :: cptr
  integer(c_int) :: maxlen
  character(kind=c_char,len=1), pointer :: s(:)
  integer i, nchars
  call c_f_pointer ( cptr , s, (/maxlen/) )
  i = 1
  do
      if (s(i) == c_null_char) exit
      i = i + 1
  enddo
  nchars = i - 1  ! Exclude null character from Fortran string
  allocate( character(len=(nchars)) :: string )
  do i=1,nchars
      string(i:i) = s(i)
  enddo
end function


subroutine read_command_line(argc,argv)
  ! Read command line arguments into argc and argv as in C
  ! (copied from fckit)
  use, intrinsic :: iso_c_binding
  implicit none
  integer(c_int), parameter :: CMD_MAX_LEN = MAX_ARG_LEN * EC_MAX_ARGS
  integer(c_int) :: argc
  type(c_ptr) :: argv(:)
  character(kind=c_char,len=1), save, target :: args(CMD_MAX_LEN)
  character(kind=c_char,len=CMD_MAX_LEN), save, target :: cmd
  character(kind=c_char,len=CMD_MAX_LEN) :: arg
  integer(c_int) :: iarg, arglen, pos, ich, argpos
  call get_command(cmd)
  do ich=1,len(cmd)
    if (cmd(ich:ich) == " ") then
      cmd(ich:ich) = c_null_char
      exit
    endif
  enddo
  argv(1) = c_loc(cmd(1:1))
  argc = command_argument_count()+1
  pos = 1
  do iarg=1,argc
    argpos = pos
    call get_command_argument(iarg, arg )
    arglen = len_trim(arg)
    do ich=1,arglen
      args(pos) = arg(ich:ich)
      pos = pos+1
    end do
    args(pos) = c_null_char;  pos = pos+1
    args(pos) = " ";          pos = pos+1
    argv(iarg+1) = c_loc(args(argpos))
  enddo
end subroutine

end module

! (C) Copyright 2024- ECMWF.
!
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
!
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.

program drhook_papi_mpi
  use mpl_module
  use yomhook, only : jphook, dr_hook
  use sdl_mod, only : sdl_traceback
  implicit none
  integer jpe, npes, mype, a
  character(len=256) arg, env
  real(jphook) :: zhook_handle

  call mpl_init(ldinfo=.false.)
  call dr_hook('drhook_papi_mpi',0,zhook_handle)

  npes = mpl_nproc()
  mype = mpl_myrank()

  do jpe=1,npes
    if (mype == jpe) then
      a = a + jpe
    endif
  enddo

  call mpl_barrier()
  call dr_hook('drhook_papi_mpi',1,zhook_handle)
  call mpl_end()
end program drhook_papi_mpi

! (C) Copyright 2005- ECMWF.
! 
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!

program drhook_ex3
use yomhook, only : jphook, dr_hook
implicit none
integer(4) :: n
real(8), allocatable  :: a(:)
integer(4) :: j
real(jphook) :: zhook_handle
call dr_hook('drhook_ex3',0,zhook_handle)
n = 100
allocate(a(n))
do j=1,n
  a(j) = j-1
enddo
write(0,*)'drhook_ex3: sum#1 = ',sum(a)
deallocate(a)

n = 5 * n
allocate(a(n))
do j=1,n
  a(j) = j + n
enddo
do j=1,n
 call sub1(a,j)
enddo
write(0,*)'drhook_ex3: sum#2 = ',sum(a)
deallocate(a)

n = n/10
allocate(a(-n:n))
do j=-n,n
  a(j) = j + 2*n
enddo
do j=1,n
 call sub1(a,j)
enddo
write(0,*)'drhook_ex3: sum#3 = ',sum(a)
deallocate(a)
call dr_hook('drhook_ex3',1,zhook_handle)
end program drhook_ex3

subroutine sub1(a,n)
use yomhook, only : jphook, dr_hook
implicit none
integer(4), intent(in) :: n
real(8), intent(inout) :: a(n)
integer(4) j
real(jphook) :: zhook_handle
call dr_hook('sub1',0,zhook_handle)
do j=1,n
  if (mod(j,2) == 0) call sub2(a(j))
  a(j) = 2*a(j) + 1
enddo
call dr_hook('sub1',1,zhook_handle)
end subroutine sub1

subroutine sub2(s)
use yomhook, only : jphook, dr_hook
implicit none
real(8), intent(inout) :: s
real(jphook) :: zhook_handle
call dr_hook('sub2',0,zhook_handle)
s = 1/(s+1)
call dr_hook('sub2',1,zhook_handle)
end subroutine sub2

! (C) Copyright 2005- ECMWF.
! (C) Copyright 2013- Meteo-France.
! 
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!

MODULE DR_HOOK_WATCH_MOD

USE EC_PARKIND  ,ONLY : JPRD, JPIM, JPIB, JPRM

!-- Watch point creation interface for Dr.Hook
IMPLICIT NONE
SAVE
PRIVATE

INTEGER, PUBLIC, PARAMETER :: KEYNONE =  0
INTEGER, PUBLIC, PARAMETER :: KEYLOG  =  1
INTEGER, PUBLIC, PARAMETER :: KEYCHAR =  2
INTEGER, PUBLIC, PARAMETER :: KEY_I4  =  4
INTEGER, PUBLIC, PARAMETER :: KEY_I8  =  8
INTEGER, PUBLIC, PARAMETER :: KEY_R4  = 16
INTEGER, PUBLIC, PARAMETER :: KEY_R8  = 32

INTERFACE DR_HOOK_WATCH
MODULE PROCEDURE &
  DR_HOOK_WATCH_CHARACTER, &
  DR_HOOK_WATCH_LOGICAL_SCALAR, &
  DR_HOOK_WATCH_LOGICAL_VEC, &
  DR_HOOK_WATCH_I4_SCALAR, &
  DR_HOOK_WATCH_I4_VEC, &
  DR_HOOK_WATCH_I8_SCALAR, &
  DR_HOOK_WATCH_I8_VEC, &
  DR_HOOK_WATCH_R4_SCALAR, &
  DR_HOOK_WATCH_R4_VEC, &
  DR_HOOK_WATCH_R8_SCALAR, &
  DR_HOOK_WATCH_R8_VEC
END INTERFACE 

PUBLIC :: DR_HOOK_WATCH
PUBLIC :: DR_HOOK_CHECK_WATCH

CONTAINS

SUBROUTINE CHECK_ARGS(LLABORT, LLACTIVE, LLPRINT, LLTRBK, &
     &                IABORT, IACTIVE, IPRINT, ITRBK, IPRTKEY, &
     &                LDABORT, LDACTIVE, LDPRINT, LDTRBK)
LOGICAL, INTENT(INOUT) :: LLABORT, LLACTIVE, LLPRINT, LLTRBK
INTEGER(KIND=JPIM), INTENT(OUT) :: IABORT, IACTIVE, IPRINT, ITRBK
INTEGER(KIND=JPIM), INTENT(IN) :: IPRTKEY
LOGICAL, INTENT(IN), OPTIONAL :: LDABORT, LDACTIVE, LDPRINT, LDTRBK
IABORT = 0
LLABORT = .TRUE.
IF (PRESENT(LDABORT)) LLABORT = LDABORT
IF (LLABORT) IABORT = 1

IACTIVE = 0
LLACTIVE = .TRUE.
IF (PRESENT(LDACTIVE)) LLACTIVE = LDACTIVE
IF (LLACTIVE) IACTIVE = 1

IPRINT = KEYNONE
LLPRINT = .TRUE.
IF (PRESENT(LDPRINT)) LLPRINT = LDPRINT
IF (LLPRINT) IPRINT = IPRTKEY

ITRBK = 0
LLTRBK = .FALSE.
IF (PRESENT(LDTRBK)) LLTRBK = LDTRBK
IF (LLTRBK) ITRBK = 1
END SUBROUTINE CHECK_ARGS

SUBROUTINE DR_HOOK_WATCH_CHARACTER(CDNAME, PTR, &
          &                        LDABORT, LDACTIVE, LDPRINT, LDTRBK)
INTEGER(KIND=JPIM), PARAMETER :: JP_BYTES_PER_ELEM = 1
CHARACTER(LEN=*), INTENT(IN) :: CDNAME
CHARACTER(LEN=*), INTENT(IN) :: PTR
LOGICAL, INTENT(IN), OPTIONAL :: LDABORT, LDACTIVE, LDPRINT, LDTRBK
LOGICAL :: LLABORT, LLACTIVE, LLPRINT, LLTRBK
INTEGER(KIND=JPIM) :: IBYTES, IABORT, IACTIVE, IPRINT, ITRBK
IBYTES = LEN(PTR) * JP_BYTES_PER_ELEM
IF (IBYTES <= 0) RETURN
CALL CHECK_ARGS(LLABORT, LLACTIVE, LLPRINT, LLTRBK, &
     &          IABORT, IACTIVE, IPRINT, ITRBK, KEYCHAR, &
     &          LDABORT, LDACTIVE, LDPRINT, LDTRBK)
CALL C_DRHOOK_WATCH(IACTIVE, CDNAME, PTR(1:1), IBYTES, IABORT, IPRINT, LEN(PTR), ITRBK)
END SUBROUTINE DR_HOOK_WATCH_CHARACTER

SUBROUTINE DR_HOOK_WATCH_LOGICAL_SCALAR(CDNAME, PTR, &
          &                             LDABORT, LDACTIVE, LDPRINT, LDTRBK)
INTEGER(KIND=JPIM), PARAMETER :: JP_BYTES_PER_ELEM = 4
CHARACTER(LEN=*), INTENT(IN) :: CDNAME
LOGICAL, INTENT(IN) :: PTR
LOGICAL, INTENT(IN), OPTIONAL :: LDABORT, LDACTIVE, LDPRINT, LDTRBK
LOGICAL :: LLABORT, LLACTIVE, LLPRINT, LLTRBK
INTEGER(KIND=JPIM) :: IBYTES, IABORT, IACTIVE, IPRINT, ITRBK
IBYTES = JP_BYTES_PER_ELEM
CALL CHECK_ARGS(LLABORT, LLACTIVE, LLPRINT, LLTRBK, &
     &          IABORT, IACTIVE, IPRINT, ITRBK, KEYLOG, &
     &          LDABORT, LDACTIVE, LDPRINT, LDTRBK)
CALL C_DRHOOK_WATCH(IACTIVE, CDNAME, PTR, IBYTES, IABORT, IPRINT, 1, ITRBK)
END SUBROUTINE DR_HOOK_WATCH_LOGICAL_SCALAR

SUBROUTINE DR_HOOK_WATCH_LOGICAL_VEC(CDNAME, PTR, &
          &                         LDABORT, LDACTIVE, LDPRINT, LDTRBK)
INTEGER(KIND=JPIM), PARAMETER :: JP_BYTES_PER_ELEM = 4
CHARACTER(LEN=*), INTENT(IN) :: CDNAME
LOGICAL, INTENT(IN) :: PTR(:)
LOGICAL, INTENT(IN), OPTIONAL :: LDABORT, LDACTIVE, LDPRINT, LDTRBK
LOGICAL :: LLABORT, LLACTIVE, LLPRINT, LLTRBK
INTEGER(KIND=JPIM) :: IBYTES, IABORT, IACTIVE, IPRINT, ITRBK
IBYTES = SIZE(PTR) * JP_BYTES_PER_ELEM
IF (IBYTES <= 0) RETURN
CALL C_DRHOOK_WATCH(IACTIVE, CDNAME, PTR(1), IBYTES, IABORT, IPRINT, SIZE(PTR), ITRBK)
END SUBROUTINE DR_HOOK_WATCH_LOGICAL_VEC

SUBROUTINE DR_HOOK_WATCH_I4_SCALAR(CDNAME, PTR, &
          &                        LDABORT, LDACTIVE, LDPRINT, LDTRBK)
INTEGER(KIND=JPIM), PARAMETER :: JP_BYTES_PER_ELEM = 4
CHARACTER(LEN=*), INTENT(IN) :: CDNAME
INTEGER(KIND=JPIM), INTENT(IN) :: PTR
LOGICAL, INTENT(IN), OPTIONAL :: LDABORT, LDACTIVE, LDPRINT, LDTRBK
LOGICAL :: LLABORT, LLACTIVE, LLPRINT, LLTRBK
INTEGER(KIND=JPIM) :: IBYTES, IABORT, IACTIVE, IPRINT, ITRBK
IBYTES = JP_BYTES_PER_ELEM
CALL CHECK_ARGS(LLABORT, LLACTIVE, LLPRINT, LLTRBK, &
     &          IABORT, IACTIVE, IPRINT, ITRBK, KEY_I4, &
     &          LDABORT, LDACTIVE, LDPRINT, LDTRBK)
CALL C_DRHOOK_WATCH(IACTIVE, CDNAME, PTR, IBYTES, IABORT, IPRINT, 1, ITRBK)
END SUBROUTINE DR_HOOK_WATCH_I4_SCALAR

SUBROUTINE DR_HOOK_WATCH_I4_VEC(CDNAME, PTR, &
          &                    LDABORT, LDACTIVE, LDPRINT, LDTRBK)
INTEGER(KIND=JPIM), PARAMETER :: JP_BYTES_PER_ELEM = 4
CHARACTER(LEN=*), INTENT(IN) :: CDNAME
INTEGER(KIND=JPIM), INTENT(IN) :: PTR(:)
LOGICAL, INTENT(IN), OPTIONAL :: LDABORT, LDACTIVE, LDPRINT, LDTRBK
LOGICAL :: LLABORT, LLACTIVE, LLPRINT, LLTRBK
INTEGER(KIND=JPIM) :: IBYTES, IABORT, IACTIVE, IPRINT, ITRBK
IBYTES = SIZE(PTR) * JP_BYTES_PER_ELEM
IF (IBYTES <= 0) RETURN
CALL CHECK_ARGS(LLABORT, LLACTIVE, LLPRINT, LLTRBK, &
     &          IABORT, IACTIVE, IPRINT, ITRBK, KEY_I4, &
     &          LDABORT, LDACTIVE, LDPRINT, LDTRBK)
CALL C_DRHOOK_WATCH(IACTIVE, CDNAME, PTR(1), IBYTES, IABORT, IPRINT, SIZE(PTR), ITRBK)
END SUBROUTINE DR_HOOK_WATCH_I4_VEC

SUBROUTINE DR_HOOK_WATCH_I8_SCALAR(CDNAME, PTR, &
          &                        LDABORT, LDACTIVE, LDPRINT, LDTRBK)
INTEGER(KIND=JPIM), PARAMETER :: JP_BYTES_PER_ELEM = 8
CHARACTER(LEN=*), INTENT(IN) :: CDNAME
INTEGER(KIND=JPIB), INTENT(IN) :: PTR
LOGICAL, INTENT(IN), OPTIONAL :: LDABORT, LDACTIVE, LDPRINT, LDTRBK
LOGICAL :: LLABORT, LLACTIVE, LLPRINT, LLTRBK
INTEGER(KIND=JPIM) :: IBYTES, IABORT, IACTIVE, IPRINT, ITRBK
IBYTES = JP_BYTES_PER_ELEM
CALL CHECK_ARGS(LLABORT, LLACTIVE, LLPRINT, LLTRBK, &
     &          IABORT, IACTIVE, IPRINT, ITRBK, KEY_I8, &
     &          LDABORT, LDACTIVE, LDPRINT, LDTRBK)
CALL C_DRHOOK_WATCH(IACTIVE, CDNAME, PTR, IBYTES, IABORT, IPRINT, 1, ITRBK)
END SUBROUTINE DR_HOOK_WATCH_I8_SCALAR

SUBROUTINE DR_HOOK_WATCH_I8_VEC(CDNAME, PTR, &
          &                    LDABORT, LDACTIVE, LDPRINT, LDTRBK)
INTEGER(KIND=JPIM), PARAMETER :: JP_BYTES_PER_ELEM = 8
CHARACTER(LEN=*), INTENT(IN) :: CDNAME
INTEGER(KIND=JPIB), INTENT(IN) :: PTR(:)
LOGICAL, INTENT(IN), OPTIONAL :: LDABORT, LDACTIVE, LDPRINT, LDTRBK
LOGICAL :: LLABORT, LLACTIVE, LLPRINT, LLTRBK
INTEGER(KIND=JPIM) :: IBYTES, IABORT, IACTIVE, IPRINT, ITRBK
IBYTES = SIZE(PTR) * JP_BYTES_PER_ELEM
IF (IBYTES <= 0) RETURN
CALL CHECK_ARGS(LLABORT, LLACTIVE, LLPRINT, LLTRBK, &
     &          IABORT, IACTIVE, IPRINT, ITRBK, KEY_I8, &
     &          LDABORT, LDACTIVE, LDPRINT, LDTRBK)
CALL C_DRHOOK_WATCH(IACTIVE, CDNAME, PTR(1), IBYTES, IABORT, IPRINT, SIZE(PTR), ITRBK)
END SUBROUTINE DR_HOOK_WATCH_I8_VEC

SUBROUTINE DR_HOOK_WATCH_R4_SCALAR(CDNAME, PTR, &
          &                        LDABORT, LDACTIVE, LDPRINT, LDTRBK)
INTEGER(KIND=JPIM), PARAMETER :: JP_BYTES_PER_ELEM = 4
CHARACTER(LEN=*), INTENT(IN) :: CDNAME
REAL(KIND=JPRM), INTENT(IN) :: PTR
LOGICAL, INTENT(IN), OPTIONAL :: LDABORT, LDACTIVE, LDPRINT, LDTRBK
LOGICAL :: LLABORT, LLACTIVE, LLPRINT, LLTRBK
INTEGER(KIND=JPIM) :: IBYTES, IABORT, IACTIVE, IPRINT, ITRBK
IBYTES = JP_BYTES_PER_ELEM
CALL CHECK_ARGS(LLABORT, LLACTIVE, LLPRINT, LLTRBK, &
     &          IABORT, IACTIVE, IPRINT, ITRBK, KEY_R4, &
     &          LDABORT, LDACTIVE, LDPRINT, LDTRBK)
CALL C_DRHOOK_WATCH(IACTIVE, CDNAME, PTR, IBYTES, IABORT, IPRINT, 1, ITRBK)
END SUBROUTINE DR_HOOK_WATCH_R4_SCALAR

SUBROUTINE DR_HOOK_WATCH_R4_VEC(CDNAME, PTR, &
          &                    LDABORT, LDACTIVE, LDPRINT, LDTRBK)
INTEGER(KIND=JPIM), PARAMETER :: JP_BYTES_PER_ELEM = 4
CHARACTER(LEN=*), INTENT(IN) :: CDNAME
REAL(KIND=JPRM), INTENT(IN) :: PTR(:)
LOGICAL, INTENT(IN), OPTIONAL :: LDABORT, LDACTIVE, LDPRINT, LDTRBK
LOGICAL :: LLABORT, LLACTIVE, LLPRINT, LLTRBK
INTEGER(KIND=JPIM) :: IBYTES, IABORT, IACTIVE, IPRINT, ITRBK
IBYTES = SIZE(PTR) * JP_BYTES_PER_ELEM
IF (IBYTES <= 0) RETURN
CALL CHECK_ARGS(LLABORT, LLACTIVE, LLPRINT, LLTRBK, &
     &          IABORT, IACTIVE, IPRINT, ITRBK, KEY_R4, &
     &          LDABORT, LDACTIVE, LDPRINT, LDTRBK)
CALL C_DRHOOK_WATCH(IACTIVE, CDNAME, PTR(1), IBYTES, IABORT, IPRINT, SIZE(PTR), ITRBK)
END SUBROUTINE DR_HOOK_WATCH_R4_VEC

SUBROUTINE DR_HOOK_WATCH_R8_SCALAR(CDNAME, PTR, &
          &                        LDABORT, LDACTIVE, LDPRINT, LDTRBK)
INTEGER(KIND=JPIM), PARAMETER :: JP_BYTES_PER_ELEM = 8
CHARACTER(LEN=*), INTENT(IN) :: CDNAME
REAL(KIND=JPRD), INTENT(IN) :: PTR
LOGICAL, INTENT(IN), OPTIONAL :: LDABORT, LDACTIVE, LDPRINT, LDTRBK
LOGICAL :: LLABORT, LLACTIVE, LLPRINT, LLTRBK
INTEGER(KIND=JPIM) :: IBYTES, IABORT, IACTIVE, IPRINT, ITRBK
IBYTES = JP_BYTES_PER_ELEM
CALL CHECK_ARGS(LLABORT, LLACTIVE, LLPRINT, LLTRBK, &
     &          IABORT, IACTIVE, IPRINT, ITRBK, KEY_R8, &
     &          LDABORT, LDACTIVE, LDPRINT, LDTRBK)
CALL C_DRHOOK_WATCH(IACTIVE, CDNAME, PTR, IBYTES, IABORT, IPRINT, 1, ITRBK)
END SUBROUTINE DR_HOOK_WATCH_R8_SCALAR

SUBROUTINE DR_HOOK_WATCH_R8_VEC(CDNAME, PTR, &
          &                    LDABORT, LDACTIVE, LDPRINT, LDTRBK)
INTEGER(KIND=JPIM), PARAMETER :: JP_BYTES_PER_ELEM = 8
CHARACTER(LEN=*), INTENT(IN) :: CDNAME
REAL(KIND=JPRD), INTENT(IN) :: PTR(:)
LOGICAL, INTENT(IN), OPTIONAL :: LDABORT, LDACTIVE, LDPRINT, LDTRBK
LOGICAL :: LLABORT, LLACTIVE, LLPRINT, LLTRBK
INTEGER(KIND=JPIM) :: IBYTES, IABORT, IACTIVE, IPRINT, ITRBK
IBYTES = SIZE(PTR) * JP_BYTES_PER_ELEM
IF (IBYTES <= 0) RETURN
CALL CHECK_ARGS(LLABORT, LLACTIVE, LLPRINT, LLTRBK, &
     &          IABORT, IACTIVE, IPRINT, ITRBK, KEY_R8, &
     &          LDABORT, LDACTIVE, LDPRINT, LDTRBK)
CALL C_DRHOOK_WATCH(IACTIVE, CDNAME, PTR(1), IBYTES, IABORT, IPRINT, SIZE(PTR), ITRBK)
END SUBROUTINE DR_HOOK_WATCH_R8_VEC

SUBROUTINE DR_HOOK_CHECK_WATCH(CDWHERE, LDABORT)
CHARACTER(LEN=*), INTENT(IN) :: CDWHERE
LOGICAL, INTENT(IN), OPTIONAL :: LDABORT
LOGICAL :: LLABORT
INTEGER(KIND=JPIM) :: IABORT
IABORT = 0
LLABORT = .FALSE.
IF (PRESENT(LDABORT)) LLABORT = LDABORT
IF (LLABORT) IABORT = 1
CALL C_DRHOOK_CHECK_WATCH(CDWHERE, IABORT)
END SUBROUTINE DR_HOOK_CHECK_WATCH

END MODULE DR_HOOK_WATCH_MOD

! (C) Copyright 2005- ECMWF.
! 
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!

SUBROUTINE GETMEMSTAT(KOUT, CDLABEL)

USE EC_PARKIND  ,ONLY : JPIM, JPRD, JPIB

USE MPL_MODULE

IMPLICIT NONE

INTEGER(KIND=JPIM), INTENT(IN) :: KOUT
CHARACTER(LEN=*), INTENT(IN) :: CDLABEL
INTEGER(KIND=JPIM) :: I, IMYPROC, INPROC, IOFFSET
INTEGER(KIND=JPIM), PARAMETER :: JP_MEMKEYS = 5  ! pls. consult ifsaux/utilities/getmemvals.F90
INTEGER(KIND=JPIM) IMEMKEYS(JP_MEMKEYS)
INTEGER(KIND=JPIB) IMEMVALS(JP_MEMKEYS)
REAL(KIND=JPRD), ALLOCATABLE :: ZSEND(:), ZRECV(:)
INTEGER(KIND=JPIM), ALLOCATABLE :: ICOUNTS(:)
CHARACTER(LEN=1) CLENV

CALL GET_ENVIRONMENT_VARIABLE("EC_PROFILE_MEM", CLENV) ! turn ON by export EC_PROFILE_MEM=1

IF (KOUT >= 0 .AND. CLENV == '1') THEN
  IMYPROC = MPL_MYRANK()
  INPROC  = MPL_NPROC()

  ALLOCATE(ZSEND(JP_MEMKEYS))
  ALLOCATE(ZRECV(JP_MEMKEYS * INPROC))
  ALLOCATE(ICOUNTS(INPROC))

!                 1=MAXHEAP, 2=MAXRSS, 3=CURRENTHEAP, 5=MAXSTACK, 6=PAGING
  IMEMKEYS(:) = (/1,         2,        3,             5,          6/) 
  CALL GETMEMVALS(JP_MEMKEYS, IMEMKEYS, IMEMVALS)

  ZSEND(:) = 0
  DO I=1,JP_MEMKEYS
    ZSEND(I) = IMEMVALS(I)
  ENDDO
  ZRECV(:) = -1

  ICOUNTS(:) = JP_MEMKEYS
  CALL MPL_GATHERV(ZSEND(:), KROOT=1, KRECVCOUNTS=ICOUNTS(:), &
                  &PRECVBUF=ZRECV, CDSTRING='GETMEMSTAT:')

  IF (IMYPROC == 1) THEN
     WRITE(KOUT,9000) TRIM(CDLABEL)
9000 FORMAT(/,"Memory Utilization Information (in bytes) : ",a,/,79("="),//,&
         &  " Task   Max heapsize   Max resident   Current heap      Max stack   I/O-paging #",/,&
         &  " ====   ============   ============   ============   ============   ============",//)
     IOFFSET = 0
     DO I=1,INPROC
       IMEMVALS(:) = ZRECV(IOFFSET+1:IOFFSET+JP_MEMKEYS)
       WRITE(KOUT,'(I5,5(3X,I12))') I,IMEMVALS(:)
       IOFFSET = IOFFSET + JP_MEMKEYS
     ENDDO
     WRITE(KOUT,'(/,a,/)') 'End of Memory Utilization Information'
  ENDIF

  DEALLOCATE(ZSEND)
  DEALLOCATE(ZRECV)
  DEALLOCATE(ICOUNTS)

  CALL GETHEAPSTAT(KOUT, CDLABEL)
ENDIF
END SUBROUTINE GETMEMSTAT

! (C) Copyright 2005- ECMWF.
! (C) Copyright 2013- Meteo-France.
! 
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!

SUBROUTINE DR_HOOK_END()
  ! Make sure DrHook output is produced before MPI_Finalize (in case it fails)
  IMPLICIT NONE
  EXTERNAL :: c_drhook_prof
  LOGICAL,SAVE :: LL_FIRST_TIME = .TRUE.
  IF( .NOT. LL_FIRST_TIME ) THEN
    LL_FIRST_TIME = .FALSE.
    CALL c_drhook_prof()
  ENDIF
END SUBROUTINE

! (C) Copyright 2005- ECMWF.
! (C) Copyright 2013- Meteo-France.
! 
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!

MODULE MPL_GROUPS

!     Purpose.
!     --------
!       Use MPI groups for easier to read code (and more efficient
!       communications, at least on IBM).

!     Author.
!     -------
!       Y. Tremolet

!     Modifications.
!     --------------
!       Original: 02-03-13
! ------------------------------------------------------------------

! --- *NOT* THREAD SAFE YET ---

USE EC_PARKIND  ,ONLY : JPIM

USE MPL_MPIF
USE MPL_DATA_MODULE
USE MPL_MESSAGE_MOD

IMPLICIT NONE
PRIVATE
PUBLIC MPL_COMM_GRID, MPL_ALL_LEVS_COMM, MPL_ALL_MS_COMM, &
     & MPL_GROUPS_CREATE, MPL_CART_RANK, MPL_CART_COORDS

INTEGER(KIND=JPIM) :: MPL_COMM_GRID, MPL_ALL_LEVS_COMM, MPL_ALL_MS_COMM, &
           & MPL_GP_GRID
LOGICAL,SAVE :: LGROUPSETUP=.FALSE.
CONTAINS
! ------------------------------------------------------------------

SUBROUTINE MPL_GROUPS_CREATE(KPROCW, KPROCV)


#ifdef USE_8_BYTE_WORDS
  USE MPI4TO8, ONLY : &
    MPI_CART_CREATE => MPI_CART_CREATE8, MPI_COMM_GROUP => MPI_COMM_GROUP8, &
    MPI_CART_SUB => MPI_CART_SUB8
#endif


IMPLICIT NONE
INTEGER(KIND=JPIM), INTENT(IN) :: KPROCW, KPROCV

INTEGER(KIND=JPIM) :: IDIMS(2), IERR
LOGICAL :: LTORUS(2), LDIMS(2), LREORDER

IF(LGROUPSETUP) RETURN

IDIMS(1)=KPROCW
IDIMS(2)=KPROCV
LTORUS(1)=.FALSE.
LTORUS(2)=.FALSE.
LREORDER=.FALSE.

CALL MPI_CART_CREATE(MPL_COMM_OML(1), 2, IDIMS, LTORUS, LREORDER, &
                   & MPL_COMM_GRID, IERR)
IF (IERR/=0) CALL MPL_MESSAGE(IERR,'MPL_GROUPS_CREATE: MPI_CART_CREATE')

CALL MPI_COMM_GROUP(MPL_COMM_GRID, MPL_GP_GRID, IERR)
IF (IERR/=0) CALL MPL_MESSAGE(IERR,'MPL_GROUPS_CREATE: mpi_comm_group')

! Group all levels for same Ms
! ----------------------------
LDIMS(1)=.FALSE.
LDIMS(2)=.TRUE.
CALL MPI_CART_SUB(MPL_COMM_GRID, LDIMS, MPL_ALL_LEVS_COMM, IERR)
IF (IERR/=0) CALL MPL_MESSAGE(IERR,'MPL_GROUPS_CREATE: mpi_cart_sub 1')

! Group all Ms for same levels
! ----------------------------
LDIMS(1)=.TRUE.
LDIMS(2)=.FALSE.
CALL MPI_CART_SUB(MPL_COMM_GRID, LDIMS, MPL_ALL_MS_COMM, IERR)
IF (IERR/=0) CALL MPL_MESSAGE(IERR,'MPL_GROUPS_CREATE: mpi_cart_sub 2')

LGROUPSETUP=.TRUE.

END SUBROUTINE MPL_GROUPS_CREATE

! ------------------------------------------------------------------

FUNCTION MPL_CART_RANK(KPROCW, KPROCV)

#ifdef USE_8_BYTE_WORDS
  USE MPI4TO8, ONLY : &
    MPI_CART_RANK => MPI_CART_RANK8
#endif

IMPLICIT NONE
INTEGER(KIND=JPIM), INTENT(IN)  :: KPROCW, KPROCV
INTEGER(KIND=JPIM) :: MPL_CART_RANK

INTEGER(KIND=JPIM) :: IDIMS(2), IPROC, IERR

IDIMS(1)=KPROCW-1
IDIMS(2)=KPROCV-1

CALL MPI_CART_RANK(MPL_COMM_GRID, IDIMS, IPROC, IERR)
IF (IERR/=0) CALL MPL_MESSAGE(IERR,'MPL_CART_RANK: mpi_cart_rank')

MPL_CART_RANK=IPROC+1

END FUNCTION MPL_CART_RANK

! ------------------------------------------------------------------

SUBROUTINE MPL_CART_COORDS(KPROC, KPROCW, KPROCV)

#ifdef USE_8_BYTE_WORDS
  USE MPI4TO8, ONLY : &
    MPI_CART_COORDS => MPI_CART_COORDS8
#endif


IMPLICIT NONE
INTEGER(KIND=JPIM), INTENT(IN)   :: KPROC
INTEGER(KIND=JPIM), INTENT(OUT)  :: KPROCW, KPROCV

INTEGER(KIND=JPIM) :: IDIMS(2), IPROC, IERR

IPROC=KPROC-1

CALL MPI_CART_COORDS(MPL_COMM_GRID, IPROC, 2, IDIMS, IERR)
IF (IERR/=0) CALL MPL_MESSAGE(IERR,'MPL_CART_COORDS: mpi_cart_coords')

KPROCW=IDIMS(1)+1
KPROCV=IDIMS(2)+1

END SUBROUTINE MPL_CART_COORDS

! ------------------------------------------------------------------

END MODULE MPL_GROUPS

! (C) Copyright 2005- ECMWF.
! (C) Copyright 2013- Meteo-France.
! 
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!

MODULE MPL_END_MOD

!**** MPL_END - Terminates the message passing environment

!     Purpose.
!     --------
!     Cleans up all of the MPI state. 
!     Subsequently, no MPI routine can be called

!**   Interface.
!     ----------
!        CALL MPL_END

!        Input required arguments :
!        -------------------------
!           none

!        Input optional arguments :
!        -------------------------
!           LDMEMINFO -  print memory info (default True)

!        Output required arguments :
!        -------------------------
!           none

!        Output optional arguments :
!        -------------------------
!           KERROR    -  return error code.     If not supplied, 
!                        MPL_END aborts when an error is detected.
!     Author.
!     -------
!        D.Dent, M.Hamrud     ECMWF

!     Modifications.
!     --------------
!        Original: 2000-09-01
!        P. Towers     3-Jul-2014 Add call to ec_cray_meminfo

!     ------------------------------------------------------------------

USE EC_PARKIND  ,ONLY : JPIM

USE MPL_DATA_MODULE
USE MPL_MESSAGE_MOD

IMPLICIT NONE

PUBLIC MPL_END
PRIVATE

INTEGER :: IERROR

CONTAINS 

SUBROUTINE MPL_END(KERROR,LDMEMINFO)


#ifdef USE_8_BYTE_WORDS
  USE MPI4TO8, ONLY : &
    MPI_BUFFER_DETACH => MPI_BUFFER_DETACH8, MPI_FINALIZE => MPI_FINALIZE8
#endif


INTEGER(KIND=JPIM),INTENT(OUT),OPTIONAL :: KERROR
LOGICAL           ,INTENT(IN), OPTIONAL :: LDMEMINFO
INTEGER(KIND=JPIM)                      :: IBUFFMPI,IERROR
LOGICAL                      :: LLMEMINFO
LOGICAL,parameter            :: LLABORT=.TRUE.

#include "ec_mpi_finalize.intfb.h"

IF(MPL_NUMPROC < 1) THEN
  IF(MPL_NUMPROC == -1) THEN
    IF (.NOT.LINITMPI_VIA_MPL) THEN
      ! Neither MPL_INIT_MOD nor MPL_ARG_MOD -modules were called before this
      CALL MPL_MESSAGE(CDMESSAGE=' MPL_END CALLED BEFORE MPL_INIT ')
    ENDIF
!!-- we do not want the following message to appear, since its non-fatal
!!  ELSEIF(MPL_NUMPROC == -2) THEN
!!    CALL MPL_MESSAGE(CDMESSAGE=' MPL_END CALLED MULTIPLE TIMES ')
  ENDIF
  IF(PRESENT(KERROR)) THEN
    IERROR=0
    KERROR=IERROR
  ENDIF
  RETURN
ENDIF

IF (ALLOCATED(MPL_ATTACHED_BUFFER)) THEN
  IF( MPI_IS_FINALIZED() ) THEN
    CALL MPL_MESSAGE(CDMESSAGE='MPL_END -- Cannot call MPI_Buffer_detach() as MPI is already finalized',LDABORT=.FALSE.)
  ELSE
    IBUFFMPI=SIZE(MPL_ATTACHED_BUFFER) * JP_ATTACHED_BUFFER_BYTES ! in bytes
    CALL MPI_BUFFER_DETACH(MPL_ATTACHED_BUFFER,IBUFFMPI,IERROR)
    IF(PRESENT(KERROR)) THEN
      KERROR=IERROR
    ELSE
      IF( IERROR /= 0 )THEN
        CALL MPL_MESSAGE(IERROR,'MPL_END ',LDABORT=LLABORT)
      ENDIF
    ENDIF
  ENDIF
  DEALLOCATE(MPL_ATTACHED_BUFFER)
ENDIF

LLMEMINFO=.TRUE.
IF(PRESENT(LDMEMINFO)) LLMEMINFO=LDMEMINFO
CALL EC_MPI_FINALIZE(IERROR,LINITMPI_VIA_MPL,LLMEMINFO,"mpl_end")

MPL_NUMPROC = -2
LINITMPI_VIA_MPL = .FALSE.

IF(PRESENT(KERROR)) THEN
  KERROR=IERROR
ENDIF

RETURN
END SUBROUTINE MPL_END

FUNCTION MPI_IS_FINALIZED()
  LOGICAL :: MPI_IS_FINALIZED
  LOGICAL :: LLINIT, LLFIN
  INTEGER(KIND=JPIM) :: IERR
  MPI_IS_FINALIZED = .FALSE.
  CALL MPI_INITIALIZED(LLINIT,IERR)
  IF (LLINIT .AND. IERR == 0) THEN
    CALL MPI_FINALIZED(LLFIN,IERR)
    IF( IERR == 0 ) THEN
      MPI_IS_FINALIZED = LLFIN
    ENDIF
  ENDIF
END FUNCTION

END MODULE MPL_END_MOD

! (C) Copyright 2026- ECMWF.
!
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
!
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.

program drhook_no_hw_fpe_basic

use yomhook, only : jphook, dr_hook

implicit none

real(jphook) :: zhook_handle
real :: x
real, volatile :: y ! This is needed because some compilers are smart enough to perform constant folding at compile time, which prevents FPE flags being set a runtime

interface
  subroutine silently_disable_all_fpes() bind(C, name="silently_disable_all_fpes")
  end subroutine
end interface

call dr_hook('drhook_no_hw_fpe_basic', 0, zhook_handle)


! DrHook can't see this, so it thinks FPEs are still enabled & gives the behaviour we want, but the test won't fail to an FPE
call silently_disable_all_fpes()

! This is needed because some compilers are smart enough to throw an error at compile time
y = 0.0
x = 1.0/y

call dr_hook('drhook_no_hw_fpe_basic', 1, zhook_handle)

print *, "Hello, x is ", x

end program drhook_no_hw_fpe_basic

! (C) Copyright 2005- ECMWF.
! (C) Copyright 2013- Meteo-France.
! 
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!

MODULE DR_HOOK_STACKCHECK_MOD

! Used by dr_hook_util to monitor thread stack usage 

USE EC_PARKIND  ,ONLY : JPIB

IMPLICIT NONE

SAVE

PRIVATE :: JPIB

PUBLIC

INTEGER(KIND=JPIB), ALLOCATABLE :: ISAVE(:) 
INTEGER(KIND=JPIB), ALLOCATABLE :: IMAXSTACK(:) 
LOGICAL,            ALLOCATABLE :: LL_THREAD_FIRST(:)

END MODULE DR_HOOK_STACKCHECK_MOD

! (C) Copyright 2005- ECMWF.
! (C) Copyright 2013- Meteo-France.
! 
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!

MODULE MPL_COMM_FREE_MOD

!**** *MPL_COMM_FREE_MOD*  - Release ressources used by a communicator

!     Author. 
!     ------- 
!      Philippe Marguinaud *METEO FRANCE*
!      Original : 11-09-2012

USE EC_PARKIND, ONLY : JPIM

IMPLICIT NONE

PRIVATE
PUBLIC :: MPL_COMM_FREE

CONTAINS

SUBROUTINE MPL_COMM_FREE (KCOMM, KERR, CDSTRING)
INTEGER (KIND=JPIM), INTENT (IN)  :: KCOMM
INTEGER (KIND=JPIM), INTENT (OUT) :: KERR
CHARACTER (LEN=*),   INTENT (IN), OPTIONAL :: CDSTRING

CALL MPI_COMM_FREE (KCOMM, KERR)

END SUBROUTINE MPL_COMM_FREE

END MODULE MPL_COMM_FREE_MOD

MODULE XRD_UNIX_ENV

!**** *XRD_UNIX_ENV*  - 

!     Author. 
!     ------- 
!      Philippe Marguinaud *METEO FRANCE*
!      Original : 11-09-2012

USE EC_PARKIND, ONLY : JPIM
#ifdef NAGFOR
use F90_UNIX, only: GETARG
use F90_UNIX_PROC, only: EXIT
#endif
IMPLICIT NONE

CONTAINS

SUBROUTINE XRD_GETENV( KEY, VAL )
  IMPLICIT NONE
  CHARACTER(LEN=*), INTENT(IN) :: KEY
  CHARACTER(LEN=*), INTENT(OUT) :: VAL

  CALL GET_ENVIRONMENT_VARIABLE( KEY, VAL )
END SUBROUTINE XRD_GETENV


FUNCTION XRD_IARGC()
  IMPLICIT NONE
  INTEGER(KIND=JPIM) :: XRD_IARGC
  XRD_IARGC = COMMAND_ARGUMENT_COUNT()
END FUNCTION XRD_IARGC

SUBROUTINE XRD_GETARG( KEY, VAL )
  IMPLICIT NONE
  INTEGER(KIND=JPIM), INTENT(IN) :: KEY
  CHARACTER(LEN=*), INTENT(OUT) :: VAL
  CALL GETARG( INT(KEY,SELECTED_INT_KIND(9)), VAL )
END SUBROUTINE XRD_GETARG

SUBROUTINE XRD_EXIT( STATUS )
  IMPLICIT NONE
  INTEGER(KIND=JPIM), INTENT(IN) :: STATUS
  CALL EXIT( INT(STATUS,SELECTED_INT_KIND(9)) )
END SUBROUTINE XRD_EXIT

SUBROUTINE XRD_MKDIR( PATH )
  IMPLICIT NONE
  CHARACTER(LEN=*), INTENT(IN) :: PATH
#ifdef NAGFOR
  CALL EXECUTE_COMMAND_LINE( "mkdir -p "//TRIM(PATH))
#else
  CALL SYSTEM( "mkdir -p "//TRIM(PATH))
#endif
END SUBROUTINE XRD_MKDIR

CHARACTER*256 FUNCTION XRD_DIRNAME( PATH )
  IMPLICIT NONE
  CHARACTER(LEN=*), INTENT(IN) :: PATH

  INTEGER(KIND=JPIM) :: I
  XRD_DIRNAME = ""
  I = LEN( TRIM( PATH ) ) - 1
  DO
    IF( I .LE. 0 ) RETURN
    IF( PATH(I:I) .EQ. '/' ) EXIT
    I = I - 1
  ENDDO
  XRD_DIRNAME = PATH(1:I)
END FUNCTION XRD_DIRNAME

FUNCTION XRD_BASENAME( PATH )
  IMPLICIT NONE
  CHARACTER*256 :: XRD_BASENAME
  CHARACTER(LEN=*), INTENT(IN) :: PATH

  INTEGER(KIND=JPIM) :: I
  XRD_BASENAME = ""
  I = LEN( TRIM( PATH ) ) - 1
  DO
    IF( I .LE. 0 ) THEN
      I = 0
      EXIT
    ENDIF
    IF( PATH(I:I) .EQ. '/' ) EXIT
    I = I - 1
  ENDDO
  XRD_BASENAME = PATH(I+1:)
END FUNCTION XRD_BASENAME

ELEMENTAL SUBROUTINE XRD_LOWER_CASE(OUS,INS)
IMPLICIT NONE
! CONVERT A WORD TO LOWER CASE
CHARACTER (LEN=*) , INTENT(OUT) :: OUS
CHARACTER (LEN=*) , INTENT(IN) :: INS
INTEGER :: I,IC,NLEN
NLEN = LEN(INS)
OUS = ''
DO I=1,NLEN
   IC = ICHAR(INS(I:I))
   IF (IC >= 65 .AND. IC < 90) THEN
     OUS(I:I) = CHAR(IC+32)
   ELSE
     OUS(I:I) = INS(I:I)
   ENDIF
END DO
END SUBROUTINE XRD_LOWER_CASE

ELEMENTAL SUBROUTINE XRD_UPPER_CASE(OUS,INS)
IMPLICIT NONE
! CONVERT A WORD TO UPPER CASE
CHARACTER (LEN=*) , INTENT(OUT) :: OUS
CHARACTER (LEN=*) , INTENT(IN) :: INS
INTEGER :: I,IC,NLEN
NLEN = LEN(INS)
OUS = ''
DO I=1,NLEN
   IC = ICHAR(INS(I:I))
   IF (IC >= 97 .AND. IC < 122) THEN
     OUS(I:I) = CHAR(IC-32)
   ELSE
     OUS(I:I) = INS(I:I)
   ENDIF
END DO
END SUBROUTINE XRD_UPPER_CASE

FUNCTION XRD_ISALPHA(C)
IMPLICIT NONE
LOGICAL(KIND=JPIM) :: XRD_ISALPHA
CHARACTER, INTENT(IN) :: C

XRD_ISALPHA = ((C.GE.'A').AND.(C.LE.'Z'))&
            .OR.((C.GE.'a').AND.(C.LE.'z'))

END FUNCTION XRD_ISALPHA

FUNCTION XRD_ISDIGIT(C)
IMPLICIT NONE
LOGICAL(KIND=JPIM) :: XRD_ISDIGIT
CHARACTER, INTENT(IN) :: C

XRD_ISDIGIT = (C.GE.'0').AND.(C.LE.'9')

END FUNCTION XRD_ISDIGIT

SUBROUTINE XRD_DATE_AND_TIME( VL )
IMPLICIT NONE
INTEGER(KIND=JPIM), INTENT(OUT) :: VL(8)
!
INTEGER :: VLX(8)

  CALL DATE_AND_TIME( VALUES = VLX )

  VL = VLX
END SUBROUTINE XRD_DATE_AND_TIME

SUBROUTINE XRD_CPU_TIME( T )
  IMPLICIT NONE
  REAL,INTENT(OUT) :: T
  CALL CPU_TIME( T )
END SUBROUTINE XRD_CPU_TIME

SUBROUTINE XRD_COUNTLINES( NLINES, F, ERR )
IMPLICIT NONE
INTEGER(KIND=JPIM), INTENT(OUT) :: NLINES
CHARACTER*(*), INTENT(IN) :: F
INTEGER(KIND=JPIM), INTENT(OUT) :: ERR
CHARACTER*32 :: STR


ERR = 0

NLINES = 0
OPEN( 77, FILE = F, ERR = 888 )

DO
  READ( 77, *, ERR = 888, END = 777 ) STR
  NLINES = NLINES + 1
ENDDO

777 CONTINUE

CLOSE( 77 )

RETURN
888 CONTINUE
  ERR = 1
END SUBROUTINE XRD_COUNTLINES

FUNCTION XRD_COUNTWORDS( S )
  IMPLICIT NONE
  INTEGER(KIND=JPIM) :: XRD_COUNTWORDS
  CHARACTER(LEN=*), INTENT(IN) :: S
  INTEGER(KIND=JPIM) :: N, I, L
  LOGICAL(KIND=JPIM) :: IN
  N = 0_JPIM
  IN = .FALSE.
  L = LEN( TRIM( S ) )
  DO I = 1, L
    IF( S(I:I) .EQ. ' ' ) THEN
      IN = .FALSE.
    ELSE IF( .NOT. IN ) THEN
      N = N + 1
      IN = .TRUE.
    ENDIF
  ENDDO
  XRD_COUNTWORDS = N
END FUNCTION XRD_COUNTWORDS

END MODULE XRD_UNIX_ENV

! (C) Copyright 2005- ECMWF.
! 
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!

subroutine get_openmp(kopenmp)
use EC_PARKIND, only : JPIM
implicit none
INTEGER(KIND=JPIM), INTENT(out) :: kopenmp
#ifdef _OPENMP
kopenmp = _OPENMP
#else
kopenmp = 0
#endif
end subroutine get_openmp

! (C) Copyright 2005- ECMWF.
! 
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!

!RJ: make interfaceable; generalization
SUBROUTINE CPTIME(PVCP,PTCP)
USE EC_PARKIND, ONLY : JPRD, JPIM
IMPLICIT NONE
REAL(KIND=JPRD) :: PVCP
REAL(KIND=JPRD) :: PTCP
!
#if defined (NEWTIMER)
! this routine should work better with OpenMP
! But doesn't work on Cray - and in any case does not return 
! CPU time for all threads combined 
INTEGER(KIND=JPIM),SAVE :: IFIRST=1
INTEGER(KIND=JPIM),SAVE :: KFIRST,KTPS
INTEGER(KIND=JPIM) :: KTICK
!     Usage of Fortran95 intrinsic function system_clock for ELAPSED time,
!     thus taking into account the parallelism if inside an open-mp region. REK
IF(IFIRST.EQ.1) THEN
  IFIRST=0
  CALL SYSTEM_CLOCK(KFIRST,KTPS)
  PVCP=0.0_JPRD
  PTCP=PVCP
ELSE
  CALL SYSTEM_CLOCK(KTICK)
  PVCP=REAL(KTICK-KFIRST,KIND=JPRD)/REAL(KTPS,KIND=JPRD)
  PTCP=PVCP
ENDIF
#else
INTEGER(KIND=JPIM),SAVE :: IFIRST=0
REAL(KIND=JPRD),SAVE :: ZFIRST
REAL(KIND=JPRD) :: ZSEC
!     Usage of Fortran95 intrinsic function for CPU timing.
IF(IFIRST.EQ.0) THEN
  IFIRST=1
  CALL CPU_TIME(ZFIRST)
  PVCP=0.0_JPRD
  PTCP=PVCP
ELSE
  CALL CPU_TIME(ZSEC)
  PVCP=ZSEC-ZFIRST
  PTCP=PVCP
ENDIF
#endif
!
RETURN
END SUBROUTINE CPTIME

! (C) Copyright 2005- ECMWF.
! (C) Copyright 2013- Meteo-France.
! 
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!

MODULE MPL_NPROC_MOD
!**** MPL_NPROC - return Number of processes 

!        Input optional arguments :
!        -------------------------
!           KCOMM    -  Communicator number if different from MPI_COMM_WORLD 

!     Author.
!     -------
!        D.Dent, M.Hamrud     ECMWF

!     Modifications.
!     --------------
!        Original: 2000-09-01

!     ------------------------------------------------------------------

USE EC_PARKIND  ,ONLY : JPIM
USE MPL_DATA_MODULE
USE MPL_MESSAGE_MOD

IMPLICIT NONE
PRIVATE
PUBLIC MPL_NPROC

CONTAINS 
FUNCTION MPL_NPROC(KCOMM)

#ifdef USE_8_BYTE_WORDS
  USE MPI4TO8, ONLY : &
    MPI_COMM_SIZE => MPI_COMM_SIZE8
#endif

INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL :: KCOMM
INTEGER(KIND=JPIM) :: MPL_NPROC

INTEGER(KIND=JPIM) :: IERROR,IPROC
LOGICAL   :: LLABORT=.TRUE.

IF(MPL_NUMPROC < 1) CALL MPL_MESSAGE( &
  & CDMESSAGE='MPL_MYRANK: MPL NOT INITIALISED ',LDABORT=LLABORT) 
IF(PRESENT(KCOMM)) THEN
  CALL MPI_COMM_SIZE(KCOMM,IPROC,IERROR)
  MPL_NPROC = IPROC
ELSE
  MPL_NPROC = MPL_NUMPROC 
ENDIF

  
END FUNCTION MPL_NPROC
END MODULE MPL_NPROC_MOD

! (C) Copyright 2005- ECMWF.
! (C) Copyright 2013- Meteo-France.
! 
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!

SUBROUTINE GSTATS_PRINT(KULOUT,PAVEAVE,KLEN)

!**** *GSTATS_PRINT* - print timing statistics

!     PURPOSE.
!     --------
!       To print out timings gathered by GSTATS


!**   INTERFACE.
!     ----------
!       *CALL* *GSTATS_PRINT*

!        EXPLICIT ARGUMENTS     None
!        --------------------


!        IMPLICIT ARGUMENTS
!        --------------------
!        Module YOMSTATS

!     METHOD.
!     -------


!     EXTERNALS.   
!     ----------   

!     REFERENCE.
!     ----------
!        ECMWF Research Department documentation of the IFS

!     AUTHOR.
!     -------
!        Mats Hamrud ECMWF

!     MODIFICATIONS.
!     --------------
!        ORIGINAL : 98-11-15
!        D.Salmond: 99-09-21 : Timer for SLCOMM2
!        G.Mozdzynski 05-09-25 : fix master ncalls overwrite for nproc>1
!        C.Larsson    8-May-2006 : Added xml file output
!        G.Mozdzynski 16-Oct-2007 : xml file output under switch LXML_STATS
!        P.Towers     11-May-2011 : mpl comms statistics output
!        F. Vana  05-Mar-2015  Support for single precision
!        G. Mozdzynski 18-Aug-2015 Avoid confusion, procs are tasks
!     ------------------------------------------------------------------

USE EC_PARKIND, ONLY: JPRD, JPIM
USE YOMGSTATS, ONLY: JPMAXDELAYS, JPMAXSTAT, NPROC_STATS, LXML_STATS, MYPROC_STATS, LSYNCSTATS, &
  &                  LDETAILED_STATS, LSTATS_COMMS, LSTATS_OMP, LBARRIER_STATS2, JBMAXBASE, &
  &                  NBAR_PTR, CCDESC, CCTYPE, LSTATS, TIMESUM, TIMESQSUM, TIMEMAX, TIMESUMB, &
  &                  TIMELCALL, NCALLS, TTCPUSUM, TVCPUSUM, JPTAGSTAT, NPRCIDS_STATS, LSTATS_MPL, &
  &                  NUMSEND, SENDBYTES, NUMRECV, RECVBYTES, LSTATSCPU, NPRNT_STATS, TIME_START, &
  &                  UNKNOWN_NUMSEND, UNKNOWN_NUMRECV, UNKNOWN_SENDBYTES, UNKNOWN_RECVBYTES, &
  &                  NDELAY_INDEX, NDELAY_COUNTER, TDELAY_VALUE, CDELAY_TIME, LTRACE_STATS, &
  &                  NCALLS_TOTAL, NTRACE_STATS, NCALL_TRACE, TIME_TRACE, LSTATS_MEM, NTMEM
USE MPL_MODULE, ONLY: MPL_SEND, MPL_RECV, MPL_BARRIER

IMPLICIT NONE

INTEGER(KIND=JPIM) :: KULOUT,KLEN
REAL(KIND=JPRD) :: PAVEAVE(0:KLEN)
CHARACTER*7  CLACTION(0:3)
CHARACTER(LEN=JPMAXDELAYS*10) CLTEMP
INTEGER(KIND=JPIM),PARAMETER :: JPARRAYS=8
REAL(KIND=JPRD) :: ZREABUF(JPARRAYS*(JPMAXSTAT+1))
REAL(KIND=JPRD) :: ZAVEAVE(0:JPMAXSTAT),ZAVEMAX(0:JPMAXSTAT),ZTIMELCALL(0:JPMAXSTAT),&
         &ZTHISTIME(0:JPMAXSTAT),ZFRACMAX(0:JPMAXSTAT),&
         &ZSUMMAX(0:JPMAXSTAT),ZSUMTOT(0:JPMAXSTAT)
REAL(KIND=JPRD) :: ZT_SUM,ZT_SUM2,ZT_SUM3,ZT_SUMIO,ZT_SUM4,ZT_SUM5,ZT_SUMB
REAL(KIND=JPRD) :: ZDELAY,ZDELAY_MAX

REAL(KIND=JPRD) :: ZMPL(NPROC_STATS)
REAL(KIND=JPRD) :: ZBAR(NPROC_STATS)
REAL(KIND=JPRD) :: ZGBR(NPROC_STATS)
REAL(KIND=JPRD) :: ZGB2(NPROC_STATS)
REAL(KIND=JPRD) :: ZOMP(NPROC_STATS)
REAL(KIND=JPRD) :: ZIO (NPROC_STATS)
REAL(KIND=JPRD) :: ZSER(NPROC_STATS)
REAL(KIND=JPRD) :: ZMXD(NPROC_STATS)

INTEGER(KIND=JPIM) :: ICALLSX(0:JPMAXSTAT)

!     LOCAL INTEGER SCALARS
INTEGER(KIND=JPIM) :: ICALLS, ILBUF, ILSEND, ILRECV, &
             &ISEND, ITAG, JJ, JNUM, JROC, JCALL, ICALLER,IACTION
INTEGER(KIND=JPIM) :: IMEM, INUM, JMEM
INTEGER(KIND=JPIM) :: JDELAY, IDELAY
INTEGER(KIND=JPIM) :: NSEND,NRECV

!     LOCAL REAL SCALARS
REAL(KIND=JPRD) :: ZAVE, ZAVETCPU, ZAVEVCPU, ZCOMTIM, ZDETAIL,&
          &ZFRAC, ZMAX, ZMEAN, ZSTDDEV, ZSUM, ZSUMB, &
          &ZTOTAL, ZTOTCPU, ZTOTUNBAL, ZTOTVCPU, &
          &ZUNBAL, ZMEANT, ZMAXT

REAL(KIND=JPRD)    :: SBYTES,RBYTES,SENDRATE,RECVRATE
REAL(KIND=JPRD)    :: AVGSENDLEN,AVGRECVLEN
REAL(KIND=JPRD)    :: MAXCOMMTIME(501:1000)
REAL(KIND=JPRD)    :: TOTSENDBYTES(501:1000)
REAL(KIND=JPRD)    :: TOTRECVBYTES(501:1000)
REAL(KIND=JPRD)    :: TOTSENDBYTESSUM
REAL(KIND=JPRD)    :: TOTRECVBYTESSUM
INTEGER(KIND=JPIM) :: IXMLLUN  

!     ------------------------------------------------------------------

ILBUF = JPARRAYS*(JPMAXSTAT+1)
ILRECV = 500*4
ZAVEAVE(:) = 0.0_JPRD
ZAVEMAX(:) = 0.0_JPRD
ZFRACMAX(:)= 0.0_JPRD
ZSUMMAX(:)= 0.0_JPRD
ZSUMTOT(:)= 0.0_JPRD

! OPEN GSTATS.XML for xml statistics
IF(LXML_STATS .AND. MYPROC_STATS==1)THEN
  IXMLLUN=40
  OPEN (UNIT=IXMLLUN, FILE='gstats.xml',ACTION='write')
  WRITE(IXMLLUN,'(A)')'<?xml version="1.0" encoding="UTF-8"?>'
  WRITE(IXMLLUN,'(A)')'<gstats '
  WRITE(IXMLLUN,'(A)')' xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"&
  & xsi:schemaLocation="http://www.ecmwf.int/services/prepifs/gstats   ./gstats.xsd">'
ENDIF

WRITE(KULOUT,'(A)')'===-=== START OF TIMING STATISTICS ===-==='
IF(LSYNCSTATS.AND.NPROC_STATS>1) THEN
  WRITE(KULOUT,'(A)')'START OF TIMINGS SYNCRONIZED'
ENDIF
IF(LDETAILED_STATS) THEN
  LSTATS_COMMS=.TRUE.
  LSTATS_OMP=.TRUE.
ENDIF
IF(LBARRIER_STATS2) THEN
  DO JNUM=1,JBMAXBASE
    IF(NBAR_PTR(JNUM) > 0) THEN
      INUM=NBAR_PTR(JNUM)
      CCDESC(INUM)=CCDESC(JNUM)
      CCTYPE(INUM)='GB2'
    ENDIF
  ENDDO
ENDIF
IF (LSTATS .AND. MYPROC_STATS /= 1) THEN
  JJ = 1
  DO JNUM=0,JPMAXSTAT
    ZREABUF(JJ  ) = TIMESUM(JNUM)
    ZREABUF(JJ+1) = TIMESQSUM(JNUM)
    ZREABUF(JJ+2) = TIMEMAX(JNUM)
    ZREABUF(JJ+3) = TIMESUMB(JNUM)
    ZREABUF(JJ+4) = TIMELCALL(JNUM)
    ZREABUF(JJ+5) = NCALLS(JNUM)
    ZREABUF(JJ+6) = TTCPUSUM(JNUM)
    ZREABUF(JJ+7) = TVCPUSUM(JNUM)
    JJ = JJ+JPARRAYS
  ENDDO
  ILSEND = ILBUF
  ISEND =1
  ITAG = JPTAGSTAT
  CALL MPL_SEND(ZREABUF(1:ILSEND),KDEST=NPRCIDS_STATS(ISEND), &
       & KTAG=ITAG,CDSTRING='GSTATS_PRINT:')

  IF(LSTATS_MPL) THEN
    JJ=1
    DO JNUM=501,1000
      ZREABUF(JJ  ) = NUMSEND(JNUM)
      ZREABUF(JJ+1) = SENDBYTES(JNUM)
      ZREABUF(JJ+2) = NUMRECV(JNUM)
      ZREABUF(JJ+3) = RECVBYTES(JNUM)
      JJ=JJ+4
    ENDDO

    ILSEND = JJ-1
    ITAG = JPTAGSTAT + 1

    CALL MPL_SEND(ZREABUF(1:ILSEND),KDEST=NPRCIDS_STATS(ISEND), &
         & KTAG=ITAG,CDSTRING='GSTATS_PRINT:')

  ENDIF
ELSEIF(LSTATS) THEN
  IF(LSTATS_MPL) THEN
    DO JNUM=501,1000
      MAXCOMMTIME(JNUM)=0.0_JPRD
      TOTSENDBYTES(JNUM)=0.0_JPRD
      TOTRECVBYTES(JNUM)=0.0_JPRD
    ENDDO
  ENDIF
  DO JROC=1,NPROC_STATS
    IF (JROC /= 1) THEN
      ITAG = JPTAGSTAT
      CALL MPL_RECV(ZREABUF(1:ILBUF),KSOURCE=NPRCIDS_STATS(JROC), &
       & KTAG=ITAG,CDSTRING='GSTATS_PRINT:')
      JJ = 1
      DO JNUM=0,JPMAXSTAT
        TIMESUM(JNUM)   = ZREABUF(JJ  )
        TIMESQSUM(JNUM) = ZREABUF(JJ+1)
        TIMEMAX(JNUM)   = ZREABUF(JJ+2)
        TIMESUMB(JNUM)  = ZREABUF(JJ+3)
        TIMELCALL(JNUM) = ZREABUF(JJ+4)
        ICALLSX(JNUM)    = NINT(ZREABUF(JJ+5))
        TTCPUSUM(JNUM)  = ZREABUF(JJ+6)
        TVCPUSUM(JNUM)  = ZREABUF(JJ+7)
        JJ = JJ+JPARRAYS
      ENDDO

      IF(LSTATS_MPL) THEN
        ITAG = JPTAGSTAT+1
        CALL MPL_RECV(ZREABUF(1:ILRECV),KSOURCE=NPRCIDS_STATS(JROC), &
         & KTAG=ITAG,CDSTRING='GSTATS_PRINT:')
        JJ = 1
        DO JNUM=501,1000
          NUMSEND(JNUM)   = NINT(ZREABUF(JJ))
          SENDBYTES(JNUM) = ZREABUF(JJ+1)
          NUMRECV(JNUM)   = NINT(ZREABUF(JJ+2))
          RECVBYTES(JNUM) = ZREABUF(JJ+3)
          JJ=JJ+4
        ENDDO
      ENDIF

    ELSE
      ICALLSX(:)=NCALLS(:)

    ENDIF
    IF (JROC == 1) THEN
      ZTOTAL=TIMESUM(0)
      ZTOTCPU = TTCPUSUM(0)
      ZTOTVCPU = TVCPUSUM(0)
    ENDIF
    IF(.NOT. LSTATSCPU) THEN
      TTCPUSUM(1:JPMAXSTAT) = -0.0_JPRD
      TVCPUSUM(1:JPMAXSTAT) = -0.0_JPRD
    ENDIF
    ZT_SUM=0.0_JPRD
    ZT_SUM2=0.0_JPRD
    ZT_SUM3=0.0_JPRD
    ZT_SUM4=0.0_JPRD
    ZT_SUM5=0.0_JPRD
    ZT_SUMIO=0.0_JPRD
    ZT_SUMB=0.0_JPRD
    IF( LDETAILED_STATS .AND. JROC <= NPRNT_STATS ) THEN
      WRITE(KULOUT,'(A,I4)') 'TIMING STATISTICS:TASK=',JROC
      IF(LXML_STATS)THEN
        WRITE(IXMLLUN,'(A,I4,A)')'<timing task="',JROC,'">'
      ENDIF
      IF(NPROC_STATS > 1) THEN
        WRITE(KULOUT,'(A,F6.1,A)')'STARTUP COST ',&
         &TIME_START(JROC),' SECONDS'
      ENDIF
      WRITE(KULOUT,'(A)')&
       &' NUM     ROUTINE                                     '//&
       &'CALLS  SUM(s)   AVE(ms)   CPUAVE(ms) VAVE(ms) '//&
       &'STDDEV(ms)  MAX(ms) '//&
       &'SUMB(s) FRAC(%)'
    ENDIF
    DO JNUM=0,JPMAXSTAT
      IF(ICALLSX(JNUM) > 1) THEN
        ICALLS = ICALLSX(JNUM)/2
        ZSUM = TIMESUM(JNUM)
        ZAVE = TIMESUM(JNUM)/ICALLS*1000._JPRD
        ZMAX = TIMEMAX(JNUM)*1000._JPRD
        ZSUMB = TIMESUMB(JNUM)
        ZFRAC = TIMESUM(JNUM)/ZTOTAL*100.0_JPRD
        ZFRACMAX(JNUM)=MAX(ZFRACMAX(JNUM),ZFRAC)
        ZSUMMAX(JNUM)=MAX(ZSUMMAX(JNUM),TIMESUM(JNUM))
        ZSUMTOT(JNUM)=ZSUMTOT(JNUM)+ZSUM
        ZAVEAVE(JNUM)=ZAVEAVE(JNUM)+ZAVE
        ZAVEMAX(JNUM)=MAX(ZAVEMAX(JNUM),ZAVE)
        ZAVETCPU = TTCPUSUM(JNUM)/ICALLS*1000._JPRD
        ZAVEVCPU = TVCPUSUM(JNUM)/ICALLS*1000._JPRD
        IF(ICALLS > 1 ) THEN
          ZSTDDEV = 1000._JPRD*&
           &SQRT(MAX((TIMESQSUM(JNUM)-TIMESUM(JNUM)**2/ICALLS)&
           &/(ICALLS-1),0.0_JPRD))
        ELSE
          ZSTDDEV = 0.0_JPRD
        ENDIF
        IF(CCTYPE(JNUM).EQ.'MPL') THEN
          ZT_SUM=ZT_SUM+ZSUM
          ZT_SUMB=ZT_SUMB+ZSUMB
        ENDIF
        IF(CCTYPE(JNUM).EQ.'BAR' .OR. CCTYPE(JNUM).EQ.'GBR' .OR. CCTYPE(JNUM).EQ.'GB2' ) THEN
          ZT_SUM4=ZT_SUM4+ZSUM
          ZT_SUMB=ZT_SUMB+ZSUMB
        ENDIF
        IF(CCTYPE(JNUM).EQ.'OMP') THEN
          ZT_SUM2=ZT_SUM2+ZSUM
          ZT_SUMB=ZT_SUMB+ZSUMB
        ENDIF
        IF(CCTYPE(JNUM).EQ.'IO-') THEN
          ZT_SUMIO=ZT_SUMIO+ZSUM
          ZT_SUMB=ZT_SUMB+ZSUMB
        ENDIF
        IF(CCTYPE(JNUM).EQ.'SER') THEN
          ZT_SUM3=ZT_SUM3+ZSUM
          ZT_SUMB=ZT_SUMB+ZSUMB
        ENDIF
        IF(CCTYPE(JNUM).EQ.'MXD') THEN
          ZT_SUM5=ZT_SUM5+ZSUM
          ZT_SUMB=ZT_SUMB+ZSUMB
        ENDIF
        IF( LDETAILED_STATS .AND. JROC <= NPRNT_STATS ) THEN
            WRITE(KULOUT,'(I4,1X,A3,1X,A40,1X,I5,6(1X,F9.1),1X,F5.1,1X,F8.2)')&
             &JNUM,CCTYPE(JNUM),CCDESC(JNUM),ICALLS,ZSUM,ZAVE,ZAVETCPU,ZAVEVCPU,&
             &ZSTDDEV,ZMAX,ZSUMB,ZFRAC
            IF(LXML_STATS)THEN
              WRITE(IXMLLUN,&
               & '(A,I4,A,/,A,A40,A,/,A,I5,A,/,6(A,F9.1,A,/),A,F5.1,A,/,A,F8.2,A,/,A)')&
               & '<num id="',JNUM,'">',&
               & '<description>',CCDESC(JNUM),'</description>',&
               & '<sum unit="seconds">',ICALLS,'</sum>',&
               & '<sumcall unit="ms">',ZSUM,'</sumcall>',&
               & '<average unit="ms">',ZAVE,'</average>',&
               & '<cpuaverage unit="ms">',ZAVETCPU,'</cpuaverage>',&
               & '<vave unit="ms">',ZAVEVCPU,'</vave>',&
               & '<stddev unit="ms">',ZSTDDEV,'</stddev>',&
               & '<max unit="ms">',ZMAX,'</max>',&
               & '<sumb unit="seconds">',ZSUMB,'</sumb>',&
               & '<frac unit="percent">',ZFRAC,'</frac>',&
               & '</num>'
             ENDIF
        ENDIF
      ENDIF
    ENDDO
    IF( LDETAILED_STATS .AND. JROC <= NPRNT_STATS ) THEN
      WRITE(KULOUT,*) ''
      WRITE(KULOUT,'((A,2F8.1))')&
       &'CPU-TIME AND VECTOR CPU-TIME AS PERCENT OF TOTAL ',&
       &TTCPUSUM(0)/TIMESUM(0)*100.0_JPRD,TVCPUSUM(0)/TIMESUM(0)*100.0_JPRD
      IF(LXML_STATS)THEN
        WRITE(IXMLLUN,'((A,F8.1,A,/,A,F8.1,A))')&
         &'<cpufraction>',&
         &TTCPUSUM(0)/TIMESUM(0)*100.0_JPRD,&
         &'</cpufraction>',&
         &'<cpuvectorfraction>',&
         &TVCPUSUM(0)/TIMESUM(0)*100.0_JPRD,&
         &'</cpuvectorfraction>'
      ENDIF


      IF(ZT_SUM > 0.0_JPRD) THEN
        WRITE(KULOUT,'(A,F10.1,A,F6.2,A)')'SUMMED TIME IN COMMUNICATIONS   = '&
         & ,ZT_SUM, ' SECONDS ',ZT_SUM/TIMESUM(0)*100.0_JPRD,&
         &' PERCENT OF TOTAL'
        IF(LXML_STATS)THEN
          WRITE(IXMLLUN,'(A,F10.1,A,/,A,F6.2,A)')'<zcom unit="seconds">',&
           &ZT_SUM,'</zcom>',&
           &'<fraczcom unit="percent">',ZT_SUM/TIMESUM(0)*100.0_JPRD,&
           &'</fraczcom>'
        ENDIF
      ENDIF
      IF(ZT_SUM2 > 0.0_JPRD) THEN
        WRITE(KULOUT,'(A,F10.1,A,F6.2,A)')'SUMMED TIME IN PARALLEL REGIONS = '&
         & ,ZT_SUM2, ' SECONDS ',ZT_SUM2/TIMESUM(0)*100.0_JPRD,&
         &' PERCENT OF TOTAL'
        IF(LXML_STATS)THEN
          WRITE(IXMLLUN,'(A,F10.1,A,/,A,F6.2,A)') &
           &'<parallelztime unit="seconds">',&
           &ZT_SUM2, '</parallelztime>',&
           &'<fracparallelztime unit="percent">',ZT_SUM2/TIMESUM(0)*100.0_JPRD,&
           &'</fracparallelztime>'
        ENDIF
      ENDIF
      IF(ZT_SUMIO > 0.0_JPRD) THEN
        WRITE(KULOUT,'(A,F10.1,A,F6.2,A)')'SUMMED TIME IN I/O SECTIONS     = '&
         & ,ZT_SUMIO, ' SECONDS ',ZT_SUMIO/TIMESUM(0)*100.0_JPRD,&
         &' PERCENT OF TOTAL'
        IF(LXML_STATS)THEN
          WRITE(IXMLLUN,'(A,F10.1,A,/,A,F6.2,A)')'<ioztime unit="seconds">',&
           &ZT_SUMIO, '</ioztime>',&
           &'<fracioztime unit="percent">',ZT_SUMIO/TIMESUM(0)*100.0_JPRD,&
           &'</fracioztime>'
        ENDIF
      ENDIF
      IF(ZT_SUM3 > 0.0_JPRD) THEN
        WRITE(KULOUT,'(A,F10.1,A,F6.2,A)')'SUMMED TIME IN SERIAL SECTIONS  = '&
        & ,ZT_SUM3, ' SECONDS ',ZT_SUM3/TIMESUM(0)*100.0_JPRD,&
         &' PERCENT OF TOTAL'
        IF(LXML_STATS)THEN
          WRITE(IXMLLUN,'(A,F10.1,A,/,A,F6.2,A)')'<serialztime unit="seconds">',&
           & ZT_SUM3,'</serialztime>',&
           &'<fracserialztime unit="percent">',&
           &ZT_SUM3/TIMESUM(0)*100.0_JPRD,&
           &'</fracserialztime>'
        ENDIF
      ENDIF
      IF(ZT_SUM4 > 0.0_JPRD) THEN
        WRITE(KULOUT,'(A,F10.1,A,F6.2,A)')'SUMMED TIME IN BARRIERS         = '&
         & ,ZT_SUM4, ' SECONDS ',ZT_SUM4/TIMESUM(0)*100.0_JPRD,&
         &' PERCENT OF TOTAL'
        IF(LXML_STATS)THEN
          WRITE(IXMLLUN,'(A,F10.1,A,/,A,F6.2,A)')&
           &'<barrierztime unit="seconds">',&
           &ZT_SUM4,'</barrierztime>',&
           & '<fracbarrierztime unit="percent">',&
           & ZT_SUM4/TIMESUM(0)*100.0_JPRD,'</fracbarrierztime>'
        ENDIF
      ENDIF
      IF(ZT_SUM5 > 0.0_JPRD) THEN
        WRITE(KULOUT,'(A,F10.1,A,F6.2,A)')'SUMMED TIME IN MIXED SECTIONS   = '&
         & ,ZT_SUM5, ' SECONDS ',ZT_SUM5/TIMESUM(0)*100.0_JPRD,&
         &' PERCENT OF TOTAL'
        WRITE(IXMLLUN,'(A,F10.1,A,/,A,F6.2,A)')&
         &'<mixedztime unit="seconds">',&
         &ZT_SUM5,'</mixedztime>',&
         & '<fracmixedztime unit="percent">',&
         & ZT_SUM5/TIMESUM(0)*100.0_JPRD,'</fracmixedztime>'
      ENDIF
      IF(LSTATS_COMMS.AND.LSTATS_OMP)THEN
        WRITE(KULOUT,'(A,F8.2)')'FRACTION OF TOTAL TIME ACCOUNTED FOR ',&
         & (ZT_SUM+ZT_SUM2+ZT_SUMIO+ZT_SUM3+ZT_SUM4+ZT_SUM5)/TIMESUM(0)*100.0_JPRD
        WRITE(KULOUT,'(A,F8.2)')'FRACTION OF TOTAL TIME ACCOUNTED FOR INCLUDING SUMB ',&
         & (ZT_SUM+ZT_SUM2+ZT_SUMIO+ZT_SUM3+ZT_SUM4+ZT_SUM5+ZT_SUMB)/TIMESUM(0)*100.0_JPRD
        WRITE(KULOUT,'(" ")')
        IF(LXML_STATS)THEN
          WRITE(IXMLLUN,'(A,F8.2,A)')'<fractotal unit="percent">',&
           &(ZT_SUM+ZT_SUM2+ZT_SUMIO+ZT_SUM3+ZT_SUM4+ZT_SUM5)/TIMESUM(0)*100.0_JPRD,&
           &'</fractotal>'
        ENDIF
      ENDIF
    ENDIF
    IF( LDETAILED_STATS .AND. JROC < 3 ) THEN
      IF(LXML_STATS)THEN
        WRITE(IXMLLUN,'(A)')'</timing>'
      ENDIF
    ENDIF
    IF( LSTATS_MPL .AND. JROC <= NPRNT_STATS ) THEN
      WRITE(KULOUT,'(/,A,I4,/)') 'COMMUNICATIONS STATISTICS:TASK=',JROC
      WRITE(KULOUT,'(A)') &
       &' NUM     ROUTINE                              '//&
       &'  SUM(s)   SENDS  AVG(kb) TOTAL(MB) MB/s '//&
       &'  RECVS  AVG(kb) TOTAL(MB) MB/s '

      DO JNUM=501,1000
        IF((NUMSEND(JNUM) /= 0 .OR. NUMRECV(JNUM) /= 0 ) &
           .AND. TIMESUM(JNUM) > 0.0_JPRD) THEN
           SENDRATE=SENDBYTES(JNUM)*1.E-6_JPRD/TIMESUM(JNUM)
           RECVRATE=RECVBYTES(JNUM)*1.E-6_JPRD/TIMESUM(JNUM)
           IF(NUMSEND(JNUM) /= 0) THEN
             AVGSENDLEN=SENDBYTES(JNUM)*1.E-3_JPRD/NUMSEND(JNUM)
           ELSE
             AVGSENDLEN=0.0_JPRD
           ENDIF
           IF(NUMRECV(JNUM) /= 0) THEN
             AVGRECVLEN=RECVBYTES(JNUM)*1.E-3_JPRD/NUMRECV(JNUM)
           ELSE
             AVGSENDLEN=0.0_JPRD
           ENDIF
           IF(NUMRECV(JNUM) /= 0) THEN
             AVGRECVLEN=RECVBYTES(JNUM)*1.E-3_JPRD/NUMRECV(JNUM)
           ELSE
             AVGRECVLEN=0.0_JPRD
           ENDIF
           WRITE(KULOUT,'(I6,1X,A40,f6.1,2(I8,3F8.1))') &
            &  JNUM,CCDESC(JNUM),TIMESUM(JNUM),&
            &  NUMSEND(JNUM),AVGSENDLEN,SENDBYTES(JNUM)*1.E-6_JPRD, SENDRATE, &
            &  NUMRECV(JNUM),AVGRECVLEN,RECVBYTES(JNUM)*1.E-6_JPRD, RECVRATE
        ENDIF
      ENDDO
      WRITE(KULOUT,'(/,A,I4,/)') 'UNKNOWN COMMUNICATIONS STATISTICS:TASK=', JROC
      WRITE(KULOUT,'(A)') &
       &' NUM     BEFORE ROUTINE                        '//&
       &'    SENDS TOTAL(MB) '//&
       &'RECVS TOTAL(MB)  '
      DO JNUM=501,1000
        IF(UNKNOWN_NUMSEND(JNUM) /= 0 .OR. UNKNOWN_NUMRECV(JNUM) /= 0 ) THEN
           WRITE(KULOUT,'(I6,1X,A40,2(I8,F8.1))') &
            &  JNUM,CCDESC(JNUM),&
            &  UNKNOWN_NUMSEND(JNUM),UNKNOWN_SENDBYTES(JNUM)*1.E-6_JPRD, &
            &  UNKNOWN_NUMRECV(JNUM),UNKNOWN_RECVBYTES(JNUM)*1.E-6_JPRD
        ENDIF
      ENDDO
      WRITE(KULOUT,'(7x,"TOTAL",35x,2(I8,F8.1),//)') &
       & SUM(UNKNOWN_NUMSEND(:)),SUM(UNKNOWN_SENDBYTES(:))*1.E-6_JPRD , &
       & SUM(UNKNOWN_NUMRECV(:)),SUM(UNKNOWN_RECVBYTES(:))*1.E-6_JPRD

     ENDIF

     IF(LSTATS_MPL) THEN
      DO JNUM=501,1000
         TOTSENDBYTES(JNUM) = TOTSENDBYTES(JNUM) + SENDBYTES(JNUM)
         TOTRECVBYTES(JNUM) = TOTRECVBYTES(JNUM) + RECVBYTES(JNUM)
         IF(SENDBYTES(JNUM).GT.0.0_JPRD.OR. &
         &  RECVBYTES(JNUM).GT.0.0_JPRD) THEN
           MAXCOMMTIME(JNUM)  = MAX(MAXCOMMTIME(JNUM),TIMESUM(JNUM))
         ENDIF
      ENDDO
     ENDIF

  ENDDO
  IF(LXML_STATS)THEN
    WRITE(IXMLLUN,'(A)')'<timing_all_tasks>'
  ENDIF
  WRITE(KULOUT,*) ''
  WRITE(KULOUT,'(A)') 'STATS FOR ALL TASKS'
  WRITE(KULOUT,'(A)') &
  &' NUM ROUTINE                                     CALLS      MEAN(ms)       MAX(ms)   FRAC(%)  UNBAL(%)'
  ZTOTUNBAL = 0.0_JPRD
  DO JNUM=0,500
    IF(NCALLS(JNUM) > 1) THEN
      ICALLS = NCALLS(JNUM)/2
      ZMEAN = ZAVEAVE(JNUM)/NPROC_STATS
      ZMAX  = ZAVEMAX(JNUM)
      ZMEANT = ZSUMTOT(JNUM)/NPROC_STATS
      ZMAXT  = ZSUMMAX(JNUM)
      IF(ZMEANT .NE. 0._JPRD)THEN
        ZUNBAL= (ZMAXT-ZMEANT)/ZTOTAL*100._JPRD
      ELSE
        ZUNBAL=0._JPRD
      ENDIF
      ZFRAC=ZFRACMAX(JNUM)
      WRITE(KULOUT,'(I4,1X,A40,1X,I8,2(1X,F13.3),2(1X,F9.2))')&
       &JNUM,CCDESC(JNUM),ICALLS,ZMEAN,ZMAX,ZFRAC,ZUNBAL

      IF(LXML_STATS)THEN
        WRITE(IXMLLUN,'(A,I4,A,/,A,A40,A,/,A,I8,A,2(A,F13.3,A,/),2(A,F9.2,A,/),A)')&
         &'<item id="',JNUM,'">',&
         &'<description>',CCDESC(JNUM),'</description>',&
         &'<calls>',ICALLS,'</calls>',&
         &'<mean unit="ms">',ZMEAN,'</mean>',&
         &'<max unit="ms">',ZMAX,'</max>',&
         &'<fraction unit="percent">',ZFRAC,'</fraction>',&
         &'<unbalanced unit="percent">',ZUNBAL,'</unbalanced>','</item>'
      ENDIF
    ENDIF
  ENDDO
  IF(LXML_STATS)THEN
    WRITE(IXMLLUN,'(A)')'</timing_all_tasks>'
  ENDIF

IF(LSTATS_COMMS)THEN
  IF(LXML_STATS)THEN
    WRITE(IXMLLUN,'(A)')'<timing_communications>'
  ENDIF
  WRITE(KULOUT,*) ''
  WRITE(KULOUT,'(A)') 'STATS FOR COMMUNICATIONS'
  WRITE(KULOUT,'(A)')  &
  &' NUM ROUTINE                                     CALLS    MEAN(ms)  MAX(ms)   FRAC(%)  UNBAL(%)'
  ZT_SUM=0._JPRD
  DO JNUM=500,JPMAXSTAT
    IF((CCTYPE(JNUM).EQ."MPL".OR.CCTYPE(JNUM).EQ."BAR".OR.CCTYPE(JNUM).EQ."GBR".OR.CCTYPE(JNUM).EQ."GB2") &
     & .AND.NCALLS(JNUM) > 1) THEN
      ICALLS = NCALLS(JNUM)/2
      ZMEAN = ZAVEAVE(JNUM)/NPROC_STATS
      ZMAX  = ZAVEMAX(JNUM)
      ZMEANT = ZSUMTOT(JNUM)/NPROC_STATS
      ZMAXT  = ZSUMMAX(JNUM)
      IF(ZMEANT .NE. 0._JPRD)THEN
        ZUNBAL= (ZMAXT-ZMEANT)/ZTOTAL*100._JPRD
      ELSE
        ZUNBAL=0._JPRD
      ENDIF
      ZFRAC=ZFRACMAX(JNUM)
      ZTOTUNBAL = ZTOTUNBAL+(ZMAXT-ZMEANT)
      WRITE(KULOUT,'(I4,1X,A40,1X,I8,2(1X,F9.1),2(1X,F9.2))')&
       &JNUM,CCDESC(JNUM),ICALLS,ZMEAN,ZMAX,ZFRAC,ZUNBAL
      IF(LXML_STATS)THEN
        WRITE(IXMLLUN,'(A,I4,A,/,A,A40,A,/,A,I8,A,/,2(A,F9.1,A,/),2(A,F9.2,A,/),A)')&
         &'<comitem id="',JNUM,'">',&
         &'<description>',CCDESC(JNUM),'</description>',&
         &'<calls>',ICALLS,'</calls>',&
         &'<mean unit="ms">',ZMEAN,'</mean>',&
         &'<max unit="ms">',ZMAX,'</max>',&
         &'<fraction unit="percent">',ZFRAC,'</fraction>',&
         &'<unbalanced unit="percent">',ZUNBAL,'</unbalanced>','</comitem>'
      ENDIF

      ZT_SUM=ZT_SUM+ZMEANT
    ENDIF
  ENDDO

  WRITE(KULOUT,*) ''
  WRITE(KULOUT,'(A,F10.1,A)')'SUMMED TIME IN COMMUNICATIONS   = ',ZT_SUM, ' SECONDS '
  IF(LSTATS_MPL) THEN
    WRITE(KULOUT,'(/,A,/)') 'TOTAL COMMUNICATIONS VOLUMES AND BANDWIDTH'
    WRITE(KULOUT,'(A)') &
     &'   NUM   ROUTINE                              '//&
     &'  SUM(s)  SEND(GB)  RECV(GB)    GB/s'
    DO JNUM=501,1000
       IF((TOTSENDBYTES(JNUM).GT.0.0_JPRD.OR.TOTRECVBYTES(JNUM).GT.0.0_JPRD) &
          .AND. MAXCOMMTIME(JNUM) > 0.0_JPRD) THEN
          WRITE(KULOUT,'(I6,1X,A40,f6.1,2F10.1,F8.1)') &
           &  JNUM,CCDESC(JNUM),MAXCOMMTIME(JNUM),&
           &  TOTSENDBYTES(JNUM)*1.E-9_JPRD, &
           &  TOTRECVBYTES(JNUM)*1.E-9_JPRD , &
           &  (TOTSENDBYTES(JNUM)*1.E-9_JPRD)/MAXCOMMTIME(JNUM)
       ENDIF
    ENDDO
    TOTSENDBYTESSUM = SUM(TOTSENDBYTES)
    TOTRECVBYTESSUM = SUM(TOTRECVBYTES)
    IF( TOTSENDBYTESSUM.GT.0.0_JPRD ) THEN
      WRITE(KULOUT,'(/,A,42x,f6.1,2F10.1,F8.1)') &
       &   'TOTAL', &
       &   SUM(MAXCOMMTIME) , &
       &   TOTSENDBYTESSUM*1.E-9_JPRD, &
       &   TOTRECVBYTESSUM*1.E-9_JPRD, &
       &   (TOTSENDBYTESSUM*1.E-9_JPRD)/SUM(MAXCOMMTIME)
     ENDIF
  ENDIF

  IF(LXML_STATS)THEN
    WRITE(IXMLLUN,'(A,F10.1,A)')'<zcom unit="seconds">',ZT_SUM, '</zcom>'
  ENDIF
  WRITE(KULOUT,*) ''
  IF(LXML_STATS)THEN
    WRITE(IXMLLUN,'(A)')'</timing_communications>'
  ENDIF

ENDIF
IF(LSTATS_OMP)THEN
  IF(LXML_STATS)THEN
    WRITE(IXMLLUN,'(A)')'<timing_parallel>'
  ENDIF
  WRITE(KULOUT,*) ''
  WRITE(KULOUT,'(A)') 'STATS FOR PARALLEL REGIONS'
  WRITE(KULOUT,'(A)')  &
  &' NUM ROUTINE                                     CALLS    MEAN(ms)  MAX(ms)   FRAC(%)  UNBAL(%)'
  ZT_SUM=0._JPRD
  DO JNUM=500,JPMAXSTAT
    IF(CCTYPE(JNUM).EQ."OMP".AND.NCALLS(JNUM) > 1) THEN
      ICALLS = NCALLS(JNUM)/2
      ZMEAN = ZAVEAVE(JNUM)/NPROC_STATS
      ZMAX  = ZAVEMAX(JNUM)
      ZMEANT = ZSUMTOT(JNUM)/NPROC_STATS
      ZMAXT  = ZSUMMAX(JNUM)
      IF(ZMEANT .NE. 0._JPRD)THEN
        ZUNBAL= (ZMAXT-ZMEANT)/ZTOTAL*100._JPRD
      ELSE
        ZUNBAL=0._JPRD
      ENDIF
      ZFRAC=ZFRACMAX(JNUM)
      ZTOTUNBAL = ZTOTUNBAL+(ZMAXT-ZMEANT)
      WRITE(KULOUT,'(I4,1X,A40,1X,I8,2(1X,F9.1),2(1X,F9.2))')&
       &JNUM,CCDESC(JNUM),ICALLS,ZMEAN,ZMAX,ZFRAC,ZUNBAL
      IF(LXML_STATS)THEN
        WRITE(IXMLLUN,'(A,I4,A,/,A,A40,A,/,A,I8,A,/,2(A,F9.1,A,/),2(A,F9.2,A,/),A)')&
         &'<parallelitem id="',JNUM,'">',&
         &'<description>',CCDESC(JNUM),'</description>',&
         &'<calls>',ICALLS,'</calls>',&
         &'<mean unit="seconds">',ZMEAN,'</mean>',&
         &'<max unit="seconds">',ZMAX,'</max>',&
         &'<fraction unit="percent">',ZFRAC,'</fraction>',&
         &'<unbalanced unit="percent">',ZUNBAL,'</unbalanced>',&
         &'</parallelitem>'
      ENDIF

      ZT_SUM=ZT_SUM+ZMEANT
    ENDIF
  ENDDO

  WRITE(KULOUT,*) ''
  WRITE(KULOUT,'(A,F10.1,A)')'SUMMED TIME IN PARALLEL REGIONS = ',ZT_SUM, ' SECONDS '
  WRITE(KULOUT,*) ''

  IF(LXML_STATS)THEN
    WRITE(IXMLLUN,'(A,F10.1,A)')'<zpar unit="seconds">',ZT_SUM, '</zpar>'
  ENDIF

  WRITE(KULOUT,*) ''
  WRITE(KULOUT,'(A)') 'STATS FOR I/O REGIONS'
  WRITE(KULOUT,'(A)')  &
  &' NUM ROUTINE                                     CALLS    MEAN(ms)  MAX(ms)   FRAC(%)  UNBAL(%)'
  ZT_SUM=0._JPRD
  DO JNUM=500,JPMAXSTAT
    IF(CCTYPE(JNUM).EQ."IO-".AND.NCALLS(JNUM) > 1) THEN
      ICALLS = NCALLS(JNUM)/2
      ZMEAN = ZAVEAVE(JNUM)/NPROC_STATS
      ZMAX  = ZAVEMAX(JNUM)
      ZMEANT = ZSUMTOT(JNUM)/NPROC_STATS
      ZMAXT  = ZSUMMAX(JNUM)
      IF(ZMEANT .NE. 0._JPRD)THEN
        ZUNBAL= (ZMAXT-ZMEANT)/ZTOTAL*100._JPRD
      ELSE
        ZUNBAL=0._JPRD
      ENDIF
      ZFRAC=ZFRACMAX(JNUM)
      ZTOTUNBAL = ZTOTUNBAL+(ZMAXT-ZMEANT)
      WRITE(KULOUT,'(I4,1X,A40,1X,I8,2(1X,F9.1),2(1X,F9.2))')&
       &JNUM,CCDESC(JNUM),ICALLS,ZMEAN,ZMAX,ZFRAC,ZUNBAL
      IF(LXML_STATS)THEN
        WRITE(IXMLLUN,'(A,I4,A,/,A,A40,A,/,A,I8,A,/,2(A,F9.1,A,/),2(A,F9.2,A,/),A)')&
         &'<para_io_item id="',JNUM,'">',&
         &'<description>',CCDESC(JNUM),'</description>',&
         &'<calls>',ICALLS,'</calls>',&
         &'<mean unit="seconds">',ZMEAN,'</mean>','<max unit="seconds">',&
         & ZMAX,'</max>',&
         &'<fraction unit="percent">',ZFRAC,'</fraction>',&
         &'<unbalanced unit="percent">',ZUNBAL,'</unbalanced>',&
         &'</para_io_item>'
      ENDIF

      ZT_SUM=ZT_SUM+ZMEANT
    ENDIF
  ENDDO

  WRITE(KULOUT,*) ''
  WRITE(KULOUT,'(A,F10.1,A)')'SUMMED TIME IN I/O REGIONS = ',&
       &ZT_SUM, ' SECONDS '
  WRITE(KULOUT,*) ''

  IF(LXML_STATS)THEN
    WRITE(IXMLLUN,'(A,F10.1,A)')'<zio unit="seconds">',ZT_SUM,'</zio>'
  ENDIF

  WRITE(KULOUT,*) ''
  WRITE(KULOUT,'(A)') 'STATS FOR SERIAL(no OMP) REGIONS'
  WRITE(KULOUT,'(A)')  &
  &' NUM ROUTINE                                     CALLS    MEAN(ms)  MAX(ms)   FRAC(%)  UNBAL(%)'
  ZT_SUM=0._JPRD
  DO JNUM=500,JPMAXSTAT
    IF(CCTYPE(JNUM).EQ."SER".AND.NCALLS(JNUM) > 1) THEN
      ICALLS = NCALLS(JNUM)/2
      ZMEAN = ZAVEAVE(JNUM)/NPROC_STATS
      ZMAX  = ZAVEMAX(JNUM)
      ZMEANT = ZSUMTOT(JNUM)/NPROC_STATS
      ZMAXT  = ZSUMMAX(JNUM)
      IF(ZMEANT .NE. 0._JPRD)THEN
        ZUNBAL= (ZMAXT-ZMEANT)/ZTOTAL*100._JPRD
      ELSE
        ZUNBAL=0._JPRD
      ENDIF
      ZFRAC=ZFRACMAX(JNUM)
      ZTOTUNBAL = ZTOTUNBAL+(ZMAXT-ZMEANT)
      WRITE(KULOUT,'(I4,1X,A40,1X,I8,2(1X,F9.1),2(1X,F9.2))')&
       &JNUM,CCDESC(JNUM),ICALLS,ZMEAN,ZMAX,ZFRAC,ZUNBAL
      IF(LXML_STATS)THEN
        WRITE(IXMLLUN,'(A,I4,A,A,A40,A,A,I8,A,2(A,F9.1,A),2(A,F9.2,A,/),A)')&
         &'<serialitem id="',JNUM,'">',&
         &'<description>',CCDESC(JNUM),'</description>',&
         &'<calls>',ICALLS,'</calls>',&
         &'<mean unit="ms">',ZMEAN,'</mean>','<max unit="ms">',ZMAX,'</max>',&
         &'<fraction unit="percent">',ZFRAC,'</fraction>',&
         &'<unbalanced unit="percent">',ZUNBAL,'</unbalanced>','</serialitem>'
      ENDIF

      ZT_SUM=ZT_SUM+ZMEANT
    ENDIF
  ENDDO

  WRITE(KULOUT,*) ''
  WRITE(KULOUT,'(A,F10.1,A)')'SUMMED TIME IN SERIAL REGIONS = ',ZT_SUM, ' SECONDS '
  WRITE(KULOUT,*) ''

  IF(LXML_STATS)THEN
    WRITE(IXMLLUN,'(A,F10.1,A)')'<zserial unit="seconds">',&
     &ZT_SUM, '</zserial>'
  ENDIF

  WRITE(KULOUT,*) ''
  WRITE(KULOUT,'(A)') 'STATS FOR MIXED SECTIONS'
  WRITE(KULOUT,'(A)')  &
  &' NUM ROUTINE                                     CALLS    MEAN(ms)  MAX(ms)   FRAC(%)  UNBAL(%)'
  ZT_SUM=0._JPRD
  DO JNUM=500,JPMAXSTAT
    IF(CCTYPE(JNUM).EQ."MXD".AND.NCALLS(JNUM) > 1) THEN
      ICALLS = NCALLS(JNUM)/2
      ZMEAN = ZAVEAVE(JNUM)/NPROC_STATS
      ZMAX  = ZAVEMAX(JNUM)
      ZMEANT = ZSUMTOT(JNUM)/NPROC_STATS
      ZMAXT  = ZSUMMAX(JNUM)
      IF(ZMEANT .NE. 0._JPRD)THEN
        ZUNBAL= (ZMAXT-ZMEANT)/ZTOTAL*100._JPRD
      ELSE
        ZUNBAL=0._JPRD
      ENDIF
      ZFRAC=ZFRACMAX(JNUM)
      ZTOTUNBAL = ZTOTUNBAL+(ZMAXT-ZMEANT)
      WRITE(KULOUT,'(I4,1X,A40,1X,I8,2(1X,F9.1),2(1X,F9.2))')&
       &JNUM,CCDESC(JNUM),ICALLS,ZMEAN,ZMAX,ZFRAC,ZUNBAL
      IF(LXML_STATS)THEN
        WRITE(IXMLLUN,'(A,I4,A,A,A40,A,A,I8,A,2(A,F9.1,A),2(A,F9.2,A,/),A)')&
         &'<mixeditem id="',JNUM,'">',&
         &'<description>',CCDESC(JNUM),'</description>',&
         &'<calls>',ICALLS,'</calls>',&
         &'<mean unit="ms">',ZMEAN,'</mean>','<max unit="ms">',ZMAX,'</max>',&
         &'<fraction unit="percent">',ZFRAC,'</fraction>',&
         &'<unbalanced unit="percent">',ZUNBAL,'</unbalanced>','</mixeditem>'
      ENDIF

      ZT_SUM=ZT_SUM+ZMEANT
    ENDIF
  ENDDO

  WRITE(KULOUT,*) ''
  WRITE(KULOUT,'(A,F10.1,A)')'SUMMED TIME IN MIXED SECTIONS = ',ZT_SUM, ' SECONDS '
  WRITE(KULOUT,*) ''

  IF(LXML_STATS)THEN
    WRITE(IXMLLUN,'(A,F10.1,A)')'<zmixed unit="seconds">',&
     &ZT_SUM, '</zmixed>'
  ENDIF

  IF(LXML_STATS)THEN
    WRITE(IXMLLUN,'(A)')'</timing_parallel>'
  ENDIF

ENDIF

  WRITE(KULOUT,'(A,F10.1,A,F4.1,A)')&
   &'TOTAL MEASURED IMBALANCE =',ZTOTUNBAL,&
   &' SECONDS, ',ZTOTUNBAL/ZTOTAL*100._JPRD,' PERCENT'
ELSE
  ZTOTAL=TIMESUM(0)
  ZTOTCPU = TTCPUSUM(0)
  ZTOTVCPU = TVCPUSUM(0)
ENDIF

IF ( MYPROC_STATS == 1) THEN
  WRITE(KULOUT,'(3(A,F11.3)/)')'TOTAL WALLCLOCK TIME ',ZTOTAL,&
   &' CPU TIME',ZTOTCPU,' VECTOR TIME ',ZTOTVCPU
  IF(LXML_STATS)THEN
    WRITE(IXMLLUN,'(3(A,F11.3,A,/)/)')'<totalwallclocktime>',ZTOTAL,&
     &'</totalwallclocktime>',&
     &'<cputime>',ZTOTCPU,'</cputime>',&
     & '<vectortime>',ZTOTVCPU,'</vectortime>'
  ENDIF
ENDIF
IF( LDETAILED_STATS )THEN
  ITAG = JPTAGSTAT
  ZDELAY_MAX=0.0_JPRD
  ZMPL(:)=0.0_JPRD
  ZBAR(:)=0.0_JPRD
  ZGBR(:)=0.0_JPRD
  ZGB2(:)=0.0_JPRD
  ZOMP(:)=0.0_JPRD
  ZIO (:)=0.0_JPRD
  ZSER(:)=0.0_JPRD
  ZMXD(:)=0.0_JPRD
  DO JROC=1,NPROC_STATS
    IF( JROC > 1 )THEN
      IF( MYPROC_STATS == JROC )THEN
        ISEND=1
        CALL MPL_SEND(NDELAY_INDEX,KDEST=NPRCIDS_STATS(ISEND), &
         & KTAG=ITAG,CDSTRING='GSTATS_PRINT:')
        IF( NDELAY_INDEX > 0 )THEN
          CALL MPL_SEND(NDELAY_COUNTER(1:NDELAY_INDEX),KDEST=NPRCIDS_STATS(ISEND), &
           & KTAG=ITAG+1,CDSTRING='GSTATS_PRINT:')
          CALL MPL_SEND(TDELAY_VALUE(1:NDELAY_INDEX),KDEST=NPRCIDS_STATS(ISEND), &
           & KTAG=ITAG+2,CDSTRING='GSTATS_PRINT:')
          DO JDELAY=1,NDELAY_INDEX
            CLTEMP((JDELAY-1)*10+1:JDELAY*10)=CDELAY_TIME(JDELAY)
          ENDDO
          CALL MPL_SEND(CLTEMP(1:NDELAY_INDEX*10),KDEST=NPRCIDS_STATS(ISEND), &
           & KTAG=ITAG+3,CDSTRING='GSTATS_PRINT:')
        ENDIF
      ENDIF
      IF( MYPROC_STATS == 1 )THEN
        CALL MPL_RECV(NDELAY_INDEX,KSOURCE=NPRCIDS_STATS(JROC), &
         & KTAG=ITAG,CDSTRING='GSTATS_PRINT:')
        IF( NDELAY_INDEX > 0 )THEN
          CALL MPL_RECV(NDELAY_COUNTER(1:NDELAY_INDEX),KSOURCE=NPRCIDS_STATS(JROC), &
           & KTAG=ITAG+1,CDSTRING='GSTATS_PRINT:')
          CALL MPL_RECV(TDELAY_VALUE(1:NDELAY_INDEX),KSOURCE=NPRCIDS_STATS(JROC), &
           & KTAG=ITAG+2,CDSTRING='GSTATS_PRINT:')
          CALL MPL_RECV(CLTEMP(1:NDELAY_INDEX*10),KSOURCE=NPRCIDS_STATS(JROC), &
            & KTAG=ITAG+3,CDSTRING='GSTATS_PRINT:')
          DO JDELAY=1,NDELAY_INDEX
            CDELAY_TIME(JDELAY)=CLTEMP((JDELAY-1)*10+1:JDELAY*10)
          ENDDO
        ENDIF
      ENDIF
    ENDIF
    IF( MYPROC_STATS == 1 .AND. NDELAY_INDEX > 0 )THEN
      WRITE(KULOUT,'("+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++")')
      WRITE(KULOUT,'("TASK=",I6," NUMBER OF UNEXPECTED DELAYS=",I4)') JROC,NDELAY_INDEX
      IF( NDELAY_INDEX == JPMAXDELAYS )THEN
        WRITE(KULOUT,'(" NOTE THAT THE MAXIMUM NUMBER OF DELAYS HAS BEEN REACHED =",I6)')JPMAXDELAYS
      ENDIF
      ZDELAY=SUM(TDELAY_VALUE(1:NDELAY_INDEX))
      WRITE(KULOUT,'("TOTAL UNEXPECTED DELAY TIME (SECS) =",F9.1)') ZDELAY
      ZDELAY_MAX=MAX(ZDELAY_MAX,ZDELAY)
      DO JDELAY=1,NDELAY_INDEX
        WRITE(KULOUT,'(A,":",A,":",A,1X,I4,1X,A3,1X,A40,1X,F6.1)')&
         &CDELAY_TIME(JDELAY)(1:2),CDELAY_TIME(JDELAY)(3:4),CDELAY_TIME(JDELAY)(5:6),&
         &NDELAY_COUNTER(JDELAY),CCTYPE(NDELAY_COUNTER(JDELAY)),&
         &CCDESC(NDELAY_COUNTER(JDELAY)),TDELAY_VALUE(JDELAY)
         IF( CCTYPE(NDELAY_COUNTER(JDELAY)) .EQ. 'MPL' ) ZMPL(JROC)=ZMPL(JROC)+TDELAY_VALUE(JDELAY)
         IF( CCTYPE(NDELAY_COUNTER(JDELAY)) .EQ. 'BAR' ) ZBAR(JROC)=ZBAR(JROC)+TDELAY_VALUE(JDELAY)
         IF( CCTYPE(NDELAY_COUNTER(JDELAY)) .EQ. 'GBR' ) ZGBR(JROC)=ZGBR(JROC)+TDELAY_VALUE(JDELAY)
         IF( CCTYPE(NDELAY_COUNTER(JDELAY)) .EQ. 'GB2' ) ZGB2(JROC)=ZGB2(JROC)+TDELAY_VALUE(JDELAY)
         IF( CCTYPE(NDELAY_COUNTER(JDELAY)) .EQ. 'OMP' ) ZOMP(JROC)=ZOMP(JROC)+TDELAY_VALUE(JDELAY)
         IF( CCTYPE(NDELAY_COUNTER(JDELAY)) .EQ. 'IO-' ) ZIO (JROC)=ZIO (JROC)+TDELAY_VALUE(JDELAY)
         IF( CCTYPE(NDELAY_COUNTER(JDELAY)) .EQ. 'SER' ) ZSER(JROC)=ZSER(JROC)+TDELAY_VALUE(JDELAY)
         IF( CCTYPE(NDELAY_COUNTER(JDELAY)) .EQ. 'MXD' ) ZMXD(JROC)=ZMXD(JROC)+TDELAY_VALUE(JDELAY)
      ENDDO
      WRITE(KULOUT,'(" ")')
      WRITE(KULOUT,'("TASK=",I6," UNEXPECTED DELAYS SORTED BY COUNTER")') JROC
      DO JNUM=500,JPMAXSTAT
        IDELAY=0
        ZDELAY=0.0_JPRD
        DO JDELAY=1,NDELAY_INDEX
          IF( NDELAY_COUNTER(JDELAY) == JNUM )THEN
            IDELAY=IDELAY+1
            ZDELAY=ZDELAY+TDELAY_VALUE(JDELAY)
          ENDIF
        ENDDO
        IF( IDELAY /= 0 )THEN
          WRITE(KULOUT,'(I4,1X,A3,1X,A40,1X,I4,3X,F6.1)')&
           &JNUM,CCTYPE(JNUM),CCDESC(JNUM),IDELAY,ZDELAY
        ENDIF
      ENDDO
      WRITE(KULOUT,'(" ")')
      WRITE(KULOUT,'(" ")')
    ENDIF
    CALL MPL_BARRIER(CDSTRING='GSTATS_PRINT')
  ENDDO
  IF( MYPROC_STATS == 1 )THEN
    WRITE(KULOUT,'("MAXIMUM TOTAL UNEXPECTED DELAY TIME (SECS) =",F9.1)') ZDELAY_MAX
    WRITE(KULOUT,'(" ")')
    WRITE(KULOUT,'(" ")')
    WRITE(KULOUT,'("  TASK   ","     MPL   ","     BAR   ","     GBR   ","     GB2   ","     OMP   ",&
     &"     IO-   ","     SER   ","     MXD   ")')
    DO JROC=1,NPROC_STATS
      WRITE(KULOUT,'(I6,8(2X,F9.1))') JROC,ZMPL(JROC),ZBAR(JROC),ZGBR(JROC),ZGB2(JROC),&
      &ZOMP(JROC),ZIO (JROC),ZSER(JROC),ZMXD(JROC)
    ENDDO
    WRITE(KULOUT,'(" ")')
    WRITE(KULOUT,'(" ")')
  ENDIF
ENDIF

!   Trace stats

IF (LTRACE_STATS) THEN
  WRITE(KULOUT,'(A)') '=== TRACE OF CALLS TO GSTATS'
  IF (NCALLS_TOTAL > NTRACE_STATS) THEN
    WRITE(KULOUT,'(A,2I10)') ' ONLY PART OF TRACE STORED AS BUFFER TO SMALL ',&
     & NCALLS_TOTAL,NTRACE_STATS
  ENDIF
  WRITE(KULOUT,'(A)') '==='
  CLACTION(0)='ON'
  CLACTION(1)='OFF'
  CLACTION(2)='SUSPEND'
  CLACTION(3)='RESUME'
  DO JCALL=1,MIN(NCALLS_TOTAL,NTRACE_STATS)
    ICALLER = MOD(NCALL_TRACE(JCALL),(JPMAXSTAT+1))
    IACTION   = NCALL_TRACE(JCALL)/(JPMAXSTAT+1)
    IF (IACTION == 0) THEN
      ZTIMELCALL(ICALLER) = TIME_TRACE(JCALL)
      ZTHISTIME(ICALLER) = 0.0_JPRD
    ELSEIF (IACTION == 2) THEN
      ZTHISTIME(ICALLER) = TIME_TRACE(JCALL)-ZTIMELCALL(ICALLER)
    ELSEIF (IACTION == 3) THEN
      ZTIMELCALL(ICALLER) = TIME_TRACE(JCALL)
    ENDIF
    IF (IACTION == 1) THEN
      WRITE(KULOUT,'(1X,F10.3,1X,A,1X,A,1X,F10.3)') &
       &TIME_TRACE(JCALL),CCDESC(ICALLER),CLACTION(IACTION),&
       &ZTHISTIME(ICALLER)+(TIME_TRACE(JCALL)-ZTIMELCALL(ICALLER))
    ELSE
      WRITE(KULOUT,'(1X,F10.3,1X,A,1X,A)') TIME_TRACE(JCALL),CCDESC(ICALLER),&
       & CLACTION(IACTION)
    ENDIF
  ENDDO
ENDIF

IF(LSTATS .AND. MYPROC_STATS == 1) THEN
  PAVEAVE(0:KLEN) = ZAVEAVE(0:KLEN)
ELSE
  PAVEAVE(0:KLEN) = 0.0_JPRD
ENDIF

WRITE(KULOUT,'(/A)')'===-=== END   OF TIMING STATISTICS ===-==='


IF(LSTATS_MEM)THEN
  IF(LXML_STATS)THEN
    WRITE(IXMLLUN,'(A)')'<memory>'
  ENDIF
  WRITE(KULOUT,*) ''
  WRITE(KULOUT,*) 'STATS FOR MEMORY'
  WRITE(KULOUT,*)  &
 &' NUM ROUTINE               CALLS  CALL    MAXINCR   TOTINCR   MININCR'
  WRITE(KULOUT,*)  &
 &'                                   NO      (KB)      (KB)      (KB)'
  DO JNUM=0,JPMAXSTAT
    IF(NCALLS(JNUM) > 1) THEN
      ICALLS = NCALLS(JNUM)/2
      IMEM=NTMEM(JNUM,1)
      INUM=NTMEM(JNUM,3)/2
      JMEM=NTMEM(JNUM,4)
      WRITE(KULOUT,'(I4,1X,A20,1X,I8,1X,I6,3(1X,I9))')&
       &JNUM,CCDESC(JNUM),ICALLS,INUM,IMEM,JMEM,NTMEM(JNUM,5)

      IF(LXML_STATS)THEN
        WRITE(IXMLLUN,'(A,I4,A,/,A,A20,A,/,A,I8,A,/,A,I6,A,/,3(A,I9,A,/))')&
         &'<memitem id="',JNUM,'"/>',&
         &'<description>',CCDESC(JNUM),'</description>',&
         &'<calls>',ICALLS,'</calls>',&
         &'<callnum>',INUM,'</callnum>','<maxincr unit="kb">',IMEM,'</maxincr>',&
         &'<totincr unit="kb">',JMEM,'</totincr>',&
         &'<minincr unit="kb">',NTMEM(JNUM,5),'</minincr>'
      ENDIF
    ENDIF
  ENDDO

  WRITE(KULOUT,*) ''
  WRITE(KULOUT,'(/A)')'===-=== END   OF MEMORY STATISTICS ===-==='
  WRITE(KULOUT,*) ''
  IF(LXML_STATS)THEN
    WRITE(IXMLLUN,'(A)')'</memory>'
  ENDIF
ENDIF
IF(LXML_STATS .AND. MYPROC_STATS==1)THEN
  WRITE(IXMLLUN,'(A)')'</gstats>'
  CLOSE(IXMLLUN)
ENDIF

RETURN
END SUBROUTINE GSTATS_PRINT

! (C) Copyright 2005- ECMWF.
! 
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!

!
! Simple Test program
!
subroutine fail_impl(msg,line)
  character(*) :: msg
  integer :: line
  write(0,'(A,I0,A)') "TEST FAILED in test_bytes_io.F90 @ line ",line," :"
  write(0,*) msg
  stop 1
end subroutine

#define FAIL(msg) call fail_impl(msg,__LINE__)

program bytes_io_test
use EC_PARKIND, only: jpim, jprd
use bytes_io_mod
use yomhook, only: lhook

implicit none

integer(jpim) :: unit, iret, ibuf, nbytes
integer(jpim) :: nbuffer(100)
integer(jpim), allocatable :: nrbuffer(:)
real(jprd) :: zbuffer(50)
real(jprd), allocatable :: zrbuffer(:)
integer(jpim) :: nrsize

integer(jpim), parameter :: sizeof_int  = 4
integer(jpim), parameter :: sizeof_real = 8

! Turn off DRHOOK, to avoid MPI init during testing
lhook = .False.

do ibuf=1,size(nbuffer)
  nbuffer(ibuf)=ibuf
enddo

call bytes_io_open( unit, "testfile_bytes_io", "w", iret )
if( iret < 0 ) FAIL("open for write failed")

call bytes_io_write( unit, size(nbuffer), sizeof_int, iret  )
if( iret < 0 ) FAIL("writing failed")

call bytes_io_write( unit, nbuffer, size(nbuffer)*sizeof_int, iret  )
if( iret < 0 ) FAIL("writing failed")

call bytes_io_close( unit, iret )
if( iret < 0 ) FAIL("close failed")

call bytes_io_open( unit, "testfile_bytes_io", "r", iret)
if( iret < 0 ) FAIL("open for read failed")

call bytes_io_read( unit, nrsize, sizeof_int, iret  )
if( iret < 0 ) FAIL("reading failed")

allocate( nrbuffer(nrsize) )
call bytes_io_read( unit, nrbuffer, nrsize*sizeof_int, iret  )
if( iret < 0 ) FAIL("reading failed")

call bytes_io_close( unit, iret )
if( iret < 0 ) FAIL("close failed")


do ibuf=1,size(nbuffer)
  if( nrbuffer(ibuf) /= nbuffer(ibuf) ) then
    FAIL("rbuffer read not equal to nbuffer written")
  endif
enddo


!=============================


do ibuf=1,size(zbuffer)
  zbuffer(ibuf)=ibuf
enddo

call bytes_io_open( unit, "testfile_bytes_io", "w", iret )
if( iret < 0 ) FAIL("open for write failed")

call bytes_io_write( unit, size(zbuffer), sizeof_int, iret  )
if( iret < 0 ) FAIL("writing failed")

call bytes_io_write( unit, zbuffer, size(zbuffer)*sizeof_real, iret  )
if( iret < 0 ) FAIL("writing failed")

call bytes_io_close( unit, iret )
if( iret < 0 ) FAIL("close failed")

call bytes_io_open( unit, "testfile_bytes_io", "r", iret)
if( iret < 0 ) FAIL("open for read failed")

call bytes_io_read( unit, nrsize, sizeof_int, iret  )
if( iret < 0 ) FAIL("reading failed")

if( nrsize /= size(zbuffer) ) FAIL("size does not match")

allocate( zrbuffer(nrsize) )
call bytes_io_read( unit, zrbuffer, nrsize*sizeof_real, iret  )
if( iret < 0 ) FAIL("reading failed")

call bytes_io_close( unit, iret )
if( iret < 0 ) FAIL("close failed")

do ibuf=1,size(zbuffer)
  if( zrbuffer(ibuf) /= zbuffer(ibuf) ) then
    FAIL("zrbuffer read not equal to zbuffer written")
  endif
enddo

write(0,'(A)') "SUCCESS"
end program

! (C) Copyright 2005- ECMWF.
! (C) Copyright 2013- Meteo-France.
! 
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!

MODULE EC_LUN

USE EC_PARKIND  ,ONLY : JPIM

IMPLICIT NONE

SAVE

PRIVATE :: JPIM

PUBLIC
!     ------------------------------------------------------------------

!*    Logical units used by code

!     NULOUT :   output unit
!     NULERR :   unit number for comparison with reference run

INTEGER(KIND=JPIM) :: NULOUT = 6
INTEGER(KIND=JPIM) :: NULERR = 0

!     ------------------------------------------------------------------
END MODULE EC_LUN

! (C) Copyright 2005- ECMWF.
! (C) Copyright 2013- Meteo-France.
! 
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!

MODULE MPL_SETDFLT_COMM_MOD

!**** MPL_SETDFLT_COMM Set new default communicator

!     Purpose.
!     --------
!     Set new communicator as default, and return old communicator

!**   Interface.
!     ----------
!        CALL MPL_SETDFLT_COMM(KCOMM,KCOMM_OLD)

!        Input required arguments :
!        -------------------------
!           KCOMM    -  New communicator

!        Input optional arguments :
!        -------------------------

!        Output required arguments :
!        -------------------------
!           KCOMM_OLD    -  Old communicator

!        Output optional arguments :
!        -------------------------

!     Author.
!     -------
!        J.Hague        

!     Modifications.
!     --------------
!        Original: 2003-16-07

!     ------------------------------------------------------------------

USE EC_PARKIND  ,ONLY : JPIM
USE OML_MOD   ,ONLY : OML_MY_THREAD

USE MPL_MPIF
USE MPL_DATA_MODULE
USE MPL_MESSAGE_MOD

IMPLICIT NONE

PRIVATE
PUBLIC MPL_SETDFLT_COMM

CONTAINS 


SUBROUTINE MPL_SETDFLT_COMM(KCOMM,KCOMM_OLD)


#ifdef USE_8_BYTE_WORDS
  USE MPI4TO8, ONLY : &
    MPI_COMM_SIZE => MPI_COMM_SIZE8
#endif


INTEGER(KIND=JPIM),INTENT(IN)  :: KCOMM
INTEGER(KIND=JPIM),INTENT(OUT) :: KCOMM_OLD

INTEGER(KIND=JPIM) :: IER
INTEGER(KIND=JPIM) :: ITID
ITID = OML_MY_THREAD()

KCOMM_OLD=MPL_COMM_OML(ITID)
MPL_COMM_OML(ITID)=KCOMM

CALL MPI_COMM_SIZE(KCOMM,MPL_NUMPROC,IER)

RETURN
END SUBROUTINE MPL_SETDFLT_COMM

END MODULE MPL_SETDFLT_COMM_MOD

! (C) Copyright 2005- ECMWF.
! (C) Copyright 2013- Meteo-France.
! 
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!

SUBROUTINE EC_MPI_FINALIZE(KERROR,LDCALLFINITO,LDMEMINFO,CALLER)
USE EC_PARKIND, ONLY : JPIM
USE MPL_MPIF
IMPLICIT NONE
INTEGER(KIND=JPIM), INTENT(OUT) :: KERROR
LOGICAL, INTENT(IN) :: LDCALLFINITO
LOGICAL, INTENT(IN) :: LDMEMINFO
CHARACTER(LEN=*), INTENT(IN) :: CALLER
LOGICAL :: LLINIT, LLFIN, LLNOTMPIWORLD
INTEGER(KIND=JPIM) :: IERR, ICOMM
INTEGER(KIND=JPIM) :: NCOMM_MEMINFO
COMMON /cmn_meminfo/ NCOMM_MEMINFO
#include "ec_meminfo.intfb.h"
#include "dr_hook_end.intfb.h"
KERROR = 0
IF (LDCALLFINITO) THEN !*** common MPI_Finalize()
  CALL MPI_INITIALIZED(LLINIT,IERR)
  IF (LLINIT .AND. IERR == 0) THEN
    CALL MPI_FINALIZED(LLFIN,IERR)
    IF (.NOT.LLFIN .AND. IERR == 0) THEN
      LLNOTMPIWORLD = (NCOMM_MEMINFO /= 0 .and. NCOMM_MEMINFO /= MPI_COMM_WORLD)
      IF (LLNOTMPIWORLD) THEN
        ICOMM = NCOMM_MEMINFO
      ELSE
        ICOMM = MPI_COMM_WORLD
      ENDIF

      IF( LDMEMINFO ) CALL EC_MEMINFO(-1,"ec_mpi_finalize:"//caller,ICOMM,KBARR=1,KIOTASK=-1,KCALL=1)

      CALL DR_HOOK_END() ! Make sure DrHook output is produced before MPI_Finalize (in case it fails)
      CALL MPI_BARRIER(ICOMM,IERR)
      IF (LLNOTMPIWORLD) THEN
        ! CALL MPI_COMM_FREE(NCOMM_MEMINFO,IERR)
        NCOMM_MEMINFO = 0
      ENDIF
      CALL MPI_FINALIZE(KERROR)
    ENDIF
  ENDIF
ENDIF
END SUBROUTINE EC_MPI_FINALIZE

! (C) Copyright 2005- ECMWF.
!
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!

!
! Simple Test program
!
subroutine fail_impl(msg,line)
use mpl_module, only : mpl_abort
character(*) :: msg
integer :: line

write(0,'(A,I0,A)') "TEST FAILED in allgatherv.F90 @ line ",line," :"
write(0,*) msg

call mpl_abort()

end subroutine

#define FAIL(msg) call fail_impl(msg,__LINE__)

subroutine work1(r)
implicit none
integer, intent(out) :: r

real a(100000)
call  random_number(a)
if (any(a < 0.0) ) then
  r =1
else
  r =0
endif
end subroutine work1


program test_mpl_allgatherv
use ec_parkind, only : jpim, jprm, jprd
use mpl_module, only: mpl_init, mpl_end, mpl_rank, linitmpi_via_mpl, mpl_allgatherv, JP_NON_BLOCKING_STANDARD, mpl_wait

implicit none

integer(jpim) :: nprocs
logical :: verbose = .false.

character(len=256) msg

call mpl_init(KPROCS=nprocs,ldinfo=verbose,ldenv=.true.)

if( nprocs <= 1 ) FAIL("nprocs must be > 1")
if( mpl_rank < 1 .or. mpl_rank > nprocs  ) FAIL("mpl_rank must be >= 1 and <= nprocs")
if( .not. linitmpi_via_mpl ) FAIL("linitmpi_via_mpl must be True")

call do_allgatherv("blocking")

call do_allgatherv("nonblocking")

call mpl_end(ldmeminfo=verbose)
! Note that with mpi_serial meminfo will not be printed regardless of ldmeminfo

contains

subroutine do_allgatherv(mode)
use ec_parkind, only : jpim, jprm, jprd
implicit none
character(len=*), intent(in) :: mode

integer(jpim), allocatable :: sbuf(:), rbuf(:), rcounts(:)
integer(jpim) :: scounts
real(jprm), allocatable :: sbufr(:), rbufr(:)
real(jprd), allocatable :: sbufd(:), rbufd(:)
character(len=256) :: msg

integer request_i, request_r, request_d, i, j, k, res
integer rdispl(nprocs)


allocate(sbuf(mpl_rank),rbuf((nprocs*(nprocs+1))/2+nprocs),&
  sbufr(mpl_rank),rbufr((nprocs*(nprocs+1))/2+nprocs), &
  sbufd(mpl_rank),rbufd((nprocs*(nprocs+1))/2+nprocs),&
  rcounts(nprocs))


sbuf    = mpl_rank
sbufr   = mpl_rank
sbufd   = mpl_rank
scounts = mpl_rank
rcounts = [ (i, i=1,nprocs) ]

select case(mode)
 case("blocking")
  call mpl_allgatherv(sbuf,rbuf,rcounts)
  call mpl_allgatherv(sbufr,rbufr,rcounts)
  call mpl_allgatherv(sbufd,rbufd,rcounts)
 case("nonblocking")
  ! trying to get a random failure
  do j=1,1
    call mpl_allgatherv(sbuf,rbuf,rcounts, KMP_TYPE = JP_NON_BLOCKING_STANDARD, KREQUEST=request_i)
    call mpl_allgatherv(sbufr,rbufr,rcounts, KMP_TYPE = JP_NON_BLOCKING_STANDARD, KREQUEST=request_r)
    call mpl_allgatherv(sbufd,rbufd,rcounts, KMP_TYPE = JP_NON_BLOCKING_STANDARD, KREQUEST=request_d)
    call work1(res)
    if ( res > 0 ) write(0,*) "error in work1 non-blocking alltoallv" ! this should not happen ever !!!
    call mpl_wait(request_r)
    call mpl_wait(request_d)
    call mpl_wait(request_i)
  enddo
end select
 ! test values
k=1
do i=1,nprocs
  if ( any(rbuf(k:k+i-1) /= i) ) then
    !write(0,*) 'send ', mpl_rank, scounts, sbuf
    !write(0,*) 'recv ', mpl_rank, rcounts, rdispl
    write(msg,*) trim(mode)//" int allgatherv test test failed on mpl_rank", mpl_rank, rbuf
    FAIL(msg)
  endif
  if ( any(nint(rbufr(k:k+i-1)) /= i) ) then
    write(msg,*) trim(mode)//" real allgatherv test test failed on mpl_rank", mpl_rank, rbufr
    FAIL(msg)
  endif
  if ( any(nint(rbufd(k:k+i-1)) /= i) ) then
    write(msg,*) trim(mode)//" double allgatherv test test failed on mpl_rank", mpl_rank, rbufd
    FAIL(msg)
  endif
  k=k+i
enddo

 ! test with displacement arguments
 ! leaving a space of 1 between each block
rdispl(1)=1
do i=2,nprocs
  rdispl(i)=rdispl(i-1)+(i-1)+1
enddo
select case(mode)
 case("blocking")
  call mpl_allgatherv(sbuf,rbuf,rcounts, KRECVDISPL=rdispl)
  call mpl_allgatherv(sbufr,rbufr,rcounts, KRECVDISPL=rdispl)
  call mpl_allgatherv(sbufd,rbufd,rcounts, KRECVDISPL=rdispl)
 case("nonblocking")
  ! trying to get a random failure
  do j=1,1
    call mpl_allgatherv(sbuf,rbuf,rcounts,KRECVDISPL=rdispl, KMP_TYPE = JP_NON_BLOCKING_STANDARD, KREQUEST=request_i)
    call mpl_allgatherv(sbufr,rbufr,rcounts,KRECVDISPL=rdispl, KMP_TYPE = JP_NON_BLOCKING_STANDARD, KREQUEST=request_r)
    call mpl_allgatherv(sbufd,rbufd,rcounts,KRECVDISPL=rdispl, KMP_TYPE = JP_NON_BLOCKING_STANDARD, KREQUEST=request_d)
    call work1(res)
    if ( res > 0 ) write(0,*) "error in work1 non-blocking alltoallv" ! this should not happen ever !!!
    call mpl_wait(request_r)
    call mpl_wait(request_d)
    call mpl_wait(request_i)
  enddo
end select
 ! test values
k=2
do i=1,nprocs
  if ( any(rbuf(k:k+i-1) /= i) ) then
    !write(0,*) 'send ', mpl_rank, scounts, sbuf
    !write(0,*) 'recv ', mpl_rank, rcounts, rdispl
    write(msg,*) trim(mode)//" int allgatherv test failed on mpl_rank", mpl_rank, rbuf
    FAIL(msg)
  endif
  if ( any(nint(rbufr(k:k+i-1)) /= i) ) then
    write(msg,*) trim(mode)//" real allgatherv test failed on mpl_rank", mpl_rank, rbufr
    FAIL(msg)
  endif
  if ( any(nint(rbufd(k:k+i-1)) /= i) ) then
    write(msg,*) trim(mode)//" double allgatherv test failed on mpl_rank", mpl_rank, rbufd
    FAIL(msg)
  endif
  k=k+i+1
enddo

 ! test for int_scalar
do i=1,nprocs
  rcounts(i) = mod(i+1,2)
enddo
select case(mode)
 case("blocking")
  call mpl_allgatherv(mpl_rank,rbuf(1:nprocs)) ! the simplest no correctness test just interface functionality
  call mpl_allgatherv(mpl_rank,rbuf,rcounts,ksendcount=mod(mpl_rank+1,2))
 case("nonblocking")
  call mpl_allgatherv(mpl_rank,rbuf,rcounts,ksendcount=mod(mpl_rank+1,2), &
    KMP_TYPE = JP_NON_BLOCKING_STANDARD, KREQUEST=request_i)
  call mpl_wait(request_i)
end select
do i=1,nprocs/2
  if ( rbuf(i) /= 2*i) then
    write(msg,*) trim(mode)//" int_scalar allgatherv test failed on mpl_rank", mpl_rank, rbuf
    FAIL(msg)
  endif
enddo

end subroutine do_allgatherv

end program test_mpl_allgatherv

! (C) Copyright 2026- ECMWF.
!
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
!
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.

program drhook_no_hw_fpe_Apple_Silicon_SIGILL

  use yomhook, only : jphook, dr_hook

  implicit none

  real(jphook) :: zhook_handle

  interface
    subroutine raise_sigill() bind(C, name="raise_sigill")
    end subroutine
  end interface

  call dr_hook('drhook_no_hw_fpe_Apple_Silicon_SIGILL', 0, zhook_handle)

  ! Ensure that DrHook still processes legitamate SIGILLs, as signal_drhook()
  ! converts SIGFPEs posing as SIGILLs to SIGFPEs.
  ! https://developer.apple.com/forums/thread/689159?answerId=733736022
  call raise_sigill()

  call dr_hook('drhook_no_hw_fpe_Apple_Silicon_SIGILL', 1, zhook_handle)

end program drhook_no_hw_fpe_Apple_Silicon_SIGILL

! (C) Copyright 2025- ECMWF.
!
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!

MODULE BYTESWAP_MOD

!**** Module for byteswapping buffers

!     Purpose.
!     --------
!     Fortran 90 Interface to calling byteswap

!     Author.
!     -------
!        W.Deconinck     ECMWF

!     Modifications.
!     --------------
!        Original: 2025-01-30

!     ------------------------------------------------------------------

IMPLICIT NONE
PRIVATE

PUBLIC :: convert_to_big_endian, is_little_endian, byteswap

! ISO-C-BINDING C-interfaces
INTERFACE

    ! void iswap_ (char * a, const char * b, const int * _t, const int * _n);
    subroutine iswap_bind( &
      & ptr_out, &
      & ptr_in,  &
      & size_of_type_in_bytes, &
      & length) &
      & bind(c, name="iswap_")
      use, intrinsic :: iso_c_binding
      type(c_ptr), value, intent(in)    :: ptr_out
      type(c_ptr), value, intent(in)    :: ptr_in
      integer(c_int), intent(in)        :: size_of_type_in_bytes
      integer(c_int), intent(in)        :: length
    end subroutine

    ! void jswap_ (char * a, const char * b, const int * _t, const int * _n);
    subroutine jswap_bind( &
      & ptr_out, &
      & ptr_in,  &
      & size_of_type_in_bytes, &
      & length) &
      & bind(c, name="jswap_")
      use, intrinsic :: iso_c_binding
      type(c_ptr), value, intent(in)    :: ptr_out
      type(c_ptr), value, intent(in)    :: ptr_in
      integer(c_int), intent(in)        :: size_of_type_in_bytes
      integer(c_int), intent(in)        :: length
    end subroutine


    ! void iswap_isle_ (int * reqd);
    subroutine iswap_isle_bind(value) bind(c,name="iswap_isle_")
      use, intrinsic :: iso_c_binding, only : c_int
      integer(c_int), intent(out) :: value
    end subroutine

END INTERFACE

INTERFACE convert_to_big_endian
  MODULE PROCEDURE convert_to_big_endian_int32_r1
  MODULE PROCEDURE convert_to_big_endian_int64_r1
  MODULE PROCEDURE convert_to_big_endian_real32_r1
  MODULE PROCEDURE convert_to_big_endian_real64_r1
END INTERFACE

INTERFACE byteswap
  MODULE PROCEDURE byteswap_int32_r1
  MODULE PROCEDURE byteswap_int64_r1
  MODULE PROCEDURE byteswap_real32_r1
  MODULE PROCEDURE byteswap_real64_r1
END INTERFACE

CONTAINS

function is_little_endian()
  use, intrinsic :: iso_c_binding, only : c_int
  logical :: is_little_endian
  integer(c_int) :: isle
  call iswap_isle_bind(isle)
  if (isle == 0) then
    is_little_endian = .false.
  else
    is_little_endian = .true.
  endif
end function

subroutine convert_to_big_endian_int32_r1( array_out, array_in )
  use, intrinsic :: iso_c_binding, only : c_ptr, c_loc, c_sizeof, c_int
  integer(c_int), target, intent(inout) :: array_out(:)
  integer(c_int), target, intent(in)    :: array_in(:)
  call iswap_bind(c_loc(array_out(1)), c_loc(array_in(1)), int(c_sizeof(array_in(1)),c_int), size(array_in))
end subroutine

subroutine convert_to_big_endian_int64_r1( array_out, array_in )
  use, intrinsic :: iso_c_binding, only : c_ptr, c_loc, c_sizeof, c_int, c_long
  integer(c_long), target, intent(inout) :: array_out(:)
  integer(c_long), target, intent(in)    :: array_in(:)
  call iswap_bind(c_loc(array_out(1)), c_loc(array_in(1)), int(c_sizeof(array_in(1)),c_int), size(array_in))
end subroutine

subroutine convert_to_big_endian_real32_r1( array_out, array_in )
  use, intrinsic :: iso_c_binding, only : c_ptr, c_loc, c_sizeof, c_int, c_float
  real(c_float), target, intent(inout) :: array_out(:)
  real(c_float), target, intent(in)    :: array_in(:)
  call iswap_bind(c_loc(array_out(1)), c_loc(array_in(1)), int(c_sizeof(array_in(1)),c_int), size(array_in))
end subroutine

subroutine convert_to_big_endian_real64_r1( array_out, array_in )
  use, intrinsic :: iso_c_binding, only : c_ptr, c_loc, c_sizeof, c_int, c_double
  real(c_double), target, intent(inout) :: array_out(:)
  real(c_double), target, intent(in)    :: array_in(:)
  call iswap_bind(c_loc(array_out(1)), c_loc(array_in(1)), int(c_sizeof(array_in(1)),c_int), size(array_in))
end subroutine

subroutine byteswap_int32_r1( array_out, array_in )
  use, intrinsic :: iso_c_binding, only : c_ptr, c_loc, c_sizeof, c_int
  integer(c_int), target, intent(inout) :: array_out(:)
  integer(c_int), target, intent(in)    :: array_in(:)
  call jswap_bind(c_loc(array_out(1)), c_loc(array_in(1)), int(c_sizeof(array_in(1)),c_int), size(array_in))
end subroutine

subroutine byteswap_int64_r1( array_out, array_in )
  use, intrinsic :: iso_c_binding, only : c_ptr, c_loc, c_sizeof, c_int, c_long
  integer(c_long), target, intent(inout) :: array_out(:)
  integer(c_long), target, intent(in)    :: array_in(:)
  call jswap_bind(c_loc(array_out(1)), c_loc(array_in(1)), int(c_sizeof(array_in(1)),c_int), size(array_in))
end subroutine

subroutine byteswap_real32_r1( array_out, array_in )
  use, intrinsic :: iso_c_binding, only : c_ptr, c_loc, c_sizeof, c_int, c_float
  real(c_float), target, intent(inout) :: array_out(:)
  real(c_float), target, intent(in)    :: array_in(:)
  call jswap_bind(c_loc(array_out(1)), c_loc(array_in(1)), int(c_sizeof(array_in(1)),c_int), size(array_in))
end subroutine

subroutine byteswap_real64_r1( array_out, array_in )
  use, intrinsic :: iso_c_binding, only : c_ptr, c_loc, c_sizeof, c_int, c_double
  real(c_double), target, intent(inout) :: array_out(:)
  real(c_double), target, intent(in)    :: array_in(:)
  call jswap_bind(c_loc(array_out(1)), c_loc(array_in(1)), int(c_sizeof(array_in(1)),c_int), size(array_in))
end subroutine



END MODULE

! (C) Copyright 2025- ECMWF.
!
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!

module ec_checksum_mod

!**** Checksum of arrays
!
!     Purpose.
!     --------
!     Take the checksum of an array printed as 4-char string
!
!     An example Fortran programs:
!
!         program main
!             use ec_checksum_mod, only: fletcher16, fletcher16_hex
!             write(0,*) fletcher16(array(:,:))     ! as integer
!             write(0,*) fletcher16_hex(array(:,:)) ! as hex-string
!         end program
!
!     Multiple arrays can be checksummed together to a single hash:
!
!         program main
!             use ec_checksum_mod, only: fletcher16_type
!             type(fletcher16_type) :: checksum
!             call checksum%update(array1(:,:))
!             call checksum%update(array2(:,:,:))
!             write(0,*) checksum%digest_hex()
!         end program
!
!     Author.
!     -------
!        W.Deconinck, ECMWF
!
!     Modifications.
!     --------------
!        Original: 2025-07-04
!
!     ------------------------------------------------------------------
use, intrinsic :: iso_c_binding, only : c_ptr, c_size_t, c_int32_t, c_int16_t, c_char
implicit none

private
public :: fletcher16_type, fletcher16, fletcher16_hex

#define fletcher16_digest_t c_int16_t

! Workaround an internal compiler error in function digest() for NVHPC <= 22 and Classic Flang (PGI-based)
#if defined(__NVCOMPILER)
#if __NVCOMPILER_MAJOR__ <= 22
#undef  fletcher16_digest_t
#define fletcher16_digest_t c_int32_t
#endif
#elif defined(__FLANG)
! Classic Flang (PGI-based), includes also AOCC/4.0. Note, LLVM Flang defines __flang__ and __llvm__ instead.
#undef  fletcher16_digest_t
#define fletcher16_digest_t c_int32_t
#endif

type :: fletcher16_type
  integer(c_int32_t) :: handle = 0
contains
  procedure, public  :: reset => fletcher16_reset
  procedure, private :: update_real32_r1 => fletcher16_update_real32_r1
  procedure, private :: update_real32_r2 => fletcher16_update_real32_r2
  procedure, private :: update_real32_r3 => fletcher16_update_real32_r3
  procedure, private :: update_real32_r4 => fletcher16_update_real32_r4
  procedure, private :: update_real32_r5 => fletcher16_update_real32_r5
  procedure, private :: update_real64_r1 => fletcher16_update_real64_r1
  procedure, private :: update_real64_r2 => fletcher16_update_real64_r2
  procedure, private :: update_real64_r3 => fletcher16_update_real64_r3
  procedure, private :: update_real64_r4 => fletcher16_update_real64_r4
  procedure, private :: update_real64_r5 => fletcher16_update_real64_r5
  procedure, private :: update_int32_r1  => fletcher16_update_int32_r1
  procedure, private :: update_int32_r2  => fletcher16_update_int32_r2
  procedure, private :: update_int32_r3  => fletcher16_update_int32_r3
  procedure, private :: update_int32_r4  => fletcher16_update_int32_r4
  procedure, private :: update_int32_r5  => fletcher16_update_int32_r5
  procedure, private :: update_int64_r1  => fletcher16_update_int64_r1
  procedure, private :: update_int64_r2  => fletcher16_update_int64_r2
  procedure, private :: update_int64_r3  => fletcher16_update_int64_r3
  procedure, private :: update_int64_r4  => fletcher16_update_int64_r4
  procedure, private :: update_int64_r5  => fletcher16_update_int64_r5
  generic, public :: update => &
    & update_real32_r1, update_real32_r2, update_real32_r3, update_real32_r4, update_real32_r5, &
    & update_real64_r1, update_real64_r2, update_real64_r3, update_real64_r4, update_real64_r5, &
    & update_int32_r1,  update_int32_r2,  update_int32_r3,  update_int32_r4,  update_int32_r5,  &
    & update_int64_r1,  update_int64_r2,  update_int64_r3,  update_int64_r4,  update_int64_r5

  procedure, public :: digest     => fletcher16__digest
  procedure, public :: digest_hex => fletcher16__digest_hex
end type

interface
    subroutine c_fletcher16_reset(checksum) bind(C,name="ec_checksum_fletcher16_reset")
      use, intrinsic :: iso_c_binding, only : c_int32_t
      integer(c_int32_t), intent(inout) :: checksum
    end subroutine

    subroutine c_ec_checksum_fletcher16_update(checksum, data, size) bind(C,name="ec_checksum_fletcher16_update")
      use, intrinsic :: iso_c_binding, only : c_ptr, c_size_t, c_int32_t
      integer(c_int32_t), intent(inout) :: checksum
      type(c_ptr), value, intent(in) :: data
      integer(c_size_t), value, intent(in) :: size
    end subroutine

    function c_ec_checksum_fletcher16_digest(checksum) bind(C,name="ec_checksum_fletcher16_digest") result(digest)
      use, intrinsic :: iso_c_binding, only : c_int32_t, c_int16_t
      integer(c_int16_t) :: digest
      integer(c_int32_t), intent(in) :: checksum
    end function
end interface

interface fletcher16
module procedure fletcher16_real32_r1
module procedure fletcher16_real32_r2
module procedure fletcher16_real32_r3
module procedure fletcher16_real32_r4
module procedure fletcher16_real32_r5
module procedure fletcher16_real64_r1
module procedure fletcher16_real64_r2
module procedure fletcher16_real64_r3
module procedure fletcher16_real64_r4
module procedure fletcher16_real64_r5
module procedure fletcher16_int32_r1
module procedure fletcher16_int32_r2
module procedure fletcher16_int32_r3
module procedure fletcher16_int32_r4
module procedure fletcher16_int32_r5
module procedure fletcher16_int64_r1
module procedure fletcher16_int64_r2
module procedure fletcher16_int64_r3
module procedure fletcher16_int64_r4
module procedure fletcher16_int64_r5
end interface

interface fletcher16_hex
module procedure fletcher16_hex_real32_r1
module procedure fletcher16_hex_real32_r2
module procedure fletcher16_hex_real32_r3
module procedure fletcher16_hex_real32_r4
module procedure fletcher16_hex_real32_r5
module procedure fletcher16_hex_real64_r1
module procedure fletcher16_hex_real64_r2
module procedure fletcher16_hex_real64_r3
module procedure fletcher16_hex_real64_r4
module procedure fletcher16_hex_real64_r5
module procedure fletcher16_hex_int32_r1
module procedure fletcher16_hex_int32_r2
module procedure fletcher16_hex_int32_r3
module procedure fletcher16_hex_int32_r4
module procedure fletcher16_hex_int32_r5
module procedure fletcher16_hex_int64_r1
module procedure fletcher16_hex_int64_r2
module procedure fletcher16_hex_int64_r3
module procedure fletcher16_hex_int64_r4
module procedure fletcher16_hex_int64_r5
end interface

interface to_hex
module procedure to_hex_16
module procedure to_hex_32
module procedure to_hex_64
end interface

contains

subroutine to_lower_inplace(string)
  character(len=*), intent(inout) :: string
  integer :: i
  do i = 1, len(string)
    string(i:i) = char_to_lower(string(i:i))
  end do
contains
  pure function char_to_lower(c) result(t)
    character(len=1), intent(in) :: c !! A character.
    character(len=1)             :: t
    integer, parameter :: wp= iachar('a')-iachar('A'), BA=iachar('A'), BZ=iachar('Z')
    integer :: k
    ! Check whether the integer equivalent is between BA=65 and BZ=90
    k = ichar(c)
    if (k>=BA.and.k<=BZ) k = k + wp
    t = char(k)
  end function
end subroutine

function to_hex_16(value) result(hex)
  use, intrinsic :: iso_c_binding, only : c_int16_t
  character(len=4) :: hex
  integer(c_int16_t), intent(in) :: value
  write(hex,'(z4.4)') value
  call to_lower_inplace(hex)
end function

function to_hex_32(value) result(hex)
  use, intrinsic :: iso_c_binding, only : c_int32_t
  character(len=8) :: hex
  integer(c_int32_t), intent(in) :: value
  write(hex,'(z8.8)') value
  call to_lower_inplace(hex)
end function

function to_hex_64(value) result(hex)
  use, intrinsic :: iso_c_binding, only : c_int64_t
  character(len=16) :: hex
  integer(c_int64_t), intent(in) :: value
  write(hex,'(z16.16)') value
  call to_lower_inplace(hex)
end function

subroutine fletcher16_reset(this)
  class(fletcher16_type), intent(inout) :: this
  this%handle = 0
end subroutine

subroutine fletcher16_update_real32_r1(this, array)
  use, intrinsic :: iso_c_binding, only : c_ptr, c_size_t, c_loc, c_sizeof, c_float
  class(fletcher16_type), intent(inout) :: this
  real(c_float), contiguous, target, intent(in) :: array(:)
  integer(c_size_t) :: array_size
  array_size = size(array,kind=c_size_t)
  if (array_size > 0) then
    call c_ec_checksum_fletcher16_update(this%handle, c_loc(array(1)), c_sizeof(array(1)) * array_size)
  endif
end subroutine

subroutine fletcher16_update_real32_r2(this, array)
  use, intrinsic :: iso_c_binding, only : c_ptr, c_size_t, c_loc, c_sizeof, c_float
  class(fletcher16_type), intent(inout) :: this
  real(c_float), contiguous, target, intent(in) :: array(:,:)
  integer(c_size_t) :: array_size
  array_size = size(array,kind=c_size_t)
  if (array_size > 0) then
    call c_ec_checksum_fletcher16_update(this%handle, c_loc(array(1,1)), c_sizeof(array(1,1)) * array_size)
  endif
end subroutine

subroutine fletcher16_update_real32_r3(this, array)
  use, intrinsic :: iso_c_binding, only : c_ptr, c_size_t, c_loc, c_sizeof, c_float
  class(fletcher16_type), intent(inout) :: this
  real(c_float), contiguous, target, intent(in) :: array(:,:,:)
  integer(c_size_t) :: array_size
  array_size = size(array,kind=c_size_t)
  if (array_size > 0) then
    call c_ec_checksum_fletcher16_update(this%handle, c_loc(array(1,1,1)), c_sizeof(array(1,1,1)) * array_size)
  endif
end subroutine

subroutine fletcher16_update_real32_r4(this, array)
  use, intrinsic :: iso_c_binding, only : c_ptr, c_size_t, c_loc, c_sizeof, c_float
  class(fletcher16_type), intent(inout) :: this
  real(c_float), contiguous, target, intent(in) :: array(:,:,:,:)
  integer(c_size_t) :: array_size
  array_size = size(array,kind=c_size_t)
  if (array_size > 0) then
    call c_ec_checksum_fletcher16_update(this%handle, c_loc(array(1,1,1,1)), c_sizeof(array(1,1,1,1)) * array_size)
  endif
end subroutine

subroutine fletcher16_update_real32_r5(this, array)
  use, intrinsic :: iso_c_binding, only : c_ptr, c_size_t, c_loc, c_sizeof, c_float
  class(fletcher16_type), intent(inout) :: this
  real(c_float), contiguous, target, intent(in) :: array(:,:,:,:,:)
  integer(c_size_t) :: array_size
  array_size = size(array,kind=c_size_t)
  if (array_size > 0) then
    call c_ec_checksum_fletcher16_update(this%handle, c_loc(array(1,1,1,1,1)), c_sizeof(array(1,1,1,1,1)) * array_size)
  endif
end subroutine

subroutine fletcher16_update_real64_r1(this, array)
  use, intrinsic :: iso_c_binding, only : c_ptr, c_size_t, c_loc, c_sizeof, c_double
  class(fletcher16_type), intent(inout) :: this
  real(c_double), contiguous, target, intent(in) :: array(:)
  integer(c_size_t) :: array_size
  array_size = size(array,kind=c_size_t)
  if (array_size > 0) then
    call c_ec_checksum_fletcher16_update(this%handle, c_loc(array(1)), c_sizeof(array(1)) * array_size)
  endif
end subroutine

subroutine fletcher16_update_real64_r2(this, array)
  use, intrinsic :: iso_c_binding, only : c_ptr, c_size_t, c_loc, c_sizeof, c_double
  class(fletcher16_type), intent(inout) :: this
  real(c_double), contiguous, target, intent(in) :: array(:,:)
  integer(c_size_t) :: array_size
  array_size = size(array,kind=c_size_t)
  if (array_size > 0) then
    call c_ec_checksum_fletcher16_update(this%handle, c_loc(array(1,1)), c_sizeof(array(1,1)) * array_size)
  endif
end subroutine

subroutine fletcher16_update_real64_r3(this, array)
  use, intrinsic :: iso_c_binding, only : c_ptr, c_size_t, c_loc, c_sizeof, c_double
  class(fletcher16_type), intent(inout) :: this
  real(c_double), contiguous, target, intent(in) :: array(:,:,:)
  integer(c_size_t) :: array_size
  array_size = size(array,kind=c_size_t)
  if (array_size > 0) then
    call c_ec_checksum_fletcher16_update(this%handle, c_loc(array(1,1,1)), c_sizeof(array(1,1,1)) * array_size)
  endif
end subroutine

subroutine fletcher16_update_real64_r4(this, array)
  use, intrinsic :: iso_c_binding, only : c_ptr, c_size_t, c_loc, c_sizeof, c_double
  class(fletcher16_type), intent(inout) :: this
  real(c_double), contiguous, target, intent(in) :: array(:,:,:,:)
  integer(c_size_t) :: array_size
  array_size = size(array,kind=c_size_t)
  if (array_size > 0) then
    call c_ec_checksum_fletcher16_update(this%handle, c_loc(array(1,1,1,1)), c_sizeof(array(1,1,1,1)) * array_size)
  endif
end subroutine

subroutine fletcher16_update_real64_r5(this, array)
  use, intrinsic :: iso_c_binding, only : c_ptr, c_size_t, c_loc, c_sizeof, c_double
  class(fletcher16_type), intent(inout) :: this
  real(c_double), contiguous, target, intent(in) :: array(:,:,:,:,:)
  integer(c_size_t) :: array_size
  array_size = size(array,kind=c_size_t)
  if (array_size > 0) then
    call c_ec_checksum_fletcher16_update(this%handle, c_loc(array(1,1,1,1,1)), c_sizeof(array(1,1,1,1,1)) * array_size)
  endif
end subroutine

subroutine fletcher16_update_int32_r1(this, array)
  use, intrinsic :: iso_c_binding, only : c_ptr, c_size_t, c_loc, c_sizeof, c_int32_t
  class(fletcher16_type), intent(inout) :: this
  integer(c_int32_t), contiguous, target, intent(in) :: array(:)
  integer(c_size_t) :: array_size
  array_size = size(array,kind=c_size_t)
  if (array_size > 0) then
    call c_ec_checksum_fletcher16_update(this%handle, c_loc(array(1)), c_sizeof(array(1)) * array_size)
  endif
end subroutine

subroutine fletcher16_update_int32_r2(this, array)
  use, intrinsic :: iso_c_binding, only : c_ptr, c_size_t, c_loc, c_sizeof, c_int32_t
  class(fletcher16_type), intent(inout) :: this
  integer(c_int32_t), contiguous, target, intent(in) :: array(:,:)
  integer(c_size_t) :: array_size
  array_size = size(array,kind=c_size_t)
  if (array_size > 0) then
    call c_ec_checksum_fletcher16_update(this%handle, c_loc(array(1,1)), c_sizeof(array(1,1)) * array_size)
  endif
end subroutine

subroutine fletcher16_update_int32_r3(this, array)
  use, intrinsic :: iso_c_binding, only : c_ptr, c_size_t, c_loc, c_sizeof, c_int32_t
  class(fletcher16_type), intent(inout) :: this
  integer(c_int32_t), contiguous, target, intent(in) :: array(:,:,:)
  integer(c_size_t) :: array_size
  array_size = size(array,kind=c_size_t)
  if (array_size > 0) then
    call c_ec_checksum_fletcher16_update(this%handle, c_loc(array(1,1,1)), c_sizeof(array(1,1,1)) * array_size)
  endif
end subroutine

subroutine fletcher16_update_int32_r4(this, array)
  use, intrinsic :: iso_c_binding, only : c_ptr, c_size_t, c_loc, c_sizeof, c_int32_t
  class(fletcher16_type), intent(inout) :: this
  integer(c_int32_t), contiguous, target, intent(in) :: array(:,:,:,:)
  integer(c_size_t) :: array_size
  array_size = size(array,kind=c_size_t)
  if (array_size > 0) then
    call c_ec_checksum_fletcher16_update(this%handle, c_loc(array(1,1,1,1)), c_sizeof(array(1,1,1,1)) * array_size)
  endif
end subroutine

subroutine fletcher16_update_int32_r5(this, array)
  use, intrinsic :: iso_c_binding, only : c_ptr, c_size_t, c_loc, c_sizeof, c_int32_t
  class(fletcher16_type), intent(inout) :: this
  integer(c_int32_t), contiguous, target, intent(in) :: array(:,:,:,:,:)
  integer(c_size_t) :: array_size
  array_size = size(array,kind=c_size_t)
  if (array_size > 0) then
    call c_ec_checksum_fletcher16_update(this%handle, c_loc(array(1,1,1,1,1)), c_sizeof(array(1,1,1,1,1)) * array_size)
  endif
end subroutine

subroutine fletcher16_update_int64_r1(this, array)
  use, intrinsic :: iso_c_binding, only : c_ptr, c_size_t, c_int64_t, c_loc, c_sizeof
  class(fletcher16_type), intent(inout) :: this
  integer(c_int64_t), contiguous, target, intent(in) :: array(:)
  integer(c_size_t) :: array_size
  array_size = size(array,kind=c_size_t)
  if (array_size > 0) then
    call c_ec_checksum_fletcher16_update(this%handle, c_loc(array(1)), c_sizeof(array(1)) * array_size)
  endif
end subroutine

subroutine fletcher16_update_int64_r2(this, array)
  use, intrinsic :: iso_c_binding, only : c_ptr, c_size_t, c_int64_t, c_loc, c_sizeof
  class(fletcher16_type), intent(inout) :: this
  integer(c_int64_t), contiguous, target, intent(in) :: array(:,:)
  integer(c_size_t) :: array_size
  array_size = size(array,kind=c_size_t)
  if (array_size > 0) then
    call c_ec_checksum_fletcher16_update(this%handle, c_loc(array(1,1)), c_sizeof(array(1,1)) * array_size)
  endif
end subroutine

subroutine fletcher16_update_int64_r3(this, array)
  use, intrinsic :: iso_c_binding, only : c_ptr, c_size_t, c_int64_t, c_loc, c_sizeof
  class(fletcher16_type), intent(inout) :: this
  integer(c_int64_t), contiguous, target, intent(in) :: array(:,:,:)
  integer(c_size_t) :: array_size
  array_size = size(array,kind=c_size_t)
  if (array_size > 0) then
    call c_ec_checksum_fletcher16_update(this%handle, c_loc(array(1,1,1)), c_sizeof(array(1,1,1)) * array_size)
  endif
end subroutine

subroutine fletcher16_update_int64_r4(this, array)
  use, intrinsic :: iso_c_binding, only : c_ptr, c_size_t, c_int64_t, c_loc, c_sizeof
  class(fletcher16_type), intent(inout) :: this
  integer(c_int64_t), contiguous, target, intent(in) :: array(:,:,:,:)
  integer(c_size_t) :: array_size
  array_size = size(array,kind=c_size_t)
  if (array_size > 0) then
    call c_ec_checksum_fletcher16_update(this%handle, c_loc(array(1,1,1,1)), c_sizeof(array(1,1,1,1)) * array_size)
  endif
end subroutine

subroutine fletcher16_update_int64_r5(this, array)
  use, intrinsic :: iso_c_binding, only : c_ptr, c_size_t, c_int64_t, c_loc, c_sizeof
  class(fletcher16_type), intent(inout) :: this
  integer(c_int64_t), contiguous, target, intent(in) :: array(:,:,:,:,:)
  integer(c_size_t) :: array_size
  array_size = size(array,kind=c_size_t)
  if (array_size > 0) then
    call c_ec_checksum_fletcher16_update(this%handle, c_loc(array(1,1,1,1,1)), c_sizeof(array(1,1,1,1,1)) * array_size)
  endif
end subroutine

function fletcher16__digest(this) result(digest)
  class(fletcher16_type), intent(in) :: this
  integer(fletcher16_digest_t) :: digest
  digest = c_ec_checksum_fletcher16_digest(this%handle)
end function

function fletcher16__digest_hex(this) result(digest)
  class(fletcher16_type), intent(in) :: this
  character(len=4) :: digest
  digest = to_hex_16(int(this%digest(),c_int16_t))
end function


function fletcher16_real32_r1(array) result(digest)
  use, intrinsic :: iso_c_binding, only : c_float
  integer(c_int16_t) :: digest
  real(c_float), intent(in) :: array(:)
  type(fletcher16_type) :: checksum
  call checksum%update(array)
  digest = checksum%digest()
end function

function fletcher16_real32_r2(array) result(digest)
  use, intrinsic :: iso_c_binding, only : c_float
  integer(c_int16_t) :: digest
  real(c_float), intent(in) :: array(:,:)
  type(fletcher16_type) :: checksum
  call checksum%update(array)
  digest = checksum%digest()
end function

function fletcher16_real32_r3(array) result(digest)
  use, intrinsic :: iso_c_binding, only : c_float
  integer(c_int16_t) :: digest
  real(c_float), intent(in) :: array(:,:,:)
  type(fletcher16_type) :: checksum
  call checksum%update(array)
  digest = checksum%digest()
end function

function fletcher16_real32_r4(array) result(digest)
  use, intrinsic :: iso_c_binding, only : c_float
  integer(c_int16_t) :: digest
  real(c_float), intent(in) :: array(:,:,:,:)
  type(fletcher16_type) :: checksum
  call checksum%update(array)
  digest = checksum%digest()
end function

function fletcher16_real32_r5(array) result(digest)
  use, intrinsic :: iso_c_binding, only : c_float
  integer(c_int16_t) :: digest
  real(c_float), intent(in) :: array(:,:,:,:,:)
  type(fletcher16_type) :: checksum
  call checksum%update(array)
  digest = checksum%digest()
end function

function fletcher16_real64_r1(array) result(digest)
  use, intrinsic :: iso_c_binding, only : c_double
  integer(c_int16_t) :: digest
  real(c_double), intent(in) :: array(:)
  type(fletcher16_type) :: checksum
  call checksum%update(array)
  digest = checksum%digest()
end function

function fletcher16_real64_r2(array) result(digest)
  use, intrinsic :: iso_c_binding, only : c_double
  integer(c_int16_t) :: digest
  real(c_double), intent(in) :: array(:,:)
  type(fletcher16_type) :: checksum
  call checksum%update(array)
  digest = checksum%digest()
end function

function fletcher16_real64_r3(array) result(digest)
  use, intrinsic :: iso_c_binding, only : c_double
  integer(c_int16_t) :: digest
  real(c_double), intent(in) :: array(:,:,:)
  type(fletcher16_type) :: checksum
  call checksum%update(array)
  digest = checksum%digest()
end function

function fletcher16_real64_r4(array) result(digest)
  use, intrinsic :: iso_c_binding, only : c_double
  integer(c_int16_t) :: digest
  real(c_double), intent(in) :: array(:,:,:,:)
  type(fletcher16_type) :: checksum
  call checksum%update(array)
  digest = checksum%digest()
end function

function fletcher16_real64_r5(array) result(digest)
  use, intrinsic :: iso_c_binding, only : c_double
  integer(c_int16_t) :: digest
  real(c_double), intent(in) :: array(:,:,:,:,:)
  type(fletcher16_type) :: checksum
  call checksum%update(array)
  digest = checksum%digest()
end function

function fletcher16_int32_r1(array) result(digest)
  use, intrinsic :: iso_c_binding, only : c_int32_t
  integer(c_int16_t) :: digest
  integer(c_int32_t), intent(in) :: array(:)
  type(fletcher16_type) :: checksum
  call checksum%update(array)
  digest = checksum%digest()
end function

function fletcher16_int32_r2(array) result(digest)
  use, intrinsic :: iso_c_binding, only : c_int32_t
  integer(c_int16_t) :: digest
  integer(c_int32_t), intent(in) :: array(:,:)
  type(fletcher16_type) :: checksum
  call checksum%update(array)
  digest = checksum%digest()
end function

function fletcher16_int32_r3(array) result(digest)
  use, intrinsic :: iso_c_binding, only : c_int32_t
  integer(c_int16_t) :: digest
  integer(c_int32_t), intent(in) :: array(:,:,:)
  type(fletcher16_type) :: checksum
  call checksum%update(array)
  digest = checksum%digest()
end function

function fletcher16_int32_r4(array) result(digest)
  use, intrinsic :: iso_c_binding, only : c_int32_t
  integer(c_int16_t) :: digest
  integer(c_int32_t), intent(in) :: array(:,:,:,:)
  type(fletcher16_type) :: checksum
  call checksum%update(array)
  digest = checksum%digest()
end function

function fletcher16_int32_r5(array) result(digest)
  use, intrinsic :: iso_c_binding, only : c_int32_t
  integer(c_int16_t) :: digest
  integer(c_int32_t), intent(in) :: array(:,:,:,:,:)
  type(fletcher16_type) :: checksum
  call checksum%update(array)
  digest = checksum%digest()
end function

function fletcher16_int64_r1(array) result(digest)
  use, intrinsic :: iso_c_binding, only : c_int64_t
  integer(c_int16_t) :: digest
  integer(c_int64_t), intent(in) :: array(:)
  type(fletcher16_type) :: checksum
  call checksum%update(array)
  digest = checksum%digest()
end function

function fletcher16_int64_r2(array) result(digest)
  use, intrinsic :: iso_c_binding, only : c_int64_t
  integer(c_int16_t) :: digest
  integer(c_int64_t), intent(in) :: array(:,:)
  type(fletcher16_type) :: checksum
  call checksum%update(array)
  digest = checksum%digest()
end function

function fletcher16_int64_r3(array) result(digest)
  use, intrinsic :: iso_c_binding, only : c_int64_t
  integer(c_int16_t) :: digest
  integer(c_int64_t), intent(in) :: array(:,:,:)
  type(fletcher16_type) :: checksum
  call checksum%update(array)
  digest = checksum%digest()
end function

function fletcher16_int64_r4(array) result(digest)
  use, intrinsic :: iso_c_binding, only : c_int64_t
  integer(c_int16_t) :: digest
  integer(c_int64_t), intent(in) :: array(:,:,:,:)
  type(fletcher16_type) :: checksum
  call checksum%update(array)
  digest = checksum%digest()
end function

function fletcher16_int64_r5(array) result(digest)
  use, intrinsic :: iso_c_binding, only : c_int64_t
  integer(c_int16_t) :: digest
  integer(c_int64_t), intent(in) :: array(:,:,:,:,:)
  type(fletcher16_type) :: checksum
  call checksum%update(array)
  digest = checksum%digest()
end function

function fletcher16_hex_real32_r1(array) result(hex4)
  use, intrinsic :: iso_c_binding, only : c_float
  character(len=4) :: hex4
  real(c_float), intent(in) :: array(:)
  hex4 = to_hex(fletcher16(array))
end function

function fletcher16_hex_real32_r2(array) result(hex4)
  use, intrinsic :: iso_c_binding, only : c_float
  character(len=4) :: hex4
  real(c_float), intent(in) :: array(:,:)
  hex4 = to_hex(fletcher16(array))
end function

function fletcher16_hex_real32_r3(array) result(hex4)
  use, intrinsic :: iso_c_binding, only : c_float
  character(len=4) :: hex4
  real(c_float), intent(in) :: array(:,:,:)
  hex4 = to_hex(fletcher16(array))
end function

function fletcher16_hex_real32_r4(array) result(hex4)
  use, intrinsic :: iso_c_binding, only : c_float
  character(len=4) :: hex4
  real(c_float), intent(in) :: array(:,:,:,:)
  hex4 = to_hex(fletcher16(array))
end function

function fletcher16_hex_real32_r5(array) result(hex4)
  use, intrinsic :: iso_c_binding, only : c_float
  character(len=4) :: hex4
  real(c_float), intent(in) :: array(:,:,:,:,:)
  hex4 = to_hex(fletcher16(array))
end function

function fletcher16_hex_real64_r1(array) result(hex4)
  use, intrinsic :: iso_c_binding, only : c_double
  character(len=4) :: hex4
  real(c_double), intent(in) :: array(:)
  hex4 = to_hex(fletcher16(array))
end function

function fletcher16_hex_real64_r2(array) result(hex4)
  use, intrinsic :: iso_c_binding, only : c_double
  character(len=4) :: hex4
  real(c_double), intent(in) :: array(:,:)
  hex4 = to_hex(fletcher16(array))
end function

function fletcher16_hex_real64_r3(array) result(hex4)
  use, intrinsic :: iso_c_binding, only : c_double
  character(len=4) :: hex4
  real(c_double), intent(in) :: array(:,:,:)
  hex4 = to_hex(fletcher16(array))
end function

function fletcher16_hex_real64_r4(array) result(hex4)
  use, intrinsic :: iso_c_binding, only : c_double
  character(len=4) :: hex4
  real(c_double), intent(in) :: array(:,:,:,:)
  hex4 = to_hex(fletcher16(array))
end function

function fletcher16_hex_real64_r5(array) result(hex4)
  use, intrinsic :: iso_c_binding, only : c_double
  character(len=4) :: hex4
  real(c_double), intent(in) :: array(:,:,:,:,:)
  hex4 = to_hex(fletcher16(array))
end function

function fletcher16_hex_int32_r1(array) result(hex4)
  use, intrinsic :: iso_c_binding, only : c_int32_t
  character(len=4) :: hex4
  integer(c_int32_t), intent(in) :: array(:)
  hex4 = to_hex(fletcher16(array))
end function

function fletcher16_hex_int32_r2(array) result(hex4)
  use, intrinsic :: iso_c_binding, only : c_int32_t
  character(len=4) :: hex4
  integer(c_int32_t), intent(in) :: array(:,:)
  hex4 = to_hex(fletcher16(array))
end function

function fletcher16_hex_int32_r3(array) result(hex4)
  use, intrinsic :: iso_c_binding, only : c_int32_t
  character(len=4) :: hex4
  integer(c_int32_t), intent(in) :: array(:,:,:)
  hex4 = to_hex(fletcher16(array))
end function

function fletcher16_hex_int32_r4(array) result(hex4)
  use, intrinsic :: iso_c_binding, only : c_int32_t
  character(len=4) :: hex4
  integer(c_int32_t), intent(in) :: array(:,:,:,:)
  hex4 = to_hex(fletcher16(array))
end function

function fletcher16_hex_int32_r5(array) result(hex4)
  use, intrinsic :: iso_c_binding, only : c_int32_t
  character(len=4) :: hex4
  integer(c_int32_t), intent(in) :: array(:,:,:,:,:)
  hex4 = to_hex(fletcher16(array))
end function

function fletcher16_hex_int64_r1(array) result(hex4)
  use, intrinsic :: iso_c_binding, only : c_int64_t
  character(len=4) :: hex4
  integer(c_int64_t), intent(in) :: array(:)
  hex4 = to_hex(fletcher16(array))
end function

function fletcher16_hex_int64_r2(array) result(hex4)
  use, intrinsic :: iso_c_binding, only : c_int64_t
  character(len=4) :: hex4
  integer(c_int64_t), intent(in) :: array(:,:)
  hex4 = to_hex(fletcher16(array))
end function

function fletcher16_hex_int64_r3(array) result(hex4)
  use, intrinsic :: iso_c_binding, only : c_int64_t
  character(len=4) :: hex4
  integer(c_int64_t), intent(in) :: array(:,:,:)
  hex4 = to_hex(fletcher16(array))
end function

function fletcher16_hex_int64_r4(array) result(hex4)
  use, intrinsic :: iso_c_binding, only : c_int64_t
  character(len=4) :: hex4
  integer(c_int64_t), intent(in) :: array(:,:,:,:)
  hex4 = to_hex(fletcher16(array))
end function

function fletcher16_hex_int64_r5(array) result(hex4)
  use, intrinsic :: iso_c_binding, only : c_int64_t
  character(len=4) :: hex4
  integer(c_int64_t), intent(in) :: array(:,:,:,:,:)
  hex4 = to_hex(fletcher16(array))
end function

end module

! (C) Copyright 2024- ECMWF.
!
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
!
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.

program drhook_papi_basic

  use yomhook, only : jphook, dr_hook

  implicit none

  real(jphook) :: zhook_handle
  integer :: a

  call dr_hook('drhook_papi_basic', 0, zhook_handle)

  a = 1
  a = a + a

  call dr_hook('drhook_papi_basic', 1, zhook_handle)

end program drhook_papi_basic

MODULE test_drhook_counters_stream_mod
  !=======================================================================
  ! Program: STREAM
  ! Programmer: John D. McCalpin
  ! RCS Revision: $Id: stream.f,v 5.6 2005/10/04 00:20:48 mccalpin Exp mccalpin $
  !-----------------------------------------------------------------------
  ! Copyright 1991-2003: John D. McCalpin
  !-----------------------------------------------------------------------
  ! License:
  !  1. You are free to use this program and/or to redistribute
  !     this program.
  !  2. You are free to modify this program for your own use,
  !     including commercial use, subject to the publication
  !     restrictions in item 3.
  !  3. You are free to publish results obtained from running this
  !     program, or from works that you derive from this program,
  !     with the following limitations:
  !     3a. In order to be referred to as "STREAM benchmark results",
  !         published results must be in conformance to the STREAM
  !         Run Rules, (briefly reviewed below) published at
  !         http://www.cs.virginia.edu/stream/ref.html
  !         and incorporated herein by reference.
  !         As the copyright holder, John McCalpin retains the
  !         right to determine conformity with the Run Rules.
  !     3b. Results based on modified source code or on runs not in
  !         accordance with the STREAM Run Rules must be clearly
  !         labelled whenever they are published.  Examples of
  !         proper labelling include:
  !         "tuned STREAM benchmark results" 
  !         "based on a variant of the STREAM benchmark code"
  !         Other comparable, clear and reasonable labelling is
  !         acceptable.
  !     3c. Submission of results to the STREAM benchmark web site
  !         is encouraged, but not required.
  !  4. Use of this program or creation of derived works based on this
  !     program constitutes acceptance of these licensing restrictions.
  !  5. Absolutely no warranty is expressed or implied.
  !-----------------------------------------------------------------------
  ! This program measures sustained memory transfer rates in MB/s for
  ! simple computational kernels coded in FORTRAN.
  !
  ! The intent is to demonstrate the extent to which ordinary user
  ! code can exploit the main memory bandwidth of the system under
  ! test.
  use yomhook, only : lhook,dr_hook,jphook

contains
  subroutine stream_combinations(n_init)
    implicit none
    integer(kind=8), intent(in), optional :: n_init
    integer(kind=8) :: n, ntimes, i
    real(kind=jphook) :: zhook_handle
    n=1024*1024
    if (present(n_init)) then
      n = n_init
    endif
    ntimes=1024
    if (lhook) call dr_hook('STREAM',0,zhook_handle)
    do i=1,3
       write(6,'(" =============================== CALL STREAM(",I0,",",I0,")")') n, ntimes
       call stream(n,ntimes)
       n=n*8
       ntimes=ntimes/8
    end do
    if (lhook) call dr_hook('STREAM',1,zhook_handle)

  end subroutine stream_combinations

  SUBROUTINE stream(n,ntimes)
!$  USE omp_lib
    INTEGER*8 n,offset,ndim
    INTEGER*8 ntimes
    PARAMETER (offset=0)
    !     ..
    !     .. Local Scalars ..
    DOUBLE PRECISION scalar,t
    INTEGER j,k,nbpw,quantum
    !     ..
    !     .. Local Arrays ..
    DOUBLE PRECISION maxtime(4),mintime(4),avgtime(4), &
         times(4,ntimes)
    INTEGER bytes(4)
    CHARACTER label(4)*11
    !     ..
    !     .. External Functions ..
    DOUBLE PRECISION timef
    REAL(KIND=JPHOOK) :: ZHOOK_HANDLE
    REAL(KIND=JPHOOK) :: ZHOOK_1,ZHOOK_2,ZHOOK_3,ZHOOK_4
    CHARACTER(len=29) :: tag

!    INTEGER realsize
    EXTERNAL mysecond !,checktick !,realsize
    !     ..
    !     .. Intrinsic Functions ..
    !
    INTRINSIC dble,max,min,nint,sqrt
    !     ..
    !     .. Arrays in Common ..
    DOUBLE PRECISION, allocatable :: a(:),b(:),c(:)
    !dir$ attributes align:64 :: A, B, C
!    CHARACTER(len=40) :: suffix
    !     ..
    !     .. Common blocks ..
    !     COMMON a,b,c
    !     ..
    !     .. Data statements ..
    DATA avgtime/4*0.0D0/,mintime/4*1.0D+36/,maxtime/4*0.0D0/
    DATA label/'Copy:      ','Scale:     ','Add:       ','Triad:     '/
    DATA bytes/2,2,3,3/
    !     ..
!    WRITE(suffix,'(A,I30)')"_",n
    !       --- SETUP --- determine precision and check timing ---
    ndim=n+offset
    allocate(a(ndim),b(ndim),c(ndim))
    nbpw = realsize()
    write(tag,'(I20)')n    
!$  if (omp_in_parallel()) then
!$    tag="_par_n="//adjustl(tag)
!$  else
      tag="_n="//adjustl(tag)
!$  end if

    PRINT *,'----------------------------------------------'
    PRINT *,'STREAM Version $Revision: 5.6 $'
    PRINT *,'----------------------------------------------'
    WRITE (*,FMT=9010) 'Array size = ',n
    WRITE (*,FMT=9010) 'Offset     = ',offset
    WRITE (*,FMT=9020) 'The total memory requirement is ', &
         3*nbpw*n/ (1024*1024),' MB'
    WRITE (*,FMT=9030) 'You are running each test ',ntimes,' times'
    WRITE (*,FMT=9030) '--'
    WRITE (*,FMT=9030) 'The *best* time for each test is used'
    WRITE (*,FMT=9030) '*EXCLUDING* the first and last iterations'
!$OMP PARALLEL
!$OMP MASTER
    PRINT *,'----------------------------------------------'
!$  PRINT *,'Number of Threads = ',OMP_GET_NUM_THREADS()
!$OMP END MASTER
!$OMP END PARALLEL

    PRINT *,'----------------------------------------------'

!$OMP PARALLEL DO
    DO 10 j = 1,n
       a(j) = 2.0d0
       b(j) = 0.5D0
       c(j) = 0.0D0
10  END DO
    t = timef()
!$OMP PARALLEL DO
    DO 20 j = 1,n
       a(j) = 0.5d0*a(j)
20  END DO
    t = timef() - t
    PRINT *,'----------------------------------------------------'
    quantum = checktick()
    WRITE (*,FMT=9000) &
         'Your clock granularity/precision appears to be ',quantum, &
         ' microseconds'
    PRINT *,'----------------------------------------------------'

    !       --- MAIN LOOP --- repeat test cases NTIMES times ---
    scalar = 0.5d0*a(1)
    DO 70 k = 1,ntimes

       IF (LHOOK) CALL DR_HOOK('STREAM_COPY'//TRIM(tag),0,ZHOOK_1)
       t = timef()
       a(1) = a(1) + t
!$OMP PARALLEL DO
       DO 30 j = 1,n
          c(j) = a(j)
30     END DO
       t = timef() - t
       IF (LHOOK) CALL DR_HOOK('STREAM_COPY'//TRIM(tag),1,ZHOOK_1)

       c(n) = c(n) + t
       times(1,k) = t

       IF (LHOOK) CALL DR_HOOK('STREAM_SCALE'//TRIM(tag),0,ZHOOK_2)
       t = timef()
       c(1) = c(1) + t
!$OMP PARALLEL DO
       DO 40 j = 1,n
          b(j) = scalar*c(j)
40     END DO
       t = timef() - t
       IF (LHOOK) CALL DR_HOOK('STREAM_SCALE'//TRIM(tag),1,ZHOOK_2)

       b(n) = b(n) + t
       times(2,k) = t

       IF (LHOOK) CALL DR_HOOK('STREAM_ADD'//TRIM(tag),0,ZHOOK_3)
       t = timef()
       a(1) = a(1) + t
!$OMP PARALLEL DO
       DO 50 j = 1,n
          c(j) = a(j) + b(j)
50     END DO
       t = timef() - t
       IF (LHOOK) CALL DR_HOOK('STREAM_ADD'//TRIM(tag),1,ZHOOK_3)
       c(n) = c(n) + t
       times(3,k) = t

       IF (LHOOK) CALL DR_HOOK('STREAM_TRIAD'//TRIM(tag),0,ZHOOK_4)
       t = timef()
       b(1) = b(1) + t
!$OMP PARALLEL DO
       DO 60 j = 1,n
          a(j) = b(j) + scalar*c(j)
60     END DO
       t = timef() - t
       IF (LHOOK) CALL DR_HOOK('STREAM_TRIAD'//TRIM(tag),1,ZHOOK_4)

       a(n) = a(n) + t
       times(4,k) = t
70  END DO

    !       --- SUMMARY ---
    DO 90 k = 2,ntimes
       DO 80 j = 1,4
          avgtime(j) = avgtime(j) + times(j,k)
          mintime(j) = min(mintime(j),times(j,k))
          maxtime(j) = max(maxtime(j),times(j,k))
80     END DO
90  END DO
    WRITE (*,FMT=9040)
    DO 100 j = 1,4
       avgtime(j) = avgtime(j)/dble(ntimes-1)
       WRITE (*,FMT=9050) label(j),n*bytes(j)*nbpw/mintime(j)/1.0D6, &
            avgtime(j),mintime(j),maxtime(j)
100 END DO
    PRINT *,'----------------------------------------------------'
    CALL checksums (a,b,c,n,ntimes)
    PRINT *,'----------------------------------------------------'

9000 FORMAT (1x,a,i6,a)
9010 FORMAT (1x,a,i10)
9020 FORMAT (1x,a,i7,a)
9030 FORMAT (1x,a,i5,a,a)
9040 FORMAT ('Function',5x,'Rate (MB/s)  Avg time   Min time  Max time' &
         )
9050 FORMAT (a,4 (f12.4,2x))
  END SUBROUTINE stream

 !-------------------------------------
 ! INTEGER FUNCTION dblesize()
 !
 ! A semi-portable way to determine the precision of DOUBLE PRECISION
 ! in Fortran.
 ! Here used to guess how many bytes of storage a DOUBLE PRECISION
 ! number occupies.
 !
 INTEGER FUNCTION realsize()
   !     IMPLICIT NONE

   !     .. Local Scalars ..
   DOUBLE PRECISION result,test
   INTEGER j,ndigits
   !     ..
   !     .. Local Arrays ..
   DOUBLE PRECISION ref(30)
   !     ..
   !     .. External Subroutines ..
!   EXTERNAL confuse
   !     ..
   !     .. Intrinsic Functions ..
   INTRINSIC abs,acos,log10,sqrt
   !     ..

   !       Test #1 - compare single(1.0d0+delta) to 1.0d0

10 DO 20 j = 1,30
      ref(j) = 1.0d0 + 10.0d0** (-j)
20 END DO

   DO 30 j = 1,30
      test = ref(j)
      ndigits = j
      CALL confuse(test,result)
      IF (test.EQ.1.0D0) THEN
         GO TO 40
      END IF
30 END DO
   GO TO 50

40 WRITE (*,FMT='(a)') &
        '----------------------------------------------'
   WRITE (*,FMT='(1x,a,i2,a)') 'Double precision appears to have ', &
        ndigits,' digits of accuracy'
   IF (ndigits.LE.8) THEN
      realsize = 4
   ELSE
      realsize = 8
   END IF
   WRITE (*,FMT='(1x,a,i1,a)') 'Assuming ',realsize, &
        ' bytes per DOUBLE PRECISION word'
   WRITE (*,FMT='(a)') &
        '----------------------------------------------'
   RETURN

50 PRINT *,'Hmmmm.  I am unable to determine the size.'
   PRINT *,'Please enter the number of Bytes per DOUBLE PRECISION', &
        ' number : '
   READ (*,FMT=*) realsize
   IF (realsize.NE.4 .AND. realsize.NE.8) THEN
      PRINT *,'Your answer ',realsize,' does not make sense.'
      PRINT *,'Try again.'
      PRINT *,'Please enter the number of Bytes per ', &
           'DOUBLE PRECISION number : '
      READ (*,FMT=*) realsize
   END IF
   PRINT *,'You have manually entered a size of ',realsize, &
        ' bytes per DOUBLE PRECISION number'
   WRITE (*,FMT='(a)') &
        '----------------------------------------------'
 END FUNCTION realsize

 SUBROUTINE confuse(q,r)
  !     IMPLICIT NONE
  !     .. Scalar Arguments ..
   DOUBLE PRECISION q,r
  !     ..
  !     .. Intrinsic Functions ..
  INTRINSIC cos
  !     ..
  r = cos(q)
  RETURN
END SUBROUTINE confuse

! A semi-portable way to determine the clock granularity
! Adapted from a code by John Henning of Digital Equipment Corporation
!
INTEGER FUNCTION checktick()
  !     IMPLICIT NONE

  !     .. Parameters ..
  INTEGER n
  PARAMETER (n=20)
  !     ..
  !     .. Local Scalars ..
  DOUBLE PRECISION t1,t2
  INTEGER i,j,jmin
  !     ..
  !     .. Local Arrays ..
  DOUBLE PRECISION timesfound(n)
  !     ..
  !     .. External Functions ..
  DOUBLE PRECISION timef
  EXTERNAL timef
  !     ..
  !     .. Intrinsic Functions ..
  INTRINSIC max,min,nint
  !     ..
  i = 0
  t1=-1
10 t2 = timef()
  IF (t2.EQ.t1) GO TO 10

  t1 = t2
  i = i + 1
  timesfound(i) = t1
  IF (i.LT.n) GO TO 10

  jmin = 1000000
  DO 20 i = 2,n
     j = nint((timesfound(i)-timesfound(i-1))*1d6)
     jmin = min(jmin,max(j,0))
20 END DO

  IF (jmin.GT.0) THEN
     checktick = jmin
  ELSE
     PRINT *,'Your clock granularity appears to be less ', &
          'than one microsecond'
     checktick = 1
  END IF
  RETURN

  !      PRINT 14, timesfound(1)*1d6
  !      DO 20 i=2,n
  !         PRINT 14, timesfound(i)*1d6,
  !     &       nint((timesfound(i)-timesfound(i-1))*1d6)
  !   14    FORMAT (1X, F18.4, 1X, i8)
  !   20 END DO

END FUNCTION checktick




SUBROUTINE checksums(a,b,c,n,ntimes)
  !     IMPLICIT NONE
  !     ..
  !     .. Arguments ..
 DOUBLE PRECISION a(*),b(*),c(*)
 INTEGER*8 n,ntimes
 !     ..
 !     .. Local Scalars ..
 DOUBLE PRECISION aa,bb,cc,scalar,suma,sumb,sumc,epsilon
 INTEGER k
 !     ..

 !     Repeat the main loop, but with scalars only.
 !     This is done to check the sum & make sure all
 !     iterations have been executed correctly.

 aa = 2.0D0
 bb = 0.5D0
 cc = 0.0D0
 aa = 0.5D0*aa
 scalar = 0.5d0*aa
 DO k = 1,ntimes
    cc = aa
    bb = scalar*cc
    cc = aa + bb
    aa = bb + scalar*cc
 END DO
 aa = aa*DBLE(n-2)
 bb = bb*DBLE(n-2)
 cc = cc*DBLE(n-2)

 !     Now sum up the arrays, excluding the first and last
 !     elements, which are modified using the timing results
 !     to confuse aggressive optimizers.

 suma = 0.0d0
 sumb = 0.0d0
 sumc = 0.0d0
 !$OMP PARALLEL DO REDUCTION(+:suma,sumb,sumc)
 DO 110 j = 2,n-1
    suma = suma + a(j)
    sumb = sumb + b(j)
    sumc = sumc + c(j)
110 END DO

 epsilon = 1.D-6

 IF (ABS(suma-aa)/suma .GT. epsilon) THEN
    PRINT *,'Failed Validation on array a()'
    PRINT *,'Target   Sum of a is = ',aa
    PRINT *,'Computed Sum of a is = ',suma
 ELSEIF (ABS(sumb-bb)/sumb .GT. epsilon) THEN
    PRINT *,'Failed Validation on array b()'
    PRINT *,'Target   Sum of b is = ',bb
    PRINT *,'Computed Sum of b is = ',sumb
 ELSEIF (ABS(sumc-cc)/sumc .GT. epsilon) THEN
    PRINT *,'Failed Validation on array c()'
    PRINT *,'Target   Sum of c is = ',cc
    PRINT *,'Computed Sum of c is = ',sumc
 ELSE
    PRINT *,'Solution Validates!'
 ENDIF

END SUBROUTINE checksums

function itoa(i) result(res)
  character(:),allocatable :: res
  integer,intent(in) :: i
  character(range(i)+2) :: tmp
  write(tmp,'(i0)') i
  res = trim(tmp)
end function itoa

END MODULE

! (C) Copyright 2005- ECMWF.
! (C) Copyright 2013- Meteo-France.
!
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!

MODULE MPL_SCATTERV_MOD

!**** MPL_SCATTERV Scatter data from specific processor

!     Purpose.
!     --------
!     Scatter data from specific processor
!     The data may be REAL*8,or INTEGER, one dimensional array
!
!**   Interface.
!     ----------
!        CALL MPL_SCATTERV

!        Input required arguments :
!        -------------------------
!           PRECVBUF -  buffer containing message
!                       (can be type REAL*4, REAL*8 or INTEGER)
!           PSENDBUF -  buffer containing message
!                       (required from kroot)
!                       (can be type REAL*4, REAL*8 or INTEGER)
!           KSENDCOUNTS-number of elements to be sent to each process
!                       (required from kroot processor)

!        Input optional arguments :
!        -------------------------
!           KROOT    -  rank of sending processor (default 1)
!           KCOMM    -  Communicator number if different from MPI_COMM_WORLD
!                       or from that established as the default
!                       by an MPL communicator routine
!           KMP_TYPE -  buffering type (see MPL_BUFFER_METHOD)
!                       overrides value provided to MPL_BUFFER_METHOD
!           KSENDDISPL -displacements in PRECVBUF at which to place
!                       the incoming data
!           CDSTRING -  Character string for ABORT messages
!                       used when KERROR is not provided

!        Output required arguments :
!        -------------------------
!           none

!        Output optional arguments :
!        -------------------------
!           KREQUEST -  Communication request
!                       required when buffering type is non-blocking
!           KERROR   -  return error code.     If not supplied,
!                       MPL_SCATTERV aborts when an error is detected.
!     Author.
!     -------
!        Y. Tremolet, M.Hamrud     ECMWF

!     Modifications.
!     --------------
!        Original: 02-03-13
!        M.Hamrud     : 2014-10-22 : Add nonblocking option
!      F. Vana  05-Mar-2015  Support for single precision

! --- *NOT* THREAD SAFE YET ---

!     ----------------------------------------------------------------
USE EC_PARKIND, ONLY : JPRD, JPIM, JPRM
USE OML_MOD,    ONLY : OML_MY_THREAD

USE MPL_MPI,                  ONLY : MPI_COMM, MPI_DATATYPE, MPI_REQUEST, MPI_REAL4, MPI_REAL8, MPI_INTEGER
USE MPL_DATA_MODULE,          ONLY : MPL_RANK, MPL_COMM_OML, MPL_ERRUNIT, MPL_NUMPROC, MPL_METHOD, &
 &                                   JP_BLOCKING_STANDARD, JP_BLOCKING_BUFFERED, &
 &                                   JP_NON_BLOCKING_STANDARD, JP_NON_BLOCKING_BUFFERED
USE MPL_MESSAGE_MOD,          ONLY : MPL_MESSAGE
USE MPL_STATS_MOD,            ONLY : MPL_RECVSTATS, MPL_SENDSTATS
USE YOMMPLSTATS,              ONLY : LMPLSTATS
USE MPL_MYRANK_MOD,           ONLY : MPL_MYRANK
USE MPL_DISPLS_CONTAINER_MOD, ONLY : YDDISPLS_LIST

IMPLICIT NONE
PRIVATE
PUBLIC MPL_SCATTERV

TYPE(MPI_COMM)     :: ICOMM
INTEGER(KIND=JPIM) :: IROOT,IPL_NUMPROC,IRECVCOUNT,ISENDBUFSIZE,IR,IPL_MYRANK,IMP_TYPE
LOGICAL            :: LLABORT=.TRUE.
INTEGER(KIND=JPIM) :: IERROR,IDUM
REAL(KIND=JPRD)    :: ZDUM
REAL(KIND=JPRM)    :: ZDUM_4
INTEGER(KIND=JPIM)    :: ZDUM_INT
INTEGER(KIND=JPIM), ALLOCATABLE :: ONES(:)

INTERFACE MPL_SCATTERV
  MODULE PROCEDURE MPL_SCATTERV_REAL8,MPL_SCATTERV_REAL4,MPL_SCATTERV_INTEGER
END INTERFACE

CONTAINS

SUBROUTINE MPL_SCATTERV_PREAMB1(KCOMM,KROOT,KMP_TYPE,KREQUEST)

#ifdef USE_8_BYTE_WORDS
USE MPI4TO8, ONLY : &
  MPI_SCATTERV => MPI_SCATTERV8, MPI_COMM_SIZE => MPI_COMM_SIZE8
#endif

INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL :: KCOMM
INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL :: KROOT
INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL :: KMP_TYPE
INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL :: KREQUEST
INTEGER(KIND=JPIM) :: ITID,ICOMM_SIZE,IERR
ITID = OML_MY_THREAD()

IERROR = 0

IF(MPL_NUMPROC < 1) CALL MPL_MESSAGE( &
  & CDMESSAGE='MPL_SCATTERV: MPL NOT INITIALISED ',LDABORT=LLABORT)

IF(PRESENT(KCOMM)) THEN
  ICOMM%MPI_VAL=KCOMM
ELSE
  ICOMM%MPI_VAL=MPL_COMM_OML(ITID)
ENDIF
CALL MPI_COMM_SIZE(ICOMM, ICOMM_SIZE, IERR)
IF (IERR /= 0) THEN
  CALL ABOR1('PROBLEM WITH SIZE OF ICOMM IN MPL_SCATTERV_PREAMB1')
ELSE
  IF (.NOT. ALLOCATED(ONES)) THEN
    ALLOCATE(ONES(ICOMM_SIZE))
    ONES(:) = 1_JPIM
  ENDIF
ENDIF

IF(PRESENT(KMP_TYPE)) THEN
  IMP_TYPE=KMP_TYPE
ELSE
  IMP_TYPE=MPL_METHOD
ENDIF
IF(IMP_TYPE == JP_NON_BLOCKING_STANDARD .OR. IMP_TYPE == JP_NON_BLOCKING_BUFFERED) THEN
  IF(.NOT.PRESENT(KREQUEST)) CALL MPL_MESSAGE(CDMESSAGE='MPL_SCATTERV:  KREQUEST MISSING',LDABORT=LLABORT)
ENDIF

IF(ICOMM%MPI_VAL == MPL_COMM_OML(ITID)) THEN
  IPL_NUMPROC = MPL_NUMPROC
  IPL_MYRANK  = MPL_RANK
ELSE
  CALL MPI_COMM_SIZE(ICOMM,IPL_NUMPROC,IERROR)
  IPL_MYRANK  = MPL_MYRANK(ICOMM%MPI_VAL)
ENDIF

IF(PRESENT(KROOT)) THEN
  IROOT=KROOT
ELSE
  IROOT=1
ENDIF

END SUBROUTINE MPL_SCATTERV_PREAMB1

SUBROUTINE MPL_SCATTERV_PREAMB2(KSENDCOUNTS,KISENDDISPL,KSENDDISPL,KISENDDISPL_PT,CDSTRING)

INTEGER(KIND=JPIM),INTENT(IN) :: KSENDCOUNTS(:)
INTEGER(KIND=JPIM),TARGET,INTENT(IN),OPTIONAL :: KSENDDISPL(:)
INTEGER(KIND=JPIM),ALLOCATABLE,TARGET,INTENT(OUT) :: KISENDDISPL(:)
INTEGER(KIND=JPIM),POINTER,INTENT(OUT),OPTIONAL :: KISENDDISPL_PT(:)
CHARACTER(LEN=*),INTENT(IN),OPTIONAL :: CDSTRING


IF(SIZE(KSENDCOUNTS)  < IPL_NUMPROC) THEN
  WRITE(MPL_ERRUNIT,*)'MPL_SCATTERV: ERROR KSENDCOUNTS DIMENSION=',&
    & SIZE(KSENDCOUNTS)
  CALL MPL_MESSAGE(CDMESSAGE=&
    & 'MPL_SCATTERV: ERROR KSENDCOUNTS DIMENSION IS WRONG',LDABORT=LLABORT)
ENDIF
IF(IRECVCOUNT /= KSENDCOUNTS(IPL_MYRANK)) THEN
  WRITE(MPL_ERRUNIT,*)'MPL_SCATTERV: ERROR KSENDCOUNTS INCONSISTENCY ',&
    & IRECVCOUNT,KSENDCOUNTS(IPL_MYRANK)
  CALL MPL_MESSAGE(CDMESSAGE=&
    & 'MPL_SCATTERV: ERROR IRECVCOUNT /= KSENDCOUNTS(MPL_RANK) ',LDABORT=LLABORT)
ENDIF

IF(PRESENT(KSENDDISPL)) THEN
  KISENDDISPL_PT => KSENDDISPL(:)
ELSE
  IF(IMP_TYPE == JP_NON_BLOCKING_STANDARD .OR. IMP_TYPE == JP_NON_BLOCKING_BUFFERED) THEN
    CALL YDDISPLS_LIST%APPEND(KNPROC=IPL_NUMPROC,KRECV_PT=KISENDDISPL_PT)
  ELSE
    ALLOCATE(KISENDDISPL(IPL_NUMPROC))
    KISENDDISPL_PT => KISENDDISPL
  END IF
  KISENDDISPL_PT(1) = 0
  DO IR=2, IPL_NUMPROC
    KISENDDISPL_PT(IR) = KISENDDISPL_PT(IR-1) + KSENDCOUNTS(IR-1)
  ENDDO
ENDIF
DO IR=1, IPL_NUMPROC
  IF(KISENDDISPL_PT(IR)+KSENDCOUNTS(IR) > ISENDBUFSIZE) THEN
    WRITE(MPL_ERRUNIT,'(A,4I10)')'MPL_SCATTERV:SEND BUFFER TOO SMALL  ', &
      & IR,KISENDDISPL_PT(IR),KSENDCOUNTS(IR),ISENDBUFSIZE
    CALL MPL_MESSAGE(CDMESSAGE='MPL_SCATTERV',CDSTRING=CDSTRING,LDABORT=LLABORT)
  ENDIF
ENDDO

END SUBROUTINE MPL_SCATTERV_PREAMB2
! ------------------------------------------------------------------
SUBROUTINE MPL_SCATTERV_REAL8(PRECVBUF,KROOT,PSENDBUF,KSENDCOUNTS,KSENDDISPL,&
  & KMP_TYPE,KCOMM,KERROR,KREQUEST,CDSTRING)


#ifdef USE_8_BYTE_WORDS
USE MPI4TO8, ONLY : &
  MPI_SCATTERV => MPI_SCATTERV8
#endif


REAL(KIND=JPRD), INTENT(OUT) :: PRECVBUF(:)
INTEGER(KIND=JPIM), INTENT(IN) :: KROOT
REAL(KIND=JPRD), INTENT(IN),OPTIONAL  :: PSENDBUF(:)
INTEGER(KIND=JPIM), INTENT(IN),OPTIONAL :: KSENDCOUNTS(:)
INTEGER(KIND=JPIM), INTENT(IN),TARGET,OPTIONAL :: KSENDDISPL(:)
INTEGER(KIND=JPIM), INTENT(IN),OPTIONAL :: KCOMM,KMP_TYPE
INTEGER(KIND=JPIM),INTENT(OUT),OPTIONAL :: KERROR,KREQUEST
CHARACTER(LEN=*),INTENT(IN),OPTIONAL :: CDSTRING

INTEGER(KIND=JPIM),ALLOCATABLE :: ISENDDISPL(:)
INTEGER(KIND=JPIM),POINTER :: ISENDDISPL_PT(:)
TYPE(MPI_DATATYPE) :: IDATA_TYPE
LOGICAL            :: LLPRESENT_SENDBUF
TYPE(MPI_REQUEST)  :: IREQUEST_LOCAL

IDATA_TYPE=MPI_REAL8
LLPRESENT_SENDBUF=PRESENT(PSENDBUF)

#include "mpl_scatterv_array_tmpl.i90"

END SUBROUTINE MPL_SCATTERV_REAL8
! ------------------------------------------------------------------
SUBROUTINE MPL_SCATTERV_REAL4(PRECVBUF,KROOT,PSENDBUF,KSENDCOUNTS,KSENDDISPL,&
  &  KMP_TYPE,KCOMM,KERROR,KREQUEST,CDSTRING)

#ifdef USE_8_BYTE_WORDS
USE MPI4TO8, ONLY : &
  MPI_SCATTERV => MPI_SCATTERV8
#endif

REAL(KIND=JPRM), INTENT(OUT) :: PRECVBUF(:)
INTEGER(KIND=JPIM), INTENT(IN) :: KROOT
REAL(KIND=JPRM), INTENT(IN),OPTIONAL  :: PSENDBUF(:)
INTEGER(KIND=JPIM), INTENT(IN),OPTIONAL :: KSENDCOUNTS(:)
INTEGER(KIND=JPIM), INTENT(IN),TARGET,OPTIONAL :: KSENDDISPL(:)
INTEGER(KIND=JPIM), INTENT(IN),OPTIONAL :: KCOMM,KMP_TYPE
INTEGER(KIND=JPIM),INTENT(OUT),OPTIONAL :: KERROR,KREQUEST
CHARACTER(LEN=*),INTENT(IN),OPTIONAL :: CDSTRING

INTEGER(KIND=JPIM),ALLOCATABLE :: ISENDDISPL(:)
INTEGER(KIND=JPIM),POINTER :: ISENDDISPL_PT(:)
TYPE(MPI_DATATYPE) :: IDATA_TYPE
LOGICAL            :: LLPRESENT_SENDBUF
TYPE(MPI_REQUEST)  :: IREQUEST_LOCAL

IDATA_TYPE=MPI_REAL4
LLPRESENT_SENDBUF=PRESENT(PSENDBUF)

#include "mpl_scatterv_array_tmpl.i90"

END SUBROUTINE MPL_SCATTERV_REAL4


SUBROUTINE MPL_SCATTERV_INTEGER(KRECVBUF,KROOT,KSENDBUF,KSENDCOUNTS,&
  & KSENDDISPL,KMP_TYPE,KCOMM,KERROR,KREQUEST,CDSTRING)

#ifdef USE_8_BYTE_WORDS
USE MPI4TO8, ONLY : &
  MPI_SCATTERV => MPI_SCATTERV8
#endif

INTEGER(KIND=JPIM), INTENT(OUT) :: KRECVBUF(:)
INTEGER(KIND=JPIM), INTENT(IN) :: KROOT
INTEGER(KIND=JPIM), INTENT(IN),OPTIONAL :: KSENDBUF(:)
INTEGER(KIND=JPIM), INTENT(IN),OPTIONAL :: KSENDCOUNTS(:)
INTEGER(KIND=JPIM), INTENT(IN),TARGET,OPTIONAL :: KSENDDISPL(:)
INTEGER(KIND=JPIM), INTENT(IN),OPTIONAL :: KCOMM,KMP_TYPE
INTEGER(KIND=JPIM),INTENT(OUT),OPTIONAL :: KERROR,KREQUEST
CHARACTER(LEN=*),INTENT(IN),OPTIONAL :: CDSTRING

INTEGER(KIND=JPIM),ALLOCATABLE :: ISENDDISPL(:)
INTEGER(KIND=JPIM),POINTER :: ISENDDISPL_PT(:)
TYPE(MPI_DATATYPE) :: IDATA_TYPE
LOGICAL            :: LLPRESENT_SENDBUF
TYPE(MPI_REQUEST)  :: IREQUEST_LOCAL

IDATA_TYPE=MPI_INTEGER
LLPRESENT_SENDBUF=PRESENT(KSENDBUF)

IF (PRESENT(KSENDBUF)) THEN
ASSOCIATE(PRECVBUF=>KRECVBUF, PSENDBUF=>KSENDBUF)
#include "mpl_scatterv_array_tmpl.i90"
END ASSOCIATE
ELSE
ASSOCIATE(PRECVBUF=>KRECVBUF, PSENDBUF=>KRECVBUF)
#include "mpl_scatterv_array_tmpl.i90"
END ASSOCIATE
END IF

END SUBROUTINE MPL_SCATTERV_INTEGER
! ------------------------------------------------------------------

END MODULE MPL_SCATTERV_MOD

! (C) Copyright 2005- ECMWF.
! (C) Copyright 2013- Meteo-France.
!
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!

MODULE MPL_GATHERV_MOD

!**** MPL_GATHERV Gather data to specific processor

!     Purpose.
!     --------
!     Gather data to specific processor
!     The data may be REAL*4, REAL*8,or INTEGER, one dimensional array
!                     REAL*4,or REAL*8, two dimensional array
!                  or INTEGER scalar

!**   Interface.
!     ----------
!        CALL MPL_GATHERV

!        Input required arguments :
!        -------------------------
!           PSENDBUF -  buffer containing message
!                       (can be type REAL*4, REAL*8 or INTEGER)
!           PRECVBUF -  buffer containing message (required from kroot)
!                       (can be type REAL*4, REAL*8 or INTEGER)
!           KRECVCOUNTS-number of elements received from each process
!                       (required from kroot processor)

!        Input optional arguments :
!        -------------------------
!           KROOT    -  rank of receiveing processor (default 1)
!           KMP_TYPE -  buffering type (see MPL_BUFFER_METHOD)
!                       overrides value provided to MPL_BUFFER_METHOD
!           KCOMM    -  Communicator number if different from MPI_COMM_WORLD
!                       or from that established as the default
!                       by an MPL communicator routine
!           KRECVDISPL -displacements in PRECVBUF at which to place
!                       the incoming data
!           CDSTRING -  Character string for ABORT messages
!                       used when KERROR is not provided

!        Output required arguments :
!        -------------------------
!           none

!        Output optional arguments :
!        -------------------------
!           KREQUEST -  Communication request
!                       required when buffering type is non-blocking
!           KERROR   -  return error code.     If not supplied,
!                       MPL_GATHERV aborts when an error is detected.
!     Author.
!     -------
!        D.Dent, M.Hamrud     ECMWF

!     Modifications.
!     --------------
!        Original:  2000-11-23
!        M.Hamrud:  2014-10-22 : Add nonblocking option
!        F.Vana:    2015-03-05 : Support for single precision
!        P.Gillies: 2018-06-25 : Add SENDCOUNT argument, needed for zero-length sends
! --- *NOT* THREAD SAFE YET ---

!     ------------------------------------------------------------------

USE EC_PARKIND, ONLY : JPRD, JPIM, JPIB, JPRM
USE OML_MOD,    ONLY : OML_MY_THREAD

USE MPL_MPIF,                 ONLY : MPI_CHARACTER, MPI_INTEGER, MPI_REAL4, MPI_REAL8
USE MPL_DATA_MODULE,          ONLY : MPL_COMM_OML, MPL_ERRUNIT, MPL_METHOD, MPL_NUMPROC, MPL_RANK, &
 &                                   JP_BLOCKING_STANDARD, JP_BLOCKING_BUFFERED, &
 &                                   JP_NON_BLOCKING_STANDARD, JP_NON_BLOCKING_BUFFERED
USE MPL_STATS_MOD,            ONLY : MPL_RECVSTATS, MPL_SENDSTATS
USE YOMMPLSTATS,              ONLY : LMPLSTATS
USE MPL_MESSAGE_MOD,          ONLY : MPL_MESSAGE
USE MPL_MYRANK_MOD,           ONLY : MPL_MYRANK
USE MPL_WAIT_MOD,             ONLY : MPL_WAIT
USE MPL_DISPLS_CONTAINER_MOD, ONLY : YDDISPLS_LIST
IMPLICIT NONE

PRIVATE


LOGICAL   :: LLABORT=.TRUE.
REAL(KIND=JPRD)    :: ZDUM_JPRD
REAL(KIND=JPRM)    :: ZDUM_JPRM
INTEGER(KIND=JPIM)    :: ZDUM_INT

INTERFACE MPL_GATHERV
  MODULE PROCEDURE MPL_GATHERV_REAL8,MPL_GATHERV_REAL4,MPL_GATHERV_CHAR_SCALAR,&
    & MPL_GATHERV_INT,MPL_GATHERV_INT_SCALAR
END INTERFACE

PUBLIC MPL_GATHERV

CONTAINS

SUBROUTINE MPL_GATHERV_PREAMB1(IERROR,IPL_NUMPROC,IPL_MYRANK,ICOMM,IROOT,IMP_TYPE, &
  & KCOMM,KROOT,KMP_TYPE,KREQUEST)

#ifdef USE_8_BYTE_WORDS
USE MPI4TO8, ONLY : &
  MPI_COMM_SIZE => MPI_COMM_SIZE8
#endif

INTEGER(KIND=JPIM),INTENT(OUT) :: IERROR,IPL_NUMPROC,IPL_MYRANK,ICOMM,IROOT,IMP_TYPE
INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL :: KROOT
INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL :: KCOMM,KMP_TYPE,KREQUEST
INTEGER(KIND=JPIM) :: ITID
ITID = OML_MY_THREAD()
IERROR = 0

IF(MPL_NUMPROC < 1) CALL MPL_MESSAGE( &
  & CDMESSAGE='MPL_GATHERV: MPL NOT INITIALISED ',LDABORT=LLABORT)

IF(PRESENT(KCOMM)) THEN
  ICOMM=KCOMM
ELSE
  ICOMM=MPL_COMM_OML(ITID)
ENDIF

IF(ICOMM == MPL_COMM_OML(ITID)) THEN
  IPL_NUMPROC = MPL_NUMPROC
  IPL_MYRANK  = MPL_RANK
ELSE
  CALL MPI_COMM_SIZE(ICOMM,IPL_NUMPROC,IERROR)
  IPL_MYRANK  = MPL_MYRANK(ICOMM)
ENDIF

IF(PRESENT(KROOT)) THEN
  IROOT=KROOT
ELSE
  IROOT=1
ENDIF

IF(PRESENT(KMP_TYPE)) THEN
  IMP_TYPE=KMP_TYPE
ELSE
  IMP_TYPE=MPL_METHOD
ENDIF
IF(IMP_TYPE == JP_NON_BLOCKING_STANDARD .OR. IMP_TYPE == JP_NON_BLOCKING_BUFFERED) THEN
  IF(.NOT.PRESENT(KREQUEST)) CALL MPL_MESSAGE(CDMESSAGE='MPL_GATHERV:  KREQUEST MISSING',LDABORT=LLABORT)
ENDIF


END SUBROUTINE MPL_GATHERV_PREAMB1

SUBROUTINE MPL_GATHERV_PREAMB2(IPL_NUMPROC,IPL_MYRANK,IRECVBUFSIZE,ISENDCOUNT,&
  & KRECVCOUNTS,KIRECVDISPL,KIRECVDISPL_PT,IMP_TYPE,KRECVDISPL,KREQUEST,CDSTRING)

INTEGER(KIND=JPIM),INTENT(IN) :: IPL_NUMPROC,IPL_MYRANK,IRECVBUFSIZE,ISENDCOUNT
INTEGER(KIND=JPIM),INTENT(IN)  :: KRECVCOUNTS(:)
INTEGER(KIND=JPIM),ALLOCATABLE,TARGET,INTENT(OUT) :: KIRECVDISPL(:)
INTEGER(KIND=JPIM), POINTER, INTENT(OUT) :: KIRECVDISPL_PT(:)
INTEGER(KIND=JPIM),INTENT(IN) :: IMP_TYPE
INTEGER(KIND=JPIM),INTENT(IN),TARGET,OPTIONAL :: KRECVDISPL(:)
INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL :: KREQUEST
CHARACTER(LEN=*),INTENT(IN),OPTIONAL :: CDSTRING
INTEGER(KIND=JPIM) :: IR


IF(SIZE(KRECVCOUNTS)  < IPL_NUMPROC) THEN
  WRITE(MPL_ERRUNIT,*)'MPL_GATHERV: ERROR KRECVCOUNTS DIMENSION=',&
    & SIZE(KRECVCOUNTS)
  CALL MPL_MESSAGE(CDMESSAGE=&
    & 'MPL_GATHERV: ERROR KRECVCOUNTS DIMENSION IS WRONG',LDABORT=LLABORT)
ENDIF
IF(ISENDCOUNT /= KRECVCOUNTS(IPL_MYRANK)) THEN
  WRITE(MPL_ERRUNIT,*)'MPL_GATHERV: ERROR KRECVCOUNTS INCONSISTENCY ',&
    & ISENDCOUNT,KRECVCOUNTS(IPL_MYRANK)
  CALL MPL_MESSAGE(CDMESSAGE=&
    & 'MPL_GATHERV: ERROR ISENDCOUNT /= KRECVCOUNTS(MPL_RANK) ',LDABORT=LLABORT)
ENDIF

IF(PRESENT(KRECVDISPL)) THEN
  KIRECVDISPL_PT => KRECVDISPL
ELSE
  IF(IMP_TYPE == JP_NON_BLOCKING_STANDARD .OR. IMP_TYPE == JP_NON_BLOCKING_BUFFERED) THEN
    CALL YDDISPLS_LIST%APPEND(KNPROC=IPL_NUMPROC, KRECV_PT=KIRECVDISPL_PT)
  ELSE
    ALLOCATE(KIRECVDISPL(IPL_NUMPROC))
    KIRECVDISPL_PT => KIRECVDISPL
  END IF
  KIRECVDISPL_PT(1) = 0
  DO IR=2, IPL_NUMPROC
    KIRECVDISPL_PT(IR) = KIRECVDISPL_PT(IR-1) + KRECVCOUNTS(IR-1)
  ENDDO
ENDIF
DO IR=1, IPL_NUMPROC
  IF(KIRECVDISPL_PT(IR)+KRECVCOUNTS(IR) > IRECVBUFSIZE) THEN
    WRITE(MPL_ERRUNIT,'(A,4I10)')'MPL_GATHERV:RECV BUFFER TOO SMALL  ', &
      & IR,KIRECVDISPL_PT(IR),KRECVCOUNTS(IR),IRECVBUFSIZE
    CALL MPL_MESSAGE(CDMESSAGE='MPL_GATHERV',CDSTRING=CDSTRING,LDABORT=LLABORT)
  ENDIF
ENDDO

END SUBROUTINE MPL_GATHERV_PREAMB2

SUBROUTINE MPL_GATHERV_REAL4(PSENDBUF,KROOT,PRECVBUF,KRECVCOUNTS,KSENDCOUNT,KRECVDISPL, &
  & KMP_TYPE,KCOMM,KERROR,KREQUEST,CDSTRING)

#ifdef USE_8_BYTE_WORDS
USE MPI4TO8, ONLY : &
  MPI_GATHERV => MPI_GATHERV8
#endif

REAL(KIND=JPRM),INTENT(IN) :: PSENDBUF(:)
INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL :: KROOT
REAL(KIND=JPRM),INTENT(OUT),OPTIONAL  :: PRECVBUF(:)
INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL :: KRECVCOUNTS(:),KSENDCOUNT
INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL :: KRECVDISPL(:),KCOMM,KMP_TYPE
INTEGER(KIND=JPIM),INTENT(OUT),OPTIONAL :: KERROR,KREQUEST
CHARACTER(LEN=*),INTENT(IN),OPTIONAL :: CDSTRING

INTEGER(KIND=JPIM),ALLOCATABLE :: IRECVDISPL(:)
INTEGER(KIND=JPIM),POINTER :: IRECVDISPL_PT(:)
INTEGER(KIND=JPIM) :: IERROR,IPL_NUMPROC,IPL_MYRANK,ICOMM,IROOT,IMP_TYPE
INTEGER(KIND=JPIM) :: IRECVBUFSIZE,ISENDCOUNT,IDATA_TYPE
LOGICAL LLPRESENT_RECVBUF

IDATA_TYPE=INT(MPI_REAL4)
LLPRESENT_RECVBUF=PRESENT(PRECVBUF)

#include "mpl_gatherv_array_tmpl.i90"

END SUBROUTINE MPL_GATHERV_REAL4

SUBROUTINE MPL_GATHERV_REAL8(PSENDBUF,KROOT,PRECVBUF,KRECVCOUNTS,KSENDCOUNT,KRECVDISPL, &
  & KMP_TYPE,KCOMM,KERROR,KREQUEST,CDSTRING)

#ifdef USE_8_BYTE_WORDS
USE MPI4TO8, ONLY : &
  MPI_GATHERV => MPI_GATHERV8
#endif

REAL(KIND=JPRD)            :: PSENDBUF(:)
INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL :: KRECVCOUNTS(:),KSENDCOUNT
INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL :: KROOT
REAL(KIND=JPRD),OPTIONAL   :: PRECVBUF(:)
INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL :: KRECVDISPL(:),KCOMM,KMP_TYPE
INTEGER(KIND=JPIM),INTENT(OUT),OPTIONAL :: KERROR,KREQUEST
CHARACTER(LEN=*),INTENT(IN),OPTIONAL :: CDSTRING

INTEGER(KIND=JPIM),ALLOCATABLE :: IRECVDISPL(:)
INTEGER(KIND=JPIM),POINTER :: IRECVDISPL_PT(:)
INTEGER(KIND=JPIM) :: IERROR,IPL_NUMPROC,IPL_MYRANK,ICOMM,IROOT,IMP_TYPE
INTEGER(KIND=JPIM) :: IRECVBUFSIZE,ISENDCOUNT
INTEGER(KIND=JPIM) :: IDUM,IST,IEND,JK, IDATA_TYPE
LOGICAL            :: LLPRESENT_RECVBUF

IDATA_TYPE = INT(MPI_REAL8)
LLPRESENT_RECVBUF=PRESENT(PRECVBUF)

#include "mpl_gatherv_array_tmpl.i90"

END SUBROUTINE MPL_GATHERV_REAL8

SUBROUTINE MPL_GATHERV_INT(KSENDBUF,KROOT,KRECVBUF,KRECVCOUNTS,KSENDCOUNT,KRECVDISPL, &
  &  KMP_TYPE,KCOMM,KERROR,KREQUEST,CDSTRING)

#ifdef USE_8_BYTE_WORDS
USE MPI4TO8, ONLY : &
  MPI_GATHERV => MPI_GATHERV8
#endif

INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL :: KROOT
INTEGER(KIND=JPIM),TARGET,INTENT(IN)         :: KSENDBUF(:)
INTEGER(KIND=JPIM),TARGET,INTENT(OUT),OPTIONAL :: KRECVBUF(:)
INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL :: KRECVCOUNTS(:)
INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL :: KSENDCOUNT,KCOMM,KMP_TYPE
INTEGER(KIND=JPIM),TARGET,INTENT(IN),OPTIONAL :: KRECVDISPL(:)
INTEGER(KIND=JPIM),INTENT(OUT),OPTIONAL :: KERROR,KREQUEST
CHARACTER(LEN=*),INTENT(IN),OPTIONAL :: CDSTRING

INTEGER(KIND=JPIM),ALLOCATABLE :: IRECVDISPL(:)
INTEGER(KIND=JPIM),POINTER :: IRECVDISPL_PT(:)
INTEGER(KIND=JPIM) :: IERROR,IPL_NUMPROC,IPL_MYRANK,ICOMM,IROOT,IMP_TYPE
INTEGER(KIND=JPIM) :: IRECVBUFSIZE,ISENDCOUNT,IDATA_TYPE

LOGICAL LLPRESENT_RECVBUF

IDATA_TYPE=INT(MPI_INTEGER)
LLPRESENT_RECVBUF=PRESENT(KRECVBUF)

IF (PRESENT(KRECVBUF)) THEN
ASSOCIATE(PSENDBUF=>KSENDBUF,PRECVBUF=>KRECVBUF)
#include "mpl_gatherv_array_tmpl.i90"
END ASSOCIATE
ELSE
ASSOCIATE(PSENDBUF=>KSENDBUF,PRECVBUF=>KSENDBUF)
#include "mpl_gatherv_array_tmpl.i90"
END ASSOCIATE
END IF

END SUBROUTINE MPL_GATHERV_INT

SUBROUTINE MPL_GATHERV_CHAR_SCALAR(CSENDBUF,KROOT,CRECVBUF,KRECVCOUNTS,KSENDCOUNT,KRECVDISPL, &
  & KMP_TYPE,KCOMM,KERROR,KREQUEST,CDSTRING)

#ifdef USE_8_BYTE_WORDS
USE MPI4TO8, ONLY : &
  MPI_GATHERV => MPI_GATHERV8
#endif

CHARACTER(LEN=*)                        :: CSENDBUF
INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL  :: KRECVCOUNTS(:),KSENDCOUNT
INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL  :: KROOT
CHARACTER(LEN=*),OPTIONAL               :: CRECVBUF(:)
INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL  :: KRECVDISPL(:),KCOMM,KMP_TYPE
INTEGER(KIND=JPIM),INTENT(OUT),OPTIONAL :: KERROR,KREQUEST
CHARACTER(LEN=*),INTENT(IN),OPTIONAL    :: CDSTRING

INTEGER(KIND=JPIM),ALLOCATABLE :: IRECVDISPL(:)
INTEGER(KIND=JPIM),POINTER :: IRECVDISPL_PT(:)
INTEGER(KIND=JPIM) :: IERROR,IPL_NUMPROC,IPL_MYRANK,ICOMM,IROOT,IMP_TYPE
INTEGER(KIND=JPIM) :: IRECVBUFSIZE,ISENDCOUNT
INTEGER(KIND=JPIM) :: IDUM,IST,IEND,JK !,ICOUNT

IF(PRESENT(KSENDCOUNT)) THEN
  ISENDCOUNT=KSENDCOUNT
ELSE
  ISENDCOUNT = LEN(CSENDBUF)
ENDIF

CALL MPL_GATHERV_PREAMB1(IERROR,IPL_NUMPROC,IPL_MYRANK,ICOMM,IROOT,IMP_TYPE,KCOMM,KROOT,KMP_TYPE,KREQUEST)

IF(IPL_MYRANK == IROOT) THEN
  IF( .NOT. PRESENT(CRECVBUF)) CALL MPL_MESSAGE(&
    & CDMESSAGE='MPL_GATHERV:RECVBUF MISSING',CDSTRING=CDSTRING,LDABORT=LLABORT)
  IRECVBUFSIZE = LEN(CRECVBUF)*SIZE(CRECVBUF)
#ifndef NAGFOR
  IF( (LOC(CRECVBUF(UBOUND(CRECVBUF,1))) - LOC(CRECVBUF(LBOUND(CRECVBUF,1)))) /= (IRECVBUFSIZE-LEN(CRECVBUF) ) .AND. &
    & IRECVBUFSIZE > 0 ) THEN
    CALL MPL_MESSAGE(CDMESSAGE='MPL_GATHERV: RECVBUF NOT CONTIGUOUS ',LDABORT=LLABORT)
  ENDIF
#endif
  CALL MPL_GATHERV_PREAMB2(IPL_NUMPROC,IPL_MYRANK,IRECVBUFSIZE,ISENDCOUNT,&
    & KRECVCOUNTS,IRECVDISPL,IRECVDISPL_PT,IMP_TYPE,KRECVDISPL,KREQUEST,CDSTRING)

  IF(IMP_TYPE == JP_BLOCKING_STANDARD .OR. IMP_TYPE == JP_BLOCKING_BUFFERED) THEN
    CALL MPI_GATHERV(CSENDBUF,ISENDCOUNT,INT(MPI_CHARACTER),CRECVBUF(1),KRECVCOUNTS,&
      &  IRECVDISPL_PT,INT(MPI_CHARACTER),IROOT-1,ICOMM,IERROR)
  ELSEIF(IMP_TYPE == JP_NON_BLOCKING_STANDARD .OR. IMP_TYPE == JP_NON_BLOCKING_BUFFERED) THEN
    CALL MPI_IGATHERV(CSENDBUF,ISENDCOUNT,INT(MPI_CHARACTER),CRECVBUF(1),KRECVCOUNTS,&
      &  IRECVDISPL_PT,INT(MPI_CHARACTER),IROOT-1,ICOMM,KREQUEST,IERROR)
    IF(.NOT. PRESENT(KRECVDISPL)) THEN
      CALL YDDISPLS_LIST%APPEND(KREQ=KREQUEST,NO_NEW_NODE=.TRUE.)
    ENDIF
  ENDIF
  IF(LMPLSTATS) THEN
    CALL MPL_SENDSTATS(ISENDCOUNT,INT(MPI_CHARACTER))
    CALL MPL_RECVSTATS(SUM(KRECVCOUNTS),INT(MPI_CHARACTER))
  ENDIF
ELSE
  IF(IMP_TYPE == JP_BLOCKING_STANDARD .OR. IMP_TYPE == JP_BLOCKING_BUFFERED) THEN
    CALL MPI_GATHERV(CSENDBUF,ISENDCOUNT,INT(MPI_CHARACTER),ZDUM_JPRD,1, &
      &  1,INT(MPI_CHARACTER),IROOT-1,ICOMM,IERROR)
  ELSEIF(IMP_TYPE == JP_NON_BLOCKING_STANDARD .OR. IMP_TYPE == JP_NON_BLOCKING_BUFFERED) THEN
    CALL MPI_IGATHERV(CSENDBUF,ISENDCOUNT,INT(MPI_CHARACTER),ZDUM_JPRD,1, &
      &  1,INT(MPI_CHARACTER),IROOT-1,ICOMM,KREQUEST,IERROR)
  ENDIF
  IF(LMPLSTATS) THEN
    CALL MPL_SENDSTATS(ISENDCOUNT,INT(MPI_CHARACTER))
  ENDIF
ENDIF

IF(PRESENT(KERROR)) THEN
  KERROR=IERROR
ELSE
  IF(IERROR /= 0 ) CALL MPL_MESSAGE(IERROR,'MPL_GATHERV',CDSTRING,&
    & LDABORT=LLABORT)
ENDIF

END SUBROUTINE MPL_GATHERV_CHAR_SCALAR

SUBROUTINE MPL_GATHERV_INT_SCALAR(KSENDBUF,KROOT,KRECVBUF,KRECVCOUNTS,KSENDCOUNT,&
  & KMP_TYPE,KRECVDISPL,KCOMM,KERROR,KREQUEST,CDSTRING)

#ifdef USE_8_BYTE_WORDS
USE MPI4TO8, ONLY : &
  MPI_GATHERV => MPI_GATHERV8, MPI_GATHER => MPI_GATHER8
#endif

INTEGER(KIND=JPIM),INTENT(IN) :: KSENDBUF
INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL :: KROOT
INTEGER(KIND=JPIM),INTENT(OUT),OPTIONAL :: KRECVBUF(:)
INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL :: KRECVCOUNTS(:),KSENDCOUNT
INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL :: KRECVDISPL(:),KCOMM,KMP_TYPE
INTEGER(KIND=JPIM),INTENT(OUT),OPTIONAL :: KERROR,KREQUEST
CHARACTER(LEN=*),INTENT(IN),OPTIONAL :: CDSTRING

INTEGER(KIND=JPIM) :: IRECVCOUNTS(MPL_NUMPROC)
INTEGER(KIND=JPIM),ALLOCATABLE :: IRECVDISPL(:)
INTEGER(KIND=JPIM),POINTER :: IRECVDISPL_PT(:)
INTEGER(KIND=JPIM) :: IERROR,IPL_NUMPROC,IPL_MYRANK,ICOMM,IROOT,IMP_TYPE
INTEGER(KIND=JPIM) :: IRECVBUFSIZE,ISENDCOUNT

IF(PRESENT(KSENDCOUNT)) THEN
  ISENDCOUNT=KSENDCOUNT
ELSE
  ISENDCOUNT = 1
ENDIF
IF(PRESENT(KRECVCOUNTS)) THEN
  IRECVCOUNTS=KRECVCOUNTS
ELSE
  IRECVCOUNTS(:) = 1
ENDIF
CALL MPL_GATHERV_PREAMB1(IERROR,IPL_NUMPROC,IPL_MYRANK,ICOMM,IROOT,IMP_TYPE,KCOMM,KROOT,KMP_TYPE,KREQUEST)

IF(IPL_MYRANK == IROOT) THEN
  IF( .NOT. PRESENT(KRECVBUF)) CALL MPL_MESSAGE(&
    & CDMESSAGE='MPL_GATHERV:RECVBUF MISSING',CDSTRING=CDSTRING,LDABORT=LLABORT)
  IRECVBUFSIZE = SIZE(KRECVBUF)
  IF(PRESENT(KRECVDISPL).OR.PRESENT(KSENDCOUNT)) THEN
    IF(.NOT.PRESENT(KSENDCOUNT)) THEN
      IRECVCOUNTS(:) = 1
    ENDIF
    CALL MPL_GATHERV_PREAMB2(IPL_NUMPROC,IPL_MYRANK,IRECVBUFSIZE,ISENDCOUNT,&
      & IRECVCOUNTS,IRECVDISPL,IRECVDISPL_PT,IMP_TYPE,KRECVDISPL,KREQUEST,CDSTRING)
    IF(IMP_TYPE == JP_BLOCKING_STANDARD .OR. IMP_TYPE == JP_BLOCKING_BUFFERED) THEN
      CALL MPI_GATHERV(KSENDBUF,ISENDCOUNT,INT(MPI_INTEGER),KRECVBUF(1),&
        & IRECVCOUNTS,IRECVDISPL_PT,INT(MPI_INTEGER),IROOT-1,ICOMM,IERROR)
    ELSEIF(IMP_TYPE == JP_NON_BLOCKING_STANDARD .OR. IMP_TYPE == JP_NON_BLOCKING_BUFFERED) THEN
      CALL MPI_IGATHERV(KSENDBUF,ISENDCOUNT,INT(MPI_INTEGER),KRECVBUF(1),&
        & IRECVCOUNTS,IRECVDISPL_PT,INT(MPI_INTEGER),IROOT-1,ICOMM,KREQUEST,IERROR)
      IF(.NOT. PRESENT(KRECVDISPL)) THEN
        CALL YDDISPLS_LIST%APPEND(KREQ=KREQUEST,NO_NEW_NODE=.TRUE.)
      ENDIF
    ENDIF
    IF(LMPLSTATS) THEN
      CALL MPL_SENDSTATS(ISENDCOUNT,INT(MPI_INTEGER))
      CALL MPL_RECVSTATS(SUM(IRECVCOUNTS),INT(MPI_INTEGER))
    ENDIF
  ELSE
    IF(IRECVBUFSIZE < IPL_NUMPROC) THEN
      CALL MPL_MESSAGE(CDMESSAGE='MPL_GATHERV:IRECVBUFSIZE < IPL_NUMPROC',&
        & CDSTRING=CDSTRING,LDABORT=LLABORT)
    ENDIF
    IF(IMP_TYPE == JP_BLOCKING_STANDARD .OR. IMP_TYPE == JP_BLOCKING_BUFFERED) THEN
      CALL MPI_GATHER(KSENDBUF,ISENDCOUNT,INT(MPI_INTEGER),KRECVBUF(1),&
        & ISENDCOUNT,INT(MPI_INTEGER),IROOT-1,ICOMM,IERROR)
    ELSEIF(IMP_TYPE == JP_NON_BLOCKING_STANDARD .OR. IMP_TYPE == JP_NON_BLOCKING_BUFFERED) THEN
      CALL MPI_IGATHER(KSENDBUF,ISENDCOUNT,INT(MPI_INTEGER),KRECVBUF(1),&
        & ISENDCOUNT,INT(MPI_INTEGER),IROOT-1,ICOMM,KREQUEST,IERROR)
      CALL MPL_WAIT(KREQUEST)
    ENDIF
    IF(LMPLSTATS) THEN
      CALL MPL_SENDSTATS(ISENDCOUNT,INT(MPI_INTEGER))
      CALL MPL_RECVSTATS(ISENDCOUNT,INT(MPI_INTEGER))
    ENDIF
  ENDIF
ELSE
  IF(PRESENT(KRECVDISPL).OR.PRESENT(KSENDCOUNT)) THEN
    IF(.NOT.PRESENT(KSENDCOUNT)) THEN
      IRECVCOUNTS(:)=1
    ENDIF
    IF(IMP_TYPE == JP_BLOCKING_STANDARD .OR. IMP_TYPE == JP_BLOCKING_BUFFERED) THEN
      CALL MPI_GATHERV(KSENDBUF,ISENDCOUNT,INT(MPI_INTEGER),ZDUM_INT,KRECVBUF(1), &
        &  IRECVCOUNTS,INT(MPI_INTEGER),IROOT-1,ICOMM,IERROR)
    ELSEIF(IMP_TYPE == JP_NON_BLOCKING_STANDARD .OR. IMP_TYPE == JP_NON_BLOCKING_BUFFERED) THEN
      CALL MPI_IGATHERV(KSENDBUF,ISENDCOUNT,INT(MPI_INTEGER),ZDUM_INT,1, &
        &  1,INT(MPI_INTEGER),IROOT-1,ICOMM,KREQUEST,IERROR)
      CALL MPL_WAIT(KREQUEST)
    ENDIF
    IF(LMPLSTATS) THEN
      CALL MPL_SENDSTATS(ISENDCOUNT,INT(MPI_INTEGER))
    ENDIF
  ELSE
    IF(IMP_TYPE == JP_BLOCKING_STANDARD .OR. IMP_TYPE == JP_BLOCKING_BUFFERED) THEN
      CALL MPI_GATHER(KSENDBUF,ISENDCOUNT,INT(MPI_INTEGER),ZDUM_INT,&
        & 1,INT(MPI_INTEGER),IROOT-1,ICOMM,IERROR)
    ELSEIF(IMP_TYPE == JP_NON_BLOCKING_STANDARD .OR. IMP_TYPE == JP_NON_BLOCKING_BUFFERED) THEN
      CALL MPI_IGATHER(KSENDBUF,ISENDCOUNT,INT(MPI_INTEGER),ZDUM_INT,&
        & 1,INT(MPI_INTEGER),IROOT-1,ICOMM,KREQUEST,IERROR)
      IF(.NOT. PRESENT(KRECVDISPL)) THEN
        CALL YDDISPLS_LIST%APPEND(KREQ=KREQUEST,NO_NEW_NODE=.TRUE.)
      ENDIF
    ENDIF
    IF(LMPLSTATS) THEN
      CALL MPL_SENDSTATS(ISENDCOUNT,INT(MPI_INTEGER))
    ENDIF
  ENDIF
ENDIF

IF(PRESENT(KERROR)) THEN
  KERROR=IERROR
ELSE
  IF(IERROR /= 0 ) CALL MPL_MESSAGE(IERROR,'MPL_GATHERV',CDSTRING,LDABORT=LLABORT)
ENDIF

END SUBROUTINE MPL_GATHERV_INT_SCALAR

SUBROUTINE MPL_GATHERV_REAL8_SCALAR(PSENDBUF,KROOT,PRECVBUF,KRECVCOUNTS,&
  &  KRECVDISPL,KMP_TYPE,KCOMM,KERROR,KREQUEST,CDSTRING)

#ifdef USE_8_BYTE_WORDS
USE MPI4TO8, ONLY : &
  MPI_GATHERV => MPI_GATHERV8, MPI_GATHER => MPI_GATHER8
#endif

REAL(KIND=JPRD),INTENT(IN) :: PSENDBUF
INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL :: KROOT
REAL(KIND=JPRD),INTENT(OUT),OPTIONAL :: PRECVBUF(:)
INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL :: KRECVCOUNTS(:) ! Not used; for compatibility only
INTEGER(KIND=JPIM),INTENT(IN),OPTIONAL :: KRECVDISPL(:),KCOMM,KMP_TYPE
INTEGER(KIND=JPIM),INTENT(OUT),OPTIONAL :: KERROR,KREQUEST
CHARACTER(LEN=*),INTENT(IN),OPTIONAL :: CDSTRING

INTEGER(KIND=JPIM) :: IRECVCOUNTS(MPL_NUMPROC)
INTEGER(KIND=JPIM),ALLOCATABLE :: IRECVDISPL(:)
INTEGER(KIND=JPIM),POINTER :: IRECVDISPL_PT(:)
INTEGER(KIND=JPIM) :: IERROR,IPL_NUMPROC,IPL_MYRANK,ICOMM,IROOT,IMP_TYPE
INTEGER(KIND=JPIM) :: IRECVBUFSIZE,ISENDCOUNT

ISENDCOUNT = 1
CALL MPL_GATHERV_PREAMB1(IERROR,IPL_NUMPROC,IPL_MYRANK,ICOMM,IROOT,IMP_TYPE,KCOMM,KROOT,KMP_TYPE,KREQUEST)

IF(IPL_MYRANK == IROOT) THEN
  IF( .NOT. PRESENT(PRECVBUF)) CALL MPL_MESSAGE(&
    & CDMESSAGE='MPL_GATHERV:RECVBUF MISSING',CDSTRING=CDSTRING,LDABORT=LLABORT)
  IRECVBUFSIZE = SIZE(PRECVBUF)
  IF(PRESENT(KRECVDISPL)) THEN
    IRECVCOUNTS(:) = 1
    CALL MPL_GATHERV_PREAMB2(IPL_NUMPROC,IPL_MYRANK,IRECVBUFSIZE,ISENDCOUNT,&
      & IRECVCOUNTS,IRECVDISPL,IRECVDISPL_PT,IMP_TYPE,KRECVDISPL,KREQUEST,CDSTRING)
    IF(IMP_TYPE == JP_BLOCKING_STANDARD .OR. IMP_TYPE == JP_BLOCKING_BUFFERED) THEN
      CALL MPI_GATHERV(PSENDBUF,ISENDCOUNT,INT(MPI_REAL8),PRECVBUF(1),&
        & IRECVCOUNTS,IRECVDISPL_PT,INT(MPI_REAL8),IROOT-1,ICOMM,IERROR)
    ELSEIF(IMP_TYPE == JP_NON_BLOCKING_STANDARD .OR. IMP_TYPE == JP_NON_BLOCKING_BUFFERED) THEN
      CALL MPI_IGATHERV(PSENDBUF,ISENDCOUNT,INT(MPI_REAL8),PRECVBUF(1),&
        & IRECVCOUNTS,IRECVDISPL_PT,INT(MPI_REAL8),IROOT-1,ICOMM,KREQUEST,IERROR)
      IF(.NOT. PRESENT(KRECVDISPL)) THEN
        CALL YDDISPLS_LIST%APPEND(KREQ=KREQUEST,NO_NEW_NODE=.TRUE.)
      ENDIF
    ENDIF
    IF(LMPLSTATS) THEN
      CALL MPL_SENDSTATS(ISENDCOUNT,INT(MPI_REAL8))
      CALL MPL_RECVSTATS(SUM(IRECVCOUNTS),INT(MPI_REAL8))
    ENDIF
  ELSE
    IF(IRECVBUFSIZE < IPL_NUMPROC) THEN
      CALL MPL_MESSAGE(CDMESSAGE='MPL_GATHERV:IRECVBUFSIZE < IPL_NUMPROC',&
        & CDSTRING=CDSTRING,LDABORT=LLABORT)
    ENDIF
    IF(IMP_TYPE == JP_BLOCKING_STANDARD .OR. IMP_TYPE == JP_BLOCKING_BUFFERED) THEN
      CALL MPI_GATHER(PSENDBUF,ISENDCOUNT,INT(MPI_REAL8),PRECVBUF(1),&
        & ISENDCOUNT,INT(MPI_REAL8),IROOT-1,ICOMM,IERROR)
    ELSEIF(IMP_TYPE == JP_NON_BLOCKING_STANDARD .OR. IMP_TYPE == JP_NON_BLOCKING_BUFFERED) THEN
      CALL MPI_IGATHER(PSENDBUF,ISENDCOUNT,INT(MPI_REAL8),PRECVBUF(1),&
        & ISENDCOUNT,INT(MPI_REAL8),IROOT-1,ICOMM,KREQUEST,IERROR)
      CALL MPL_WAIT(KREQUEST)
    ENDIF
    IF(LMPLSTATS) THEN
      CALL MPL_SENDSTATS(ISENDCOUNT,INT(MPI_REAL8))
      CALL MPL_RECVSTATS(ISENDCOUNT,INT(MPI_REAL8))
    ENDIF
  ENDIF
ELSE
  IF(PRESENT(KRECVDISPL)) THEN
    IF(IMP_TYPE == JP_BLOCKING_STANDARD .OR. IMP_TYPE == JP_BLOCKING_BUFFERED) THEN
      CALL MPI_GATHERV(PSENDBUF,ISENDCOUNT,INT(MPI_REAL8),ZDUM_JPRD,1, &
        &  1,INT(MPI_REAL8),IROOT-1,ICOMM,IERROR)
    ELSEIF(IMP_TYPE == JP_NON_BLOCKING_STANDARD .OR. IMP_TYPE == JP_NON_BLOCKING_BUFFERED) THEN
      CALL MPI_IGATHERV(PSENDBUF,ISENDCOUNT,INT(MPI_REAL8),ZDUM_JPRD,1, &
        &  1,INT(MPI_REAL8),IROOT-1,ICOMM,KREQUEST,IERROR)
      CALL MPL_WAIT(KREQUEST)
    ENDIF
    IF(LMPLSTATS) THEN
      CALL MPL_SENDSTATS(ISENDCOUNT,INT(MPI_REAL8))
    ENDIF
  ELSE
    IF(IMP_TYPE == JP_BLOCKING_STANDARD .OR. IMP_TYPE == JP_BLOCKING_BUFFERED) THEN
      CALL MPI_GATHER(PSENDBUF,ISENDCOUNT,INT(MPI_REAL8),ZDUM_JPRD,&
        & 1,INT(MPI_REAL8),IROOT-1,ICOMM,IERROR)
    ELSEIF(IMP_TYPE == JP_NON_BLOCKING_STANDARD .OR. IMP_TYPE == JP_NON_BLOCKING_BUFFERED) THEN
      CALL MPI_IGATHER(PSENDBUF,ISENDCOUNT,INT(MPI_REAL8),ZDUM_JPRD,&
        & 1,INT(MPI_REAL8),IROOT-1,ICOMM,KREQUEST,IERROR)
      CALL MPL_WAIT(KREQUEST)
    ENDIF
    IF(LMPLSTATS) THEN
      CALL MPL_SENDSTATS(ISENDCOUNT,INT(MPI_REAL8))
    ENDIF
  ENDIF
ENDIF

IF(PRESENT(KERROR)) THEN
  KERROR=IERROR
ELSE
  IF(IERROR /= 0 ) CALL MPL_MESSAGE(IERROR,'MPL_GATHERV',CDSTRING,LDABORT=LLABORT)
ENDIF

END SUBROUTINE MPL_GATHERV_REAL8_SCALAR

END MODULE MPL_GATHERV_MOD

MODULE NAMELIST_MOD

! This module contains namelist utilities, especially subroutines/function to
! position on the requested namelist "block" to read variables.
!
! To the legacy POSNAM and POSNAME subroutines from IAL (IFS-ARPEGE-LAM),
! a POSNAMEF function is added to enable a shorter syntax:
! IF (POSNAMEF(KULNAM, CDNAML, ...) == 0) READ(KULNAM, NAML)

IMPLICIT NONE

PUBLIC :: POSNAME, POSNAM, POSNAMEF

CONTAINS
!     ------------------------------------------------------------------
SUBROUTINE POSNAME(KULNAM,CDNAML,KSTAT,LDNOREWIND)

!**** *POSNAME* - position namelist file for reading; return error code
!                 if namelist is not found

!     Purpose.
!     --------
!     To position namelist file at correct place for reading
!     namelist CDNAML. Replaces use of Cray specific ability
!     to skip to the correct namelist.

!**   Interface.
!     ----------
!        *CALL* *POSNAME*(..)

!        Explicit arguments :     KULNAM - file unit number (input)
!        --------------------     CDNAML - namelist name    (input)
!                                 KSTAT  - non-zero if namelist not found
!                                          1 = namelist not found

!     Author.
!     -------
!      P.Marguinaud 22-Nov-2010

!     Modifications.
!     --------------
!      R.Hogan      20-Jan-2022  Added no-rewind optional argument

!     --------------------------------------------------------------

USE EC_PARKIND ,ONLY : JPIM
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK, JPHOOK

IMPLICIT NONE

INTEGER(KIND=JPIM),INTENT(IN)    :: KULNAM
CHARACTER(LEN=*)  ,INTENT(IN)    :: CDNAML
INTEGER(KIND=JPIM),INTENT(OUT)   :: KSTAT
LOGICAL,OPTIONAL,  INTENT(IN)    :: LDNOREWIND

#include "abor1.intfb.h"


CHARACTER (LEN = 40) ::  CLINE
CHARACTER (LEN =  1) ::  CLTEST

INTEGER(KIND=JPIM) :: ILEN, IND1, ISTATUS, ISCAN
REAL(KIND=JPHOOK)    :: ZHOOK_HANDLE

!      -----------------------------------------------------------

!*       1.    POSITION FILE
!              -------------

IF (LHOOK) CALL DR_HOOK('POSNAME',0,ZHOOK_HANDLE)

KSTAT = 0

CLINE='                                        '
! Rewind by default, but not if LDNOREWIND is present and TRUE. This
! is useful for reading an array of structures of arbitrary length
! from a namelist, by repeated use of the same group name.
IF (.NOT. PRESENT(LDNOREWIND)) THEN
  REWIND(KULNAM)
ELSEIF (.NOT. LDNOREWIND) THEN
  REWIND(KULNAM)
ENDIF

ILEN=LEN(CDNAML)
ISTATUS=0
ISCAN=0
DO WHILE (ISTATUS==0 .AND. ISCAN==0)
  READ(KULNAM,'(A)',IOSTAT=ISTATUS) CLINE
  SELECT CASE (ISTATUS)
  CASE (:-1)
    KSTAT=1
    ISCAN=-1
  CASE (0)
    IF (INDEX(CLINE(1:10),'&') == 0) THEN
      ISCAN=0
    ELSE
      IND1=INDEX(CLINE,'&'//CDNAML)
      IF (IND1 == 0) THEN
        ISCAN=0
      ELSE
        CLTEST=CLINE(IND1+ILEN+1:IND1+ILEN+1)
        IF (   (LGE(CLTEST,'0').AND.LLE(CLTEST,'9')) &
         & .OR.(LGE(CLTEST,'A').AND.LLE(CLTEST,'Z')) ) THEN
          ISCAN=0
        ELSE
          ISCAN=1
        ENDIF
      ENDIF
    ENDIF
  CASE (1:)
    CALL ABOR1 ('POSNAME: AN ERROR OCCURRED WHILE READING THE NAMELIST')
  END SELECT
ENDDO
BACKSPACE(KULNAM)

!     ------------------------------------------------------------------

IF (LHOOK) CALL DR_HOOK('POSNAME',1,ZHOOK_HANDLE)
END SUBROUTINE POSNAME


FUNCTION POSNAMEF(KULNAM, CDNAML, LDNOREWIND, LDFATAL, LDVERBOSE, KULOUT) RESULT(ISTAT)
!**** *POSNAMEF* - function to position namelist file for reading and return error code
!                  if namelist is not found

!     Purpose.
!     --------
!     To position namelist file at correct place for reading namelist CDNAML.

!**   Interface.
!     ----------
!        IF (POSNAMEF(KULNAM, CDNAML, ...) == 0) READ(KULNAM, NAML)

!        Explicit arguments :     KULNAM - file unit number (input)
!        --------------------     CDNAML - namelist name    (input)
!                                 LDNOREWIND - no rewind; This is useful for
!                                   reading an array of structures of arbitrary
!                                   length from a namelist, by repeated use of
!                                   the same group name.
!                                 LDFATAL - to call ABOR1 in case CDNAML not present in file
!                                   The default value is .TRUE. or can be defined via env var
!                                   POSNAMEF_DEFAULT_FATAL=0
!                                 LDVERBOSE - verbosity
!                                 KULOUT - output unit for verbosity

USE EC_PARKIND, ONLY : JPIM
USE EC_LUN, ONLY : NULOUT
USE YOMHOOK,  ONLY : LHOOK, DR_HOOK, JPHOOK

IMPLICIT NONE

INTEGER(KIND=JPIM), INTENT(IN) :: KULNAM
CHARACTER(LEN=*),   INTENT(IN) :: CDNAML
LOGICAL,OPTIONAL,   INTENT(IN) :: LDNOREWIND
LOGICAL,OPTIONAL,   INTENT(IN) :: LDFATAL
LOGICAL,OPTIONAL,   INTENT(IN) :: LDVERBOSE
INTEGER(KIND=JPIM),OPTIONAL, INTENT(IN) :: KULOUT

INTEGER(KIND=JPIM) :: ISTAT
CHARACTER(LEN=256) :: CLFILE
LOGICAL :: LLNOREWIND
LOGICAL :: LLFATAL
CHARACTER(LEN=256) :: CLFATAL
LOGICAL :: LLVERBOSE
INTEGER :: ILULOUT

REAL(KIND=JPHOOK) :: ZHOOK_HANDLE

#include "abor1.intfb.h"

IF (LHOOK) CALL DR_HOOK('POSNAMEF',0,ZHOOK_HANDLE)
! defaults
LLNOREWIND = .FALSE.
CALL GET_ENVIRONMENT_VARIABLE('POSNAMEF_DEFAULT_FATAL',CLFATAL)
IF (TRIM(CLFATAL) == '' .OR. TRIM(CLFATAL) == '1') THEN
  LLFATAL = .TRUE.
ELSE
  LLFATAL = .FALSE.
ENDIF
LLVERBOSE = .TRUE.
ILULOUT = NULOUT
! optional arguments
IF (PRESENT(LDNOREWIND)) LLNOREWIND = LDNOREWIND
IF (PRESENT(LDFATAL)) LLFATAL = LDFATAL
IF (PRESENT(LDVERBOSE)) LLVERBOSE = LDVERBOSE
IF (PRESENT(KULOUT)) ILULOUT = KULOUT

CLFILE=""

INQUIRE(KULNAM,NAME=CLFILE)
IF (CLFILE == "") THEN
  ! No file is explicitely connected to this logical unit number yet
  ! (because the file is not yet opened)
  ! then give it its standard name "fort.KULNAM" :
  IF (KULNAM <= 9) THEN
    WRITE(CLFILE,'(''fort.'',I1)') KULNAM
  ELSE
    WRITE(CLFILE,'(''fort.'',I2)') KULNAM
  ENDIF
ENDIF
IF (LLVERBOSE) WRITE(ILULOUT,"('Reading namelist ',A,' from ',A)") CDNAML,TRIM(CLFILE)

CALL POSNAME (KULNAM, CDNAML, ISTAT, LDNOREWIND=LLNOREWIND)

SELECT CASE (ISTAT)
  CASE (0)
  CASE (1)
    IF (LLFATAL) THEN
      CALL ABOR1 ('POSNAM:CANNOT LOCATE '//CDNAML//' ')
    ENDIF
  CASE DEFAULT
    CALL ABOR1 ('POSNAM:READ ERROR IN NAMELIST FILE')
END SELECT

IF (LHOOK) CALL DR_HOOK('POSNAMEF',1,ZHOOK_HANDLE)
END FUNCTION POSNAMEF


SUBROUTINE POSNAM(KULNAM, CDNAML)

!**** *POSNAM* - position namelist file for reading

!     Purpose.
!     --------
!     To position namelist file at correct place for reading
!     namelist CDNAML. Replaces use of Cray specific ability
!     to skip to the correct namelist.

!**   Interface.
!     ----------
!        *CALL* *POSNAM*(..)

!        Explicit arguments :     KULNAM - file unit number (input)
!        --------------------     CDNAML - namelist name    (input)

!        Implicit arguments :     None
!        --------------------

!     Method.
!     -------
!        See documentation

!     Externals.   None
!     ----------

!     Reference.
!     ----------
!        ECMWF Research Department documentation of the IFS

!     Author.
!     -------
!        Mats Hamrud *ECMWF*

!     Modifications.
!     --------------
!        Original : 93-06-22
!        M.Hamrud      01-Oct-2003 CY28 Cleaning
!        M.Hamrud      01-Dec-2003 CY28R1 Cleaning
!      R. El Khatib 04-08-10 Apply norms + proper abort if namelist is missing
!      P. Marguinaud   Proxy to POSNAME
!      H Petithomme Sept 2023: some cleaning
!      R. El Khatib 11-Feb-2025 Fix uninitialized filename and arbitrary choice "fort.4"
!      A.Mary       22-05-2025: move contents to POSNAMEF
!     --------------------------------------------------------------

USE EC_PARKIND, ONLY : JPIM
USE YOMHOOK,  ONLY : LHOOK, DR_HOOK, JPHOOK

IMPLICIT NONE

INTEGER(KIND=JPIM),INTENT(IN) :: KULNAM
CHARACTER(LEN=*)  ,INTENT(IN) :: CDNAML

INTEGER(KIND=JPIM) :: ISTAT
REAL(KIND=JPHOOK)    :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('POSNAM',0,ZHOOK_HANDLE)
ISTAT = POSNAMEF(KULNAM, CDNAML, &
               & LDNOREWIND=.FALSE., &
               & LDFATAL=.TRUE., &
               & LDVERBOSE=.TRUE.)
IF (LHOOK) CALL DR_HOOK('POSNAM',1,ZHOOK_HANDLE)
END SUBROUTINE POSNAM

END MODULE NAMELIST_MOD

! (C) Copyright 2005- ECMWF.
! (C) Copyright 2013- Meteo-France.
!
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!

MODULE MPL_ALLTOALLV_MOD

!**** MPL_ALLTOALLV - Everyone sends different data to everyone

!     Purpose.
!     --------
!     Interface to MPI_ALLTOALLV

!     The data may be REAL*8,or INTEGER

!**   Interface.
!     ----------
!        CALL MPL_ALLTOALLV

!        Input required arguments :
!        -------------------------
!           PSENDBUF -  buffer containing message
!                       (can be type  REAL*8 or INTEGER)
!           PRECVBUF -  buffer containing message
!                       (can be type REAL*8 or INTEGER)
!           KRECVCOUNTS-number of elements received from each process
!           KSENDCOUNTS-number of elements to be sent to each process

!        Input optional arguments :
!        -------------------------
!           KCOMM    -  Communicator number if different from MPI_COMM_WORLD
!                       or from that established as the default
!                       by an MPL communicator routine
!           KRECVDISPL -displacements in PRECVBUF at which to place
!                       the incoming data
!           KSENDDISPL -displacements in PSENDBUF from which to send
!                       the data
!           KMP_TYPE -  buffering type (see MPL_BUFFER_METHOD)
!                       overrides value provided to MPL_BUFFER_METHOD
!           CDSTRING -  Character string for ABORT messages
!                       used when KERROR is not provided

!        Output optional arguments :
!        -------------------------
!           KREQUEST -  Communication request
!                       required when buffering type is non-blocking
!           KERROR   -  return error code.     If not supplied,
!                       MPL_ALLTOALLV aborts when an error is detected.

!     Author.
!     -------
!       Y. Tremolet

!     Modifications.
!     --------------
!       Original: 02-03-21
!       Modified : 25-09-02 M.Hamrud - generalize
!      F. Vana  05-Mar-2015  Support for single precision
! ------------------------------------------------------------------

   USE EC_PARKIND, ONLY : JPRD, JPIM, JPIB, JPRM
   USE OML_MOD,    ONLY : OML_MY_THREAD

   USE MPL_MPIF,                 ONLY : MPI_INTEGER, MPI_REAL4, MPI_REAL8
   USE MPL_DATA_MODULE,          ONLY : MPL_COMM_OML, MPL_ERRUNIT, MPL_METHOD, MPL_NUMPROC, &
 &                                      JP_BLOCKING_STANDARD, JP_BLOCKING_BUFFERED, &
 &                                      JP_NON_BLOCKING_STANDARD, JP_NON_BLOCKING_BUFFERED
   USE MPL_MESSAGE_MOD,          ONLY : MPL_MESSAGE
   USE MPL_STATS_MOD,            ONLY : MPL_RECVSTATS, MPL_SENDSTATS
   USE YOMMPLSTATS,              ONLY : LMPLSTATS
   USE MPL_DISPLS_CONTAINER_MOD, ONLY : YDDISPLS_LIST

   IMPLICIT NONE
   PRIVATE

   LOGICAL :: LLABORT=.TRUE.
   INTEGER(KIND=JPIM) :: ICOMM,IERROR,IPL_NUMPROC,IRECVCOUNT,ISENDCOUNT,IR,IMP_TYPE
   LOGICAL :: LLSCALAR

   INTERFACE MPL_ALLTOALLV
      MODULE PROCEDURE MPL_ALLTOALLV_REAL8,MPL_ALLTOALLV_INTEGER,MPL_ALLTOALLV_REAL4
   END INTERFACE

   PUBLIC MPL_ALLTOALLV

CONTAINS
! ------------------------------------------------------------------

   SUBROUTINE MPL_ALLTOALLV_PREAMB(KSENDCOUNTS,KISENDDISPL,KISENDDISPL_PT,&
   & KRECVCOUNTS,KIRECVDISPL,KIRECVDISPL_PT, &
      KSENDDISPL,KRECVDISPL,KMP_TYPE,KCOMM,KREQUEST,CDSTRING)

#ifdef USE_8_BYTE_WORDS
      USE MPI4TO8, ONLY : &
         MPI_COMM_SIZE => MPI_COMM_SIZE8
#endif

      IMPLICIT NONE
      INTEGER(KIND=JPIM),INTENT(IN)          :: KRECVCOUNTS(:),KSENDCOUNTS(:)
      INTEGER(KIND=JPIM),TARGET,INTENT(OUT)  :: KISENDDISPL(:),KIRECVDISPL(:)
      INTEGER(KIND=JPIM),POINTER,INTENT(OUT) :: KISENDDISPL_PT(:),KIRECVDISPL_PT(:)
      INTEGER(KIND=JPIM),OPTIONAL,INTENT(IN) :: KSENDDISPL(:),KRECVDISPL(:),KCOMM,KMP_TYPE,KREQUEST
      CHARACTER(LEN=*),INTENT(IN),OPTIONAL :: CDSTRING
      TARGET :: KSENDDISPL,KRECVDISPL
      INTEGER(KIND=JPIM) :: ITID,J
      ITID = OML_MY_THREAD()
      IF(MPL_NUMPROC < 1) CALL MPL_MESSAGE( &
      & CDMESSAGE='MPL_ALLTOALLV: MPL NOT INITIALISED ',LDABORT=LLABORT)

      IF(PRESENT(KCOMM)) THEN
         ICOMM=KCOMM
      ELSE
         ICOMM=MPL_COMM_OML(ITID)
      ENDIF

      IF(PRESENT(KMP_TYPE)) THEN
         IMP_TYPE=KMP_TYPE
      ELSE
         IMP_TYPE=MPL_METHOD
      ENDIF

      IF(ICOMM == MPL_COMM_OML(ITID)) THEN
         IPL_NUMPROC = MPL_NUMPROC
      ELSE
         CALL MPI_COMM_SIZE(ICOMM,IPL_NUMPROC,IERROR)
      ENDIF

      IF(SIZE(KRECVCOUNTS)  < IPL_NUMPROC) THEN
         WRITE(MPL_ERRUNIT,*)'MPL_ALLTOALLV: ERROR KRECVCOUNTS dimension=',&
         & SIZE(KRECVCOUNTS)
         CALL MPL_MESSAGE(CDMESSAGE=&
         & 'MPL_ALLTOALLV: ERROR KRECVCOUNTS dimension is wrong',LDABORT=LLABORT)
      ENDIF

      IF(SIZE(KSENDCOUNTS)  < IPL_NUMPROC) THEN
         WRITE(MPL_ERRUNIT,*)'MPL_ALLTOALLV: ERROR KSENDCOUNTS dimension=',&
         & SIZE(KSENDCOUNTS)
         CALL MPL_MESSAGE(CDMESSAGE=&
         & 'MPL_ALLTOALLV: ERROR KSENDCOUNTS dimension is wrong',LDABORT=LLABORT)
      ENDIF

      IF(PRESENT(KRECVDISPL)) THEN
         KIRECVDISPL_PT => KRECVDISPL
      ELSE
         IF(IMP_TYPE == JP_NON_BLOCKING_STANDARD .OR. IMP_TYPE == JP_NON_BLOCKING_BUFFERED) THEN
            CALL YDDISPLS_LIST%APPEND(KNPROC=IPL_NUMPROC,KRECV_PT=KIRECVDISPL_PT)
         ELSE
            KIRECVDISPL_PT => KIRECVDISPL
         ENDIF
         KIRECVDISPL_PT(:) = 0
         IF(LLSCALAR) THEN
            DO IR=2, IPL_NUMPROC
               KIRECVDISPL_PT(IR) = KIRECVDISPL_PT(IR-1) + 1
            ENDDO
         ELSE
            DO IR=2, IPL_NUMPROC
               KIRECVDISPL_PT(IR) = KIRECVDISPL_PT(IR-1) + KRECVCOUNTS(IR-1)
            ENDDO
         ENDIF
      ENDIF

      DO IR=1, IPL_NUMPROC
         IF(KIRECVDISPL_PT(IR) < 0 .OR. KRECVCOUNTS(IR) < 0) THEN
            WRITE(MPL_ERRUNIT,'(A,4I10)')'MPL_ALLTOALLV: RECV.. < 0 ',&
            & IR,KIRECVDISPL_PT(IR),KRECVCOUNTS(IR)
            CALL MPL_MESSAGE(IERROR,'MPL_ALLTOALLV',CDSTRING,LDABORT=LLABORT)
         ENDIF
         IF(KIRECVDISPL_PT(IR)+KRECVCOUNTS(IR) > IRECVCOUNT) THEN
            WRITE(MPL_ERRUNIT,'(A,4I10)')'MPL_ALLTOALLV:RECV BUFFER TOO SMALL  ', &
            & IR,KIRECVDISPL_PT(IR),KRECVCOUNTS(IR),IRECVCOUNT
            CALL MPL_MESSAGE(IERROR,'MPL_ALLTOALLV',CDSTRING,LDABORT=LLABORT)
         ENDIF
      ENDDO

      IF(PRESENT(KSENDDISPL)) THEN
         KISENDDISPL_PT => KSENDDISPL
      ELSE
         IF(IMP_TYPE == JP_NON_BLOCKING_STANDARD .OR. IMP_TYPE == JP_NON_BLOCKING_BUFFERED) THEN
            CALL YDDISPLS_LIST%APPEND(KSEND_PT = KISENDDISPL_PT,NO_NEW_NODE=.TRUE.)
         ELSE
            KISENDDISPL_PT => KISENDDISPL
         ENDIF
         KISENDDISPL_PT(:) = 0
         IF(LLSCALAR) THEN
            DO IR=2, IPL_NUMPROC
               KISENDDISPL_PT(IR) = KISENDDISPL_PT(IR-1) + 1
            ENDDO
         ELSE
            DO IR=2, IPL_NUMPROC
               KISENDDISPL_PT(IR) = KISENDDISPL_PT(IR-1) + KSENDCOUNTS(IR-1)
            ENDDO
         ENDIF
      ENDIF
      DO IR=1,IPL_NUMPROC
         IF(KISENDDISPL_PT(IR) < 0 .OR. KSENDCOUNTS(IR) < 0) THEN
            WRITE(MPL_ERRUNIT,'(A,4I10)')'MPL_ALLTOALLV:SEND.. <0 ',&
            & IR,KISENDDISPL_PT(IR),KSENDCOUNTS(IR)
            CALL MPL_MESSAGE(IERROR,'MPL_ALLTOALLV',CDSTRING,LDABORT=LLABORT)
         ENDIF
         IF(KISENDDISPL_PT(IR)+KSENDCOUNTS(IR) > ISENDCOUNT) THEN
            WRITE(MPL_ERRUNIT,'(A,4I10)')'MPL_ALLTOALLV:SEND BUFFER TOO SMALL  ', &
            & IR,KISENDDISPL_PT(IR),KSENDCOUNTS(IR),ISENDCOUNT
            CALL MPL_MESSAGE(IERROR,'MPL_ALLTOALLV',CDSTRING,LDABORT=LLABORT)
         ENDIF
      ENDDO

   END SUBROUTINE MPL_ALLTOALLV_PREAMB

   SUBROUTINE MPL_ALLTOALLV_REAL8(PSENDBUF,KSENDCOUNTS,PRECVBUF,KRECVCOUNTS,&
   &KSENDDISPL,KRECVDISPL,KMP_TYPE,KCOMM,KERROR,KREQUEST,CDSTRING)

#ifdef USE_8_BYTE_WORDS
      USE MPI4TO8, ONLY : &
         MPI_ALLTOALLV => MPI_ALLTOALLV8
#endif

      IMPLICIT NONE
      INTEGER(KIND=JPIM), INTENT(IN) :: KSENDCOUNTS(:), KRECVCOUNTS(:)
      REAL(KIND=JPRD), INTENT(IN)  :: PSENDBUF(:)
      REAL(KIND=JPRD), INTENT(OUT) :: PRECVBUF(:)
      INTEGER(KIND=JPIM), INTENT(IN),OPTIONAL :: KCOMM ,KMP_TYPE
      INTEGER(KIND=JPIM), INTENT(IN),OPTIONAL,TARGET :: KSENDDISPL(:),KRECVDISPL(:)
      CHARACTER(LEN=*),INTENT(IN),OPTIONAL :: CDSTRING
      INTEGER(KIND=JPIM),INTENT(OUT),OPTIONAL :: KREQUEST,KERROR

      INTEGER(KIND=JPIM),TARGET  :: IRECVDISPL(MPL_NUMPROC),ISENDDISPL(MPL_NUMPROC)
      INTEGER(KIND=JPIM),POINTER :: KISENDDISPL_PT(:),KIRECVDISPL_PT(:)

      ISENDCOUNT=SIZE(PSENDBUF)
      IRECVCOUNT=SIZE(PRECVBUF)

#ifndef NAGFOR
      IF (ISENDCOUNT > 0) THEN
         IF( (LOC(PSENDBUF(UBOUND(PSENDBUF,1))) - LOC(PSENDBUF(LBOUND(PSENDBUF,1)))) /= 8_JPIB*(ISENDCOUNT - 1) .AND. &
         & ISENDCOUNT > 0 ) THEN
            CALL MPL_MESSAGE(CDMESSAGE='MPL_ALLTOALLV: SENDBUF NOT CONTIGUOUS ',LDABORT=LLABORT)
         ENDIF
      ENDIF

      IF (IRECVCOUNT > 0) THEN
         IF( (LOC(PRECVBUF(UBOUND(PRECVBUF,1))) - LOC(PRECVBUF(LBOUND(PRECVBUF,1)))) /= 8_JPIB*(IRECVCOUNT - 1) .AND. &
         & IRECVCOUNT > 0 ) THEN
            CALL MPL_MESSAGE(CDMESSAGE='MPL_ALLTOALLV: RECVBUF NOT CONTIGUOUS ',LDABORT=LLABORT)
         ENDIF
      ENDIF
#endif

      LLSCALAR=.FALSE.

      IERROR=0
      CALL MPL_ALLTOALLV_PREAMB(KSENDCOUNTS,ISENDDISPL,KISENDDISPL_PT,&
      & KRECVCOUNTS,IRECVDISPL,KIRECVDISPL_PT,KSENDDISPL,KRECVDISPL,KMP_TYPE,KCOMM,KREQUEST,CDSTRING)
      IF(IMP_TYPE == JP_BLOCKING_STANDARD .OR. IMP_TYPE == JP_BLOCKING_BUFFERED) THEN
         CALL MPI_ALLTOALLV(PSENDBUF(:),KSENDCOUNTS,KISENDDISPL_PT,INT(MPI_REAL8), &
         & PRECVBUF(:),KRECVCOUNTS,KIRECVDISPL_PT,INT(MPI_REAL8),ICOMM,IERROR)
      ELSEIF(IMP_TYPE == JP_NON_BLOCKING_STANDARD .OR. IMP_TYPE == JP_NON_BLOCKING_BUFFERED) THEN
         IF(.NOT.PRESENT(KREQUEST)) CALL MPL_MESSAGE(KERROR,'MPL_ALLTOALLV',' KREQUEST MISSING',LDABORT=LLABORT)
         CALL MPI_IALLTOALLV(PSENDBUF(:),KSENDCOUNTS,KISENDDISPL_PT,INT(MPI_REAL8), &
         & PRECVBUF(:),KRECVCOUNTS,KIRECVDISPL_PT,INT(MPI_REAL8),ICOMM,KREQUEST,IERROR)
         IF (.NOT. PRESENT(KSENDDISPL) .OR. .NOT. PRESENT(KRECVDISPL)) THEN
            ! in this case the preamble has set the linked list for the missing displacements
            CALL YDDISPLS_LIST%APPEND(KREQ=KREQUEST,NO_NEW_NODE=.TRUE.)
         END IF
      ELSE
         IF(PRESENT(KERROR)) THEN
            IERROR=1
         ELSE
            CALL MPL_MESSAGE(KERROR,'MPL_ALLTOALLV',' INVALID METHOD',LDABORT=LLABORT)
         ENDIF
      ENDIF

      IF(PRESENT(KERROR)) THEN
         KERROR=IERROR
      ELSE
         IF (IERROR/=0) CALL MPL_MESSAGE(IERROR,'ERROR IN MPL_ALLTOALLV',&
         &LDABORT=LLABORT)
      ENDIF

      IF(LMPLSTATS) THEN
         CALL MPL_SENDSTATS(SUM(KSENDCOUNTS),INT(MPI_REAL8))
         CALL MPL_RECVSTATS(SUM(KRECVCOUNTS),INT(MPI_REAL8))
      ENDIF

   END SUBROUTINE MPL_ALLTOALLV_REAL8

   SUBROUTINE MPL_ALLTOALLV_REAL4(PSENDBUF,KSENDCOUNTS,PRECVBUF,KRECVCOUNTS,&
   &KSENDDISPL,KRECVDISPL,KMP_TYPE,KCOMM,KERROR,KREQUEST,CDSTRING)

#ifdef USE_8_BYTE_WORDS
      USE MPI4TO8, ONLY : &
         MPI_ALLTOALLV => MPI_ALLTOALLV8
#endif

      IMPLICIT NONE
      INTEGER(KIND=JPIM), INTENT(IN) :: KSENDCOUNTS(:), KRECVCOUNTS(:)
      REAL(KIND=JPRM), INTENT(IN)  :: PSENDBUF(:)
      REAL(KIND=JPRM), INTENT(OUT) :: PRECVBUF(:)
      INTEGER(KIND=JPIM), INTENT(IN),OPTIONAL :: KCOMM  ,KMP_TYPE
      INTEGER(KIND=JPIM), INTENT(IN),OPTIONAL,TARGET :: KSENDDISPL(:),KRECVDISPL(:)
      CHARACTER(LEN=*),INTENT(IN),OPTIONAL :: CDSTRING
      INTEGER(KIND=JPIM),INTENT(OUT),OPTIONAL :: KREQUEST,KERROR

      INTEGER(KIND=JPIM),TARGET  :: IRECVDISPL(MPL_NUMPROC),ISENDDISPL(MPL_NUMPROC)
      INTEGER(KIND=JPIM),POINTER :: KISENDDISPL_PT(:),KIRECVDISPL_PT(:)

      ISENDCOUNT=SIZE(PSENDBUF)
      IRECVCOUNT=SIZE(PRECVBUF)

#ifndef NAGFOR
      IF (ISENDCOUNT > 0) THEN
         IF( (LOC(PSENDBUF(UBOUND(PSENDBUF,1))) - LOC(PSENDBUF(LBOUND(PSENDBUF,1)))) /= 4_JPIB*(ISENDCOUNT - 1) ) THEN
            CALL MPL_MESSAGE(CDMESSAGE='MPL_ALLTOALLV: SENDBUF NOT CONTIGUOUS ',LDABORT=LLABORT)
         ENDIF
      ENDIF

      IF (IRECVCOUNT > 0) THEN
         IF( (LOC(PRECVBUF(UBOUND(PRECVBUF,1))) - LOC(PRECVBUF(LBOUND(PRECVBUF,1)))) /= 4_JPIB*(IRECVCOUNT - 1) ) THEN
            CALL MPL_MESSAGE(CDMESSAGE='MPL_ALLTOALLV: RECVBUF NOT CONTIGUOUS ',LDABORT=LLABORT)
         ENDIF
      ENDIF
#endif

      LLSCALAR=.FALSE.

      IERROR=0
      CALL MPL_ALLTOALLV_PREAMB(KSENDCOUNTS,ISENDDISPL,KISENDDISPL_PT,&
      & KRECVCOUNTS,IRECVDISPL,KIRECVDISPL_PT,KSENDDISPL,KRECVDISPL,KMP_TYPE,KCOMM,KREQUEST,CDSTRING)
      IF(IMP_TYPE == JP_BLOCKING_STANDARD .OR. IMP_TYPE == JP_BLOCKING_BUFFERED) THEN
         CALL MPI_ALLTOALLV(PSENDBUF(1),KSENDCOUNTS,KISENDDISPL_PT,INT(MPI_REAL4), &
         & PRECVBUF(:),KRECVCOUNTS,KIRECVDISPL_PT,INT(MPI_REAL4),ICOMM,IERROR)
      ELSEIF(IMP_TYPE == JP_NON_BLOCKING_STANDARD .OR. IMP_TYPE == JP_NON_BLOCKING_BUFFERED) THEN
         CALL MPI_IALLTOALLV(PSENDBUF(1),KSENDCOUNTS,KISENDDISPL_PT,INT(MPI_REAL4), &
         & PRECVBUF(:),KRECVCOUNTS,KIRECVDISPL_PT,INT(MPI_REAL4),ICOMM,KREQUEST,IERROR)
         IF (.NOT. PRESENT(KSENDDISPL) .OR. .NOT. PRESENT(KRECVDISPL)) THEN
            CALL YDDISPLS_LIST%APPEND(KREQ=KREQUEST,NO_NEW_NODE=.TRUE.)
         END IF
      ELSE
         IF(PRESENT(KERROR)) THEN
            IERROR=1
         ELSE
            CALL MPL_MESSAGE(KERROR,'MPL_ALLTOALLV',' INVALID METHOD',LDABORT=LLABORT)
         ENDIF
      ENDIF

      IF(PRESENT(KERROR)) THEN
         KERROR=IERROR
      ELSE
         IF (IERROR/=0) CALL MPL_MESSAGE(IERROR,'ERROR IN MPL_ALLTOALLV',&
         &LDABORT=LLABORT)
      ENDIF

      IF(LMPLSTATS) THEN
         CALL MPL_SENDSTATS(SUM(KSENDCOUNTS),INT(MPI_REAL4))
         CALL MPL_RECVSTATS(SUM(KRECVCOUNTS),INT(MPI_REAL4))
      ENDIF

   END SUBROUTINE MPL_ALLTOALLV_REAL4


   SUBROUTINE MPL_ALLTOALLV_INTEGER(KSENDBUF,KSENDCOUNTS,KRECVBUF,KRECVCOUNTS,&
   &KSENDDISPL,KRECVDISPL,KMP_TYPE,KCOMM,KERROR,KREQUEST,CDSTRING)

#ifdef USE_8_BYTE_WORDS
      USE MPI4TO8, ONLY : &
         MPI_ALLTOALLV => MPI_ALLTOALLV8
#endif

      IMPLICIT NONE
      INTEGER(KIND=JPIM), INTENT(IN) :: KSENDCOUNTS(:), KRECVCOUNTS(:)
      INTEGER(KIND=JPIM), INTENT(IN)  :: KSENDBUF(:)
      INTEGER(KIND=JPIM), INTENT(OUT) :: KRECVBUF(:)
      INTEGER(KIND=JPIM), INTENT(IN),OPTIONAL,TARGET :: KSENDDISPL(:), KRECVDISPL(:)
      INTEGER(KIND=JPIM), INTENT(IN),OPTIONAL        :: KCOMM,KMP_TYPE
      CHARACTER(LEN=*),INTENT(IN),OPTIONAL :: CDSTRING
      INTEGER(KIND=JPIM),INTENT(OUT),OPTIONAL :: KREQUEST,KERROR

      INTEGER(KIND=JPIM),TARGET  :: IRECVDISPL(MPL_NUMPROC),ISENDDISPL(MPL_NUMPROC)
      INTEGER(KIND=JPIM),POINTER :: KISENDDISPL_PT(:),KIRECVDISPL_PT(:)

      ISENDCOUNT=SIZE(KSENDBUF)
      IRECVCOUNT=SIZE(KRECVBUF)

#ifndef NAGFOR
      IF (ISENDCOUNT > 0) THEN
         IF( (LOC(KSENDBUF(UBOUND(KSENDBUF,1))) - LOC(KSENDBUF(LBOUND(KSENDBUF,1)))) /= 4_JPIB*(ISENDCOUNT - 1) ) THEN
            CALL MPL_MESSAGE(CDMESSAGE='MPL_ALLTOALLV: SENDBUF NOT CONTIGUOUS ',LDABORT=LLABORT)
         ENDIF
      ENDIF

      IF (IRECVCOUNT > 0) THEN
         IF( (LOC(KRECVBUF(UBOUND(KRECVBUF,1))) - LOC(KRECVBUF(LBOUND(KRECVBUF,1)))) /= 4_JPIB*(IRECVCOUNT - 1) ) THEN
            CALL MPL_MESSAGE(CDMESSAGE='MPL_ALLTOALLV: RECVBUF NOT CONTIGUOUS ',LDABORT=LLABORT)
         ENDIF
      ENDIF
#endif

      LLSCALAR=.FALSE.

      IERROR=0
      CALL MPL_ALLTOALLV_PREAMB(KSENDCOUNTS,ISENDDISPL,KISENDDISPL_PT,&
      & KRECVCOUNTS,IRECVDISPL,KIRECVDISPL_PT,KSENDDISPL,KRECVDISPL,KMP_TYPE,KCOMM,KREQUEST,CDSTRING)
      IF(IMP_TYPE == JP_BLOCKING_STANDARD .OR. IMP_TYPE == JP_BLOCKING_BUFFERED) THEN
         CALL MPI_ALLTOALLV(KSENDBUF(1),KSENDCOUNTS,KISENDDISPL_PT,INT(MPI_INTEGER), &
         & KRECVBUF(1),KRECVCOUNTS,KIRECVDISPL_PT,INT(MPI_INTEGER),ICOMM,IERROR)
      ELSEIF(IMP_TYPE == JP_NON_BLOCKING_STANDARD .OR. IMP_TYPE == JP_NON_BLOCKING_BUFFERED) THEN
         IF(.NOT.PRESENT(KREQUEST)) CALL MPL_MESSAGE(KERROR,'MPL_ALLTOALLV',' KREQUEST MISSING',LDABORT=LLABORT)
         CALL MPI_IALLTOALLV(KSENDBUF(1),KSENDCOUNTS,KISENDDISPL_PT,INT(MPI_INTEGER), &
         & KRECVBUF(1),KRECVCOUNTS,KIRECVDISPL_PT,INT(MPI_INTEGER),ICOMM,KREQUEST,IERROR)
         IF (.NOT. PRESENT(KSENDDISPL) .OR. .NOT. PRESENT(KRECVDISPL)) THEN
            CALL YDDISPLS_LIST%APPEND(KREQ=KREQUEST,NO_NEW_NODE=.TRUE.)
         END IF
      ELSE
         IF(PRESENT(KERROR)) THEN
            IERROR=1
         ELSE
            CALL MPL_MESSAGE(KERROR,'MPL_ALLTOALLV',' INVALID METHOD',LDABORT=LLABORT)
         ENDIF
      ENDIF

      IF(PRESENT(KERROR)) THEN
         KERROR=IERROR
      ELSE
         IF (IERROR/=0) CALL MPL_MESSAGE(IERROR,'ERROR IN MPL_ALLTOALLV',&
         &LDABORT=LLABORT)
      ENDIF

      IF(LMPLSTATS) THEN
         CALL MPL_SENDSTATS(SUM(KSENDCOUNTS),INT(MPI_INTEGER))
         CALL MPL_RECVSTATS(SUM(KRECVCOUNTS),INT(MPI_INTEGER))
      ENDIF

   END SUBROUTINE MPL_ALLTOALLV_INTEGER

! ------------------------------------------------------------------

END MODULE MPL_ALLTOALLV_MOD

! (C) Copyright 2005- ECMWF.
! (C) Copyright 2013- Meteo-France.
! 
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!

SUBROUTINE GSTATS_PRINT(KULOUT,PAVEAVE,KLEN)

!**** *GSTATS_PRINT* - print timing statistics

!     PURPOSE.
!     --------
!       To print out timings gathered by GSTATS


!**   INTERFACE.
!     ----------
!       *CALL* *GSTATS_PRINT*

!        EXPLICIT ARGUMENTS     None
!        --------------------


!        IMPLICIT ARGUMENTS
!        --------------------
!        Module YOMSTATS

!     METHOD.
!     -------


!     EXTERNALS.   
!     ----------   

!     REFERENCE.
!     ----------
!        ECMWF Research Department documentation of the IFS

!     AUTHOR.
!     -------
!        Mats Hamrud ECMWF

!     MODIFICATIONS.
!     --------------
!        ORIGINAL : 98-11-15
!        D.Salmond: 99-09-21 : Timer for SLCOMM2
!        G.Mozdzynski 05-09-25 : fix master ncalls overwrite for nproc>1
!        C.Larsson    8-May-2006 : Added xml file output
!        G.Mozdzynski 16-Oct-2007 : xml file output under switch LXML_STATS
!        P.Towers     11-May-2011 : mpl comms statistics output
!        F. Vana  05-Mar-2015  Support for single precision
!        G. Mozdzynski 18-Aug-2015 Avoid confusion, procs are tasks
!        M. Plesske 05-Nov-2025 added LCSV_STATS
!     ------------------------------------------------------------------

USE EC_PARKIND, ONLY: JPRD, JPIM
USE YOMGSTATS, ONLY: JPMAXDELAYS, JPMAXSTAT, NPROC_STATS, LXML_STATS, LCSV_STATS, MYPROC_STATS, LSYNCSTATS, &
  &                  LDETAILED_STATS, LSTATS_COMMS, LSTATS_OMP, LBARRIER_STATS2, JBMAXBASE, &
  &                  NBAR_PTR, CCDESC, CCTYPE, LSTATS, TIMESUM, TIMESQSUM, TIMEMAX, TIMESUMB, &
  &                  TIMELCALL, NCALLS, TTCPUSUM, TVCPUSUM, JPTAGSTAT, NPRCIDS_STATS, LSTATS_MPL, &
  &                  NUMSEND, SENDBYTES, NUMRECV, RECVBYTES, LSTATSCPU, NPRNT_STATS, TIME_START, &
  &                  UNKNOWN_NUMSEND, UNKNOWN_NUMRECV, UNKNOWN_SENDBYTES, UNKNOWN_RECVBYTES, &
  &                  NDELAY_INDEX, NDELAY_COUNTER, TDELAY_VALUE, CDELAY_TIME, LTRACE_STATS, &
  &                  NCALLS_TOTAL, NTRACE_STATS, NCALL_TRACE, TIME_TRACE, LSTATS_MEM, NTMEM
USE MPL_MODULE, ONLY: MPL_SEND, MPL_RECV, MPL_BARRIER

IMPLICIT NONE

INTEGER(KIND=JPIM) :: KULOUT,KLEN
REAL(KIND=JPRD) :: PAVEAVE(0:KLEN)
CHARACTER*7  CLACTION(0:3)
CHARACTER(LEN=JPMAXDELAYS*10) CLTEMP
CHARACTER(LEN=128) :: CLCSVNAME
CHARACTER(LEN=32) :: CLCSVCOLS(15)

INTEGER(KIND=JPIM),PARAMETER :: JPARRAYS=8
REAL(KIND=JPRD) :: ZREABUF(JPARRAYS*(JPMAXSTAT+1))
REAL(KIND=JPRD) :: ZAVEAVE(0:JPMAXSTAT),ZAVEMAX(0:JPMAXSTAT),ZTIMELCALL(0:JPMAXSTAT),&
         &ZTHISTIME(0:JPMAXSTAT),ZFRACMAX(0:JPMAXSTAT),&
         &ZSUMMAX(0:JPMAXSTAT),ZSUMTOT(0:JPMAXSTAT)
REAL(KIND=JPRD) :: ZT_SUM,ZT_SUM2,ZT_SUM3,ZT_SUMIO,ZT_SUM4,ZT_SUM5,ZT_SUMB
REAL(KIND=JPRD) :: ZDELAY,ZDELAY_MAX

REAL(KIND=JPRD) :: ZMPL(NPROC_STATS)
REAL(KIND=JPRD) :: ZBAR(NPROC_STATS)
REAL(KIND=JPRD) :: ZGBR(NPROC_STATS)
REAL(KIND=JPRD) :: ZGB2(NPROC_STATS)
REAL(KIND=JPRD) :: ZOMP(NPROC_STATS)
REAL(KIND=JPRD) :: ZIO (NPROC_STATS)
REAL(KIND=JPRD) :: ZSER(NPROC_STATS)
REAL(KIND=JPRD) :: ZMXD(NPROC_STATS)

INTEGER(KIND=JPIM) :: ICALLSX(0:JPMAXSTAT)

!     LOCAL INTEGER SCALARS
INTEGER(KIND=JPIM) :: ICALLS, ILBUF, ILSEND, ILRECV, &
             &ISEND, ITAG, JJ, JNUM, JROC, JCALL, ICALLER,IACTION
INTEGER(KIND=JPIM) :: IMEM, INUM, JMEM
INTEGER(KIND=JPIM) :: JDELAY, IDELAY
INTEGER(KIND=JPIM) :: NSEND,NRECV

!     LOCAL REAL SCALARS
REAL(KIND=JPRD) :: ZAVE, ZAVETCPU, ZAVEVCPU, ZCOMTIM, ZDETAIL,&
          &ZFRAC, ZMAX, ZMEAN, ZSTDDEV, ZSUM, ZSUMB, &
          &ZTOTAL, ZTOTCPU, ZTOTUNBAL, ZTOTVCPU, &
          &ZUNBAL, ZMEANT, ZMAXT

REAL(KIND=JPRD)    :: SBYTES,RBYTES,SENDRATE,RECVRATE
REAL(KIND=JPRD)    :: AVGSENDLEN,AVGRECVLEN
REAL(KIND=JPRD)    :: MAXCOMMTIME(501:1000)
REAL(KIND=JPRD)    :: TOTSENDBYTES(501:1000)
REAL(KIND=JPRD)    :: TOTRECVBYTES(501:1000)
REAL(KIND=JPRD)    :: TOTSENDBYTESSUM
REAL(KIND=JPRD)    :: TOTRECVBYTESSUM
INTEGER(KIND=JPIM) :: IXMLLUN, ICSVUN

!     ------------------------------------------------------------------

ILBUF = JPARRAYS*(JPMAXSTAT+1)
ILRECV = 500*4
ZAVEAVE(:) = 0.0_JPRD
ZAVEMAX(:) = 0.0_JPRD
ZFRACMAX(:)= 0.0_JPRD
ZSUMMAX(:)= 0.0_JPRD
ZSUMTOT(:)= 0.0_JPRD

! OPEN GSTATS.XML for xml statistics
IF(LXML_STATS .AND. MYPROC_STATS==1)THEN
  IXMLLUN=40
  OPEN (UNIT=IXMLLUN, FILE='gstats.xml',ACTION='write')
  WRITE(IXMLLUN,'(A)')'<?xml version="1.0" encoding="UTF-8"?>'
  WRITE(IXMLLUN,'(A)')'<gstats '
  WRITE(IXMLLUN,'(A)')' xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"&
  & xsi:schemaLocation="http://www.ecmwf.int/services/prepifs/gstats   ./gstats.xsd">'
ENDIF

WRITE(KULOUT,'(A)')'===-=== START OF TIMING STATISTICS ===-==='
IF(LSYNCSTATS.AND.NPROC_STATS>1) THEN
  WRITE(KULOUT,'(A)')'START OF TIMINGS SYNCRONIZED'
ENDIF
IF(LDETAILED_STATS) THEN
  LSTATS_COMMS=.TRUE.
  LSTATS_OMP=.TRUE.
ENDIF
IF(LBARRIER_STATS2) THEN
  DO JNUM=1,JBMAXBASE
    IF(NBAR_PTR(JNUM) > 0) THEN
      INUM=NBAR_PTR(JNUM)
      CCDESC(INUM)=CCDESC(JNUM)
      CCTYPE(INUM)='GB2'
    ENDIF
  ENDDO
ENDIF

! Number 400 and 401 are reserved for overall GSTATS timing, so if no label is set, use "GSTATS" and "GSTATS HOOK"
! These are the labels used in gstats_ifs_setup.F90
IF (LEN_TRIM(CCDESC(400)) == 0) THEN
  CCDESC(400) = 'GSTATS'
ENDIF
IF (LEN_TRIM(CCDESC(401)) == 0) THEN
  CCDESC(401) = 'GSTATS HOOK'
ENDIF

! CSV OUTPUT FOR EACH RANK
IF (LSTATS .AND. LCSV_STATS) THEN
  ! OPENING THE FILE
  WRITE(CLCSVNAME, '(A,I0,A)') 'gstats.', MYPROC_STATS, '.csv'
  IF (NPROC_STATS <= 1) WRITE(KULOUT, '(A,A)')    "GSTATS writing file ", CLCSVNAME
  IF (NPROC_STATS  > 1) WRITE(KULOUT, '(A,I0,A)') "GSTATS writing files gstats.{1..", NPROC_STATS, "}.csv"
  OPEN (NEWUNIT=ICSVUN, FILE=CLCSVNAME, ACTION='write')
  !write header
  WRITE(ICSVUN,'(A)') 'GSTATS ID, SECTION, NUMCALLS, TOTAL TIME, MAX TIME, AVE TIME, AVE TIME CPU, AVE TIME VECTOR, STDDEV, NUMSENDS, BYTES SEND, AVE BYTES SEND, NUMRECVS, BYTES RECV, AVE BYTES RECV'

  ! WRITING OUTPUT FOR EVERY RECORDED GSTATS SECTION
  DO JNUM=0,JPMAXSTAT
    CLCSVCOLS(:)='NaN'
    IF (NCALLS(JNUM) > 1) THEN   
      ! TIMING INFORMATION
      ICALLS = NCALLS(JNUM)/2
      IF (ICALLS > 1) THEN
        ZSTDDEV = 1000._JPRD*SQRT(MAX((TIMESQSUM(JNUM)-TIMESUM(JNUM)**2/REAL(ICALLS,JPRD))/REAL(ICALLS-1,JPRD),0.0_JPRD))
      ELSE
        ZSTDDEV= 0.0_JPRD
      ENDIF
      WRITE(CLCSVCOLS(1), '(I0)') JNUM
      CLCSVCOLS(2) = CCDESC(JNUM)
      WRITE(CLCSVCOLS(3), '(I0)') ICALLS
      WRITE(CLCSVCOLS(4), '(F0.6)') TIMESUM(JNUM)
      WRITE(CLCSVCOLS(5), '(F0.6)') TIMEMAX(JNUM)*1000._JPRD
      WRITE(CLCSVCOLS(6), '(F0.6)') TIMESUM(JNUM)/ICALLS*1000._JPRD
      WRITE(CLCSVCOLS(7), '(F0.6)') TTCPUSUM(JNUM)/ICALLS*1000._JPRD
      WRITE(CLCSVCOLS(8), '(F0.6)') TVCPUSUM(JNUM)/ICALLS*1000._JPRD
      WRITE(CLCSVCOLS(9), '(F0.6)') ZSTDDEV
     
      ! COMMUNICATION INFORMATION
      IF (LSTATS_MPL .AND. JNUM > 500 .AND. JNUM < 1001) THEN
        IF(NUMSEND(JNUM) /= 0) THEN
          AVGSENDLEN=SENDBYTES(JNUM)*1.E-3_JPRD/NUMSEND(JNUM)
        ELSE
          AVGSENDLEN=0.0_JPRD
        ENDIF
        IF(NUMRECV(JNUM) /= 0) THEN
          AVGRECVLEN=RECVBYTES(JNUM)*1.E-3_JPRD/NUMRECV(JNUM)
        ELSE
          AVGRECVLEN=0.0_JPRD
        ENDIF
        WRITE(CLCSVCOLS(10), '(I0)') NUMSEND(JNUM)
        WRITE(CLCSVCOLS(11), '(F0.6)') SENDBYTES(JNUM)
        WRITE(CLCSVCOLS(12), '(F0.6)') AVGSENDLEN
        WRITE(CLCSVCOLS(13), '(I0)') NUMRECV(JNUM)
        WRITE(CLCSVCOLS(14), '(F0.6)') RECVBYTES(JNUM)
        WRITE(CLCSVCOLS(15), '(F0.6)') AVGRECVLEN
      ENDIF
      ! WRITE TO CSV FILE
      DO JJ = 1, 14
        WRITE(ICSVUN, '(2A)', advance='no') TRIM(CLCSVCOLS(JJ)), ','
      ENDDO
      WRITE(ICSVUN, '(A)') TRIM(CLCSVCOLS(15))
    ENDIF
  ENDDO

  ! CLOSING CSV FILES
  CLOSE(ICSVUN) 
ENDIF

! COLLECTING ALL INFORMATION AT RANK 1 AND COMPUTING FURTHER METRICS
IF (LSTATS .AND. MYPROC_STATS /= 1) THEN
  JJ = 1
  DO JNUM=0,JPMAXSTAT
    ZREABUF(JJ  ) = TIMESUM(JNUM)
    ZREABUF(JJ+1) = TIMESQSUM(JNUM)
    ZREABUF(JJ+2) = TIMEMAX(JNUM)
    ZREABUF(JJ+3) = TIMESUMB(JNUM)
    ZREABUF(JJ+4) = TIMELCALL(JNUM)
    ZREABUF(JJ+5) = NCALLS(JNUM)
    ZREABUF(JJ+6) = TTCPUSUM(JNUM)
    ZREABUF(JJ+7) = TVCPUSUM(JNUM)
    JJ = JJ+JPARRAYS
  ENDDO
  ILSEND = ILBUF
  ISEND =1
  ITAG = JPTAGSTAT
  CALL MPL_SEND(ZREABUF(1:ILSEND),KDEST=NPRCIDS_STATS(ISEND), &
       & KTAG=ITAG,CDSTRING='GSTATS_PRINT:')

  IF(LSTATS_MPL) THEN
    JJ=1
    DO JNUM=501,1000
      ZREABUF(JJ  ) = NUMSEND(JNUM)
      ZREABUF(JJ+1) = SENDBYTES(JNUM)
      ZREABUF(JJ+2) = NUMRECV(JNUM)
      ZREABUF(JJ+3) = RECVBYTES(JNUM)
      JJ=JJ+4
    ENDDO

    ILSEND = JJ-1
    ITAG = JPTAGSTAT + 1

    CALL MPL_SEND(ZREABUF(1:ILSEND),KDEST=NPRCIDS_STATS(ISEND), &
         & KTAG=ITAG,CDSTRING='GSTATS_PRINT:')

  ENDIF
ELSEIF(LSTATS) THEN
  IF(LSTATS_MPL) THEN
    DO JNUM=501,1000
      MAXCOMMTIME(JNUM)=0.0_JPRD
      TOTSENDBYTES(JNUM)=0.0_JPRD
      TOTRECVBYTES(JNUM)=0.0_JPRD
    ENDDO
  ENDIF
  DO JROC=1,NPROC_STATS
    IF (JROC /= 1) THEN
      ITAG = JPTAGSTAT
      CALL MPL_RECV(ZREABUF(1:ILBUF),KSOURCE=NPRCIDS_STATS(JROC), &
       & KTAG=ITAG,CDSTRING='GSTATS_PRINT:')
      JJ = 1
      DO JNUM=0,JPMAXSTAT
        TIMESUM(JNUM)   = ZREABUF(JJ  )
        TIMESQSUM(JNUM) = ZREABUF(JJ+1)
        TIMEMAX(JNUM)   = ZREABUF(JJ+2)
        TIMESUMB(JNUM)  = ZREABUF(JJ+3)
        TIMELCALL(JNUM) = ZREABUF(JJ+4)
        ICALLSX(JNUM)    = NINT(ZREABUF(JJ+5))
        TTCPUSUM(JNUM)  = ZREABUF(JJ+6)
        TVCPUSUM(JNUM)  = ZREABUF(JJ+7)
        JJ = JJ+JPARRAYS
      ENDDO

      IF(LSTATS_MPL) THEN
        ITAG = JPTAGSTAT+1
        CALL MPL_RECV(ZREABUF(1:ILRECV),KSOURCE=NPRCIDS_STATS(JROC), &
         & KTAG=ITAG,CDSTRING='GSTATS_PRINT:')
        JJ = 1
        DO JNUM=501,1000
          NUMSEND(JNUM)   = NINT(ZREABUF(JJ))
          SENDBYTES(JNUM) = ZREABUF(JJ+1)
          NUMRECV(JNUM)   = NINT(ZREABUF(JJ+2))
          RECVBYTES(JNUM) = ZREABUF(JJ+3)
          JJ=JJ+4
        ENDDO
      ENDIF

    ELSE
      ICALLSX(:)=NCALLS(:)

    ENDIF
    IF (JROC == 1) THEN
      ZTOTAL=TIMESUM(0)
      ZTOTCPU = TTCPUSUM(0)
      ZTOTVCPU = TVCPUSUM(0)
    ENDIF
    IF(.NOT. LSTATSCPU) THEN
      TTCPUSUM(1:JPMAXSTAT) = -0.0_JPRD
      TVCPUSUM(1:JPMAXSTAT) = -0.0_JPRD
    ENDIF
    ZT_SUM=0.0_JPRD
    ZT_SUM2=0.0_JPRD
    ZT_SUM3=0.0_JPRD
    ZT_SUM4=0.0_JPRD
    ZT_SUM5=0.0_JPRD
    ZT_SUMIO=0.0_JPRD
    ZT_SUMB=0.0_JPRD
    IF( LDETAILED_STATS .AND. JROC <= NPRNT_STATS ) THEN
      WRITE(KULOUT,'(A,I4)') 'TIMING STATISTICS:TASK=',JROC
      IF(LXML_STATS)THEN
        WRITE(IXMLLUN,'(A,I4,A)')'<timing task="',JROC,'">'
      ENDIF
      IF(NPROC_STATS > 1) THEN
        WRITE(KULOUT,'(A,F6.1,A)')'STARTUP COST ',&
         &TIME_START(JROC),' SECONDS'
      ENDIF
      WRITE(KULOUT,'(A)')&
       &' NUM     ROUTINE                                     '//&
       &'CALLS  SUM(s)   AVE(ms)   CPUAVE(ms) VAVE(ms) '//&
       &'STDDEV(ms)  MAX(ms) '//&
       &'SUMB(s) FRAC(%)'
    ENDIF
    DO JNUM=0,JPMAXSTAT
      IF(ICALLSX(JNUM) > 1) THEN
        ICALLS = ICALLSX(JNUM)/2
        ZSUM = TIMESUM(JNUM)
        ZAVE = TIMESUM(JNUM)/ICALLS*1000._JPRD
        ZMAX = TIMEMAX(JNUM)*1000._JPRD
        ZSUMB = TIMESUMB(JNUM)
        ZFRAC = TIMESUM(JNUM)/ZTOTAL*100.0_JPRD
        ZFRACMAX(JNUM)=MAX(ZFRACMAX(JNUM),ZFRAC)
        ZSUMMAX(JNUM)=MAX(ZSUMMAX(JNUM),TIMESUM(JNUM))
        ZSUMTOT(JNUM)=ZSUMTOT(JNUM)+ZSUM
        ZAVEAVE(JNUM)=ZAVEAVE(JNUM)+ZAVE
        ZAVEMAX(JNUM)=MAX(ZAVEMAX(JNUM),ZAVE)
        ZAVETCPU = TTCPUSUM(JNUM)/ICALLS*1000._JPRD
        ZAVEVCPU = TVCPUSUM(JNUM)/ICALLS*1000._JPRD
        IF(ICALLS > 1 ) THEN
          ZSTDDEV = 1000._JPRD*&
           &SQRT(MAX((TIMESQSUM(JNUM)-TIMESUM(JNUM)**2/ICALLS)&
           &/(ICALLS-1),0.0_JPRD))
        ELSE
          ZSTDDEV = 0.0_JPRD
        ENDIF
        IF(CCTYPE(JNUM).EQ.'MPL') THEN
          ZT_SUM=ZT_SUM+ZSUM
          ZT_SUMB=ZT_SUMB+ZSUMB
        ENDIF
        IF(CCTYPE(JNUM).EQ.'BAR' .OR. CCTYPE(JNUM).EQ.'GBR' .OR. CCTYPE(JNUM).EQ.'GB2' ) THEN
          ZT_SUM4=ZT_SUM4+ZSUM
          ZT_SUMB=ZT_SUMB+ZSUMB
        ENDIF
        IF(CCTYPE(JNUM).EQ.'OMP') THEN
          ZT_SUM2=ZT_SUM2+ZSUM
          ZT_SUMB=ZT_SUMB+ZSUMB
        ENDIF
        IF(CCTYPE(JNUM).EQ.'IO-') THEN
          ZT_SUMIO=ZT_SUMIO+ZSUM
          ZT_SUMB=ZT_SUMB+ZSUMB
        ENDIF
        IF(CCTYPE(JNUM).EQ.'SER') THEN
          ZT_SUM3=ZT_SUM3+ZSUM
          ZT_SUMB=ZT_SUMB+ZSUMB
        ENDIF
        IF(CCTYPE(JNUM).EQ.'MXD') THEN
          ZT_SUM5=ZT_SUM5+ZSUM
          ZT_SUMB=ZT_SUMB+ZSUMB
        ENDIF
        IF( LDETAILED_STATS .AND. JROC <= NPRNT_STATS ) THEN
            WRITE(KULOUT,'(I4,1X,A3,1X,A40,1X,I5,6(1X,F9.1),1X,F5.1,1X,F8.2)')&
             &JNUM,CCTYPE(JNUM),CCDESC(JNUM),ICALLS,ZSUM,ZAVE,ZAVETCPU,ZAVEVCPU,&
             &ZSTDDEV,ZMAX,ZSUMB,ZFRAC
            IF(LXML_STATS)THEN
              WRITE(IXMLLUN,&
               & '(A,I4,A,/,A,A40,A,/,A,I5,A,/,6(A,F9.1,A,/),A,F5.1,A,/,A,F8.2,A,/,A)')&
               & '<num id="',JNUM,'">',&
               & '<description>',CCDESC(JNUM),'</description>',&
               & '<sum unit="seconds">',ICALLS,'</sum>',&
               & '<sumcall unit="ms">',ZSUM,'</sumcall>',&
               & '<average unit="ms">',ZAVE,'</average>',&
               & '<cpuaverage unit="ms">',ZAVETCPU,'</cpuaverage>',&
               & '<vave unit="ms">',ZAVEVCPU,'</vave>',&
               & '<stddev unit="ms">',ZSTDDEV,'</stddev>',&
               & '<max unit="ms">',ZMAX,'</max>',&
               & '<sumb unit="seconds">',ZSUMB,'</sumb>',&
               & '<frac unit="percent">',ZFRAC,'</frac>',&
               & '</num>'
             ENDIF
        ENDIF
      ENDIF
    ENDDO
    IF( LDETAILED_STATS .AND. JROC <= NPRNT_STATS ) THEN
      WRITE(KULOUT,*) ''
      WRITE(KULOUT,'((A,2F8.1))')&
       &'CPU-TIME AND VECTOR CPU-TIME AS PERCENT OF TOTAL ',&
       &TTCPUSUM(0)/TIMESUM(0)*100.0_JPRD,TVCPUSUM(0)/TIMESUM(0)*100.0_JPRD
      IF(LXML_STATS)THEN
        WRITE(IXMLLUN,'((A,F8.1,A,/,A,F8.1,A))')&
         &'<cpufraction>',&
         &TTCPUSUM(0)/TIMESUM(0)*100.0_JPRD,&
         &'</cpufraction>',&
         &'<cpuvectorfraction>',&
         &TVCPUSUM(0)/TIMESUM(0)*100.0_JPRD,&
         &'</cpuvectorfraction>'
      ENDIF


      IF(ZT_SUM > 0.0_JPRD) THEN
        WRITE(KULOUT,'(A,F10.1,A,F6.2,A)')'SUMMED TIME IN COMMUNICATIONS   = '&
         & ,ZT_SUM, ' SECONDS ',ZT_SUM/TIMESUM(0)*100.0_JPRD,&
         &' PERCENT OF TOTAL'
        IF(LXML_STATS)THEN
          WRITE(IXMLLUN,'(A,F10.1,A,/,A,F6.2,A)')'<zcom unit="seconds">',&
           &ZT_SUM,'</zcom>',&
           &'<fraczcom unit="percent">',ZT_SUM/TIMESUM(0)*100.0_JPRD,&
           &'</fraczcom>'
        ENDIF
      ENDIF
      IF(ZT_SUM2 > 0.0_JPRD) THEN
        WRITE(KULOUT,'(A,F10.1,A,F6.2,A)')'SUMMED TIME IN PARALLEL REGIONS = '&
         & ,ZT_SUM2, ' SECONDS ',ZT_SUM2/TIMESUM(0)*100.0_JPRD,&
         &' PERCENT OF TOTAL'
        IF(LXML_STATS)THEN
          WRITE(IXMLLUN,'(A,F10.1,A,/,A,F6.2,A)') &
           &'<parallelztime unit="seconds">',&
           &ZT_SUM2, '</parallelztime>',&
           &'<fracparallelztime unit="percent">',ZT_SUM2/TIMESUM(0)*100.0_JPRD,&
           &'</fracparallelztime>'
        ENDIF
      ENDIF
      IF(ZT_SUMIO > 0.0_JPRD) THEN
        WRITE(KULOUT,'(A,F10.1,A,F6.2,A)')'SUMMED TIME IN I/O SECTIONS     = '&
         & ,ZT_SUMIO, ' SECONDS ',ZT_SUMIO/TIMESUM(0)*100.0_JPRD,&
         &' PERCENT OF TOTAL'
        IF(LXML_STATS)THEN
          WRITE(IXMLLUN,'(A,F10.1,A,/,A,F6.2,A)')'<ioztime unit="seconds">',&
           &ZT_SUMIO, '</ioztime>',&
           &'<fracioztime unit="percent">',ZT_SUMIO/TIMESUM(0)*100.0_JPRD,&
           &'</fracioztime>'
        ENDIF
      ENDIF
      IF(ZT_SUM3 > 0.0_JPRD) THEN
        WRITE(KULOUT,'(A,F10.1,A,F6.2,A)')'SUMMED TIME IN SERIAL SECTIONS  = '&
        & ,ZT_SUM3, ' SECONDS ',ZT_SUM3/TIMESUM(0)*100.0_JPRD,&
         &' PERCENT OF TOTAL'
        IF(LXML_STATS)THEN
          WRITE(IXMLLUN,'(A,F10.1,A,/,A,F6.2,A)')'<serialztime unit="seconds">',&
           & ZT_SUM3,'</serialztime>',&
           &'<fracserialztime unit="percent">',&
           &ZT_SUM3/TIMESUM(0)*100.0_JPRD,&
           &'</fracserialztime>'
        ENDIF
      ENDIF
      IF(ZT_SUM4 > 0.0_JPRD) THEN
        WRITE(KULOUT,'(A,F10.1,A,F6.2,A)')'SUMMED TIME IN BARRIERS         = '&
         & ,ZT_SUM4, ' SECONDS ',ZT_SUM4/TIMESUM(0)*100.0_JPRD,&
         &' PERCENT OF TOTAL'
        IF(LXML_STATS)THEN
          WRITE(IXMLLUN,'(A,F10.1,A,/,A,F6.2,A)')&
           &'<barrierztime unit="seconds">',&
           &ZT_SUM4,'</barrierztime>',&
           & '<fracbarrierztime unit="percent">',&
           & ZT_SUM4/TIMESUM(0)*100.0_JPRD,'</fracbarrierztime>'
        ENDIF
      ENDIF
      IF(ZT_SUM5 > 0.0_JPRD) THEN
        WRITE(KULOUT,'(A,F10.1,A,F6.2,A)')'SUMMED TIME IN MIXED SECTIONS   = '&
         & ,ZT_SUM5, ' SECONDS ',ZT_SUM5/TIMESUM(0)*100.0_JPRD,&
         &' PERCENT OF TOTAL'
        WRITE(IXMLLUN,'(A,F10.1,A,/,A,F6.2,A)')&
         &'<mixedztime unit="seconds">',&
         &ZT_SUM5,'</mixedztime>',&
         & '<fracmixedztime unit="percent">',&
         & ZT_SUM5/TIMESUM(0)*100.0_JPRD,'</fracmixedztime>'
      ENDIF
      IF(LSTATS_COMMS.AND.LSTATS_OMP)THEN
        WRITE(KULOUT,'(A,F8.2)')'FRACTION OF TOTAL TIME ACCOUNTED FOR ',&
         & (ZT_SUM+ZT_SUM2+ZT_SUMIO+ZT_SUM3+ZT_SUM4+ZT_SUM5)/TIMESUM(0)*100.0_JPRD
        WRITE(KULOUT,'(A,F8.2)')'FRACTION OF TOTAL TIME ACCOUNTED FOR INCLUDING SUMB ',&
         & (ZT_SUM+ZT_SUM2+ZT_SUMIO+ZT_SUM3+ZT_SUM4+ZT_SUM5+ZT_SUMB)/TIMESUM(0)*100.0_JPRD
        WRITE(KULOUT,'(" ")')
        IF(LXML_STATS)THEN
          WRITE(IXMLLUN,'(A,F8.2,A)')'<fractotal unit="percent">',&
           &(ZT_SUM+ZT_SUM2+ZT_SUMIO+ZT_SUM3+ZT_SUM4+ZT_SUM5)/TIMESUM(0)*100.0_JPRD,&
           &'</fractotal>'
        ENDIF
      ENDIF
    ENDIF
    IF( LDETAILED_STATS .AND. JROC < 3 ) THEN
      IF(LXML_STATS)THEN
        WRITE(IXMLLUN,'(A)')'</timing>'
      ENDIF
    ENDIF
    IF( LSTATS_MPL .AND. JROC <= NPRNT_STATS ) THEN
      WRITE(KULOUT,'(/,A,I4,/)') 'COMMUNICATIONS STATISTICS:TASK=',JROC
      WRITE(KULOUT,'(A)') &
       &' NUM     ROUTINE                              '//&
       &'  SUM(s)   SENDS  AVG(kb) TOTAL(MB) MB/s '//&
       &'  RECVS  AVG(kb) TOTAL(MB) MB/s '

      DO JNUM=501,1000
        IF((NUMSEND(JNUM) /= 0 .OR. NUMRECV(JNUM) /= 0 ) &
           .AND. TIMESUM(JNUM) > 0.0_JPRD) THEN
           SENDRATE=SENDBYTES(JNUM)*1.E-6_JPRD/TIMESUM(JNUM)
           RECVRATE=RECVBYTES(JNUM)*1.E-6_JPRD/TIMESUM(JNUM)
           IF(NUMSEND(JNUM) /= 0) THEN
             AVGSENDLEN=SENDBYTES(JNUM)*1.E-3_JPRD/NUMSEND(JNUM)
           ELSE
             AVGSENDLEN=0.0_JPRD
           ENDIF
           IF(NUMRECV(JNUM) /= 0) THEN
             AVGRECVLEN=RECVBYTES(JNUM)*1.E-3_JPRD/NUMRECV(JNUM)
           ELSE
             AVGRECVLEN=0.0_JPRD
           ENDIF
           WRITE(KULOUT,'(I6,1X,A40,f6.1,2(I8,3F8.1))') &
            &  JNUM,CCDESC(JNUM),TIMESUM(JNUM),&
            &  NUMSEND(JNUM),AVGSENDLEN,SENDBYTES(JNUM)*1.E-6_JPRD, SENDRATE, &
            &  NUMRECV(JNUM),AVGRECVLEN,RECVBYTES(JNUM)*1.E-6_JPRD, RECVRATE
        ENDIF
      ENDDO
      WRITE(KULOUT,'(/,A,I4,/)') 'UNKNOWN COMMUNICATIONS STATISTICS:TASK=', JROC
      WRITE(KULOUT,'(A)') &
       &' NUM     BEFORE ROUTINE                        '//&
       &'    SENDS TOTAL(MB) '//&
       &'RECVS TOTAL(MB)  '
      DO JNUM=501,1000
        IF(UNKNOWN_NUMSEND(JNUM) /= 0 .OR. UNKNOWN_NUMRECV(JNUM) /= 0 ) THEN
           WRITE(KULOUT,'(I6,1X,A40,2(I8,F8.1))') &
            &  JNUM,CCDESC(JNUM),&
            &  UNKNOWN_NUMSEND(JNUM),UNKNOWN_SENDBYTES(JNUM)*1.E-6_JPRD, &
            &  UNKNOWN_NUMRECV(JNUM),UNKNOWN_RECVBYTES(JNUM)*1.E-6_JPRD
        ENDIF
      ENDDO
      WRITE(KULOUT,'(7x,"TOTAL",35x,2(I8,F8.1),//)') &
       & SUM(UNKNOWN_NUMSEND(:)),SUM(UNKNOWN_SENDBYTES(:))*1.E-6_JPRD , &
       & SUM(UNKNOWN_NUMRECV(:)),SUM(UNKNOWN_RECVBYTES(:))*1.E-6_JPRD

     ENDIF

     IF(LSTATS_MPL) THEN
      DO JNUM=501,1000
         TOTSENDBYTES(JNUM) = TOTSENDBYTES(JNUM) + SENDBYTES(JNUM)
         TOTRECVBYTES(JNUM) = TOTRECVBYTES(JNUM) + RECVBYTES(JNUM)
         IF(SENDBYTES(JNUM).GT.0.0_JPRD.OR. &
         &  RECVBYTES(JNUM).GT.0.0_JPRD) THEN
           MAXCOMMTIME(JNUM)  = MAX(MAXCOMMTIME(JNUM),TIMESUM(JNUM))
         ENDIF
      ENDDO
     ENDIF

  ENDDO
  IF(LXML_STATS)THEN
    WRITE(IXMLLUN,'(A)')'<timing_all_tasks>'
  ENDIF
  WRITE(KULOUT,*) ''
  WRITE(KULOUT,'(A)') 'STATS FOR ALL TASKS'
  WRITE(KULOUT,'(A)') &
  &' NUM ROUTINE                                     CALLS      MEAN(ms)       MAX(ms)   FRAC(%)  UNBAL(%)'
  ZTOTUNBAL = 0.0_JPRD
  DO JNUM=0,500
    IF(NCALLS(JNUM) > 1) THEN
      ICALLS = NCALLS(JNUM)/2
      ZMEAN = ZAVEAVE(JNUM)/NPROC_STATS
      ZMAX  = ZAVEMAX(JNUM)
      ZMEANT = ZSUMTOT(JNUM)/NPROC_STATS
      ZMAXT  = ZSUMMAX(JNUM)
      IF(ZMEANT .NE. 0._JPRD)THEN
        ZUNBAL= (ZMAXT-ZMEANT)/ZTOTAL*100._JPRD
      ELSE
        ZUNBAL=0._JPRD
      ENDIF
      ZFRAC=ZFRACMAX(JNUM)
      WRITE(KULOUT,'(I4,1X,A40,1X,I8,2(1X,F13.3),2(1X,F9.2))')&
       &JNUM,CCDESC(JNUM),ICALLS,ZMEAN,ZMAX,ZFRAC,ZUNBAL

      IF(LXML_STATS)THEN
        WRITE(IXMLLUN,'(A,I4,A,/,A,A40,A,/,A,I8,A,2(A,F13.3,A,/),2(A,F9.2,A,/),A)')&
         &'<item id="',JNUM,'">',&
         &'<description>',CCDESC(JNUM),'</description>',&
         &'<calls>',ICALLS,'</calls>',&
         &'<mean unit="ms">',ZMEAN,'</mean>',&
         &'<max unit="ms">',ZMAX,'</max>',&
         &'<fraction unit="percent">',ZFRAC,'</fraction>',&
         &'<unbalanced unit="percent">',ZUNBAL,'</unbalanced>','</item>'
      ENDIF
    ENDIF
  ENDDO
  IF(LXML_STATS)THEN
    WRITE(IXMLLUN,'(A)')'</timing_all_tasks>'
  ENDIF

IF(LSTATS_COMMS)THEN
  IF(LXML_STATS)THEN
    WRITE(IXMLLUN,'(A)')'<timing_communications>'
  ENDIF
  WRITE(KULOUT,*) ''
  WRITE(KULOUT,'(A)') 'STATS FOR COMMUNICATIONS'
  WRITE(KULOUT,'(A)')  &
  &' NUM ROUTINE                                     CALLS    MEAN(ms)  MAX(ms)   FRAC(%)  UNBAL(%)'
  ZT_SUM=0._JPRD
  DO JNUM=500,JPMAXSTAT
    IF((CCTYPE(JNUM).EQ."MPL".OR.CCTYPE(JNUM).EQ."BAR".OR.CCTYPE(JNUM).EQ."GBR".OR.CCTYPE(JNUM).EQ."GB2") &
     & .AND.NCALLS(JNUM) > 1) THEN
      ICALLS = NCALLS(JNUM)/2
      ZMEAN = ZAVEAVE(JNUM)/NPROC_STATS
      ZMAX  = ZAVEMAX(JNUM)
      ZMEANT = ZSUMTOT(JNUM)/NPROC_STATS
      ZMAXT  = ZSUMMAX(JNUM)
      IF(ZMEANT .NE. 0._JPRD)THEN
        ZUNBAL= (ZMAXT-ZMEANT)/ZTOTAL*100._JPRD
      ELSE
        ZUNBAL=0._JPRD
      ENDIF
      ZFRAC=ZFRACMAX(JNUM)
      ZTOTUNBAL = ZTOTUNBAL+(ZMAXT-ZMEANT)
      WRITE(KULOUT,'(I4,1X,A40,1X,I8,2(1X,F9.1),2(1X,F9.2))')&
       &JNUM,CCDESC(JNUM),ICALLS,ZMEAN,ZMAX,ZFRAC,ZUNBAL
      IF(LXML_STATS)THEN
        WRITE(IXMLLUN,'(A,I4,A,/,A,A40,A,/,A,I8,A,/,2(A,F9.1,A,/),2(A,F9.2,A,/),A)')&
         &'<comitem id="',JNUM,'">',&
         &'<description>',CCDESC(JNUM),'</description>',&
         &'<calls>',ICALLS,'</calls>',&
         &'<mean unit="ms">',ZMEAN,'</mean>',&
         &'<max unit="ms">',ZMAX,'</max>',&
         &'<fraction unit="percent">',ZFRAC,'</fraction>',&
         &'<unbalanced unit="percent">',ZUNBAL,'</unbalanced>','</comitem>'
      ENDIF
      ZT_SUM=ZT_SUM+ZMEANT
    ENDIF
  ENDDO

  WRITE(KULOUT,*) ''
  WRITE(KULOUT,'(A,F10.1,A)')'SUMMED TIME IN COMMUNICATIONS   = ',ZT_SUM, ' SECONDS '
  IF(LSTATS_MPL) THEN
    WRITE(KULOUT,'(/,A,/)') 'TOTAL COMMUNICATIONS VOLUMES AND BANDWIDTH'
    WRITE(KULOUT,'(A)') &
     &'   NUM   ROUTINE                              '//&
     &'  SUM(s)  SEND(GB)  RECV(GB)    GB/s'
    DO JNUM=501,1000
       IF((TOTSENDBYTES(JNUM).GT.0.0_JPRD.OR.TOTRECVBYTES(JNUM).GT.0.0_JPRD) &
          .AND. MAXCOMMTIME(JNUM) > 0.0_JPRD) THEN
          WRITE(KULOUT,'(I6,1X,A40,f6.1,2F10.1,F8.1)') &
           &  JNUM,CCDESC(JNUM),MAXCOMMTIME(JNUM),&
           &  TOTSENDBYTES(JNUM)*1.E-9_JPRD, &
           &  TOTRECVBYTES(JNUM)*1.E-9_JPRD , &
           &  (TOTSENDBYTES(JNUM)*1.E-9_JPRD)/MAXCOMMTIME(JNUM)
       ENDIF
    ENDDO
    TOTSENDBYTESSUM = SUM(TOTSENDBYTES)
    TOTRECVBYTESSUM = SUM(TOTRECVBYTES)
    IF( TOTSENDBYTESSUM.GT.0.0_JPRD ) THEN
      WRITE(KULOUT,'(/,A,42x,f6.1,2F10.1,F8.1)') &
       &   'TOTAL', &
       &   SUM(MAXCOMMTIME) , &
       &   TOTSENDBYTESSUM*1.E-9_JPRD, &
       &   TOTRECVBYTESSUM*1.E-9_JPRD, &
       &   (TOTSENDBYTESSUM*1.E-9_JPRD)/SUM(MAXCOMMTIME)
     ENDIF
  ENDIF

  IF(LXML_STATS)THEN
    WRITE(IXMLLUN,'(A,F10.1,A)')'<zcom unit="seconds">',ZT_SUM, '</zcom>'
  ENDIF
  WRITE(KULOUT,*) ''
  IF(LXML_STATS)THEN
    WRITE(IXMLLUN,'(A)')'</timing_communications>'
  ENDIF

ENDIF
IF(LSTATS_OMP)THEN
  IF(LXML_STATS)THEN
    WRITE(IXMLLUN,'(A)')'<timing_parallel>'
  ENDIF
  WRITE(KULOUT,*) ''
  WRITE(KULOUT,'(A)') 'STATS FOR PARALLEL REGIONS'
  WRITE(KULOUT,'(A)')  &
  &' NUM ROUTINE                                     CALLS    MEAN(ms)  MAX(ms)   FRAC(%)  UNBAL(%)'
  ZT_SUM=0._JPRD
  DO JNUM=500,JPMAXSTAT
    IF(CCTYPE(JNUM).EQ."OMP".AND.NCALLS(JNUM) > 1) THEN
      ICALLS = NCALLS(JNUM)/2
      ZMEAN = ZAVEAVE(JNUM)/NPROC_STATS
      ZMAX  = ZAVEMAX(JNUM)
      ZMEANT = ZSUMTOT(JNUM)/NPROC_STATS
      ZMAXT  = ZSUMMAX(JNUM)
      IF(ZMEANT .NE. 0._JPRD)THEN
        ZUNBAL= (ZMAXT-ZMEANT)/ZTOTAL*100._JPRD
      ELSE
        ZUNBAL=0._JPRD
      ENDIF
      ZFRAC=ZFRACMAX(JNUM)
      ZTOTUNBAL = ZTOTUNBAL+(ZMAXT-ZMEANT)
      WRITE(KULOUT,'(I4,1X,A40,1X,I8,2(1X,F9.1),2(1X,F9.2))')&
       &JNUM,CCDESC(JNUM),ICALLS,ZMEAN,ZMAX,ZFRAC,ZUNBAL
      IF(LXML_STATS)THEN
        WRITE(IXMLLUN,'(A,I4,A,/,A,A40,A,/,A,I8,A,/,2(A,F9.1,A,/),2(A,F9.2,A,/),A)')&
         &'<parallelitem id="',JNUM,'">',&
         &'<description>',CCDESC(JNUM),'</description>',&
         &'<calls>',ICALLS,'</calls>',&
         &'<mean unit="seconds">',ZMEAN,'</mean>',&
         &'<max unit="seconds">',ZMAX,'</max>',&
         &'<fraction unit="percent">',ZFRAC,'</fraction>',&
         &'<unbalanced unit="percent">',ZUNBAL,'</unbalanced>',&
         &'</parallelitem>'
      ENDIF

      ZT_SUM=ZT_SUM+ZMEANT
    ENDIF
  ENDDO

  WRITE(KULOUT,*) ''
  WRITE(KULOUT,'(A,F10.1,A)')'SUMMED TIME IN PARALLEL REGIONS = ',ZT_SUM, ' SECONDS '
  WRITE(KULOUT,*) ''

  IF(LXML_STATS)THEN
    WRITE(IXMLLUN,'(A,F10.1,A)')'<zpar unit="seconds">',ZT_SUM, '</zpar>'
  ENDIF

  WRITE(KULOUT,*) ''
  WRITE(KULOUT,'(A)') 'STATS FOR I/O REGIONS'
  WRITE(KULOUT,'(A)')  &
  &' NUM ROUTINE                                     CALLS    MEAN(ms)  MAX(ms)   FRAC(%)  UNBAL(%)'
  ZT_SUM=0._JPRD
  DO JNUM=500,JPMAXSTAT
    IF(CCTYPE(JNUM).EQ."IO-".AND.NCALLS(JNUM) > 1) THEN
      ICALLS = NCALLS(JNUM)/2
      ZMEAN = ZAVEAVE(JNUM)/NPROC_STATS
      ZMAX  = ZAVEMAX(JNUM)
      ZMEANT = ZSUMTOT(JNUM)/NPROC_STATS
      ZMAXT  = ZSUMMAX(JNUM)
      IF(ZMEANT .NE. 0._JPRD)THEN
        ZUNBAL= (ZMAXT-ZMEANT)/ZTOTAL*100._JPRD
      ELSE
        ZUNBAL=0._JPRD
      ENDIF
      ZFRAC=ZFRACMAX(JNUM)
      ZTOTUNBAL = ZTOTUNBAL+(ZMAXT-ZMEANT)
      WRITE(KULOUT,'(I4,1X,A40,1X,I8,2(1X,F9.1),2(1X,F9.2))')&
       &JNUM,CCDESC(JNUM),ICALLS,ZMEAN,ZMAX,ZFRAC,ZUNBAL
      IF(LXML_STATS)THEN
        WRITE(IXMLLUN,'(A,I4,A,/,A,A40,A,/,A,I8,A,/,2(A,F9.1,A,/),2(A,F9.2,A,/),A)')&
         &'<para_io_item id="',JNUM,'">',&
         &'<description>',CCDESC(JNUM),'</description>',&
         &'<calls>',ICALLS,'</calls>',&
         &'<mean unit="seconds">',ZMEAN,'</mean>','<max unit="seconds">',&
         & ZMAX,'</max>',&
         &'<fraction unit="percent">',ZFRAC,'</fraction>',&
         &'<unbalanced unit="percent">',ZUNBAL,'</unbalanced>',&
         &'</para_io_item>'
      ENDIF

      ZT_SUM=ZT_SUM+ZMEANT
    ENDIF
  ENDDO

  WRITE(KULOUT,*) ''
  WRITE(KULOUT,'(A,F10.1,A)')'SUMMED TIME IN I/O REGIONS = ',&
       &ZT_SUM, ' SECONDS '
  WRITE(KULOUT,*) ''

  IF(LXML_STATS)THEN
    WRITE(IXMLLUN,'(A,F10.1,A)')'<zio unit="seconds">',ZT_SUM,'</zio>'
  ENDIF

  WRITE(KULOUT,*) ''
  WRITE(KULOUT,'(A)') 'STATS FOR SERIAL(no OMP) REGIONS'
  WRITE(KULOUT,'(A)')  &
  &' NUM ROUTINE                                     CALLS    MEAN(ms)  MAX(ms)   FRAC(%)  UNBAL(%)'
  ZT_SUM=0._JPRD
  DO JNUM=500,JPMAXSTAT
    IF(CCTYPE(JNUM).EQ."SER".AND.NCALLS(JNUM) > 1) THEN
      ICALLS = NCALLS(JNUM)/2
      ZMEAN = ZAVEAVE(JNUM)/NPROC_STATS
      ZMAX  = ZAVEMAX(JNUM)
      ZMEANT = ZSUMTOT(JNUM)/NPROC_STATS
      ZMAXT  = ZSUMMAX(JNUM)
      IF(ZMEANT .NE. 0._JPRD)THEN
        ZUNBAL= (ZMAXT-ZMEANT)/ZTOTAL*100._JPRD
      ELSE
        ZUNBAL=0._JPRD
      ENDIF
      ZFRAC=ZFRACMAX(JNUM)
      ZTOTUNBAL = ZTOTUNBAL+(ZMAXT-ZMEANT)
      WRITE(KULOUT,'(I4,1X,A40,1X,I8,2(1X,F9.1),2(1X,F9.2))')&
       &JNUM,CCDESC(JNUM),ICALLS,ZMEAN,ZMAX,ZFRAC,ZUNBAL
      IF(LXML_STATS)THEN
        WRITE(IXMLLUN,'(A,I4,A,A,A40,A,A,I8,A,2(A,F9.1,A),2(A,F9.2,A,/),A)')&
         &'<serialitem id="',JNUM,'">',&
         &'<description>',CCDESC(JNUM),'</description>',&
         &'<calls>',ICALLS,'</calls>',&
         &'<mean unit="ms">',ZMEAN,'</mean>','<max unit="ms">',ZMAX,'</max>',&
         &'<fraction unit="percent">',ZFRAC,'</fraction>',&
         &'<unbalanced unit="percent">',ZUNBAL,'</unbalanced>','</serialitem>'
      ENDIF

      ZT_SUM=ZT_SUM+ZMEANT
    ENDIF
  ENDDO

  WRITE(KULOUT,*) ''
  WRITE(KULOUT,'(A,F10.1,A)')'SUMMED TIME IN SERIAL REGIONS = ',ZT_SUM, ' SECONDS '
  WRITE(KULOUT,*) ''

  IF(LXML_STATS)THEN
    WRITE(IXMLLUN,'(A,F10.1,A)')'<zserial unit="seconds">',&
     &ZT_SUM, '</zserial>'
  ENDIF

  WRITE(KULOUT,*) ''
  WRITE(KULOUT,'(A)') 'STATS FOR MIXED SECTIONS'
  WRITE(KULOUT,'(A)')  &
  &' NUM ROUTINE                                     CALLS    MEAN(ms)  MAX(ms)   FRAC(%)  UNBAL(%)'
  ZT_SUM=0._JPRD
  DO JNUM=500,JPMAXSTAT
    IF(CCTYPE(JNUM).EQ."MXD".AND.NCALLS(JNUM) > 1) THEN
      ICALLS = NCALLS(JNUM)/2
      ZMEAN = ZAVEAVE(JNUM)/NPROC_STATS
      ZMAX  = ZAVEMAX(JNUM)
      ZMEANT = ZSUMTOT(JNUM)/NPROC_STATS
      ZMAXT  = ZSUMMAX(JNUM)
      IF(ZMEANT .NE. 0._JPRD)THEN
        ZUNBAL= (ZMAXT-ZMEANT)/ZTOTAL*100._JPRD
      ELSE
        ZUNBAL=0._JPRD
      ENDIF
      ZFRAC=ZFRACMAX(JNUM)
      ZTOTUNBAL = ZTOTUNBAL+(ZMAXT-ZMEANT)
      WRITE(KULOUT,'(I4,1X,A40,1X,I8,2(1X,F9.1),2(1X,F9.2))')&
       &JNUM,CCDESC(JNUM),ICALLS,ZMEAN,ZMAX,ZFRAC,ZUNBAL
      IF(LXML_STATS)THEN
        WRITE(IXMLLUN,'(A,I4,A,A,A40,A,A,I8,A,2(A,F9.1,A),2(A,F9.2,A,/),A)')&
         &'<mixeditem id="',JNUM,'">',&
         &'<description>',CCDESC(JNUM),'</description>',&
         &'<calls>',ICALLS,'</calls>',&
         &'<mean unit="ms">',ZMEAN,'</mean>','<max unit="ms">',ZMAX,'</max>',&
         &'<fraction unit="percent">',ZFRAC,'</fraction>',&
         &'<unbalanced unit="percent">',ZUNBAL,'</unbalanced>','</mixeditem>'
      ENDIF

      ZT_SUM=ZT_SUM+ZMEANT
    ENDIF
  ENDDO

  WRITE(KULOUT,*) ''
  WRITE(KULOUT,'(A,F10.1,A)')'SUMMED TIME IN MIXED SECTIONS = ',ZT_SUM, ' SECONDS '
  WRITE(KULOUT,*) ''

  IF(LXML_STATS)THEN
    WRITE(IXMLLUN,'(A,F10.1,A)')'<zmixed unit="seconds">',&
     &ZT_SUM, '</zmixed>'
  ENDIF

  IF(LXML_STATS)THEN
    WRITE(IXMLLUN,'(A)')'</timing_parallel>'
  ENDIF

ENDIF

  WRITE(KULOUT,'(A,F10.1,A,F4.1,A)')&
   &'TOTAL MEASURED IMBALANCE =',ZTOTUNBAL,&
   &' SECONDS, ',ZTOTUNBAL/ZTOTAL*100._JPRD,' PERCENT'
ELSE
  ZTOTAL=TIMESUM(0)
  ZTOTCPU = TTCPUSUM(0)
  ZTOTVCPU = TVCPUSUM(0)
ENDIF

IF ( MYPROC_STATS == 1) THEN
  WRITE(KULOUT,'(3(A,F11.3)/)')'TOTAL WALLCLOCK TIME ',ZTOTAL,&
   &' CPU TIME',ZTOTCPU,' VECTOR TIME ',ZTOTVCPU
  IF(LXML_STATS)THEN
    WRITE(IXMLLUN,'(3(A,F11.3,A,/)/)')'<totalwallclocktime>',ZTOTAL,&
     &'</totalwallclocktime>',&
     &'<cputime>',ZTOTCPU,'</cputime>',&
     & '<vectortime>',ZTOTVCPU,'</vectortime>'
  ENDIF
ENDIF
IF( LDETAILED_STATS )THEN
  ITAG = JPTAGSTAT
  ZDELAY_MAX=0.0_JPRD
  ZMPL(:)=0.0_JPRD
  ZBAR(:)=0.0_JPRD
  ZGBR(:)=0.0_JPRD
  ZGB2(:)=0.0_JPRD
  ZOMP(:)=0.0_JPRD
  ZIO (:)=0.0_JPRD
  ZSER(:)=0.0_JPRD
  ZMXD(:)=0.0_JPRD
  DO JROC=1,NPROC_STATS
    IF( JROC > 1 )THEN
      IF( MYPROC_STATS == JROC )THEN
        ISEND=1
        CALL MPL_SEND(NDELAY_INDEX,KDEST=NPRCIDS_STATS(ISEND), &
         & KTAG=ITAG,CDSTRING='GSTATS_PRINT:')
        IF( NDELAY_INDEX > 0 )THEN
          CALL MPL_SEND(NDELAY_COUNTER(1:NDELAY_INDEX),KDEST=NPRCIDS_STATS(ISEND), &
           & KTAG=ITAG+1,CDSTRING='GSTATS_PRINT:')
          CALL MPL_SEND(TDELAY_VALUE(1:NDELAY_INDEX),KDEST=NPRCIDS_STATS(ISEND), &
           & KTAG=ITAG+2,CDSTRING='GSTATS_PRINT:')
          DO JDELAY=1,NDELAY_INDEX
            CLTEMP((JDELAY-1)*10+1:JDELAY*10)=CDELAY_TIME(JDELAY)
          ENDDO
          CALL MPL_SEND(CLTEMP(1:NDELAY_INDEX*10),KDEST=NPRCIDS_STATS(ISEND), &
           & KTAG=ITAG+3,CDSTRING='GSTATS_PRINT:')
        ENDIF
      ENDIF
      IF( MYPROC_STATS == 1 )THEN
        CALL MPL_RECV(NDELAY_INDEX,KSOURCE=NPRCIDS_STATS(JROC), &
         & KTAG=ITAG,CDSTRING='GSTATS_PRINT:')
        IF( NDELAY_INDEX > 0 )THEN
          CALL MPL_RECV(NDELAY_COUNTER(1:NDELAY_INDEX),KSOURCE=NPRCIDS_STATS(JROC), &
           & KTAG=ITAG+1,CDSTRING='GSTATS_PRINT:')
          CALL MPL_RECV(TDELAY_VALUE(1:NDELAY_INDEX),KSOURCE=NPRCIDS_STATS(JROC), &
           & KTAG=ITAG+2,CDSTRING='GSTATS_PRINT:')
          CALL MPL_RECV(CLTEMP(1:NDELAY_INDEX*10),KSOURCE=NPRCIDS_STATS(JROC), &
            & KTAG=ITAG+3,CDSTRING='GSTATS_PRINT:')
          DO JDELAY=1,NDELAY_INDEX
            CDELAY_TIME(JDELAY)=CLTEMP((JDELAY-1)*10+1:JDELAY*10)
          ENDDO
        ENDIF
      ENDIF
    ENDIF
    IF( MYPROC_STATS == 1 .AND. NDELAY_INDEX > 0 )THEN
      WRITE(KULOUT,'("+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++")')
      WRITE(KULOUT,'("TASK=",I6," NUMBER OF UNEXPECTED DELAYS=",I4)') JROC,NDELAY_INDEX
      IF( NDELAY_INDEX == JPMAXDELAYS )THEN
        WRITE(KULOUT,'(" NOTE THAT THE MAXIMUM NUMBER OF DELAYS HAS BEEN REACHED =",I6)')JPMAXDELAYS
      ENDIF
      ZDELAY=SUM(TDELAY_VALUE(1:NDELAY_INDEX))
      WRITE(KULOUT,'("TOTAL UNEXPECTED DELAY TIME (SECS) =",F9.1)') ZDELAY
      ZDELAY_MAX=MAX(ZDELAY_MAX,ZDELAY)
      DO JDELAY=1,NDELAY_INDEX
        WRITE(KULOUT,'(A,":",A,":",A,1X,I4,1X,A3,1X,A40,1X,F6.1)')&
         &CDELAY_TIME(JDELAY)(1:2),CDELAY_TIME(JDELAY)(3:4),CDELAY_TIME(JDELAY)(5:6),&
         &NDELAY_COUNTER(JDELAY),CCTYPE(NDELAY_COUNTER(JDELAY)),&
         &CCDESC(NDELAY_COUNTER(JDELAY)),TDELAY_VALUE(JDELAY)
         IF( CCTYPE(NDELAY_COUNTER(JDELAY)) .EQ. 'MPL' ) ZMPL(JROC)=ZMPL(JROC)+TDELAY_VALUE(JDELAY)
         IF( CCTYPE(NDELAY_COUNTER(JDELAY)) .EQ. 'BAR' ) ZBAR(JROC)=ZBAR(JROC)+TDELAY_VALUE(JDELAY)
         IF( CCTYPE(NDELAY_COUNTER(JDELAY)) .EQ. 'GBR' ) ZGBR(JROC)=ZGBR(JROC)+TDELAY_VALUE(JDELAY)
         IF( CCTYPE(NDELAY_COUNTER(JDELAY)) .EQ. 'GB2' ) ZGB2(JROC)=ZGB2(JROC)+TDELAY_VALUE(JDELAY)
         IF( CCTYPE(NDELAY_COUNTER(JDELAY)) .EQ. 'OMP' ) ZOMP(JROC)=ZOMP(JROC)+TDELAY_VALUE(JDELAY)
         IF( CCTYPE(NDELAY_COUNTER(JDELAY)) .EQ. 'IO-' ) ZIO (JROC)=ZIO (JROC)+TDELAY_VALUE(JDELAY)
         IF( CCTYPE(NDELAY_COUNTER(JDELAY)) .EQ. 'SER' ) ZSER(JROC)=ZSER(JROC)+TDELAY_VALUE(JDELAY)
         IF( CCTYPE(NDELAY_COUNTER(JDELAY)) .EQ. 'MXD' ) ZMXD(JROC)=ZMXD(JROC)+TDELAY_VALUE(JDELAY)
      ENDDO
      WRITE(KULOUT,'(" ")')
      WRITE(KULOUT,'("TASK=",I6," UNEXPECTED DELAYS SORTED BY COUNTER")') JROC
      DO JNUM=500,JPMAXSTAT
        IDELAY=0
        ZDELAY=0.0_JPRD
        DO JDELAY=1,NDELAY_INDEX
          IF( NDELAY_COUNTER(JDELAY) == JNUM )THEN
            IDELAY=IDELAY+1
            ZDELAY=ZDELAY+TDELAY_VALUE(JDELAY)
          ENDIF
        ENDDO
        IF( IDELAY /= 0 )THEN
          WRITE(KULOUT,'(I4,1X,A3,1X,A40,1X,I4,3X,F6.1)')&
           &JNUM,CCTYPE(JNUM),CCDESC(JNUM),IDELAY,ZDELAY
        ENDIF
      ENDDO
      WRITE(KULOUT,'(" ")')
      WRITE(KULOUT,'(" ")')
    ENDIF
    IF (NPROC_STATS > 1) THEN
      CALL MPL_BARRIER(CDSTRING='GSTATS_PRINT')
    ENDIF
  ENDDO
  IF( MYPROC_STATS == 1 )THEN
    WRITE(KULOUT,'("MAXIMUM TOTAL UNEXPECTED DELAY TIME (SECS) =",F9.1)') ZDELAY_MAX
    WRITE(KULOUT,'(" ")')
    WRITE(KULOUT,'(" ")')
    WRITE(KULOUT,'("  TASK   ","     MPL   ","     BAR   ","     GBR   ","     GB2   ","     OMP   ",&
     &"     IO-   ","     SER   ","     MXD   ")')
    DO JROC=1,NPROC_STATS
      WRITE(KULOUT,'(I6,8(2X,F9.1))') JROC,ZMPL(JROC),ZBAR(JROC),ZGBR(JROC),ZGB2(JROC),&
      &ZOMP(JROC),ZIO (JROC),ZSER(JROC),ZMXD(JROC)
    ENDDO
    WRITE(KULOUT,'(" ")')
    WRITE(KULOUT,'(" ")')
  ENDIF
ENDIF

!   Trace stats

IF (LTRACE_STATS) THEN
  WRITE(KULOUT,'(A)') '=== TRACE OF CALLS TO GSTATS'
  IF (NCALLS_TOTAL > NTRACE_STATS) THEN
    WRITE(KULOUT,'(A,2I10)') ' ONLY PART OF TRACE STORED AS BUFFER TO SMALL ',&
     & NCALLS_TOTAL,NTRACE_STATS
  ENDIF
  WRITE(KULOUT,'(A)') '==='
  CLACTION(0)='ON'
  CLACTION(1)='OFF'
  CLACTION(2)='SUSPEND'
  CLACTION(3)='RESUME'
  DO JCALL=1,MIN(NCALLS_TOTAL,NTRACE_STATS)
    ICALLER = MOD(NCALL_TRACE(JCALL),(JPMAXSTAT+1))
    IACTION   = NCALL_TRACE(JCALL)/(JPMAXSTAT+1)
    IF (IACTION == 0) THEN
      ZTIMELCALL(ICALLER) = TIME_TRACE(JCALL)
      ZTHISTIME(ICALLER) = 0.0_JPRD
    ELSEIF (IACTION == 2) THEN
      ZTHISTIME(ICALLER) = TIME_TRACE(JCALL)-ZTIMELCALL(ICALLER)
    ELSEIF (IACTION == 3) THEN
      ZTIMELCALL(ICALLER) = TIME_TRACE(JCALL)
    ENDIF
    IF (IACTION == 1) THEN
      WRITE(KULOUT,'(1X,F10.3,1X,A,1X,A,1X,F10.3)') &
       &TIME_TRACE(JCALL),CCDESC(ICALLER),CLACTION(IACTION),&
       &ZTHISTIME(ICALLER)+(TIME_TRACE(JCALL)-ZTIMELCALL(ICALLER))
    ELSE
      WRITE(KULOUT,'(1X,F10.3,1X,A,1X,A)') TIME_TRACE(JCALL),CCDESC(ICALLER),&
       & CLACTION(IACTION)
    ENDIF
  ENDDO
ENDIF

IF(LSTATS .AND. MYPROC_STATS == 1) THEN
  PAVEAVE(0:KLEN) = ZAVEAVE(0:KLEN)
ELSE
  PAVEAVE(0:KLEN) = 0.0_JPRD
ENDIF

WRITE(KULOUT,'(/A)')'===-=== END   OF TIMING STATISTICS ===-==='


IF(LSTATS_MEM)THEN
  IF(LXML_STATS)THEN
    WRITE(IXMLLUN,'(A)')'<memory>'
  ENDIF
  WRITE(KULOUT,*) ''
  WRITE(KULOUT,*) 'STATS FOR MEMORY'
  WRITE(KULOUT,*)  &
 &' NUM ROUTINE               CALLS  CALL    MAXINCR   TOTINCR   MININCR'
  WRITE(KULOUT,*)  &
 &'                                   NO      (KB)      (KB)      (KB)'
  DO JNUM=0,JPMAXSTAT
    IF(NCALLS(JNUM) > 1) THEN
      ICALLS = NCALLS(JNUM)/2
      IMEM=NTMEM(JNUM,1)
      INUM=NTMEM(JNUM,3)/2
      JMEM=NTMEM(JNUM,4)
      WRITE(KULOUT,'(I4,1X,A20,1X,I8,1X,I6,3(1X,I9))')&
       &JNUM,CCDESC(JNUM),ICALLS,INUM,IMEM,JMEM,NTMEM(JNUM,5)

      IF(LXML_STATS)THEN
        WRITE(IXMLLUN,'(A,I4,A,/,A,A20,A,/,A,I8,A,/,A,I6,A,/,3(A,I9,A,/))')&
         &'<memitem id="',JNUM,'"/>',&
         &'<description>',CCDESC(JNUM),'</description>',&
         &'<calls>',ICALLS,'</calls>',&
         &'<callnum>',INUM,'</callnum>','<maxincr unit="kb">',IMEM,'</maxincr>',&
         &'<totincr unit="kb">',JMEM,'</totincr>',&
         &'<minincr unit="kb">',NTMEM(JNUM,5),'</minincr>'
      ENDIF
    ENDIF
  ENDDO

  WRITE(KULOUT,*) ''
  WRITE(KULOUT,'(/A)')'===-=== END   OF MEMORY STATISTICS ===-==='
  WRITE(KULOUT,*) ''
  IF(LXML_STATS)THEN
    WRITE(IXMLLUN,'(A)')'</memory>'
  ENDIF
ENDIF
IF(LXML_STATS .AND. MYPROC_STATS==1)THEN
  WRITE(IXMLLUN,'(A)')'</gstats>'
  CLOSE(IXMLLUN)
ENDIF
RETURN
END SUBROUTINE GSTATS_PRINT

! (C) Copyright 2021- ECMWF.
! 
! This software is licensed under the terms of the Apache Licence Version 2.0
! which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
! In applying this licence, ECMWF does not waive the privileges and immunities
! granted to it by virtue of its status as an intergovernmental organisation
! nor does it submit to any jurisdiction.
!

!
! Testing of ec_args; expected to be launched with 3 arguments:
!    <program> arg1 arg2 arg3
!

#define FAIL(msg) call fail_impl(msg,__LINE__)

program test_namelist
use namelist_mod
#ifdef NAGFOR
use f90_unix_dir, only: unlink
#endif
implicit none

character(len=*),parameter :: cfile = 'fort.4'
logical,parameter          :: lvalue_check = .true.
integer,parameter          :: ivalue_check = 12
real,parameter             :: rvalue_check = 0.12
character(len=*),parameter :: cvalue_check = 'NONE'

integer :: kulnam = 4

logical           :: lvalue = .false.
integer           :: ivalue = 0
real              :: rvalue = 0.0
character(len=80) :: cvalue = ''

character(len=*),parameter :: cpresent = 'NAMBLOCK2'
character(len=*),parameter :: cnonpresent = 'NAM_NONPRESENT'
namelist/NAMBLOCK2/lvalue,ivalue,rvalue,cvalue
namelist/NAM_NONPRESENT/lvalue,ivalue,rvalue,cvalue

call write_namelist()

open(kulnam, file=cfile)

call test_posnamef_present()
call test_posnamef_nonpresent()
call test_posnam_present()
call test_posnam_nonpresent()
close(kulnam)
! checking it also works with a closed kulnam,
! guessing filename (fort.kulnam) and opening it
call test_posnam_present()

contains

subroutine write_namelist()
implicit none
integer :: iunit = 4
logical :: lexist
inquire(file=cfile, exist=lexist)
if (lexist) then
  print*, "Removing", cfile
  call unlink(cfile)
endif
open(iunit, file=cfile, status='NEW')
write(iunit,*) '&NAMBLOCK1'
write(iunit,*) '/'
write(iunit,*) '&NAMBLOCK2'
write(iunit,*) '  LVALUE=.TRUE.,'
write(iunit,*) '  RVALUE=0.12,'
write(iunit,*) '  IVALUE=12,'
write(iunit,*) '  CVALUE="NONE",'
write(iunit,*) '/'
write(iunit,*) '&NAMBLOCK3'
write(iunit,*) '/'
close(iunit)
end subroutine write_namelist

subroutine test_posnamef_present()
implicit none

if (posnamef(kulnam, cpresent, ldfatal=.false., ldverbose=.true.) == 0) read(kulnam, NAMBLOCK2)

if (lvalue .neqv. lvalue_check) FAIL("LVALUE")
if (ivalue /= ivalue_check) FAIL("IVALUE")
if (rvalue /= rvalue_check) FAIL("RVALUE")
if (trim(cvalue) /= trim(cvalue_check)) FAIL("CVALUE")
end subroutine test_posnamef_present

subroutine test_posnamef_nonpresent()
implicit none
if (posnamef(kulnam, cnonpresent, ldfatal=.false., ldverbose=.true.) == 0) then
  read(kulnam, NAM_NONPRESENT)
else
  print*,'This should not be printed'
endif
end subroutine test_posnamef_nonpresent

subroutine test_posnam_present()
implicit none
call posnam(kulnam, cpresent)
read(kulnam, NAMBLOCK2)
end subroutine test_posnam_present

subroutine test_posnam_nonpresent()
implicit none
call posnam(kulnam, cnonpresent)  ! should call abor1
end subroutine test_posnam_nonpresent

subroutine fail_impl(msg,line)
    character(*) :: msg
    integer :: line
    write(0,'(A,I0,A)') "TEST FAILED in test_namelist.F90 @ line ",line," :"
    write(0,*) msg
    stop 1
end subroutine
end program

#!/usr/bin/env bash

version=2023.2.0
KEY=GPG-PUB-KEY-INTEL-SW-PRODUCTS.PUB
wget https://apt.repos.intel.com/intel-gpg-keys/$KEY
sudo apt-key add $KEY
rm $KEY
echo "deb https://apt.repos.intel.com/oneapi all main" | sudo tee /etc/apt/sources.list.d/oneAPI.list
sudo apt-get update
sudo apt-get install \
    intel-oneapi-compiler-fortran-$version \
    intel-oneapi-compiler-dpcpp-cpp-and-cpp-classic-$version \
    intel-oneapi-mpi-devel-2021.10.0 \
    intel-oneapi-mkl-$version

#!/bin/bash


set +x
set -e -o pipefail

SCRIPTDIR="$( cd "$( dirname "${BASH_SOURCE[0]}" )" && pwd )"
export PATH=$SCRIPTDIR:$PATH

# Some defaults for the arguments
PREFIX=$(pwd)/${MPI}
mpi_override=false
MPI=openmpi

while [ $# != 0 ]; do
    case "$1" in
    "--prefix")
        PREFIX="$2"; shift
        ;;
    "--override")
        mpi_override=true; 
        ;;
    "--version")
        mpi_version="$2"; shift
        ;;
    "--mpi")
        MPI="$2"; shift
        ;;
    *)
        echo "Unrecognized argument '$1'"
        exit 1
        ;;
    esac
    shift
done

os=$(uname)
OMPIVER=4.1.1
MPICHVER=3.4.2

if [ ! -z ${mpi_version+x} ]; then
  if [[ "${MPI}" =~ [Oo][Pp][Ee][Nn]\-?[Mm][Pp][Ii] ]]; then
    OMPIVER=${mpi_version}
  fi
  if [[ "${MPI}" =~ [Mm][Pp][Ii][Cc][Hh] ]]; then
    MPICHVER=${mpi_version}
  fi
fi


mkdir -p ${PREFIX}
touch ${PREFIX}/env.sh

MPI_INSTALLED=false

case "$os" in
    Darwin)
        case "$MPI" in
            mpich)
                brew ls --versions mpich || brew install mpich
                ;;
            openmpi)
                brew ls --versions openmpi || brew install openmpi
                echo "localhost slots=72" >> $(brew --prefix)/etc/openmpi-default-hostfile
                echo "localhost slots=72" >> $(brew --prefix)/etc/prte-default-hostfile

                # workaround for open-mpi/omp#7516
                echo "setting the mca gds to hash..."
                echo "gds = hash" >> $(brew --prefix)/etc/pmix-mca-params.conf

                # workaround for open-mpi/ompi#5798
                echo "setting the mca btl_vader_backing_directory to /tmp..."
                echo "btl_vader_backing_directory = /tmp" >> $(brew --prefix)/etc/openmpi-mca-params.conf
                ;;
            *)
                echo "Unknown MPI implementation: $MPI"
                exit 1
                ;;
        esac
    ;;

    Linux)
        if [ -n "${MPI_HOME}" ]; then
          echo "MPI is already installed at MPI_HOME=${MPI_HOME}."
          echo "Not taking any action."
          exit 0
        fi
        if [ -n "${I_MPI_ROOT}" ]; then
          echo "MPI is already installed at I_MPI_ROOT=${I_MPI_ROOT}."
          echo "Not taking any action."
          exit 0
        fi
        case "$MPI" in
            mpich)
                if [ -f ${PREFIX}/include/mpi.h ]; then
                  echo "${PREFIX}/include/mpi.h found"
                fi
                if [ -f ${PREFIX}/lib/libmpich.so ]; then
                  echo "${PREFIX}/lib/libmpich.so found -- nothing to build."
                else
                  echo "Downloading mpich source..."
                  wget http://www.mpich.org/static/downloads/${MPICHVER}/mpich-${MPICHVER}.tar.gz
                  tar xfz mpich-${MPICHVER}.tar.gz
                  rm mpich-${MPICHVER}.tar.gz
                  echo "Configuring and building mpich..."
                  cd mpich-${MPICHVER}
                  unset F90
                  unset F90FLAGS
                  ${SCRIPTDIR}/reduce-output.sh ./configure \
                          --prefix=${PREFIX} \
                          --enable-static=false \
                          --enable-alloca=true \
                          --enable-threads=single \
                          --enable-fortran=yes \
                          --enable-fast=all \
                          --enable-g=none \
                          --enable-timing=none
                  ${SCRIPTDIR}/reduce-output.sh make -j48
                  ${SCRIPTDIR}/reduce-output.sh make install
                  MPI_INSTALLED=true
                  cd -
                  rm -rf mpich-${MPICHVER}
                fi
                ;;
            openmpi)
                if [ -f ${PREFIX}/include/mpi.h ]; then
                  echo "openmpi/include/mpi.h found."
                fi
                if [ -f ${PREFIX}/lib/libmpi.so ] || [ -f ${PREFIX}/lib64/libmpi.so ]; then
                  echo "libmpi.so found -- nothing to build."
                else
                  echo "Downloading openmpi source..."
                  wget --no-check-certificate https://www.open-mpi.org/software/ompi/v4.1/downloads/openmpi-$OMPIVER.tar.gz
                  tar -zxf openmpi-$OMPIVER.tar.gz
                  rm openmpi-$OMPIVER.tar.gz
                  echo "Configuring and building openmpi..."
                  cd openmpi-$OMPIVER
                  ${SCRIPTDIR}/reduce-output.sh ./configure --prefix=${PREFIX}
                  ${SCRIPTDIR}/reduce-output.sh make -j4
                  ${SCRIPTDIR}/reduce-output.sh make install
                  MPI_INSTALLED=true
                  echo "localhost slots=72" >> ${PREFIX}/etc/openmpi-default-hostfile
                  cd -
                  rm -rf openmpi-$OMPIVER
                fi
                ;;
            *)
                echo "Unknown MPI implementation: $MPI"
                exit 1
                ;;
        esac
        ;;

    *)
        echo "Unknown operating system: $os"
        exit 1
        ;;
esac


if ${MPI_INSTALLED} ; then
cat > ${PREFIX}/env.sh << EOF
export MPI_HOME=${PREFIX}
export PATH=\${MPI_HOME}/bin:\${PATH}
EOF
echo "Please source ${PREFIX}/env.sh, containing:"
cat ${PREFIX}/env.sh
fi

#!/bin/ksh
trap 'set +x; echo "Received signal, aborting ..."; exit 1' 1 2 3 15 
#
# Run the 3 test examples provided in the Dr.Hook distribution
#
# These examples have been tested on ibm_power4 platform
# where memory profiling and Mflop-counters are definitely available.
#
# Change the FC and LIBS first if you want to run it on your platform.
#
# Usage : drhook_ex.ksh [$ARCH]
#
#
# Please note, that these example rely on serial MPI-lib
# i.e. run only using one MPI-task
#
# In order to run with multiple processors, refer to your local
# MPI documentation on how to include MPI-lib proper and how to run MPI-
# applications on your platform. Also, do not forget to remove references
# to lib mpi_serial !
#

set -veu

if [[ $# -eq 1 ]] ; then
  export ARCH=$1
else
  export ARCH=${ARCH:=ibm_power4}
fi

has_mpi=0
NPES=1
ECYOD=""

if [[ "$ARCH" = ibm_power* ]] ; then
#-- IBM Power4
  FC="xlf90_r -g -qsmp=omp -qextname -qsuffix=cpp=F90 -qfree=F90 -I."
  CC="xlc_r -g -qsmp=noauto -I."
#-- The following assumes that drhook.c has been compiled with -DHPM
#-- Requires odbdummy because of ec_bind()
  LIBS="-L. -ldrhook -lmpi_serial -L/usr/pmapi/lib -lpmapi -lessl -lodbdummy"
#-- If not compiled with -DHPM, then supply pm_* dummies
#  LIBS="-L. -ldrhook -lmpi_serial -lodbdummy -lessl"
# Note: -lessl i.e. ESSL-library is needed due to jsort.F
elif [[ "$ARCH" = rs6000 ]] ; then
#-- IBM Power3 (at ECMWF)
  FC="xlf90_r -g -qsmp=omp -qextname -qsuffix=cpp=F90 -qfree=F90 -I."
  CC="xlc_r -g -qsmp=noauto -I."
  LIBS="-L. -ldrhook -lmpi_serial -lessl"
elif [[ "$ARCH" = linux ]] ; then
#-- Linux with Portland Group F90 (for IA32)
  FC="pgf90 -mp -I. -g -Ktrap=fp -O1 -fPIC"
  CC="gcc -g -m32 -ansi -Werror"
  LIBS="-L. -ldrhook -lmpi_serial -Wl,-export-dynamic"
elif [[ "$ARCH" = @(linuxg95|cygwin) ]] ; then
#-- Linux with GNU g95
  FC="g95 -I. -g -fno-second-underscore"
  CC="gcc -g -m32 -ansi -Werror"
  LIBS="-L. -ldrhook -lmpi_serial"
elif [[ "$ARCH" = ia64 ]] ; then
#-- Linux with Intel F90
  FC="ifort -openmp -cpp -I. -g -fpe0 -O1 -assume byterecl -assume cc_omp -traceback \
            -assume cc_omp -assume underscore -lowercase -nomixed_str_len_arg -fPIC"
  CC="gcc -g -ansi -Werror"
  LIBS="-L. -ldrhook -lmpi_serial -Wl,-export-dynamic"
elif [[ "$ARCH" = amd64 ]] ; then
  MPICH_ROOT=${MPICH_ROOT:=/not/available}
  if [[ -d $MPICH_ROOT && -x $MPICH_ROOT/bin/mpirun ]] ; then
    #-- Linux with Portland Group F90 -- for AMD64 with MPICH
    MPFC="$MPICH_ROOT/bin/mpif90 -f90=pgf90 -mp -I. -g -Ktrap=fp -O1 -fPIC -tp amd64"
    MPLIBS="-L. -ldrhook -L$MPICH_ROOT/lib -lmpichf90 -lmpich -ldl -Wl,-export-dynamic"
    NPES=2
    mpirun="./mpirun.linux -np $NPES"
    has_mpi=1
  fi
  #-- Linux with Portland Group F90 -- for AMD64
  FC="pgf90 -mp -I. -g -Ktrap=fp -O1 -fPIC -tp amd64"
  LIBS="-L. -ldrhook -lmpi_serial -Wl,-export-dynamic"
  CC="gcc -g -m64 -ansi -Werror"
elif [[ "$ARCH" = @(*alpha) ]] ; then
#-- ECMWF Dec Alpha (nowadays an outdated toy machine)
  FC="f90 -convert big_endian -O0 -assume byterecl"
  CC="cc -std -g -O0"
  LIBS="-L. -ldrhook -lmpi_serial"
elif [[ "$ARCH" = i86pc ]] ; then
#-- ECMWF Intel/Solaris
  FC="f90 -xfilebyteorder=big8:%all -I. -M."
  CC=${CC:="gcc -g -ansi -Werror"}
  I86PC_GCC=${I86PC_GCC:="-L/opt/sfw/lib/gcc-lib/i386-pc-solaris2.9/2.95.3 -lgcc"}
  #suse 10.0: I86PC_GCC=${I86PC_GCC:="-L/usr/lib/gcc/i586-suse-linux/4.0.2 -lgcc"}
  LIBS="-L. -ldrhook -lmpi_serial $I86PC_GCC"
  export DBXDEBUGGER=${DBXDEBUGGER:=1}
elif [[ "$ARCH" = "necsx" ]] ; then
  FC="./run_fe sxf90 -DNECSX -V -USX -Cvopt -Wf,-pvctl fullmsg vwork=stack,-L fmtlist transform"
  CC="./run_fe sxcc -DNECSX" 
  LIBS="-L. -ldrhook -lmpi_serial -lgen -lcpp -lpthread"
  export DBXDEBUGGER=${DBXDEBUGGER:=1}
elif [[ "$ARCH" = @(cray_xt*) ]] ; then
  FC="ftn -g"
  CC="cc -g"
  LIBS="-L. -ldrhook -ldl -Wl,-export-dynamic"
  #-- yod stuff
  MPFC="$FC"
  MPLIBS="$LIBS"
  NPES=2
  mpirun="yod -sz $NPES"
  has_mpi=1
  ECYOD="yod -sz 1 -SN"
else
  echo "***Error: Unrecognized ARCH=$ARCH"
  echo "          Please edit this file $0"
  exit 1
fi

if [[ -f ./ODB_FCLIBS ]] ; then
  ODB_FCLIBS=$(cat ./ODB_FCLIBS)
else
  ODB_FCLIBS=""
fi

#-- In case of shareable linkage ...

LD_LIBRARY_PATH=${LD_LIBRARY_PATH:=.}
if [[ "$LD_LIBRARY_PATH" != "." ]] ; then
  LD_LIBRARY_PATH=".:${LD_LIBRARY_PATH}"
fi
export LD_LIBRARY_PATH

#-- Initialize (outside this script) the following to 0/1 to prevent/allow running GNU-debugger
# export GNUDEBUGGER=${GNUDEBUGGER:=0}
#-- Initialize (outside this script) the following to 0/1 to prevent/allow running DBX-debugger
# export DBXDEBUGGER=${DBXDEBUGGER:=0}

set -xv

#-------------------------------------------------------------------------
# Example#0 : Show wordsizes in F90 & C of this arch (these are MPI/serial)
#-------------------------------------------------------------------------

$ECYOD ./sizeof.x || :

$ECYOD ./kind.x || :

#-------------------------------------------------------------------------
# Example#1 : Generate Dr.Hook, run and fail in divide by zero
#-------------------------------------------------------------------------

./insert_drhook drhook_ex1.F90
$FC -I. _drhook_ex1.F90 -o drhook_ex1.x $LIBS
env DR_HOOK=1 $ECYOD ./drhook_ex1.x || :

#-------------------------------------------------------------------------
# Example#2 : With the previous case fixed experience with watch point
#             Testing also mpl_arg_mod
#-------------------------------------------------------------------------

./insert_drhook drhook_ex2.F90
$FC -I. _drhook_ex2.F90 -o drhook_ex2.x $LIBS
env DR_HOOK=1 $ECYOD ./drhook_ex2.x 1000 || :

#-------------------------------------------------------------------------
# Example#3 : Experience with different profilings. Also silence Dr.Hook!
#-------------------------------------------------------------------------

./insert_drhook drhook_ex3.F90
$FC -I. _drhook_ex3.F90 -o drhook_ex3.x $LIBS
export DR_HOOK=1

export DR_HOOK_SILENT=1
export DR_HOOK_SHOW_PROCESS_OPTIONS=0

#-- Wall clock profile
env DR_HOOK_OPT=wallprof $ECYOD ./drhook_ex3.x || :
mv drhook.prof.1 drhook.prof.1.wallprof
cat drhook.prof.1.wallprof

#-- CPU-time profile
env DR_HOOK_OPT=cpuprof $ECYOD ./drhook_ex3.x || :
mv drhook.prof.1 drhook.prof.1.cpuprof
cat drhook.prof.1.cpuprof

#-- Mflop-counter profile
env DR_HOOK_OPT=hpmprof $ECYOD ./drhook_ex3.x || :
mv drhook.prof.1 drhook.prof.1.hpmprof
cat drhook.prof.1.hpmprof

#-- Wall clock & memory usage with timeline
env DR_HOOK_OPT=wall,mem DR_HOOK_TIMELINE=-1 $ECYOD ./drhook_ex3.x > drhook.timeline 2>&1 || :
ls -l drhook.timeline

#-- Memory profile (only)
env DR_HOOK_OPT=memprof $ECYOD ./drhook_ex3.x || :
mv drhook.prof.1-mem drhook.prof.1.memprof
cat drhook.prof.1.memprof

unset DR_HOOK
unset DR_HOOK_SILENT
unset DR_HOOK_SHOW_PROCESS_OPTIONS

#-------------------------------------------------------------------------
# Example#4 : Check whether your Dr.Hook works with C-main program
#-------------------------------------------------------------------------

rc4=0
$CC -c drhook_ex4.c || {
  set +xv
  echo "***Error: Your Dr.Hook C-main program test did not compile"
  rc4=1
}

if [[ $rc4 -eq 0 ]] ; then
  $CC drhook_ex4.o -o ./drhook_ex4.x $LIBS $ODB_FCLIBS || {
    set +xv
    echo "***Error: Your Dr.Hook C-main program test did not link"
    rc4=2
  }
fi

if [[ $rc4 -eq 0 ]] ; then
  #-- Test 4a) : Trigger SIGFPE and fail
  env DR_HOOK=1 $ECYOD ./drhook_ex4.x SIGFPE "ARG TEST" 'test arg' `pwd` || :
fi

if [[ $rc4 -eq 0 ]] ; then
  #-- Test 4b) : Do not fail and produce wall clock profile
  export DR_HOOK_SILENT=1
  export DR_HOOK_SHOW_PROCESS_OPTIONS=0
  export DR_HOOK_PROFILE=cdrhook.prof.%d
  env DR_HOOK=1 DR_HOOK_OPT=wallprof $ECYOD ./drhook_ex4.x || :
  cat cdrhook.prof.1
  unset DR_HOOK_PROFILE
  unset DR_HOOK_SILENT
  unset DR_HOOK_SHOW_PROCESS_OPTIONS
fi

set -xv

#-------------------------------------------------------------------------
# Example#5 : Check MPI implementation, if applicable
#-------------------------------------------------------------------------

rc5=0

export DR_HOOK=1
export DR_HOOK_SILENT=1
export DR_HOOK_SHOW_PROCESS_OPTIONS=0

if [[ $has_mpi -eq 1 ]] ; then
  # "*** Testing parallel MPI-implementation ***"

  ./insert_drhook drhook_ex5.F90
  $MPFC -I. _drhook_ex5.F90 -o drhook_ex5.x $MPLIBS || rc5=$?

  if [[ $rc5 -eq 0 ]] ; then
    #-- Wall clock profile
    env DR_HOOK_OPT=wallprof $mpirun ./drhook_ex5.x one two three || rc5=$?

    if [[ ! -f drhook.prof.1 ]] ; then
    #-- Something went wrong ... reverting to serial version
      rc5=1
      has_mpi=0
    fi

    if [[ $rc5 -eq 0 ]] ; then
      typeset np=0
      while [[ $np -lt $NPES ]]
      do
        ((np+=1))
        mv drhook.prof.$np drhook.prof.$np.wallprof
        cat drhook.prof.$np.wallprof
      done
    fi
  fi

fi

if [[ $has_mpi -eq 0 ]] ; then
  rc5=0
  # "*** Testing MPI-implementation with a dummy MPI-serial version ***"

  ./insert_drhook drhook_ex5.F90
  $FC -I. _drhook_ex5.F90 -o drhook_ex5.x $LIBS || rc5=$?

  if [[ $rc5 -eq 0 ]] ; then
    #-- Wall clock profile
    env DR_HOOK_OPT=wallprof $ECYOD ./drhook_ex5.x one two three || rc5=$?

    if [[ $rc5 -eq 0 ]] ; then
      mv drhook.prof.1 drhook.prof.1.wallprof
      cat drhook.prof.1.wallprof
    fi
  fi

fi

unset DR_HOOK_PROFILE
unset DR_HOOK_SILENT
unset DR_HOOK_SHOW_PROCESS_OPTIONS

#-------------------------------------------------------------------------

((rc=rc4+rc5))

exit $rc

#!/bin/sh

# Install NVHPC
# https://github.com/nemequ/pgi-travis
#
# Originally written for Squash <https://github.com/quixdb/squash> by
# Evan Nemerson.  For documentation, bug reports, support requests,
# etc. please use <https://github.com/nemequ/pgi-travis>.
#
# To the extent possible under law, the author(s) of this script have
# waived all copyright and related or neighboring rights to this work.
# See <https://creativecommons.org/publicdomain/zero/1.0/> for
# details.

version=24.3

TEMPORARY_FILES="${TMPDIR:-/tmp}"
export NVHPC_INSTALL_DIR=$(pwd)/nvhpc-install
export NVHPC_SILENT=true
while [ $# != 0 ]; do
    case "$1" in
    "--prefix")
        export NVHPC_INSTALL_DIR="$2"; shift
        ;;
    "--tmpdir")
        TEMPORARY_FILES="$2"; shift
        ;;
    "--verbose")
        export NVHPC_SILENT=false;
        ;;
    "--version")
        version="$2"; shift
        ;;
    *)   
        echo "Unrecognized argument '$1'"
        exit 1
        ;;
    esac 
    shift
done

case "$(uname -m)" in
	x86_64|ppc64le|aarch64)
		;;
	*)
		echo "Unknown architecture: $(uname -m)" >&2
		exit 1
		;;
esac

if [ -d "${NVHPC_INSTALL_DIR}" ]; then
    if [[ $(find "${NVHPC_INSTALL_DIR}" -name "nvc" | wc -l) == 1 ]]; then
      echo "NVHPC already installed at ${NVHPC_INSTALL_DIR}"
      exit
    fi
fi

# Example download URL for version 24.3
#    https://developer.download.nvidia.com/hpc-sdk/24.3/nvhpc_2024_243_Linux_x86_64_cuda_12.3.tar.gz

ver="$(echo $version | tr -d . )"
URL=$(curl -s "https://developer.nvidia.com/nvidia-hpc-sdk-$ver-downloads" | grep -oP "https://developer.download.nvidia.com/hpc-sdk/([0-9]{2}\.[0-9]+)/nvhpc_([0-9]{4})_([0-9]+)_Linux_$(uname -m)_cuda_([0-9\.]+).tar.gz" | sort | tail -1)
FOLDER="$(basename "$(echo "${URL}" | grep -oP '[^/]+$')" .tar.gz)"

if [ ! -d "${TEMPORARY_FILES}/${FOLDER}" ]; then
  echo "Downloading ${TEMPORARY_FILES}/${FOLDER} from URL [${URL}]"
  mkdir -p ${TEMPORARY_FILES}
  curl --location \
       --user-agent "pgi-travis (https://github.com/nemequ/pgi-travis)" \
       "${URL}" | tar zx -C "${TEMPORARY_FILES}"
else
   echo "Download already present in ${TEMPORARY_FILES}/${FOLDER}"
fi

echo "+ ${TEMPORARY_FILES}/${FOLDER}/install"
"${TEMPORARY_FILES}/${FOLDER}/install"

#comment out to cleanup
#rm -rf "${TEMPORARY_FILES}/${FOLDER}"

NVHPC_VERSION=$(basename "${NVHPC_INSTALL_DIR}"/Linux_$(uname -m)/*.*/)

# Use gcc which is available in PATH
${NVHPC_INSTALL_DIR}/Linux_$(uname -m)/${NVHPC_VERSION}/compilers/bin/makelocalrc \
  -x ${NVHPC_INSTALL_DIR}/Linux_$(uname -m)/${NVHPC_VERSION}/compilers/bin \
  -gcc $(which gcc) \
  -gpp $(which g++) \
  -g77 $(which gfortran)

cat > ${NVHPC_INSTALL_DIR}/env.sh << EOF
### Variables
export NVHPC_INSTALL_DIR=${NVHPC_INSTALL_DIR}
export NVHPC_VERSION=${NVHPC_VERSION}
export NVHPC_DIR=\${NVHPC_INSTALL_DIR}/Linux_$(uname -m)/\${NVHPC_VERSION}

### Compilers
export PATH=\${NVHPC_DIR}/compilers/bin:\${PATH}
export NVHPC_LIBRARY_PATH=\${NVHPC_DIR}/compilers/lib
export LD_LIBRARY_PATH=\${NVHPC_LIBRARY_PATH}

### MPI
export MPI_HOME=\${NVHPC_DIR}/comm_libs/mpi
export PATH=\${MPI_HOME}/bin:\${PATH}
EOF

cat ${NVHPC_INSTALL_DIR}/env.sh

#!/bin/bash

# (C) Copyright 2013 ECMWF.
#
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation nor
# does it submit to any jurisdiction.


# Abort on Error
set -e

PING_SLEEP=30s

dump_output() {
   echo " ++ Tailing the last 100 lines of output from $BUILD_OUTPUT"
   tail -100 $BUILD_OUTPUT  
}
error_handler() {
  echo ERROR: An error was encountered with the build.
  kill $PING_LOOP_PID
  dump_output
  exit 1
}
# If an error occurs, run our error handler to output a tail of the build
trap 'error_handler' ERR

# Set up a repeating loop to display some output regularly.
bash -c "while true; do sleep $PING_SLEEP; echo \" ++ \$(date) - running ... \"; done" &
PING_LOOP_PID=$!
BUILD_OUTPUT=build-$PING_LOOP_PID.out
touch $BUILD_OUTPUT
echo " + $@"
echo " ++ Output redirected to $BUILD_OUTPUT"
$@ >> $BUILD_OUTPUT 2>&1

# The build finished without returning an error so dump a tail of the output
dump_output

# nicely terminate the ping output loop
kill $PING_LOOP_PID
